/**
 * Created by mintao on 2016/10/13.
 */


var AppSplashScene = cc.Scene.extend({
    _interval : null,
    _label : null,
    _className:"AppSplashScene",
    cb: null,
    target: null,

    init : function(){
        var self = this;

        var layerbg = self._layerbg = new cc.Sprite(res.Splashbg_png);
        layerbg.setPosition(cc.visibleRect.center);
        self.addChild(layerbg, 0);

        //loading percent
        var label = self._label = new cc.LabelTTF("Loading... 0%", "Arial", 24);
        label.setPosition(cc.pAdd(cc.visibleRect.center, cc.p(0, 200)));
        label.setColor(cc.color(180, 180, 180));
        layerbg.addChild(this._label, 10);

        return true;
    },

    onEnter: function () {
        var self = this;
        cc.Node.prototype.onEnter.call(self);
        self.schedule(self._startLoading, 0.3);
    },

    onExit: function () {
        cc.Node.prototype.onExit.call(this);

        //cc.director.get
        var tmpStr = "Loading... 0%";
        this._label.setString(tmpStr);
    },

    /**
     * init with resources
     * @param {Array} resources
     * @param {Function|String} cb
     * @param {Object} target
     */
    initWithResources: function (resources, cb, target) {
        if(cc.isString(resources))
            resources = [resources];
        this.resources = resources || [];
        this.cb = cb;
        this.target = target;
    },

    _startLoading: function () {
        var self = this;
        self.unschedule(self._startLoading);
        var res = self.resources;
        cc.loader.load(res,
            function (result, count, loadedCount) {
                var percent = (loadedCount / count * 100) | 0;
                percent = Math.min(percent, 100);
                self._label.setString("Loading... " + percent + "%");
            }, function () {
                if (self.cb)
                    self.cb.call(self.target);
            });
    },

});

AppSplashScene.preload = function(resources, cb, target){
    if(!FYEngine.splashScene) {
        FYEngine.splashScene = new AppSplashScene();
        FYEngine.splashScene.init();
    }
    FYEngine.splashScene.initWithResources(resources, cb, target);
    cc.director.runScene(FYEngine.splashScene);
    return FYEngine.splashScene;
};