/**
 * Created by mintao on 2016/11/15.
 * common protocol
 */

var CommonProtocol = {
    LinkProto       :  1, //链接主协议
    HeartBeat       :  1, //心跳

    AccessProto     : 10, //access协议
    PublicKey       :  0, //公钥
    PrivateKey      :  1, //私钥

};

/***
 * 链接消息
 * @type {{lRoleId: number}}
 */
CommonProtocol.HeartBeatReq = {
    lRoleId : 0,
};

CommonProtocol.encode_HeartBeat = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

/****
 * Access 消息
 * @type {{dwPrvKeyLen: number, szPrvKey: string}}
 */
CommonProtocol.PrivateKeyReq = {
    dwPrvKeyLen : 0,            //4字节: AES密钥长度(16,24,32)
    szPrvKey    : '',           //32字节: AES密钥
};

CommonProtocol.PrivateKeyRsp = {
    iResult     : 0,            //结果
};

CommonProtocol.PublicKeyReq =
{
    iType : 0, //加密类型
};

CommonProtocol.PublicKeyRsp =
{
    dwPubKeyLen : 0,          //4字节: RSA公钥长度
    szPubKey    : '',         //512字节: RSA公钥
};

CommonProtocol.encode_PublicKey = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt32(req.iType);
};

CommonProtocol.decode_PublicKey = function(byteBuf){
    var rsp = createObj(CommonProtocol.PublicKeyRsp);
    rsp.dwPubKeyLen = byteBuf.getUint32();
    rsp.szPubKey = byteBuf.getFixedString(rsp.dwPubKeyLen);
    return rsp;
};

CommonProtocol.encode_PrivateKey = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setUint32(req.dwPrvKeyLen);
    bb.setFixedString(req.szPrvKey, req.dwPrvKeyLen);
};

CommonProtocol.decode_PrivateKey = function(byteBuf){
    var rsp = createObj(CommonProtocol.PrivateKeyRsp);
    rsp.iResult = byteBuf.getInt32();
    return rsp;
};