/**
 * Created by xiadi on 16/6/14.
 * http://www.cocos2d-x.org/wiki/Invoking_Android_Java_methods_from_JavaScript
 */

// 定义命名空间
var FYEngine = FYEngine || {};

/**
 * This object is only used by android platform
 */
var JavascriptJavaBridge = cc.Class.extend({

    _clazz : "com/phoneu/fyplatform/jsb/JavascriptJavaBridge",

    _isAndroid : function () {
    	return cc.sys.os === cc.sys.OS_ANDROID;
    },

    is3rdSdkLogin : function () {
        if (!this._isAndroid()) { return false; }
        try {
            var ret = jsb.reflection.callStaticMethod(this._clazz, "is3rdSdkLogin", "()Z");
        } catch (e) {
            cc.error(e.stack);
        }
        return ret;
    },

    handleSdkInit : function () {
        if (this._isAndroid()) {
            // jsb.reflection.callStaticMethod(this._clazz, "handleWXLogin", "(Ljava/lang/String;)V", params);
        } else {
            jsb.reflection.callStaticMethod("JavascriptObjcBridge", "jsCall:andData:", "sdkInit", "");
        }
    },

    handleWXLogin : function (params) {
        if (this._isAndroid()) {
            jsb.reflection.callStaticMethod(this._clazz, "handleWXLogin", "(Ljava/lang/String;)V", params);
        } else {
            jsb.reflection.callStaticMethod("JavascriptObjcBridge", "jsCall:andData:", "login", params);
        }
    },

    handleWXLogout : function () {
        if (this._isAndroid()) {
            return jsb.reflection.callStaticMethod(this._clazz, "handleWXLogout", "()Z");
        } else {
            return jsb.reflection.callStaticMethod("JavascriptObjcBridge", "jsCall:andData:", "logout", "");
        }
    },

    handle3rdSdkLogin : function (params) {
        if (!this._isAndroid()) { return; }
        jsb.reflection.callStaticMethod(this._clazz, "handle3rdSdkLogin", "(Ljava/lang/String;)V", params);
    },

	// Check whether the third sdk logout is used or not
    is3rdSdkLogout : function () {
    	if (!this._isAndroid()) { return false; }
        var ret = jsb.reflection.callStaticMethod(this._clazz, "is3rdSdkLogout", "()Z");
        return ret;
    },

    handle3rdSdkLogout : function () {
    	if (!this._isAndroid()) { return; }
    	jsb.reflection.callStaticMethod(this._clazz, "handle3rdSdkLogout", "()V");
    },

    exitGame : function () {
        if (!this._isAndroid()) { return false; }
        jsb.reflection.callStaticMethod(this._clazz, "exitGame", "()V");
    },

    invokeRongIM : function (userid, nickname, faceid) {
        if (!this._isAndroid()) { return false; }
        jsb.reflection.callStaticMethod(this._clazz, "invokeRongIM",
            "(ILjava/lang/String;Ljava/lang/String;)V", userid, nickname, faceid);
        return true;
    },

    getNetworkType : function () {
        if (!this._isAndroid()) { return 0; }
        return jsb.reflection.callStaticMethod(this._clazz, "getNetworkType", "()I");
    },

    syncAcctPwd : function (pwd, acct) {
        if (!this._isAndroid()) { return false; }
        return jsb.reflection.callStaticMethod(this._clazz, "syncAcctPwd",
            "(Ljava/lang/String;Ljava/lang/String;)Z", pwd, acct);
    },
    simpleXor : function (base_data, encrytkey) {
        if (!this._isAndroid()) { return 0; }
        return jsb.reflection.callStaticMethod(this._clazz, "simpleXor", "(Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;", base_data, encrytkey);
    },
    getLocalIp: function () {
        if (!this._isAndroid()) { return ''; }
        return jsb.reflection.callStaticMethod(this._clazz, "getLocalIp", "()Ljava/lang/String;");
    },
    getUA: function () {
        if (!this._isAndroid()) { return }
        jsb.reflection.callStaticMethod(this._clazz, "getUA", "()V");
    },
});

FYEngine.javascriptJavaBridge = FYEngine.javascriptJavaBridge || new JavascriptJavaBridge();
