/**
 * Created by mintao on 16/5/25.
 */

/***
 * js类型判断
 * @param obj
 * @returns {boolean}
 */
var isUndefined = function(obj) {
    return typeof obj == 'undefined';
};
var isString = function(obj) {
    return typeof obj == 'string' || Object.prototype.toString.call(obj) == '[object String]';
};
var isArray = function(obj) {
    return Object.prototype.toString.call(obj) == '[object Array]';
};
var isNumber = function(obj) {
    return typeof obj == 'number' || Object.prototype.toString.call(obj) == '[object Number]';
};
var isFunction = function(obj) {
    return typeof obj === 'function';
};
var isBoolean = function(obj){
    return typeof obj == 'boolean' || Object.prototype.toString.call(obj) == '[object Boolean]';
};

/****
 * 创建对象并初始化
 * @param obj
 * @returns {obj}
 * @constructor
 */
var createObj = function(obj){
    var tObj = (obj == undefined ? {} : Object.create(obj, {}));
    tObj = {};
    return tObj;
};

/***
 * 获取obj参数个数
 * @param obj
 */
function getObjCount(obj){
    var count = Object.keys(obj).length;
    //Object.getOwnPropertyNames(FruitResource.PngName).length;
    return count;
};

/***
 * 字串转ascii码
 * @param str 字符串
 * @returns {Number}
 * @constructor
 */
var getAscii = function(str){
    return str.charCodeAt();
};

/***
 * 获取1970.1.1开始的毫秒数
 */
function getUSecTime(){
    var mydata = new Date();
    return mydata.getTime();
}

function getSecTime(){
    var mydata = new Date();
    return mydata.getSeconds();
}

/***
 * 字符串转JSon
 * @param str
 */
function strTojson(str){
    return JSON.parse(str);
}

/**
 * json转字符串
 * 会自动加上双引号
 * @param json
 */
function jsonTostr(json){
    return JSON.stringify(json);
}

/****
 * 获取星座
 * @returns {string}
 * @constructor
 */
var getConstellation = function(month, day){
    var constellationArr = ["水瓶座", "双鱼座", "白羊座", "金牛座", "双子座", "巨蟹座",
        "狮子座", "处女座", "天秤座", "天蝎座", "射手座", "魔羯座"];
    var constellationEdgeDay = [ 20, 19, 21, 21, 21, 22, 23, 23, 23, 23, 22, 22 ];
    var constellation = '';
    var curIndex = month-1;
    if (day < constellationEdgeDay[curIndex]){
        constellation = constellationArr[curIndex];
    }
    else{
        var nextIndex = month == 12 ? 0 : month;
        constellation = constellationArr[nextIndex];
    }
    return constellation;
};

/***
 *创建带 '万' 的 string
 */

function matchMillionIcon(num) {
    if(Math.abs(num) > 100000){
        num = FYMath.fixedFloor(num, 10000,1)+"万";
        return num;
    }
    return num;
}



