/**
 * Created by mintao on 16/4/20.
 * 广播
 * BroadCast 为通用类
 *
 */


FYEngine.BroadCast = ccui.ImageView.extend({
    _broadlab : null,
    _move : 0,
    _callback : null,

    /***
     * 创建广播条层,默认不可点击
     * @param filename
     * @param size 大小
     * @param rect 拉伸矩形
     * @param masksize 蒙版大小
     * @param maskpos 蒙版坐标
     * @param move 移动距离 默认1.5
     * @param textureType 可不传
     * @returns {boolean}
     */
    ctor : function(filename, size, rect, masksize, maskpos, move, textureType){
        this._super();

        if (textureType == undefined){
            textureType = ccui.Widget.PLIST_TEXTURE;
        }

        this.loadTexture(filename, textureType);
        this.setScale9Enabled(true);
        if (rect != undefined){
            this.setCapInsets(rect);
        }
        this.setContentSize(size);

        ///创建模板
        this.scrollmask = new ccui.ScrollView();
        this.scrollmask.setContentSize(masksize);
        this.scrollmask.setPosition(maskpos);
        this.scrollmask.setSwallowTouches(false);
        this.addChild(this.scrollmask);

        ///添加label
        this._broadlab = FYEngine.createLabel('', 20, cc.color.WHITE);
        this._broadlab.setPosition(cc.p(this.scrollmask.width, this.scrollmask.height/2));
        this.scrollmask.addChild(this._broadlab);

        ///
        if (move == undefined){
            var frameW = cc.director.getOpenGLView().getFrameSize().width;
            move = 1.5*frameW/1136;
        }
        this._move = move;
        this.scheduleUpdate();

        return true;
    },


    /***
     * 设置文本
     * @param str
     * @param fontsize
     * @param color
     */
    setLabelText : function(str, fontsize, color){
        if (!this._broadlab){
            this._broadlab = FYEngine.createLabel('', 20, cc.color.WHITE);
        }
//        cc.log('--------设置文本 setLabelText : ', str);
        if (str == null){
            str = '';
        }
        this._broadlab.setString(str);
        this._broadlab.setSystemFontSize(fontsize);
        this._broadlab.setColor(color);
        this._broadlab.setPosition(cc.p(this.scrollmask.width, this.scrollmask.height/2));
    },

    /***
     * 每帧刷新
     * @param dt
     */
    update : function(dt){
        if (this._broadlab.getString() == '' ){
            return;
        }

        this._broadlab.x -= this._move;
        if (this._broadlab.x < -this.scrollmask.width){
            this._broadlab.setString('');
        }
    },

    /***
     * 设置可以点击
     * @param callback 点击回调
     */
    setBroadEnabled : function(callback){
        this.setTouchEnabled(true);
        this._callback = callback;
        this.addTouchEventListener(this.BroadTouchCallBack);
    },

    /***
     *
     * @param sender
     * @param type
     * @constructor
     */
    BroadTouchCallBack : function(sender, type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setOpacity(180);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setOpacity(255);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setOpacity(255);
                sender._callback(sender);
            }
                break;
        }
    },

});


/**
 * 富文本广播
 */
FYEngine.RichBroadCast = ccui.ImageView.extend({
    _broadlab : null,
    _move : 0,
    _callback : null,
    _isAwlaysShow : true,
    _broadlength : 0,
    count:0,
    /***
     * 创建广播条层,默认不可点击
     * @param filename
     * @param size 大小
     * @param rect 拉伸矩形
     * @param masksize 蒙版大小
     * @param maskpos 蒙版坐标
     * @param move 移动距离 默认1.5
     * @param textureType 可不传
     * @returns {boolean}
     */
    ctor : function(filename, size, rect, masksize, maskpos, move, textureType, isshow){
        this._super();
        this._isAwlaysShow = isshow;

        if (textureType == undefined){
            textureType = ccui.Widget.PLIST_TEXTURE;
        }

        this.loadTexture(filename, textureType);
        this._handler =CoreServiceProxy.getInstance().getGameHandler();

        if (rect != undefined && rect != null){
            this.setScale9Enabled(true);
            this.setCapInsets(rect);
        }
        this.setContentSize(size);

        ///创建模板
        this.scrollmask = new ccui.ScrollView();
        this.scrollmask.setContentSize(masksize);
        this.scrollmask.setPosition(maskpos);
        this.scrollmask.setSwallowTouches(false);
        this.scrollmask.setScrollBarEnabled(false);
        this.addChild(this.scrollmask);

        var scene =FYEngine.getRunningLayer(0);

        var pulength = FYEngine.createLabel('[phoneu][/phoneu]', scene.getName() == 'fishscene'? 30:24);
        if(pulength){
            this._broadlength = pulength.getContentSize().width;
            this.addChild(pulength);
            pulength.setVisible(false);
        }

        ///
        if (move == undefined){
            move = 1.5;
        }
        var frameW = cc.director.getOpenGLView().getFrameSize().width;
        this._move = move*frameW/1136;

        return true;
    },

    /***
     * 设置文本
     * @param str
     * @param fontsize
     * @param color
     */
    setLabelText : function(text, color1, color2, fontsize){
        this.count = 0;

        if (!this._broadlab){
            this._broadlab = new ccui.RichText();
            this._broadlab.ignoreContentAdaptWithSize(false);
            this._broadlab.setPosition(cc.p(this.scrollmask.width, this.scrollmask.height/2));
            var label = FYEngine.createLabel(text, fontsize);
            this._broadlab.setContentSize(label.getContentSize());
            this._broadlab.setAnchorPoint(cc.p(0,0.5));
            this.scrollmask.addChild(this._broadlab);
        }

        if (text == null){
            text = '';
        }
//        cc.log('-----------changdu' + label.getContentSize().width);
        if (color1 == undefined){
            color1 = cc.color.WHITE;
        }

        if (color2 == undefined){
            color2 = cc.color.YELLOW;
        }

        if (fontsize == undefined){
            fontsize = 25;
        }

        var startKey = "[phoneu]", endKey = "[/phoneu]";
        var startlen = startKey.length, endlen = endKey.length;
        var eleIndex = 1;
        while (text.length > 0){
            var startPos = text.indexOf(startKey);
            var endPos = text.indexOf(endKey);
            if(startPos == -1){
                var eletext = new ccui.RichElementText(eleIndex, color1, 255, text, "", fontsize);
                this._broadlab.pushBackElement(eletext);
                break;
            }
            else if(startPos == 0){
                var temptext = text.substr(startlen, endPos-startlen);
                if(eleIndex<=2){
                    temptext = SoftReplaceWords(temptext);
                }
                var eletext = new ccui.RichElementText(eleIndex, color2, 255, temptext, "", fontsize);
                this.count += 1;
                this._broadlab.pushBackElement(eletext);
                text = text.substr(endPos+endlen);
            }
            else if(startPos >= 1){
                var eletext = new ccui.RichElementText(eleIndex, color1, 255, text.substr(0, startPos), "", fontsize);
                //this.count += 4;
                this._broadlab.pushBackElement(eletext);
                text = text.substr(startPos);
            }
            ++ eleIndex;
        }
    },

    /***
     * 每帧刷新
     * @param dt
     */
    OnUpdateOrigion : function(dt){
        if (!this._broadlab){
            return;
        }

        this._broadlab.x -= this._move;
        if (this._broadlab.x < -(this._broadlab._getWidth())){
            this._broadlab.removeFromParent();
            this._broadlab = null;
            if (!this._isAwlaysShow){
                this.setVisible(false);
            }
        }
    },


    runMoveToAction : function(){
        if(!this._broadlab){
            return;
        }
        var self = this;
        this._broadlab.runAction(new cc.Sequence(new cc.MoveTo(20,cc.p(-this._broadlab._getWidth(),this._broadlab.y)), new cc.RemoveSelf, new cc.CallFunc(function(){
            self._broadlab=null;
            if (!self._isAwlaysShow){
                self.setVisible(false);
            }
        })));

    },

    /***
     * 设置可以点击
     * @param callback 点击回调
     */
    setBroadEnabled : function(callback){
        this.setTouchEnabled(true);
        this._callback = callback;
        this.addTouchEventListener(this.BroadTouchCallBack);
    },

    /***
     *
     * @param sender
     * @param type
     * @constructor
     */
    BroadTouchCallBack : function(sender, type){
        switch (type){
            case ccui.Widget.TOUCH_BEGAN:
                sender.setOpacity(180);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setOpacity(255);
                break;
            case ccui.Widget.TOUCH_ENDED:
            {
                sender.setOpacity(255);
                sender._callback(sender);
            }
                break;
        }
    },

});


