/**
 * Created by mintao on 16/5/26.
 */

/***
 * 创建编辑框
 * @param bgname 默认plist
 * @param size 编辑框size
 * @param model 编辑框类型
 * @param holdtext 占位文本
 * @param holdcolor 占本颜色
 * @param editcolor 编辑文本颜色
 * @param fontsize 字体大小
 * @param maxlen 最大长度
 * @param bgrect 背景九宫拉伸rect
 */
FYEngine.createEditBox = function(bgname, size, model, holdtext, holdcolor, editcolor, fontsize, maxlen, bgrect){
    if (editcolor === undefined){
        editcolor = cc.color.BLACK;
    }
    if (fontsize === undefined){
        fontsize = 28;
    }
    if (maxlen === undefined){
        maxlen = 30;
    }
    if (holdcolor == undefined){
        holdcolor = cc.color.GRAY;
    }

    if (model == undefined){
        model = cc.EDITBOX_INPUT_MODE_SINGLELINE;
    }

    var editbg = new ccui.Scale9Sprite(bgname);
    if (bgrect != undefined){
        editbg.setCapInsets(bgrect);
    }
    editbg.setContentSize(size);

    var editbox = new cc.EditBox(size, editbg);
    editbox.setPlaceHolder(holdtext);
    editbox.setPlaceholderFontColor(holdcolor);
    editbox.setPlaceholderFontSize(fontsize);
    editbox.setFontColor(editcolor);
    editbox.setInputMode(model);
    editbox.setMaxLength(maxlen);
    editbox.setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
    editbox.setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE);
    return editbox;
};

FYEngine.isEmojiCharacter = function (substring) {
    return (new RegExp('\ud83c[\udf00-\udfff]|\ud83d[\udc00-\udfff]|\ud83d[\ude80-\udeff]|[\u2600-\u27ff]')).test(substring);
};