/**
 * Created by mintao on 16/5/26.
 */

/***
 * @returns {cc.Sprite}
 */
FYEngine.createSprite = function(name, pos, anch){
    if (anch == undefined){
        anch = cc.p(0.5, 0.5);
    }
    var sp = null;
    if (name == undefined || name == ''){
        sp = new cc.Sprite();
    }
    else{
        sp = new cc.Sprite(name);
    }
    sp.setPosition(pos);
    sp.setAnchorPoint(anch);
    return sp;
};

/***
 * @returns ccui.Scale9Sprite
 */
FYEngine.createScale9Sprite = function(bgname, size, pos, anch, innerRect){
    var scalesp = new ccui.Scale9Sprite(bgname);
    if (innerRect != undefined){
        scalesp.setCapInsets(innerRect);
    }
    scalesp.setContentSize(size);
    scalesp.setPosition(pos);
    if (anch == undefined){
        anch = cc.p(0.5, 0.5);
    }
    scalesp.setAnchorPoint(anch);
    return scalesp;
};

/***
 * 创建img
 * @param size 大小 可传undefine
 * @param rect 九妹拉伸矩形 可传undefine
 * @param textureType
 */
FYEngine.createImageView = function(filename, pos, anch, size, rect, textureType){
    if (anch == undefined){
        anch = cc.p(0.5, 0.5);
    }

    if (filename[0] == '#'){
        textureType = ccui.Widget.PLIST_TEXTURE;
        filename = filename.slice(1, filename.length-1);
    }

    if (textureType == undefined){
        textureType = ccui.Widget.PLIST_TEXTURE;
    }

    var img = new ccui.ImageView(filename, textureType);
    if (pos == undefined){
        pos = cc.p(0, 0);
    }
    img.setPosition(pos);
    img.setAnchorPoint(anch);
    if (size != undefined){
        img.setScale9Enabled(true);
        img.setContentSize(size);
    }
    if (rect != undefined){
        img.setCapInsets(rect);
    }

    return img;
};

/***
 * plist获取数字
 * @param numstr 数字
 * @param name 小图名字
 * @returns {cc.Node}
 */
FYEngine.createNumSprite = function(numstr, name){
    var node = new cc.Node();
    var nodeW = 0;
    var nodeH = 0;
    numstr += '';
    for(var i = 0; i < numstr.length; ++ i){
        var sp = new cc.Sprite(name.format(numstr[i]));
//        cc.log('------name.format(i) : ', name.format(numstr[i]));
        sp.setPosition(cc.p(nodeW, 0));
        sp.setAnchorPoint(cc.p(0, 0));
        node.addChild(sp, 0, i);
        nodeW = nodeW + sp.getContentSize().width;
        nodeH = sp.getContentSize().height;
    }
    node.setContentSize(cc.size(nodeW, nodeH));
    node.setCascadeOpacityEnabled(true);
    return node;
};

/***
 * 创建裁切对象
 * stencil的位置需要设置
 * @param filename 模板文件名
 */
FYEngine.createClipNode = function(filename){
    var stencil = new cc.Sprite(filename);
    var clip = new cc.ClippingNode(stencil);
    clip.setContentSize(stencil.getContentSize());
    clip.setAlphaThreshold(0.05);
    clip.setInverted(false);
    return clip;
};

/***
 * 金色闪光shine
 * @param filename
 * @param eftname
 */
FYEngine.clipShine = function(filename, eftname){
    var clip = FYEngine.createClipNode(filename);
    var sp_eft = new cc.Sprite(eftname);
    sp_eft.setAnchorPoint(cc.p(0,0.5));
    sp_eft.setPosition(cc.p(-clip.getContentSize().width, clip.getContentSize().height/2));
    clip.addChild(sp_eft);
    var seq = new cc.Sequence(new cc.MoveBy(1.5, cc.p(clip.getContentSize().width+sp_eft.getContentSize().width, 0)),
            new cc.DelayTime(2), new cc.Place(cc.p(-clip.getContentSize().width, clip.getContentSize().height/2)));
    sp_eft.runAction(new cc.RepeatForever(seq));
    return clip;
};

/***
 *
 * @param url
 * @param func 
 * func 必须重载，需要有两个
 */
FYEngine.loadWebImage = function(target, url, func){
    jsb.loadRemoteImg(url, function (successed, tex) {

    });
};

