/**
 * Created by mintao on 2016/10/20.
 */


function loadCSV(){
    this.csvArray = null;

};

/***
 * initConfig
 * @param filepath
 */
loadCSV.prototype.initConfig = function(filepath){
    var self = this;
    try{
        cc.loader.loadTxt(filepath, function(err, data){
            if (err){
                cc.log('--------loadCSV file:'+filepath+' failed! err: '+err);
                return;
            }
            else{
                //csv数据二维数组
                self.csvArray = self.CSV2Array(data,",");

                //for(var i = 1;i < self.csvArray.length; i ++){
                //    //rowData表示一行的数据
                //    var rowData = self.csvArray[i];
                //    //一行有很多列，遍历，获取每一列的内容
                //    for(var j = 0; j < rowData.length; j ++){
                //        //输出i行j列数据
                //        cc.log('-----csv : '+self.csvArray[i][j]);
                //    }
                //}
            }
        });
    }catch (err){
        cc.log('-----------loadText err: '+err);
    }

};

/***
 * CSV2Array
 * @param strData
 * @param strDelimiter
 * @returns {*[]}
 * @constructor
 */
loadCSV.prototype.CSV2Array = function(strData, strDelimiter){
    strDelimiter = (strDelimiter || ",");
    var objPattern = new RegExp(
        (
            "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
            "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
            "([^\"\\" + strDelimiter + "\\r\\n]*))"
        ),
        "gi"
    );

    var arrData = [[]];
    var arrMatches = null;
    while (arrMatches = objPattern.exec( strData )){
        var strMatchedDelimiter = arrMatches[ 1 ];
        if (
            strMatchedDelimiter.length &&
            (strMatchedDelimiter != strDelimiter)
        ){
            arrData.push( [] );
        }
        if (arrMatches[ 2 ]){
            var strMatchedValue = arrMatches[ 2 ].replace(
                new RegExp( "\"\"", "g" ),
                "\""
            );
        } else {
            var strMatchedValue = arrMatches[ 3 ];
        }
        arrData[ arrData.length - 1 ].push( strMatchedValue );
    }
    return arrData;
};

/**
 *
 * @param row
 * @param key //列名
 */
loadCSV.prototype.getStrByKeyFromArray = function(row, key){
    for(var i = 0; i < this.csvArray[0].length; i++){
        if (this.csvArray[0][i] == key){
            return  this.csvArray[row+1][i];
        }
    }
    return  "";
};

/***
 * 获取某行的str
 * @param strData
 * @param strDelimiter
 * @param row
 * @param key //列名
 * @returns {*}
 */
loadCSV.prototype.getStrByRowAndKeyFromCSV = function( strData, strDelimiter, row, key ) {
    strDelimiter = (strDelimiter || ",");
    var objPattern = new RegExp(
        (
            "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +

            "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +

            "([^\"\\" + strDelimiter + "\\r\\n]*))"
        ),
        "gi"
    );
    var arrData = [[]];
    var arrMatches = null;
    while (arrMatches = objPattern.exec( strData )){
        var strMatchedDelimiter = arrMatches[ 1 ];
        if (
            strMatchedDelimiter.length &&
            (strMatchedDelimiter != strDelimiter)
        ){
            arrData.push( [] );
        }
        if (arrMatches[ 2 ]){
            var strMatchedValue = arrMatches[ 2 ].replace(
                new RegExp( "\"\"", "g" ),
                "\""
            );
        } else {
            var strMatchedValue = arrMatches[ 3 ];
        }
        arrData[ arrData.length - 1 ].push( strMatchedValue );
    }
    for(var i = 0; i<arrData[0].length; i++){
        if (arrData[0][i] == key){
            return  arrData[row+1][i]
        }
    }
    return  "";
};