/**
 * Created by mintao on 16/4/14.
 * 添加radiobtn
 * 绑定radio
 */

var FYRadioButton = ccui.Button.extend({
    _ispressed : false,
    _radioImg : null,
    _radionormal : "",
    _radiopress : "",
    _labImg : null,
    _labNormal : '',
    _labPress : '',
    _index : 0,
    /***
     * 创建radiobtn
     * 特性:
     * @param index radiobtn在radiolayer中得index
     * @param backbg 按钮背景图片,可传入"",选中时出现
     * @param normal 按钮普通状态
     * @param press
     * @param isChoose
     * @param labnormal 按钮文字普通状态
     * @param labpress 按钮文字点击状态
     */
    ctor : function(index, backbg, normal, press, isChoose, labnormal, labpress){

        this._super();

        this._index = index;
        this._ispressed = isChoose;
        if (backbg == undefined){
            backbg = '';
        }
        this.loadTextures(backbg, backbg, "", ccui.Widget.PLIST_TEXTURE);
        this.addClickEventListener(this.FYRadioBtnCallBack);
        this.setEnabled(true);

        ///没有背景图,设置大小为按钮本身大小
        if (backbg == ""){
            var img = new ccui.ImageView(normal, ccui.Widget.PLIST_TEXTURE);
            this.setContentSize(img.getContentSize());
        }

        this._radionormal = normal;
        this._radiopress = press;
        if (labnormal != undefined){
            this._labNormal = labnormal;
        }
        if (labpress != undefined){
            this._labPress = labpress;
        }
        this.addRadioImg();

        return true;
    },


    /***
     * 添加按钮文字
     */
    addRadioImg : function(){
        this._radioImg = new ccui.ImageView(this._radionormal, ccui.Widget.PLIST_TEXTURE);
        this._radioImg.setPosition(cc.p(this.getContentSize().width/2, this.getContentSize().height/2));
        this.addChild(this._radioImg, 0, 0);

        if (this._labNormal != ''){
            this._labImg = new ccui.ImageView(this._labNormal, ccui.Widget.PLIST_TEXTURE);
            this._labImg.setPosition(cc.p(this.getContentSize().width/2, this.getContentSize().height/2));
            this.addChild(this._labImg, 0, 1);
        }

        if (this._ispressed){
            this.setRadioPressed(this);
        }
        else {
            this.setRadioNormal(this);
        }
    },


    /***
     *
     * @param sender
     * @constructor
     */
    FYRadioBtnCallBack : function(sender) {
        var parent = sender.getParent();
        parent.setPressedRadio(sender._index);

    },

    /***
     *
     * @param target
     */
    setRadioPressed : function(target){
        target.setOpacity(255);
        target._radioImg.loadTexture(target._radiopress, ccui.Widget.PLIST_TEXTURE);
        target._ispressed = true;
        if (target._labImg){
            target._labImg.loadTexture(target._labPress, ccui.Widget.PLIST_TEXTURE);
        }
    },

    /***
     *
     * @param target
     */
    setRadioNormal : function(target){
        target.setOpacity(0);
        target._radioImg.loadTexture(target._radionormal, ccui.Widget.PLIST_TEXTURE);
        target._ispressed = false;
        if (target._labImg){
            target._labImg.loadTexture(target._labNormal, ccui.Widget.PLIST_TEXTURE);
        }
    },


    /***
     * 设置按钮点击
     * @param pressed
     */
    setPressed : function(pressed){
        this._ispressed = pressed;
        if (this._ispressed){
            this.setRadioPressed(this);
        }
        else {
            this.setRadioNormal(this);
        }
    },

    /***
     *
     */
    isPressed : function(){
        return this._ispressed;
    },


    /***
     *
     * @returns {number}
     */
    getIndex : function(){
        return this._index;
    }
});


/***
 *
 */
var FYRadioBtnLayer = cc.Sprite.extend({
    _radios : [], //radio按钮数字
    _multilayer : null, //布景层
    _target:null, //代理

    /***
     *
     * @param fileName 可为''
     * @param size filename为''时需要设置
     * @returns {boolean}
     */
    ctor : function(fileName, size){
        this._super();

        this._radios = [];

        if (fileName == undefined || fileName == ''){
            this.init();
            this.setContentSize(size);
        }
        else {
            this.initWithSpriteFrameName(fileName);
        }

        return true;
    },


    /***
     * 设置代理
     * @param target
     */

    setTarget:function(target){
        this._target=target;
    },

    /**
     * 获取代理
     * @returns {null}
     */

    getTarget:function(){
        return this._target;
    },

    /***
     * 加入radio
     * @param radio
     * @param pos
     * @param anch
     */
    pushRadioBtn : function(radio, pos, anch){
        var index = radio.getIndex();
        this._radios[index] = radio;

        radio.setAnchorPoint(anch);
        radio.setPosition(pos);
        this.addChild(radio);
    },

    /***
     * 设置按钮点击
     * @param index
     */
    setPressedRadio : function(index){
        for(var i = 0; i < this._radios.length; ++ i){
            if (i == index){
                this._radios[i].setPressed(true);
                this._multilayer.switchTo(i);

                //按钮被点击之后的回调
              this._target && this._target.radioBtnTouchDown && this._target.radioBtnTouchDown(index);  //add by zhangli
            }
            else{
                this._radios[i].setPressed(false);
            }
        }
    },

    /***
     * 获取当前选中radio
     * @param index
     */
    getCurRadio : function(index){
        return this._radios[index];
    },

    /***
     * 获取当前选中radio index
     */
    getCurIndex : function(){
        for(var i = 0; i < this._radios.length; ++ i){
            var radiobtn = this._radios[i];
            if (radiobtn.isPressed()){
                return i;
            }
        }

        return 0;
    },


    /***
     * 添加radio对应层
     * @param layer
     */
    pushRadioLayer : function(layer){
        if (!this._multilayer){
            this._multilayer = new cc.LayerMultiplex();
        }

        this._multilayer.addLayer(layer);
    },


    /***
     *
     * @param pos
     * @param target
     */
    setMultilayerPos : function(pos, target){

    },

    /***
     * 绑定多布景层
     * @param multi 传入已经创建好的布景层
     */
    bindMultiLayer : function(multi){
        this._multilayer = multi;
    },

    /***
     * 获取多布景层
     */
    getMultiLayer : function(){
        return this._multilayer;
    },

    /***
     * 获取当前层
     */
    getCurLayer : function(){
        var index = this.getCurIndex();
        var curlayer = this._multilayer.switchTo(index);
        return curlayer;
    },

});