/**
 * Created by mintao on 16/5/26.
 */

/***
 * 本地存储
 * 获取声音开关
 * @returns {boolean}
 */
FYEngine.getIsOpenSound = function(){
    var IsOpenSound = cc.sys.localStorage.getItem('IsOpenSound');
    if (IsOpenSound == 'open'){
        return true;
    }
    else{
        return false;
    }
};

/****
 * 本地存储
 * 3g下加载图片开关
 * @returns {boolean}
 */
FYEngine.getIsLoadOn3G = function(){
    var IsOpenSound = cc.sys.localStorage.getItem('IsDownImg');
    if (IsOpenSound == 'open'){
        return true;
    }
    else{
        return false;
    }
};

/***
 * 修改bool类型本地存储
 * @param key string
 * @constructor
 */
FYEngine.StorageBoolItem = function(key){
    var keyvalue = cc.sys.localStorage.getItem(key);
    if (keyvalue == 'open'){
        cc.sys.localStorage.setItem(key, 'close');
    }
    else{
        cc.sys.localStorage.setItem(key, 'open');
    }
};


/***
 * 本地数据存储管理
 * 模仿UserDefault Api
 */
var FYStorage = {

    setBool : function(_key,_value){
        cc.sys.localStorage.setItem(_key,_value.toString());
    },

    setInt:function(_key,_value){
        cc.sys.localStorage.setItem(_key,_value.toString())
    },

    getInt:function(_key){
        return Number(cc.sys.localStorage.getItem(_key))
    },

    setString:function(_key,_value){
        cc.sys.localStorage.setItem(_key,_value)
    },

    getString:function(_key){
        return cc.sys.localStorage.getItem(_key)
    },

    setObject:function(_key,_value){
        cc.sys.localStorage.setItem(_key,JSON.stringify(_value))
    },

    getObject:function(_key){
        return JSON.parse(cc.sys.localStorage.getItem(_key))
    },

};