/**
 * Created by PhoneU on 16/5/6.
 * 头像精灵
 * 包含模板框
 * 继承自Widget,保证listview等ui控件可用
 */


FYEngine.WebImage = ccui.Widget.extend({
    _userId: 0,
    _facestatus: 0, //0:未审核 1:审核通过
    _faceId: null,
    _singleup: false,
    _out: false,

    /****
     * 头像
     * @param bgname 头像框 string // 或者是node  也可以不传
     * @param stencilname 头像模板 string // 或者是node
     * @param defaulthead 默认头像 // 0-3
     * @param facestatus 头像审核状态
     * @param faceid 头像id string
     * @param userid 存储网络图片的标志
     * @param picType 1 大图,默认小图
     * @returns {boolean}
     */
    ctor: function (bgname, stencilname, defaulthead, facestatus, faceid, userid, outstatus, zorder, picType) {
        this._super();
        this._userId = userid;
        this._faceId = faceid;
        this._facestatus = facestatus;
        this._picType = picType || 0; // 0  小图 , 1 大图
        this._zorder = zorder || 0;
        this._singleup = false;
        this._out = outstatus || false;
        this.initImg(bgname, stencilname, defaulthead, facestatus, faceid);
        return true;
    },


    initImg: function (bgname, stencilname, defaulthead, facestatus, faceid) {
        var that = this;

        that.addKuang(bgname);

        that.addStencil(stencilname);

        that.addHeadSp(defaulthead, facestatus, faceid);

        if (faceid != 'default' && faceid != '' && faceid != null) {
//            cc.log('--------下载头像:'+faceid);
            if (facestatus != -1) {
                this.sendHeadUrlRequest();
                this.refreshHeadImg();
                this.schedule(this.refreshHeadImg, 1, 3);
            }
        }

    },

    refreshPic: function () {
        if (this._faceId != 'default' && this._faceId != '' && this._faceId != null) {
            if (this._facestatus == 0) {
                this.sendHeadUrlRequest();
                this.refreshHeadImg();
                this.schedule(this.refreshHeadImg, 1, 3);
            }
        }
    },


    addKuang: function (bgname) {
        var that = this;
        var sp_kuang = null;
        if (cc.isString(bgname)) {
            sp_kuang = new cc.Sprite(bgname);
        } else {
            sp_kuang = bgname;
        }
        this.setContentSize(sp_kuang.getContentSize());
        sp_kuang.setPosition(cc.p(this.width / 2, this.height / 2 * 0.95));
        this.addChild(sp_kuang, 2, 0);
        this._kuang = sp_kuang;
    },

    addStencil: function (stencilname) {
        var that = this;
        var stencil = null;
        if (cc.isString(stencilname)) {
            stencil = new cc.Sprite(stencilname);
        } else {
            stencil = stencilname;
        }
        var clipnode = new cc.ClippingNode(stencil);
        clipnode.setPosition(cc.p(this.width / 2, this.height / 2));
        clipnode.setContentSize(stencil.getContentSize());
        clipnode.setScale(stencil.getScale());
        clipnode.setAlphaThreshold(0.05);
        clipnode.setInverted(false);
        this.addChild(clipnode, this._zorder, 1);
        that._clipnode = clipnode;
    },

    addHeadSp: function (defaulthead, facestatus, faceid) {
        var that = this;
        var sp_head = new cc.Sprite(defaulthead);
        sp_head.setPosition(0, 0);
        sp_head.setScale(this._clipnode.width / sp_head.width, this._clipnode.height / sp_head.height);
        that._clipnode.addChild(sp_head);
        that._headsprite = sp_head;

        if (facestatus == -1) {
            this._headsprite.setColor(cc.color(120, 120, 120));
            var word = this.getChildByName('shenhetip');
            if (word) {
                word.removeFromParent(true);
            }
            var param = 22;
            if (this._out) {
                param = 12;
            }
            var word2 = new ccui.Text('审核失败', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), param);
            if (word2) {
                //word2.setAnchorPoint(cc.p(0,0.5));
                word2.setPosition(cc.p(this.width / 2, this.height / 2));
                word2.setColor(cc.color("c8c8c8"));
                this.addChild(word2, 0, 'shenhetip');
            }
        }

    },


    setPicType: function (type) {
        this._picType = type;
    },

    /***
     * 修改玩家头像
     * @param facestatus 头像状态
     * @param faceid 头像
     * @param userid
     */
    changeHeadImg: function (facestatus, faceid, userid) {
        this._facestatus = facestatus;
        if (facestatus == 0) {
        }
        else {
            this.sendHeadUrlRequest();
            this.schedule(this.refreshHeadImg, 1, 3, 0, 'headrefresh');
        }
    },

    /***
     * 发送url
     */
    sendHeadUrlRequest: function () {
        //cc.log('--------获取不到图片下载');
        var type = this._picType == 0 ? "small_" : "";
        var frame = cc.spriteFrameCache.getSpriteFrame(type + this._faceId + ".png");
        if (frame)return;
        var url = appglobal._downphoto + "/" + type + this._faceId;
//        cc.log('---------url:'+url);
        app.httpManager.loadImgFromUrl(url, type + this._faceId);
    },

    /***
     * 刷新网络图片
     * @param dt
     */
    refreshHeadImg: function (dt) {
        //cc.log('--------获取图片');
        var type = this._picType == 0 ? "small_" : "";
        var frame = cc.spriteFrameCache.getSpriteFrame(type + this._faceId + ".png");
        if (frame) {
            //cc.log('--------获取图片1');
            this._headsprite.setSpriteFrame(frame);
            //cc.log('--------获取图片2');
            var size = this._headsprite.getContentSize();
            this._headsprite.setScale(this._clipnode.width / size.width, this._clipnode.height / size.height);
            //cc.log('--------获取图片3');
            if (this._facestatus == 0) {
                //cc.log('--------获取图片4');
                this._headsprite.setColor(cc.color(120, 120, 120));
                if (this._singleup == false) {
                    //cc.log('--------获取图片5');
                    var word = this.getChildByName('shenhetip');
                    if (word) {
                        word.removeFromParent(true);
                    }
                    //cc.log('--------获取图片6');
                    if (this._out) {
                        //cc.log('--------获取图片7');
                        var word2 = new ccui.Text('审核中', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 12);
                        if (word2) {
                            //word2.setAnchorPoint(cc.p(0,0.5));
                            word2.setPosition(cc.p(this.width / 2 - 8, this.height / 2));
                            word2.setColor(cc.color("10fefd"));
                            this.addChild(word2, 0, 'shenhetip');
                            this.createLoadAnimat(word2, 10);
                        }
                    } else {
                        //cc.log('--------获取图片8');
                        var word2 = new ccui.Text('审核中', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
                        if (word2) {
                            //word2.setAnchorPoint(cc.p(0,0.5));
                            word2.setPosition(cc.p(this.width / 2 - 15, this.height / 2));
                            word2.setColor(cc.color("10fefd"));
                            this.addChild(word2, 0, 'shenhetip');
                            this.createLoadAnimat(word2, 22);
                        }
                    }

                    this._singleup = true;
                }
            } else if (this._facestatus == -1) {
                this._headsprite.setColor(cc.color(120, 120, 120));
                var word = this.getChildByName('shenhetip');
                if (word) {
                    word.removeFromParent(true);
                }
                var word2 = new ccui.Text('审核失败', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 22);
                if (word2) {
                    //word2.setAnchorPoint(cc.p(0,0.5));
                    word2.setPosition(cc.p(this.width / 2, this.height / 2));
                    word2.setColor(cc.color("c8c8c8"));
                    this.addChild(word2, 0, 'shenhetip');
                }
            }
            this.unschedule(this.refreshHeadImg);
        }
        else {
            this.sendHeadUrlRequest();
        }
    },

    createLoadAnimat: function (target, size) {
        //cc.log('--------获取图片9');
        var connet = target.getChildByName("conneting");
        if (connet)return;
        var node = new cc.Node();
        var point0 = new ccui.Text('.', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), size);
        point0.setColor(cc.color("10fefd"));
        var point1 = new ccui.Text('.', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), size);
        point1.setColor(cc.color("10fefd"));
        var point2 = new ccui.Text('.', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), size);
        point2.setColor(cc.color("10fefd"));
        node.addChild(point0, 2, 0);
        node.addChild(point1, 2, 1);
        node.addChild(point2, 2, 2);
        target.addChild(node, 300, "conneting");
        node.setPosition(target.width + 5, target.height * 0.5 + 3);
        point0.setPosition(0, node.height / 2);
        point1.setVisible(false);
        point2.setVisible(false);
        point1.setPosition(10, node.height / 2);
        point2.setPosition(20, node.height / 2);
        var count = 0;
        node.runAction(cc.sequence(cc.delayTime(0.5), cc.callFunc(function () {
            if (count == 3) {
                for (var i = 0; i < 3; ++i) {
                    var sp = node.getChildByTag(i);
                    sp && sp.setVisible(false);
                }
                count = 0;
            } else {
                var sp = node.getChildByTag(count);
                sp && sp.setVisible(true);
                ++count;
            }
        })).repeatForever());
        //cc.log('--------获取图片10');
    },

    /***
     * 添加触摸属性
     * @param callfunc
     */
    addHeadClickListener: function (callfunc) {
        this.setTouchEnabled(true);
        this.setSwallowTouches(true);
        this.addClickEventListener(function (sender) {
            callfunc(sender);
        });
    },

});

//排行榜使用


FYEngine.WebImage2 = ccui.Widget.extend({
    _userId: 0,
    _facestatus: 0, //0:未审核 1:审核通过
    _faceId: null,
    _count: 0,

    /****
     * 头像
     * @param bgname 头像框 string // 或者是node  也可以不传
     * @param stencilname 头像模板 string // 或者是node
     * @param defaulthead 默认头像 // 0-3
     * @param facestatus 头像审核状态
     * @param faceid 头像id string
     * @param userid 存储网络图片的标志
     * @param picType 1 大图,默认小图
     * @returns {boolean}
     */
    ctor: function (bgname, stencilname, defaulthead, facestatus, faceid, userid, zorder, picType) {
        this._super();
        this._count = 0;
        this._userId = userid;
        this._faceId = faceid;
        this._facestatus = facestatus;
        this._picType = picType || 0; // 0  小图 , 1 大图
        this._zorder = zorder || 0;
        this.initImg(bgname, stencilname, defaulthead, facestatus, faceid);
        return true;
    },


    initImg: function (bgname, stencilname, defaulthead, facestatus, faceid) {
        var that = this;

        that.addKuang(bgname);

        that.addStencil(stencilname);

        that.addHeadSp(defaulthead, facestatus, faceid);

        if (faceid != 'default' && faceid != '' && faceid != null) {
            if (facestatus == 1) {
                this.sendHeadUrlRequest();
                this.refreshHeadImg();
                this.schedule(this.refreshHeadImg, 1, 6);
            }
        }

    },


    addKuang: function (bgname) {
        var that = this;
        var sp_kuang = null;
        if (cc.isString(bgname)) {
            sp_kuang = new cc.Sprite(bgname);
        } else {
            sp_kuang = bgname;
        }
        this.setContentSize(sp_kuang.getContentSize());
        sp_kuang.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(sp_kuang, 2, 0);
        this._kuang = sp_kuang;
    },

    addStencil: function (stencilname) {
        var that = this;
        var stencil = null;
        if (cc.isString(stencilname)) {
            stencil = new cc.Sprite(stencilname);
        } else {
            stencil = stencilname;
        }
        var clipnode = new cc.ClippingNode(stencil);
        clipnode.setPosition(cc.p(this.width / 2, this.height * 0.55));
        clipnode.setContentSize(stencil.getContentSize());
        clipnode.setScale(stencil.getScale());
        clipnode.setAlphaThreshold(0.05);
        clipnode.setInverted(false);
        this.addChild(clipnode, this._zorder, 1);
        that._clipnode = clipnode;
    },

    addHeadSp: function (defaulthead, facestatus, faceid) {
        var that = this;
        var sp_head = new cc.Sprite(defaulthead);
        sp_head.setPosition(0, 0);
        sp_head.setScale(this._clipnode.width / sp_head.width, this._clipnode.height / sp_head.height);
        that._clipnode.addChild(sp_head);
        that._headsprite = sp_head;
    },


    setPicType: function (type) {
        this._picType = type;
    },

    /***
     * 修改玩家头像
     * @param facestatus 头像状态
     * @param faceid 头像
     * @param userid
     */
    changeHeadImg: function (facestatus, faceid, userid) {
        this._facestatus = facestatus;
        if (facestatus == 0) {
        }
        else {
            this.sendHeadUrlRequest();
            this.schedule(this.refreshHeadImg, 1, 3, 0, 'headrefresh');
        }
    },

    /***
     * 发送url
     */
    sendHeadUrlRequest: function () {
        var type = this._picType == 0 ? "small_" : "";
        var frame = cc.spriteFrameCache.getSpriteFrame(type + this._faceId + ".png");
        if (frame)return;
        var url = appglobal._downphoto + "/" + type + this._faceId;
        app.httpManager.loadImgFromUrl(url, type + this._faceId);
    },

    /***
     * 刷新网络图片
     * @param dt
     */
    refreshHeadImg: function (dt) {
//        cc.log("--------this._count:" +this._count);
        var type = this._picType == 0 ? "small_" : "";
        var frame = cc.spriteFrameCache.getSpriteFrame(type + this._faceId + ".png");
        if (frame) {
            this._headsprite.setSpriteFrame(frame);
            var size = this._headsprite.getContentSize();
            this._headsprite.setScale(this._clipnode.width / size.width, this._clipnode.height / size.height);
            this.unschedule(this.refreshHeadImg);
        }
        else {
            if ((this._count % 3) == 0) {
//                cc.log("--------发送" +this._count);
                this.sendHeadUrlRequest();
            }
        }
        this._count++;
    },

    /***
     * 添加触摸属性
     * @param callfunc
     */
    addHeadClickListener: function (callfunc) {
        this.setTouchEnabled(true);
        this.setSwallowTouches(true);
        this.addClickEventListener(function (sender) {
            callfunc(sender);
        });
    },

});

/**
 * 排行榜使用，大厅的排行头像框无偏移
 */
FYEngine.WebImage3 = ccui.Widget.extend({
    _userId: 0,
    _facestatus: 0, //0:未审核 1:审核通过
    _faceId: null,
    _count: 0,

    /****
     * 头像
     * @param bgname 头像框 string // 或者是node  也可以不传
     * @param stencilname 头像模板 string // 或者是node
     * @param defaulthead 默认头像 // 0-3
     * @param facestatus 头像审核状态
     * @param faceid 头像id string
     * @param userid 存储网络图片的标志
     * @param picType 1 大图,默认小图
     * @returns {boolean}
     */
    ctor: function (bgname, stencilname, defaulthead, facestatus, faceid, userid, zorder, picType) {
        this._super();
        this._count = 0;
        this._userId = userid;
        this._faceId = faceid;
        this._facestatus = facestatus;
        this._picType = picType || 0; // 0  小图 , 1 大图
        this._zorder = zorder || 0;
        this.setCascadeOpacityEnabled(true);
        this.initImg(bgname, stencilname, defaulthead, facestatus, faceid);
        return true;
    },


    initImg: function (bgname, stencilname, defaulthead, facestatus, faceid) {
        var that = this;

        that.addKuang(bgname);

        that.addStencil(stencilname);

        that.addHeadSp(defaulthead, facestatus, faceid);

        if (faceid != 'default' && faceid != '' && faceid != null) {
            if (facestatus == 1) {
                this.sendHeadUrlRequest();
                this.refreshHeadImg();
                this.schedule(this.refreshHeadImg, 1, 6);
            }
        }

    },


    addKuang: function (bgname) {
        var that = this;
        var sp_kuang = null;
        if (cc.isString(bgname)) {
            sp_kuang = new cc.Sprite(bgname);
        } else {
            sp_kuang = bgname;
        }
        this.setContentSize(sp_kuang.getContentSize());
        sp_kuang.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(sp_kuang, 2, 0);
        this._kuang = sp_kuang;
    },

    addStencil: function (stencilname) {
        var that = this;
        var stencil = null;
        if (cc.isString(stencilname)) {
            stencil = new cc.Sprite(stencilname);
        } else {
            stencil = stencilname;
        }
        var clipnode = new cc.ClippingNode(stencil);
        clipnode.setCascadeOpacityEnabled(true);
        clipnode.setPosition(cc.p(this.width / 2, this.height * 0.5));
        clipnode.setContentSize(stencil.getContentSize());
        clipnode.setScale(stencil.getScale());
        clipnode.setAlphaThreshold(0.05);
        clipnode.setInverted(false);
        this.addChild(clipnode, this._zorder, 1);
        that._clipnode = clipnode;
    },

    addHeadSp: function (defaulthead, facestatus, faceid) {
        var that = this;
        var sp_head = new cc.Sprite(defaulthead);
        sp_head.setPosition(0, 0);
        sp_head.setScale(this._clipnode.width / sp_head.width, this._clipnode.height / sp_head.height);
        that._clipnode.addChild(sp_head);
        that._headsprite = sp_head;
    },


    setPicType: function (type) {
        this._picType = type;
    },

    /***
     * 修改玩家头像
     * @param facestatus 头像状态
     * @param faceid 头像
     * @param userid
     */
    changeHeadImg: function (facestatus, faceid, userid) {
        this._facestatus = facestatus;
        if (facestatus == 0) {
        }
        else {
            this.sendHeadUrlRequest();
            this.schedule(this.refreshHeadImg, 1, 3, 0, 'headrefresh');
        }
    },

    /***
     * 发送url
     */
    sendHeadUrlRequest: function () {
        var type = this._picType == 0 ? "small_" : "";
        var frame = cc.spriteFrameCache.getSpriteFrame(type + this._faceId + ".png");
        if (frame)return;
        var url = appglobal._downphoto + "/" + type + this._faceId;
        cc.log("---getheadurl:" + url);
        app.httpManager.loadImgFromUrl(url, type + this._faceId);
    },

    /***
     * 刷新网络图片
     * @param dt
     */
    refreshHeadImg: function (dt) {
//        cc.log("--------this._count:" +this._count);
        var type = this._picType == 0 ? "small_" : "";
        var frame = cc.spriteFrameCache.getSpriteFrame(type + this._faceId + ".png");
        if (frame) {
            this._headsprite.setSpriteFrame(frame);
            var size = this._headsprite.getContentSize();
            this._headsprite.setScale(this._clipnode.width / size.width, this._clipnode.height / size.height);
            this.unschedule(this.refreshHeadImg);
        }
        else {
            if ((this._count % 3) == 0) {
//                cc.log("--------发送" +this._count);
                this.sendHeadUrlRequest();
            }
        }
        this._count++;
    },

    /***
     * 添加触摸属性
     * @param callfunc
     */
    addHeadClickListener: function (callfunc) {
        this.setTouchEnabled(true);
        this.setSwallowTouches(true);
        this.addClickEventListener(function (sender) {
            callfunc(sender);
        });
    },

});

FYEngine.rangkImage = FYEngine.WebImage2.extend({
    ctor: function (bgname, stencilname, defaulthead, facestatus, faceid, userid, zorder, picType) {
        if (faceid != '' && faceid != null && facestatus == 1) {
            defaulthead = '#rankup041.png';
        }
        this._super(bgname, stencilname, defaulthead, facestatus, faceid, userid, zorder, picType);
    }
});

FYEngine.rangkImageForNewRank = FYEngine.WebImage3.extend({
    ctor: function (bgname, stencilname, defaulthead, facestatus, faceid, userid, zorder, picType) {
        if (faceid != '' && faceid != null && facestatus == 1) {
            defaulthead = '#fishranknew_6.png';
        }
        this._super(bgname, stencilname, defaulthead, facestatus, faceid, userid, zorder, picType);
    }
});


FYEngine.FightImage = ccui.Widget.extend({
    _userId: 0,
    _facestatus: 0, //0:未审核 1:审核通过
    _faceId: null,
    _singleup: false,
    _out: false,
    _defaulthead: null,
    _stencilname :null,
    /****
     * 头像
     * @param bgname 头像框 string // 或者是node  也可以不传
     * @param stencilname 头像模板 string // 或者是node
     * @param defaulthead 默认头像 // 0-3
     * @param facestatus 头像审核状态
     * @param faceid 头像id string
     * @param userid 存储网络图片的标志
     * @param picType 1 大图,默认小图
     * @returns {boolean}
     */
    ctor: function (bgname, stencilname, defaulthead,active) {
        this._super();
        this._defaulthead = defaulthead;
        this._stencilname = stencilname;
        this._picType = 0; // 0  小图 , 1 大图
        this._zorder = 0;
        this._singleup = false;
        this._out = false;
        this._faceId =-1;
        this.initImg(bgname, stencilname,active);
        return true;
    },


    initImg: function (bgname, stencilname,active) {
        var that = this;

        that.addKuang(bgname);

        that.addStencil(stencilname);

        that.addHeadSp(stencilname);

        that.addWaitTip(active);

    },

    playerLeave: function () {
        cc.log("playerLeave"+this._faceId);
        this._faceId =-1;
        this.unschedule(this.refreshHeadImg);
        if (this._waittip) {
            this._waittip.setVisible(true);
        }
        this._headsprite.setSpriteFrame(""+this._stencilname);//玩家离开时候，头像恢复成等待状态
        this._headsprite.setScale(this._clipnode.width /  this._headsprite.width, this._clipnode.height /  this._headsprite.height);
    },

    playerJoin: function (faceid) {
        cc.log("playerJoin"+faceid);
        if(this._faceId == faceid){
            return;
        }
        this._faceId = faceid;
        if (this._waittip) {
            this._waittip.setVisible(false);

        }
        if (faceid != 'default' && faceid != '' && faceid != null) {//玩家进一定是等待状态，等待下载。
            this.sendHeadUrlRequest();
            this.refreshHeadImg();
            this.schedule(this.refreshHeadImg, 1, 6);
        }else{//如果玩家没有头像，设置为默认头像
            this._headsprite.setSpriteFrame(""+this._defaulthead);
            this._headsprite.setScale(this._clipnode.width /  this._headsprite.width, this._clipnode.height /  this._headsprite.height);

        }
    },

    addWaitTip: function (active) {
        var name  = active == true?"#fish_fight_res54.png" : "#fish_fight_res49.png";
        var tip = this._waittip = new cc.Sprite(name);
        if (tip) {
            this.addChild(tip, 10, "waittip");
            tip.setPosition(cc.p(this.width / 2, this.height / 2));
        }
    },

    addKuang: function (bgname) {
        var that = this;
        var sp_kuang = null;
        if (cc.isString(bgname)) {
            sp_kuang = new cc.Sprite("#"+bgname);
        } else {
            sp_kuang = bgname;
        }
        this.setContentSize(sp_kuang.getContentSize());
        sp_kuang.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(sp_kuang, 2, 0);
        this._kuang = sp_kuang;
    },

    addStencil: function (stencilname) {
        var that = this;
        var stencil = null;
        if (cc.isString(stencilname)) {
            stencil = new cc.Sprite("#"+stencilname);
        } else {
            stencil = stencilname;
        }
        var clipnode = new cc.ClippingNode(stencil);
        clipnode.setPosition(cc.p(this.width / 2, this.height / 2));
        clipnode.setContentSize(stencil.getContentSize());
        clipnode.setScale(stencil.getScale());
        clipnode.setAlphaThreshold(0.05);
        clipnode.setInverted(false);
        this.addChild(clipnode, this._zorder, 1);
        that._clipnode = clipnode;
    },

    addHeadSp: function (stencilname) {
        var that = this;
        var sp_head = new cc.Sprite("#"+stencilname);
        sp_head.setPosition(0, 0);
        sp_head.setScale(this._clipnode.width / sp_head.width, this._clipnode.height / sp_head.height);
        that._clipnode.addChild(sp_head);
        that._headsprite = sp_head;
    },


    /***
     * 发送url
     */
    sendHeadUrlRequest: function () {
        //cc.log('--------获取不到图片下载');
        var type = this._picType == 0 ? "small_" : "";
        var frame = cc.spriteFrameCache.getSpriteFrame(type + this._faceId + ".png");
        if (frame)return;
        var url = appglobal._downphoto + "/" + type + this._faceId;
        cc.log('---------url:'+url);
        app.httpManager.loadImgFromUrl(url, type + this._faceId);
    },

    /***
     * 刷新网络图片
     * @param dt
     */
    refreshHeadImg: function (dt) {
        //cc.log('--------获取图片');
        var type = this._picType == 0 ? "small_" : "";
        var frame = cc.spriteFrameCache.getSpriteFrame(type + this._faceId + ".png");
        if (frame) {
            this.unschedule(this.refreshHeadImg);
            this._headsprite.setSpriteFrame(frame);
            var size = this._headsprite.getContentSize();
            this._headsprite.setScale(this._clipnode.width / size.width, this._clipnode.height / size.height);
        }
        else {
            this.sendHeadUrlRequest();
        }
    },


});