/**
 * Created by mintao on 16/5/26.
 */

var MaxContentLen = 2048;//消息不会超过2048的大小

var ByteBuffer = cc.Class.extend({
    _buf  : null,   // ArrayBuffer
    _view : null,
    _rpos : 0,
    _wpos : 0,
    _little_order : true,   // default by little endian
    _buflen : 0,
    ///read ByteArray -> ArrayBuffer
    _u8aBuf : null,

    ctor : function(){
        this.initData();
    },

    initData : function(){
        this._rpos = 0;
        this._wpos = 0;
        this._little_order = true;   // default by little endian
        this._buflen = 0;
    },

    initWriteBuffer : function ()
    {
        this._buf  = new ArrayBuffer(MaxContentLen);
        this._view = new DataView(this._buf);
    },

    initReadBuffer : function (){
        this._buf  = new ArrayBuffer(MaxContentLen);
        this._u8aBuf = new Uint8Array(this._buf);
        this._view = new DataView(this._buf);
    },

    setReadBuffer : function(byteArray){
        this.clearBuffer();
        this._buflen = byteArray.length;
        this._u8aBuf.set(byteArray, 0);

    },

    clearBuffer : function(){
        this._buflen = 0;
        this._u8aBuf.set([], 0);
    },

    getWriteBuffer : function(){
        return this._buf.slice(0, this._wpos);
    },

    setLittleOrder : function(b) {
        this._little_order = b;
    },

    isLittleOrder : function() {
        return this._little_order;
    },

    getArrayBuffer : function(){
        return this._buf;
    },

    setReadPos : function(rpos) {
        this._rpos = rpos;
        return this._rpos;
    },

    getReadPos: function()
    {
        return this._rpos;
    },

    setWritePos : function(wpos) {
        this._wpos = wpos;
        return this._wpos;
    },

    getWritePos: function()
    {
        return this._wpos;
    },

    getBufLength : function(){
        return this._buflen;
    },

    getFloat32 : function() {
        var fVal = this._view.getFloat32( this._rpos, this.isLittleOrder() );
        this.setReadPos( this._rpos + 4 );
        return fVal;
    },

    getFloat64 : function() {
        var fVal = this._view.getFloat64( this._rpos, this.isLittleOrder() );
        this.setReadPos( this._rpos + 8 );
        return fVal;
    },

    getInt8 : function() {
        var iVal = this._view.getInt8( this._rpos );
        this.setReadPos( this._rpos + 1 );
        return iVal;
    },

    getInt16 : function() {
        var iVal = this._view.getInt16( this._rpos, this.isLittleOrder() );
        this.setReadPos( this._rpos + 2 );
        return iVal;
    },

    getInt32 : function() {
        var iVal = this._view.getInt32( this._rpos, this.isLittleOrder() );
        this.setReadPos( this._rpos + 4 );
        return iVal;
    },

    getInt64 : function(){
        var lo = this.getInt32();
        var hi  = this.getInt32();
        var int64 = Int64.setInt64(hi,lo);
       // cc.log('----getInt64 lo:'+lo+'----hi:'+hi+'------int64: '+int64);
        return int64;

        // var lo = this.getUint32();
        // var hi  = this.getUint32();
        // // cc.log('----getUint64 lo:'+lo+'----hi:'+hi+'------int64: '+Int64.setInt64(hi,lo));
        // return Int64.setInt64(hi,lo);

    },

    getUint64 : function(){
        var lo = this.getUint32();
        var hi  = this.getUint32();
        // cc.log('----getUint64 lo:'+lo+'----hi:'+hi+'------int64: '+Int64.setInt64(hi,lo));
        return Int64.setInt64(hi,lo);
    },


    getUint8 : function() {
        var iVal = this._view.getUint8( this._rpos );
        this.setReadPos( this._rpos + 1 );
        return iVal;
    },

    getUint16 : function() {
        var iVal = this._view.getUint16( this._rpos, this.isLittleOrder() );
        this.setReadPos( this._rpos + 2 );
        return iVal;
    },

    getUint32 : function() {
        var iVal = this._view.getUint32( this._rpos, this.isLittleOrder() );
        this.setReadPos( this._rpos + 4 );
        return iVal;
    },

    setFloat32 : function(value) {
        this._view.setFloat32( this._wpos, value, this.isLittleOrder() );
        this.setWritePos( this._wpos + 4 );
    },

    setFloat64 : function(value) {
        this._view.setFloat64( this._wpos, value, this.isLittleOrder() );//
        this.setWritePos( this._wpos + 8 );
    },

    setInt8 : function(value) {
        this._view.setInt8( this._wpos, value );
        this.setWritePos( this._wpos + 1 );
    },

    setInt16 : function(value) {
        this._view.setInt16( this._wpos, value, this.isLittleOrder() );
        this.setWritePos( this._wpos + 2 );
    },

    setInt32 : function(value) {
        this._view.setInt32( this._wpos, value, this.isLittleOrder() );
        this.setWritePos( this._wpos + 4 );
    },

    setInt64 : function(value){
        var lo = Int64.getInt64lo(value);
        var hi = Int64.getInt64hi(value);
        this.setInt32(lo);
        this.setInt32(hi);
    },

    setUint64 : function(value){
        var lo = Int64.getInt64lo(value);
        var hi = Int64.getInt64hi(value);
        this.setUint32(lo);
        this.setUint32(hi);
    },

    setUint8 : function(value) {
        this._view.setUint8( this._wpos, value );
        this.setWritePos( this._wpos + 1 );
    },

    setUint16 : function(value) {
        this._view.setUint16( this._wpos, value, this.isLittleOrder() );
        this.setWritePos( this._wpos + 2 );
    },

    setUint32 : function(value) {
        this._view.setUint32( this._wpos, value, this.isLittleOrder() );
        this.setWritePos( this._wpos + 4 );
    },


    setFixedString : function(value,fixedLen){
        value = utf16to8(value);// this.unicode2utf8(value);//
        var strLen = value.length;
        for (var i = 0; i < strLen; ++ i){
            this.setUint8(value.charCodeAt(i));
        }

        var leftCount = fixedLen - strLen;
        for (var i = 0; i < leftCount; ++ i){
            this.setUint8(0);
        }
    },

    getFixedString : function(fixedLen){
        // return this.getJsString(fixedLen);

         var utf8_array = [];
         var bpush = true;
         for (var i = 0; i < fixedLen; ++ i){
            var ch = this.getUint8();
            if(ch == 0){
                bpush = false;
                continue;
            }

             if (bpush){
                 utf8_array.push(ch);
             }
         }
         utf8_array.push(0);
         return app.coreservice.utf82unicdoe(utf8_array);
    },

    getJsString : function(fixedLen){
        var utf8_array = '';
        var bpush = true;
        for (var i = 0; i < fixedLen; ++ i){
            var ch = this.getUint8();
            if(ch == 0){
                bpush = false;
                continue;
            }

            if (bpush){
                utf8_array += String.fromCharCode(ch);
            }
        }
        utf8_array += '\0';
        return utf8to16(utf8_array);
    },

    getString : function(Len){
        var utf8_array = '';
        var bpush = true;
        for (var i = 0; i < Len; ++ i){
            var ch = this.getUint8();
            if(ch == 0){
                bpush = false;
                continue;
            }

            if (bpush){
                utf8_array += String.fromCharCode(ch);
            }
        }
        utf8_array += '\0';
        return utf8_array;
    },

    setString : function(value, len){
        var strLen = value.length;
        for (var i = 0; i < strLen; ++ i){
            var ch = value.charCodeAt(i);
            this.setUint8(ch);
        }

        var leftCount = len - strLen;
        for (var i = 0; i < leftCount; ++ i){
            this.setUint8(0);
        }
    },

    unicode2utf8: function (strInUni) {
        if (null == strInUni)
            return '';
        var strUni = String(strInUni);
        var strUTF8 = String();
        for (var i = 0; i < strUni.length; i++) {
            var wchr = strUni.charCodeAt(i);
            if (wchr < 0x80) {
                strUTF8 += strUni.charAt(i);
            }
            else if (wchr < 0x800) {
                var chr1 = wchr & 0xff;
                var chr2 = (wchr >> 8) & 0xff;
                strUTF8 += String.fromCharCode(0xC0 | (chr2 << 2) | ((chr1 >> 6) & 0x3));
                strUTF8 += String.fromCharCode(0x80 | (chr1 & 0x3F));
            }
            else {
                var chr1 = wchr & 0xff;
                var chr2 = (wchr >> 8) & 0xff;
                strUTF8 += String.fromCharCode(0xE0 | (chr2 >> 4));
                strUTF8 += String.fromCharCode(0x80 | ((chr2 << 2) & 0x3C) | ((chr1 >> 6) & 0x3));
                strUTF8 += String.fromCharCode(0x80 | (chr1 & 0x3F));
            }
        }
        return strUTF8;
    },

});



