/**
 * Created by garychen on 16/3/10.
 */

var eClientId = {
    CLIENT_LOBBY  : 1,
    CLIENT_GAME   : 2,
    CLIENT_SOCIAL : 3,
};

///加密方式
var EntryptType = {
    Entrypt_None : 0,
    Entrypt_Rsa : 1,
    Entrypt_Aes : 2,
};

var CoreServiceProxy = cc.Node.extend({
    clientMgr : null,
    handlerMgr : null,
    heartCount : 0,

    ctor : function(){
        this._super();

        cc.director.getScheduler().scheduleUpdateForTarget(this, 1, false);

        this.initClientMgr();
        this.initHandlerMgr();
    },

    initClientMgr : function(){
        this.clienMgr = new ClientManager();

        var clientLobby = app.coreservice.createClientThread(eClientId.CLIENT_LOBBY);
        this.clienMgr.addClient(eClientId.CLIENT_LOBBY,clientLobby);

        var clientGame = app.coreservice.createClientThread(eClientId.CLIENT_GAME);
        this.clienMgr.addClient(eClientId.CLIENT_GAME,clientGame);

        var clientSocial = app.coreservice.createClientThread(eClientId.CLIENT_SOCIAL);
        this.clienMgr.addClient(eClientId.CLIENT_SOCIAL, clientSocial);
    },

    initHandlerMgr : function(){
        this.handlerMgr = new ClientHandlerMgr();
    },

    addLobbyHandler : function(handler){
        this.handlerMgr && this.handlerMgr.addHandler(eClientId.CLIENT_LOBBY,handler);
    },

    getLobbyHandler : function(){
        return  this.handlerMgr.getHandler(eClientId.CLIENT_LOBBY);
    },

    addGameHandler : function(handler)
    {
        this.handlerMgr && this.handlerMgr.addHandler(eClientId.CLIENT_GAME, handler);
    },

    getGameHandler : function(){
        return  this.handlerMgr.getHandler(eClientId.CLIENT_GAME);
    },

    removeGameHandler : function(){
        this.handlerMgr.removeHandler(eClientId.CLIENT_GAME);
    },

    addSocialHandler : function(handler){
        this.handlerMgr && this.handlerMgr.addHandler(eClientId.CLIENT_SOCIAL, handler);
    },

    getSocialHandler : function(){
        return  this.handlerMgr.getHandler(eClientId.CLIENT_SOCIAL);
    },

    update : function(dt) {
        ///轮询发送js消息
        var handlers = this.handlerMgr.getHandlers();
        for (var i in handlers){
            if (handlers[i]){
                handlers[i].onSendAllMsg(dt);
            }
        }

        ///轮询获取c++消息
        app.coreservice.update(dt);
    },

    getClientLobby : function() {
        return this.clienMgr.getClient(eClientId.CLIENT_LOBBY);
    },

    getClientGame : function() {
        return this.clienMgr.getClient(eClientId.CLIENT_GAME);
    },

    getClientSocial : function(){
        return this.clienMgr.getClient(eClientId.CLIENT_SOCIAL);
    },

    removeClientGame : function(){
        if (this.clientMgr){
            this.clientMgr.removeClient(eClientId.CLIENT_GAME);
        }
    },

    linkLobbyClient : function(accessinfo){
        var client = this.getClientLobby();
        var access = accessinfo.split(':');
        client.setAccessInfo(access[0], parseInt(access[1]));
        client.start();
    },

    linkSocialClient : function(accessinfo){
        var client = this.getClientSocial();
        var access = accessinfo.split(':');
        client.setAccessInfo(access[0], parseInt(access[1]));
        client.start();
    },

    linkGameClinet : function(accessinfo){
        var client = this.getClientGame();
        var access = accessinfo.split(':');
        client.setAccessInfo(access[0], parseInt(access[1]));
        client.start();
    },

    unlinkLobbyClient : function(){
        var handler = this.getLobbyHandler();
        handler && handler.closeClient();
        this.handlerMgr.removeHandler(eClientId.CLIENT_LOBBY);
    },

    unlinkSocialClient : function () {
        var handler = this.getSocialHandler();
        handler && handler.closeClient();
    },

    unlinkGameClient : function(){
        var handler = this.getGameHandler();
        handler && handler.closeClient();
        this.removeClientGame();
        this.removeGameHandler();
    },

    onConnectionMsg : function(clientId, eventId, eventParam){
        var client = this.clienMgr.getClient(clientId);
        var handler = this.handlerMgr.getHandler(clientId);
        if (handler){
            handler.setClient(client);
            handler.onConnectionMsg(eventId, eventParam);
        }
    },

    onFishEventJson : function(clientId, jsonParam){
        var client = this.clienMgr.getClient(clientId);
        var handler = this.handlerMgr.getHandler(clientId);
        if (handler) {
            handler.setClient(client);
            handler.onFishEventJson(jsonParam);
        }
    },

    getUserInfo : function() {
        return app.coreservice.getUserInfo();
    },

    reconnetClient : function(){
        ///轮询发送js消息
        var handlers = this.handlerMgr.getHandlers();
        for (var i in handlers){
            if (handlers[i]){
                handlers[i].reconnClient();
            }
        }
    }

});


s_coreserviceProxy = null;
CoreServiceProxy.getInstance = function (){
    if( s_coreserviceProxy == null ){
        s_coreserviceProxy = new CoreServiceProxy();
    }
    return s_coreserviceProxy;
};
