


var LobbyProtocol = {
    LobbyProto      : 14, //大厅主协议
    PlayerLogin     : 0,
    PlayerLogout    : 1,
    BackToLobby     : 2,
    PlayerReLogin   : 3,

    ListProto       : 11, //列表主协议
    GameList        : 0,
    AroundList      : 1,
    CacheBroadList  : 8 ,//缓存的兑奖列表
    FreeRoomRank    :9, //免费场排名
    SelfRank        :10,//免费场当前自己排名
    FreeRoomList    :11,//免费场的列表

    GameInfoProto   : 13, //游戏信息主协议
    GameInfo        : 0,
    Treasure        : 1, //财富刷新
    ReliveConf      : 2,  //救济金配置
    PayNotice       : 10, //充值服务器通知
    GetCrystalInfo  : 4,  //获取水晶数量
    PlayerSign      :12,  //用户签名
    GetPhoneNum     :13,  //手机号获取
    GetTicketQty    :14,//获取免费门票数量
    QueryDailyCharge:15, //查询当天充值额度
    GetVIPcfg       :16, //获取vip配置信息
    QueryVIPinfo    :17, //查询自己的vip信息
    QueryCheckinCfg :18, // 查询签到配置
    GetCheckinStatu :19,//查询是否能签到
    FUBEN2_COIN_GET: 20,  //副本2财富获取
    FUBEN2_SYLZ_CFG: 21,    //深渊领主配置
    FUBEN2_JZSJ_CFG: 22,    //精准射击配置
    FUBEN2_OPENBOX_CFG: 23, //开宝箱配置
    FUBEN2_BUY_BOX_CFG: 24, //购买宝箱
    FUBEN2_OPENBOX: 25,   //开宝箱
    SCORE_EX_GET :26,   //积分兑换查询

    ModuleInfoProto : 12, //周边功能主协议
    BindAccount     : 0, //绑定帐号
    CheckAccount    : 1, //检验帐号
    ModPass         : 2, //修改密码
    ModNick         : 3, //修改昵称
    ChangeHead      : 5, //更换头像
    TurnTable       : 11, //转盘
    Relive          : 12, //救济金
    Exchange        : 15, //兑换
    Pay             : 18,  //充值订单
    GiveCrystal     : 14, //水晶
    CheckUID        : 21, //检查UID
    CrystalPushInfo : 22, //水晶推送消息
    EditSign        : 4,   //修改签名
    ExchangeIntergral : 23, //积分兑换
    BindPhone       :24, //绑定手机
    UnBindPhone     :25, //解绑手机
    GetMail             :27, //获取邮件
    ServerPushMail      :28, //服务器推送邮件
    ChangeMailStatus    :29,//更该邮件状态
    GetTool            : 30,//获取道具列表
    ExchangeTool       :33, //道具兑换
    CheckIn            :37, //捕鱼签到




    BroadProto      : 15, //大厅广播
    BroadMsg        : 0 ,

    ServerKick      :100,//
    Kick            :7,

    HallExternalProto : 107,    //周边功能主协议
    GetActiveStatus   :21, //获取活跃度


};


/***
 * 大厅登录
 * @type {{lUserId: number, szToken: string}}
 */
LobbyProtocol.PlayerLoginReq = {
    lUserId : 0, //int64
    szToken : '', //32
};

LobbyProtocol.PlayerLoginRsp = {
    iResult : 0, //int32
    iSourceId : 0, //int32
    lUserId : 0, //int64
    lRoleId : 0, //int64
    szNickName : '',//32
    szFaceId : '', //32
    szIMEI : '', //32
    szGameToken : '', //
    iFaceStatus : 0,//int32
    iGender : 0, //int32
    iTotalPay : 0, //int32
    iStatus : 0, //int32
    lGold : 0, //int64
    lCoupon : 0,
    lScore : 0,
    lExp : 0,
    szSign : 0,//128
};

LobbyProtocol.PlayerReLoginRsp = {
    iResult : 0, //int32
    iTotalPay : 0, //int32
    iStatus : 0, //int32
    lGold : 0, //int64
    lCoupon : 0,
    lScore : 0,
    lExp : 0,
};

LobbyProtocol.encode_PlayerLogon = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setFixedString(req.szToken, FYEngine.TokenLen);
//    FYEngine.logObject(req, '------encode_PlayerLogon : ');
};

LobbyProtocol.encode_PlayerReLogin = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setFixedString(req.szToken, FYEngine.TokenLen);
//    FYEngine.logObject(req, '------encode_PlayerReLogon : ');
};

LobbyProtocol.encode_BackToLobby = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iSourceId);

//    FYEngine.logObject(req, '------encode_BackToLobby : ');
};

LobbyProtocol.decode_PlayerLogon = function(byteBuf){
    var rsp = createObj(LobbyProtocol.PlayerLoginRsp);
    rsp.iResult = byteBuf.getInt32();
    rsp.iSourceId = byteBuf.getInt32();
    rsp.lUserId = byteBuf.getInt64();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.szNickName = byteBuf.getFixedString(FYEngine.NickNameLen);
    rsp.szFaceId = byteBuf.getFixedString(FYEngine.FaceIdLen);
    rsp.szIMEI = byteBuf.getFixedString(FYEngine.ImeiLen);
    rsp.szGameToken = byteBuf.getFixedString(FYEngine.TokenLen);
    rsp.iFaceStatus = byteBuf.getInt32();
    rsp.iGender = byteBuf.getInt32();
    rsp.iTotalPay = byteBuf.getInt32();
    rsp.iStatus = byteBuf.getInt32();
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    rsp.lScore = byteBuf.getUint64();
    rsp.lExp = byteBuf.getUint64();
    rsp.szSigned = byteBuf.getFixedString(FYEngine.SignLen);

//    FYEngine.logObject(rsp, '----------登录 : ');
    return rsp;
};

LobbyProtocol.decode_PlayerReLogin = function(byteBuf){
  var rsp = createObj(LobbyProtocol.PlayerReLoginRsp);
    rsp.iResult = byteBuf.getInt32();
    rsp.iTotalPay = byteBuf.getInt32();
    rsp.iStatus = byteBuf.getInt32();
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    rsp.lScore = byteBuf.getUint64();
    rsp.lExp = byteBuf.getUint64();
    return rsp;
};


/***
 * 游戏列表
 * @type {{iSourceId: number, iVersion: number}}
 */
LobbyProtocol.GameListReq = {
    lRoleId : 0
};

var TGameInfo = {
    iType : 0,   //房间场次 初级中级高级
    iLength : 0 //当前游戏人数
};

LobbyProtocol.GameListRsp = {
    iResult : 0,
    iCount : 0, //int32
    game : []   //[]
};

LobbyProtocol.encode_GameListReq = function (req, bb) {
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

LobbyProtocol.decode_GameListRsp = function (byteBuf) {
    var rsp = createObj(LobbyProtocol.GameListRsp);
    rsp.iResult = byteBuf.getInt32();
    rsp.iCount = byteBuf.getInt32();
    rsp.game = [];
    for (var i = 0; i < rsp.iCount; ++ i){
        var info = createObj(TGameInfo);
        info.iType = byteBuf.getInt32();
        info.iLength = byteBuf.getInt32();
        rsp.game.push(info);
    }
    return rsp;
};

/***
 * 游戏信息
 * @type {{iSourceId: number, iGameId: number}}
 */
LobbyProtocol.GameInfoReq = {
    lRoleId : 0,
    iSourceId : 0, //int32
    iType : 0 //场次id
};

LobbyProtocol.GameInfoRsp = {
    iResult : 0,
    iType : 0,
    szName : '',   //32
    szIP : '',     //游戏接入IP 32
    iPort : 0,     //游戏接入端口
    szParams : ''  //256
};

LobbyProtocol.encode_GameInfoReq = function (req, bb) {
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iSourceId);
    bb.setInt32(req.iType);
};

LobbyProtocol.decode_GameInfoRsp = function (byteBuf) {
    var rsp = createObj(LobbyProtocol.GameInfoRsp);
    rsp.iResult = byteBuf.getInt32();
    rsp.iType = byteBuf.getInt32();
    rsp.szName = byteBuf.getFixedString(32);
    rsp.szIP = byteBuf.getFixedString(32);
    rsp.iPort = byteBuf.getInt32();
    rsp.szParams = byteBuf.getFixedString(256);
    return rsp;
};
//奖券兑换消息发送
LobbyProtocol.exchangeReq = {
    lRoleId : 0,           //角色ID
    lCoupon : 0,           //奖券
    iGoodsId : 0,          //商品ID
    szIMEI : 0,            //手机IMEI
    szMobile : 0,          //手机号码
    szPostCode :'',        //邮政编码
    szAddress : '',        //地址
    szRealName : '',       //真实姓名
    szOtherMsg :''
};

LobbyProtocol.exchangeRsp = {
    //RoleId : 0,           //角色ID
    iResult : 0,           //结果
    iGoodsId : 0,          //商品ID
    szGoodsName : '',       //商品名字
    //GoodsQty : 0,         //数量
    lPayCount : 0,
    iType : 0,
    iCount : 0,

};
LobbyProtocol.encode_ExchangeProduct = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt64(req.lCoupon);
    bb.setInt32(req.iGoodsId);
    bb.setFixedString(req.szIMEI,32);
    bb.setFixedString(req.szMobile, 64);
    bb.setFixedString(req.szPostCode, 16);
    bb.setFixedString(req.szAddress, 256);
    bb.setFixedString(req.szRealName, 32);
    bb.setFixedString(req.szDesc, 256);

};
LobbyProtocol.decode_ExchangeProduct = function(byteBuf){
    var rsp = createObj(LobbyProtocol.exchangeRsp);
    //rsp.RoleId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    if(rsp.iResult==0){
    rsp.GoodsId = byteBuf.getInt32();
    rsp.GoodsName = byteBuf.getFixedString(32);
    //rsp.GoodsQty = byteBuf.getInt64();
    rsp.lPayCount = byteBuf.getUint64();
    rsp.iType = byteBuf.getUint32();
    rsp.iCount = byteBuf.getUint32();
    }
    return rsp;
};

LobbyProtocol.updateWealthRsp = {
    iResult:0,
    iTotalPay:0,
    iStatus:0,
    lGold : 0,
    lCoupon : 0,
    lScore:0,
    lExp:0
};


LobbyProtocol.encode_UpdateWealth = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};
LobbyProtocol.decode_UpdateWealth = function(byteBuf){
    var rsp = createObj(LobbyProtocol.updateWealthRsp);
    rsp.iResult = byteBuf.getUint32();
    if(rsp.iResult==0){
    rsp.iTotalPay = byteBuf.getUint32();
    rsp.iStatus = byteBuf.getUint32();
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    rsp.lScore = byteBuf.getUint64();
    rsp.lExp = byteBuf.getUint64();
    }
    //cc.log('--------decode_UpdateWealth rsp.lGold: '+rsp.lGold+'---rsp.lCoupon:'+rsp.lCoupon);
    return rsp;
};
LobbyProtocol.getReliveGoldRsp = {
    iResult : 0,           //结果
    lAddGold : 0,
    lTotalGold : 0,
    iReliveCount:0
};
LobbyProtocol.encode_getReliveGold =function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setFixedString(req.szToken, 32);
};

LobbyProtocol.decode_getReliveGold = function(byteBuf){
    var rsp =createObj(LobbyProtocol.getReliveGoldRsp);
    rsp.iResult= byteBuf.getInt32();
    rsp.lAddGold = byteBuf.getUint64();
    rsp.lTotalGold = byteBuf.getUint64();
    rsp.iReliveCount = byteBuf.getUint32();
    return rsp;
};

LobbyProtocol.getReliveConfRsp = {
    iResult : 0,           //结果
    iMinGold : 0,
    iAddGold : 0,
    iLimit : 0,
    iDayCount:0,
    iDay:0,
    iStatus:0
};
LobbyProtocol.encode_getReliveConf =function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

LobbyProtocol.decode_getReliveConf = function(byteBuf){
    var rsp = createObj(LobbyProtocol.getReliveConfRsp);
    rsp.iResult = byteBuf.getUint32();
    rsp.iMinGold = byteBuf.getUint32();
    rsp.iAddGold = byteBuf.getUint32();
    rsp.iLimit = byteBuf.getUint32();
    rsp.iDayCount = byteBuf.getUint32();
    rsp.iDay = byteBuf.getUint32();
    rsp.iStatus = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.getOrderReq = {
    iMId : 0,             //默认0
    iPayId : 0,           // SDK配置
    lPayUid: 0,           // UID
    lUid:0,               //Uid
    iGameId:0,            // 0
    iServerId: 0,         // 0
    lRoleId:0,
    iGoodsId:0,           //商品Id
    szDesc: '',           //
    szIp : '',            // 0

};

LobbyProtocol.getOrderRsp = {
    lRoleId:0,            //角色Id
    iResult:0,            //结果
    lUId:0,               //
    szSn:0,              //
    iGoodsId:0,          //商品Id
    szPoint:0,           //
    fMoney:0,            //
    szUrl: 0 ,          //
};
LobbyProtocol.encode_getOrder = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt32(req.iMId);
    bb.setInt32(req.iPayId);
    bb.setInt64(req.lPayUid);
    bb.setInt64(req.lUid);
    bb.setInt32(req.iGameId);
    bb.setInt32(req.iServerId);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iGoodsId);
    bb.setFixedString(req.szDesc,256);
    bb.setFixedString(req.szIp,16);
};

LobbyProtocol.decode_getOrder = function(byteBuf){
    cc.log('解析数据');
    var rsp =createObj(LobbyProtocol.getOrderRsp);
    rsp.iResult= byteBuf.getInt32();
    rsp.lRoleId= byteBuf.getInt64();

    rsp.lUId= byteBuf.getInt64();
    rsp.szSn= byteBuf.getFixedString(32);
    rsp.iGoodsId= byteBuf.getInt32();
    rsp.szPoint= byteBuf.getFixedString(32);          //
    rsp.fMoney= byteBuf.getFloat64();           //
    rsp.szUrl= byteBuf.getFixedString(256);         //
    return rsp;
};
LobbyProtocol.bindAccountRsp = {
    iResult:0,
    szAccount:'',
    szPassword:''
};
LobbyProtocol.encode_BindAccount = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setFixedString(req.szAccount,64);
    bb.setFixedString(req.szPassword,32);
    bb.setFixedString(req.szIMEI,32);
    bb.setFixedString(req.szIp,32);
};
LobbyProtocol.decode_BindAccount = function(byteBuf){
    var rsp =createObj(LobbyProtocol.bindAccountRsp);
    rsp.iResult= byteBuf.getInt32();
    if(rsp.iResult==0){
        rsp.szAccount= byteBuf.getFixedString(64);
        rsp.szPassword= byteBuf.getFixedString(32);
    }
    return rsp;
};
LobbyProtocol.checkAccountRsp = {
    iResult:0,
    lRoleId:0,
    szAccount:''
};
LobbyProtocol.encode_CheckAccount = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setFixedString(req.szAccount,64);
};
LobbyProtocol.decode_CheckAccount = function(byteBuf){
    var rsp =createObj(LobbyProtocol.checkAccountRsp);
    rsp.iResult= byteBuf.getInt32();
    if(rsp.iResult==0){
        rsp.lRoleId= byteBuf.getInt64();
        rsp.szAccount= byteBuf.getFixedString(64);
    }
    return rsp;
};

LobbyProtocol.modNickRsp = {
    iResult:0,
    szNickName:''
};
LobbyProtocol.encode_ModNick = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setFixedString(req.szNickName,32);
    bb.setFixedString(req.szIMEI,32);
    bb.setFixedString(req.szIp,32);
};
LobbyProtocol.decode_ModNick = function(byteBuf){
    var rsp =createObj(LobbyProtocol.modNickRsp);
    rsp.iResult= byteBuf.getInt32();
    rsp.szNickName= byteBuf.getFixedString(32);
    return rsp;
};

LobbyProtocol.modPassRsp = {
    iResult:0,
    szNewPass:''
};
LobbyProtocol.encode_ModPass = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setFixedString(req.szOldPass,32);
    bb.setFixedString(req.szNewPass,32);
    bb.setFixedString(req.szIMEI,32);
    bb.setFixedString(req.szIp,32);
};
LobbyProtocol.decode_ModPass = function(byteBuf){
    var rsp =createObj(LobbyProtocol.modNickRsp);
    rsp.iResult= byteBuf.getInt32();
    if(rsp.iResult==0){
        rsp.szNewPass= byteBuf.getFixedString(32);
    }
    return rsp;
};

/**
 * 转盘
 * @param req
 * @param bb
 */

LobbyProtocol.turnTableReq= {
    mainCmd:0,
    subCmd:0,
    lRoleId:0,
    szToken:""
};

LobbyProtocol.turnTableRsp={
    lRoleId:0,
    lResult:0,
    iNum:0,
    iType:0,
    lAddValue:0,
    lTotal:0
};
LobbyProtocol.encode_turnTable=function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setFixedString(req.szToken,32);
};
LobbyProtocol.decode_turnTable = function(byteBuf){
    var rsp = createObj(LobbyProtocol.turnTableRsp);
    rsp.lResult = byteBuf.getInt32();
    if(rsp.lResult ==0){
        rsp.iNum = byteBuf.getInt32();
        rsp.iType=byteBuf.getInt32();
        rsp.lAddValue = byteBuf.getInt32();
        rsp.lTotal = byteBuf.getInt64();
    }
    return rsp;
};

LobbyProtocol.decode_BroadMsg = function (byteBuf) {
    var rsp ={};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iArea = byteBuf.getInt32();
    rsp.iShowType = byteBuf.getInt32();
    rsp.iLevel = byteBuf.getInt32();
    rsp.iGameId = byteBuf.getInt32();
    rsp.iMsgLen = byteBuf.getInt32();
    rsp.szMsg = byteBuf.getFixedString(rsp.iMsgLen);
    return rsp;

};
LobbyProtocol.cacheBroadList = {
    iType:0,
    iResult:0,
    iCount:0,
    pMsg:[]
}
LobbyProtocol.encode_BroadList = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt32(req.iShowType);
};
LobbyProtocol.decode_BroadList = function(byteBuf){
    var rsp = createObj(LobbyProtocol.cacheBroadList);
    rsp.iType = byteBuf.getInt32();
    rsp.iResult =byteBuf.getInt32();
    rsp.iCount = byteBuf.getInt32();
    rsp.pMsg=[];
    for(var i=0;i<rsp.iCount;i++){
        var info = {};
        info.lUserId = byteBuf.getInt64();
        info.iArea = byteBuf.getInt32();
        info.iShowType = byteBuf.getInt32();
        info.iLevel = byteBuf.getInt32();
        info.iGameId = byteBuf.getInt32();
        info.iMsgLen = byteBuf.getInt32();
        info.szMsg = byteBuf.getFixedString(512);
        rsp.pMsg.push(info);
    }
    return rsp;
};
LobbyProtocol.PayNoticeObj = {
    lRoleId:0,
    iResult:0
};
LobbyProtocol.decode_NoticePayRsp = function(byteBuf){
    var rsp = createObj(LobbyProtocol.PayNoticeObj);
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iResult= byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.decode_serverKickRsp = function(byteBuf){
    var rsp = {};
    rsp.iKickType = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.encode_GetCrystalInfo = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

LobbyProtocol.decode_GetCrystalInfoRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lCrystal = byteBuf.getUint64();
    rsp.lRecharge = byteBuf.getInt64();
    rsp.lRemaind = byteBuf.getInt64();
    return rsp;
};

LobbyProtocol.encode_CheckUID = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt64(req.lUserId);

};

LobbyProtocol.decode_CheckUIDRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.szNickName = byteBuf.getFixedString(32);
    return rsp;
};


LobbyProtocol.encode_GiveCrystal = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt64(req.lGiveId);
    bb.setInt64(req.lCrystal);
};

LobbyProtocol.decode_GiveCrystalRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lGiveId = byteBuf.getInt64();
    rsp.lCrystal = byteBuf.getUint64();
    rsp.NewCrystal = byteBuf.getUint64();
    rsp.lGold = byteBuf.getUint64();
    //rsp.iNeedRecharge = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.encode_CrystalPushInfo= function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt32(req.iMessageNum);
    for(var i =0; i<req.iMessageNum ; ++i){
        bb.setInt64(req.szCrystalRsp[i].lMessageId);
        bb.setInt32(req.szCrystalRsp[i].iTypeId);
    }
};

LobbyProtocol.decode_CrystalPushInfoRsp = function(byteBuf){
    var rsp = {};

    rsp.iMessageNum = byteBuf.getInt32();
    rsp.Msg = [];
    for(var i =0; i< rsp.iMessageNum; ++i){
        var lrsp = {};
        lrsp.lMessageId = byteBuf.getUint64();
        lrsp.iTypeId = byteBuf.getInt32();// 0 送 1 被送
        //byteBuf.getInt32();
        lrsp.lUserId = byteBuf.getUint64();//送人
        lrsp.szNickName = byteBuf.getFixedString(32);
        lrsp.lGiveId = byteBuf.getUint64();//被送人
        lrsp.szGiveName =  byteBuf.getFixedString(32);
        lrsp.lCrystal = byteBuf.getUint64();
        lrsp.szTime = byteBuf.getFixedString(32);
        rsp.Msg.push(lrsp);
    }
    return rsp;
};

LobbyProtocol.encode_getSignReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};
LobbyProtocol.decode_GetSignRsp = function(byteBuf){
    var rsp ={};
    rsp.iResult = byteBuf.getInt32();
    rsp.szSign = byteBuf.getFixedString(256);

    return rsp;
};

LobbyProtocol.decode_GetPhoneNumRsp = function(byteBuf){
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.szPhone = byteBuf.getFixedString(16);
    return rsp;
};

LobbyProtocol.encode_GetPhoneNumReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

LobbyProtocol.encode_editSignReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setFixedString(req.szSign,256);
};

LobbyProtocol.decode_editSignRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult=byteBuf.getInt32();
    if(rsp.iResult==0){
        rsp.szSign = byteBuf.getFixedString(256);
    }
    return rsp;
};

LobbyProtocol.encode_ChangeHeadReq = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iType);
    bb.setFixedString(req.szFaceid, 32);
    bb.setInt32(req.iFaceStatus);
};

LobbyProtocol.decode_ChangeHeadReq = function(byteBuf){
    var rsp = {};
    rsp.iResult=byteBuf.getInt32();
    rsp.szFaceid = byteBuf.getFixedString(32);
    rsp.iFaceStatus = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.encode_ExchangeIntergral = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iGoodsId);
};

LobbyProtocol.decode_ExchangeIntergral = function(byteBuf){
    var rsp = {};
    rsp.iResult=byteBuf.getInt32();
    rsp.lGold = byteBuf.getUint64();
    rsp.lCoupon = byteBuf.getUint64();
    rsp.lScore = byteBuf.getUint64();
    rsp.lCrystal = byteBuf.getUint64();
    rsp.szChangeCode = byteBuf.getFixedString(32);
    rsp.iCount = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.encode_BindPhoneNumReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setFixedString(req.szPhone, 16);
    bb.setFixedString(req.szCode, 16);
};

LobbyProtocol.encode_UnBindPhoneNumReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setFixedString(req.szPhone,16);
    bb.setFixedString(req.szCode,16);
};

LobbyProtocol.decode_bindPhoneNumRsp = function(byteBuf){
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.szPhone = byteBuf.getFixedString(16);
    rsp.rewardGold = byteBuf.getInt64();
    rsp.iStatus = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.decode_unBindPhoneNumRsp = function(byteBuf){
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.szPhone = byteBuf.getFixedString(16);
    return rsp;
};

LobbyProtocol.encode_getToolReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

LobbyProtocol.decode_getToolRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.itemCount = byteBuf.getInt32();
    rsp.toolitem = [];
    for(var i=0;i<rsp.itemCount;++i){
        var sp = {};
        sp.id = byteBuf.getInt32();
        sp.icount = byteBuf.getInt32();
        rsp.toolitem.push(sp);
    }
    return rsp;
};

LobbyProtocol.encode_ToolExchangeReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iGoodsId);
    bb.setFixedString(req.szIMEI,32);
    bb.setFixedString(req.szMobile, 64);
    bb.setFixedString(req.szPostCode, 16);
    bb.setFixedString(req.szAddress, 256);
    bb.setFixedString(req.szRealName, 32);
    bb.setFixedString(req.szDesc, 256);

};

LobbyProtocol.decode_ToolExchangeRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.GoodsId = byteBuf.getInt32();
    rsp.GoodsName = byteBuf.getFixedString(32);
    rsp.iPrice = byteBuf.getInt32();
    rsp.iType = byteBuf.getUint32();
    rsp.iCount = byteBuf.getUint32();
    rsp.szNickName = byteBuf.getFixedString(32);
    return rsp;
};

LobbyProtocol.encode_GetMail = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setUint64(req.lMailId);
};

LobbyProtocol.decode_GetMail = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iMailCount=byteBuf.getInt32();
    rsp.mailitem = [];
    for(var i=0;i<rsp.iMailCount;++i){
        var sp = {};
        sp.mailid = byteBuf.getUint64();
        sp.lRoleId =0;
        sp.lReceiver =0;
        sp.lSender = byteBuf.getInt64();
        sp.iType = byteBuf.getInt32();
        sp.szTitle = byteBuf.getFixedString(32);
        sp.szContent = byteBuf.getFixedString(256);
        sp.iPacketId = byteBuf.getInt32();
        sp.lCtime = byteBuf.getInt64();
        sp.lEtime = byteBuf.getInt64();
        sp.iStatus = byteBuf.getInt32();
        sp.localStatus = 0;//自定义, 0没有领取,1已读,2已领取
        rsp.mailitem.push(sp);
    }
    return rsp;
};

LobbyProtocol.decode_ServerPushMail = function(byteBuf){
    var rsp = {};
    rsp.mailid = byteBuf.getUint64();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.lReceiver = byteBuf.getInt64();
    rsp.lSender =0;
    rsp.iType = byteBuf.getInt32();
    rsp.szTitle = byteBuf.getFixedString(32);
    rsp.szContent = byteBuf.getFixedString(256);
    rsp.iPacketId = byteBuf.getInt32();
    rsp.lCtime = byteBuf.getInt64();
    rsp.lEtime = byteBuf.getInt64();
    rsp.iStatus = byteBuf.getInt32();
    rsp.localStatus = 0;
    return rsp;
};

LobbyProtocol.encode_changeMailStatus = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt64(req.lMailId);
    bb.setInt32(req.iType);
    bb.setInt32(req.iStatus);
    bb.setInt32(req.iPacketId);
};

LobbyProtocol.decode_changeMailStatus = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.mailid = byteBuf.getInt64();
    rsp.iType = byteBuf.getInt32();
    rsp.iStatus = byteBuf.getInt32();
    rsp.iPacketId = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.encode_FreeGameRankReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iRoomId);
};

LobbyProtocol.decode_FreeGameRankRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iRoomId = byteBuf.getInt32();
    rsp.myRank = byteBuf.getInt32();
    rsp.iCount = byteBuf.getInt32();
    rsp.rankData = [];
    for(var i =0;i<rsp.iCount;++i){
        var sp = {};
        sp.roleId = byteBuf.getInt64();
        sp.rank = byteBuf.getInt32();
        sp.packId = byteBuf.getInt32();
        //sp.szPackName =byteBuf.getFixedString(32);
        sp.score = byteBuf.getInt64();
        sp.lTime = byteBuf.getInt64();
        sp.nickName = byteBuf.getFixedString(32);
        sp.icon = byteBuf.getFixedString(32);
        sp.iGender = byteBuf.getInt32();
        sp.iconStatus = byteBuf.getInt32();
        rsp.rankData.push(sp);
    }
    return rsp;
};

LobbyProtocol.encode_SelfRankReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
    bb.setInt32(req.iRoomId);
};

LobbyProtocol.decode_SelfRankRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iRank = byteBuf.getInt32();
    rsp.iAllRank = byteBuf.getInt32();
    rsp.iServerCT = byteBuf.getUint64();
    return rsp;
};

LobbyProtocol.encode_GetTicketNumbReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

LobbyProtocol.decode_GetTicketNumbRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iCount = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.encode_GetFreeRoomListReq = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lRoleId);
};

LobbyProtocol.decode_GetFreeRoomListRsp = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lRoleId = byteBuf.getInt64();
    rsp.iCount = byteBuf.getInt32();
    rsp.roominfo = [];
    for(var i =0;i<rsp.iCount;++i){
        var sp = {};
        sp.iRoomId = byteBuf.getInt32();
        //sp.szRoomName = byteBuf.getFixedString(48);
        sp.szRoomName = FishGlobal.getRoomNameByID(sp.iRoomId);
        sp.szTotalName = byteBuf.getFixedString(16);
        sp.iSigned = byteBuf.getInt32();
        sp.iTickCount = byteBuf.getInt32();
        sp.iCoinId = byteBuf.getInt32();
        sp.lCoinCount = byteBuf.getInt64();
        sp.lStartCoin = byteBuf.getInt64();
        sp.lStartTime = byteBuf.getInt64();
        sp.lEndTime = byteBuf.getInt64();
        rsp.roominfo.push(sp);
    }
    return rsp;
};

LobbyProtocol.encode_QueryDailyCharge = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt64(req.iGoodsId);
};

LobbyProtocol.decode_QueryDailyCharge = function(byteBuf){
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iGoodsId = byteBuf.getInt32();
    rsp.iDayChargeMoney = byteBuf.getInt32();//当天充值
    rsp.iDayLimitMoney = byteBuf.getInt32();//当天充值限额
    rsp.iShenfenType =  byteBuf.getInt32();//身份认证类型：0未认证，1未成年，2成年
    return rsp;
};

LobbyProtocol.encode_GetVIPcfg = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

LobbyProtocol.decode_GetVIPcfg = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lUserId = byteBuf.getInt64();
    rsp.iCount = byteBuf.getInt32();
    rsp.iCanSend = 0;//可以送的等级
    var tag = 0;
    rsp.cfg =[];
    for(var i =0;i<rsp.iCount;++i){
        var vipcfg = {};
        vipcfg.iVIPLevel = byteBuf.getInt32();
        vipcfg.iMoney = byteBuf.getInt32();
        vipcfg.iSendCount = byteBuf.getInt32();
        if(vipcfg.iSendCount>0 && tag == 0){
            rsp.iCanSend =  vipcfg.iVIPLevel;
        }
        tag = vipcfg.iSendCount;
        rsp.cfg.push(vipcfg);
    }
    return rsp;
};

LobbyProtocol.encode_QueryVIPinfo = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

LobbyProtocol.decode_QueryVIPinfo = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lUserId = byteBuf.getInt64();
    rsp.iVIPLevel = byteBuf.getInt32();//vip等级
    rsp.iMoney = byteBuf.getInt32();//充值
    rsp.iSend = byteBuf.getInt32();//已送个数
    rsp.iVIPMoney = byteBuf.getInt32();//当前VIP充值
    rsp.iVIPSend = byteBuf.getInt32();//当前vip送数量
    rsp.iVIPNextMoney = byteBuf.getInt32();//下一等级VIP充值
    rsp.iNextSend = byteBuf.getInt32();//下一等级VIP送数量
    return rsp;
};


LobbyProtocol.encode_QueryCheckCfg = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};

LobbyProtocol.decode_QueryCheckCfg = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lUserId = byteBuf.getInt64();
    rsp.checkCfg = [];
    for(var i=0;i<7;++i){
        var sp = {};
        sp.iDays = byteBuf.getInt32();
        sp.iCoinType1 = byteBuf.getInt32();
        sp.iCoinValue1 = byteBuf.getInt64();
        sp.iCoinType2 = byteBuf.getInt32();
        sp.iCoinValue2 = byteBuf.getInt64();
        rsp.checkCfg.push(sp);
    }

    return rsp;
};

LobbyProtocol.encode_GetCheckStatus = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};


LobbyProtocol.decode_GetCheckStatus = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lUserId = byteBuf.getInt64();
    rsp.iCheckinDays = byteBuf.getInt32();
    rsp.iStatus = byteBuf.getInt32();
    return rsp;
};

LobbyProtocol.encode_GetCheckResult = function(req,bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};


LobbyProtocol.decode_GetCheckResult = function(byteBuf){
    var rsp = {};
    rsp.iResult = byteBuf.getInt32();
    rsp.lUserId = byteBuf.getInt64();
    rsp.iCheckinDays = byteBuf.getInt32();//签到天数
    rsp.lTimeStamp = byteBuf.getInt64();//上次签到时间
    rsp.iCoinType1 = byteBuf.getInt32();
    rsp.lCoinValueOld1 = byteBuf.getInt64();//财富1旧值
    rsp.lCoinValueAdd1 = byteBuf.getInt64();//财富1增加量
    rsp.iCoinType2 = byteBuf.getInt32();
    rsp.lCoinValueOld2 = byteBuf.getInt64();
    rsp.lCoinValueAdd2 = byteBuf.getInt64();
    return rsp;
};


LobbyProtocol.encode_FUBEN2_COIN_GET = function (req, bb) {
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};


LobbyProtocol.decode_FUBEN2_COIN_GET = function (byteBuf) {
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.lGold = byteBuf.getUint64();
    rsp.lYubi = byteBuf.getUint64();
    rsp.lBox = byteBuf.getUint64();
    return rsp;
};

LobbyProtocol.encode_FUBEN2_SYLZ_CFG = function (req, bb) {
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};


LobbyProtocol.decode_FUBEN2_SYLZ_CFG = function (byteBuf) {
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iSpeed = byteBuf.getInt32();
    rsp.bombCfg =[];
    for(var i=0;i<3;++i){
        var sp = {};
        sp.iRate = byteBuf.getInt32();//炮台倍率（消耗金币）
        sp.iIndex =byteBuf.getInt32();//索引0-2
        sp.iFreeTimes =byteBuf.getInt32();//每天免费次数
        sp.iLimitBuyTimes =byteBuf.getInt32();//每日限购次数
        sp.iScorePerBom =byteBuf.getInt32();//每个炮弹消耗积分
        rsp.bombCfg.push(sp);
    }
    return rsp;
};

LobbyProtocol.encode_FUBEN2_JZSJ_CFG = function (req, bb) {
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};


LobbyProtocol.decode_FUBEN2_JZSJ_CFG = function (byteBuf) {
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.roomCfg =[];
    for(var i=0;i<3;++i){
        var sp = {};
        sp.iRate = byteBuf.getInt32();//炮台倍率（消耗金币）
        sp.iIndex =byteBuf.getInt32();//索引0-2
        sp.iMaxTimes =byteBuf.getInt32();//每天最大报名次数，-1为不限制
        sp.iGameTime =byteBuf.getInt32();//游戏时间（不包括准备时间）
        sp.iScore =byteBuf.getInt32();//入场需要消耗的积分
        sp.iGoldFishRatio =byteBuf.getInt32();//金币鱼占比0-100取值
        sp.iLimitGold =byteBuf.getInt32();//准入限制
        rsp.roomCfg.push(sp);
    }
    return rsp;
};

LobbyProtocol.encode_FUBEN2_OPENBOX_CFG = function (req, bb) {
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
};


LobbyProtocol.decode_FUBEN2_OPENBOX_CFG = function (byteBuf) {
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.boxCfg = [];
    for(var i =0;i<3;++i){
        var sp ={};
        sp.iType = byteBuf.getInt32();//开宝箱类型
        sp.iScore = byteBuf.getInt32();//消耗积分
        rsp.boxCfg.push(sp);
    }
    return rsp;
};

LobbyProtocol.encode_FUBEN2_BUY_BOX = function (req, bb) {
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iType); //1：购买宝箱:2：换金币
    bb.setInt32(req.iValue);//兑换的数量
};


LobbyProtocol.decode_FUBEN2_BUY_BOX = function (byteBuf) {
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.lAllGold = byteBuf.getUint64();
    rsp.lAllYubi = byteBuf.getUint64();
    rsp.lAllBox = byteBuf.getUint64();
    rsp.lAddGold = byteBuf.getUint64();
    rsp.lAddYubi = byteBuf.getUint64();
    rsp.lAddBox = byteBuf.getUint64();
    return rsp;
};

LobbyProtocol.encode_FUBEN2_OPEN_BOX = function (req, bb) {
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iType); //开宝箱类型
    bb.setInt32(req.iBoxCount);//开宝箱数量
};


LobbyProtocol.decode_FUBEN2_OPEN_BOX = function (byteBuf) {
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.lAllCoupon = byteBuf.getUint64();
    rsp.lAllGold = byteBuf.getUint64();
    rsp.lAllScore = byteBuf.getUint64();
    rsp.lAllMedal = byteBuf.getUint64();//剩余弹头数量
    rsp.lAddGold = byteBuf.getUint64();//增量金豆
    rsp.lAddCoupon = byteBuf.getUint64();//增量奖券
    rsp.lAddMedal = byteBuf.getUint64();//增量弹头
    rsp.lAllBox = byteBuf.getUint64();//剩余宝箱数量
    return rsp;
};
LobbyProtocol.encode_Score_Exchange = function(req, bb){
    bb.setInt32(req.mainCmd);
    bb.setInt32(req.subCmd);
    bb.setInt64(req.lUserId);
    bb.setInt32(req.iGoodsId);
};

LobbyProtocol.decode_Score_Exchange = function(byteBuf){
    var rsp = {};
    rsp.lUserId = byteBuf.getInt64();
    rsp.iResult = byteBuf.getInt32();
    rsp.iDayLimit = byteBuf.getInt32();
    rsp.iDayCount = byteBuf.getInt32();
    return rsp;
};