var Lobbyhandler = ClientHandler.extend({
    _lobbyData: null,
    _ReloginTime: 0,

    ctor: function () {
        this._super();
        this._ReloginTime = 0;
        this._lobbyData = new LobbyData();
        this.setReconnetMaxCount(-1);
        this.setHeartBeatTime(5);
        this.setReconnetMaxTime(35);
    },

    /***
     * 链接成功失败可能会有一些逻辑展示
     * @param event_id
     */
    onConnectEvent: function (event_id) {
//        cc.log('-----------大厅重连次数:'+this._reconnetCount);
        if (event_id == eClientEvent.EVENT_CONNECT_OK) {
//            cc.log("-----连接Lobby服务器成功----");
        }
        else {
            //cc.log('--------------断线了-);');
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent && (scene.getName() == 'lobbyscene' || scene.getName() == "GameNewLobby")) {
                scene.onGameEvent(FishGameEventID.unConnect, 1);
            }
            //cc.log("-----连接Lobby服务器失败----");
        }
    },

    /***
     * 公私钥消息完成与否的一些逻辑处理
     * @param issuccess 0成功 其他失败
     */
    onAccessEvent: function (issuccess) {
//        cc.log('--------大厅-------issuccess' + issuccess);
        if (issuccess == 0) {
            var layer = FYEngine.getRunningLayer(0);
            if (layer.getName() != AppSceneName.Fourth) {
                this.sendPlayerReLoginRequest();
            } else {
                this.sendPlayerLoginRequest();
            }
        }
        else {
            cc.log("-----公私钥验证失败-------");
        }
    },

    /***
     * 发送消息 override
     * @param subCmd
     * @param req
     */
    sendDataMsg: function (subCmd, req) {
        switch (req.mainCmd) {
            case LobbyProtocol.LobbyProto:
                this.sendLobbyMsg(req.subCmd, req);
                break;
            case LobbyProtocol.ListProto:
                if (this._canSendNormalMsg) {
                    this.sendListMsg(req.subCmd, req);
                }
                break;
            case LobbyProtocol.GameInfoProto:
                if (this._canSendNormalMsg) {
                    this.sendGameInfoMsg(req.subCmd, req);
                }
                break;
            case LobbyProtocol.ModuleInfoProto:
                if (this._canSendNormalMsg) {
                    this.sendModuleMsg(req.subCmd, req);
                }
                break;
            case LobbyProtocol.HallExternalProto :
                if (this._canSendNormalMsg) {
                    this.sendHallExternalMsg(req.subCmd, req);
                }
                break;
            default:
                break;
        }
    },

    /***
     * 接受解析消息 override
     * @param mainCmd
     * @param subCmd
     * @param byteBuf
     */
    handleDataMsg: function (mainCmd, subCmd, byteBuf) {
        cc.log("main cmd===" + mainCmd + "-----subcmd====" + subCmd);
        switch (mainCmd) {
            case LobbyProtocol.LobbyProto:
                this.handleLobbyMsg(subCmd, byteBuf);
                break;
            case LobbyProtocol.ListProto:
                this.handleListMsg(subCmd, byteBuf);
                break;
            case LobbyProtocol.GameInfoProto:
                this.handleGameInfoMsg(subCmd, byteBuf);
                break;
            case LobbyProtocol.ModuleInfoProto:
                this.handleModuleMsg(subCmd, byteBuf);
                break;
            case LobbyProtocol.BroadProto:
                this.handleBroadMsg(subCmd, byteBuf);
                break;
            case LobbyProtocol.ServerKick:
                this.handleServerKick(subCmd, byteBuf);
                break;
            case FishProtocol.FishProto:
                this.handleIntergralResult(subCmd, byteBuf);
                break;
            default:
                break;
        }
    },

    /****
     * 大厅消息
     * @param subCmd
     * @param byteBuf
     */
    sendLobbyMsg: function (subCmd, req) {
        switch (subCmd) {
            case LobbyProtocol.PlayerLogin:
                LobbyProtocol.encode_PlayerLogon(req, this._sendBuf);
                break;
            case LobbyProtocol.PlayerLogout:
                LobbyProtocol.encode_PlayerLogout(req, this._sendBuf);
                break;
            case LobbyProtocol.PlayerReLogin:
                LobbyProtocol.encode_PlayerReLogin(req, this._sendBuf);
                break;
            case LobbyProtocol.BackToLobby:
                LobbyProtocol.encode_BackToLobby(req, this._sendBuf);
                break;
            default:
                break;
        }
    },

    handleLobbyMsg: function (subCmd, byteBuf) {
//        cc.log("lobbyhandle sub cum====="+subCmd);
        this._needReConnect = true;
        switch (subCmd) {
            case LobbyProtocol.PlayerLogin:
                this.handlePlayerLoginRsp(byteBuf);
                break;
            case LobbyProtocol.PlayerLogout:
                this.handlePlayerLogoutRsp(byteBuf);
                break;
            case LobbyProtocol.PlayerReLogin:
                this.handlePlayerReLoginRsp(byteBuf);
                break;
            default:
                break;
        }
    },

    handleIntergralResult: function (subCmd, byteBuf) {
        switch (subCmd) {
            case FishProtocol.IntergralNumber :
                if (appglobal._switch10 == 1) {
                    this.handleIntergralResultRsp(byteBuf);
                }
                break;
            case LobbyProtocol.GetActiveStatus :
                this.handleGetActiveRsp(byteBuf);
                break;
            default :
                break;
        }

    },

    ///登录请求
    sendPlayerLoginRequest: function () {
//        cc.log('--------大厅发送登录请求');
        var player = appglobal.getPlayer();
        var req = createObj(LobbyProtocol.PlayerLoginReq);
        req.mainCmd = LobbyProtocol.LobbyProto;
        req.subCmd = LobbyProtocol.PlayerLogin;
        req.lUserId = player.userid;
        req.szToken = player.token;
        this.pushSendReq(req);
    },

    sendPlayerReLoginRequest: function () {
//        cc.log('--------大厅发送重新登录请求');
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.LobbyProto;
        req.subCmd = LobbyProtocol.PlayerReLogin;
        req.lRoleId = player.roleid;
        req.szToken = player.gametoken;
        this.pushSendReq(req);
    },

    sendBackToLobbyRequest: function () {
//        cc.log('--------发送渔场内退出到渔场外的请求');
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.LobbyProto;
        req.subCmd = LobbyProtocol.BackToLobby;
        req.lRoleId = player.roleid;
        req.iSourceId = appglobal._appCfg.source;
        this.pushSendReq(req);
    },

    handlePlayerReLoginRsp: function (byteBuf) {
        this._needReConnect = true;
        cc.log('-----------收到大厅重连登录请求');
        var rsp = LobbyProtocol.decode_PlayerReLogin(byteBuf);
        if (rsp.iResult != 0) {
            this.setLoginStatus(false);
//            cc.log('-------重连登录大厅服务器失败, rsp.iResult:' + rsp.iResult);
            if (rsp.iResult = -3) {
                var scene = FYEngine.getRunningLayer(0);
                var mlayer = scene.getChildByName('tokenfail');
                if (!mlayer) {
                    mlayer = new TokenFailLayer(0);
                    if (mlayer) {
                        scene.addChild(mlayer, FishZorder.poplayer + 1, 'tokenfail');
                    }
                }
                return;
            }
            if (this._ReloginTime == 3) {
                var scene = FYEngine.getRunningLayer(0);
                var mlayer = scene.getChildByName('tokenfail');
                if (!mlayer) {
                    mlayer = new TokenFailLayer(1);
                    if (mlayer) {
                        scene.addChild(mlayer, FishZorder.poplayer + 1, 'tokenfail');
                    }
                }
                return;
            }
            this.sendPlayerReLoginRequest();
            this._ReloginTime += 1;
        } else {
            this.setCanSendHeart(true);
            this._canSendNormalMsg = true;
            this._ReloginTime = 0;
            this.resetReconnetCount();
            this.setLoginStatus(true);
            this.sendUpdateWealthReq();
            this.sendGetActiveReq();
            this.sendQueryVIPinfo();
            this.sendGetCrystalInfoReq();
            this.sendFUBEN2_COIN_GET();
            this.sendFUBEN2_JZSJ_CFG();
            this.sendFUBEN2_SYLZ_CFG();
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent && (scene.getName() == 'lobbyscene' || scene.getName() == 'GameNewLobby')) {
//                cc.log('---------大厅服务器--重连登录 -链接成功------');
                scene.onGameEvent(FishGameEventID.unConnect, 2);
                if (FishGlobal.bInited == true) {
                    //this.sendGetReliveConfReq();
                    this.sendCacheBroadListReq();
                }
            }
        }
    },

    handlePlayerLoginRsp: function (byteBuf) {
        var scene = FYEngine.getRunningLayer(0);
        cc.log('-----------收到大厅登录请求');
        var rsp = LobbyProtocol.decode_PlayerLogon(byteBuf);
        if (rsp.iResult != 0) {
            cc.log('-------登录大厅服务器失败, rsp.iResult:' + rsp.iResult);
            this.setLoginStatus(false);
            var layer = new LoginErrorLayer(rsp.iResult, UsedResName.ConfirmTitle);
            if (layer) {
                scene.addChild(layer, 10, LoginLayerName.LoginErrLayer);
            }
            return;
        }
        FishGlobal.linkLobbyAcess = true;
        this._canSendNormalMsg = true;
        this.setCanSendHeart(true);
        var player = appglobal.getPlayer();
        player.userid = rsp.lUserId;
        player.roleid = rsp.lRoleId;
        player.gametoken = rsp.szGameToken;
        player.gender = rsp.iGender;
        player.facestatus = rsp.iFaceStatus;
        player.faceid = rsp.szFaceId;
        player.gold = rsp.lGold;
        player.coupon = rsp.lCoupon;
        player.signature = rsp.szSigned;
        player.totalpay = rsp.iTotalPay;
        player.score = rsp.lScore;

//        FYEngine.logObject(rsp,'-------登录消息:');
        ///获取游戏列表
//        cc.log('------发送获取游戏列表');
        this.sendGameListReq();
        this.sendGetReliveConfReq();
        this.sendGetPhoneNumReq();

        this.sendGetActiveReq();
        this.sendGetSignReq();
        this.sendGetVIPconfig();
        this.setLoginStatus(true);
        this.sendHeadUrlRequest(player.faceid, player.facestatus);
        this.getUserAuthenticationRecord();
        this.sendGetCrystalInfoReq();
        this.sendQueryVIPinfo();

    },

    sendHeadUrlRequest: function (faceid, facestatus) {
        if (faceid != 'default' && faceid != '' && faceid != null) {
            cc.log('--------下载头像:' + faceid);
            if (facestatus != -1) {
                var type = "";
                var url = appglobal._downphoto + "/" + type + faceid;
                app.httpManager.loadImgFromUrl(url, type + faceid);
            }
        }

    },

    sendPlayerLogoutReq: function () {
        var req = {};
        req.mainCmd = LobbyProtocol.LobbyProto;
        req.subCmd = LobbyProtocol.PlayerLogout;
        req.lRoleId = appglobal.getPlayer().roleid;
        this.pushSendReq(req);
    },
    /****
     * 列表消息
     * @param subCmd
     * @param byteBuf
     */
    sendListMsg: function (subCmd, req) {
        switch (subCmd) {
            case LobbyProtocol.GameList:
                LobbyProtocol.encode_GameListReq(req, this._sendBuf);
                break;
            case LobbyProtocol.CacheBroadList:
                LobbyProtocol.encode_BroadList(req, this._sendBuf);
                break;
            case LobbyProtocol.FreeRoomRank :
                LobbyProtocol.encode_FreeGameRankReq(req, this._sendBuf);
                break;
            case LobbyProtocol.SelfRank :
                LobbyProtocol.encode_SelfRankReq(req, this._sendBuf);
                break;
            case LobbyProtocol.FreeRoomList:
                LobbyProtocol.encode_GetFreeRoomListReq(req, this._sendBuf);
                break;
            default:
                break;
        }
    },

    handleListMsg: function (subCmd, byteBuf) {
        switch (subCmd) {
            case LobbyProtocol.GameList:
                this.handlerGameListRsp(byteBuf);
                break;
            case LobbyProtocol.AroundList:
                break;
            case LobbyProtocol.CacheBroadList:
                this.handleCacheBroadListRsp(byteBuf);
                break;
            case LobbyProtocol.FreeRoomRank :
                this.handleFreeGameRankRsp(byteBuf);
                break;
            case LobbyProtocol.SelfRank :
                this.handleSelfRankRsp(byteBuf);
                break;
            case LobbyProtocol.FreeRoomList :
                this.handleGetFreeRoomListRsp(byteBuf);
                break;
            default:
                break;
        }
    },

    sendGameListReq: function () {
        var req = createObj(LobbyProtocol.GameListReq);
        req.mainCmd = LobbyProtocol.ListProto;
        req.subCmd = LobbyProtocol.GameList;
        req.lRoleId = appglobal.getPlayer().roleid;
        this.pushSendReq(req);
    },

    handlerGameListRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GameListRsp(byteBuf);
        cc.log("rsp========" + JSON.stringify(rsp));
        if (rsp.iResult != 0) {
            //cc.log('-------获取游戏列表失败, rsp.iResult:' + rsp.iResult);
            return;
        }

        for (var i = 0; i < rsp.iCount; ++i) {
            var info = createObj(RoomInfo);
            info.iType = rsp.game[i].iType;
            info.iLength = rsp.game[i].iLength;
            this._lobbyData.putRoom(info.iType, info);
        }
        var layer = FYEngine.getRunningLayer(0);
        //if(layer && layer.getName()=="lobbyscene"){
        //    layer.onGameEvent(lobbyGameEvent.refreshOnline);
        //    return;
        //}
        if (layer && layer.getName() == AppSceneName.Fourth) {
            //layer._layercount = 0;
            //layer.schedule(function(dt){
            //    if(layer._layercount>=65){
            //        layer.unscheduleAllCallbacks();
            //    }
            //    layer._layercount++;
            //    layer.changePercent(layer._layercount);
            //});


            layer.changePercent(49);
            layer.changeLabel('正在加载资源，请稍候...');
            FishGlobal.init();
        }

    },

    /****
     * 游戏信息消息
     * @param subCmd
     * @param byteBuf
     */
    sendGameInfoMsg: function (subCmd, req) {
        switch (subCmd) {
            case LobbyProtocol.GameInfo:
                LobbyProtocol.encode_GameInfoReq(req, this._sendBuf);
                break;
            case LobbyProtocol.Treasure:
                LobbyProtocol.encode_UpdateWealth(req, this._sendBuf);
                break;
            case LobbyProtocol.ReliveConf:
                LobbyProtocol.encode_getReliveConf(req, this._sendBuf);
                break;
            case LobbyProtocol.GetCrystalInfo :
                LobbyProtocol.encode_GetCrystalInfo(req, this._sendBuf);
                break;
            case LobbyProtocol.PlayerSign:
                LobbyProtocol.encode_getSignReq(req, this._sendBuf);
                break;
            case LobbyProtocol.GetPhoneNum:
                LobbyProtocol.encode_GetPhoneNumReq(req, this._sendBuf);
                break;
            case LobbyProtocol.GetTicketQty:
                LobbyProtocol.encode_GetTicketNumbReq(req, this._sendBuf);
                break;
            case LobbyProtocol.QueryDailyCharge :
                LobbyProtocol.encode_QueryDailyCharge(req, this._sendBuf);
                break;
            case LobbyProtocol.GetVIPcfg :
                LobbyProtocol.encode_GetVIPcfg(req, this._sendBuf);
                break;
            case LobbyProtocol.QueryVIPinfo:
                LobbyProtocol.encode_QueryVIPinfo(req, this._sendBuf);
                break;
            case LobbyProtocol.QueryCheckinCfg :
                LobbyProtocol.encode_QueryCheckCfg(req, this._sendBuf);
                break;
            case LobbyProtocol.GetCheckinStatu :
                LobbyProtocol.encode_GetCheckStatus(req, this._sendBuf);
                break;
            case LobbyProtocol.FUBEN2_COIN_GET :
                LobbyProtocol.encode_FUBEN2_COIN_GET(req, this._sendBuf);
                break;
            case LobbyProtocol.FUBEN2_SYLZ_CFG :
                LobbyProtocol.encode_FUBEN2_SYLZ_CFG(req, this._sendBuf);
                break;
            case LobbyProtocol.FUBEN2_JZSJ_CFG :
                LobbyProtocol.encode_FUBEN2_JZSJ_CFG(req, this._sendBuf);
                break;
            case LobbyProtocol.FUBEN2_OPENBOX_CFG :
                LobbyProtocol.encode_FUBEN2_OPENBOX_CFG(req, this._sendBuf);
                break;
            case LobbyProtocol.FUBEN2_BUY_BOX_CFG :
                LobbyProtocol.encode_FUBEN2_BUY_BOX(req, this._sendBuf);
                break;
            case LobbyProtocol.FUBEN2_OPENBOX :
                LobbyProtocol.encode_FUBEN2_OPEN_BOX(req, this._sendBuf);
                break;
            case LobbyProtocol.SCORE_EX_GET :
                    //cc.log("----13-26:"+JSON.stringify(req));
                LobbyProtocol.encode_Score_Exchange(req, this._sendBuf);
                break;
            default :
                break;
        }
    },

    handleGameInfoMsg: function (subCmd, byteBuf) {
        switch (subCmd) {
            case LobbyProtocol.GameInfo:
                this.handlerGameInfoRsp(byteBuf);
                break;
            case LobbyProtocol.Treasure:
                this.handleUpdateWealthRsp(byteBuf);
                break;
            case LobbyProtocol.ReliveConf:
                this.handleGetReliveConfRsp(byteBuf);
                break;
            case LobbyProtocol.PayNotice:
                this.handlePayNoticeRsp(byteBuf);
                break;
            case LobbyProtocol.GetCrystalInfo :
                this.handleGetCrystalInfoRsp(byteBuf);
                break;
            case LobbyProtocol.PlayerSign:
                this.handleGetSignRsp(byteBuf);
                break;
            case LobbyProtocol.GetPhoneNum:
                this.handleGetPhoneNumRsp(byteBuf);
                break;
            case LobbyProtocol.GetTicketQty:
                this.handleGetTicketRsp(byteBuf);
                break;
            case LobbyProtocol.QueryDailyCharge :
                this.handleQueryDailyChargeRsp(byteBuf);
                break;
            case LobbyProtocol.GetVIPcfg :
                this.handleGetVipconfig(byteBuf);
                break;
            case LobbyProtocol.QueryVIPinfo :
                this.handleQueryVIPinfo(byteBuf);
                break;
            case LobbyProtocol.QueryCheckinCfg :
                this.handleQueryCheckinCfgRsp(byteBuf);
                break;
            case LobbyProtocol.GetCheckinStatu :
                this.handleGetCheckinStatus(byteBuf);
                break;
            case LobbyProtocol.FUBEN2_COIN_GET :
                this.handleFUBEN2_COIN_GET(byteBuf);
                break;
            case LobbyProtocol.FUBEN2_SYLZ_CFG :
                this.handleFUBEN2_SYLZ_CFG(byteBuf);
                break;
            case LobbyProtocol.FUBEN2_JZSJ_CFG :
                this.handleFUBEN2_JZSJ_CFG(byteBuf);
                break;
            case LobbyProtocol.FUBEN2_OPENBOX_CFG :
                this.handleFUBEN2_OPENBOX_CFG(byteBuf);
                break;
            case LobbyProtocol.FUBEN2_BUY_BOX_CFG :
                this.handleFUBEN2_BUY_BOX_CFG(byteBuf);
                break;
            case LobbyProtocol.FUBEN2_OPENBOX :
                this.handleFUBEN2_OPENBOX(byteBuf);
                break;
            case LobbyProtocol.SCORE_EX_GET :
                this.handleQueryScoreExchange(byteBuf);
                break;
            default:
                break;
        }
    },

    sendGameInfoReq: function (type) {
//        cc.log('----------发送进入游戏大厅GameInfo请求');
        var req = createObj(LobbyProtocol.GameInfoReq);
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.GameInfo;
        req.lRoleId = appglobal.getPlayer().roleid;
        req.iSourceId = appglobal._appCfg.source;
        req.iType = type;//roomid
        FYEngine.logObject(req, "--------sendGameInfoReq");
        this.pushSendReq(req);
    },

    handlerGameInfoRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GameInfoRsp(byteBuf);
        FYEngine.logObject(rsp, '----------handlerGameInfoRsp:');
        if (rsp.iResult != 0 || rsp.szIP == "" || rsp.iPort == "") {
            FYEngine.AddCommToast("游戏信息未配置");
            return;
        }
        FishGlobal.roomId = rsp.iType;
        appglobal._gameAccess = rsp.szIP + ':' + rsp.iPort;

        if (rsp.iType == 6) {
            FishGlobal.roomId = 6;
            appglobal.runFishNewScene();
        } else if (rsp.iType == 4) {
            FishGlobal.roomId = 4;
            appglobal.runFishCopyScene();
        } else if (rsp.iType == 5) {
            FishGlobal.roomId = 5;
            appglobal.runFishFightScene();
        } else {
            appglobal.runFishScene();
        }

    },
    sendModuleMsg: function (subCmd, req) {
        switch (subCmd) {
            case LobbyProtocol.Exchange:
                LobbyProtocol.encode_ExchangeProduct(req, this._sendBuf);
                break;
            case LobbyProtocol.Relive:
                LobbyProtocol.encode_getReliveGold(req, this._sendBuf);
                break;
            case LobbyProtocol.Pay:
                LobbyProtocol.encode_getOrder(req, this._sendBuf);
                break;
            case LobbyProtocol.BindAccount:
                LobbyProtocol.encode_BindAccount(req, this._sendBuf);
                break;
            case LobbyProtocol.CheckAccount:
                LobbyProtocol.encode_CheckAccount(req, this._sendBuf);
                break;
            case LobbyProtocol.ModNick:
                LobbyProtocol.encode_ModNick(req, this._sendBuf);
                break;
            case LobbyProtocol.ModPass:
                LobbyProtocol.encode_ModPass(req, this._sendBuf);
                break;
            case LobbyProtocol.TurnTable:
                LobbyProtocol.encode_turnTable(req, this._sendBuf);
                break;
            case LobbyProtocol.CheckUID :
                LobbyProtocol.encode_CheckUID(req, this._sendBuf);
                break;
            case LobbyProtocol.GiveCrystal :
                LobbyProtocol.encode_GiveCrystal(req, this._sendBuf);
                break;
            case LobbyProtocol.CrystalPushInfo :
                LobbyProtocol.encode_CrystalPushInfo(req, this._sendBuf);
                break;
            case LobbyProtocol.EditSign:
                LobbyProtocol.encode_editSignReq(req, this._sendBuf);
                break;
            case LobbyProtocol.ChangeHead:
                LobbyProtocol.encode_ChangeHeadReq(req, this._sendBuf);
                break;
            case LobbyProtocol.ExchangeIntergral :
                LobbyProtocol.encode_ExchangeIntergral(req, this._sendBuf);
                break;
            case LobbyProtocol.BindPhone :
                LobbyProtocol.encode_BindPhoneNumReq(req, this._sendBuf);
                break;
            case LobbyProtocol.UnBindPhone :
                LobbyProtocol.encode_UnBindPhoneNumReq(req, this._sendBuf);
                break;
            case LobbyProtocol.GetTool:
                LobbyProtocol.encode_getToolReq(req, this._sendBuf);
                break;
            case LobbyProtocol.ExchangeTool:
                LobbyProtocol.encode_ToolExchangeReq(req, this._sendBuf);
                break;
            case LobbyProtocol.GetMail :
                LobbyProtocol.encode_GetMail(req, this._sendBuf);
                break;
            case LobbyProtocol.ChangeMailStatus :
                LobbyProtocol.encode_changeMailStatus(req, this._sendBuf);
                break;
            case LobbyProtocol.CheckIn :
                LobbyProtocol.encode_GetCheckResult(req, this._sendBuf);
                break;
            default :
                break;
        }
    },

    sendHallExternalMsg: function (subCmd, req) {
        switch (subCmd) {
            case LobbyProtocol.GetActiveStatus :
                FishProtocol.encode_GetUserActiveReq(req, this._sendBuf);
                break;
            default :
                break;
        }
    },

    handleModuleMsg: function (subCmd, byteBuf) {
        switch (subCmd) {
            case LobbyProtocol.Exchange:
                this.handleExchangeProductRsp(byteBuf);
                break;
            case LobbyProtocol.Relive:
                this.handleGetReliveGoldRsp(byteBuf);
                break;
            case LobbyProtocol.Pay:
                this.handleGetOrderRsp(byteBuf);
                break;
            case LobbyProtocol.BindAccount:
                this.handleBindAccountRsp(byteBuf);
                break;
            case LobbyProtocol.CheckAccount:
                this.handleCheckAccountRsp(byteBuf);
                break;
            case LobbyProtocol.ModNick:
                this.handleModNickRsp(byteBuf);
                break;
            case LobbyProtocol.ModPass:
                this.handleModPassRsp(byteBuf);
                break;
            case LobbyProtocol.TurnTable:
                this.handleTurnTableRsp(byteBuf);
                break;
            case LobbyProtocol.GiveCrystal :
                this.handleGiveCrystalRsp(byteBuf);
                break;
            case LobbyProtocol.CheckUID :
                this.handleCheckUIDRsp(byteBuf);
                break;
            case LobbyProtocol.CrystalPushInfo :
                this.handleCrystalPushInfoRsp(byteBuf);
                break;
            case LobbyProtocol.EditSign:
                this.handleEditSignRsp(byteBuf);
                break;
            case LobbyProtocol.ChangeHead :
                this.handlesetFaceidRsp(byteBuf);
                break;
            case LobbyProtocol.ExchangeIntergral:
                this.handlerIntergralBuyReq(byteBuf);
                break;
            case LobbyProtocol.BindPhone :
                this.handleBindPhoneNumRsp(byteBuf);
                break;
            case LobbyProtocol.UnBindPhone :
                this.handleUnBindPhoneNumRsp(byteBuf);
                break;
            case LobbyProtocol.GetTool :
                this.handleGetToolRsp(byteBuf);
                break;
            case LobbyProtocol.ExchangeTool :
                this.handleToolExchangeRsp(byteBuf);
                break;
            case LobbyProtocol.GetMail :
                this.handleGetMail(byteBuf);
                break;
            case LobbyProtocol.ServerPushMail :
                this.handleServerPushMailRsp(byteBuf);
                break;
            case LobbyProtocol.ChangeMailStatus :
                this.handleChangeMailStatusRsp(byteBuf);
                break;
            case LobbyProtocol.CheckIn :
                this.handleGetCheckinResult(byteBuf);
                break;
            default :
                break;
        }
    },
//发送兑换请求
    sendExchangeProductReq: function (goodid, name, phone, youbian, addres, otherinfo) {
//        cc.log('-------发送1');
        var userInfo = appglobal.getPlayer();
        if (addres == undefined) {
            addres = '';
        }
        if (youbian == undefined) {
            youbian = '';
        }
        if (phone == undefined) {
            phone = '';
        }
        if (name == undefined) {
            name = '';
        }
        if (otherinfo == undefined) {
            otherinfo = '';
        }

        var Req = {};
        Req.mainCmd = LobbyProtocol.ModuleInfoProto;
        Req.subCmd = LobbyProtocol.Exchange;
        Req.lRoleId = userInfo.roleid;
        Req.iGoodsId = goodid;
        Req.lCoupon = userInfo.coupon;
        Req.szIMEI = userInfo.imei;
        Req.szMobile = phone;
        Req.szPostCode = youbian;
        Req.szAddress = addres;
        Req.szRealName = name;
        Req.szDesc = otherinfo;
        this.pushSendReq(Req);

    },

    handleExchangeProductRsp: function (byteBuf) {
        var scene = FYEngine.getRunningLayer(0);
        var layer3 = scene.getChildByName(LobbySceneName.ProductInfoLayer);
        var layer4 = scene.getChildByName(LobbySceneName.BillOrderLayer);
        var layer5 = scene.getChildByName(LobbySceneName.RealProductLayer);

        if (layer3 && layer3.timeCount) {
            layer3.unschedule(layer3.timeCount);
        }
        if (layer4 && layer4.timeCount) {
            layer4.unschedule(layer4.timeCount);
        }

        if (layer5 && layer5.timeCount) {
            layer5.unschedule(layer5.timeCount);
        }

        var loading2 = scene.getChildByName('loading2');
        if (loading2) {
            loading2.removeFromParent(true);
        }

        var rsp = LobbyProtocol.decode_ExchangeProduct(byteBuf);
//        FYEngine.logObject(rsp,"兑换消息返回");
        if (rsp.iResult == 0) {
            if (layer4) {
                layer4.removeFromParent();
            }
            if (layer5) {
                layer5.removeFromParent();
            }
            var mlayer = new ExchangeSuccessLayer(rsp.GoodsName);
            if (mlayer) {
                scene.addChild(mlayer, FishZorder.poplayer, LobbySceneName.ExchangeSucessLayer);
            }

            if (rsp.iType == 99) {
                this.sendGetCrystalInfoReq();
            }
            this.sendUpdateWealthReq();


        } else if (rsp.iResult == -314) {
            FYEngine.AddCommToast("此商品每人每天限兑{0}次".format(FishGlobal.ProLimitCount));

        } else if (rsp.iResult == -311) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeFailed311));

        } else if (rsp.iResult == -309) {
            FYEngine.AddCommToast("兑换失败，请稍后再试");
        } else {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeFailed));
        }


    },

    sendUpdateWealthReq: function () {
        var roleid = appglobal.getPlayer().roleid;

        var Req = {};
        Req.mainCmd = LobbyProtocol.GameInfoProto;
        Req.subCmd = LobbyProtocol.Treasure;
        Req.lUserId = roleid;
        this.pushSendReq(Req);
    },

    handleUpdateWealthRsp: function (byteBuf) {
        var player = appglobal.getPlayer();
        var rsp = LobbyProtocol.decode_UpdateWealth(byteBuf);
        FYEngine.logObject(rsp, '-----------财富u刷新:');
        // FYEngine.AddCommToast("rsp.lCoupon"+rsp.lCoupon);
        player.totalpay = rsp.iTotalPay;
        player.gold = rsp.lGold;
        player.coupon = rsp.lCoupon;
        player.score = rsp.lScore;

        var scene = FYEngine.getRunningLayer(0);

        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.refreshWealth);
        }
        // this.sendGetCrystalInfoReq();
    },

    sendGetReliveConfReq: function () {
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.ReliveConf;
        req.lRoleId = appglobal.getPlayer().roleid;
        this.pushSendReq(req);
    },

    handleGetReliveConfRsp: function (byteBuf) {
        var info = LobbyProtocol.decode_getReliveConf(byteBuf);
        //var dataValue = jsonInfo.data;
        FishGlobal.reliveinfor = info;
//        FYEngine.logObject(FishGlobal.reliveinfor,'------------获取救济金配置');
        FishGlobal.relivelimit = FishGlobal.reliveinfor.iLimit - FishGlobal.reliveinfor.iDayCount;
        if (FishGlobal.reliveinfor.iDay < 7 && appglobal._switch1 == 1) {
            FishGlobal.showturn = 1;
        }
        if (appglobal._switch5 == 1) {
            if (FYEngine.getRunningScene().getName() == AppSceneName.Fourth) {
                //cc.log('------------获取救济金配置1');
//                                        FishGlobal.isTurnBtnShow = true;
                if (FishGlobal.reliveinfor.iStatus != (-1) && appglobal._switch1 == 1) {
                    FishGlobal.isTurnBtnShow = true;
                    //cc.log('------------获取救济金配置2'+FishGlobal.isTurnBtnShow);
                }
                return;
            }

            if (FishGlobal.reliveinfor.iStatus != 1 || NoticeComm.loadFlag == 0) {
                return;
            }
            if (FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.NoticeLayer) && NoticeComm.btnFlag != 1) {
                cc.log("弹出大转盘");
            } else if (NoticeComm.loadFlag == 1 && NoticeComm._data == undefined && FishGlobal.stoptip == 0) {
//                cc.log('---------大转盘创建1');
                var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.LuckPan);
                if (!layer) {
                    layer = new TurnTableDialog(FishGlobal.reliveinfor.iStatus);
                    if (layer) {
                        FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.LuckPan);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                }
            }
        }
    },

    sendGetReliveGoldReq: function () {
        var Req = {};
        Req.mainCmd = LobbyProtocol.ModuleInfoProto;
        Req.subCmd = LobbyProtocol.Relive;
        Req.lUserId = appglobal.getPlayer().roleid;
        Req.szToken = appglobal.getPlayer().gametoken;
        this.pushSendReq(Req);

    },

    handleGetReliveGoldRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_getReliveGold(byteBuf);
//        FYEngine.logObject(rsp,"--救济金：");
        var scene = FYEngine.getRunningLayer(0);
        var layer1 = scene.getChildByName(LobbySceneName.HelpLayer);
        var layer2 = scene.getChildByName('jiuji');
        if (layer1) {
            layer1.removeFromParent(true);
        }
        if (layer2) {
            layer2.removeFromParent(true);
        }

        if (rsp.iResult != 0) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue("reliveGetFailed"));
            return;
        }

        FishGlobal.relivelimit = FishGlobal.relivelimit - 1;
        FishGlobal.reliveinfor.iDayCount = rsp.iReliveCount;
        FYEngine.AddCommToast(FYEngine.LanguageString.getValue("reliveGetSuccess"));
        if (FishGlobal.bInFishScene == true) {
            var gamehandler = CoreServiceProxy.getInstance().getGameHandler()._fishData;
            gamehandler._userData[gamehandler._selfId].lGold = rsp.lTotalGold;
            scene.changeUserGold(gamehandler._selfId);
        }
        this.sendUpdateWealthReq();
    },

    sendGetPayOrderReq: function (goodsId) {
        var player = appglobal.getPlayer();
        var req = {};//createObj(LobbyProtocol.getOrderReq);
        var nativeInfo = eval("(" + app.sdkPlugin.getNativeInfo() + ")");
//        FYEngine.logObject(nativeInfo,'--------nativeInfo:');
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.Pay;
        req.iMId = 0;
        if (appglobal.isBufanPay()) {
            req.iPayId = nativeInfo.paySource;
        } else {
            if (FishGlobal.iosPayTag == 0) {
                req.iPayId = nativeInfo.paySource;
            } else {
                var cachetest = nativeInfo.payAibeiSource;
                if (cachetest && cachetest != "") {
                    req.iPayId = cachetest;
                } else {
                    req.iPayId = 104;
                }
            }
        }

        req.lPayUid = player.userid;
        req.lUid = player.userid;
        req.iGameId = 0;
        req.iServerId = 0;
        req.lRoleId = player.roleid;
        req.iGoodsId = goodsId;
        req.szDesc = '';
        req.szIp = '';
        this.pushSendReq(req);
        //FYEngine.logObject(req,'---------------充值订单请求:');
    },

    handleGetOrderRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_getOrder(byteBuf);
//        FYEngine.logObject(rsp, '-------------handleGetOrderRsp:');
        if (rsp.iResult == -8) {
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.getName() == "lobbyscene") {
                var layer = scene.getChildByName(LobbySceneName.OverChargeLayer);
                if (!layer) {
                    var mlayer = new DailyChargeOverrangeWindow();
                    scene.addChild(mlayer, FishZorder.poplayer, LobbySceneName.OverChargeLayer);
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }
            return;
        }

        if (rsp.iResult == -7) {
            FYEngine.AddCommToast('您今天已经购买过此礼包了');
            return;
        }

        if (rsp.iResult == -2) {
            if (FishGlobal.NYMallTag == true) {
                FYEngine.AddCommToast('新春礼包已下架');
            } else {
                FYEngine.AddCommToast('商品已下架');
            }
            return;
        }

        // if(FishGlobal.NYMallTag == true){
        //     var productName = FishGlobal.getNYMallProductName(rsp.iGoodsId);
        // }else{
        //     var productName = FishGlobal.getMallProductName(rsp.iGoodsId);
        // }
        var productName = FishGlobal.getMallProductName(rsp.iGoodsId);

        if (rsp.iResult == 0) {
            var base = new Base64();
            var data = {
                userId: appglobal.getPlayer().userid,
                itemType: 1,
                itemPrice: rsp.fMoney,
                orderNo: rsp.szSn,
                notifyUrl: rsp.szUrl,
                point: rsp.szPoint,
                itemName: base.encode(productName),
                payType: FishGlobal.multipayTag
            };
            if (appglobal.isBufanPay()) {
                app.sdkPlugin.callNativeMethodAysc("bufanPay", JSON.stringify(data));
            } else {
                if (FishGlobal.iosPayTag == 0) {
                    app.sdkPlugin.callNativeMethodAysc("startPay", JSON.stringify(data));
                } else {
                    app.sdkPlugin.callNativeMethodAysc("startIosApay", JSON.stringify(data));
                }
            }
        } else {
            if (rsp.iResult == -101 || rsp.iResult == -102 || rsp.iResult == -103) {
                FYEngine.AddCommToast("您今日充值已达上限");
            } else {

                FYEngine.AddCommToast("充值失败，请联系客服QQ:3003674856");

            }
        }

    },

    sendBindAccountReq: function (account, password) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.BindAccount;
        req.lRoleId = player.roleid;
        req.szAccount = account;
        req.szPassword = password;
        req.szIMEI = player.imei;
        req.szIp = "";
        this.pushSendReq(req);
    },

    handleBindAccountRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_BindAccount(byteBuf);

        if (rsp.iResult == 0) {
            appglobal.getPlayer().account = rsp.szAccount;
            var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.CompleteInfoLayer);
            if (layer) {
                layer.removeFromParent(true);
            }
            //更新sdk密码
            app.accountManager.modifyAccount(rsp.szAccount);
            app.accountManager.modifyPwd(rsp.szPassword);
            var settinglayer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.SettingInfoLayer);
            if (settinglayer) {
                settinglayer.updateAccount(rsp.szAccount);
            }
            //var warmalayer = new WarmTipLayer(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount7));
            var warmalayer = new BindAccountOkDialog();
            if (warmalayer) {
                FYEngine.getRunningLayer(0).addChild(warmalayer, FishZorder.poplayer, "lay4");
                FYEngine.popupLayerAnimate(warmalayer.layerbg);
            }
            //layer.removeFromParent();
        } else if (rsp.iResult == -3 || rsp.iResult == -6) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount6));
        } else {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingAccount8));
        }
    },

    sendCheckAccountReq: function (account) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.CheckAccount;
        req.lRoleId = player.roleid;
        req.szAccount = account;
        this.pushSendReq(req);
    },

    handleCheckAccountRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_CheckAccount(byteBuf);
    },

    sendModNickReq: function (nickName) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.ModNick;
        req.lRoleId = player.roleid;
        req.szNickName = nickName;
        req.szIMEI = player.imei;
        req.szIp = "";
        this.pushSendReq(req);
    },
    handleModNickRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_ModNick(byteBuf);
        var scene = FYEngine.getRunningLayer(0);
        scene.removeChildByName(LobbySceneName.ChangeNickNameLayer, true);
        cc.log("----handleModNickRsp:" + rsp.iResult);
        if (rsp.iResult == 0) {
            var tempname = SoftReplaceWords(rsp.szNickName);
            appglobal.getPlayer().nickname = tempname;
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingNickSuccess));
            scene.initUserInfo("changeNick");
        } else {
            if (rsp.iResult < -10000) {
                var faillayer = scene.getChildByName(LobbySceneName.changeNickFailWarn);
                if (!faillayer) {
                    faillayer = new ChangeNickFailLayer(Math.abs(rsp.iResult + 10000));
                    scene.addChild(faillayer, FishZorder.poplayer, LobbySceneName.changeNickFailWarn);
                }
            } else {
                FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingNickFailed));
            }

        }
        var layer = scene.getChildByName(LobbySceneName.SettingInfoLayer);
        if (layer && layer.refreshNickName) {
            layer.refreshNickName();
        }
    },
    sendModPassReq: function (oldPass, newPass) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.ModPass;
        req.lRoleId = player.roleid;
        req.szOldPass = oldPass;
        req.szNewPass = newPass;
        req.szIMEI = player.imei;
        req.szIp = "";
        this.pushSendReq(req);
    },

    handleModPassRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_ModPass(byteBuf);
        if (rsp.iResult == 0) {
            var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.ChangepSWLayer);
            app.accountManager.modifyPwd(rsp.szNewPass);
            if (layer) {
                layer.removeFromParent();
            }
            var warmalayer = new WarmTipLayer(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr6));
            if (warmalayer) {
                FYEngine.getRunningLayer(0).addChild(warmalayer, FishZorder.poplayer, "lay4");
                FYEngine.popupLayerAnimate(warmalayer.layerbg);
            }

        } else if (rsp.iResult == -2) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr7));
        } else {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr8));
        }
    },
    /**
     * 转盘
     */
    sendTurnTableReq: function () {
        var player = appglobal.getPlayer();
        var Req = {};
        Req.mainCmd = LobbyProtocol.ModuleInfoProto;
        Req.subCmd = LobbyProtocol.TurnTable;
        Req.lRoleId = player.roleid;
        Req.szToken = player.gametoken;
        this.pushSendReq(Req);
    },

    handleTurnTableRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_turnTable(byteBuf);
//        FYEngine.logObject(rsp,"---------接受转盘的消息");
        var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.LuckPan);
        if (layer) {
            layer.onGameEventTurnTable(rsp);
        }
        this.sendGetReliveConfReq();
    },

    handleBroadMsg: function (subCmd, byteBuf) {

        var rsp = LobbyProtocol.decode_BroadMsg(byteBuf);
        // FYEngine.logObject(rsp,"------大厅广播req1:");

        if (FishGlobal.LiveLevel == 0 || (FishGlobal.playerscorelevel < FishGlobal.realProSwitch)
            || (FishGlobal.playerscorelevel < FishGlobal.rankCoupon)) {
            var number = rsp.szMsg.indexOf("真是太厉害了");//todo 后续如果修改兑奖广播的内容,需要对应修改这个判断字符串
            if (number > 0) {
                return;
            }
        }

        if ((FishGlobal.LiveLevel == 1 || FishGlobal.LiveLevel == 2)) {
            var number = rsp.szMsg.indexOf("弹头");//todo 后续如果修改兑奖广播的内容,需要对应修改这个判断字符串
            if (number > 0) {
                return;
            }
        }

        this._lobbyData.putLobbyBroad(rsp);

        if (rsp.iShowType == 256) {
            this._lobbyData.putLobbyBroadExchange(rsp);
        }
    },

    sendCacheBroadListReq: function () {
        if (this._lobbyData._lobbyBroadExchange && this._lobbyData._lobbyBroadExchange.length > 0) {
            return;
        }
        this._lobbyData._lobbyBroadExchange = [];

        var req = {};
        req.mainCmd = LobbyProtocol.ListProto;
        req.subCmd = LobbyProtocol.CacheBroadList;
        req.iShowType = 256;
        this.pushSendReq(req);
    },

    handleCacheBroadListRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_BroadList(byteBuf);
        // FYEngine.logObject(rsp,"------大厅广播req:");
        if (appglobal._switch2 == 0) {
            return;
        }
        if (rsp.iType == 256 && rsp.iResult == 0) {
            if (FishGlobal.LiveLevel == 0) {
                for (var i = 0; i < rsp.iCount; i++) {
                    var number = rsp.pMsg[i].szMsg.indexOf("真是太厉害了");
                    if (number > 0) {
                        continue;
                    }
                    this._lobbyData.putLobbyBroadExchangeBase(rsp.pMsg[i]);
                }
            } else if (FishGlobal.LiveLevel == 1 || FishGlobal.LiveLevel == 2) {
                for (var i = 0; i < rsp.iCount; i++) {
                    var number = rsp.pMsg[i].szMsg.indexOf("弹头");
                    if (number > 0) {
                        continue;
                    }
                    this._lobbyData.putLobbyBroadExchangeBase(rsp.pMsg[i]);
                }
            } else {
                if (FishGlobal.playerscorelevel < FishGlobal.realProSwitch) {
                    for (var i = 0; i < rsp.iCount; i++) {
                        var number = rsp.pMsg[i].szMsg.indexOf("真是太厉害了");
                        if (number > 0) {
                            continue;
                        }
                        this._lobbyData.putLobbyBroadExchangeBase(rsp.pMsg[i]);
                    }
                } else {
                    for (var i = 0; i < rsp.iCount; i++) {
                        this._lobbyData.putLobbyBroadExchangeBase(rsp.pMsg[i]);
                    }
                }
            }


        }
    },

    handlePayNoticeRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_NoticePayRsp(byteBuf);
        if (rsp.iResult == 0) {
            cc.log('--------------------------------充值成功提示');
            if (appglobal.idVerifySwitch) {
                var date = new Date();

                var localcharge = cc.sys.localStorage.getItem(appglobal.getPlayer().userid + 'gamechargemoney' + date.getFullYear() + date.getMonth() + date.getUTCDate());
                if (localcharge) {
                    var numb = parseInt(localcharge) + FishGlobal.currentcharge;
                    cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'gamechargemoney' + date.getFullYear() + date.getMonth() + date.getUTCDate(), numb);
                } else {
                    cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'gamechargemoney' + date.getFullYear() + date.getMonth() + date.getUTCDate(), FishGlobal.currentcharge + "");
                }
            }

            this.sendGetActiveReq();
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue("chargeSuccess"));
            this.sendUpdateWealthReq();
            var scene = FYEngine.getRunningLayer(0);
            var layer = scene.getChildByName(LobbySceneName.NYMallLayer);
            var layer2 = scene.getChildByName(LobbySceneName.IosPayLayer);
            if (layer2) {
                layer2.removeFromParent(true);
            }
            if (layer && layer.setBuyedFunction) {
                //cc.log('----------充值成功1');
                layer.setBuyedFunction();
            }

            this.sendQueryVIPinfo();
        }
    },

    handleServerKick: function (subCmd, byteBuf) {
        var rsp = LobbyProtocol.decode_serverKickRsp(byteBuf);
        //FYEngine.logObject(rsp,'--------------踢人功能:');
        if (appglobal.isWechatLogin) FYEngine.javascriptJavaBridge.handleWXLogout();
        switch (rsp.iKickType) {
            case 2 : {
                app.accountManager.userLogout();
                cc.sys.localStorage.setItem("VIVO_TAG", "0");
                CoreServiceProxy.getInstance().unlinkLobbyClient();
                CoreServiceProxy.getInstance().unlinkGameClient();
                FishGlobal.kick = rsp.iKickType;
                appglobal._runLobby = false;
                cc.director.runScene(LoginLayer.createScene());
            }
                break;
            case 3 : {
                var coreserviceproxy = CoreServiceProxy.getInstance();
                coreserviceproxy.unlinkLobbyClient();
                CoreServiceProxy.getInstance().unlinkGameClient();
                var scene = FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(LobbySceneName.KickedByServer);
                if (!layer) {
                    layer = new KickByServer(0);
                    scene.addChild(layer, FishZorder.poplayer + 10, LobbySceneName.KickedByServer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
        }
    },

    sendGetSignReq: function () {
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.PlayerSign;
        req.lRoleId = appglobal.getPlayer().roleid;
        this.pushSendReq(req);
    },

    handleGetSignRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GetSignRsp(byteBuf);
        if (rsp.iResult == 0) {
            var tempsign = SoftReplaceWords(rsp.szSign);
            appglobal.getPlayer().setSign(tempsign);
        }
    },

    sendEditSignReq: function (sign) {
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.EditSign;
        req.lRoleId = appglobal.getPlayer().roleid;
        req.szSign = sign;
        this.pushSendReq(req);
//        FYEngine.logObject(req,"---发送签名");
    },

    handleEditSignRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_editSignRsp(byteBuf);
//        FYEngine.logObject(rsp,"-------签名消息返回");
        if (rsp.iResult == 0) {
            var tempsign = SoftReplaceWords(rsp.szSign);
            appglobal.getPlayer().setSign(tempsign);
            var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.ChangeSignLayer);
            if (layer) {
                layer.removeFromParent(true);
            }
            var SettingLayer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.SettingInfoLayer);
            if (SettingLayer) {
                SettingLayer.updateSign();
            }
        } else {
            FYEngine.AddCommToast("修改签名失败，请稍后再试");
            var layer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.ChangeSignLayer);
            if (layer) {
                layer.removeFromParent(true);
            }
        }

    },

    sendGetCrystalInfoReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.GetCrystalInfo;
        req.lRoleId = player.roleid;
        this.pushSendReq(req);
//       FYEngine.logObject(req,'-----------发送获取钻石数量的消息:');
    },

    handleGetCrystalInfoRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GetCrystalInfoRsp(byteBuf);
        FYEngine.logObject(rsp, '-----------handleGetCrystalInfoRsp:');
        if (rsp.iResult == 0) {
            var scene = FYEngine.getRunningLayer(0);
            var layer = scene.getChildByName(LobbySceneName.LuckyCrystalLayer);
            var player = appglobal.getPlayer();
            player.crystal = rsp.lCrystal;
            FishGlobal.lRemaind = rsp.lRemaind;
//            appglobal.getPlayer().totoalchargegold = rsp.lRecharge;
            if (layer) {
                layer.unschedule(layer.checkGetCrystalNumber);
                layer.removeIncomingLoading();
                layer.initUI();
            }
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(lobbyGameEvent.refreshWealth);
            }
        }
    },

    sendGiveCrystalReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.GiveCrystal;
        req.lRoleId = player.roleid;
        req.lGiveId = FishGlobal.sendTemp.UID;
        req.lCrystal = FishGlobal.sendTemp.Qty;
        this.pushSendReq(req);
    },

    handleGiveCrystalRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GiveCrystalRsp(byteBuf);
        var scene = FYEngine.getRunningLayer(0);
        var lay3 = scene.getChildByName(LobbySceneName.CrystalSoldOutLayer) || scene.getChildByName(LobbySceneName.CrystalSendToOtherLayer);
        var lay4 = scene.getChildByName(LobbySceneName.CrystalConfirmLayer);
        if (lay4) {
            lay4.removeLoading();
            lay4.unschedule(lay4.timeCount);
        }
        if (rsp.iResult == 0) {
            appglobal._player.crystal = rsp.NewCrystal;
            if (lay4) {
                lay4.removeFromParent(true);
            }
            if (lay3) {
                lay3.removeFromParent(true);
            }

            if (rsp.lGiveId == 0) {
                FYEngine.AddCommToast('成功');
            } else {
                FYEngine.AddCommToast('成功');
            }
            //scene.onGameEvent(lobbyGameEvent.refreshWealth);
            this.sendUpdateWealthReq();
            this.sendQueryVIPinfo();
        } else {
            if (rsp.lGiveId == 0) {
                FYEngine.AddCommToast('失败，请稍后再试');
            } else {
                FYEngine.AddCommToast('失败，请稍后再试');
            }
        }
    },

    sendcheckUIDreq: function (UID) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.CheckUID;
        req.lRoleId = player.roleid;
        req.lUserId = UID;
        this.pushSendReq(req);
        FYEngine.logObject(req, '-----------发送校验UID的消息:');
    },

    handleCheckUIDRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_CheckUIDRsp(byteBuf);
        FYEngine.logObject(rsp, '-----------接受校验UID的消息:');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.CrystalSendToOtherLayer);
        if (layer) {
            layer.removeLoading();
            layer.unschedule(layer.timeCount);
        }
        if (rsp.iResult == 0) {
            var lay4 = scene.getChildByName(LobbySceneName.CrystalConfirmLayer);
            if (!lay4) {
                var tempname = SoftReplaceWords(rsp.szNickName);
                lay4 = new CrystalConfirmLayer(0, tempname);
                scene.addChild(lay4, FishZorder.poplayer, LobbySceneName.CrystalConfirmLayer);
            }

        } else {
            FYEngine.AddCommToast('对方ID不存在');
        }
    },

    sendCrystallPushInfoReq: function (num, msgid) {
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.CrystalPushInfo;
        req.iMessageNum = num;
        req.szCrystalRsp = msgid;
        this.pushSendReq(req);
    },

    handleCrystalPushInfoRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_CrystalPushInfoRsp(byteBuf);
        var msgArry = [];
        var strSendArry = [];
        var strRevArry = [];
        var player = appglobal.getPlayer();
        for (var i = 0; i < rsp.iMessageNum; ++i) {
            FishGlobal.backMsg = {};
            FishGlobal.backMsg.lMessageId = rsp.Msg[i].lMessageId;
            FishGlobal.backMsg.iTypeId = rsp.Msg[i].iTypeId;
            msgArry.push(FishGlobal.backMsg);
            cc.log('------------FishGlobal.pushMsgRecord :' + FishGlobal.pushMsgRecord);
            if (rsp.Msg[i].lMessageId <= FishGlobal.pushMsgRecord) {
                cc.log('----------重复的消息FishGlobal.backMsg.iTypeId+:' + rsp.Msg[i].lMessageId);
                continue;
            }
            FishGlobal.pushMsgRecord = rsp.Msg[i].lMessageId;

            if (rsp.Msg[i].iTypeId == 0) {
                FishGlobal.sendRecordTemp = {};
                FishGlobal.sendRecordTemp.lGiveId = rsp.Msg[i].lGiveId;
                FishGlobal.sendRecordTemp.szGiveName = rsp.Msg[i].szGiveName;
                FishGlobal.sendRecordTemp.lCrystal = rsp.Msg[i].lCrystal;
                FishGlobal.sendRecordTemp.szTime = (rsp.Msg[i].szTime);
                strSendArry.push(FishGlobal.sendRecordTemp);
            } else {
                player.crystal = player.crystal + rsp.Msg[i].lCrystal;
                FishGlobal.revRecordTemp = {};
                FishGlobal.revRecordTemp.lGiveId = rsp.Msg[i].lUserId;
                FishGlobal.revRecordTemp.szGiveName = rsp.Msg[i].szNickName;
                FishGlobal.revRecordTemp.lCrystal = rsp.Msg[i].lCrystal;
                FishGlobal.revRecordTemp.szTime = (rsp.Msg[i].szTime);
                strRevArry.push(FishGlobal.revRecordTemp);
                FishGlobal.showRedTip = 1;
                cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'noRead', 1 + '');
                var scene = FYEngine.getRunningLayer(0);
                if (scene && scene.onGameEvent) {
                    scene.onGameEvent(lobbyGameEvent.showRed);
                    scene.onGameEvent(lobbyGameEvent.refreshWealth);
                }
            }

        }
        cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'pushMsgRecord', FishGlobal.pushMsgRecord + '');

        if (strSendArry.length > 0) {
            for (var j = 0; j < strSendArry.length; ++j) {
                FishGlobal.sendRecord.Msg.push(strSendArry[j])
            }
            if (FishGlobal.sendRecord.Msg.length > 100) {
                FishGlobal.sendRecord.Msg.splice(0, FishGlobal.sendRecord.Msg.length - 100);

            }
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'sendRecord', JSON.stringify(FishGlobal.sendRecord));
        }

        if (strRevArry.length > 0) {
            for (var j = 0; j < strRevArry.length; ++j) {
                FishGlobal.revRecord.Msg.push(strRevArry[j])
            }
            if (FishGlobal.revRecord.Msg.length > 100) {
                FishGlobal.revRecord.Msg.splice(0, FishGlobal.revRecord.Msg.length - 100);

            }
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'revRecord', JSON.stringify(FishGlobal.revRecord));
        }

        this.sendCrystallPushInfoReq(rsp.iMessageNum, msgArry);
    },

    sendSetFaceIdReq: function (faceid) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.ChangeHead;
        req.lRoleId = player.roleid;
        req.lUserId = player.userid;
        req.iType = 0;
        req.szFaceid = faceid;
        req.iFaceStatus = 0;
//        FYEngine.logObject(req, '------------发送修改faceid的请求:');
        this.pushSendReq(req);
    },

    handlesetFaceidRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_ChangeHeadReq(byteBuf);
//        FYEngine.logObject(rsp,'-----------修改头像消息返回:');
        if (rsp.iResult == 0) {
            var player = appglobal.getPlayer();
            player.facestatus = rsp.iFaceStatus;
            player.faceid = rsp.szFaceid + '';
            FYEngine.AddCommToast('修改头像成功');
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.getName() == 'lobbyscene') {
                scene.onGameEvent(lobbyGameEvent.refreshLobbyHead, player.faceid);
            }
        }
    },

    sendIntergralBuyReq: function (id) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.ExchangeIntergral;
        req.lRoleId = player.roleid;
        req.iGoodsId = id;
       FYEngine.logObject(req,'--------fasong:');
        this.pushSendReq(req);
    },

    handlerIntergralBuyReq: function (byteBuf) {
        var rsp = LobbyProtocol.decode_ExchangeIntergral(byteBuf);
        FYEngine.logObject(rsp,'-------兑换消息返回:');
        var scene =FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.IntergralLayer);
        if(layer){
            layer.setBuyResult(rsp);
        }
        this.sendQueryScoreExchange(FishGlobal._tempScoreId );
        if(rsp.iResult ==0){
            //cc.log('--------兑换成功');
            var player = appglobal.getPlayer();
            player.gold = rsp.lGold;
            player.coupon = rsp.lCoupon;
            player.score = rsp.lScore;
            player.crystal = rsp.lCrystal;

            if(scene && scene.onGameEvent){
                scene.onGameEvent(lobbyGameEvent.refreshWealth);
            }
        }
    },

    sendQueryScoreExchange : function(id){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.SCORE_EX_GET;
        req.lUserId = player.roleid;
        req.iGoodsId = id;
        this.pushSendReq(req);
    },

    handleQueryScoreExchange : function(byteBuf){
        var rsp = LobbyProtocol.decode_Score_Exchange(byteBuf);
        FYEngine.logObject(rsp,"---查询次数：");
        var scene =FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.IntergralLayer);
        if(layer){
            layer.setQueryResult(rsp);
        }
    },

    handleIntergralResultRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_IntergralResultRsp(byteBuf);
        //FYEngine.logObject(rsp,'----------积分的消息:');
        if (rsp.iResult == 0 && FishGlobal.LiveLevel >= 2) {
            FishGlobal.InterNumber = rsp.lScore;
            var scene = FYEngine.getRunningLayer(0);
            if (scene.getName() == 'lobbyscene') {
                if (rsp.lScore != 0) {
                    var layer = scene.getChildByName(LobbySceneName.IntergralTipsLayer);
                    if (!layer) {
                        layer = new NewIntergralResultLayer(FishGlobal.InterNumber);
                        scene.addChild(layer, FishZorder.poplayer, LobbySceneName.IntergralTipsLayer);
                        FishGlobal.InterNumber = 0;
                    }
                }
            }
        }
    },

    sendGetActiveReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.HallExternalProto;
        req.subCmd = LobbyProtocol.GetActiveStatus;
        req.lRoleId = player.roleid;
//        FYEngine.logObject(req,'--------发送获取活跃度消息:');
        this.pushSendReq(req);
    },

    handleGetActiveRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_GetUserActiveRsp(byteBuf);
//        FYEngine.logObject(rsp,'----------获取活跃度消息:');
        if (rsp.iResult == 0) {
            FishGlobal.setPlayerScoreLevel(rsp.iLevel);
            var scene = FYEngine.getRunningScene();
            switch (scene.getName()) {
                case AppSceneName.Fourth : {
                    var score = FishGlobal.getLiveLevel(rsp.lActive);
                    cc.log("--------------------activescore" + score + "------当前:" + FishGlobal.LiveLevel);
                    FishGlobal.LiveLevel = score;
                    //FishGlobal.LiveLevel = 4;
                }
                    break;
                case AppSceneName.Lobby : {
                    var layer = FYEngine.getRunningLayer(0);
                    if (layer && layer.onGameEvent) {
                        layer.onGameEvent(lobbyGameEvent.refreshplayerscore);
                    }
                    var score = FishGlobal.getLiveLevel(rsp.lActive);
                    //cc.log("--------------------activescore"+score+"------当前:"+FishGlobal.LiveLevel);
                    if (FishGlobal.LiveLevel >= score) {
                        return;
                    }
                    FishGlobal.LiveLevel = score;

                    if (layer && layer.onGameEvent) {
                        layer.onGameEvent(lobbyGameEvent.refreshActive, score);
                    }
                }
                    break;
                default :
                    break;
            }
        }
    },

    sendGetPhoneNumReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.GetPhoneNum;
        req.lUserId = player.userid;
        //FYEngine.logObject(req,'---------------发送获取手机号码的消息:');
        this.pushSendReq(req);
    },

    handleGetPhoneNumRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GetPhoneNumRsp(byteBuf);
        //FYEngine.logObject(rsp,'---------------收到获取手机号码的消息:');
        var player = appglobal.getPlayer();
        player.phonenumber = "";
        if (rsp.iResult == 0) {
            player.phonenumber = "" + rsp.szPhone;
        }
    },

    sendBindPhoneNumReq: function (phonenumer, code) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.BindPhone;
        req.lUserId = player.userid;
        req.szPhone = phonenumer;
        req.szCode = code;
        //FYEngine.logObject(req,'----------发送绑定手机消息:');
        this.pushSendReq(req);
    },

    handleBindPhoneNumRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_bindPhoneNumRsp(byteBuf);
        //FYEngine.logObject(rsp,'---------绑定手机消息返回:');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.BindPhoneDialog);
        if (layer) {
            layer.removeLoading();
            layer.unschedule(layer.timeCount);
        }
        if (rsp.iResult == 0) {
            layer.removeFromParent(true);
            var player = appglobal.getPlayer();
            player.phonenumber = rsp.szPhone;
            var time = Date.now();
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'userguide', "" + time);

            var settinglayer = scene.getChildByName(LobbySceneName.SettingInfoLayer);
            if (settinglayer) {
                settinglayer.updatePhonenumber();
            }
            if (rsp.iStatus == -1) {
                FYEngine.AddCommToast("手机绑定成功");
            } else {
                var newlayer = new BindPhoneOkDialog();
                if (newlayer) {
                    scene.addChild(newlayer, FishZorder.poplayer, LobbySceneName.BindPhoneOKDialog);
                    FYEngine.popupLayerAnimate(newlayer.layerbg);
                }
            }

        } else {
            if (rsp.iResult == -2) {
                FYEngine.AddCommToast("该手机已被其他账号绑定");
            } else if (rsp.iResult == -3) {
                FYEngine.AddCommToast("该账号已绑定过手机");
            } else if (rsp.iResult == -4) {
                FYEngine.AddCommToast("短信验证码错误");
            } else if (rsp.iResult == -6) {
                FYEngine.AddCommToast("短信验证码已失效");
            } else {
                FYEngine.AddCommToast("绑定手机失败");
            }
        }
    },

    sendUnBindPhoneNumReq: function (phonenumer, code) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.UnBindPhone;
        req.lUserId = player.userid;
        req.szPhone = phonenumer;
        req.szCode = code;
        //FYEngine.logObject(req,'---------------发送解除绑定手机号码的消息');
        this.pushSendReq(req);
    },

    handleUnBindPhoneNumRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_unBindPhoneNumRsp(byteBuf);
        //FYEngine.logObject(rsp,'--------------接受解绑手机号码的消息');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.UnBindPhoneDialog);
        if (layer) {
            layer.removeLoading();
            layer.unschedule(layer.timeCount);
        }

        if (rsp.iResult == 0) {
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'userguide', "" + 0);
            layer.removeFromParent(true);
            var player = appglobal.getPlayer();
            player.phonenumber = "";
            var settinglayer = scene.getChildByName(LobbySceneName.SettingInfoLayer);
            if (settinglayer) {
                settinglayer.updateUnPhonenumber();
            }
            FYEngine.AddCommToast("手机解绑成功");
        } else {
            if (rsp.iResult == -3) {
                FYEngine.AddCommToast("请输入正确的验证码");
            } else if (rsp.iResult == -5) {
                FYEngine.AddCommToast("短信验证码已失效");
            } else {
                FYEngine.AddCommToast("手机解除绑定失败");
            }

        }
    },

    getUserAuthenticationRecord: function () {
        var player = appglobal.getPlayer();
        player.realName = "";
        player.realIDnumber = "";
        player.isAdult = false;
        Http.getMessage(function () {
            var service = formservice("idCardCheck");
            var time = Date.now();
            var uid = {name: "uid", value: appglobal.getPlayer().userid};
            var name = {name: "name", value: ""};
            var idNo = {name: "idNo", value: ""};
            var imei = {name: "imei", value: appglobal._appCfg.imei};
            var sign = formsign("idCardCheck", time);
            time = formTime(time);
            var checksum = formchecksum(uid.value, idNo.value, name.value, imei.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, uid, name, idNo, imei, sign, checksum);
            cc.log('-------发送获取身份证号请求url:' + url);
            return url;
        }(), null, function (cfgStr) {
            //self.removeLoading();
            //self.unschedule(self.timeCount);
            var jsonInfo = eval('(' + cfgStr + ')');
//            FYEngine.logObject(jsonInfo,'------获取:');
            var errcode = jsonInfo.code;
            if (errcode != 0) {
                cc.log('-----获取失败');
                switch (errcode) {
                    case -1 : {//未实名认证

                    }
                        break;
                    case 1 : {//实名认证失败

                    }
                        break;
                    case 2 : {//连接实名认证服务器失败

                    }
                        break;
                    case 3 : {//身份证不符合规则

                    }
                        break;
                    default :
                        break;
                }
            } else {
                var IDdata = jsonInfo.data;
                //var player = appglobal.getPlayer();
                player.realName = IDdata.realName;
                player.realIDnumber = IDdata.idCard;
                var age = FYEngine.getAgeByIdCard(IDdata.idCard);
                cc.log('------------age' + age);
                if (age >= 18) {
                    player.isAdult = true;
                }
            }

        });
    },

    /**
     * 获取道具列表
     */
    sendGetToolReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.GetTool;
        req.lRoleId = player.roleid;
//        FYEngine.logObject(req,'---------------发送获取道具的消息');
        this.pushSendReq(req);
    },

    handleGetToolRsp: function (byteBuf) {
//         var rsp = LobbyProtocol.decode_getToolRsp(byteBuf);
// //        FYEngine.logObject(rsp,'--------------接受获取道具的消息');
//         FishGlobal.playerToolInfo = rsp.toolitem;
//         var scene = FYEngine.getRunningLayer(0);
//         if(scene && scene.onGameEvent){
//             scene.onGameEvent(lobbyGameEvent.GetPlayerPack,rsp);
//         }


    },

    /**
     * 道具兑换
     */
    sendToolExchangeReq: function (goodid, name, phone, youbian, addres, otherinfo) {
        if (addres == undefined) {
            addres = '';
        }
        if (youbian == undefined) {
            youbian = '';
        }
        if (phone == undefined) {
            phone = '';
        }
        if (name == undefined) {
            name = '';
        }
        if (otherinfo == undefined) {
            otherinfo = '';
        }
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.ExchangeTool;
        req.lRoleId = player.roleid;
        req.iGoodsId = goodid;
        req.szIMEI = player.imei;
        req.szMobile = phone;
        req.szPostCode = youbian;
        req.szAddress = addres;
        req.szRealName = name;
        req.szDesc = otherinfo;
//        FYEngine.logObject(req,'---------------发送道具兑换的消息');
        this.pushSendReq(req);
    },

    handleToolExchangeRsp: function (byteBuf) {
        // var rsp = LobbyProtocol.decode_ToolExchangeRsp(byteBuf);
        // FYEngine.logObject(rsp,'--------------接受道具兑换的消息');
        //
        // var scene = FYEngine.getRunningLayer(0);
        // var layer3 = scene.getChildByName(LobbySceneName.ProductInfoLayer);
        // var layer4 = scene.getChildByName(LobbySceneName.BillOrderLayer);
        // var layer5 = scene.getChildByName(LobbySceneName.RealProductLayer);
        //
        // if (layer3 && layer3.timeCount) {
        //     layer3.unschedule(layer3.timeCount);
        // }
        // if (layer4 && layer4.timeCount) {
        //     layer4.unschedule(layer4.timeCount);
        // }
        //
        // if (layer5 && layer5.timeCount) {
        //     layer5.unschedule(layer5.timeCount);
        // }
        //
        // var loading2 = scene.getChildByName('loading2');
        // if (loading2) {
        //     loading2.removeFromParent(true);
        // }
        //
        // if (rsp.iResult == 0) {
        //     if (layer4) {
        //         layer4.removeFromParent();
        //     }
        //     if(layer5){
        //         layer5.removeFromParent();
        //     }
        //     var sname =FishGlobal.getExchangeGoodsNameById(rsp.GoodsName);
        //     var mlayer = new ExchangeToolSuccessLayer(rsp.GoodsName);
        //     if (mlayer) {
        //         scene.addChild(mlayer, FishZorder.poplayer, LobbySceneName.ExchangeSucessLayer);
        //     }
        //     //this.sendUpdateWealthReq();
        //     this.sendGetToolReq();
        //     return;
        // } else if (rsp.iResult == -314) {
        //     FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeFailed314));
        //     return;
        // } else if (rsp.iResult == -311) {
        //     FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeFailed311));
        //     return;
        // } else {
        //     FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SccomMsgKey.exchangeFailed));
        // }
    },

    /**
     * 邮件列表
     */
    sendGetMail: function (mailid) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.GetMail;
        req.lRoleId = player.roleid;
        req.lMailId = mailid;
        //req.lMailId = 0;
//        FYEngine.logObject(req,'---------------发送获取邮件的消息');
        this.pushSendReq(req);
    },

    handleGetMail: function (byteBuf) {
        //  var rsp = LobbyProtocol.decode_GetMail(byteBuf);
        // FYEngine.logObject(rsp,'--------------接受获取邮件的消息');
        //  if(rsp.iResult ==0){
        //      if(rsp.iMailCount>0){
        //          for(var i =0;i<rsp.iMailCount;++i){
        //              if(FishGlobal.PlayerMail.Mailid<rsp.mailitem[i].mailid){
        //                  FishGlobal.PlayerMail.Mailid =rsp.mailitem[i].mailid;
        //              }
        //              if(FishGlobal.PlayerMail.Msg.length ==0){
        //                  FishGlobal.PlayerMail.Msg.push(rsp.mailitem[i]);
        //              }else{
        //                  var j=0;
        //                  for(;j<FishGlobal.PlayerMail.Msg.length;++j){
        //                      if(FishGlobal.PlayerMail.Msg[j].mailid<rsp.mailitem[i].mailid){
        //                          FishGlobal.PlayerMail.Msg.splice(j,0,rsp.mailitem[i]);
        //                          break;
        //                      }
        //                  }
        //                  if(j==FishGlobal.PlayerMail.Msg.length){
        //                      FishGlobal.PlayerMail.Msg.push(rsp.mailitem[i]);
        //                  }
        //              }
        //
        //          }
        //          FishGlobal.writeMailRecord();
        //      }
        //
        //      var scene = FYEngine.getRunningLayer(0);
        //      if (scene && scene.onGameEvent) {
        //          scene.onGameEvent(lobbyGameEvent.refreshMail,rsp);
        //      }
        //
        //      if(FishGlobal.checkHasUnreadMail() !=FishGlobal.unReadMail){
        //          FishGlobal.unReadMail = FishGlobal.checkHasUnreadMail();
        //          if (scene && scene.onGameEvent) {
        //              scene.onGameEvent(lobbyGameEvent.unreadMail);
        //          }
        //      }
        //
        //  }else{
        //      var scene = FYEngine.getRunningLayer(0);
        //      if (scene && scene.onGameEvent) {
        //          scene.onGameEvent(lobbyGameEvent.refreshMail,rsp);
        //      }
        //  }
    },

    /**
     * 服务器推送的邮件
     * @param byteBuf
     */

    handleServerPushMailRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_ServerPushMail(byteBuf);
//        FYEngine.logObject(rsp,'--------------服务器推送获取邮件的消息');

        if (FishGlobal.PlayerMail.Mailid < rsp.mailid) {
            FishGlobal.PlayerMail.Mailid = rsp.mailid;
            if (FishGlobal.PlayerMail.Msg.length == 0) {
                FishGlobal.PlayerMail.Msg.push(rsp);
            } else {
                var j = 0;
                for (; j < FishGlobal.PlayerMail.Msg.length; ++j) {
                    if (FishGlobal.PlayerMail.Msg[j].mailid < rsp.mailid) {
                        FishGlobal.PlayerMail.Msg.splice(j, 0, rsp);
                        break;
                    }
                }
                if (j == FishGlobal.PlayerMail.Msg.length) {
                    FishGlobal.PlayerMail.Msg.push(rsp);
                }
            }
            FishGlobal.writeMailRecord();
            FishGlobal.unReadMail = true;
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(lobbyGameEvent.serverpushmail, rsp);
            }
        }


    },

    /**
     * 更改邮件状态
     * @param mailil
     * @param itype
     * @param status
     * @param packid
     */

    sendChangeMailStatusReq: function (mailid, itype, status, packid) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.ChangeMailStatus;
        req.lRoleId = player.roleid;
        req.lMailId = mailid;
        req.iType = itype;//0
        req.iStatus = status;//1领取附件，2读邮件
        req.iPacketId = packid;
//        FYEngine.logObject(req,'---------------发送更改邮件状态的消息');
        this.pushSendReq(req);
    },


    handleChangeMailStatusRsp: function (byteBuf) {
//         var rsp = LobbyProtocol.decode_changeMailStatus(byteBuf);
// //        FYEngine.logObject(rsp,'--------------接受更改邮件状态的消息');
//         var scene = FYEngine.getRunningLayer(0);
//         if (scene && scene.onGameEvent) {
//             scene.onGameEvent(lobbyGameEvent.GetMailAcee,rsp);
//         }

    },

    /**
     * 免费场排名
     * @param iRoomId
     */
    sendFreeGameRankReq: function (iRoomId) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ListProto;
        req.subCmd = LobbyProtocol.FreeRoomRank;
        req.lRoleId = player.roleid;
        req.iRoomId = iRoomId;
        FYEngine.logObject(req, '---------------发送查询免费场排名的消息');
        this.pushSendReq(req);
    },

    handleFreeGameRankRsp: function (byteBuf) {
//         var rsp = LobbyProtocol.decode_FreeGameRankRsp(byteBuf);
// //        FYEngine.logObject(rsp,'--------------接受查询免费场排名的消息');
//         var scene = FYEngine.getRunningLayer(0);
//         if (scene && scene.onGameEvent) {
//             scene.onGameEvent(lobbyGameEvent.GetFreeRankOuter,rsp);
//         }
    },

    /**
     *查询免费场自己的排名
     */
    sendSelfRankReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ListProto;
        req.subCmd = LobbyProtocol.SelfRank;
        req.lRoleId = player.roleid;
        req.iRoomId = FishGlobal.roomId;
//        FYEngine.logObject(req,'---------------发送查询当前自己排名的消息');
        this.pushSendReq(req);
    },

    handleSelfRankRsp: function (byteBuf) {
        // var rsp = LobbyProtocol.decode_SelfRankRsp(byteBuf);
        // FYEngine.logObject(rsp,'--------------接受查询当前自己排名的消息');
        // if(rsp.iResult ==0){
        //     var scene = FYEngine.getRunningLayer(0);
        //     if (scene && scene.onGameEvent) {
        //         scene.onGameEvent(lobbyGameEvent.refreshSelfRank,rsp);
        //     }
        // }
    },


    /**
     * 查询免费场的门票
     */
    sendGetTicketReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.GetTicketQty;
        req.lRoleId = player.roleid;
//        FYEngine.logObject(req,'---------------发送查询门票的消息');
        this.pushSendReq(req);
    },

    handleGetTicketRsp: function (byteBuf) {
        // var rsp = LobbyProtocol.decode_GetTicketNumbRsp(byteBuf);
        // FYEngine.logObject(rsp,'--------------接受查询门票的消息');
        // if(rsp.iResult ==0){
        //     var player = appglobal.getPlayer();
        //     player.freeticket = rsp.iCount;
        //     var scene = FYEngine.getRunningLayer(0);
        //     if (scene && scene.onGameEvent) {
        //         //scene.onGameEvent(lobbyGameEvent.refreshWealth);
        //         this.sendUpdateWealthReq();
        //     }
        // }
    },

    /**
     * 免费场列表
     */
    sendGetFreeRoomListReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ListProto;
        req.subCmd = LobbyProtocol.FreeRoomList;
        req.lRoleId = player.roleid;
//        FYEngine.logObject(req,'---------------发送查询免费场列表的消息');
        this.pushSendReq(req);
    },

    handleGetFreeRoomListRsp: function (byteBuf) {
        // var rsp = LobbyProtocol.decode_GetFreeRoomListRsp(byteBuf);
        // FYEngine.logObject(rsp,'--------------接受查询免费场列表的消息');
        //
        //     var player = appglobal.getPlayer();
        //     //player.freeticket = rsp.iCount;
        //     var scene = FYEngine.getRunningLayer(0);
        //     if (scene && scene.onGameEvent) {
        //         scene.onGameEvent(lobbyGameEvent.GetFreeRoomList,rsp);
        //     }
    },


    getTempRewardData: function () {
        Http.getMessage(function () {
            var service = formservice("gameItemExchange");
            var time = Date.now();
            var sign = formsign("gameItemExchange", time);
            time = formTime(time);
            var type = {name: "type", value: 0};
            var mode = {name: "mode", value: 0};
            //var source = formsource(appglobal.getSource());
            var checksum = formchecksum(mode.value, sign.value, FYEngine.PrivateKey);
            //FYEngine.logObject(formUrl(appglobal.getFishApiUrl(), "fishService", service, time, mode,sign, type,checksum),"---------wangzhi:");
            return formUrl(appglobal.getFishApiUrl(), "fishService", service, time, mode, type, sign, checksum);
        }(), null, function (cfgStr) {
            FishGlobal.fishExchangeTempData = [];
            var jsonInfo = eval('(' + cfgStr + ')');
            var errcode = jsonInfo.code;
            if (errcode != 0) {
//                    cc.log('-----获取获取商品列表 失败');
                return;
            }
            FYEngine.logObject(jsonInfo.data, '------兑奖商城列表2');
            for (var i = 0; i < jsonInfo.data.length; ++i) {
                FishGlobal.fishExchangeTempData.push(jsonInfo.data[i]);
            }
        });
    },

    sendQueryDailyChargeReq: function (goodsid) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.QueryDailyCharge;
        req.lUserId = player.userid;
        req.iGoodsId = goodsid;
        this.pushSendReq(req);
        FYEngine.logObject(req, '--------------发送查询当日充值额度');
    },

    handleQueryDailyChargeRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_QueryDailyCharge(byteBuf);
        FYEngine.logObject(rsp, '--------------查询当日充值额度');
        if (rsp.iResult == 0) {
            var curentprice = FishGlobal.getMallProductPrice(rsp.iGoodsId);
            cc.log("----当前商品的价格：" + curentprice);
            if ((curentprice + rsp.iDayChargeMoney) > rsp.iDayLimitMoney) {//当前商品加上超过限额
                var scene = FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(LobbySceneName.DailyChargeOverTip);
                if (!layer) {
                    layer = new DailyChargeOverTip(rsp);
                    scene.addChild(layer, FishZorder.poplayer, LobbySceneName.DailyChargeOverTip);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            } else {
                if (appglobal._dailyChargeMoney > 0 && (curentprice + rsp.iDayChargeMoney) > appglobal._dailyChargeMoney) {
                    var irsp = {};
                    irsp.lUserId = rsp.lUserId;
                    irsp.iResult = rsp.iResult;
                    irsp.iGoodsId = rsp.iGoodsId;
                    irsp.iDayChargeMoney = rsp.iDayChargeMoney;//当天充值
                    irsp.iDayLimitMoney = appglobal._dailyChargeMoney > rsp.iDayChargeMoney ? appglobal._dailyChargeMoney : rsp.iDayChargeMoney;//当天充值限额
                    irsp.iShenfenType = 2;//身份认证类型：0未认证，1未成年，2成年
                    var scene = FYEngine.getRunningLayer(0);
                    var layer = scene.getChildByName(LobbySceneName.DailyChargeOverTip);
                    if (!layer) {
                        layer = new DailyChargeOverTip(irsp, true);
                        scene.addChild(layer, FishZorder.poplayer, LobbySceneName.DailyChargeOverTip);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                } else {
                    this.sendGetPayOrderReq(rsp.iGoodsId);
                }
            }
        } else {

            FYEngine.AddCommToast("充值失败，请联系客服QQ:3003674856");

        }

    },

    sendGetVIPconfig: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.GetVIPcfg;
        req.lUserId = player.userid;
        this.pushSendReq(req);
        FYEngine.logObject(req, '--------------发送查询vip配置的消息');
    },

    handleGetVipconfig: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GetVIPcfg(byteBuf);
        FYEngine.logObject(rsp, '--------------vip配置返回');
        if (rsp.iResult == 0) {
            FishGlobal.setVIPcfg(rsp.cfg);
            FishGlobal._canSendLevel = rsp.iCanSend;
        }
    },

    sendQueryVIPinfo: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.QueryVIPinfo;
        req.lUserId = player.userid;
        this.pushSendReq(req);
        FYEngine.logObject(req, '--------------发送查询自己vip消息');
    },

    handleQueryVIPinfo: function (byteBuf) {
        var rsp = LobbyProtocol.decode_QueryVIPinfo(byteBuf);
        FYEngine.logObject(rsp, "-------------查询自己vip消息");
        if (rsp.iResult == 0) {
            var player = appglobal.getPlayer();
            player.iVIPLevel = rsp.iVIPLevel;
            player.iSend = rsp.iSend;
            player.iMoney = rsp.iMoney;//充值
            player.iSend = rsp.iSend;//已送个数
            player.iVIPMoney = rsp.iVIPMoney;//当前VIP充值
            player.iVIPSend = rsp.iVIPSend;//当前vip送数量
            player.iVIPNextMoney = rsp.iVIPNextMoney;//下一等级VIP充值
            player.iNextSend = rsp.iNextSend;//下一等级VIP送数量

            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(lobbyGameEvent.refreshVIPinfo);
            }
        }

    },

    sendQueryCheckinCfgReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.QueryCheckinCfg;
        req.lUserId = player.userid;
        this.pushSendReq(req);
        // FYEngine.logObject(req,'--------------sendQueryCheckinCfgReq');
    },

    handleQueryCheckinCfgRsp: function (byteBuf) {
        var rsp = LobbyProtocol.decode_QueryCheckCfg(byteBuf);
        FYEngine.logObject(rsp, "-------------handleQueryCheckinCfgRsp");
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.getCheckinCfg, rsp);
        }
    },

    sendGetCheckinStatus: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.GetCheckinStatu;
        req.lUserId = player.userid;
        this.pushSendReq(req);
        // FYEngine.logObject(req,'--------------sendGetCheckinStatus');
    },

    handleGetCheckinStatus: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GetCheckStatus(byteBuf);
        FYEngine.logObject(rsp, "-------------handleGetCheckinStatus");
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.getCheckinStatus, rsp);
        }
    },

    sendGetCheckinResult: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.ModuleInfoProto;
        req.subCmd = LobbyProtocol.CheckIn;
        req.lUserId = player.userid;
        this.pushSendReq(req);
        // FYEngine.logObject(req,'--------------sendGetCheckinResult');
    },

    handleGetCheckinResult: function (byteBuf) {
        var rsp = LobbyProtocol.decode_GetCheckResult(byteBuf);
        FYEngine.logObject(rsp, "-------------handleGetCheckinResult");
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.getCheckinResult, rsp);
        }
    },

    sendFUBEN2_COIN_GET: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.FUBEN2_COIN_GET;
        req.lUserId = player.userid;
        cc.log("sendFUBEN2_COIN_GET");
        this.pushSendReq(req);
    },

    handleFUBEN2_COIN_GET: function (byteBuf) {
        var rsp = LobbyProtocol.decode_FUBEN2_COIN_GET(byteBuf);
        FYEngine.logObject(rsp, "-------------handleFUBEN2_COIN_GET");
        if (rsp.iResult == 0) {
            var player = appglobal.getPlayer();
            player.fishcoin = rsp.lYubi;
            player.fishbox = rsp.lBox;
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(lobbyGameEvent.refreshWealth, rsp);
            }
        }
    },

    sendFUBEN2_SYLZ_CFG: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.FUBEN2_SYLZ_CFG;
        req.lUserId = player.userid;
        this.pushSendReq(req);
    },

    handleFUBEN2_SYLZ_CFG: function (byteBuf) {
        var rsp = LobbyProtocol.decode_FUBEN2_SYLZ_CFG(byteBuf);
        FYEngine.logObject(rsp, "-------------handleFUBEN2_SYLZ_CFG");
        if (rsp.iResult == 0) {
            GAME_NEW_INT_DATA.ARROW_SPEED_RATE = rsp.iSpeed < 5 ? 15 : rsp.iSpeed;
            for (var i = 0; i < 3; ++i) {
                GAME_NEW_INT_DATA.ATTACK_PRICE[i] = rsp.bombCfg[i].iRate;
                GAME_NEW_INT_DATA.TOTAL_ATTACK_TIMES[i] = rsp.bombCfg[i].iFreeTimes;
                GAME_NEW_INT_DATA.TOTAL_EX_ATTACK_TIME[i] = rsp.bombCfg[i].iLimitBuyTimes;
                GAME_NEW_INT_DATA.EX_ATTACK_NEED_SCORE[i] = rsp.bombCfg[i].iScorePerBom;
            }
            GAME_NEW_INT_DATA._SYLZ_CFG_OK = true;
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(GAME_NEW_EVENT.UPDATE_SYLZ_CFG, rsp);
            }
        }

    },

    sendFUBEN2_JZSJ_CFG: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.FUBEN2_JZSJ_CFG;
        req.lUserId = player.userid;
        this.pushSendReq(req);
    },

    handleFUBEN2_JZSJ_CFG: function (byteBuf) {
        var rsp = LobbyProtocol.decode_FUBEN2_JZSJ_CFG(byteBuf);
        FYEngine.logObject(rsp, "-------------handleFUBEN2_JZSJ_CFG");
        if (rsp.iResult == 0) {
            for (var i = 0; i < 3; ++i) {
                GAME_NEW_INT_DATA.GAME2_CANNON_RATE[i] = rsp.roomCfg[i].iRate;
                GAME_NEW_INT_DATA.GAME2_TOTAL_ENTER_TIMES[i] = rsp.roomCfg[i].iMaxTimes;
                GAME_NEW_INT_DATA.GAME2_TOTAL_PLAY_TIME[i] = rsp.roomCfg[i].iGameTime;
                GAME_NEW_INT_DATA.GAME2_NEED_INT[i] = rsp.roomCfg[i].iScore;
                GAME_NEW_INT_DATA.GAME2_FISH_YELLOW_RATE[i] = rsp.roomCfg[i].iGoldFishRatio;
                GAME_NEW_INT_DATA.GAME2_ENTER_NEED_MONEY[i] = rsp.roomCfg[i].iLimitGold;
            }
            GAME_NEW_INT_DATA._JZSJ_CFG_OK = true;
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(GAME_NEW_EVENT.UPDATE_JZSJ_CFG, rsp);
            }
        }
    },

    sendFUBEN2_OPENBOX_CFG: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.FUBEN2_OPENBOX_CFG;
        req.lUserId = player.userid;
        this.pushSendReq(req);
    },

    handleFUBEN2_OPENBOX_CFG: function (byteBuf) {
        var rsp = LobbyProtocol.decode_FUBEN2_OPENBOX_CFG(byteBuf);
        FYEngine.logObject(rsp, "-------------handleFUBEN2_OPENBOX_CFG");
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.FUBEN2_OPENBOX_CFG, rsp);
        }
    },

    sendFUBEN2_BUY_BOX_CFG: function (iType, iValue) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.FUBEN2_BUY_BOX_CFG;
        req.lUserId = player.userid;
        req.iType = iType;
        req.iValue = iValue;
        // FYEngine.logObject(req, "-------------sendFUBEN2_BUY_BOX_CFG");
        this.pushSendReq(req);
    },

    handleFUBEN2_BUY_BOX_CFG: function (byteBuf) {
        var rsp = LobbyProtocol.decode_FUBEN2_BUY_BOX(byteBuf);
        FYEngine.logObject(rsp, "-------------handleFUBEN2_BUY_BOX_CFG");
        var scene = FYEngine.getRunningLayer(0);
        if (rsp.iResult == 0) {
            var player = appglobal.getPlayer();
            player.gold += rsp.lAddGold;
            player.fishcoin = rsp.lAllYubi;
            player.fishbox += rsp.lAddBox;
        }
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.refreshWealth);
            scene.onGameEvent(GAME_NEW_EVENT.FUBEN2_BUY_BOX_CFG, rsp);
        }
    },

    sendFUBEN2_OPEN_BOX: function (iType, iBoxCount) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = LobbyProtocol.GameInfoProto;
        req.subCmd = LobbyProtocol.FUBEN2_OPENBOX;
        req.lUserId = player.userid;
        req.iType = iType;
        req.iBoxCount = iBoxCount;
        // FYEngine.logObject(req, "-------------sendFUBEN2_OPEN_BOX");
        this.pushSendReq(req);
    },

    handleFUBEN2_OPENBOX: function (byteBuf) {
        var rsp = LobbyProtocol.decode_FUBEN2_OPEN_BOX(byteBuf);
        FYEngine.logObject(rsp, "-------------handleFUBEN2_OPENBOX");
        var scene = FYEngine.getRunningLayer(0);
        if (rsp.iResult == 0) {
            var player = appglobal.getPlayer();
            player.coupon = rsp.lAllCoupon;
            player.gold = rsp.lAllGold;
            player.score = rsp.lAllScore;
            player.crystal = rsp.lAllMedal;//todo
            player.fishbox = rsp.lAllBox;
        }
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.refreshWealth);
            scene.onGameEvent(GAME_NEW_EVENT.FUBEN2_OPEN_BOX, rsp);
        }
    },
});
