/**
 * Created by daichunfeng on 2017/1/9.
 */

var FourthLayer = cc.Layer.extend({
    _count: 0,
    ctor: function () {
        this._super();
        this._count = 0;
        this.setName(AppSceneName.Fourth);
        this.initUI();
        FishGlobal.stoptip = 0;
        FishGlobal.showturn = 0;
        if (appglobal._switch13 == 1) {
            if (!FishGlobal.is3rdLogin && !appglobal.isWechatLogin) {
                this.isNewPlayer();
            }
        }

    },

    initUI: function () {
        var size = cc.winSize;

        var bg = new cc.Sprite(HallRes.Png.BG);
        if (bg) {
            bg.setPosition(cc.p(size.width / 2, size.height / 2));
            this.addChild(bg, 0, "bg");
        }

        var tittle = new cc.Sprite("res/ChannelRes/comtitle.png");
        tittle.setAnchorPoint(cc.p(0.5, 0.5));
        tittle.setPosition(cc.p(573, 486));
        this.addChild(tittle, 0, 0);

        var progressbg = new cc.Sprite('#processbg.png');
        if (progressbg) {
            this.addChild(progressbg);
            progressbg.setPosition(cc.p(size.width / 2, 170));
        }

        var progress = new cc.ProgressTimer(new cc.Sprite('#process.png'));
        if (progress) {
            progress.setAnchorPoint(cc.p(0, 0));
            progress.setPosition(cc.p(1, -1));
            progress.setType(cc.ProgressTimer.TYPE_BAR);
            progress.setPercentage(0);
            progress.setBarChangeRate(cc.p(1, 0));
            progress.setMidpoint(cc.p(0, 0));
            progressbg.addChild(progress, 1, 'progress');
            this._progress = progress;
        }


        var labelPercent = FYEngine.createAlts("res/num_asserts.png", 10, '0', '0');
        if (labelPercent) {
            labelPercent.setPosition(cc.p(size.width / 2, 170));
            labelPercent.setAnchorPoint(cc.p(0.5, 0.5));
            labelPercent.setString("0");
            this.addChild(labelPercent, 1, 'percent');
            this._labelpercent = labelPercent;

            var sp = new cc.Sprite('#num_precent.png');
            if (sp) {
                sp.setAnchorPoint(cc.p(0.5, 0.5));
                sp.setPosition(cc.p(labelPercent.getContentSize().width + 8, labelPercent.getContentSize().height / 2));
                labelPercent.addChild(sp, 0, 'sp');
                this._sp = sp;
            }
        }

        var mLabel = new ccui.Text('正在加载资源，请稍候...', '微软雅黑', 30);
        if (mLabel) {
            mLabel.setColor(cc.color(255, 249, 20));
            mLabel.enableOutline(cc.color(86, 0, 1, 255), 3);
            mLabel.setPosition(cc.p(size.width / 2, 100));
            this.addChild(mLabel);
            this._mlabel = mLabel;
        }
        this.addVerAndSource();
        this.connectToLobby();
        this.addAgeTip();

        this.addBFlogo();
        this.getDailyChargeConf();
    },

    getDailyChargeConf: function () {
        var self = this;
        Http.getMessage(self.getQueryChargeUrl(), null, function (cfgStr) {
            var jsonInfo = eval('(' + cfgStr + ')');
            appglobal.setPlayerWinLoseControl(jsonInfo);
        });
    },

    getQueryChargeUrl: function () {
        var service = formservice("ipInfo");
        var userid = {name: "uid", value: appglobal.getPlayer().userid};
        var psource = formsource(appglobal.getSource());
        var time = Date.now();
        var sign = formsign("ipInfo", time);
        time = formTime(time);
        var checksum = formchecksum(userid.value, psource.value, sign.value, FYEngine.PrivateKey);
        return formUrl(appglobal.getFishApiUrl(), "fishService", service, time, userid, psource, sign, checksum);
    },

    addBFlogo: function () {
        var bf_logo = new cc.Sprite("res/languageString/bf_logo.png");
        if (bf_logo) {
            this.addChild(bf_logo, 100, "bf_logo");
            bf_logo.setAnchorPoint(cc.p(1, 1));
            bf_logo.setPosition(cc.p(1100, 610));
        }
    },

    addAgeTip: function () {
        var agetip = new ccui.Text('适合18岁以上使用', '微软雅黑', 20);
        if (agetip) {
            agetip.setAnchorPoint(cc.p(0, 0.5));
            agetip.setPosition(cc.p(30, 580));
            agetip.enableOutline(cc.color("0663b5"), 2);
            this.addChild(agetip, 1, "agetip");
        }
    },


    changePercent: function (percent) {
        this._progress.setPercentage(percent);
        this._labelpercent.setString('' + percent);
        this._sp.setPositionX(this._labelpercent.getContentSize().width + 8);
    },

    changeLabel: function (content) {
        this._mlabel.setString(content + '');
    },

    connectToLobby: function () {
        //cc.log("connectToLobby"+appglobal._lobbyAccess);
        if (appglobal.isYXDMode()) {
            appglobal.yxdTransformLobby();
        }
        FishGlobal.linkLobbyAcess = false;
        FishGlobal.addIosRes = false;
        this._layercount = 0;
        this.schedule(function (dt) {
            if (this._layercount >= 46) {
                this.unscheduleAllCallbacks();
                var coreserviceproxy = CoreServiceProxy.getInstance();
                //cc.log('--------测试:'+appglobal._lobbyAccess);
                appglobal._lobbyAccess && coreserviceproxy.linkLobbyClient(appglobal._lobbyAccess);
                coreserviceproxy.addLobbyHandler(new Lobbyhandler());
                this.schedule(this.checkLinkLobbyAcess);
            }
            this._layercount++;
            this.changePercent(this._layercount);
        });
    },

    checkLinkLobbyAcess: function (dt) {
        this._count += dt;
        //cc.log('------------检验进入大厅的时间:'+this._count);
        if (FishGlobal.linkLobbyAcess == true) {
            this.unschedule(this.checkLinkLobbyAcess);
        }
        if (this._count > 10) {
            var coreserviceproxy = CoreServiceProxy.getInstance();
            coreserviceproxy.unlinkLobbyClient();
            var layer = this.getChildByName(FishSceneName.UnConnectDialog);
            if (!layer) {
                layer = new unConnectLayer(0);
                if (layer) {
                    layer.refreshUI(3);
                    this.addChild(layer, FishZorder.poplayer + 1, FishSceneName.UnConnectDialog);
                }
            }
            this.unschedule(this.checkLinkLobbyAcess);
        }
    },

    addVerAndSource: function () {
        var underbg = new ccui.ImageView("hall99.png", ccui.Widget.PLIST_TEXTURE);
        if (underbg) {
            this.addChild(underbg);
            underbg.setScale9Enabled(true);
            underbg.setContentSize(cc.size(1136, 66));
            underbg.setAnchorPoint(cc.p(0.5, 0));
            underbg.setPosition(cc.p(this.width / 2, 0));

            let cerinfo = "苏公网安备 32059002001824号   苏网文[2016]4133-096号   软著登记号：2016SR264803\n文网游备字[2016]M-CSG 7343号   批准文号：新广出审[2016]4740号   出版物号：ISBN978-7-7979-3179-3\n著作权人：苏州工业园区丰游网络科技有限公司   出版单位：上海科学技术文献出版社有限公司";
            if (appglobal.isLiaoCert()) {
                cerinfo = "沪网文[2016]3411-251号   软著登记号：2017SR466410   文网游备字[2016]M-CSG 2166号   批准文号：新广出审[2017]8568号\n" +
                    "出版物号：ISBN978-7-498-01547-1   著作权人：上海力傲网络科技有限公司    出版单位：杭州紫府网络科技有限公司";
            }
            if(this.needHideCert()){
                cerinfo ="";
            }
            var mLabel2 = new ccui.Text(cerinfo, '微软雅黑', 18);
            if (mLabel2) {
                mLabel2.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
                mLabel2.setColor(cc.color("#12f8f5"));
                mLabel2.setAnchorPoint(cc.p(0.5, 0.5));
                mLabel2.enableOutline(cc.color("#012b4e"), 2);
                mLabel2.setPosition(cc.p(underbg.width / 2, underbg.height / 2));
                underbg.addChild(mLabel2);
            }
        }

        var version = appglobal._appCfg.verString;
        var source = appglobal._appCfg.source;

        var mLabel3 = new ccui.Text("" + version + "（" + source + "）", '微软雅黑', 22);
        if (mLabel3) {
            mLabel3.setAnchorPoint(cc.p(1, 0.5));
            //mLabel3.enableOutline(cc.color(255,0,0),1);
            mLabel3.setPosition(cc.p(this.width - 10, 20));
            this.addChild(mLabel3);
        }
    },

    needHideCert : function(){
        if(appglobal.getSource() == 397){
            return true;
        }
        return false;
    },

    isNewPlayer: function () {
        var newPlayerRecord = cc.sys.localStorage.getItem(appglobal.getPlayer().userid + 'isnewplayer');
        var date = new Date();
        cc.log('-----年:' + date.getFullYear() + '--月:' + date.getMonth() + '---日:' + date.getHours());
        if (newPlayerRecord) {
            FishGlobal.isNewPlayerRecord = eval('(' + newPlayerRecord + ')');
            if (FishGlobal.isNewPlayerRecord.countday >= 3) {
                cc.log('-----1');
                FishGlobal.isNewPlayer = false;
                return;
            }
            if (FishGlobal.isNewPlayerRecord.counttime.year == date.getFullYear() && FishGlobal.isNewPlayerRecord.counttime.month == date.getMonth() && FishGlobal.isNewPlayerRecord.counttime.day == date.getUTCDate()) {
                cc.log('-----2');
                FishGlobal.isNewPlayer = true;
            } else {
                cc.log('-----4');
                FishGlobal.isNewPlayer = true;
                FishGlobal.isNewPlayerRecord.countday += 1;
                FishGlobal.isNewPlayerRecord.counttime = {
                    year: date.getFullYear(),
                    month: date.getMonth(),
                    day: date.getUTCDate(),
                };
                cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'isnewplayer', JSON.stringify(FishGlobal.isNewPlayerRecord));
            }

        } else {
            cc.log('-----3');
            FishGlobal.isNewPlayer = true;
            FishGlobal.isNewPlayerRecord =
                {
                    countday: 1,
                    counttime: {
                        year: date.getFullYear(),
                        month: date.getMonth(),
                        day: date.getUTCDate(),
                    }
                };
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'isnewplayer', JSON.stringify(FishGlobal.isNewPlayerRecord));
        }
    },

});

FourthLayer.createScene = function () {
    var layer = new FourthLayer();
    var scene = new cc.Scene();
    scene.addChild(layer, 0, 0);
    scene.setName(AppSceneName.Fourth);
    return scene;
};
