/**
 * Created by mintao on 16/5/26.
 */

var eLoginType = {
    LOGINTYPE_REGISTER  : 1,
    LOGINTYPE_QUICKLOG  : 2,
    LOGINTYPE_USERLOG   : 3,
    LOGINTYPE_USERLOGOUT : 4,
};

/***
 * sdk错误码
 * @type {{}}
 */
var SDKErrCode = {
    Account_Used    : 100,      //账号已使用
    AccPass_Err     : 116,      //账号或密码错误

};

var SdkHandler = cc.Class.extend({
    ctor: function (){

    },

    handleSdkResult : function(action,code) {
        action = parseInt(action);
        code = parseInt(code);
        cc.log('-----handleSdkResult: action='+action + ' code='+code);
        appglobal.isLoginOut = false;
        switch(action){
            case 0: // SDK初始化成功
                break;

            case 1: // 登录注册
            {
                if( code == 0 ){
                    var userInfo = app.coreservice.getUserInfo();
//                    cc.log("-----userInfo account:%s, userId:%d, token:%s", userInfo.account, userInfo.userId, userInfo.token);

                    var player = AppGlobal.getInstance().getPlayer();
                    player.userid = userInfo.userId;
                    player.token = userInfo.token;
                    player.setNickName(userInfo.nickname);
                    player.setAccountName(userInfo.account);

                    // 建立大厅连接
                    //var coreserviceProxy = CoreServiceProxy.getInstance();
                    //var clientLobby = coreserviceProxy.getClientLobby();
                    //var lobbyAccess = appglobal.appCfg.lobbyAccess;
                    //clientLobby.setAccessInfo(lobbyAccess.Ip, lobbyAccess.Port);
                    //clientLobby.start();

                    //// goto lobby scene
                    appglobal.loginCompleteFlag=1;
                    var layer = FYEngine.getRunningScene();
                    if(layer.getName()=="loginScene"){
                        layer.loginSDKCompeleted();
                    }
                    //layer.runAction(new cc.Sequence(new cc.DelayTime(1), new cc.CallFunc(function(){
                    //    // 建立社交连接
                    //    var clientSocial = coreserviceProxy.getClientSocial();
                    //    var socialAccess = appglobal.appCfg.snsAccess;
                    //    clientSocial.setAccessInfo(socialAccess.Ip, socialAccess.Port);
                    //    clientSocial.start();
                    //})));
                }
                else{
                    appglobal.loginCompleteFlag=0;
                    var loginScene = FYEngine.getRunningScene();
                    if(loginScene){
                    if(loginScene.getName()=="loginScene"){
                        loginScene.removeLoading();
                    }
                    loginScene.loginSDKErr(code);
                }
                }
            }break;

            case 2:{    //绑定帐号
                var scene = cc.director.getRunningScene();
                if( code == 0 ){
                    // 关闭对话框
                    var dialog = scene.getChildByName("accountBingLayer");
                    if(dialog)
                        dialog.removeFromParent();

                    // 更新用户信息
                    var userInfo = CoreServiceProxy.getInstance().getUserInfo();
                    var player = appglobal.getPlayer();
                    player.updateUserInfo(userInfo);

                    // 刷新设置界面
                    var dialog2 = scene.getChildByName("settingLayer");
                    if (dialog2)
                        dialog2.initUI();
                }
            }break;

            case 3 :  // 密码修改
            {
                var scene = cc.director.getRunningScene();
                if( code == 0 ) {
                    // 关闭对话框
                    var dialog = scene.getChildByName("changePassLayer");
                    if(dialog != null)
                        dialog.removeFromParent();
                }
            }break;

            case 4: // 账号退出
            {
                if( code == 0 ) {
                    // 断开大厅和社交连接
                    // var coreserviceProxy = CoreServiceProxy.getInstance();
                    // var clientLobby = coreserviceProxy.getClientLobby();
                    // if (clientLobby){
                    //     clientLobby.stop();
                    // }
                    //
                    // var clientSocial = coreserviceProxy.getClientSocial();
                    // if (clientSocial){
                    //     clientSocial.stop();
                    // }

                    appglobal.isLoginOut = true;
                    cc.director.runScene(new InitScene());
                }
            }break;

            case 5 : // 充值调用返回
                break;
            default:
                break;
        }

        ///
        this.sdkErrCodeToast(action, code);
    },

    /****
     * 错误码提示
     * @param action
     * @param code
     */
    sdkErrCodeToast : function(action, code){
//        cc.log('--------action is %d, code is %d', action, code);
        switch (code){
        case 0:
        {
            switch (action){
                case 2:
                    FYEngine.AddCommToast('帐号绑定成功');
                    break;
                case 3:
                    FYEngine.AddCommToast('修改密码成功');
                    break;
                case 4:
                    FYEngine.AddCommToast('帐号注销成功');
                    break;
                case 5:
                    // FYEngine.AddCommToast('用户充值成功');
                    break;
                default:
                    break;
            }
        }
            break;
        case 100:
            FYEngine.AddCommToast('帐号绑定失败，该账号已被其他玩家绑定');
            break;
        case 110:
            FYEngine.AddCommToast('帐号注销失败');
            break;
        case 111:
            FYEngine.AddCommToast('账号被封');
            break;
        case 112:
            FYEngine.AddCommToast('您输入的帐号或密码有误');
            break;
        case 113:
        case 114:
            FYEngine.AddCommToast('登录失败');
            break;
        case 116:
            FYEngine.AddCommToast('您输入的帐号或密码有误');
            break;
        case 117:
            FYEngine.AddCommToast('设备被封');
            break;
        }
    },
});



