/**
 * Created by PhoneU on 2018/3/29.
 */

var FishCopyRes = {
    bigpng: "res/updatepackmail/fishCopy.png",
    bigplist: "res/updatepackmail/fishCopy.plist",
};

var FishCopyBtn = {
    back: "backtolobby",
    room: ["firstlevel", "secondlevel", "lastlevel"],
    mall: "copymall",
    help: "copylobbyhelp",
};

var FishCopyEvent = {
    refreshWealth: 401,
    getGameTime: 402,
    reloginfail: 403,
};

var FishCopyLobbyLayer = {
    hechenglayer: 'hechenglayer',
    HechengConfirmLayer: "HechengConfirmLayer",
    HechengSucessLayer: "HechengSucessLayer",
    CopySelectSoldLayer: "CopySelectSoldLayer",
    CopySoldInfoLayer: "CopySoldInfoLayer",
    CopyConfirmEnter: "CopyConfirmEnter",
    ScoreNotEnoughLayer: "ScoreNotEnoughLayer",
    CopyTimeOutLayer: "CopyTimeOutLayer",
    CopyGameGuideLayer: "CopyGameGuideLayer",
    ExitCopy: "ExitCopy",
    GoldNotEnough: "GoldNotEnough",
    CopyResultLayer: "CopyResultLayer",
};

var FishCopyLobby = cc.Layer.extend({
    _handler: null,
    _bgImage: null,
    ctor: function () {
        this._super();
        this.setName("fishcopylobby");
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        //this.addResource();
    },

    onEnter: function () {
        this._super();
        //this.addResource();
        this.initData();
        this.initUI();
        this.initPhoneBtnCallBack();
        this.createBroadCast();
        this.loadMusic();
        this.sendMsg();

        this.checkOverLose();

        if (appglobal._switch21 == 0) {
            var player = appglobal.getPlayer();
            if (player.realIDnumber == "" || !player.isAdult) {
                this.schedule(this.writeLawRecord, 60);
            }
        }
        if (FishGlobal.isLobbyRecord == true) {
            this.createLoading();
            this.scheduleOnce(this.joinTableCheck, 15);
            if (this._handler && this._handler._canSendNormalMsg) {
                this._handler.sendGetSceneTimeReq();
            }
        }

        this.checkCopyResultLayer();
    },

    checkCopyResultLayer: function () {
        if (FishGlobal.CopyNumber) {
            var layer = this.getChildByName(FishCopyLobbyLayer.CopyResultLayer);
            if (!layer) {
                layer = new CopyResultLayer(FishGlobal.CopyNumber);
                this.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.CopyResultLayer);
                FishGlobal.CopyNumber = null;
            }
        }
    },


    onExit: function () {
        this._super();
        cc.log("alert:不能释放资源");
        // cc.director.getTextureCache().removeTextureForKey(FishCopyRes.bigpng);
        // cc.spriteFrameCache.removeSpriteFramesFromFile(FishCopyRes.bigplist);
    },

    addResource: function () {
        cc.director.getTextureCache().addImage(FishCopyRes.bigpng);
        cc.spriteFrameCache.addSpriteFramesWithFile(FishCopyRes.bigplist);
    },

    initData: function () {
        FishGlobal.bInFishScene = false;
    },

    sendMsg: function () {
        if (this._handler && this._handler._canSendNormalMsg) {
            this._handler.sendCopyGetWealthReq();
        } else {
            this.onGameEvent(FishGameEventID.unConnect, 1);
        }
    },

    createBroadCast: function () {
        var size = FYEngine.winSize;
        var _broadSp = new LobbyBroadCast('fishbroadbg2.png', cc.size(825, 37), null,
            cc.size(790, 39), cc.p(1.5, 0), 3, ccui.Widget.PLIST_TEXTURE, false);
        _broadSp.setVisible(false);
        _broadSp.setPosition(cc.p(size.width / 2, 522));
        this.addChild(_broadSp, 2, "broad");
        // this.addLobbyWarnBroad();
    },

    addLobbyWarnBroad: function () {
        var tempbr = {};
        tempbr.lUserId = 1000000;
        tempbr.iArea = 100;
        tempbr.iShowType = 100;
        tempbr.iLevel = 1;
        tempbr.iGameId = 1;
        tempbr.iMsgLen = 255;
        tempbr.szMsg = "[phoneu]倡导绿色游戏，享受健康生活，游戏内禁止一切违法行为[/phoneu]";
        CoreServiceProxy.getInstance().getLobbyHandler()._lobbyData.putLobbyBroad(tempbr);
    },

    initPhoneBtnCallBack: function () {
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
        FYEngine.AddCustomLister(this, 'game_on_show', this.gameOnShowEvent);
        FYEngine.AddCustomLister(this, 'game_on_hide', this.testGameOnHide);

    },

    phoneKeyCallBack: function (keycode, target) {
        var scene = FYEngine.getRunningLayer(0);
        switch (keycode) {
            case cc.KEY.back : {
                if (scene.getChildByName(LobbySceneName.KickedByServer) || scene.getChildByName("loading2")
                    || scene.getChildByName("loadinglayer") || scene.getChildByName(FishSceneName.UnConnectDialog)
                    || scene.getChildByName(LobbySceneName.OverLoseLayer)) {
                    return;
                }
                var otherlayer = scene.getChildByName(FishCopyLobbyLayer.ScoreNotEnoughLayer)
                    || scene.getChildByName(FishCopyLobbyLayer.CopyResultLayer)
                    || scene.getChildByName(FishCopyLobbyLayer.GoldNotEnough)
                    || scene.getChildByName(FishCopyLobbyLayer.CopyConfirmEnter)
                    || scene.getChildByName(FishCopyLobbyLayer.HechengSucessLayer)
                    || scene.getChildByName(FishCopyLobbyLayer.HechengConfirmLayer)
                    || scene.getChildByName(FishCopyLobbyLayer.CopySoldInfoLayer)
                    || scene.getChildByName(FishCopyLobbyLayer.CopySelectSoldLayer)
                    || scene.getChildByName(FishCopyLobbyLayer.HechengConfirmLayer)
                    || scene.getChildByName(FishCopyLobbyLayer.hechenglayer)
                    || scene.getChildByName(FishCopyLobbyLayer.CopyGameGuideLayer)
                    || scene.getChildByName(FishCopyLobbyLayer.ExitCopy);
                if (otherlayer) {
                    if (otherlayer.layerbg) {
                        FYEngine.popoutLayerAnimate(otherlayer.layerbg);
                    } else {
                        otherlayer.removeFromParent(true);
                    }
                } else {
                    var layer = new ExitCopy();
                    if (layer) {
                        scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.ExitCopy);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                }
            }
        }

    },

    gameOnShowEvent: function () {
        var self = this;
        cc.log("大厅show");
        if (cc.sys.os != 'iOS') {
            if (this._handler) {
                this._handler.setCanSendHeart(false);
                this._handler._needReConnect = false;
                this._handler._reconnetTime = 0;
                this.runAction(new cc.Sequence(new cc.DelayTime(1), new cc.CallFunc(function () {
                    self._handler.reconnClient();
                    cc.log('-----后台直接重连2');
                })));

                this._handler.onConnectEvent && this._handler.onConnectEvent(eClientEvent.EVENT_CONNECT_RECONN);
                this._handler._needReConnect = false;
                cc.log('-----后台直接重连1');
            }

        } else {
            this.loadMusic();
        }

    },

    loadMusic: function () {
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        for (var i = 0; i < arr.length; i++) {
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (!temp) {
                cc.sys.localStorage.setItem(arr[i], i == 2 ? 0 : 1);
            }
        }

        FYEngine.Audio.stopAll();
        if (cc.sys.localStorage.getItem("bgVolum") == 1) {
            FYEngine.Audio.setOpenMusic(true);
            FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
        }
    },


    testGameOnHide: function () {
        cc.log("大厅hide");
    },

    initUI: function () {
        var self = this;

        var layerbg = new cc.Sprite(HallRes.Png.BG);
        if (layerbg) {
            this._bgImage = layerbg;
            this.addChild(layerbg, 0, "layerbg");
            layerbg.setAnchorPoint(cc.p(0, 0));
            layerbg.setPosition(cc.p(0, 0));
        }

        var upbg = new ccui.ImageView("fish_copy_13.png", ccui.Widget.PLIST_TEXTURE);
        if (upbg) {
            this.addChild(upbg, 0, "upbg");
            upbg.setAnchorPoint(cc.p(0, 1));
            upbg.setScale9Enabled(true);
            upbg.setPosition(cc.p(0, 645));
            upbg.setCapInsets(cc.rect(323, 0, 10, 0));
            upbg.setContentSize(cc.size(1150, 100));
        }

        var scenetitle = new ccui.ImageView("fish_copy_9.png", ccui.Widget.PLIST_TEXTURE);
        if (scenetitle) {
            this.addChild(scenetitle, 0, "scenetitle");
            scenetitle.setPosition(cc.p(195, 600));
        }

        var wealthbg = new ccui.ImageView("hall35.png", ccui.Widget.PLIST_TEXTURE);
        if (wealthbg) {
            this.addChild(wealthbg, 0, "wealthbg");
            wealthbg.setAnchorPoint(cc.p(0, 0.5));
            wealthbg.setScale9Enabled(true);
            wealthbg.setPosition(cc.p(592, 597));
            wealthbg.setCapInsets(cc.rect(30, 0, 10, 0));
            wealthbg.setContentSize(cc.size(240, 41));

            var tip = new ccui.ImageView("fish_copy_14.png", ccui.Widget.PLIST_TEXTURE);
            if (tip) {
                wealthbg.addChild(tip, 0, "wealthtip");
                tip.setPosition(cc.p(10, wealthbg.height / 2));
            }
        }

        var goldbg = new ccui.ImageView("hall35.png", ccui.Widget.PLIST_TEXTURE);
        if (goldbg) {
            this.addChild(goldbg, 0, "goldbg");
            goldbg.setAnchorPoint(cc.p(0, 0.5));
            goldbg.setScale9Enabled(true);
            goldbg.setPosition(cc.p(332, 597));
            goldbg.setCapInsets(cc.rect(30, 0, 10, 0));
            goldbg.setContentSize(cc.size(240, 41));

            var tip1 = new ccui.ImageView("hall82.png", ccui.Widget.PLIST_TEXTURE);
            if (tip1) {
                goldbg.addChild(tip1, 0, "goldtip");
                tip1.setPosition(cc.p(10, goldbg.height / 2));
            }
        }

        var btncall = function (sender) {
            self.btnCallBack(sender);
        };
        var backToLobbyBtn = new ccui.ImageView("fish_copy_6.png", ccui.Widget.PLIST_TEXTURE);
        if (backToLobbyBtn) {
            this.addChild(backToLobbyBtn, 1, FishCopyBtn.back);
            backToLobbyBtn.setTouchEnabled(true);
            backToLobbyBtn.setPosition(cc.p(55, 600));
            backToLobbyBtn.addTouchEventListener(this.btnTouchEft, this);
            backToLobbyBtn.addClickEventListener(btncall);
        }

        var btnmall = new ccui.ImageView("fish_copy_4.png", ccui.Widget.PLIST_TEXTURE);
        if (btnmall) {
            this.addChild(btnmall, 1, FishCopyBtn.mall);
            btnmall.setTouchEnabled(true);
            btnmall.setPosition(cc.p(940, 580));
            btnmall.addTouchEventListener(this.btnTouchEft, this);
            btnmall.addClickEventListener(btncall);
        }

        var btnhelp = new ccui.ImageView("fish_copy_5.png", ccui.Widget.PLIST_TEXTURE);
        if (btnhelp) {
            this.addChild(btnhelp, 1, FishCopyBtn.help);
            btnhelp.setTouchEnabled(true);
            btnhelp.setPosition(cc.p(1040, 580));
            btnhelp.addTouchEventListener(this.btnTouchEft, this);
            btnhelp.addClickEventListener(btncall);
        }

        var roombtnname = ["fish_copy_10.png", "fish_copy_11.png", "fish_copy_12.png"];
        for (var i = 0; i < 3; ++i) {
            var room = new ccui.ImageView(roombtnname[i], ccui.Widget.PLIST_TEXTURE);
            if (room) {
                this.addChild(room, 1, FishCopyBtn.room[i]);
                room.setTouchEnabled(true);
                room.setPosition(cc.p(220 + i * 340, 275));
                room.addTouchEventListener(this.btnTouchEft, this);
                room.addClickEventListener(btncall);

                var info = FishGlobal.getCopyRoomConfById(i);
                var labgold = FYEngine.createAlts('res/num/fish_number.png', 12, info.iExpendScore, '.');
                labgold.setPosition(cc.p(175, 45));
                labgold.setAnchorPoint(cc.p(0, 0.5));
                room.addChild(labgold, 1, 'labgold');

                var bText1 = new ccui.Text("限用", "微软雅黑", 26);
                if (bText1) {
                    room.addChild(bText1, 1, "bText1");
                    bText1.setAnchorPoint(cc.p(0, 0.5));
                    bText1.setTextColor(cc.color("194fb1"));

                    var bText2 = new ccui.Text(info.iRate + "倍", "微软雅黑", 26);
                    if (bText2) {
                        bText1.addChild(bText2);
                        bText2.setAnchorPoint(cc.p(0, 0.5));
                        bText2.setPosition(cc.p(bText1.width, bText1.height / 2));
                        bText2.setColor(cc.color("d95020"));
                    }

                    var bText3 = new ccui.Text("炮", "微软雅黑", 26);
                    if (bText3) {
                        bText1.addChild(bText3);
                        bText3.setAnchorPoint(cc.p(0, 0.5));
                        bText3.setPosition(cc.p(bText1.width + bText2.width, bText1.height / 2));
                        bText3.setTextColor(cc.color("194fb1"));
                    }
                    bText1.setPosition(cc.p(room.width / 2 - (bText1.width + bText2.width + bText3.width) / 2, 100));
                }
            }
        }
        this.updateWealth();
    },

    updateWealth: function () {
        var player = appglobal.getPlayer();
        var scorelabel = this.getChildByName("playerscore");
        if (!scorelabel) {
            cc.log("createlabel");
            scorelabel = FYEngine.createAlts(CommResource.selfNum_png, 12, player.score, '.');
            this.addChild(scorelabel, 2, "playerscore");
            scorelabel.setPosition(cc.p(625, 597));
            scorelabel.setAnchorPoint(cc.p(0, 0.5));
        } else {
            scorelabel.setString(player.score);
        }

        var goldlabel = this.getChildByName("playergold");
        if (!goldlabel) {
            cc.log("createlabel");
            goldlabel = FYEngine.createAlts(CommResource.selfNum_png, 12, player.gold, '.');
            this.addChild(goldlabel, 2, "playergold");
            goldlabel.setPosition(cc.p(365, 597));
            goldlabel.setAnchorPoint(cc.p(0, 0.5));
        } else {
            goldlabel.setString(player.gold);
        }
    },

    btnCallBack: function (sender) {
        var btnname = sender.getName();
        var player = appglobal.getPlayer();
        cc.log("---btnname:" + btnname);
        switch (btnname) {
            case FishCopyBtn.back : {
                var layer = new ExitCopy();
                if (layer) {
                    this.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.ExitCopy);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
            case FishCopyBtn.room[0] : {
                if (this.checkOverLose()) {
                    FishGlobal.roomId = 1;
                    if (this._handler && this._handler._canSendNormalMsg) {
                        this._handler.sendGetSceneTimeReq();
                    }
                }
            }
                break;
            case FishCopyBtn.room[1] : {
                if (this.checkOverLose()) {
                    FishGlobal.roomId = 2;
                    if (this._handler && this._handler._canSendNormalMsg) {
                        this._handler.sendGetSceneTimeReq();
                    }
                }
            }
                break;
            case FishCopyBtn.room[2] : {
                if (this.checkOverLose()) {
                    FishGlobal.roomId = 3;
                    if (this._handler && this._handler._canSendNormalMsg) {
                        this._handler.sendGetSceneTimeReq();
                    }
                }
            }
                break;
            case FishCopyBtn.mall : {
                var layer = new HeChengLayer();
                if (layer) {
                    this.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.hechenglayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
            case FishCopyBtn.help : {
                var layer = new CopyGameGuideLayer();
                if (layer) {
                    this.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.CopyGameGuideLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
            default:
                break;
        }

    },

    /**
     * 没有超过返回true ,超过返回false
     * @returns {boolean}
     */
    checkOverLose: function () {
        if (appglobal._playerCostControl == false && appglobal._playerLocationControl == false) {
            return true;
        }
        var date = new Date();
        var monthadd = cc.sys.localStorage.getItem(appglobal.getPlayer().userid + 'monthadd' + date.getFullYear() + date.getMonth());
        if (monthadd) {
            FishGlobal._addmoneymon = Number(monthadd);
        } else {
            FishGlobal._addmoneymon = 0;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'monthadd' + date.getFullYear() + date.getMonth(), "" + FishGlobal._addmoneymon);
        }
        cc.log("---本月赢钱" + monthadd);
        var dailyadd = cc.sys.localStorage.getItem(appglobal.getPlayer().userid + 'dailyadd' + date.getFullYear() + date.getMonth() + date.getUTCDate());
        if (dailyadd) {
            FishGlobal._addmoneydaily = Number(dailyadd);
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'dailyadd' + date.getFullYear() + date.getMonth() + date.getUTCDate(), "" + FishGlobal._addmoneydaily);
        } else {
            FishGlobal._addmoneydaily = 0;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'dailyadd' + date.getFullYear() + date.getMonth() + date.getUTCDate(), "" + FishGlobal._addmoneydaily);
        }
        cc.log("---本日赢钱" + dailyadd);
        var monthcost = cc.sys.localStorage.getItem(appglobal.getPlayer().userid + 'monthcost' + date.getFullYear() + date.getMonth());
        if (monthcost) {
            cc.log("---本月输钱" + monthcost);
            if ((Number(monthcost) - FishGlobal._addmoneymon) > FishGlobal.loseMoneyLimit.monthlevel) {
                cc.log(monthcost + "本月超过输赢上限" + FishGlobal._addmoneymon);
                var layer = this.getChildByName(LobbySceneName.OverLoseLayer);
                if (!layer) {
                    layer = new OverLoseLayer(1);
                    this.addChild(layer, FishZorder.poplayer + 100, LobbySceneName.OverLoseLayer);
                }
                return false;
            }
        } else {
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'monthcost' + date.getFullYear() + date.getMonth(), "" + 0);
        }


        var dailycost = cc.sys.localStorage.getItem(appglobal.getPlayer().userid + 'dailycost' + date.getFullYear() + date.getMonth() + date.getUTCDate());
        if (dailycost) {
            cc.log("---本日输钱" + dailycost);
            if ((Number(dailycost) - FishGlobal._addmoneydaily) > FishGlobal.loseMoneyLimit.dailylevel) {
                cc.log(dailycost + "本日超过输赢上限" + FishGlobal._addmoneydaily);
                var layer = this.getChildByName(LobbySceneName.OverLoseLayer);
                if (!layer) {
                    layer = new OverLoseLayer(2);
                    this.addChild(layer, FishZorder.poplayer + 100, LobbySceneName.OverLoseLayer);
                }
                return false
            }
        } else {
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'dailycost' + date.getFullYear() + date.getMonth() + date.getUTCDate(), "" + 0);
        }
        return true;
    },

    writeLawRecord: function () {

        var player = appglobal.getPlayer();
        if (player.realIDnumber != "" && player.isAdult) {
            this.unschedule(this.writeLawRecord);
            return;
        }
        var date = new Date();
        var currentRecordTime = cc.sys.localStorage.getItem(appglobal.getPlayer().userid + 'LawRecord' + date.getFullYear() + date.getMonth() + date.getUTCDate());
        if (currentRecordTime) {
            var totaltime = Number(currentRecordTime) + 1;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'LawRecord' + date.getFullYear() + date.getMonth() + date.getUTCDate(),
                totaltime + "");
            cc.log('-----------------1分钟计时一次已经游戏时间' + totaltime);
            if (totaltime < FishGlobal.lostTime.controllevel1) {
                if ((totaltime % FishGlobal.lostTime.duration1) == 0) {//3小时内每小时弹出一次
                    this.showAvoidLayer(totaltime);
                }
            } else if (totaltime == FishGlobal.lostTime.controllevel1) {
                this.showAvoidLayer(totaltime);
            } else if (totaltime > FishGlobal.lostTime.controllevel1 && totaltime < FishGlobal.lostTime.controllevel2) {
                if ((totaltime % FishGlobal.lostTime.duration2) == 0) {//3~5小时内每半小时弹出一次
                    this.showAvoidLayer(totaltime);
                }
            } else if (totaltime == FishGlobal.lostTime.controllevel2) {
                this.showAvoidLayer(totaltime);
            } else {
                if ((totaltime % FishGlobal.lostTime.duration3) == 0) {//5小时后每15分钟弹出一次
                    this.showAvoidLayer(totaltime);
                }
            }
        } else {
            var totaltime = 1;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'LawRecord' + date.getFullYear() + date.getMonth() + date.getUTCDate(),
                totaltime + "");
        }

    },

    showAvoidLayer: function (totaltime) {
        var layer = this.getChildByName(LobbySceneName.AvoidGameLostTip);
        if (!layer) {
            layer = new AvoidGameLostTip(totaltime);
            this.addChild(layer, FishZorder.poplayer, LobbySceneName.AvoidGameLostTip)
        } else {
            layer.refreshUI(totaltime);
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    createLoading: function () {
        cc.log("createLoading");
        var layer = this.getChildByName('loadinglayer');
        if (!layer) {
            layer = FYEngine.createLoadingLayer(UsedResName.HallLoadingquan, UsedResName.HallLoadingfish);
            this.addChild(layer, FishZorder.poplayer, 'loadinglayer');
        }
    },

    removeLoading: function () {
        cc.log("removeLoading");
        var layer = this.getChildByName("loadinglayer");
        if (layer) {
            layer.removeFromParent(true);
        }
    },

    joinTableCheck: function () {
        FishGlobal.isLobbyRecord = false;
        this.removeLoading();
        var str = "" + FYEngine.LanguageString.getValue("TimeOutMsg1");
        FYEngine.AddCommToast(str);
    },

    onGameEvent: function (event, param) {
        switch (event) {
            case FishCopyEvent.refreshWealth : {

                this.updateWealth();
                var layer1 = this.getChildByName(FishCopyLobbyLayer.hechenglayer);
                var layer2 = this.getChildByName(FishCopyLobbyLayer.CopySelectSoldLayer);
                var layer3 = this.getChildByName(FishCopyLobbyLayer.CopySoldInfoLayer);
                var layer4 = this.getChildByName(FishCopyLobbyLayer.HechengConfirmLayer);
                if (layer2 && layer2.updateWealth) {
                    layer2.updateWealth();
                }
                if (layer3 && layer3.updateWealth) {
                    layer3.updateWealth();
                }
                if (layer1 && layer1.updateWealth) {
                    layer1.updateWealth();
                }
                if (layer4 && layer4.updateWealth) {
                    layer4.updateWealth();
                }

            }
                break;
            case FishCopyEvent.getGameTime : {
                if (param.iResult != 0) {
                    this.removeLoading();
                    this.unschedule(this.joinTableCheck);
                    FYEngine.AddCommToast("加入房间失败");
                } else {
                    if (param.iSceneTime > 0) {
                        if ((180000 - param.iSceneTime) < 1000) {
                            if (FishGlobal.isLobbyRecord) {//如果是从大厅被拖进来，则有loading和超时了，不管
                                cc.log("-----step1");
                                FishGlobal.isLobbyRecord = false;
                                this.removeLoading();
                                this.unschedule(this.joinTableCheck);
                                FYEngine.AddCommToast("房间不存在");
                            } else {//副本大厅点击按钮的，弹出loading和schedule
                                cc.log("-----step2");
                                this.createLoading();
                                this.scheduleOnce(this.joinTableCheck, 15);
                                FishGlobal.roomId = param.iRoomId;
                                FishGlobal.copyTimeControl.copyGameLeftTime = Math.floor((180000 - param.iSceneTime) / 1000);
                                if (this._handler && this._handler._canSendNormalMsg) {
                                    this._handler.sendJoinTabelReq(FishGlobal.roomId);
                                }
                            }
                        } else {//时间剩余大于15秒
                            if (!FishGlobal.isLobbyRecord) {//点击按钮的需要加上loading
                                cc.log("-----step3");
                                this.createLoading();
                                this.scheduleOnce(this.joinTableCheck, 15);
                            }
                            cc.log("-----step4");
                            FishGlobal.roomId = param.iRoomId;
                            FishGlobal.copyTimeControl.copyGameLeftTime = Math.floor((180000 - param.iSceneTime) / 1000);
                            if (this._handler && this._handler._canSendNormalMsg) {
                                this._handler.sendJoinTabelReq(FishGlobal.roomId);
                            }
                        }
                    } else {
                        if (FishGlobal.isLobbyRecord) {//无未完成的游戏，如果是大厅拉过来的，直接去掉loading
                            cc.log("-----step5");
                            FishGlobal.isLobbyRecord = false;
                            this.removeLoading();
                            this.unschedule(this.joinTableCheck);
                            FYEngine.AddCommToast("房间不存在");
                        } else {
                            if (FishGlobal.getCopyRoomConfById(FishGlobal.roomId - 1).iExpendScore == 0
                                && FishGlobal.getCopyRoomConfById(FishGlobal.roomId - 1).lMinGold == 0) {
                                cc.log("-----step6");
                                FishGlobal.copyTimeControl.copyGameLeftTime = Math.floor((180000 - param.iSceneTime) / 1000);
                                this.createLoading();
                                this.scheduleOnce(this.joinTableCheck, 15);
                                if (this._handler && this._handler._canSendNormalMsg) {
                                    this._handler.sendJoinTabelReq(FishGlobal.roomId);
                                }
                            } else {
                                cc.log("-----step7");
                                var player = appglobal.getPlayer();
                                if (player.gold < FishGlobal.getCopyRoomConfById(FishGlobal.roomId - 1).lMinGold) {
                                    var layer = this.getChildByName(FishCopyLobbyLayer.GoldNotEnough);
                                    if (!layer) {
                                        var needmoney = FishGlobal.getCopyRoomConfById(FishGlobal.roomId - 1).lMinGold - player.gold;
                                        layer = new GoldNotEnough(needmoney);
                                        this.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.GoldNotEnough);
                                        FYEngine.popupLayerAnimate(layer.layerbg);
                                    }
                                } else {
                                    FishGlobal.copyTimeControl.copyGameLeftTime = Math.floor((180000 - param.iSceneTime) / 1000);
                                    var layer = this.getChildByName(FishCopyLobbyLayer.CopyConfirmEnter);
                                    if (!layer) {
                                        layer = new ConfirmEnter();
                                        this.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.CopyConfirmEnter);
                                        FYEngine.popupLayerAnimate(layer.layerbg);
                                    }
                                }
                            }
                        }
                    }
                }
            }
                break;
            case FishGameEventID.unConnect: {
                this.onUnconnect(param);
            }
                break;
            case FishCopyEvent.reloginfail : {
                cc.log("FishCopyEvent.reloginfail");
                if (param.iResult == 1101) {
                    FishGlobal.copyReloginTag = true;
                    var coreserviceproxy = CoreServiceProxy.getInstance();
                    coreserviceproxy.unlinkGameClient();
                    appglobal.runFishCopyScene();
                }
            }
                break;
            default:
                break;
        }
    },

    onUnconnect: function (type) {
        cc.log('----------------CopyLobbyScene unconnectType :');
        var layer = this.getChildByName(FishSceneName.UnConnectDialog);
        cc.log("unconnecttype=====" + type);
        switch (type) {
            case 1: {
                if (!layer) {
                    layer = new unConnectLayer(0);
                    layer.refreshUI(type);
                    this.addChild(layer, FishZorder.poplayer + 100, FishSceneName.UnConnectDialog);
                    layer._reConnectCode = 0;
                    layer.code = 0;
                }
                cc.log("code====" + layer._reConnectCode);
                if (layer && layer._reConnectCode && layer._reConnectCode == 1) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    layer.refreshUI(3);
                }

                if (layer && layer._reConnectCode == 0 && layer.code == 0) {
                    layer.unschedule(layer.layerF);
                    layer.unschedule(layer.removeLayer);
                    layer.refreshUI(1);
                    layer.scheduleOnce(layer.layerF, 10.0);
                    layer.code = 1;
                }
            }
                break;
            case 2:
            case 3: {
                if (layer) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    if (layer && layer.layerF) {
                        layer.unschedule(layer.layerF);
                        layer.refreshUI(type);
                        layer.code = 0;
                    }
                }
            }
                break;
            case 0: {
                if (layer) {
                    layer.removeFromParent();
                }
            }
                break;
        }
    },
});

FishCopyLobby.createScene = function () {
    var scene = new cc.Scene();
    var layer = new FishCopyLobby();
    scene.addChild(layer, 0, 0);
    scene.setName("fishcopylobby");
    return scene;
};
