/**
 * Created by PhoneU on 2018/5/25.
 */
/**
 * Created by PhoneU on 2018/3/29.
 */

var FishFightLayer = {
    FishFightCreate: "FishFightCreate",
    FishFightNoQualification: "FishFightNoQualification",
    FishFightWatingLayer: "FishFightWatingLayer",
    FishFightWrongSequence: "FishFightWrongSequence",
    FishFightTableDissolveConfirm: "FishFightTableDissolveConfirm",
    FishFightTableDissolveNotice: "FishFightTableDissolveNotice",
    FishFightTableInfo: "FishFightTableInfo",
    FishFightTableLeaveConfirm :"FishFightTableLeaveConfirm",
    FishFightRuleLayer :"FishFightRuleLayer",
    FishFightResultLayer :"FishFightResultLayer",
};


var FishFightEvent = {
    queryCreateQualification: "queryCreateQualification",
    createTabel: "createTable",
    dissolveTabel: "dissolveTabel",
    queryUnfinish: "queryUnfinish",
    queryTableInfo: "queryTableInfo",
    joinTableFail: "joinTableFail",
    joinTableOK: "joinTableOK",
    refreshPlayer: "refreshPlayer",
    getGameTime : "getGameTime",
    gameResult : "gameResult",
    playerScore : "queryplayerscore",


};
var FishFightBtn = {
    back: "backtolobby",
    createroom: "createroom",
};

var FishFightNum = {
    NUM0: "res/updatefight/fish_fight_NUM0.png",
    NUM1: "res/updatefight/fish_fight_NUM1.png",
    NUM2: "res/updatefight/fish_fight_NUM2.png",
    NUM3: "res/updatefight/fish_fight_NUM3.png",
};
var FishFightLobby = cc.Layer.extend({
    _numberarr: [],
    _numberqty: 0,
    _roomInfo: null,
    ctor: function () {
        this._super();
        this.setName("FishFightLobby");
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        if(this._handler){
            this._handler.clearData();
        }
    },

    onEnter: function () {
        this._super();
        this.initData();
        this.initUI();
        this.sendMsg();
        this.queryWealth();
        this.initPhoneBtnCallBack();
        this.loadMusic();
    },

    queryWealth : function(){
        var lobbyhandler = CoreServiceProxy.getInstance().getLobbyHandler();
        if(lobbyhandler && lobbyhandler._canSendNormalMsg){
            lobbyhandler.sendUpdateWealthReq();
            lobbyhandler.sendGetCrystalInfoReq();
        }
    },

    sendMsg: function () {
        if(this._handler && this._handler._canSendNormalMsg){
            this._handler.sendHasUnfinishedGameReq();
        }
    },


    onExit: function () {
        this._super();
    },


    initData: function () {
        FishGlobal.bInFishScene = false;
        this._numberarr = [];
        this._numberqty = 0;
        this._roomInfo = null;
        FishGlobal._TableConfig =null;
        FishGlobal._SHOWVIPINFO = false;
    },


    initPhoneBtnCallBack: function () {
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
        FYEngine.AddCustomLister(this, 'game_on_show', this.gameOnShowEvent);
        FYEngine.AddCustomLister(this, 'game_on_hide', this.testGameOnHide);

    },

    phoneKeyCallBack: function (keycode, target) {
        cc.log("--1");
        var scene = FYEngine.getRunningLayer(0);
        switch (keycode) {
            case cc.KEY.back : {
                if (scene.getChildByName(LobbySceneName.KickedByServer) || scene.getChildByName("loading2")
                    || scene.getChildByName("loadinglayer") || scene.getChildByName(FishSceneName.UnConnectDialog)
                    || scene.getChildByName(LobbySceneName.OverLoseLayer))
                {
                    return;
                }
                var otherlayer = scene.getChildByName(FishFightLayer.FishFightRuleLayer)
                    || scene.getChildByName(FishFightLayer.FishFightTableLeaveConfirm)
                    || scene.getChildByName(FishFightLayer.FishFightTableInfo)
                    || scene.getChildByName(FishFightLayer.FishFightTableDissolveNotice)
                    || scene.getChildByName(FishFightLayer.FishFightTableDissolveConfirm)
                    || scene.getChildByName(FishFightLayer.FishFightWrongSequence)
                    || scene.getChildByName(FishFightLayer.FishFightNoQualification)
                    ||scene.getChildByName(FishFightLayer.FishFightCreate)
                    || scene.getChildByName(FishCopyLobbyLayer.ExitCopy);
                if (otherlayer) {
                    cc.log("--2");
                    if (otherlayer.layerbg) {
                        FYEngine.popoutLayerAnimate(otherlayer.layerbg);
                    } else {
                        otherlayer.removeFromParent(true);
                    }
                } else {
                    cc.log("-3");
                    var protectlauer = scene.getChildByName(FishFightLayer.FishFightWatingLayer);
                    if(!protectlauer){
                        cc.log("--4");
                        var layer = new ExitCopy();
                        if (layer) {
                            scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.ExitCopy);
                            FYEngine.popupLayerAnimate(layer.layerbg);
                        }
                    }else{
                        cc.log("--5");
                        protectlauer.phoneKeyFuntion();
                    }

                }
            }
        }

    },

    gameOnShowEvent: function () {
        var self = this;
        cc.log("大厅show");
        if (cc.sys.os != 'iOS') {
            var handler = CoreServiceProxy.getInstance().getGameHandler();
            if (handler) {
                handler.setCanSendHeart(false);
                handler._needReConnect = false;
                handler._reconnetTime = 0;
                this.runAction(new cc.Sequence(new cc.DelayTime(1), new cc.CallFunc(function () {
                   handler.reconnClient();
                    cc.log('-----后台直接重连2');
                })));

               handler.onConnectEvent &&handler.onConnectEvent(eClientEvent.EVENT_CONNECT_RECONN);
                handler._needReConnect = false;
                cc.log('-----后台直接重连1');
            }

        } else {
            this.loadMusic();
        }

    },

    loadMusic: function () {
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        for (var i = 0; i < arr.length; i++) {
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (!temp) {
                cc.sys.localStorage.setItem(arr[i], i == 2 ? 0 : 1);
            }
        }

        FYEngine.Audio.stopAll();
        if (cc.sys.localStorage.getItem("bgVolum") == 1) {
            FYEngine.Audio.setOpenMusic(true);
            FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
        }
    },


    testGameOnHide: function () {
        cc.log("大厅hide");
    },

    initUI: function () {
        var self = this;
        var layerbg = new cc.Sprite("res/updatefight/fish_fight_bg.png");
        if (layerbg) {
            this._bgImage = layerbg;
            this.addChild(layerbg, 0, "layerbg");
            layerbg.setAnchorPoint(cc.p(0, 0));
            layerbg.setPosition(cc.p(0, 0));
        }

        var btn3 = new ccui.ImageView("fish_copy_6.png", ccui.Widget.PLIST_TEXTURE);
        if (btn3) {
            this.addChild(btn3, 1, FishFightBtn.back);
            btn3.setPosition(cc.p(55, 600));
            btn3.setTouchEnabled(true);
            btn3.addTouchEventListener(this.btnTouchEft, this);
            btn3.addClickEventListener(function (sender) {
                self.btnCallBack(sender);
            });
        }

        var mpicname = ["fish_boom33.png", "hall83.png"];
        for (var j = 0; j < 2; ++j) {
            var goldbg = new ccui.ImageView("hall35.png", ccui.Widget.PLIST_TEXTURE);
            if (goldbg) {
                this.addChild(goldbg, 1, "goldbg");
                goldbg.setAnchorPoint(cc.p(0, 0.5));
                goldbg.setScale9Enabled(true);
                goldbg.setPosition(cc.p(320 + 250 * j, 597));

                var tip1 = new ccui.ImageView(mpicname[j], ccui.Widget.PLIST_TEXTURE);
                if (tip1) {
                    goldbg.addChild(tip1, 0, "goldtip");
                    tip1.setPosition(cc.p(10, goldbg.height / 2 + 5));
                    if (j == 0) {
                        tip1.setScale(0.6);
                    }
                }
            }
        }
        this.updateWealth();
        this.initLeft();
        this.initRight();
    },

    initLeft: function () {
        var self = this;
        var fishbg = new cc.Sprite("#fish_fight_res15.png");
        if (fishbg) {
            this.addChild(fishbg, 3, "fishbg");
            fishbg.setPosition(cc.p(330, 290));


        }
        var cbtn = new ccui.ImageView("fish_fight_res17.png", ccui.Widget.PLIST_TEXTURE);
        if (cbtn) {
            this.addChild(cbtn, 3, FishFightBtn.createroom);
            cbtn.setPosition(cc.p(330, 155));
            cbtn.setTouchEnabled(true);
            cbtn.addTouchEventListener(this.btnTouchEft, this);
            cbtn.addClickEventListener(function (sender) {
                self.btnCallBack(sender);
            });
        }
    },

    initRight: function () {
        var self = this;
        var bigbg = new ccui.ImageView("fish_fight_res25.png", ccui.Widget.PLIST_TEXTURE);
        if (bigbg) {
            this.addChild(bigbg, 3, "bigbg");
            this._bigbg = bigbg;
            bigbg.setPosition(cc.p(755, 280));
            bigbg.setScale9Enabled(true);
            bigbg.setContentSize(cc.size(410, 455));

            var bgtitle = new cc.Sprite("#fish_fight_res19.png");
            if (bgtitle) {
                bgtitle.setPosition(cc.p(bigbg.width / 2, bigbg.height - 5));
                bigbg.addChild(bgtitle);
            }

            var btnbg = new ccui.ImageView("fish_fight_res20.png", ccui.Widget.PLIST_TEXTURE);
            if (btnbg) {
                bigbg.addChild(btnbg, 1, "btnbg");
                btnbg.setPosition(cc.p(bigbg.width / 2, 180));
                btnbg.setScale9Enabled(true);
                btnbg.setContentSize(cc.size(375, 320));

                for (var j = 0; j < 12; ++j) {
                    var btnname = "fish_fight_res22.png";
                    if (j == 9) {
                        btnname = "fish_fight_res26.png";
                    } else if (j == 11) {
                        btnname = "fish_fight_res27.png";
                    }

                    var cbtn = new ccui.ImageView(btnname, ccui.Widget.PLIST_TEXTURE);
                    if (cbtn) {
                        btnbg.addChild(cbtn, 1, "btn" + j);
                        cbtn.setTag(100 + j);
                        cbtn.setPosition(cc.p(70 + (j % 3) * 120, 270 - (Math.floor(j / 3) * 75)));
                        cbtn.setTouchEnabled(true);
                        cbtn.addTouchEventListener(this.btnTouchEft, this);
                        cbtn.addClickEventListener(function (sender) {
                            self.roomBtn(sender);
                        });

                        if (j <= 8) {
                            var shownum = FYEngine.createAlts(FishFightNum.NUM0, 10, "" + (j + 1), '0');
                            cbtn.addChild(shownum, 2, "shownum");
                            shownum.setPosition(cc.p(cbtn.width / 2, cbtn.height * 0.55));
                        } else if (j == 10) {
                            var shownum = FYEngine.createAlts(FishFightNum.NUM0, 10, "0", '0');
                            cbtn.addChild(shownum, 2, "shownum");
                            shownum.setPosition(cc.p(cbtn.width / 2, cbtn.height * 0.55));
                        }
                    }
                }
            }

            for (var i = 0; i < 6; ++i) {
                var numberbg = new ccui.ImageView("fish_fight_res21.png", ccui.Widget.PLIST_TEXTURE);
                if (numberbg) {
                    bigbg.addChild(numberbg, 1, "numberbg" + i);
                    numberbg.setPosition(cc.p(57 + i * 60, 380));
                }

                var upnumber = FYEngine.createAlts(FishFightNum.NUM1, 10, "0", '0');
                if (upnumber) {
                    upnumber.setVisible(false);
                    bigbg.addChild(upnumber, 2, "upnumber" + i);
                    upnumber.setPosition(cc.p(57 + i * 60, 380));
                }

            }
        }
    },

    roomBtn: function (sender) {
        var name = sender.getName();
        var tag = Number(sender.getTag()) - 100;
        cc.log("sender:" + name + "---tag:" + tag);

        switch (tag) {
            case 0 :
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6 :
            case 7:
            case 8: {
                this.addNumber(tag + 1);
            }
                break;
            case 9: {
                this.deletNumberAll();
            }
                break;
            case 10: {
                this.addNumber(0);
            }
                break;
            case 11: {
                this.deletNumberOne();
            }
                break;
            default :
                break;
        }
    },

    addNumber: function (num) {
        if (this._numberqty < 6) {
            this._numberarr.push("" + num);
            this._numberqty++;
            var index = this._numberqty - 1;
            this.showNumber(index, num);

            cc.log("1-----qty:" + this._numberqty + "--content:" + this._numberarr);
            if (this._numberqty == 6) {
                cc.log("可以进场了");
                var handler = CoreServiceProxy.getInstance().getGameHandler();
                if (handler && handler._canSendNormalMsg) {
                    var temp = "";
                    for (var i = 0; i < this._numberarr.length; ++i) {
                        temp += this._numberarr[i];
                    }
                    this.createLoading();
                    this.scheduleOnce(this.normalTimeOutCheck,15);
                    handler.sendQueryTabelInfoReq(temp, 1);
                    this.deletNumberAll();
                }
            }
        }

    },

    deletNumberAll: function () {
        var total = this._numberqty;
        for (var i = 0; i < total; ++i) {
            this.deletNumberOne();
        }
        // this._numberarr =[];
        // this._numberqty =0;
    },

    deletNumberOne: function () {
        if (this._numberqty > 0) {
            var index = this._numberqty - 1;
            this._numberqty--;
            this._numberarr.splice(index, 1);
            this.hideNumber(index);
        }
    },

    hideNumber: function (index) {
        var number = this._bigbg.getChildByName("upnumber" + index);
        if (number) {
            number.setVisible(false);
        }
    },

    showNumber: function (index, num) {
        var number = this._bigbg.getChildByName("upnumber" + index);
        if (number) {
            number.setString("" + num);
            number.setVisible(true);
        }
    },

    updateWealth: function () {
        var player = appglobal.getPlayer();
        var boom = this.getChildByName("playerboom");
        if (!boom) {
            cc.log("createlabel");
            boom = FYEngine.createAlts(CommResource.selfNum_png, 12, player.crystal, '.');
            this.addChild(boom, 2, "playerboom");
            boom.setPosition(cc.p(350, 597));
            boom.setAnchorPoint(cc.p(0, 0.5));
        } else {
            boom.setString(player.crystal);
        }

        var coupon = this.getChildByName("playercoupon");
        if (!coupon) {
            cc.log("createlabel");
            coupon = FYEngine.createAlts(CommResource.selfNum_png, 12, player.coupon, '.');
            this.addChild(coupon, 2, "playercoupon");
            coupon.setPosition(cc.p(600, 597));
            coupon.setAnchorPoint(cc.p(0, 0.5));
        } else {
            coupon.setString(player.coupon);
        }
    },


    btnCallBack: function (sender) {
        var btnname = sender.getName();
        var player = appglobal.getPlayer();
        cc.log("---btnname:" + btnname);
        switch (btnname) {
            case FishFightBtn.back : {
                var layer = new ExitCopy();
                if (layer) {
                    this.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.ExitCopy);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
            case FishFightBtn.createroom : {
                if (player.iVIPLevel < FishGlobal._canSendLevel) {
                    var layer = new VIPcreateLevel();
                    if (layer) {
                        this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightNoQualification);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                } else {
                    var handeler = CoreServiceProxy.getInstance().getGameHandler();
                    if (handeler && handeler._canSendNormalMsg) {
                        handeler.sendCanCreateTableReq();
                        this.createLoading();
                        this.scheduleOnce(this.normalTimeOutCheck, 15);
                    }
                }
            }
                break;
            default:
                break;
        }

    },


    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    createLoading: function () {
        cc.log("createLoading");
        var layer = this.getChildByName('loadinglayer');
        if (!layer) {
            layer = FYEngine.createLoadingLayer(UsedResName.HallLoadingquan, UsedResName.HallLoadingfish);
            this.addChild(layer, FishZorder.poplayer + 5, 'loadinglayer');
        }
    },

    removeLoading: function () {
        cc.log("removeLoading");
        var layer = this.getChildByName("loadinglayer");
        if (layer) {
            layer.removeFromParent(true);
        }
    },

    joinTableCheck: function () {
        this.removeLoading();
        var str = "" + FYEngine.LanguageString.getValue("TimeOutMsg1");
        FYEngine.AddCommToast(str);
    },

    normalTimeOutCheck: function () {
        this.removeLoading();
        var str = "连接服务器超时";
        FYEngine.AddCommToast(str);
    },

    onGameEvent: function (event, param) {
        cc.log("onGameEvent:" + event);
        switch (event) {
            case FishFightEvent.refreshPlayer : {
                var layer = this.getChildByName(FishFightLayer.FishFightWatingLayer);
                if(layer && layer.changeUserStatus){
                    layer.changeUserStatus();
                }
            }break;
            case FishFightEvent.queryCreateQualification : {
                this.unschedule(this.normalTimeOutCheck);
                this.removeLoading();
                if (param.iResult == 0) {
                    if(param.iMoney ==0){
                        var layer = this.getChildByName(FishFightLayer.FishFightCreate);
                        if(!layer){
                            layer = new FishFightCreate();
                            if (layer) {
                                this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightCreate);
                            }
                        }
                    }else if(param.iMoney >0){
                        var layer = this.getChildByName(FishFightLayer.FishFightNoQualification);
                        if(!layer){
                            layer = new SendCrystalLevelDialog(param.iMoney,1);
                            if (layer) {
                                this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightNoQualification);
                            }
                        }
                    }else{
                        var layer = this.getChildByName(FishFightLayer.FishFightNoQualification);
                        if(!layer){
                            layer = new FishFightNoQualification();
                            if (layer) {
                                this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightNoQualification);
                            }
                        }
                    }

                } else {
                    if(param.iResult == -15){
                        FYEngine.AddCommToast("创建房间失败，请重试");
                    }else{
                        var layer = this.getChildByName(FishFightLayer.FishFightNoQualification);
                        if(!layer){
                            layer = new FishFightNoQualification();
                            if (layer) {
                                this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightNoQualification);
                            }
                        }
                    }

                }
            }
                break;
            case FishFightEvent.createTabel : {
                var createLayer = this.getChildByName(FishFightLayer.FishFightCreate);
                if (param.iResult == 0) {
                    createLayer.removeFromParent(true);
                    FishGlobal._TableConfig = param;
                    var layer = new FishFightWatingLayer(param);
                    if (layer) {
                        this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightWatingLayer);
                    }
                } else {
                    createLayer.removeLoading();
                    createLayer.unschedule(createLayer.timeCount);
                    if(param.iResult == -15){
                        FYEngine.AddCommToast("服务器繁忙，请重试");
                    }else{
                        var layer = new FishFightNoQualification();
                        //var layer = new CreateRoomFail();
                        if(layer){
                            this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightNoQualification);
                        }
                    }
                    // }else if(param.iResult == 2230){
                    //     FYEngine.AddCommToast("创建房间失败");
                    // } else{
                    //     FYEngine.AddCommToast("创建房间失败"+param.iResult);
                    // }

                }
                this.queryWealth();
            }
                break;
            case FishFightEvent.dissolveTabel : {//todo  这边不管返回的解散结果是否正确，都给房间解散
                var layer = this.getChildByName(FishFightLayer.FishFightWatingLayer);
                if (layer && layer.dissolveTable)
                {
                    layer.dissolveTable();
                }
                this.queryWealth();
            }
                break;
            case FishFightEvent.queryUnfinish : {
                if (param.iResult == 0 && param.iTableId > 0) {
                    var handler = CoreServiceProxy.getInstance().getGameHandler();
                    if (handler && handler._canSendNormalMsg) {
                        this.createLoading();
                        this.scheduleOnce(this.normalTimeOutCheck,15);
                        handler.clearData();
                        handler.sendQueryTabelInfoReq(param.iTableId, 2);

                    }
                }else{
                    var layer = this.getChildByName(FishFightLayer.FishFightWatingLayer);
                    if (layer) {
                        layer.removeFromParent(true);
                        FYEngine.AddCommToast("房间已解散");
                    }
                }
            }
                break;
            case FishFightEvent.queryTableInfo : {
                this.removeLoading();
                this.unschedule(this.normalTimeOutCheck);
                if (param.iResult == 0) {
                    FishGlobal._TableConfig = param;
                    if (param.iReserved == 1) {//正常加入
                        var layer = this.getChildByName(FishFightLayer.FishFightTableInfo);
                        if (!layer) {
                            layer = new FishFightTableInfo(param);
                            this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightTableInfo);
                        }
                    } else {
                        var handler = CoreServiceProxy.getInstance().getGameHandler();
                        if (handler && handler._canSendNormalMsg) {
                            handler.sendGetSceneTimeReq();
                            //handler.sendJoinTabelReq(param.iTableId);
                        }
                    }
                } else {
                    FYEngine.AddCommToast("房间不存在");
                    var layer = this.getChildByName(FishFightLayer.FishFightWatingLayer);
                    if (layer) {
                        layer.removeFromParent(true);
                    }
                }
            }
                break;
            case FishFightEvent.joinTableFail : {
                var layer = this.getChildByName(FishFightLayer.FishFightTableInfo);
                if (layer) {
                    layer.removeLoading();
                    layer.unschedule(layer.timeCount);

                }
                if(param.iResult == 2102){
                    FYEngine.AddCommToast("房间人数已满");
                }else if(param.iResult == 2104){
                    FYEngine.AddCommToast("比赛已结束");
                }else{
                    FYEngine.AddCommToast("加入比赛失败"+param.iResult);
                }

            }
                break;
            case FishFightEvent.joinTableOK : {
                var mlayer = this.getChildByName(FishFightLayer.FishFightTableInfo);
                if (mlayer) {
                    mlayer.removeFromParent(true);
                }
                if (param.iTableStatus == 0) {//游戏未开始
                    var layer = this.getChildByName(FishFightLayer.FishFightWatingLayer);
                    if (!layer) {
                        layer = new FishFightWatingLayer(FishGlobal._TableConfig);
                        this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightWatingLayer);
                    } else {

                    }
                } else {//游戏已经开始
                    FYEngine.runScene(FishFightGameLayer.createScene());

                    // var handler = CoreServiceProxy.getInstance().getGameHandler();
                    // if (handler && handler._canSendNormalMsg) {
                    //    handler.sendGetSceneTimeReq();
                    // }
                }
            }
                break;
            case FishCopyEvent.getGameTime :{
                if(param.iResult == 0){
                    if(param.iSceneTime>2000){
                        FishGlobal._FightLeftTime = Math.floor((param.iAllGameTime - param.iSceneTime)/1000);
                        var handler = CoreServiceProxy.getInstance().getGameHandler();
                        if (handler && handler._canSendNormalMsg) {
                            handler.sendJoinTabelReq(FishGlobal._TableConfig.iTableId);
                        }
                        //FYEngine.runScene(FishFightGameLayer.createScene());
                    }else{
                        this.removeLoading();
                        this.unschedule(this.normalTimeOutCheck);
                        //FYEngine.AddCommToast("房间到期");
                    }
                }else{
                    FYEngine.AddCommToast("加入房间失败"+param.iResult);
                }

            }break;
            case lobbyGameEvent.refreshWealth :
            case FishCopyEvent.refreshWealth : {
                this.updateWealth();
            }
                break;
            case FishGameEventID.unConnect: {
                this.onUnconnect(param);
                if(param ==2){
                    this._handler = CoreServiceProxy.getInstance().getGameHandler();
                    this.sendMsg();
                    this.queryWealth();
                }
            }
                break;
            case FishCopyEvent.reloginfail : {
                cc.log("FishCopyEvent.reloginfail");
                // if (param.iResult == 1101 || param.iResult == 1204) {
                    FishGlobal.copyReloginTag = true;
                    var coreserviceproxy = CoreServiceProxy.getInstance();
                    coreserviceproxy.unlinkGameClient();
                    appglobal.runFishFightScene();
                // }
            }
                break;
            default:
                break;
        }
    },

    onUnconnect: function (type) {
        cc.log('----------------CopyLobbyScene unconnectType :');
        var layer = this.getChildByName(FishSceneName.UnConnectDialog);
        cc.log("unconnecttype=====" + type);
        switch (type) {
            case 1: {
                if (!layer) {
                    layer = new unConnectLayer(0);
                    layer.refreshUI(type);
                    this.addChild(layer, FishZorder.poplayer + 100, FishSceneName.UnConnectDialog);
                    layer._reConnectCode = 0;
                    layer.code = 0;
                }
                cc.log("code====" + layer._reConnectCode);
                if (layer && layer._reConnectCode && layer._reConnectCode == 1) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    layer.refreshUI(3);
                }

                if (layer && layer._reConnectCode == 0 && layer.code == 0) {
                    layer.unschedule(layer.layerF);
                    layer.unschedule(layer.removeLayer);
                    layer.refreshUI(1);
                    layer.scheduleOnce(layer.layerF, 10.0);
                    layer.code = 1;
                }
            }
                break;
            case 2:
            case 3: {
                if (layer) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    if (layer && layer.layerF) {
                        layer.unschedule(layer.layerF);
                        layer.refreshUI(type);
                        layer.code = 0;
                    }
                }
            }
                break;
            case 0: {
                if (layer) {
                    layer.removeFromParent();
                }
            }
                break;
        }
    },
});

FishFightLobby.createScene = function () {
    var scene = new cc.Scene();
    var layer = new FishFightLobby();
    scene.addChild(layer, 0, 0);
    scene.setName("FishFightLobby");
    return scene;
};
