var GameNewGame1 = cc.Layer.extend({

    _BulletArr: [],
    _BulletLayer: null,
    _goldEndPos: cc.p(0, 0),
    _fishcoinEndPos: cc.p(0, 0),
    _goldAni: null,
    _handler: null,
    _lobbyhandler: null,
    _moveaction: false,
    ctor: function () {
        this._super();
        this.setName("GameNewGame1");
        this.initData();
    },

    onEnter: function () {
        this._super();
        this.initUI();

    },

    onExit: function () {
        this._super();
    },


    initData: function () {
        var size = cc.winSize;
        this._moveaction = false;
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this._handler.setScene(this);
        this._lobbyhandler = CoreServiceProxy.getInstance().getLobbyHandler();
        this.setContentSize(cc.size(cc.winSize.width, cc.winSize.height));
        GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE = 0;
        this._BulletArr = [];
        this._BulletLayer = null;
        this._goldEndPos = cc.p(150, size.height - 35);
        this._fishcoinEndPos = cc.p(400, size.height - 35);
        this._goldAni = null;
        FishGlobal.bInFishScene = true;
        FishGlobal.isLobbyRecord = false;

    },


    initUI: function () {
        var self = this;
        var size = cc.winSize;
        this.initAni();

        var bg = new cc.Sprite("NewGameRes/NewGameGameBg0.jpg");
        if (bg) {
            this.addChild(bg, 0, 'bg');
            bg.setPosition(size.width / 2, size.height / 2);
            bg.setScale(appglobal.getScale());
        }

        var GameLeftUp = this._GameLeftUp = fycommonfunc.ccsLoadNode("res/NewGameRes/GAME1_LEFTUP.csb");
        this.addChild(GameLeftUp, 10, 'GameLeftUp');
        GameLeftUp.setPosition(cc.p(0, size.height));
        this.initGameLeftUp();

        var GameLeftDown = this._GameLeftDown = fycommonfunc.ccsLoadNode("res/NewGameRes/GAME1_LEFTDOWN.csb");
        this.addChild(GameLeftDown, 10, 'GameLeftDown');
        GameLeftDown.setPosition(cc.p(0, 0));
        this.initGameLeftDown(true);

        var GameProgress = this._GameProgress = new Game_Progress();
        this.addChild(GameProgress, 10, "GameProgress");
        GameProgress.setPosition(cc.p(size.width / 2, 230));

        var GameBoss = this._GameBoss = new Game_Boss();
        this.addChild(GameBoss, 1, "Game_Boss");
        GameBoss.setPosition(cc.p(size.width / 2, size.height / 2));

        var GameCannon = this._GameCannon = new Game_New_Cannon();
        this.addChild(GameCannon, 10, "GameCannon");

        GameCannon.setPosition(cc.p(size.width / 2, 0));

        var GameBulletLayer = this._BulletLayer = new GameNewTouchLayer1();
        this.addChild(GameBulletLayer, 2, "GameBulletLayer");

        this.initRightMenu();
        this.showGuide();

        this.initPhoneBtnCallBack();

        this.initBackGroundMusic();

        this.scheduleUpdate();
    },

    moveCannonBtn : function(){
        this._GameCannon.showChangeBtn();
    },

    showGuide : function(){
        if(GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW == true){
            var layer = this.getChildByName(GAME_NEW_WINDOWS.GAME1_GUIDE_LAYER);
            if(!layer){
                layer = new GAME1_GUIDE_LAYER();
                this.addChild(layer,FishZorder.poplayer+1,GAME_NEW_WINDOWS.GAME1_GUIDE_LAYER);
            }
        }else{
            this.moveCannonBtn()
        }
    },

    initPhoneBtnCallBack: function () {
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
        FYEngine.AddCustomLister(this, 'game_on_show', this.gameOnShowEvent);
        FYEngine.AddCustomLister(this, 'game_on_hide', this.testGameOnHide);
    },


    initAni: function () {
        var self = this;
        var movedown = new cc.MoveBy(0.3, cc.p(0, -60));
        this._goldAni = new cc.Sequence(new cc.MoveBy(0.2, cc.p(0, 20)), movedown.easing(cc.easeIn(3)),
            new cc.MoveBy(0.2, cc.p(0, 50)),
            new cc.Spawn(new cc.FadeTo(0.3, 50), new cc.MoveBy(0.3, cc.p(0, 60))), new cc.RemoveSelf());
        this._goldAni.retain();


    },

    initGameLeftUp: function () {
        let player = GAME_NEW_INT_DATA.player;
        var gold = this._GameLeftUp.getChildByName("LEFTUP").getChildByName("goldbg").getChildByName("num_gold");
        gold.setString(player.gold);

        var fishcoin = this._GameLeftUp.getChildByName("LEFTUP").getChildByName("fishcoinbg").getChildByName("num_fishcoin");
        fishcoin.setString(player.fishcoin);
    },

    initGameLeftDown: function (tag) {
        if (tag) {
            var self = this;
            var btnadd = this._GameLeftDown.getChildByName("bg").getChildByName("BTN_ADD");
            btnadd.addClickEventListener((sender) => {
                self.btnClickCallBack(sender);
            });
        }

        var ntime = this._GameLeftDown.getChildByName("bg").getChildByName("TIMES_NUM");
        ntime.setString(GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] +
            "/" + GAME_NEW_INT_DATA.TOTAL_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);

        var ncost = this._GameLeftDown.getChildByName("bg").getChildByName("COST_NUM");
        ncost.setString(GAME_NEW_INT_DATA.ATTACK_PRICE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);
    },

    moveGameLeftDown : function(){
        cc.log("moveGameLeftDown");
        if(this._moveaction == false){
            var self = this;
            this._moveaction = true;
            this._GameLeftDown.runAction(cc.sequence(cc.moveBy(0.8,cc.p(-20,0)),cc.moveBy(0.8,cc.p(20,0)),cc.callFunc(function(){
                self._moveaction = false;
            })));
        }
    },


    getLotteryType: function (type) {
        if (type ==1) {//红色区域，发送类型3
            return 3
        } else {
            let inum = FYMath.getRandom(0, 99);
            if (inum < GAME_NEW_INT_DATA.GAME1_REWARD_TYPE_RATE) {//发送类型1
                return 1
            } else {//发送类型2
                return 2
            }
        }
    },

    onGameEvent: function (event, param) {
        switch (event) {
            case GAME_NEW_EVENT.GAME_REMOVE_GUIDE : {
                this.moveCannonBtn();
            }
                break;
            case GAME_NEW_EVENT.SHOW_CANNOT_SHOOT : {
                this.showFireWindows(param);
            }
                break;
            case GAME_NEW_EVENT.END_SHOOT_EVENT : {
                this._GameProgress.endShoot();
            }
                break;
            case GAME_NEW_EVENT.SHOOT_BULLET : {//发射子弹时候，子弹里面挂上当前进度条的位置
                this.costMoney(GAME_NEW_INT_DATA.ATTACK_PRICE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);
                let pos = this._GameProgress.getArrowPosition();
                cc.log("----1type"+pos);
                let type = this.getLotteryType(pos);
                cc.log("----2type"+type);
                this._GameCannon.shootBullet(type, GAME_NEW_INT_DATA.ATTACK_PRICE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);
                this._GameProgress.showTip(type);
                this._GameProgress.endShootWithStay();
            }
                break;
            case GAME_NEW_EVENT.ON_HITBOSS_REWARD : {
                this.onReward(param);
            }
                break;
            case GAME_NEW_EVENT.UPDATE_PLAYER_INFO : {
                this.initGameLeftUp();
                this.initGameLeftDown();
            }
                break;
            case GAME_NEW_EVENT.CHANGE_CANNON_TYPE : {
                this.initGameLeftDown();
            }
                break;
            case GAME_NEW_EVENT.GAME_NEW_BUY_BOOM : {
                if (param.iResult == 0) {
                    FYEngine.AddCommToast("兑换成功");
                    this.initGameLeftDown();
                }
                var layer = this.getChildByName(GAME_NEW_WINDOWS.Game1ExchangeTimes);
                if (layer) {
                    if (param.iResult == 0) {
                        layer.removeFromParent(true);
                    } else {
                        layer.unschedule(layer.timeCount);
                        layer.removeGetLoading();
                        if(param.iResult == 2226){
                            FYEngine.AddCommToast("积分不足");
                        }else{
                            FYEngine.AddCommToast("兑换失败");
                        }
                    }
                }

            }
                break;
            case GAME_NEW_EVENT.GAME_NEW_SYLZ_LOTTERY : {
                this.onReward(param);
            }
                break;
            case GAME_NEW_EVENT.GAME1_SHOW_EX_TIME : {
                this.showBuyBoomLayer();
            }
                break;
            case GAME_NEW_EVENT.GAME1_SHOW_EX_CANNON : {
                this.exCannonType();
            }
                break;
            case FishGameEventID.unConnect: {
                this.onUnconnect(param);
            }
                break;
            case GAME_NEW_EVENT.GAME_NEW_LOGIN_OK:{
                this.reLoginOk();
            }break;
            case GAME_NEW_EVENT.GAME_RELOGIN_OK :{
                this.reLoginOk();
            }break;
            case GAME_NEW_EVENT.GAME_RELOGIN_FAIL :{
                if(param.iResult == 1101 || param.iResult==1204){
                    FishGlobal.copyReloginTag = true;
                    var coreserviceproxy = CoreServiceProxy.getInstance();
                    coreserviceproxy.unlinkGameClient();
                    appglobal.runFishNewScene();
                    this._handler = CoreServiceProxy.getInstance().getGameHandler();
                }
            }break;
            case GAME_NEW_EVENT.GAME_NEW_INFO_OK : {
                cc.log("获取玩家信息ok");
                this.initGameLeftUp();
                this.initGameLeftDown();
                if (param.iResult == 0) {
                    this.onUnconnect(2);
                }
            }
                break;

            default :
                break;
        }
    },

    reLoginOk : function(){
        this.clearBullet();
        this.sendGetPlayerInfo();
    },

    sendGetPlayerInfo : function(){
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle) {
            handle.sendGPlayerInfoReq();
        }
    },

    clearBullet : function(){
        for (var i = 0; i < this._BulletArr.length; ++i) {
            cc.pool.putInPool(this._BulletArr[i]);
        }
        this._BulletArr = [];
    },

    /**
     *
     * @param tag  1:都没有次数   2：当前次数为0
     */
    showFireWindows: function (tag) {
        if (tag == 1) {
            var layer = this.getChildByName(GAME_NEW_WINDOWS.Game1OnlyBuy);
            if (!layer) {
                layer = new Game1OnlyBuy();
                this.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.Game1OnlyBuy);
                FYEngine.popupLayerAnimate(layer.layerbg);
            }
        } else if (tag == 2) {
            var layer = this.getChildByName(GAME_NEW_WINDOWS.Game1ExchangeOrBuy);
            if (!layer) {
                layer = new Game1ExchangeOrBuy();
                this.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.Game1ExchangeOrBuy);
                FYEngine.popupLayerAnimate(layer.layerbg);
            }
        }
    },

    exCannonType: function () {
        this._GameCannon.exCannonType();
        this.moveGameLeftDown();
    },

    costMoney: function (gold) {
        GAME_NEW_INT_DATA.player.gold -= gold;
        GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] -= 1;
        this.onGameEvent(GAME_NEW_EVENT.UPDATE_PLAYER_INFO);
    },

    update: function (dt) {
        if (this._BulletArr.length == 0) {
            return;
        }

        for (var i = 0; i < this._BulletArr.length; ++i) {
            let distance = this._GameBoss.y - this._BulletArr[i].y;
            if(distance<=GAME_NEW_INT_DATA.GAME1_SHOOOT_DISTANCE){
                this.onHitBoss(this._BulletArr[i]);
            }
            // let distance = FYMath.getDistance(this._BulletArr[i].x, this._BulletArr[i].y, this._GameBoss.x, this._GameBoss.y);
            // if (distance <= GAME_NEW_INT_DATA.GAME1_SHOOOT_DISTANCE) {
            //     this.onHitBoss(this._BulletArr[i]);
            // }
        }
    },

    onHitBoss: function (bullet) {
        this.sendHitMsg(bullet._rate, bullet._attacktype);
        bullet.onHit(true);
        this._GameBoss.playBoom();
        cc.log("onHitBoss:"+this._BulletArr.length);
    },

    sendHitMsg: function (rate, type) {
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle && handle._canSendNormalMsg) {
            handle.sendSYLZLottery(rate, type);
        }
    },

    onReward: function (param) {//todo
        if (param.iResult == 0) {
            if (param.lAddGold > 0) {
                this.addGold(param.lAddGold);
            }
            if (param.lAddYubi > 0) {
                this.addFishCoin(param.lAddYubi);
            }
            // GAME_NEW_INT_DATA.player.gold += param.lAddGold;
            // GAME_NEW_INT_DATA.player.fishcoin += param.lAddYubi;
            this.initGameLeftUp();
        }
    },

    addGold: function (num) {
        let size = cc.winSize;
        let rand = FYMath.getRandom(-GAME_NEW_INT_DATA.REW_POS_RAND, GAME_NEW_INT_DATA.REW_POS_RAND);
        let startpos = cc.p(size.width / 2 + rand, size.height / 2 + Math.abs(rand));
        this.createCoins(1, 4, startpos, this._goldEndPos);

        var sp_gold = FYEngine.createNumSprite(num, FishSceneRes.Png.killgold);
        sp_gold.setPosition(cc.pAdd(startpos, cc.p(0, -30)));
        sp_gold.setVisible(true);
        sp_gold.setScale(0.5);
        this.addChild(sp_gold, FishZorder.eftlayer);
        sp_gold.runAction(this._goldAni.clone());
    },

    createCoins: function (type, count, bpos, epos) {

        if (count <= 4) {
            for (var i = 0; i < count; ++i) {
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20 * (i % 10), -20 * parseInt((i / 10)))));
                sp_coin.startToMoveFast(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        } else if (count <= 20) {
            for (var i = 0; i < count; ++i) {
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20 * (i % (count * 0.5)), -20 * parseInt((i / (count * 0.5))))));
                sp_coin.startToMoveFast(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        } else {
            for (var i = 0; i < count; ++i) {
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20 * (i % 10), -20 * parseInt((i / 10)))));
                sp_coin.startToMoveFast(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        }
    },

    addFishCoin: function (num) {
        let size = cc.winSize;
        let rand = FYMath.getRandom(-GAME_NEW_INT_DATA.REW_POS_RAND, GAME_NEW_INT_DATA.REW_POS_RAND);
        let startpos = cc.p(size.width / 2 + rand, size.height / 2 + Math.abs(rand));
        this.createTool(startpos, this._fishcoinEndPos, num);
    },

    createTool: function (startpos, endpos, iCoinCount) {
        cc.log("createTool");
        var sp_tool = FishCoinTool.create(iCoinCount);
        sp_tool.setPosition(startpos);
        sp_tool.startToMoveFast(startpos, endpos);
        this.addChild(sp_tool, FishZorder.eftlayer);
    },

    initRightMenu: function () {
        var self = this;
        var mfunc = function (sender) {
            self.btnClickCallBack(sender);
        };

        var automenu = new ccui.ImageView(FishSceneRes.Png.AutoMenuBg,ccui.Widget.PLIST_TEXTURE);
        if(automenu){
            this.addChild(automenu,10,'automenu');
            automenu.setScale9Enabled(true);
            automenu.setCapInsets(cc.rect(22,20,53,277));
            automenu.setContentSize(cc.size(97,317));
            automenu.setAnchorPoint(cc.p(0,0.5));
            automenu.setPosition(cc.p(this.width,this.height*0.5));

            var btnArrow = new ccui.ImageView(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
            if(btnArrow){
                automenu.addChild(btnArrow,1,'btnArrow');
                btnArrow.setTouchEnabled(true);
                btnArrow.setAnchorPoint(cc.p(0.5,0.5));
                btnArrow.setPosition(cc.p(automenu.width*(-0.1753),automenu.height*0.5));
                btnArrow.addClickEventListener(mfunc);
            }

            var btnBack = new ccui.Button(FishSceneRes.Png.btnBackNormal,FishSceneRes.Png.btnBackPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnBack){
                automenu.addChild(btnBack, 1, 'btnBack');
                btnBack.setAnchorPoint(cc.p(0.5,0.5));
                btnBack.setPosition(cc.p(automenu.width*0.5,automenu.height*0.81));
                btnBack.addClickEventListener(mfunc);
            }

            var btnSetting = new ccui.Button(FishSceneRes.Png.btnSettingNormal,FishSceneRes.Png.btnSettingPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnSetting){
                automenu.addChild(btnSetting, 1, 'btnSetting');
                btnSetting.setAnchorPoint(cc.p(0.5,0.5));
                btnSetting.setPosition(cc.p(automenu.width*0.5,automenu.height*0.5));
                btnSetting.addClickEventListener(mfunc);
            }

            var btnHelp = new ccui.Button(FishSceneRes.Png.btnHelpNormal,FishSceneRes.Png.btnHelpPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnHelp){
                automenu.addChild(btnHelp, 1, 'btnHelp');
                btnHelp.setAnchorPoint(cc.p(0.5,0.5));
                btnHelp.setPosition(cc.p(automenu.width*0.5,automenu.height*0.2));
                btnHelp.addClickEventListener(mfunc);
            }

        }
    },

    btnClickCallBack: function (sender) {
        let name = sender.getName();
        switch (name) {
            case 'btnArrow' : {
                var automenu = this.getChildByName('automenu');
                var moveout = new cc.MoveTo(0.2, cc.p(this.width, this.height / 2));
                var movein = new cc.MoveTo(0.2, cc.p(this.width-91, this.height / 2));

                if(FYMath.fixedNum(automenu.getPositionX(),0) == (this.width-91) ){

                    automenu.setEnabled(false);
                    var actionplay = new cc.Sequence(moveout, new cc.CallFunc(function(){
                        automenu.setEnabled(true);
                        sender.loadTexture(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
                    }));
                    automenu.runAction(actionplay);
                }else if(FYMath.fixedNum(automenu.getPositionX(),0) == this.width){

                    automenu.setEnabled(false);
                    var actionplay = new cc.Sequence(movein, new cc.CallFunc(function(){
                        automenu.setEnabled(true);
                        sender.loadTexture(FishSceneRes.Png.arrowbtn_out,ccui.Widget.PLIST_TEXTURE);
                    }));
                    automenu.runAction(actionplay);
                }
            }
                break;
            case 'btnBack' : {
                var mlayer = this.getChildByName('warmtiplayer');
                if (!mlayer) {
                    mlayer = new BackToLobby(2);
                    this.addChild(mlayer, FishZorder.poplayer, 'warmtiplayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }
                break;
            case 'btnSetting' : {
                var mlayer = this.getChildByName('gamesettinglayer');
                if (!mlayer) {
                    mlayer = new GameSettingLayer();
                    this.addChild(mlayer, FishZorder.poplayer, 'gamesettinglayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }


            }
                break;
            case 'btnHelp' : {
                var mlayer = this.getChildByName(GAME_NEW_WINDOWS.GAME1_HELP_LAYER);
                if (!mlayer) {
                    mlayer = new GAME1_HELP_LAYER();
                    this.addChild(mlayer, FishZorder.poplayer, GAME_NEW_WINDOWS.GAME1_HELP_LAYER);
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }
                break;
            case "BTN_ADD" : {
                this.showBuyBoomLayer();
            }
                break;
            default :
                break;
        }

    },

    showBuyBoomLayer: function () {
        if (GAME_NEW_INT_DATA.SWITCH_SHOOT == true) {
            return;
        }
        var layer = this.getChildByName(GAME_NEW_WINDOWS.Game1ExchangeTimes);
        if (!layer) {
            layer = new Game1ExchangeTimes();
            this.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.Game1ExchangeTimes);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    },

    exitGame: function () {
        cc.log('----------退出游戏1');
        this.stopAllActions();
        this.unscheduleAllCallbacks();

        this.clearBullet();
        FishGlobal.bInFishScene = false;

        var lobbyHandle = CoreServiceProxy.getInstance().getLobbyHandler();
        if (lobbyHandle && lobbyHandle._canSendNormalMsg) {
            lobbyHandle.sendBackToLobbyRequest();
        }

        FYEngine.runScene(GameNewLobby.createScene());
    },

    phoneKeyCallBack: function (keycode, target) {
        cc.log("--1");
        var scene = FYEngine.getRunningLayer(0);
        switch (keycode) {
            case cc.KEY.back : {
                if (scene.getChildByName(LobbySceneName.KickedByServer) || scene.getChildByName("loading2")
                    || scene.getChildByName("loadinglayer") || scene.getChildByName(FishSceneName.UnConnectDialog)
                    || scene.getChildByName(LobbySceneName.OverLoseLayer) || scene.getChildByName(GAME_NEW_WINDOWS.GAME1_GUIDE_LAYER)) {
                    return;
                }
                var otherlayer = scene.getChildByName(GAME_NEW_WINDOWS.Game1ExchangeTimes)
                    || scene.getChildByName(GAME_NEW_WINDOWS.Game1ExchangeOrBuy)
                    || scene.getChildByName(GAME_NEW_WINDOWS.Game1OnlyBuy)
                    || scene.getChildByName("gamesettinglayer")
                    || scene.getChildByName(GAME_NEW_WINDOWS.GAME1_HELP_LAYER);
                if (otherlayer) {
                    if (otherlayer.layerbg) {
                        FYEngine.popoutLayerAnimate(otherlayer.layerbg);
                    } else {
                        otherlayer.removeFromParent(true);
                    }
                } else {
                    var protectlauer = scene.getChildByName("warmtiplayer");
                    if(protectlauer){
                        FYEngine.popoutLayerAnimate(protectlauer.layerbg);
                    }else{
                        var layer = new BackToLobby(2);
                        if (layer) {
                            scene.addChild(layer, FishZorder.poplayer, "warmtiplayer");
                            FYEngine.popupLayerAnimate(layer.layerbg);
                        }
                    }
                }
            }
        }
    },

    gameOnShowEvent: function () {
        this.onGameEvent(FishGameEventID.unConnect,1);
        FishGlobal.copyReloginTag = true;
        var coreserviceproxy = CoreServiceProxy.getInstance();
        coreserviceproxy.unlinkGameClient();
        appglobal.runFishNewScene();
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        if (cc.sys.os == 'iOS') {
            this.initBackGroundMusic();
        }
    },

    testGameOnHide: function () {
        if (cc.sys.os == 'iOS') {
            cc.audioEngine.stopMusic();
        }
    },

    initBackGroundMusic: function (type) {
        cc.log('---------------------初始化音乐------');
        var vibtn = cc.sys.localStorage.getItem('isVibration');
        if (vibtn == null || vibtn == '0') {
            this._isVibrationSwitch = 0;
        } else {
            this._isVibrationSwitch = 1;
        }


        var bgmusic = cc.sys.localStorage.getItem('bgVolum');
        cc.log("-----fish---bgmusic====" + bgmusic);
        if (bgmusic == null) {
            FYEngine.Audio.setMusicVolume(1);
        } else {
            // FYEngine.Audio.setMusicVolume(Number(bgmusic));
            // cc.audioEngine.setMusicVolume(Number(bgmusic));
            FYEngine.Audio.setOpenMusic(Number(bgmusic))
        }

        var eftmusic = cc.sys.localStorage.getItem('eftVolum');
//        cc.log("fish---eftmusic===="+eftmusic);
        if (eftmusic == null) {
            FYEngine.Audio.setEffectVolume(1);
        } else {
            FYEngine.Audio.setEffectVolume(Number(eftmusic));
        }
        var t = FYMath.getRandom(1, 3);
        if (!type) {
            switch (t) {
                case 1 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg1,true);
                }break;
                case 2 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg2,true);
                }break;
                case 3 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg3,true);
                }break;
            }
        }
    },

    onUnconnect: function (type) {
        cc.log('----------------LobbyScene unconnectType :');
        var layer = this.getChildByName(FishSceneName.UnConnectDialog);
        cc.log("unconnecttype=====" + type);
        switch (type) {
            case 1: {

                if (!layer) {
                    layer = new unConnectLayer(0);
                    layer.refreshUI(type);
                    this.addChild(layer, FishZorder.poplayer + 100, FishSceneName.UnConnectDialog);
                    layer._reConnectCode = 0;
                    layer.code = 0;
                }
                cc.log("code====" + layer._reConnectCode);
                if (layer && layer._reConnectCode && layer._reConnectCode == 1) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    layer.refreshUI(3);
                }

                if (layer && layer._reConnectCode == 0 && layer.code == 0) {
                    layer.unschedule(layer.layerF);
                    layer.unschedule(layer.removeLayer);
                    layer.refreshUI(1);
                    layer.scheduleOnce(layer.layerF, 20.0);
                    layer.code = 1;
                }
            }
                break;
            case 2:
            case 3: {
                if (layer) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    if (layer && layer.layerF) {
                        layer.unschedule(layer.layerF);
                        layer.refreshUI(type);
                        layer.code = 0;
                    }
                    //this.unschedule(f);
                }
            }
                break;
            case 0: {
                if (layer) {
                    layer.removeFromParent();
                }
            }
                break;
        }
    },


});

GameNewGame1.createScene = function () {
    var scene = new cc.Scene();
    var layer = new GameNewGame1();
    scene.addChild(layer, 0, 0);
    scene.setName("GameNewGame1");
    return scene;
};
