var GameNewGame2 = cc.Layer.extend({

    _BulletArr: [],
    _FishArr: [],
    _BulletLayer: null,
    _goldEndPos: cc.p(0, 0),
    _fishcoinEndPos: cc.p(0, 0),
    _goldAni: null,
    _prepareTime: 3,
    _recountPicArr: [],
    _gameStart: false,
    _fishBornLeftPosMin: 0,
    _fishBornLeftPosMax: 0,
    _fishBornRightPosMin: 0,
    _fishBornRightPosMax: 0,
    _handler: null,
    _lobbyhandler: null,
    _gameEnd: false,
    ctor: function () {
        this._super();
        this.setName("GameNewGame2");
        this.initData();

    },

    onEnter: function () {
        this._super();
        this.initUI();

    },

    onExit: function () {
        this._super();
    },


    initData: function () {
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this._handler.setScene(this);
        this._lobbyhandler = CoreServiceProxy.getInstance().getLobbyHandler();
        var size = cc.winSize;
        GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE = 0;
        this._FishArr = [];
        this._BulletArr = [];
        this._BulletLayer = null;
        this._goldEndPos = cc.p(150, size.height - 35);
        this._fishcoinEndPos = cc.p(400, size.height - 35);
        this._goldAni = null;
        FishGlobal.bInFishScene = true;
        this._prepareTime = 3;
        this._recountPicArr = ["", "N_G_G_6.png", "N_G_G_4.png"];
        this._gameStart = false;
        this._fishBornLeftPosMin = 0;
        this._fishBornLeftPosMax = 300;
        this._fishBornRightPosMin = size.width - 300;
        this._fishBornRightPosMax = size.width;
        FishGlobal.isLobbyRecord = false;
        this._gameEnd = false;
    },


    initUI: function () {//todo 这边需要修改ui的层级以方便触摸
        var self = this;
        var size = cc.winSize;
        this.initAni();

        var bg = new cc.Sprite("NewGameRes/NewGameGameBg1.jpg");
        if (bg) {
            this.addChild(bg, 0, 'bg');
            bg.setPosition(size.width / 2, size.height / 2);
            bg.setScale(appglobal.getScale());
        }

        var GameLeftUp = this._GameLeftUp = fycommonfunc.ccsLoadNode("res/NewGameRes/GAME1_LEFTUP.csb");
        this.addChild(GameLeftUp, 10, 'GameLeftUp');
        GameLeftUp.setPosition(cc.p(0, size.height));
        this.initGameLeftUp();


        var GameCannon = this._GameCannon = new Game_New_Cannon();
        this.addChild(GameCannon, 10, "GameCannon");
        GameCannon.setPosition(cc.p(size.width / 2, 0));
        GameCannon.changeRate(GAME_NEW_INT_DATA.GAME2_CANNON_RATE[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX]);

        var GameBulletLayer = this._BulletLayer = new GameNewTouchLayer2();
        this.addChild(GameBulletLayer, 2, "GameBulletLayer");

        var GameRecountMode = this._GameRecountMode = fycommonfunc.ccsLoadNode("res/NewGameRes/GAME2_RECOUNT_MODE.csb");
        this.addChild(GameRecountMode, 10, "GameRecountMode");
        GameRecountMode.setPosition(cc.p(800, size.height-15));
        this._game_re_num = GameRecountMode.getChildByName("Text_1");
        this._game_re_num.setString(GAME_NEW_INT_DATA.roominfo.gamelefttime + "秒");

        this.initRightMenu();

        this.initPhoneBtnCallBack();

        this.initBackGroundMusic();

        this.initPrepareNumber();

        this.scheduleUpdate();
    },

    initPrepareNumber: function () {
        cc.log("GAME_NEW_INT_DATA.roominfo.gamestart:" + GAME_NEW_INT_DATA.roominfo.gamestart);
        if (GAME_NEW_INT_DATA.roominfo.gamestart == true) {//进来的时候假如游戏已经开始
            this.createFish();
            this.startRecount();
        } else {//进来的时候游戏还没开始
            if (GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW == true) {
                var layer = this.getChildByName(GAME_NEW_WINDOWS.GAME2_GUIDE_LAYER);
                if (!layer) {
                    layer = new GAME2_GUIDE_LAYER();
                    this.addChild(layer, FishZorder.poplayer + 1, GAME_NEW_WINDOWS.GAME2_GUIDE_LAYER);
                }
            } else {
                this.addPrepareNumber();
            }
        }
    },

    addPrepareNumber: function () {
        var number = this._re_number = new cc.Sprite("#N_G_G_5.png");
        this.addChild(number, 0, "sprite_recount");
        number.setPosition(cc.p(this.width / 2, this.height / 2));
        this.schedule(this.prepareTime, 1, 2);
    },

    prepareTime: function () {
        this._prepareTime -= 1;
        cc.log("------prepareTime：" + this._prepareTime);
        if (this._prepareTime > 0) {
            this._re_number.setSpriteFrame(this._recountPicArr[this._prepareTime]);
        } else {
            this.sendGameStart();
        }
    },

    sendGameStart: function () {
        let handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle && handle._canSendNormalMsg) {
            handle.sendJZSJStart();
        }
    },

    initPhoneBtnCallBack: function () {
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
        FYEngine.AddCustomLister(this, 'game_on_show', this.gameOnShowEvent);
        FYEngine.AddCustomLister(this, 'game_on_hide', this.testGameOnHide);
    },

    gameStart: function () {
        let sprite_recount = this.getChildByName("sprite_recount");
        if (sprite_recount) {
            sprite_recount.removeFromParent(true);
        }
        if (GAME_NEW_INT_DATA.roominfo.gamestart == false) {
            GAME_NEW_INT_DATA.roominfo.gamestart = true;
            this.createFish();
            this.startRecount();
        }
    },

    startRecount: function () {
        this.schedule(this.scheduleRecount, 1);
    },

    scheduleRecount: function () {
        GAME_NEW_INT_DATA.roominfo.gamelefttime -= 1;
        if (GAME_NEW_INT_DATA.roominfo.gamelefttime >= 0) {
            this._game_re_num.setString(GAME_NEW_INT_DATA.roominfo.gamelefttime + "秒");
        } else {
            if (this._gameEnd == false) {
                this._gameEnd = true;
                this.showGameEnd();
            }
        }
    },

    showGameEnd: function () {
        var mlayer = this.getChildByName(GAME_NEW_WINDOWS.Game2TimeOff);
        if (!mlayer) {
            mlayer = new Game2TimeOff();
            this.addChild(mlayer, FishZorder.poplayer + 9, GAME_NEW_WINDOWS.Game2TimeOff);
            FYEngine.popupLayerAnimate(mlayer.layerbg);
        }
    },

    createFish: function () {
        this.schedule(this.splashFish, 1);
    },

    splashFish: function () {
        if (this._gameEnd) {
            return;
        }
        let qty = FYMath.getRandom(GAME_NEW_INT_DATA.GAME2_FISH_RAND_NUM_MIN, GAME_NEW_INT_DATA.GAME2_FISH_RAND_NUM_MAX);
        for (var i = 0; i < qty; ++i) {
            let direction = FYMath.getRandom(0, 1);   //1左边，0右边

            let bornPos = cc.p(0, 0);
            if (direction == 0) {
                bornPos = cc.p(FYMath.getRandom(this._fishBornRightPosMin, this._fishBornRightPosMax), -50);
            } else {
                bornPos = cc.p(FYMath.getRandom(this._fishBornLeftPosMin, this._fishBornLeftPosMax), -50);
            }

            let rand_fishtyp = FYMath.getRandom(0, 99);
            let fish = null;
            if (rand_fishtyp < GAME_NEW_INT_DATA.GAME2_FISH_YELLOW_RATE[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX]) {//金币鱼
                fish = S_P_FISH.create(1, direction, bornPos);
            } else {//渔币鱼
                fish = S_P_FISH.create(2, direction, bornPos);
            }
            this.addChild(fish, 1);
            this._FishArr.push(fish);
        }
    },


    initAni: function () {
        var self = this;
        var movedown = new cc.MoveBy(0.3, cc.p(0, -60));
        this._goldAni = new cc.Sequence(new cc.MoveBy(0.2, cc.p(0, 20)), movedown.easing(cc.easeIn(3)),
            new cc.MoveBy(0.2, cc.p(0, 50)),
            new cc.Spawn(new cc.FadeTo(0.3, 50), new cc.MoveBy(0.3, cc.p(0, 60))), new cc.RemoveSelf());
        this._goldAni.retain();
    },

    initGameLeftUp: function () {
        let player = GAME_NEW_INT_DATA.player;
        var gold = this._GameLeftUp.getChildByName("LEFTUP").getChildByName("goldbg").getChildByName("num_gold");
        gold.setString(player.gold);

        var fishcoin = this._GameLeftUp.getChildByName("LEFTUP").getChildByName("fishcoinbg").getChildByName("num_fishcoin");
        fishcoin.setString(player.fishcoin);
    },


    onGameEvent: function (event, param) {
        switch (event) {
            case GAME_NEW_EVENT.GAME_REMOVE_GUIDE : {
                this.addPrepareNumber();
            }
                break;
            case GAME_NEW_EVENT.SHOW_CANNOT_SHOOT : {

            }
                break;
            case GAME_NEW_EVENT.END_SHOOT_EVENT : {

            }
                break;
            case GAME_NEW_EVENT.SHOOT_BULLET : {//发射子弹时候，先判断钱够不够
                if (this.costMoney(GAME_NEW_INT_DATA.GAME2_CANNON_RATE[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX])) {
                    this._GameCannon.shootBullet(1, GAME_NEW_INT_DATA.GAME2_CANNON_RATE[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX],GAME_NEW_INT_DATA.BULLET_SPEED_2);
                }
            }
                break;
            case GAME_NEW_EVENT.ON_HITBOSS_REWARD : {

            }
                break;
            case GAME_NEW_EVENT.UPDATE_PLAYER_INFO : {
                this.initGameLeftUp();
            }
                break;
            case GAME_NEW_EVENT.ADJUST_CANNON : {
                this._GameCannon.adjustCannonDirection(param);
            }
                break;
            case GAME_NEW_EVENT.JZSJ_GAME_START: {
                this.gameStart();
            }
                break;
            case GAME_NEW_EVENT.JZSJ_GAME_LOTTERY: {
                this.onReward(param);
            }
                break;
            case FishGameEventID.unConnect: {
                this.onUnconnect(param);
            }
                break;
            case GAME_NEW_EVENT.GAME_NEW_LOGIN_OK: {
                this.reLoginOk();
            }
                break;
            case GAME_NEW_EVENT.GAME_RELOGIN_OK : {
                this.reLoginOk();
            }
                break;
            case GAME_NEW_EVENT.GAME_RELOGIN_FAIL : {
                if (param.iResult == 1101 || param.iResult == 1204) {
                    FishGlobal.copyReloginTag = true;
                    var coreserviceproxy = CoreServiceProxy.getInstance();
                    coreserviceproxy.unlinkGameClient();
                    appglobal.runFishNewScene();
                    this._handler = CoreServiceProxy.getInstance().getGameHandler();
                }
            }
                break;
            case GAME_NEW_EVENT.GAME_NEW_INFO_OK : {
                cc.log("获取玩家信息ok");
                this.initGameLeftUp();
                if (param.iResult == 0) {
                    this.sendQueryGameStatus();
                }
            }
                break;
            case GAME_NEW_EVENT.JZSJ_GAME_STATUS : {
                if (param.iResult == 0) {
                    this.onUnconnect(2);
                    if (param.iGameStatus == 0) {//空闲状态，表示比赛时间已经结束
                        this._gameEnd = true;
                        this.showGameEnd();
                    } else if (param.iGameStatus == 1) { //游戏准备中

                        for (var i = 0; i < 3; ++i) {
                            if (GAME_NEW_INT_DATA.GAME2_CANNON_RATE[i] == param.iRate) {
                                GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = i;
                                break;
                            }
                        }
                        GAME_NEW_INT_DATA.roominfo.gamestart = false;
                        GAME_NEW_INT_DATA.roominfo.gamelefttime = GAME_NEW_INT_DATA.GAME2_TOTAL_PLAY_TIME[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX];

                        var layer = this.getChildByName(GAME_NEW_WINDOWS.GAME2_GUIDE_LAYER);
                        if (layer) {
                            return;
                        }

                        if (this._prepareTime > 0) {

                        } else {
                            this.sendGameStart();
                        }
                    } else {//游戏已经开始
                        for (var i = 0; i < 3; ++i) {
                            if (GAME_NEW_INT_DATA.GAME2_CANNON_RATE[i] == param.iRate) {
                                GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = i;
                                break;
                            }
                        }
                        GAME_NEW_INT_DATA.roominfo.gamestart = true;
                        GAME_NEW_INT_DATA.roominfo.gamelefttime = param.iLeftGameTime;

                    }
                }
            }
                break;
            default :
                break;
        }
    },

    sendQueryGameStatus: function () {
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle) {
            handle.sendJZSJGameStatus();
        }
    },

    reLoginOk: function () {
        this.clearBullet();
        this.sendGetPlayerInfo();
    },

    sendGetPlayerInfo: function () {
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle) {
            handle.sendGPlayerInfoReq();
        }
    },

    costMoney: function (gold) {
        if (GAME_NEW_INT_DATA.player.gold >= GAME_NEW_INT_DATA.GAME2_CANNON_RATE[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX]) {
            GAME_NEW_INT_DATA.player.gold -= gold;
            this.onGameEvent(GAME_NEW_EVENT.UPDATE_PLAYER_INFO);
            return true;
        } else {
            FYEngine.AddCommToast("金币不足");
            return false;
        }

    },

    update: function (dt) {
        if (this._BulletArr.length == 0 || this._FishArr.length == 0) {
            return;
        }
        for (var i = 0; i < this._BulletArr.length; ++i) {
            for (var j = 0; j < this._FishArr.length; ++j) {
                if (this._FishArr[j].canHit()) {
                    let distance = FYMath.getDistance(this._BulletArr[i].x, this._BulletArr[i].y, this._FishArr[j].x, this._FishArr[j].y);
                    if (distance <= GAME_NEW_INT_DATA.GAME2_SHOOOT_DISTANCE) {
                        this.onHitFish(this._BulletArr[i], this._FishArr[j]);
                        break;
                    }
                }
            }
        }
    },

    onHitFish: function (bullet, fish) {//这里需要透传鱼的位置
        cc.log(this._FishArr.length + "---1onHitFish" + this._BulletArr.length);
        this.sendHitMsg(fish._type, fish.getPosition());
        bullet.onHit();
        fish.playDead();
        cc.log(this._FishArr.length + "---2onHitFish" + this._BulletArr.length);

    },

    // addBullet : function(bullet){
    //     cc.log("addBullet"+bullet._id);
    //     this._BulletArr.push(bullet);
    // },
    //
    // removeBullet : function(bullet){
    //     cc.log("removeBullet"+bullet._id);
    //     this._BulletArr.remove(bullet)
    // },

    sendHitMsg: function (type, pos) {
        let posx = parseFloat(pos.x).toFixed(2);
        let posy = parseFloat(pos.y).toFixed(2);
        if (this._handler && this._handler._canSendNormalMsg) {
            this._handler.sendJZSJLottery(type, posx, posy);
        }

    },

    onReward: function (param) {//todo
        if (param.iResult == 0) {
            if (param.lAddGold > 0) {
                this.addGold(param.lAddGold, param.fx, param.fy);
            }
            if (param.lAddYubi > 0) {
                this.addFishCoin(param.lAddYubi, param.fx, param.fy);
            }
            GAME_NEW_INT_DATA.player.gold += param.lAddGold;
            GAME_NEW_INT_DATA.player.fishcoin += param.lAddYubi;
            this.initGameLeftUp();
        }
    },

    addGold: function (num, fx, fy) {
        let startpos = cc.p(fx, fy);
        this.createCoins(1, 3, startpos, this._goldEndPos);

        var sp_gold = FYEngine.createNumSprite(num, FishSceneRes.Png.killgold);
        sp_gold.setPosition(cc.pAdd(startpos, cc.p(0, -30)));
        sp_gold.setVisible(true);
        sp_gold.setScale(0.5);
        this.addChild(sp_gold, FishZorder.eftlayer);
        sp_gold.runAction(this._goldAni.clone());
    },

    createCoins: function (type, count, bpos, epos) {

        if (count <= 4) {
            for (var i = 0; i < count; ++i) {
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20 * (i % 10), -20 * parseInt((i / 10)))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        } else if (count <= 20) {
            for (var i = 0; i < count; ++i) {
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20 * (i % (count * 0.5)), -20 * parseInt((i / (count * 0.5))))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        } else {
            for (var i = 0; i < count; ++i) {
                var sp_coin = GoldProps.create(type);
                sp_coin.setPosition(cc.pAdd(bpos, cc.p(20 * (i % 10), -20 * parseInt((i / 10)))));
                sp_coin.startTomove(bpos, epos, i);
                this.addChild(sp_coin, FishZorder.eftlayer);
            }
        }
    },

    addFishCoin: function (num, fx, fy) {
        let startpos = cc.p(fx, fy);
        this.createTool(startpos, this._fishcoinEndPos, num);
    },

    createTool: function (startpos, endpos, iCoinCount) {
        cc.log("createTool");
        var sp_tool = FishCoinTool.create(iCoinCount);
        sp_tool.setPosition(startpos);
        sp_tool.startTomove(startpos, endpos);
        this.addChild(sp_tool, FishZorder.eftlayer+1);
    },

    initRightMenu: function () {
        var self = this;
        var mfunc = function (sender) {
            self.btnClickCallBack(sender);
        };

        var automenu = new ccui.ImageView(FishSceneRes.Png.AutoMenuBg,ccui.Widget.PLIST_TEXTURE);
        if(automenu){
            this.addChild(automenu,10,'automenu');
            automenu.setScale9Enabled(true);
            // automenu.setCapInsets(cc.rect(22,20,53,277));
            automenu.setContentSize(cc.size(97,270));
            automenu.setAnchorPoint(cc.p(0,0.5));
            automenu.setPosition(cc.p(this.width,this.height*0.5));

            var btnArrow = new ccui.ImageView(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
            if(btnArrow){
                automenu.addChild(btnArrow,1,'btnArrow');
                btnArrow.setTouchEnabled(true);
                btnArrow.setAnchorPoint(cc.p(0.5,0.5));
                btnArrow.setPosition(cc.p(automenu.width*(-0.1753),automenu.height*0.5));
                btnArrow.addClickEventListener(mfunc);
            }

            var btnBack = new ccui.Button(FishSceneRes.Png.btnBackNormal,FishSceneRes.Png.btnBackPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnBack){
                automenu.addChild(btnBack, 1, 'btnBack');
                btnBack.setAnchorPoint(cc.p(0.5,0.5));
                btnBack.setPosition(cc.p(automenu.width*0.5,automenu.height*0.7));
                btnBack.addClickEventListener(mfunc);
            }

            var btnSetting = new ccui.Button(FishSceneRes.Png.btnSettingNormal,FishSceneRes.Png.btnSettingPressed,'',ccui.Widget.PLIST_TEXTURE);
            if(btnSetting){
                automenu.addChild(btnSetting, 1, 'btnSetting');
                btnSetting.setAnchorPoint(cc.p(0.5,0.5));
                btnSetting.setPosition(cc.p(automenu.width*0.5,automenu.height*0.27));
                btnSetting.addClickEventListener(mfunc);
            }
        }
    },

    btnClickCallBack: function (sender) {
        let name = sender.getName();
        switch (name) {
            case 'btnArrow' : {
                var automenu = this.getChildByName('automenu');
                var moveout = new cc.MoveTo(0.2, cc.p(this.width, this.height / 2));
                var movein = new cc.MoveTo(0.2, cc.p(this.width-91, this.height / 2));

                if(FYMath.fixedNum(automenu.getPositionX(),0) == (this.width-91) ){

                    automenu.setEnabled(false);
                    var actionplay = new cc.Sequence(moveout, new cc.CallFunc(function(){
                        automenu.setEnabled(true);
                        sender.loadTexture(FishSceneRes.Png.arrowbtn_in,ccui.Widget.PLIST_TEXTURE);
                    }));
                    automenu.runAction(actionplay);
                }else if(FYMath.fixedNum(automenu.getPositionX(),0) == this.width){

                    automenu.setEnabled(false);
                    var actionplay = new cc.Sequence(movein, new cc.CallFunc(function(){
                        automenu.setEnabled(true);
                        sender.loadTexture(FishSceneRes.Png.arrowbtn_out,ccui.Widget.PLIST_TEXTURE);
                    }));
                    automenu.runAction(actionplay);
                }
            }
                break;
            case 'btnBack' : {
                var mlayer = this.getChildByName('warmtiplayer');
                if (!mlayer) {
                    mlayer = new BackToLobby(2);
                    this.addChild(mlayer, FishZorder.poplayer, 'warmtiplayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }
                break;
            case 'btnSetting' : {
                var mlayer = this.getChildByName('gamesettinglayer');
                if (!mlayer) {
                    mlayer = new GameSettingLayer();
                    this.addChild(mlayer, FishZorder.poplayer, 'gamesettinglayer');
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }
                break;
            case 'btnHelp' : {

            }
                break;
        }

    },

    exitGame: function () {
        cc.log('----------退出游戏2');
        this.stopAllActions();
        this.unscheduleAllCallbacks();

        this.clearBullet();
        this.clearFish();

        FishGlobal.bInFishScene = false;

        var lobbyHandle = CoreServiceProxy.getInstance().getLobbyHandler();
        if (lobbyHandle && lobbyHandle._canSendNormalMsg) {
            lobbyHandle.sendBackToLobbyRequest();
        }

        FYEngine.runScene(GameNewLobby.createScene());
    },

    phoneKeyCallBack: function (keycode, target) {
        cc.log("--1");
        var scene = FYEngine.getRunningLayer(0);
        switch (keycode) {
            case cc.KEY.back : {
                if (scene.getChildByName(LobbySceneName.KickedByServer) || scene.getChildByName("loading2")
                    || scene.getChildByName("loadinglayer") || scene.getChildByName(FishSceneName.UnConnectDialog)
                    || scene.getChildByName(LobbySceneName.OverLoseLayer) || scene.getChildByName(GAME_NEW_WINDOWS.GAME2_GUIDE_LAYER)
                    || scene.getChildByName(GAME_NEW_WINDOWS.Game2TimeOff)) {
                    return;
                }
                var otherlayer = scene.getChildByName(GAME_NEW_WINDOWS.Game1ExchangeTimes)
                    || scene.getChildByName(GAME_NEW_WINDOWS.Game1ExchangeOrBuy)
                    || scene.getChildByName(GAME_NEW_WINDOWS.Game1OnlyBuy)
                    || scene.getChildByName("gamesettinglayer")
                    || scene.getChildByName(GAME_NEW_WINDOWS.GAME1_HELP_LAYER);
                if (otherlayer) {
                    if (otherlayer.layerbg) {
                        FYEngine.popoutLayerAnimate(otherlayer.layerbg);
                    } else {
                        otherlayer.removeFromParent(true);
                    }
                } else {
                    var protectlauer = scene.getChildByName("warmtiplayer");
                    if(protectlauer){
                        FYEngine.popoutLayerAnimate(protectlauer.layerbg);
                    }else{
                        var layer = new BackToLobby(2);
                        if (layer) {
                            scene.addChild(layer, FishZorder.poplayer, "warmtiplayer");
                            FYEngine.popupLayerAnimate(layer.layerbg);
                        }
                    }
                }
            }
        }
    },

    gameOnShowEvent: function () {
        this.onGameEvent(FishGameEventID.unConnect,1);
        FishGlobal.copyReloginTag = true;
        var coreserviceproxy = CoreServiceProxy.getInstance();
        coreserviceproxy.unlinkGameClient();
        appglobal.runFishNewScene();
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        if (cc.sys.os == 'iOS') {
            this.initBackGroundMusic();
        }
    },

    testGameOnHide: function () {
        if (cc.sys.os == 'iOS') {
            cc.audioEngine.stopMusic();
        }
    },

    initBackGroundMusic: function (type) {
        cc.log('---------------------初始化音乐------');
        var vibtn = cc.sys.localStorage.getItem('isVibration');
        if (vibtn == null || vibtn == '0') {
            this._isVibrationSwitch = 0;
        } else {
            this._isVibrationSwitch = 1;
        }


        var bgmusic = cc.sys.localStorage.getItem('bgVolum');
        cc.log("-----fish---bgmusic====" + bgmusic);
        if (bgmusic == null) {
            FYEngine.Audio.setMusicVolume(1);
        } else {
            // FYEngine.Audio.setMusicVolume(Number(bgmusic));
            // cc.audioEngine.setMusicVolume(Number(bgmusic));
            FYEngine.Audio.setOpenMusic(Number(bgmusic))
        }

        var eftmusic = cc.sys.localStorage.getItem('eftVolum');
//        cc.log("fish---eftmusic===="+eftmusic);
        if (eftmusic == null) {
            FYEngine.Audio.setEffectVolume(1);
        } else {
            FYEngine.Audio.setEffectVolume(Number(eftmusic));
        }
        var t = FYMath.getRandom(1, 3);
        if (!type) {
            switch (t) {
                case 1 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg1,true);
                }break;
                case 2 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg2,true);
                }break;
                case 3 : {
                    FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.FishScene_bg3,true);
                }break;
            }
        }
    },

    clearFish: function () {
        for (var i = 0; i < this._FishArr.length; ++i) {
            cc.pool.putInPool(this._FishArr[i]);
        }
        this._FishArr = [];
    },

    clearBullet: function () {
        for (var i = 0; i < this._BulletArr.length; ++i) {
            cc.pool.putInPool(this._BulletArr[i]);
        }
        this._BulletArr = [];
    },

    onUnconnect: function (type) {
        cc.log('----------------LobbyScene unconnectType :');
        var layer = this.getChildByName(FishSceneName.UnConnectDialog);
        cc.log("unconnecttype=====" + type);
        switch (type) {
            case 1: {

                if (!layer) {
                    layer = new unConnectLayer(0);
                    layer.refreshUI(type);
                    this.addChild(layer, FishZorder.poplayer + 100, FishSceneName.UnConnectDialog);
                    layer._reConnectCode = 0;
                    layer.code = 0;
                }
                cc.log("code====" + layer._reConnectCode);
                if (layer && layer._reConnectCode && layer._reConnectCode == 1) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    layer.refreshUI(3);
                }

                if (layer && layer._reConnectCode == 0 && layer.code == 0) {
                    layer.unschedule(layer.layerF);
                    layer.unschedule(layer.removeLayer);
                    layer.refreshUI(1);
                    layer.scheduleOnce(layer.layerF, 20.0);
                    layer.code = 1;
                }
            }
                break;
            case 2:
            case 3: {
                if (layer) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    if (layer && layer.layerF) {
                        layer.unschedule(layer.layerF);
                        layer.refreshUI(type);
                        layer.code = 0;
                    }
                    //this.unschedule(f);
                }
            }
                break;
            case 0: {
                if (layer) {
                    layer.removeFromParent();
                }
            }
                break;
        }
    },


});

GameNewGame2.createScene = function () {
    var scene = new cc.Scene();
    var layer = new GameNewGame2();
    scene.addChild(layer, 0, 0);
    scene.setName("GameNewGame2");
    return scene;
};
