var GameNewLobby = cc.Layer.extend({
    _handler: null,
    ctor: function () {
        this._super();
        this.setName("GameNewLobby");
        this._handler = CoreServiceProxy.getInstance().getLobbyHandler();
        var coreserviceproxy = CoreServiceProxy.getInstance();
        coreserviceproxy.unlinkGameClient();
    },

    onEnter: function () {
        this._super();
        this.initData();
        this.initUI();
    },

    initData: function () {
        GAME_NEW_INT_DATA.GAME_TYPE = -1;
    },

    initUI: function () {
        var self = this;
        let size = cc.winSize;

        var mainscene = this.mainbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_N_G_HALL.csb");
        this.mainbg.setPosition(cc.p(this.width * 0.5, this.height * 0.5));
        this.addChild(mainscene, 0, 'mainscene');

        this.bg = mainscene.getChildByName("BG");
        this.bg.setScale(appglobal.getScale());

        var LeftUp = this._LeftUp = mainscene.getChildByName("LEFTUP");
        LeftUp.setPosition(cc.p(-size.width * 0.5, size.height * 0.5+5));

        this.initLeftUp(true);
        this.initLeftCenter(true);
        this.initRightCenter();

        this.initPhoneBtnCallBack();
        this.loadMusic();
        this.sendOriginMsg();
        this.checkGuideRecord();
        this.checkHasUnfinishedGame();
    },

    checkGuideRecord: function () {
        var Game_New_Guide = cc.sys.localStorage.getItem('Game_New_Guide' + appglobal.getPlayer().userid);
        if (Game_New_Guide) {
            // cc.sys.localStorage.removeItem('Game_New_Guide' + appglobal.getPlayer().userid);
            // return;
            let sp = eval('(' + Game_New_Guide + ')');
            FYEngine.logObject(sp, "-------checkGuideRecord:");
            var date = Date.parse(new Date());
            GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW = sp.GAME1_GUIDE_SHOW;
            GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW = sp.GAME2_GUIDE_SHOW;
            GAME_NEW_INT_DATA.GAME1_GUIDE_LAST_TIME = sp.GAME1_GUIDE_LAST_TIME;
            GAME_NEW_INT_DATA.GAME2_GUIDE_LAST_TIME = sp.GAME2_GUIDE_LAST_TIME;

            if (GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW == false) {
                if (date - GAME_NEW_INT_DATA.GAME1_GUIDE_LAST_TIME > (1000 * 60 * 60 * 24 * 7)) {
                    GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW = true;
                }
            }

            if (GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW == false) {
                if (date - GAME_NEW_INT_DATA.GAME2_GUIDE_LAST_TIME > (1000 * 60 * 60 * 24 * 7)) {
                    GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW = true;
                }
            }
        } else {
            GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW = true;
            GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW = true;
        }
    },

    checkHasUnfinishedGame: function () {
        if (FishGlobal.isLobbyRecord == true) {
            this.enterGame();
        }
    },

    sendOriginMsg: function () {
        if (this._handler && this._handler._canSendNormalMsg) {
            this._handler.sendUpdateWealthReq();
            this._handler.sendFUBEN2_COIN_GET();
            this._handler.sendFUBEN2_JZSJ_CFG();
            this._handler.sendFUBEN2_SYLZ_CFG();
        }
    },

    initPhoneBtnCallBack: function () {
        FYEngine.AddListenPhoneKey(this, this.phoneKeyCallBack);
        FYEngine.AddCustomLister(this, 'game_on_show', this.gameOnShowEvent);
        FYEngine.AddCustomLister(this, 'game_on_hide', this.testGameOnHide);

    },

    loadMusic: function () {
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        for (var i = 0; i < arr.length; i++) {
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (!temp) {
                cc.sys.localStorage.setItem(arr[i], i == 2 ? 0 : 1);
            }
        }

        FYEngine.Audio.stopAll();
        if (cc.sys.localStorage.getItem("bgVolum") == 1) {
            FYEngine.Audio.setOpenMusic(true);
            FYEngine.Audio.playMusicSingle(FishSceneRes.preloadAudioName.music.Lobby_bg, true);
        }
    },

    /**
     * 初始化和刷新玩家的财富
     * @param tag   true时则是初始化，否则为刷新财富
     */
    initLeftUp: function (tag) {
        var self = this;
        if (tag) {
            var btnback = this._LeftUp.getChildByName("backtolobby");
            btnback.addTouchEventListener(this.btnTouchEft, this);
            btnback.addClickEventListener(function (sender) {
                self.btnClickCallBack(sender);
            });
        }

        let player = appglobal.getPlayer();
        var gold = this._LeftUp.getChildByName("goldbg").getChildByName("num_gold");
        gold.setString(player.gold);

        var fishcoin = this._LeftUp.getChildByName("fishcoinbg").getChildByName("num_fishcoin");
        fishcoin.setString(player.fishcoin);
    },

    initLeftCenter: function (tag) {
        var self = this;
        this._LeftCenter = this.mainbg.getChildByName("LEFTCENTER");
        if (tag) {
            for (var i = 0; i < 3; ++i) {
                let btn = this._LeftCenter.getChildByName("BTN" + i);
                btn.addTouchEventListener(this.btnTouchEft, this);
                btn.addClickEventListener((sender) => {
                    self.btnClickCallBack(sender);
                });
            }
        }

        let player = appglobal.getPlayer();
        var box = this._LeftCenter.getChildByName("NUM_BOXBG").getChildByName("NUM_BOX");
        box.setString("我的宝箱：{0}个".format(player.fishbox));
    },

    initRightCenter: function () {
        var self = this;
        this._RightCenter = this.mainbg.getChildByName("RIGHTCENTER");

        for (var i = 0; i < 2; ++i) {
            let btn = this._RightCenter.getChildByName("BTN_GAME" + i);
            btn.addTouchEventListener(this.btnTouchEft, this);
            btn.addClickEventListener((sender) => {
                self.btnClickCallBack(sender);
            });
        }
    },

    /**
     * 按键点击事件
     * @param sender
     */
    btnClickCallBack: function (sender) {
        let name = sender.getName();
        switch (name) {
            case "backtolobby":{
                var layer = new ExitCopy(1);
                if(layer){
                    this.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.ExitCopy);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }break;
            case "BTN0" : {
                var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewEnterExnNumber);
                if (!layer) {
                    layer = new GameNewEnterExnNumber(1);
                    this.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.GameNewEnterExnNumber);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
            case "BTN1" : {
                var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewEnterExnNumber);
                if (!layer) {
                    layer = new GameNewEnterExnNumber(2);
                    this.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.GameNewEnterExnNumber);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
            case "BTN2": {
                var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewFishBox);
                if (!layer) {
                    layer = new GameNewFishBox();
                    this.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.GameNewFishBox);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
            case "BTN_GAME0": {
                if(GAME_NEW_INT_DATA._SYLZ_CFG_OK == false){
                    this.noConfig();
                    return;
                }
                if (GAME_NEW_INT_DATA.GAME_TYPE == -1) {
                    GAME_NEW_INT_DATA.GAME_TYPE = 0;
                    this.enterGame(0);
                }
            }
                break;
            case "BTN_GAME1": {
                if(GAME_NEW_INT_DATA._JZSJ_CFG_OK == false){
                    this.noConfig();
                    return;
                }
                if (GAME_NEW_INT_DATA.GAME_TYPE == -1) {
                    GAME_NEW_INT_DATA.GAME_TYPE = 1;
                    var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewChoosGame);
                    if (!layer) {
                        layer = new GameNewChoosGame();
                        this.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.GameNewChoosGame);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                }
            }
                break;
            default:
                break;
        }
    },

    noConfig : function(){
        this.sendOriginMsg();
        this.createLoading();
        this.scheduleOnce(this.joinTableCheck, 15);
    },

    enterGame: function (tag) {
        FishGlobal.roomId = 6;
        this.createLoading();
        this.sendMsg();
        this.scheduleOnce(this.joinTableCheck, 15);
    },

    sendMsg: function () {
        if (this._handler && this._handler._canSendNormalMsg) {
            this._handler.sendGameInfoReq(6);
        }
    },

    createLoading: function () {
        cc.log("createLoading");
        var layer = this.getChildByName('loadinglayer');
        if (!layer) {
            layer = FYEngine.createLoadingLayer(UsedResName.HallLoadingquan, UsedResName.HallLoadingfish);
            this.addChild(layer, FishZorder.poplayer + 1, 'loadinglayer');
        }
    },

    removeLoading: function () {
        cc.log("removeLoading");
        var layer = this.getChildByName("loadinglayer");
        if (layer) {
            layer.removeFromParent(true);
        }
    },

    joinTableCheck: function () {
        GAME_NEW_INT_DATA.GAME_TYPE = -1;
        GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = -1;
        this.removeLoading();
        var str = "加入房间超时，请稍后再试";
        FYEngine.AddCommToast(str);
        var coreserviceproxy = CoreServiceProxy.getInstance();
        coreserviceproxy.unlinkGameClient();
        this.checkHasUnfinishedGame();
    },

    onGameEvent: function (event, event_param) {
        switch (event) {
            case lobbyGameEvent.refreshWealth: {
//                cc.log('----刷新大厅财富');
                this.initLeftUp();
                this.initLeftCenter();

                var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewFishBox);
                if (layer && layer.updateWealth) {
                    layer.updateWealth();
                }
            }
                break;
            case FishGameEventID.unConnect: {
                this.onUnconnect(event_param);
            }
                break;
            case GAME_NEW_EVENT.GAME_NEW_LOGIN_OK : {
                var handle = CoreServiceProxy.getInstance().getGameHandler();
                if (handle) {
                    handle.sendGPlayerInfoReq();
                }
            }
                break;
            // case GAME_NEW_EVENT.QUERRY_GAME_ACC : {
            //
            // }
            //     break;
            case GAME_NEW_EVENT.GAME_NEW_INFO_OK : {
                this.initLeftUp();//刷新一下渔币
                if (event_param.iResult == 0) {
                    this.sendQueryGameStatus();
                }
            }
                break;
            case GAME_NEW_EVENT.CLICK_GAME2 : {
                this.enterGame();
            }
                break;
            case GAME_NEW_EVENT.JZSJ_CREATE_ROOM : {

                if (event_param.iResult == 0) {

                    for (var i = 0; i < 3; ++i) {
                        if (GAME_NEW_INT_DATA.GAME2_CANNON_RATE[i] == event_param.iRate) {
                            GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = i;
                            break;
                        }
                    }
                    GAME_NEW_INT_DATA.roominfo.gamestart = false;
                    //GAME_NEW_INT_DATA.roominfo.gamelefttime = 30;
                    FYEngine.runScene(GameNewGame2.createScene());
                } else {

                    if (event_param.iResult == 1206) {
                        this.sendQueryGameStatus();
                    } else if (event_param.iResult == 2901) {
                        FYEngine.AddCommToast("次数不足");
                        GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = -1;
                        this.removeLoading();
                        this.unschedule(this.joinTableCheck);
                        var coreserviceproxy = CoreServiceProxy.getInstance();
                        coreserviceproxy.unlinkGameClient();
                    } else {
                        GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = -1;
                        // FYEngine.AddCommToast("进入游戏失败" + event_param.iResult);
                        this.removeLoading();
                        this.unschedule(this.joinTableCheck);
                        var coreserviceproxy = CoreServiceProxy.getInstance();
                        coreserviceproxy.unlinkGameClient();
                        FYEngine.AddCommToast("进入游戏失败");
                    }
                }
            }
                break;
            case GAME_NEW_EVENT.FUBEN2_OPENBOX_CFG : {
                var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewFishBox);
                if (layer) {
                    if (event_param.iResult == 0) {
                        layer.getBoxConfigOK(event_param);
                    } else {
                        layer.getBoxConfigFail();
                    }
                }
            }
                break;
            case GAME_NEW_EVENT.FUBEN2_BUY_BOX_CFG : {
                var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewEnterExnNumber);
                if (layer) {
                    layer.removeFromParent(true);
                }
                if (event_param.iResult == 0) {
                    FYEngine.AddCommToast("兑换成功");
                } else {
                    FYEngine.AddCommToast("兑换失败");//todo 这边处理错误码
                }
            }
                break;
            case GAME_NEW_EVENT.FUBEN2_OPEN_BOX : {
                var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewOpenBox);
                if (layer) {
                    layer.removeFromParent(true);
                }
                if (event_param.iResult == 0) {
                    this.showOpenBoxResultLayer(event_param);
                } else {
                    if (event_param.iResult == -42) {
                        FYEngine.AddCommToast("宝箱数量不足");
                        if (this._handler && this._handler._canSendNormalMsg) {
                            this._handler.sendFUBEN2_COIN_GET();
                        }
                    } else {
                        FYEngine.AddCommToast("开启宝箱失败");//todo 这边处理错误码
                    }

                }
            }
                break;
            case GAME_NEW_EVENT.UPDATE_SYLZ_CFG : {

            }
                break;
            case GAME_NEW_EVENT.UPDATE_JZSJ_CFG : {
                this.updateJZSJConf();
            }
                break;
            case GAME_NEW_EVENT.JZSJ_GAME_STATUS : {
                if (event_param.iResult == 0) {
                    if (event_param.iGameStatus == 0) {//空闲按照按钮去区分
                        FishGlobal.isLobbyRecord = false;
                        if (GAME_NEW_INT_DATA.GAME_TYPE == 0) {
                            FYEngine.runScene(GameNewGame1.createScene());
                        } else if (GAME_NEW_INT_DATA.GAME_TYPE == 1) {
                            this.sendCreateRoom();
                        } else {
                            FYEngine.AddCommToast("游戏已结束");
                        }
                    } else if (event_param.iGameStatus == 1) { //游戏准备中
                        for (var i = 0; i < 3; ++i) {
                            if (GAME_NEW_INT_DATA.GAME2_CANNON_RATE[i] == event_param.iRate) {
                                GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = i;
                                break;
                            }
                        }
                        GAME_NEW_INT_DATA.roominfo.gamestart = false;
                        GAME_NEW_INT_DATA.roominfo.gamelefttime = GAME_NEW_INT_DATA.GAME2_TOTAL_PLAY_TIME[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX];
                        FYEngine.runScene(GameNewGame2.createScene());
                    } else {//游戏已经开始
                        for (var i = 0; i < 3; ++i) {
                            if (GAME_NEW_INT_DATA.GAME2_CANNON_RATE[i] == event_param.iRate) {
                                GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = i;
                                break;
                            }
                        }
                        GAME_NEW_INT_DATA.roominfo.gamestart = true;
                        GAME_NEW_INT_DATA.roominfo.gamelefttime = event_param.iLeftGameTime;
                        FYEngine.runScene(GameNewGame2.createScene());
                    }
                }
            }
                break;
            default:
                break;
        }
    },

    updateJZSJConf: function () {
        var layer = this.getChildByName(GAME_NEW_WINDOWS.GameNewChoosGame);
        if (layer && layer.updateJZSJConf) {
            layer.updateJZSJConf();
        }
    },

    showOpenBoxResultLayer: function (event_param) {
        var layer = this.getChildByName(GAME_NEW_WINDOWS.GAME_NEW_OPEN_BOX_RESULT);
        if (!layer) {
            layer = new GAME_NEW_OPEN_BOX_RESULT(event_param);
            this.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.GAME_NEW_OPEN_BOX_RESULT);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    },

    sendCreateRoom: function () {
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle) {
            handle.sendJZSJCreate(GAME_NEW_INT_DATA.GAME2_CANNON_RATE[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX]);
        }
    },

    sendQueryGameStatus: function () {
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle) {
            handle.sendJZSJGameStatus();
        }
    },

    onUnconnect: function (type) {
        cc.log('----------------LobbyScene unconnectType :');
        var layer = this.getChildByName(FishSceneName.UnConnectDialog);
        cc.log("unconnecttype=====" + type);
        switch (type) {
            case 1: {

                if (!layer) {
                    layer = new unConnectLayer(0);
                    layer.refreshUI(type);
                    this.addChild(layer, FishZorder.poplayer + 100, FishSceneName.UnConnectDialog);
                    layer._reConnectCode = 0;
                    layer.code = 0;
                }
                cc.log("code====" + layer._reConnectCode);
                if (layer && layer._reConnectCode && layer._reConnectCode == 1) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    layer.refreshUI(3);
                }

                if (layer && layer._reConnectCode == 0 && layer.code == 0) {
                    layer.unschedule(layer.layerF);
                    layer.unschedule(layer.removeLayer);
                    layer.refreshUI(1);
                    layer.scheduleOnce(layer.layerF, 20.0);
                    layer.code = 1;
                }
            }
                break;
            case 2:
            case 3: {
                if (layer) {
                    if (layer._type && layer._type == 3) {
                        return;
                    }
                    if (layer && layer.layerF) {
                        layer.unschedule(layer.layerF);
                        layer.refreshUI(type);
                        layer.code = 0;
                    }
                    //this.unschedule(f);
                }
            }
                break;
            case 0: {
                if (layer) {
                    layer.removeFromParent();
                }
            }
                break;
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    phoneKeyCallBack: function (keycode, target) {
        cc.log("--1");
        var scene = FYEngine.getRunningLayer(0);
        switch (keycode) {
            case cc.KEY.back : {
                if (scene.getChildByName(LobbySceneName.KickedByServer) || scene.getChildByName("loading2")
                    || scene.getChildByName("loadinglayer") || scene.getChildByName(FishSceneName.UnConnectDialog)
                    || scene.getChildByName(LobbySceneName.OverLoseLayer)) {
                    return;
                }
                var otherlayer = scene.getChildByName(GAME_NEW_WINDOWS.GameNewEnterExnNumber)
                    || scene.getChildByName(GAME_NEW_WINDOWS.GAME_NEW_OPEN_BOX_RESULT)
                    || scene.getChildByName(GAME_NEW_WINDOWS.GAME2_HELP_LAYER)
                    || scene.getChildByName(GAME_NEW_WINDOWS.GameNewOpenBox)
                    || scene.getChildByName(GAME_NEW_WINDOWS.GameNewFishBox)
                    || scene.getChildByName(GAME_NEW_WINDOWS.Game2EnterTip1)
                    || scene.getChildByName(GAME_NEW_WINDOWS.GameNewChoosGame)
                    || scene.getChildByName(FishCopyLobbyLayer.ExitCopy);
                if (otherlayer) {
                    if (otherlayer.layerbg) {
                        FYEngine.popoutLayerAnimate(otherlayer.layerbg);
                    } else {
                        otherlayer.removeFromParent(true);
                    }
                } else {
                    var layer = new ExitCopy(1);
                    if(layer){
                        scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.ExitCopy);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                }
            }
        }
    },

    gameOnShowEvent: function () {
        if (cc.sys.os != 'iOS') {
            var layer = FYEngine.getRunningLayer(0);

            var lobby_handler = CoreServiceProxy.getInstance().getLobbyHandler();
            if (!lobby_handler) return;
            lobby_handler.setCanSendHeart(false);
            lobby_handler._needReConnect = false;
            lobby_handler._reconnetTime = 0;
            cc.log('-----后台直接重连1');
            layer.runAction(new cc.Sequence(new cc.DelayTime(1), new cc.CallFunc(function () {
                lobby_handler.reconnClient();
                cc.log('-----后台直接重连2');
            })));

            layer._handler.onConnectEvent && layer._handler.onConnectEvent(eClientEvent.EVENT_CONNECT_RECONN);
            layer._handler._needReConnect = false;
        } else {
            var layer = FYEngine.getRunningLayer(0);
            if (layer.getName() == 'lobbyscene') {
                layer.loadMusic();
            }
        }
    },

    testGameOnHide: function () {
        if (cc.sys.os == 'iOS') {
            cc.audioEngine.stopMusic();
        }
    },

});

GameNewLobby.createScene = function () {
    var scene = new cc.Scene();
    var layer = new GameNewLobby();
    scene.addChild(layer, 0, 0);
    scene.setName("GameNewLobby");
    return scene;
};
