var GameNewChoosGame = DialogLayer.extend({

    ctor: function () {
        this._super();
        this.initData();
        this.initUI();
    },

    initData: function () {
        GAME_NEW_INT_DATA.GAME_TYPE = 1;
        GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = -1;
    },

    onExit: function () {
        this._super();
        GAME_NEW_INT_DATA.GAME_TYPE = -1;
    },

    initUI: function () {
        var self = this;
        let size = cc.winSize;

        var mainscene = this.mainbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_CHOOSE_GAME.csb");
        this.mainbg.setPosition(cc.p(this.width * 0.5, this.height * 0.5));
        this.addChild(mainscene, 0, 'mainscene');

        var LeftUp = this._LeftUp = mainscene.getChildByName("LEFTUP");
        LeftUp.setPosition(cc.p(-size.width * 0.5, size.height * 0.5));

        this.initLeftUp(true);
        this.initCenter();
        this.initRightUp();
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },


    /**
     * 初始化和刷新玩家的财富
     * @param tag   true时则是初始化，否则为刷新财富
     */
    initLeftUp: function (tag) {
        var self = this;
        if (tag) {
            var btnback = this._LeftUp.getChildByName("backtolobby");
            btnback.addTouchEventListener(this.btnTouchEft, this);
            btnback.addClickEventListener(function () {
                self.removeFromParent(true);
            });
        }

        let player = appglobal.getPlayer();
        var gold = this._LeftUp.getChildByName("goldbg").getChildByName("num_gold");
        gold.setString(player.gold);

    },

    initCenter: function () {
        var self = this;
        for (var i = 0; i < 3; ++i) {
            let btn = this.mainbg.getChildByName("ROOM" + i);
            btn.addTouchEventListener(this.btnTouchEft, this);
            btn.addClickEventListener((sender) => {
                self.btnClickCallBack(sender);
            });
            let rate = btn.getChildByName("rate");
            rate.setString(GAME_NEW_INT_DATA.GAME2_CANNON_RATE[i] + "倍炮");
        }
    },

    updateJZSJConf: function () {
        for (var i = 0; i < 3; ++i) {
            let btn = this.mainbg.getChildByName("ROOM" + i);
            let rate = btn.getChildByName("rate");
            rate.setString(GAME_NEW_INT_DATA.GAME2_CANNON_RATE[i] + "倍炮");
        }
    },

    initRightUp: function () {
        var self = this;
        var btn = this.mainbg.getChildByName("RIGHTUP");
        btn.addTouchEventListener(this.btnTouchEft, this);
        btn.addClickEventListener((sender) => {
            self.btnClickCallBack(sender);
        });

    },

    /**
     * 按键点击事件
     * @param sender
     */
    btnClickCallBack: function (sender) {
        let name = sender.getName();
        switch (name) {
            case "RIGHTUP" : {
                var scene = FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(GAME_NEW_WINDOWS.GAME2_HELP_LAYER);
                if (!layer) {
                    layer = new GAME2_HELP_LAYER();
                    scene.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.GAME2_HELP_LAYER);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            }
                break;
            case "ROOM0" : {
                this.chooseGame(0);
            }
                break;
            case "ROOM1": {
                this.chooseGame(1);
            }
                break;
            case "ROOM2": {
                this.chooseGame(2);
            }
                break;
            default:
                break;
        }
    },

    chooseGame: function (index) {
        if (GAME_NEW_INT_DATA.GAME2_ROOM_INDEX == -1) {
            if (appglobal.getPlayer().gold < GAME_NEW_INT_DATA.GAME2_ENTER_NEED_MONEY[index]) {
                let range = GAME_NEW_INT_DATA.GAME2_ENTER_NEED_MONEY[index] - appglobal.getPlayer().gold;
                FYEngine.AddCommToast("入场还需要" + range + "金币");
                return;
            }

            var scene = FYEngine.getRunningLayer(0);
            var layer = scene.getChildByName(GAME_NEW_WINDOWS.Game2EnterTip1);
            if (!layer) {
                GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = index;
                layer = new Game2EnterTip1();
                scene.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.Game2EnterTip1);
                FYEngine.popupLayerAnimate(layer.layerbg);
            }
        }
    },

});

var Game2EnterTip1 = DialogLayer.extend({
    _needClear: true,
    ctor: function () {
        this._super();
        this._needClear = true;
        this.initUI();
    },

    onExit: function () {
        this._super();
        if (this._needClear == true) {
            cc.log("清除房间index:" + GAME_NEW_INT_DATA.GAME2_ROOM_INDEX);
            GAME_NEW_INT_DATA.GAME2_ROOM_INDEX = -1;
        }
    },



    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/CommonUse.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        // var innerbg = this.layerbg.getChildByName("bg").getChildByName("innerbg");
        // innerbg.setVisible(false);

        let content = this.layerbg.getChildByName("bg").getChildByName("content");
        content.setVisible(false);

        var innerBg = this.layerbg.getChildByName("bg");

        var btn_quit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btn_quit.setVisible(true);
        btn_quit.addClickEventListener(function () {
            self.closeCallBack();
        });

        var btn_cancel = this.layerbg.getChildByName("bg").getChildByName("btn_cancel");
        btn_cancel.addTouchEventListener(this.btnTouchEft, this);
        btn_cancel.setVisible(true);
        btn_cancel.addClickEventListener(function () {
            self.closeCallBack();
        });

        var btn_confirm = this.layerbg.getChildByName("bg").getChildByName("btn_confirm");
        btn_confirm.addTouchEventListener(this.btnTouchEft, this);
        btn_confirm.setVisible(true);
        btn_confirm.addClickEventListener(function () {
            self.confirmCallBack();
        });


        var rich1 = new ccui.RichText();
        if (rich1) {
            innerBg.addChild(rich1, 0, "rich1");
            rich1.setPosition(cc.p(innerBg.width / 2, 250));

            var mtxt1 = new ccui.RichElementText(1, cc.color("#FFFFFF"), 255, "入场需要消耗", "", 30);
            rich1.pushBackElement(mtxt1);

            var mtxt2 = new ccui.RichElementText(2, cc.color("#00fffc"),
                255, "" + GAME_NEW_INT_DATA.GAME2_NEED_INT[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX] + "积分", "", 30);
            rich1.pushBackElement(mtxt2);

            if (GAME_NEW_INT_DATA.GAME2_TOTAL_ENTER_TIMES[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX] >= 0) {
                var mtxt3 = new ccui.RichElementText(3, cc.color("#FFFFFF"), 255, "，今日入场次数共", "", 30);
                rich1.pushBackElement(mtxt3);

                var mtxt4 = new ccui.RichElementText(4, cc.color("#00fffc"), 255, GAME_NEW_INT_DATA.GAME2_TOTAL_ENTER_TIMES[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX], "", 30);
                rich1.pushBackElement(mtxt4);

                var mtxt5 = new ccui.RichElementText(5, cc.color("#FFFFFF"), 255, "次", "", 30);
                rich1.pushBackElement(mtxt5);

                var mytext = new ccui.Text("每天的24点刷新入场次数", "", 22);
                innerBg.addChild(mytext, 1, "mytext");
                mytext.setTextColor(cc.color("FFFFFF"));
                mytext.setPosition(cc.p(innerBg.width / 2, innerBg.height / 2 - 30));
            }
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    closeCallBack: function () {
        FYEngine.popoutLayerAnimate(this.layerbg);
    },


    confirmCallBack: function () {
        GAME_NEW_INT_DATA.GAME_TYPE = 1;
        if (GAME_NEW_INT_DATA.GAME2_NEED_INT[GAME_NEW_INT_DATA.GAME2_ROOM_INDEX] > appglobal.getPlayer().score) {
            FYEngine.AddCommToast("积分不足");
            return;
        }
        this._needClear = false;
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.CLICK_GAME2);
        }
    },


});

var Game1ExchangeTimes = DialogLayer.extend({
    _time: 0,
    ctor: function () {
        this._super();
        this._time = 0;
        this.initUI();
    },

    onExit: function () {
        this._super();
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_EXCHANGE_TIMES.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var innerBg = this.layerbg.getChildByName("bg");

        var btn_quit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btn_quit.setVisible(true);

        btn_quit.addClickEventListener(function () {
            self.closeCallBack();
        });

        var btn_cancel = this.layerbg.getChildByName("bg").getChildByName("btn_left");
        btn_cancel.setVisible(true);
        btn_cancel.addTouchEventListener(this.btnTouchEft,this);
        btn_cancel.addClickEventListener(function () {
            self.closeCallBack();
        });

        var btn_confirm = this.layerbg.getChildByName("bg").getChildByName("btn_right");
        btn_confirm.setVisible(true);
        btn_confirm.addTouchEventListener(this.btnTouchEft,this);
        btn_confirm.addClickEventListener(function () {
            self.confirmCallBack();
        });


        var ex_num = FYEngine.createEditBox("", cc.size(180, 49), cc.EDITBOX_INPUT_MODE_NUMERIC, "请输入次数", cc.color(255, 255, 255), cc.color(0, 51, 89), 30, 3);
        if (ex_num) {
            ex_num.setPlaceholderFontSize(24);
            ex_num.setPosition(cc.p(387, 274));
            innerBg.addChild(ex_num);
            var delegate = {
                editBoxEditingDidBegin: function () {
                    ex_num.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = ex_num.getString();
                    if (str == "") {
                        ex_num.setPlaceHolder("请输入次数");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                    self.changeScore(value);
                }

            };
            ex_num.setDelegate(delegate);
            this.ex_num = ex_num;
        }

        this.updateText();
    },

    changeScore: function (num) {
        var score = this.layerbg.getChildByName("bg").getChildByName("txt2");

        if (num == "0" || num == "") {
            score.setString("所需积分：" + 0);
        }

        if(Number(num) <= 0){
            score.setString("所需积分："+0);
        }
        if (Number(num)) {
            score.setString("所需积分：" + Number(num) * GAME_NEW_INT_DATA.EX_ATTACK_NEED_SCORE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);
        }
    },

    updateText: function () {
        let txt1 = this.layerbg.getChildByName("bg").getChildByName("txt1");
        txt1.setString("剩余兑换次数：" + GAME_NEW_INT_DATA.LEFT_EX_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);
        if (GAME_NEW_INT_DATA.LEFT_EX_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] <= -1) {
            txt1.setVisible(false);
        }

        let txt2 = this.layerbg.getChildByName("bg").getChildByName("txt2");
        txt2.setString("所需积分：" + GAME_NEW_INT_DATA.EX_ATTACK_NEED_SCORE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);

        let txt3 = this.layerbg.getChildByName("bg").getChildByName("txt3");
        txt3.setString("我的积分：" + GAME_NEW_INT_DATA.player.score);
    },

    closeCallBack: function () {
        FYEngine.popoutLayerAnimate(this.layerbg);
    },

    confirmCallBack: function () {
        let str = this.ex_num.getString();
        if (this.canEx(str)) {
            this.sendMsg(str);
        }

    },

    canEx: function (str) {
        if (str == "" || str == "0") {
            FYEngine.AddCommToast("兑换数量不能为空或0");
            return false;
        }
        if (Number(str) <= 0) {
            FYEngine.AddCommToast("兑换数量需大于0");
            return false;
        }

        if (GAME_NEW_INT_DATA.LEFT_EX_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] >= 0 &&
            (GAME_NEW_INT_DATA.LEFT_EX_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] - Number(str) < 0)) {
            FYEngine.AddCommToast("剩余兑换次数不足");
            return false;
        }
        if (GAME_NEW_INT_DATA.LEFT_EX_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] == 0) {
            FYEngine.AddCommToast("剩余兑换次数不足");
            return false;
        }
        if (GAME_NEW_INT_DATA.player.score < (Number(str)*GAME_NEW_INT_DATA.EX_ATTACK_NEED_SCORE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE])) {
            FYEngine.AddCommToast("积分不足");
            return false;
        }

        if(Number(str)>100){
            this.ex_num.setString("100");
            FYEngine.AddCommToast("每次兑换数量不得超过100");
            return false;
        }

        return true;
    },

    sendMsg: function (str) {
        this.addGetLoading();
        this.schedule(this.timeCount, 1);
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle) {
            handle.sendSYLZBuyBoom(Number(str), GAME_NEW_INT_DATA.ATTACK_PRICE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);
        }
    },

    addGetLoading: function () {
        var layer = FYEngine.CreateAccRelatedLoading();
        if (layer) {
            this.addChild(layer, 100, "loadingnew");
        }
    },

    removeGetLoading: function () {
        var loadinglayer = this.getChildByName("loadingnew");
        if (loadinglayer) {
            loadinglayer.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeGetLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

});

var Game1ExchangeOrBuy = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },
    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },
    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_CHANGE_BUY.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btn_left = this.layerbg.getChildByName("bg").getChildByName("btn_left");
        btn_left.addTouchEventListener(this.btnTouchEft,this);
        btn_left.addClickEventListener(function (sender) {
            self.clickCallBack(sender);
        });

        var btn_right = this.layerbg.getChildByName("bg").getChildByName("btn_right");
        btn_right.addTouchEventListener(this.btnTouchEft,this);
        btn_right.addClickEventListener(function (sender) {
            self.clickCallBack(sender);
        });

        var btn_quit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btn_quit.addClickEventListener(function (sender) {
            self.removeFromParent(true);
        });
    },

    clickCallBack: function (sender) {
        let name = sender.getName();
        var scene = FYEngine.getRunningLayer(0);
        switch (name) {
            case "btn_left" : {
                if (scene && scene.onGameEvent) {
                    scene.onGameEvent(GAME_NEW_EVENT.GAME1_SHOW_EX_TIME);
                }
            }
                break;
            case "btn_right": {
                if (scene && scene.onGameEvent) {
                    scene.onGameEvent(GAME_NEW_EVENT.GAME1_SHOW_EX_CANNON);
                }
            }
                break;
        }
        this.removeFromParent(true);
    },
});

var Game1OnlyBuy = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },
    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },
    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/CommonUse.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var content = this.layerbg.getChildByName("bg").getChildByName("content");
        var mstr = "攻击次数不足，是否使用积分购买次数？";

        content.setString(mstr);
        var btn_left = this.layerbg.getChildByName("bg").getChildByName("btn_cancel");
        btn_left.setVisible(true);
        btn_left.addTouchEventListener(this.btnTouchEft,this);
        btn_left.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var btn_right = this.layerbg.getChildByName("bg").getChildByName("btn_confirm");
        btn_right.setVisible(true);
        btn_right.addTouchEventListener(this.btnTouchEft,this);
        btn_right.addClickEventListener(function (sender) {
            self.clickCallBack(sender);
        });
    },

    clickCallBack: function (sender) {
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.GAME1_SHOW_EX_TIME);
        }
    },

});

var GameNewFishBox = DialogLayer.extend({
    _param: null,
    ctor: function () {
        this._super();
        this._param = null;
        this.initUI();
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_OPEN_BOX.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btnquit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btnquit.addClickEventListener(function (sender) {
            self.removeFromParent(true);
        });
        this.updateWealth();
        this.sendMsg();
    },

    updateWealth: function () {
        var player = appglobal.getPlayer();
        let boxnum = this.layerbg.getChildByName("bg").getChildByName("BOX_BG").getChildByName("NUM_BOX");
        boxnum.setString(player.fishbox);

        let scorenum = this.layerbg.getChildByName("bg").getChildByName("INT_BG").getChildByName("NUM_SCORE");
        scorenum.setString(player.score);
    },

    sendMsg: function () {
        var handle = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handle) {
            handle.sendFUBEN2_OPENBOX_CFG();
        }
    },

    getBoxConfigOK: function (param) {
        var self = this;
        this._param = param;
        let bg = this.layerbg.getChildByName("bg");
        for (var i = 0; i < 3; ++i) {
            let box = bg.getChildByName("BOX" + i);
            let btn = box.getChildByName("BTN");
            btn.setTag(i);
            let sp = btn.getChildByName("SP");
            sp.setString(param.boxCfg[i].iScore + "积分开启");
            box.setVisible(true);
            btn.addTouchEventListener(this.btnTouchEft,this);
            btn.addClickEventListener(function (sender) {
                self.btnClickCallBack(sender)
            });
        }
    },

    btnClickCallBack: function (sender) {
        let tag = sender.getTag();
        let param = this._param.boxCfg[tag];
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(GAME_NEW_WINDOWS.GameNewOpenBox);
        if (!layer) {
            if (param.iScore == 0) {
                layer = new GameNewOpenBox1(param);
            } else {
                layer = new GameNewOpenBox0(param);
            }
            scene.addChild(layer, FishZorder.poplayer, GAME_NEW_WINDOWS.GameNewOpenBox);
        }

    },

    getBoxConfigFail: function () {
        let fail = this.layerbg.getChildByName("bg").getChildByName("LoadFail");
        fail.setVisible(true);
    },

});

var GameNewEnterExnNumber = DialogLayer.extend({
    _type: 0,
    ctor: function (type) {
        this._super();
        this._time = 0;
        this._type = type;
        this.initUI();
    },
    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },
    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_EXCHANGE_BOX.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btn_quit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btn_quit.setVisible(true);
        btn_quit.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var btn_cancel = this.layerbg.getChildByName("bg").getChildByName("btn_left");
        btn_cancel.addTouchEventListener(this.btnTouchEft,this);
        btn_cancel.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var btn_confirm = this.layerbg.getChildByName("bg").getChildByName("btn_right");
        btn_confirm.addTouchEventListener(this.btnTouchEft,this);
        btn_confirm.addClickEventListener(function (sender) {
            self.confirmCallBack(sender);
        });

        var innerBg = this.layerbg.getChildByName("bg");
        var ex_num = FYEngine.createEditBox("", cc.size(180, 49), cc.EDITBOX_INPUT_MODE_NUMERIC, "请输入数量", cc.color(255, 255, 255), cc.color(0, 51, 89), 30, 5);
        if (ex_num) {
            ex_num.setPlaceholderFontSize(24);
            ex_num.setPosition(cc.p(404, 234));
            innerBg.addChild(ex_num);
            var delegate = {
                editBoxEditingDidBegin: function () {
                    ex_num.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = ex_num.getString();
                    if (str == "") {
                        ex_num.setPlaceHolder("请输入次数");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }

            };
            ex_num.setDelegate(delegate);
            this.ex_num = ex_num;
        }

    },

    confirmCallBack: function (sender) {
        let str = this.ex_num.getString();
        if (this.canEx(str)) {
            this.sendMsg(str);
        }
    },

    canEx: function (str) {
        if (str == "" || str == "0") {
            FYEngine.AddCommToast("兑换数量不能为空或0");
            return false;
        }

        if (Number(str) <= 0) {
            FYEngine.AddCommToast("兑换数量需大于0");
            return false;
        }
        if(Number(str)>99999){
            this.ex_num.setString("99999");
            FYEngine.AddCommToast("每次兑换数量不得超过99999");
            return false;
        }

        var player = appglobal.getPlayer();
        if (this._type == 1 && player.fishcoin < (2000 * Number(str))) {
            FYEngine.AddCommToast("渔币不足");
            return false;
        }

        if (this._type == 2 && player.fishcoin < (1 * Number(str))) {
            FYEngine.AddCommToast("渔币不足");
            return false;
        }
        return true;
    },

    sendMsg: function (str) {
        this.addGetLoading();
        this.schedule(this.timeCount, 1);
        var handle = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handle) {
            handle.sendFUBEN2_BUY_BOX_CFG(this._type, Number(str));
        }
    },

    addGetLoading: function () {
        var layer = FYEngine.CreateAccRelatedLoading();
        if (layer) {
            this.addChild(layer, 100, "loadingnew");
        }
    },

    removeGetLoading: function () {
        var loadinglayer = this.getChildByName("loadingnew");
        if (loadinglayer) {
            loadinglayer.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeGetLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

});

var GameNewOpenBox0 = DialogLayer.extend({
    _param: null,
    _time: 0,
    ctor: function (param) {
        this._super();
        this._time = 0;
        this._param = param;
        this.initUI();
    },
    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },
    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_OPEN_BOX_ENTER.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btn_quit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btn_quit.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var btn_cancel = this.layerbg.getChildByName("bg").getChildByName("btn_left");
        btn_cancel.addTouchEventListener(this.btnTouchEft,this);
        btn_cancel.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var btn_confirm = this.layerbg.getChildByName("bg").getChildByName("btn_right");
        btn_confirm.addTouchEventListener(this.btnTouchEft,this);
        btn_confirm.addClickEventListener(function (sender) {
            self.confirmCallBack(sender);
        });

        var score = this.layerbg.getChildByName("bg").getChildByName("txt2");
        score.setString("消耗积分：" + 0);

        var myscore = this.layerbg.getChildByName("bg").getChildByName("txt3");
        myscore.setString("我的积分：" + appglobal.getPlayer().score);

        var innerBg = this.layerbg.getChildByName("bg");
        var ex_num = FYEngine.createEditBox("", cc.size(180, 49), cc.EDITBOX_INPUT_MODE_NUMERIC, "请输入数量",cc.color(255, 255, 255), cc.color(0, 51, 89), 30, 3);
        if (ex_num) {
            ex_num.setPlaceholderFontSize(24);
            ex_num.setPosition(cc.p(387, 234));
            innerBg.addChild(ex_num);
            var delegate = {
                editBoxEditingDidBegin: function () {
                    ex_num.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = ex_num.getString();
                    if (str == "") {
                        ex_num.setPlaceHolder("请输入次数");
                    }
                    self.changeScore(str);
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
                    cc.log(value + '---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);

                    }
                    self.changeScore(value);
                }

            };
            ex_num.setDelegate(delegate);
            this.ex_num = ex_num;
        }
    },

    changeScore: function (num) {
        var score = this.layerbg.getChildByName("bg").getChildByName("txt2");

        if (num == "0" || num == "") {
            score.setString("消耗积分：" + 0);
        }

        if (Number(num) <=0) {
            score.setString("消耗积分：" + 0);
        }
        if (Number(num)) {
            score.setString("消耗积分：" + Number(num) * this._param.iScore);
        }
    },

    confirmCallBack: function (sender) {
        let str = this.ex_num.getString();
        if (this.canEx(str)) {
            this.sendMsg(str);
        }
    },

    canEx: function (str) {
        if (str == "" || str == "0") {
            FYEngine.AddCommToast("打开数量不能为空或0");
            return false;
        }
        if (Number(str) <= 0) {
            FYEngine.AddCommToast("兑换数量需大于0");
            return false;
        }

        if (Number(str) > 100) {
            this.ex_num.setString("100");
            this.changeScore("100");
            FYEngine.AddCommToast("最多只可同时开启100个宝箱");
            return false;
        }
        var player = appglobal.getPlayer();
        if (Number(str) > player.fishbox) {
            FYEngine.AddCommToast("宝箱数量不足");
            return false;
        }

        if (Number(str) * this._param.iScore > player.score) {
            FYEngine.AddCommToast("积分不足");
            return false;
        }

        return true;
    },

    sendMsg: function (str) {
        this.addGetLoading();
        this.schedule(this.timeCount, 1);
        var handle = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handle) {
            handle.sendFUBEN2_OPEN_BOX(this._param.iType, Number(str));
        }
    },

    addGetLoading: function () {
        var layer = FYEngine.CreateAccRelatedLoading();
        if (layer) {
            this.addChild(layer, 100, "loadingnew");
        }
    },

    removeGetLoading: function () {
        var loadinglayer = this.getChildByName("loadingnew");
        if (loadinglayer) {
            loadinglayer.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeGetLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

});

var GameNewOpenBox1 = DialogLayer.extend({
    _param: null,
    _time: 0,
    ctor: function (param) {
        this._super();
        this._time = 0;
        this._param = param;
        this.initUI();
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },
    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_OPEN_BOX_ENTER1.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btn_quit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btn_quit.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var btn_cancel = this.layerbg.getChildByName("bg").getChildByName("btn_left");
        btn_cancel.addTouchEventListener(this.btnTouchEft,this);
        btn_cancel.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var btn_confirm = this.layerbg.getChildByName("bg").getChildByName("btn_right");
        btn_confirm.addTouchEventListener(this.btnTouchEft,this);
        btn_confirm.addClickEventListener(function (sender) {
            self.confirmCallBack(sender);
        });


        var innerBg = this.layerbg.getChildByName("bg");
        var ex_num = FYEngine.createEditBox("", cc.size(180, 49), cc.EDITBOX_INPUT_MODE_NUMERIC, "请输入数量", cc.color(255, 255, 255), cc.color(0, 51, 89), 30, 3);
        if (ex_num) {
            ex_num.setPlaceholderFontSize(24);
            ex_num.setPosition(cc.p(387, 224));
            innerBg.addChild(ex_num);
            var delegate = {
                editBoxEditingDidBegin: function () {
                    ex_num.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = ex_num.getString();
                    if (str == "") {
                        ex_num.setPlaceHolder("请输入次数");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }

            };
            ex_num.setDelegate(delegate);
            this.ex_num = ex_num;
        }
    },

    confirmCallBack: function (sender) {
        let str = this.ex_num.getString();
        if (this.canEx(str)) {
            this.sendMsg(str);
        }
    },

    canEx: function (str) {
        if (str == "" || str == "0") {
            FYEngine.AddCommToast("打开数量不能为空或0");
            return false;
        }
        if (Number(str) <= 0) {
            FYEngine.AddCommToast("兑换数量需大于0");
            return false;
        }
        if (Number(str) > 100) {
            this.ex_num.setString("100");
            FYEngine.AddCommToast("最多只可同时开启100个宝箱");
            return false;
        }
        var player = appglobal.getPlayer();
        if (Number(str) > player.fishbox) {
            FYEngine.AddCommToast("宝箱数量不足");
            return false;
        }

        return true;
    },

    sendMsg: function (str) {
        this.addGetLoading();
        this.schedule(this.timeCount, 1);
        var handle = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handle) {
            handle.sendFUBEN2_OPEN_BOX(this._param.iType, Number(str));
        }
    },

    addGetLoading: function () {
        var layer = FYEngine.CreateAccRelatedLoading();
        if (layer) {
            this.addChild(layer, 100, "loadingnew");
        }
    },

    removeGetLoading: function () {
        var loadinglayer = this.getChildByName("loadingnew");
        if (loadinglayer) {
            loadinglayer.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeGetLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

});

var Game2TimeOff = DialogLayer.extend({
    _recount: 10,
    _type: 0, //0：钱不够  1：时间到
    _mtext: "",
    ctor: function () {
        this._super();
        this._recount = 10;
        this._type = 1;
        this.initUI();
    },
    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    initUI: function () {
        if (this._type == 1) {
            this._mtext = "时间结束，{0}秒后返回大厅";
        } else {
            this._mtext = "金币不足，将在{0}秒后返回大厅";
        }

        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/CommonUse.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');


        var btn_confirmcenter = this.layerbg.getChildByName("bg").getChildByName("btn_confirmcenter");
        btn_confirmcenter.setVisible(true);
        btn_confirmcenter.addTouchEventListener(this.btnTouchEft,this);
        btn_confirmcenter.addClickEventListener(this.backToLobby);

        var content = this._tip = this.layerbg.getChildByName("bg").getChildByName("content");
        content.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        content.setString(this._mtext.format(this._recount));

        this.schedule(this.myRecountFun, 1, 9);


    },

    myRecountFun: function () {
        this._recount -= 1;
        if (this._recount > 0) {
            this._tip.setString(this._mtext.format(this._recount));
        } else {
            this._recount = 0;
            this.unschedule(this.myRecountFun);
            this.backToLobby();
        }
    },

    backToLobby: function () {
        var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
        if (gamehandle && gamehandle._canSendNormalMsg) {
            if(gamehandle._canSendNormalMsg){
                gamehandle.sendPlayerLogoutRequest();
            }
            var gamelayer = FYEngine.getRunningLayer(0);
            gamelayer.runAction(new cc.Sequence(new cc.DelayTime(0.5), new cc.CallFunc(function () {
                gamelayer.exitGame();
            })));
        }

    },
});

var GAME1_HELP_LAYER = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_HELP_0.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btnquit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btnquit.addClickEventListener(function (sender) {
            self.removeFromParent(true);
        });
    },

});

var GAME2_HELP_LAYER = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_HELP_1.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btnquit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btnquit.addClickEventListener(function (sender) {
            self.removeFromParent(true);
        });
    },

});

var GAME1_GUIDE_LAYER = DialogLayer.extend({
    ctor: function () {
        this._super();
        GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW = true;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var size = cc.winSize;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_GAME1_GUIDE.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btnquit = this.layerbg.getChildByName("btn_quit");
        btnquit.addClickEventListener(function (sender) {
            self.record();
            self.removeFromParent(true);

        });

        var hand = this.layerbg.getChildByName("HAND");
        hand.runAction(cc.repeatForever(cc.sequence(cc.moveBy(2, cc.p(0, 20)), cc.moveBy(2, cc.p(0, -20)))));

        var BTN_REMIND = this.BTN_REMIND = this.layerbg.getChildByName("BTN_REMIND");
        BTN_REMIND.setPosition(cc.p(size.width / 2 - 120, -size.height / 2 + 20));
        BTN_REMIND.addClickEventListener(function (sender) {
            self.clickCallBack(sender);
        });
    },

    clickCallBack: function () {
        GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW = !GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW;
        this.changeBTN();
    },

    changeBTN: function () {
        if (GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW == true) {
            this.BTN_REMIND.loadTextures("N_G_G_24.png", "N_G_G_24.png", "", ccui.Widget.PLIST_TEXTURE);
        } else {
            this.BTN_REMIND.loadTextures("N_G_G_23.png", "N_G_G_23.png", "", ccui.Widget.PLIST_TEXTURE);
        }
    },

    record: function () {
        if (GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW == false) {
            var date = Date.parse(new Date());
            var sp = {};
            sp.GAME1_GUIDE_SHOW = GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW;
            sp.GAME2_GUIDE_SHOW = GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW;
            sp.GAME1_GUIDE_LAST_TIME = date;
            sp.GAME2_GUIDE_LAST_TIME = GAME_NEW_INT_DATA.GAME2_GUIDE_LAST_TIME;
            cc.sys.localStorage.setItem('Game_New_Guide' + appglobal.getPlayer().userid, JSON.stringify(sp));
        }
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.GAME_REMOVE_GUIDE);
        }
    },

});

var GAME2_GUIDE_LAYER = DialogLayer.extend({
    ctor: function () {
        this._super();
        GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW = true;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var size = cc.winSize;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_GAME2_GUIDE.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btnquit = this.layerbg.getChildByName("btn_quit");
        btnquit.addClickEventListener(function (sender) {
            self.record();
            self.removeFromParent(true);

        });

        var hand = this.layerbg.getChildByName("HAND");
        hand.runAction(cc.repeatForever(cc.sequence(cc.moveBy(2, cc.p(0, 20)), cc.moveBy(2, cc.p(0, -20)))));

        var BTN_REMIND = this.BTN_REMIND = this.layerbg.getChildByName("BTN_REMIND");
        BTN_REMIND.setPosition(cc.p(size.width / 2 - 120, -size.height / 2 + 20));
        BTN_REMIND.addClickEventListener(function (sender) {
            self.clickCallBack(sender);
        });
    },

    clickCallBack: function () {
        GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW = !GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW;
        this.changeBTN();
    },

    changeBTN: function () {
        if (GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW == true) {
            this.BTN_REMIND.loadTextures("N_G_G_24.png", "N_G_G_24.png", "", ccui.Widget.PLIST_TEXTURE);
        } else {
            this.BTN_REMIND.loadTextures("N_G_G_23.png", "N_G_G_23.png", "", ccui.Widget.PLIST_TEXTURE);
        }
    },

    record: function () {
        if (GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW == false) {
            var date = Date.parse(new Date());
            var sp = {};
            sp.GAME1_GUIDE_SHOW = GAME_NEW_INT_DATA.GAME1_GUIDE_SHOW;
            sp.GAME2_GUIDE_SHOW = GAME_NEW_INT_DATA.GAME2_GUIDE_SHOW;
            sp.GAME2_GUIDE_LAST_TIME = date;
            sp.GAME1_GUIDE_LAST_TIME = GAME_NEW_INT_DATA.GAME2_GUIDE_LAST_TIME;
            cc.sys.localStorage.setItem('Game_New_Guide' + appglobal.getPlayer().userid, JSON.stringify(sp));
        }

        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.GAME_REMOVE_GUIDE);
        }
    },

});

var GAME_NEW_OPEN_BOX_RESULT = DialogLayer.extend({
    _param: null,
    _totalRewardCount: 0,
    ctor: function (param) {
        this._super();
        this._param = param;
        this._totalRewardCount = 0;
        this.initUI();
    },
    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },
    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/LAYER_BOX_RESULT.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btnquit = this.layerbg.getChildByName("bg").getChildByName("btn_confirm");
        btnquit.addTouchEventListener(this.btnTouchEft,this);
        btnquit.addClickEventListener(function (sender) {
            self.removeFromParent(true);
        });

        var light1 = this.layerbg.getChildByName("bg").getChildByName("light1");
        var light2 = this.layerbg.getChildByName("bg").getChildByName("light2");
        light1.runAction(new cc.RepeatForever(new cc.RotateBy(2, 360)));
        light2.runAction(new cc.RepeatForever(new cc.RotateBy(3, -360)));

        this.caculateData();
    },

    caculateData: function () {
        var info = [
            {
                type: 0,
                num: this._param.lAddGold
            },
            {
                type: 1,
                num: this._param.lAddCoupon
            },
            {
                type: 2,
                num: this._param.lAddMedal
            }];

        let sp = [];
        for (var i = 0; i < 3; ++i) {
            if (info[i].num > 0) {
                ++this._totalRewardCount;
                sp.push(info[i]);
            }
        }

        let posarr = this.getPosition();
        for (var i = 0; i < this._totalRewardCount; ++i) {
            let probg = this.layerbg.getChildByName("bg").getChildByName("pro_bg" + i);
            probg.setVisible(true);
            probg.setPosition(posarr[i]);
            let pro_gold = probg.getChildByName("pro_gold");
            let win_num = probg.getChildByName("win_num");
            if (sp[i].type == 0) {
                pro_gold.setSpriteFrame(SccomRes.MallRes.Goldbig);
                pro_gold.setScale(0.5);
            } else if (sp[i].type == 1) {
                pro_gold.setSpriteFrame("intergral50.png");
                pro_gold.setScale(0.8);
            } else {
                pro_gold.setSpriteFrame("fish_boom33.png");
                pro_gold.setScale(1.2);
            }
            win_num.setString("x" + sp[i].num);
        }
    },

    getPosition: function () {
        if (this._totalRewardCount == 1) {
            return [cc.p(570, 325)];
        } else if (this._totalRewardCount == 2) {
            return [cc.p(450, 325), cc.p(690, 325)];
        } else {
            return [cc.p(370, 325), cc.p(570, 325), cc.p(765, 325)];
        }
    },


});