var Game_Progress = cc.Node.extend({
    _arrow: null,
    _direction: 1,
    _angle: 0,
    _switch: false,
    _normalEnd : false,
    _speedRate :0,
    ctor: function () {
        this._super();
        this.initData();
        this.initUI();
        this.scheduleUpdate();
    },

    initData: function () {
        this._speedRate = GAME_NEW_INT_DATA.ARROW_SPEED_RATE;
        this._normalEnd = false;
        this._arrow = null;
        this._switch = false;
        GAME_NEW_INT_DATA.SWITCH_SHOOT = false;
        this._direction = 1;                                //方向1是顺时针
        this._angle = GAME_NEW_INT_DATA.ARROW_START_ANGLE;
    },

    randSpeedRate : function(){
        let range = FYMath.getRandom(-5,5);
        this._speedRate = GAME_NEW_INT_DATA.ARROW_SPEED_RATE+range;
        // if(this._speedRate == 15){
        //     this._speedRate = 10;
        // }else if(this._speedRate ==10){
        //     this._speedRate = 20;
        // }else if(this._speedRate = 20){
        //     this._speedRate = 10;
        // }
    },

    resetArrow: function () {
        this._direction = 1;                                //方向1是顺时针
        this._angle = GAME_NEW_INT_DATA.ARROW_START_ANGLE;
        this._arrow.setRotation(this._angle);
    },

    initUI: function () {
        var selfNode = this._selfNode = fycommonfunc.ccsLoadNode("NewGameRes/GAME1_CENTER.csb");
        this.addChild(selfNode, 0, 'selfNode');
        selfNode.setPosition(cc.p(0, 0));

        var arrow = this._arrow = selfNode.getChildByName("ARROW");
        this.resetArrow();
        var tip = this._tip = selfNode.getChildByName("sp");
        this.initTip();
    },

    initTip : function(tag){
        this._tip.stopAllActions();
        this._tip.setOpacity(0);
        this._tip.setScale(1.5);
        if(tag==2){
            this._tip.setSpriteFrame("N_G_G_25.png");
        }else if(tag ==3){
            this._tip.setSpriteFrame("N_G_G_26.png");
        }

    },

    showTip : function(tag){
        if(tag ==1){
            return;
        }
        this.initTip(tag);
        let action1 = cc.spawn(cc.fadeIn(0.2),cc.scaleTo(0.2,1));
        this._tip.runAction(cc.Sequence(action1,cc.delayTime(1),cc.fadeOut(0.1)))
    },

    update: function (dt) {
           if (GAME_NEW_INT_DATA.SWITCH_SHOOT == false ||  this._normalEnd == true) {
            return;
        }
        this._angle += this._direction * GAME_NEW_INT_DATA.ARROW_SPEED * this._speedRate;//
        // this._angle += this._direction * GAME_NEW_INT_DATA.ARROW_SPEED;
        if (this._angle >= 90) {
            this._angle = 90;
            this.changeDirection();
        } else if (this._angle <= -90) {
            this._angle = -90;
            this.changeDirection();
        }
        this._arrow.setRotation(this._angle);
    },

    changeDirection: function () {
        this._direction = this._direction == 1 ? -1 : 1;
    },

    startGame: function () {
        GAME_NEW_INT_DATA.SWITCH_SHOOT = true;
    },

    endShoot: function () {
        this.stopRotate();
        this.resetArrow();
        this.randSpeedRate();
    },

    endShootWithStay : function(){
        if(this._normalEnd == false){
            var self = this;
            this._normalEnd = true;
            this.randSpeedRate();
            this.stopRotate();
            this._direction = 1;                                //方向1是顺时针
            this._angle = GAME_NEW_INT_DATA.ARROW_START_ANGLE;
            this._arrow.runAction(cc.sequence(cc.delayTime(0.5),cc.rotateTo(0.2,-90),cc.callFunc(function(){
                self._normalEnd = false;
            })))
        }
    },

    stopRotate: function () {
        GAME_NEW_INT_DATA.SWITCH_SHOOT = false;
    },

    /**
     * 在红色区域返回1，其他区域返回0
     * @returns {number}
     */
    getArrowPosition: function () {
        if (this._angle >= 25 && this._angle <= 50) {
            return 1;
        } else {
            return 0;
        }
    }

});

var Game_Boss = cc.Node.extend({
    _boomnode :null,
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var boss = new cc.Sprite("#N_G_G_18.png");
        this.addChild(boss, 0, "boss");
        boss.setPosition(cc.p(0, 0));
        boss.runAction(cc.repeatForever(cc.sequence(cc.moveBy(2, cc.p(0, 30)), cc.moveBy(2, cc.p(0, -30)))));

        var boomnode = this._boomnode = new cc.Sprite();
        boomnode.setPosition(cc.p(0, 0));
        this.addChild(boomnode,1,"boomnode");

        this.initAnimation();
    },

    initAnimation : function(){
        let ani = cc.AnimationCache.getInstance().getAnimation('N_G_EFT_BOOM');
        if(ani){
            return;
        }
        var animation2 = new cc.Animation();
        for (var i = 0; i < 15; ++i) {
            var sname2 = 'N_G_EFT' + i + '.png';
            var spriteframe2 = cc.spriteFrameCache.getSpriteFrame(sname2);
            animation2.addSpriteFrame(spriteframe2);
        }
        animation2.setRestoreOriginalFrame(true);
        animation2.setDelayPerUnit(3 / 60);
        var name2 = 'N_G_EFT_BOOM';
        cc.AnimationCache.getInstance().addAnimation(animation2, name2);
    },

    playBoom : function(){
        // let posx = FYMath.getRandom(-120,120);
        // let posy = FYMath.getRandom(-120,120);
        // this._boomnode.setPosition(cc.p(posx,posy));
        this._boomnode.setVisible(true);
        let ani = cc.AnimationCache.getInstance().getAnimation('N_G_EFT_BOOM');
        if(ani){
            this._boomnode.runAction(new cc.Sequence(new cc.Animate(ani),new cc.Hide()));
        }


    },
});

var Game_New_Bullet = cc.Sprite.extend({
    _id: 0,
    _radianx: 0,
    _radiany: 0,
    _rate: 0,
    _status: 0,
    _Rotate: 0,
    _Speed: 0,
    _attacktype: 0,//游戏1中的标志，是否在  0：在红色区域外，  1：在红色区域内
    ctor: function () {
        this._super();
        this.setSpriteFrame("N_G_G_19.png");
    
    },

    initBullet: function (id, startpos, startangle, rate, radianx, radiany, type, speed) {
        this._Speed = speed||GAME_NEW_INT_DATA.BULLET_SPEED ;
        //cc.log("this._speed:"+ this._Speed);
        this._status = GAME_NEW_BULLET_STATUS.MOVE;
        this._id = id;
        this.setPosition(startpos);
        this.setTag(id);
        this.setRotation(startangle);
        this._Rotate = startangle;
        this._radianx = radianx;
        this._radiany = radiany;
        this._rate = rate;
        this._attacktype = type;
        this.scheduleUpdate();
    },

    update: function (dt) {
        if (this._status == GAME_NEW_BULLET_STATUS.MOVE) {
            this.startMove(dt);
        }
    },

    startMove: function (dt) {
        var rotate = this._Rotate;

        var curx = this.x + this._radianx * dt * this._Speed;
        var cury = this.y + this._radiany * dt * this._Speed;
        var size = cc.winSize;
        if (cury >= size.height) {
            this._Rotate = 180 - rotate;
            this.setRotation(this._Rotate);
            this._radiany = -this._radiany;
            cury = size.height;
        }
        else if (cury <= 0) {
            this._Rotate = 180 - rotate;
            this.setRotation(this._Rotate);
            this._radiany = -this._radiany;
            cury = 0;
        }
        else if (curx >= size.width) {
            this._Rotate = -rotate;
            this.setRotation(this._Rotate);
            this._radianx = -this._radianx;
            curx = size.width;
        }
        else if (curx <= 0) {
            this._Rotate = -rotate;
            this.setRotation(this._Rotate);
            this._radianx = -this._radianx;
            curx = 0;
        }

        this.x = curx;
        this.y = cury;
        //cc.log('--------子弹id: '+this._Id+'---子弹坐标 [x: '+this.x+', y: '+this.y+' ]');
    },

    onHit: function (tag) {
        if (this._status == GAME_NEW_BULLET_STATUS.MOVE) {
            this._status = GAME_NEW_BULLET_STATUS.STAY;
            var pos = this.getPosition();
            this.removeBullet();

            if(!tag){
                var scene = FYEngine.getRunningLayer(0);
                var fishnet = FishNet.create();
                fishnet.setPosition(pos);
                scene.addChild(fishnet, FishZorder.bulletLayer);

                var neteft = FishNetEft.create();
                neteft.setPosition(fishnet.getPosition());
                scene.addChild(neteft, FishZorder.bulletLayer);
            }

        }
    },

    removeBullet: function () {
        var scene = FYEngine.getRunningLayer(0);
        scene._BulletArr.remove(this);
        // scene.removeBullet(this);
        cc.pool.putInPool(this);
    },

    unuse: function () {
        this.setPosition(cc.p(-2000, -2000));
        this._id = 0;
        this._attacktype = 0;
        this._status = GAME_NEW_BULLET_STATUS.STAY;
        this.stopAllActions();
        this.unscheduleAllCallbacks();
        this.setVisible(false);
        this.removeAllChildren(true);
        this.removeFromParent(true);
    
    },

    reuse: function (id, startpos, startangle, rate, radianx, radiany) {
        this.setVisible(true);
        //this.initBullet(id, startpos, startangle, rate, radianx, radiany);
    },
});

Game_New_Bullet.create = function (id, startpos, startangle, rate, radianx, radiany, type, speed) {
    var nbullet = null;
    if (cc.pool.hasObject(Game_New_Bullet)) {
        nbullet = cc.pool.getFromPool(Game_New_Bullet);
    } else {
        nbullet = new Game_New_Bullet();
//        cc.log('--------bullet pool is not enough, type: '+type+'-----self:'+bself);
    }
    nbullet.initBullet(id, startpos, startangle, rate, radianx, radiany, type, speed);
    return nbullet;
};

var Game_New_Cannon = cc.Node.extend({
    _angleChanged: false,
    _angle: 0,
    _bulletPos: null,
    _scene: null,
    _radianx: 0,
    _radiany: 1,
    ctor: function () {
        this._super();
        this.initData();
        this.initUI();
    },

    initData: function () {
        let size = cc.winSize;
        this._angleChanged = false;
        this._angle = 0;
        this._bulletPos = cc.p(size.width / 2, 150);
        this._scene = FYEngine.getRunningLayer(0);
        this._radianx = 0;
        this._radiany = 1;
    },

    initUI: function () {
        var selfNode = this._selfNode = fycommonfunc.ccsLoadNode("NewGameRes/GAME1_CANNON.csb");
        this.addChild(selfNode, 0, 'selfNode');
        selfNode.setPosition(cc.p(0, 0));

        this._base = selfNode.getChildByName("CANNON_ROTATE");
        this._cannon = this._base.getChildByName("CANNON");
        this._fire = this._base.getChildByName("FIRE");
        this._number = selfNode.getChildByName("NUM");
        this.changeUserRate();
    },

    showChangeBtn: function () {
        var self = this;
        let BTN_LEFT = this._selfNode.getChildByName("BTN_LEFT");
        BTN_LEFT.setVisible(true);
        let BTN_RIGHT = this._selfNode.getChildByName("BTN_RIGHT");
        BTN_RIGHT.setVisible(true);
        BTN_LEFT.addClickEventListener(function (sender) {
            self.btnClickCallBack(sender);
        });
        BTN_RIGHT.addClickEventListener(function (sender) {
            self.btnClickCallBack(sender);
        });

        BTN_LEFT.runAction(cc.repeat(cc.sequence(cc.moveBy(0.5,cc.p(-10,0)),cc.moveBy(0.5,cc.p(10,0))),3));
        BTN_RIGHT.runAction(cc.repeat(cc.sequence(cc.moveBy(0.5,cc.p(10,0)),cc.moveBy(0.5,cc.p(-10,0))),3));
    },

    btnClickCallBack: function (sender) {
        if (GAME_NEW_INT_DATA.SWITCH_SHOOT == true) {
            return;
        }
        switch (sender.getName()) {
            case "BTN_LEFT" : {
                this.setIndex(-1);
            }
                break;
            case "BTN_RIGHT": {
                this.setIndex(1);
            }
                break;
            default:
                break;
        }
        this.changeCannon();
    },

    setIndex: function (index) {
        GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE += index;
        if (GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE == GAME_NEW_INT_DATA.ATTACK_TOTAL_TYPE) {
            GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE = 0;
        } else if (GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE == -1) {
            GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE = GAME_NEW_INT_DATA.ATTACK_TOTAL_TYPE - 1;
        }
    },

    exCannonType: function () {

        if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[0] == 0 &&
            GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[1] == 0 &&
            GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[2] == 0) {
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(GAME_NEW_EVENT.SHOW_CANNOT_SHOOT, 1);
            }
            return;
        }
        if (GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE == 0) {
            if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[1] > 0) {
                this.setIndex(1);
                this.changeCannon();
            } else if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[2] > 0) {
                this.setIndex(1);
                this.setIndex(1);
                this.changeCannon();
            }
        } else if (GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE == 2) {
            if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[1] > 0) {
                this.setIndex(-1);
                this.changeCannon();
            } else if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[0] > 0) {
                this.setIndex(-1);
                this.setIndex(-1);
                this.changeCannon();
            }
        } else {
            if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[2] > 0) {
                this.setIndex(1);
                this.changeCannon();
            } else if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[0] > 0) {
                this.setIndex(-1);
                this.changeCannon();
            }
        }
    },

    changeCannon: function () {
        FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.change_gun);
        var self = this;
        var scaleto = new cc.ScaleTo(0.05, 0.95, 0.9);
        var scaleto1 = new cc.ScaleTo(0.05, 1);
        var seq = new cc.Sequence(scaleto, scaleto1, new cc.DelayTime(0.05), new cc.CallFunc(function () {
            self.changeUserRate();
            self.changeCannonSpriteFrame();
        }));
        this._cannon.runAction(seq);
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.CHANGE_CANNON_TYPE);
        }
    },

    changeRate : function(rate){
        this._number.setString(rate);
    },

    changeUserRate: function () {
        this._number.setString(GAME_NEW_INT_DATA.ATTACK_PRICE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);
    },

    changeCannonSpriteFrame: function () {
        this._cannon.setSpriteFrame(GAME_NEW_INT_DATA.CANNON_SPRITEFRAME[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]);
    },

    adjustCannonDirection: function (angle) {
        this._angleChanged = true;

        if (angle <= 180 && angle > 90) {
            this._angle = 90;
            this._base.setRotation(90);
        } else if (angle < -90 || angle > 180) {
            this._angle = -90;
            this._base.setRotation(-90);
        } else {
            this._angle = angle;
            this._base.setRotation(angle);
        }
    },

    shootBullet: function (arrow_pos, rate, speed) {
        this.checkAngleChange();
        this.createBullet(arrow_pos, rate, speed);
        this.runCannonEffect();
        this.runFireEffect();
    },

    runCannonEffect: function () {
        let seq = cc.sequence(cc.moveBy(0.08, cc.p(0, -15)), cc.moveBy(0.08, cc.p(0, 15)));
        this._cannon.runAction(seq);
    },

    runFireEffect: function () {
        this._fire.opacity = 255;
        this._fire.runAction(cc.fadeOut(0.1));
    },

    createBullet: function (pos, rate, speed) {

        let id = FishGlobal.getAddBulletId(5);
        FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.shoot_eft);
        var bullet = Game_New_Bullet.create(id, this._bulletPos, this._angle,
            rate, this._radianx, this._radiany, pos, speed);
        this._scene._BulletLayer.addChild(bullet, 1, id);
        this._scene._BulletArr.push(bullet);
        // this._scene.addBullet(bullet);
    },

    checkAngleChange: function () {//备注 这边也可以要用角度对比
        if (this._angleChanged) {
            this._angleChanged = false;
            this._radianx = Math.sin((Math.PI / 180 * this._angle));
            this._radiany = Math.cos((Math.PI / 180 * this._angle));

            let r = 125;
            this._bulletPos.x = (this.getCannonPosition().x + r * this._radianx);
            this._bulletPos.y = (this.getCannonPosition().y + r * this._radiany);
        }
    },

    getCannonPosition: function () {
        let size = cc.winSize;
        return cc.p(size.width / 2, 25);
    },

});


var GameNewTouchLayer1 = cc.Layer.extend({
    _bTouched: false,
    _shoottime: 0,
    ctor: function () {
        this._super();
        this.initData();
        this.addTouchListener();
        this.scheduleUpdate();
    },

    initData: function () {
        this._bTouched = false;
        this._shoottime = 10;
        let size = cc.winSize;
        this.setContentSize(cc.size(size.width, size.height));
    },

    addTouchListener: function () {
        cc.log("addTouchListener");
        var self = this;
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touches, event) {
                cc.log("onTouchesBegan");
                if (self.beganControlShoot() != 0) {
                    return false;
                }
                if (self.canShoot()) {
                    self.prepareShoot();
                } else {
                    return false;
                }
                return true;
            },

            onTouchMoved: function (touches, event) {
                cc.log("onTouchesMoved");
            },

            onTouchCancelled: function (touches, event) {
                cc.log("onTouchCancelled");
                self.endShoot();
            },

            onTouchEnded: function (touches, event) {
                cc.log("onTouchesEnded");
                if (GAME_NEW_INT_DATA.SWITCH_SHOOT == true) {
                    //self.endControlShoot();
                    self.shootBullet();
                } else {
                    self.endShoot();
                }

            },
        });
        cc.eventManager.addListener(listener, this);
    },

    endControlShoot: function () {
        let count = 0;
        for (var i = 0; i < 3; ++i) {
            count += GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[i];
        }
        if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] == 1 && count == 1) {
            this.showWindows(1);
        } else if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] == 1 && count > 1) {
            this.showWindows(2);
        }
    },

    beganControlShoot: function () {
        if (GAME_NEW_INT_DATA.player.gold < GAME_NEW_INT_DATA.ATTACK_PRICE[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE]) {
            FYEngine.AddCommToast("金币不足，无法发射");
            return 3;
        }
        FYEngine.logObject(GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES, "--------beganControlShoot:");
        if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[0] == 0 &&
            GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[1] == 0 &&
            GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[2] == 0) {
            this.showWindows(1);
            return 1;
        } else if (GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[GAME_NEW_INT_DATA.CURRENT_ATTACK_TYPE] == 0) {
            this.showWindows(2);
            return 2;
        } else {
            return 0;
        }
    },

    shootBullet: function () {
        this._shoottime = 0;
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.SHOOT_BULLET);
        }
    },

    showWindows: function (tag) {
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.SHOW_CANNOT_SHOOT, tag);
        }
    },


    prepareShoot: function () {
        GAME_NEW_INT_DATA.SWITCH_SHOOT = true;
    },

    endShoot: function () {//todo
        GAME_NEW_INT_DATA.SWITCH_SHOOT = false;
        this._shoottime = 0;
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.END_SHOOT_EVENT);
        }
    },

    update: function (dt) {
        this._shoottime += dt;
    },

    canShoot: function () {
        if (this._shoottime > GAME_NEW_INT_DATA.BULLET_SHOOT_RANGE) {
            return true;
        } else {
            return false;
        }
    },


});

var FishCoinTool = cc.Sprite.extend({

    ctor: function () {
        this._super();
        this.setSpriteFrame("N_G_H_37.png");
        this.setScale(0.1);
        // var number = new ccui.Text("0", WordMgr.FontName, 30);
        var number = new ccui.TextAtlas("0","res/NewGameRes/New_Game_Num1.png",38,49,"/");
        if (number) {
            this.addChild(number, 0, "number");
            number.setAnchorPoint(cc.p(0, 0.5));
            number.setPosition(cc.p(this.width + 10, this.height / 2));
            // number.setColor(cc.color("fbff94"));
            // number.enableOutline(cc.color("15264e", 2));
        }
    },

    setNumber: function (num) {
        var number = this.getChildByName("number");
        if (number) {
            number.setString("/" + num);
        }
    },

    startTomove: function (beginpos, endpos) {
        var self = this;
        var action1 = new cc.ScaleTo(0.2, 1);
        var action2 = new cc.MoveBy(0.4, cc.p(0, 15));
        var action3 = new cc.MoveBy(0.4, cc.p(0, -15));
        var action4 = new cc.MoveBy(0.5, cc.p(0, 20));
        var action5 = new cc.MoveBy(0.5, cc.p(0, -20));
        var distance = FYMath.getDistance(beginpos.x, beginpos.y, endpos.x, endpos.y);
        var action6 = new cc.MoveTo(distance * 0.001, endpos);
        var action7 = new cc.ScaleTo(distance * 0.001, 0.1);
        this.runAction(new cc.Sequence(action1, action2, action3, action4, action5,
            new cc.Spawn(action6, action7), new cc.CallFunc(function () {
                cc.pool.putInPool(self);
            })));
    },

    startToMoveFast: function (beginpos, endpos) {
        var self = this;
        var action1 = new cc.ScaleTo(0.2, 1);
        var action2 = new cc.MoveBy(0.3, cc.p(0, 15));
        var action3 = new cc.MoveBy(0.3, cc.p(0, -15));
        var action4 = new cc.MoveBy(0.4, cc.p(0, 20));
        var action5 = new cc.MoveBy(0.4, cc.p(0, -20));
        var distance = FYMath.getDistance(beginpos.x, beginpos.y, endpos.x, endpos.y);
        var action6 = new cc.MoveTo(distance * 0.001, endpos);
        var action7 = new cc.ScaleTo(distance * 0.001, 0.1);
        this.runAction(new cc.Sequence(action1, action2, action3, action4, action5,
            new cc.Spawn(action6, action7), new cc.CallFunc(function () {
                cc.pool.putInPool(self);
            })));
    },

    unuse: function () {
        this.setScale(0.1);
        this.setVisible(false);
        this.stopAllActions();
        this.removeFromParent(true);
    },

    reuse: function () {
        this.setScale(0.1);
        this.setVisible(true);
    },

});

FishCoinTool.create = function (num) {
    var fgold = null;
    if (cc.pool.hasObject(FishCoinTool)) {
        fgold = cc.pool.getFromPool(FishCoinTool);
    }
    else {
        cc.log('------------copyTool缓存不足');
        fgold = new FishCoinTool();
    }
    fgold.setNumber(num);
    return fgold;
};

var S_P_FISH = cc.Sprite.extend({
    _starttime: 0,
    _status: 0,
    _speed_y_origin: 0,//y方向的初始速度
    _speed_x_origin: 0,
    _startpos: cc.p(-100, -100),
    _direction: 1,
    _edgeSize: cc.p(0, 0),
    _type: 0,
    _lastx: 0,
    _lasty: 0,
    ctor: function () {
        this._super();
        this.setSpriteFrame("N_G_H_18.png");
        // this._speed_y_origin = GAME_NEW_INT_DATA.GAME2_FISH_SPEED_Y;
        // this._speed_x_origin = GAME_NEW_INT_DATA.GAME2_FISH_SPEED_X;
        this._edgeSize = cc.p(cc.winSize.width, cc.winSize.height);
    },

    initFish: function (type, direction, startPos) {
        this._type = type;
        this._status = GAME_NEW_FISH_STATUS.MOVE;
        this._starttime = 0;
        this._speed_x_origin = FYMath.getRandom(GAME_NEW_INT_DATA.GAME2_F_S_X_R[0],GAME_NEW_INT_DATA.GAME2_F_S_X_R[1]);
        this._speed_y_origin = FYMath.getRandom(GAME_NEW_INT_DATA.GAME2_F_S_Y_R[0],GAME_NEW_INT_DATA.GAME2_F_S_Y_R[1]);
        this._startpos = startPos;
        this._lastx = startPos.x;
        this._lasty = startPos.y;
        this._direction = direction == 0 ? -1 : 1;
        this.setPosition(startPos);
        this.setRotation(0);
        this.playSwim();
        this.setFishFlipped();
        this.scheduleUpdate();
    },

    playSwim: function () {
        var name = 'G_NEW_Swim' + (this._type-1);
        var fishname = 'N_G_FISH_' + (this._type-1) + '_0.png';
        this.initWithSpriteFrameName(fishname);
        this.runAction(new cc.RepeatForever(FYEngine.createAnimate(name)));
    },


    canHit: function () {
        if (this._status == GAME_NEW_FISH_STATUS.MOVE && this.x > 0 && this.y > 0 && this.x < this._edgeSize.x && this.y < this._edgeSize.y) {
            return true;
        }
        return false;
    },

    update: function (dt) {
        if (this._status == GAME_NEW_FISH_STATUS.MOVE) {
            if (this.y < -100) {
                this.setFishDead();
            }
            this._starttime += dt;
            let delts = this._speed_y_origin * this._starttime - 0.5 * GAME_NEW_INT_DATA.GAME2_G * Math.pow(this._starttime, 2);
            this.y = this._startpos.y + delts;
            this.x += dt * this._speed_x_origin * this._direction;

            let angle = FYMath.getAngle(this._lastx, this._lasty, this.x, this.y);
            this.setRotation(angle);
            this._lastx = this.x;
            this._lasty = this.y;
        }
    },

    setFishFlipped: function (bx, ex) {
        if (this._direction == 1) {
            this.setFlippedX(false);
        } else {
            this.setFlippedX(true);
        }
    },

    playDead: function () {
        if (this._status == GAME_NEW_FISH_STATUS.MOVE) {
            this._status = GAME_NEW_FISH_STATUS.STAY;
            this.stopAllActions();
            this.unscheduleAllCallbacks();
            var name = 'G_NEW_Dead' + (this._type-1);
            var self = this;
            this.runAction(new cc.Sequence(FYEngine.createAnimate(name), new cc.CallFunc(function () {
                self.removeFromBezier();
            })));
        }
    },

    //这个是鱼超出屏幕的时候使用
    setFishDead: function () {
        if (this._status == GAME_NEW_FISH_STATUS.MOVE) {
        
            this._status = GAME_NEW_FISH_STATUS.STAY;
            this.unscheduleAllCallbacks();
            this.removeFromBezier();
        }
    },

    clearFish: function () {
        if (this._status == GAME_NEW_FISH_STATUS.MOVE) {
            this._status = GAME_NEW_FISH_STATUS.STAY;
            this.unscheduleAllCallbacks();
            this.removeFromBezier();
        }
    },

    removeFromBezier: function () {
        this._status = GAME_NEW_FISH_STATUS.STAY;
        var scene = FYEngine.getRunningLayer(0);
        scene._FishArr.remove(this);
        cc.pool.putInPool(this);
    },


    unuse: function () {
        this.setPosition(cc.p(-500, -500));
        this.setVisible(false);
        this.stopAllActions();
        this.setFlippedX(false);
        this.unscheduleAllCallbacks();
        this.removeFromParent(true);
        this.stopAllActions();
    },

    reuse: function () {
        this.setVisible(true);
    },

});

S_P_FISH.create = function (type, direction, startPos) {
    var sfish = null;
    if (cc.pool.hasObject(S_P_FISH)) {
        sfish = cc.pool.getFromPool(S_P_FISH);
    }
    else {
        cc.log('------------S_P_FISH缓存不足');
        sfish = new S_P_FISH();
    }
    sfish.initFish(type, direction, startPos);
    return sfish;
};


var GameNewTouchLayer2 = cc.Layer.extend({
    _bTouched: false,
    _shoottime: 0,
    _scene: null,
    _cannonpos: cc.p(0, 0),
    ctor: function () {
        this._super();
        this.initData();
        this.addTouchListener();
        this.scheduleUpdate();
    },

    initData: function () {
        let size = cc.winSize;
        this.setContentSize(cc.size(size.width, size.height));
        this._bTouched = false;
        this._shoottime = 10;
        this._scene = FYEngine.getRunningLayer(0);
        this._cannonpos = cc.p(size.width / 2, 25);
    },

    addTouchListener: function () {
        var self = this;
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                self._bTouched = true;
                let pos = touch.getLocation();
                let angle = self.getAngle(pos);
                if (self._scene && self._scene.onGameEvent) {
                    self._scene.onGameEvent(GAME_NEW_EVENT.ADJUST_CANNON, angle);
                }
                return true;
            },

            onTouchMoved: function (touch, event) {
                let pos = touch.getLocation();
                let angle = self.getAngle(pos);
                if (self._scene && self._scene.onGameEvent) {
                    self._scene.onGameEvent(GAME_NEW_EVENT.ADJUST_CANNON, angle);
                }
            },

            onTouchCancelled: function (touch, event) {
                self._bTouched = false;
                let pos = touch.getLocation();
                let angle = self.getAngle(pos);
                if (self._scene && self._scene.onGameEvent) {
                    self._scene.onGameEvent(GAME_NEW_EVENT.ADJUST_CANNON, angle);
                }
            },

            onTouchEnded: function (touch, event) {
                self._bTouched = false;

            },
        });
        cc.eventManager.addListener(listener, this);
    },

    getAngle: function (endpos) {
        let angle = FYMath.getAngle(this._cannonpos.x, this._cannonpos.y, endpos.x, endpos.y);
        return angle;
    },

    shootBullet: function () {
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.SHOOT_BULLET);
        }
    },


    update: function (dt) {
        if (this._bTouched && this.canShoot()) {
            this._shoottime = 0;
            this.shootBullet();

        }
        this._shoottime += dt;
    },

    canShoot: function () {
        if ((this._shoottime == 0 || this._shoottime > FishGlobal.bulletTimes) && GAME_NEW_INT_DATA.roominfo.gamestart) {
            return true;
        } else {
            return false;
        }
    },


});
