/**
 * Created by PhoneU on 2018/3/29.
 */

var GameNewHandler = ClientHandler.extend({
    _fishData: null,
    _selfId: 0,
    _scene: null,
    _bHeart: false,
    _gametime: 0, //服务器场景时间
    _unbirthFishArr: [],


    ctor: function () {
        this._super();
        this.setReconnetMaxCount(-1);
        this.setHeartBeatTime(1);
        this.setReconnetMaxTime(7);
        //this._fishData = new FishData();
    },

    getMsgHandler: function () {
        return this._fishData;
    },

    clearData: function () {
        this._fishData.clearData();
        this._unbirthFishArr = [];
    },

    setScene: function (scene) {
        this._scene = scene;
    },

    getSelfId: function () {
        return this._fishData._selfId;
    },

    getShootArr: function () {
        return this._fishData._eShootArray;
    },

    /***
     * 链接成功失败可能会有一些逻辑展示
     * @param event_id
     */
    onConnectEvent: function (event_id) {
        if (event_id == eClientEvent.EVENT_CONNECT_OK) {
//            cc.log("-----连接游戏服务器成功----");
        }
        else {
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent && (scene.getName() != "lobbyscene" && scene.getName() != "GameNewLobby")) {
                scene.onGameEvent(FishGameEventID.unConnect, 1);
            }
        }
    },

    /***
     * 公私钥消息完成与否的一些逻辑处理
     * @param issuccess 0成功 其他失败
     */
    onAccessEvent: function (issuccess) {
        cc.log('--------------游戏服务器acess信息-----' + issuccess);
        if (issuccess == 0) {
            var scene = FYEngine.getRunningLayer(0);
            if ((scene.getName() == 'GameNewGame1' || scene.getName() == 'GameNewGame2') && FishGlobal.copyReloginTag == false) {
                this.sendPlayerReLoginRequest();
            } else {
                this.sendPlayerLoginRequest();
            }

        }
        else {
            cc.log("-----公私钥验证失败-------");
        }
    },

    /***
     * 发送消息 override
     * @param subCmd
     * @param req
     */
    sendDataMsg: function (subCmd, req) {
        switch (req.mainCmd) {
            case FishProtocol.GameBaseProto:
                this.sendGameBaseMsg(subCmd, req);
                break;
            case FishProtocol.FishProto:
                if (this._canSendNormalMsg) {
                    this.sendFishProtoMsg(subCmd, req);
                }
                break;
            case FishProtocol.FishSceneRelive :
                if (this._canSendNormalMsg) {
                    this.sendFishSceneReliveMsg(subCmd, req);
                }
                break;
            default:
                break;
        }
    },

    /***
     * receive msg
     * @param mainCmd
     * @param subCmd
     * @param byteBuf
     */
    handleDataMsg: function (mainCmd, subCmd, byteBuf) {
        cc.log('----FishHandler handleDataMsg mainCmd : ' + mainCmd + ', subCmd: ' + subCmd);
        switch (mainCmd) {
            case FishProtocol.GameBaseProto:
                this.handleGameBaseMsg(subCmd, byteBuf);
                break;
            case FishProtocol.FishProto:
                this.handleFishProtoMsg(subCmd, byteBuf);
                break;
            case FishProtocol.FishBroad :
                this.handleFishBroadMsg(subCmd, byteBuf);
                break;
            case FishProtocol.FishSceneRelive :
                this.handlerFishSceneReliveMsg(subCmd, byteBuf);
                break;
            default:
                break;
        }
    },


    /****
     * 游戏基础消息
     * @param subCmd
     * @param Req
     */
    sendGameBaseMsg: function (subCmd, req) {
        switch (subCmd) {
            case FishProtocol.PlayerLogin:
                FishProtocol.encode_PlayerLogin(req, this._sendBuf);
                break;
            case FishProtocol.PlayerLogout:
                FishProtocol.encode_PlayerLogout(req, this._sendBuf);
                break;
            case FishProtocol.ReLogin :
                FishProtocol.encode_PlayerReLogon(req, this._sendBuf);
                break;
            case FishProtocol.GoldQuery:
                FishProtocol.encode_UpdateWealth(req, this._sendBuf);
                break;
            default:
                break;
        }
    },

    sendFishProtoMsg: function (subCmd, req) {
        switch (subCmd) {
            case FishProtocol.JoinTable :
                FishProtocol.encode_JoinTable(req, this._sendBuf);
                break;
            case FishProtocol.Collision :
                FishProtocol.encode_HitFish(req, this._sendBuf);
                break;
            case FishProtocol.copyCollision:
                FishProtocol.encode_CopyHitFish(req, this._sendBuf);
                break;
            case FishProtocol.FireBullet :
                FishProtocol.encode_FireBullet(req, this._sendBuf);
                break;
            case FishProtocol.ChangeCannon :
                FishProtocol.encode_ChangeCannon(req, this._sendBuf);
                break;
            case FishProtocol.LeaveTable :
                FishProtocol.encode_LeaveTable(req, this._sendBuf);
                break;
            case FishProtocol.SyncTable :
                FishProtocol.encode_SyncTable(req, this._sendBuf);
                break;
            case FishProtocol.FireSpecial:
                FishProtocol.encode_FireSpecialBullet(req, this._sendBuf);
                break;
            case FishProtocol.KillSpecialFish:
                FishProtocol.encode_SpecialHitFish(req, this._sendBuf);
                break;
            case FishProtocol.copyGetTime :
                FishProtocol.encode_getSceneTime(req, this._sendBuf);
                break;
            case FishProtocol.copyGetWealth :
                FishProtocol.encode_copyGetWealth(req, this._sendBuf);
                break;
            case FishProtocol.copyCombine :
                FishProtocol.encode_copyHecheng(req, this._sendBuf);
                break;
            case FishProtocol.copyCombList :
                FishProtocol.encode_copyHechengList(req, this._sendBuf);
                break;
            case FishProtocol.copyGetConf :
                FishProtocol.encode_getCopyRoomCfg(req, this._sendBuf);
                break;
            case FishProtocol.GET_P_INFO :
                FishProtocol.encode_GameNewInfoReq(req, this._sendBuf);
                break;
            case FishProtocol.SYLZ_BUY_BOOM :
                FishProtocol.encode_GameNewBuyBoom(req, this._sendBuf);
                break;
            case FishProtocol.SYLZ_LOTTERY :
                FishProtocol.encode_GameNewSYLZLottery(req, this._sendBuf);
                break;
            case FishProtocol.JZSJ_CREATE_ROOM :
                FishProtocol.encode_GameNewJZSJCreate(req, this._sendBuf);
                break;
            case FishProtocol.JZSJ_GAME_START :
                FishProtocol.encode_GameNewJZSJStart(req, this._sendBuf);
                break;
            case FishProtocol.JZSJ_LOTTERY :
                FishProtocol.encode_GameNewJZSJLottery(req, this._sendBuf);
                break;
            case FishProtocol.JZSJ_STATUS :
                FishProtocol.encode_GameNewJZSJSTATUS(req, this._sendBuf);
                break;
            default :
                break;
        }
    },

    sendFishSceneReliveMsg: function (subCmd, req) {
        switch (subCmd) {
            case FishProtocol.FishSceneReliveGet :
                FishProtocol.encode_FishSceneReliveGet(req, this._sendBuf);
                break;
            default :
                break;
        }
    },

    handleGameBaseMsg: function (subCmd, byteBuf) {
        switch (subCmd) {
            case FishProtocol.PlayerLogin:
                this.handlePlayerLoginRsp(byteBuf);
                break;
            case FishProtocol.PlayerLogout:
                this.handlePlayerLogoutRsp(byteBuf);
                break;
            case FishProtocol.ReLogin :
                this.handlePlayerReLoginRsp(byteBuf);
                break;
            case FishProtocol.GoldQuery:
                this.handleUpdateWealthRsp(byteBuf);
                break;
            default:
                break;
        }
    },

    handleFishBroadMsg: function (subCmd, byteBuf) {
        switch (subCmd) {
            case FishProtocol.FishBroadMsg :
                this.handleFishSceneBroadMsg(byteBuf);
                break;
            default :
                break;
        }
    },

    handlerFishSceneReliveMsg: function (subCmd, byteBuf) {
        switch (subCmd) {
            case FishProtocol.FishSceneReliveGet :
                this.handleFishSceneReliveGetRsp(byteBuf);
                break;
            default :
                break;
        }
    },

    handleFishProtoMsg: function (subCmd, byteBuf) {
        // this._heartBeat = 0;
        this._needReConnect = true;
        switch (subCmd) {
            case FishProtocol.JoinTable :
                this.handleJoinTableRsp(byteBuf);
                break;
            case FishProtocol.JoinEvent :
                this.handleJoinEventRsp(byteBuf);
                break;
            case FishProtocol.LeaveTable :
                this.handleLeaveTableRsp(byteBuf);
                break;
            case FishProtocol.SyncTable :
                this.handleSyncTableRsp(byteBuf);
                break;
            case FishProtocol.TideStart :
                this.handleTideStartRsp(byteBuf);
                break;
            case FishProtocol.UpdateFish :
                this.handleUpdateFishRsp(byteBuf);
                break;
            case FishProtocol.UpdateBullet :
                this.handleUpdateBulletRsp(byteBuf);
                break;
            case FishProtocol.Collision :
                this.handleCollisionRsp(byteBuf);
                break;
            case FishProtocol.copyCollision :
                this.handleCopyCollisionRsp(byteBuf);
                break;
            case FishProtocol.FireBullet :
                this.handleFireBulletRsp(byteBuf);
                break;
            case FishProtocol.ChangeCannon :
                this.handleChangeCannonRsp(byteBuf);
                break;
            case FishProtocol.KillFish :
                this.handleKillFishRsp(byteBuf);
                break;
            case FishProtocol.copyKillFish :
                this.handleCopyKillFishRsp(byteBuf);
                break;
            case FishProtocol.OnReliveInfo :
                this.handleReliveInfoRsp(byteBuf);
                break;
            case FishProtocol.FreeRommKick:
                this.handleFreeGameKickNotice(byteBuf);
                break;
            case FishProtocol.FireSpecial:
                this.handleFireSpecialRsp(byteBuf);
                break;
            case FishProtocol.KillSpecialFish:
                this.handleKillSpecialFishRsp(byteBuf);
                break;
            case FishProtocol.copyGetTime :
                this.handleGetSceneTimeRsp(byteBuf);
                break;
            case FishProtocol.copyGetWealth :
                this.handleCopyGetWealthRsp(byteBuf);
                break;
            case FishProtocol.copyCombine :
                this.handleHechengRsp(byteBuf);
                break;
            case FishProtocol.copyCombList :
                this.handleHechengListRsp(byteBuf);
                break;
            case FishProtocol.copyGetConf :
                this.handleGetCopyRoomCfg(byteBuf);
                break;
            case FishProtocol.copyResult :
                this.handleCopyResult(byteBuf);
                break;
            case FishProtocol.GET_P_INFO :
                this.handleGPlayerInfoRsp(byteBuf);
                break;
            case FishProtocol.SYLZ_BUY_BOOM :
                this.handleSYLZBuyBoom(byteBuf);
                break;
            case FishProtocol.SYLZ_LOTTERY :
                this.handleSYLZLottery(byteBuf);
                break;
            case FishProtocol.JZSJ_CREATE_ROOM :
                this.handleJZSJCreate(byteBuf);
                break;
            case FishProtocol.JZSJ_GAME_START :
                this.handleJZSJStart(byteBuf);
                break;
            case FishProtocol.JZSJ_LOTTERY:
                this.handleJZSJLottery(byteBuf);
                break;
            case FishProtocol.JZSJ_STATUS :
                this.handleJZSJGameStatus(byteBuf);
                break;
            default :
                break;
        }
    },

    sendPlayerLoginRequest: function () {
        var player = appglobal.getPlayer();
        var req = createObj(FishProtocol.PlayerLoginReq);
        req.mainCmd = FishProtocol.GameBaseProto;
        req.subCmd = FishProtocol.PlayerLogin;
        req.lRoleId = player.roleid;
        req.iSourceId = appglobal.getSource();
        req.szGameToken = player.gametoken;
        this.pushSendReq(req);
        FYEngine.logObject(req, '-----sendPlayerLoginRequest : ');
    },

    handlePlayerLoginRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_PlayerLogin(byteBuf);
        FYEngine.logObject(rsp, "-----handlePlayerLoginRsp");
        if (rsp.iResult != 0) {
            this.setLoginStatus(false);
        } else {
            this._canSendNormalMsg = true;
            this.setCanSendHeart(true);
            var player = appglobal.getPlayer();
            player.gametoken = rsp.szGameToken;
            this.setLoginStatus(true);
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(GAME_NEW_EVENT.GAME_NEW_LOGIN_OK,rsp);
            }
        }
    },

    sendPlayerLogoutRequest: function () {

        var player = appglobal.getPlayer();
        var req = createObj(FishProtocol.PlayerLogoutReq);
        req.mainCmd = FishProtocol.GameBaseProto;
        req.subCmd = FishProtocol.PlayerLogout;
        req.lRoleId = player.roleid;
        this.pushSendReq(req);
        FYEngine.logObject(req, '-----sendPlayerLogoutRequest : ');
    },

    handlePlayerLogoutRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_PlayerLogout(byteBuf);
        FYEngine.logObject(rsp, '-------handlePlayehisrLogoutRsp');
    },

    sendPlayerReLoginRequest: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.GameBaseProto;
        req.subCmd = FishProtocol.ReLogin;
        req.lRoleId = player.roleid;
        req.szGameToken = player.gametoken;
        this.pushSendReq(req);
        FYEngine.logObject(req, '---发送relogin消息 : ');
    },

    handlePlayerReLoginRsp: function (byteBuf) {
        this._needReConnect = true;
        var rsp = FishProtocol.decode_PlayerReLogon(byteBuf);
        FYEngine.logObject(rsp, '------接收relogin消息:');
        if (rsp.iResult == 0) {
            FishGlobal.copyReloginTag = false;
            this._canSendNormalMsg = true;
            this.setCanSendHeart(true);
            this.setLoginStatus(true);
            this.resetReconnetCount();
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(GAME_NEW_EVENT.GAME_RELOGIN_OK);
            }
        } else {
            this.setLoginStatus(false);
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(GAME_NEW_EVENT.GAME_RELOGIN_FAIL, rsp);
            }
            //var layer = FYEngine.getRunningLayer(0);
            //layer._handler.sendLeaveTableReq();
            //layer._handler.sendPlayerLogoutRequest();
            //layer.scheduleOnce(layer.exitGame,0.1);
        }
    },


    ////
    sendJoinTabelReq: function (tableid) {
        var player = appglobal.getPlayer();
        var req = createObj(FishProtocol.JoinTableReq);
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.JoinTable;
        req.lRoleId = player.roleid;
        req.iRate = FishGlobal.getCopyRoomConfById(tableid - 1).iRate;
        req.iRoomId = tableid;
        this.pushSendReq(req);
        FYEngine.logObject(req, '-----sendJoinTabelRequest : ');
    },

    sendChangeCannonReq: function (iChairId, iRate, itype) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.ChangeCannon;
        req.lRoleId = player.roleid;
        req.iChairId = iChairId;
        req.iRate = iRate;
        req.iType = itype;
        this.pushSendReq(req);
        FYEngine.logObject(req, '-----sendChangeCannonReq : ');
    },

    sendFireBulletReq: function (iChairId, lBulletId, iRate, iRotate, iType) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.FireBullet;
        req.lRoleId = player.roleid;
        req.iChairId = iChairId;
        req.lBulletId = lBulletId;
        req.iRate = iRate;
        req.fRotate = iRotate;
        req.iType = iType;
        req.iFireTime = 0;
        req.bisValid = 0;  //0有效,1无效;
        this.pushSendReq(req);
        FYEngine.logObject(req, '----发送本地发射子弹消息-sendFireBulletReq : ');
    },

    sendHitFishReq: function (lBulletId, iHitFishId, iRate, iHitFishType, iFishNum, iFishId) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.Collision;
        req.lRoleId = player.roleid;
        req.lBulletId = lBulletId;
        req.iHitFishId = iHitFishId;
        req.iRate = iRate;
        req.iHitFishType = iHitFishType;
        req.bisValid = 1;
        req.iFishNum = iFishNum;
        req.iFishId = iFishId;
        this.pushSendReq(req);
        FYEngine.logObject(req, '---发送本地碰撞消息--sendHitFishReq : ');

    },

    sendCopyHitFishReq: function (lBulletId, iHitFishId, iRate, iHitFishType) {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.copyCollision;
        req.lRoleId = player.roleid;
        req.lBulletId = lBulletId;
        req.iHitFishId = iHitFishId;
        req.iRate = iRate;
        req.iHitFishType = iHitFishType;
        req.bisValid = 1;
        this.pushSendReq(req);
        FYEngine.logObject(req, '---发送本地碰撞消息2--sendHitFishReq : ');

    },

    sendLeaveTableReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.LeaveTable;
        req.lRoleId = player.roleid;
        this.pushSendReq(req);
        FYEngine.logObject(req, '---发送离开牌桌消息--sendLeaveTableReq : ');
    },

    sendAnycTableRequest: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.SyncTable;
        req.lRoleId = player.roleid;
        this.pushSendReq(req);
        FYEngine.logObject(req, '---发送同步牌桌消息--sendAnycTableRequest : ');
    },

    sendFishSceneReliveGetReq: function () {
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishSceneRelive;
        req.subCmd = FishProtocol.FishSceneReliveGet;
        req.lUserId = player.roleid;
        this.pushSendReq(req);
        FYEngine.logObject(req, '---发送获领取济金的消息--sendFishSceneReliveGetReq : ');
    },


    handleJoinTableRsp: function (byteBuf) {
        this.clearData();
        var rsp = FishProtocol.decode_JoinTable(byteBuf);
        FYEngine.logObject(rsp, '--------------加入牌桌消息返回:');
        if (rsp.iResult == 0) {
            FishGlobal.roomId = rsp.iRoomId;
            this._fishData.setSelfId(rsp.iChairId);

            for (var i = 0; i < rsp.tUserInfo.length; ++i) {
                this._fishData._userData[rsp.tUserInfo[i].iChairId] = rsp.tUserInfo[i];
            }
            this._bHeart = true;
            FYEngine.runScene(FishCopyLayer.createScene());
            var date = Date.parse(new Date());
            FishGlobal.copyTimeControl.gameStartTime = date;
            cc.log("--记录场次时间" + date);
            cc.sys.localStorage.setItem('copyRecordTime' + appglobal.getPlayer().userid, JSON.stringify(FishGlobal.copyTimeControl));
            FYEngine.logObject(FishGlobal.copyTimeControl, "--本地记录时间的：");
        } else {
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.getName() == "fishcopylobby") {
                scene.unschedule(scene.joinTableCheck);
                scene.removeLoading();
                FYEngine.AddCommToast("进入房间失败");
            }
        }
    },

    handleJoinEventRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_JoinEvent(byteBuf);
        this._fishData._userData[rsp.iChairId] = rsp.tUserInfo;
        this._fishData._eJoinArray.push(rsp);
        FYEngine.logObject(rsp, '--------------玩家加入牌桌事件:');
    },

    handleLeaveTableRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_LeaveTable(byteBuf);

        var userinfo = this._fishData._userData[rsp.iChairId];
        if (userinfo) {
            userinfo.lRoleId = -1;
            userinfo.iRate = FishGlobal.getFireRate(FishGlobal.roomId, 0);
            this._fishData._userData[rsp.iChairId] = userinfo;
            this._fishData._eLeaveArray.push(rsp);
        }
        FYEngine.logObject(rsp, '--------------玩家离开牌桌事件:');

    },

    handleSyncTableRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_SyncTable(byteBuf);
        FYEngine.logObject(rsp, '--------------玩家同步事件:');
        if (this._scene && rsp.iResult == 0) {
            this._fishData._selfId = rsp.iChairId;
            for (var i = 0; i < rsp.tUserInfo.length; ++i) {
                this._fishData._userData[rsp.tUserInfo[i].iChairId] = rsp.tUserInfo[i];
                this._scene.changeUserInfo();
            }
        }
    },

    handleTideStartRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_TideStart(byteBuf);
        this._fishData._fishTideTagTime = rsp.iSceneTime * 0.001;
        this._fishData._fishTideCome = true;
        if (this._fishData._fishTideTagTime < 4) {
            this._fishData._fishTideControl = false;
        }
        FYEngine.logObject(rsp, '--------------鱼潮开始事件:');
    },

    handleUpdateFishRsp: function (byteBuf) {
        var rsp = {};
        rsp.iSceneTime = byteBuf.getInt32() * 0.001;
        rsp.iCount = byteBuf.getInt32();
        for (var i = 0; i < rsp.iCount; ++i) {
            var info = {};
            info.iFishId = byteBuf.getInt32();
            info.iPathId = byteBuf.getInt16();
            info.iSpeed = byteBuf.getInt16();
            info.iOffsetX = byteBuf.getInt16();
            info.iOffsetY = byteBuf.getInt16();
            info.iBirthTime = byteBuf.getInt32() * 0.001;
            info.bSurprise = byteBuf.getUint8();
            info.tidefish = byteBuf.getInt8();
            byteBuf.getInt16();
            info.iAlieveTime = info.iBirthTime - rsp.iSceneTime;
            info.iFishType = info.iFishId >> 24;
            this._unbirthFishArr.push(info);
        }
        // if (this._gametime < rsp.iSceneTime){
        //     this._gametime = rsp.iSceneTime;
        // }
        this._gametime = rsp.iSceneTime;

        // var rsp = FishProtocol.decode_UpdateFish(byteBuf);
        // this._fishData._eFishArry.push(rsp);

        FYEngine.logObject(rsp, '--------------刷新鱼的事件:');
    },

    handleUpdateBulletRsp: function (byteBuf) {//游戏刚开始同步子弹返钱
        var rsp = FishProtocol.decode_UpdateBullet(byteBuf);
        for (var i = 0; i < rsp.bulletArry.length; ++i) {
            this._fishData._eShootArray.push(rsp.bulletArry[i]);
        }

        for (var j = 0; j < rsp.bulletArry.length; ++j) {
            this._fishData._userData[0].lGold += rsp.bulletArry[j].iRate;
            if (this._scene && this._scene._playerNode) {

                this._scene.changeUserGold();
            }
        }
        FYEngine.logObject(rsp, '--------------同步子弹事件:');
    },

    handleCollisionRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_Collision(byteBuf);
        // this._fishData._eHitArray.push(rsp);
        // FYEngine.logObject(rsp,'--------------刷新碰撞事件:');
    },

    handleCopyCollisionRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_CopyCollision(byteBuf);
        this._fishData._eHitArray.push(rsp);
        FYEngine.logObject(rsp, '--------------刷新碰撞事件:');
    },

    handleFireBulletRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_FireBullet(byteBuf);
        this._fishData._eShootArray.push(rsp);
        FYEngine.logObject(rsp, '--------------刷新子弹事件:');

    },

    handleChangeCannonRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_ChangeCannon(byteBuf);
        this._fishData._eCannonArray.push(rsp);
        FYEngine.logObject(rsp, '--------------刷新切换炮台事件:');
    },

    handleKillFishRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_CopyKillFish(byteBuf);
        // this._fishData._eKillArray.push(rsp);
        FYEngine.logObject(rsp, '--------------刷新打死鱼事件:');

    },

    handleCopyKillFishRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_CopyKillFish(byteBuf);
        this._fishData._eKillArray.push(rsp);
        FYEngine.logObject(rsp, '--------------新打死鱼事件:');
    },

    handleReliveInfoRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_ReliveInfo(byteBuf);

    },

    handleFishSceneBroadMsg: function (byteBuf) {
        var rsp = FishProtocol.decode_FishSceneBroadMsg(byteBuf);
        FYEngine.logObject(rsp, '--------------刷新渔场内广播事件:');
    },

    handleFishSceneReliveGetRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_FishSceneReliveGet(byteBuf);
//        FYEngine.logObject(rsp,'--------------渔场内领取救济金的消息:');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName('jiuji');
        if (layer) {
            layer.removeFromParent(true);
        }

        if (rsp.iResult != 0) {
            FYEngine.AddCommToast('领取救济金失败');
            return;
        }

        FYEngine.AddCommToast('领取救济金成功');
        FishGlobal.relivelimit = FishGlobal.relivelimit - 1;
//        cc.log('----渔场内--FishGlobal.relivelimit------'+FishGlobal.relivelimit);
        FishGlobal.reliveinfor.iDayCount = rsp.iTimes;
        this._fishData._userData[this._fishData._selfId].lGold = rsp.lTotalGold;
        scene._playerNode.changeUserGold(rsp.lTotalGold);
    },

    /**
     * 免费场被踢的消息
     * @param byteBuf
     */
    handleFreeGameKickNotice: function (byteBuf) {
//        var rsp = FishProtocol.decode_FreeGameKickNoticeRsp(byteBuf);
////        FYEngine.logObject(rsp,'--------------免费场被踢的消息:');
//        var scene =FYEngine.getRunningLayer(0);
//        if(scene){
//            var layer = scene.getChildByName("FreeKickToLobby");
//            if(!layer){
//                layer = new FreeKickToLobby(rsp.iReason);
//                scene.addChild(layer,FishZorder.poplayer,"FreeKickToLobby");
//            }
//            if(scene._bulletlayer.isAutoPlay()){
//                scene._bulletlayer.setAutoPlay(false);
//                var btn = FYEngine.getChild(scene._playerNode[this.getSelfId()],'autobtn');
//                btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
//                var autoeft = FYEngine.getChild(btn, 'autoeft');
//                if(autoeft){
//                    autoeft.removeFromParent(true);
//                }
//            }
//
//        }
    },

    changeUserGold: function (chairId, sub) {
//        cc.log('test101'+chairId);
        if (sub >= 0) {
            this._fishData._userData[chairId].lGold += sub;

        }
        else {
            if (this._fishData._userData[chairId].lGold >= Math.abs(sub)) {
                this._fishData._userData[chairId].lGold += sub;

            } else {
                cc.log('---------------理论上不应该进来的----------------');
                if (chairId == this.getSelfId()) {
                    var scene = FYEngine.getRunningLayer(0);
                    scene._playerNode.checkNeedSubBatteryLevel();
                }

            }
        }
    },
    /**
     *
     * @param btype 特殊类型 101核弹  102激光  103 闪电  104 锁定
     * @param pos  爆炸点
     * @param lBulletId
     */

    sendSpecialBullet: function (btype, pos, angle, bullet) {

    },

    handleFireSpecialRsp: function (byteBuf) {


    },

    sendSpecialHitReq: function (iFishNum, iFishId, iboomtype, bullet) {

    },

    handleKillSpecialFishRsp: function (byteBuf) {

    },

    sendUpdateWealthReq: function () {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.GameBaseProto;
        Req.subCmd = FishProtocol.GoldQuery;
        Req.lUserId = roleid;
        this.pushSendReq(Req);
    },

    handleUpdateWealthRsp: function (byteBuf) {
        var player = appglobal.getPlayer();
        var rsp = FishProtocol.decode_UpdateWealth(byteBuf);
        // FYEngine.logObject(rsp,'-----------内财富刷新:');
        player.crystal = rsp.lScore;

        var scene = FYEngine.getRunningLayer(0);

        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.refreshWealth);
        }
        //this.sendGetCrystalInfoReq();
    },

    sendGetSceneTimeReq: function () {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.copyGetTime;
        Req.lUserId = roleid;
        this.pushSendReq(Req);
        FYEngine.logObject(Req, "--------fasong获取场景时间:");

    },

    handleGetSceneTimeRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_getSceneTime(byteBuf);
        FYEngine.logObject(rsp, "--------获取场景时间:");
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(FishCopyEvent.getGameTime, rsp);
        }

    },

    sendCopyGetWealthReq: function () {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.copyGetWealth;
        Req.lUserId = roleid;
        this.pushSendReq(Req);
    },

    handleCopyGetWealthRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_copyGetWealth(byteBuf);
        FYEngine.logObject(rsp, "--------副本获取财富:");
        if (rsp.iResult == 0) {
            var player = appglobal.getPlayer();
            for (var i = 0; i < rsp.iCount; ++i) {
                if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.gold) {
                    player.gold = rsp.coinArry[i].iCoinCount;
                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.coup) {
                    player.coupon = rsp.coinArry[i].iCoinCount;
                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.score) {
                    player.score = rsp.coinArry[i].iCoinCount;
                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.exp) {

                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.diamon) {

                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.medal) {

                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.beike) {
                    player.beike = rsp.coinArry[i].iCoinCount;
                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.shuijing) {
                    player.shuijing = rsp.coinArry[i].iCoinCount;
                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.shanhu) {
                    player.shanhu = rsp.coinArry[i].iCoinCount;
                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.haixing) {
                    player.haixing = rsp.coinArry[i].iCoinCount;
                } else if (rsp.coinArry[i].iCoinType == FishGlobal.WealthType.zhenzhu) {
                    player.zhenzhu = rsp.coinArry[i].iCoinCount;
                }
            }


            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent) {
                scene.onGameEvent(FishCopyEvent.refreshWealth);
            }
        }
    },

    /**
     * 副本合成与出售
     * @param count 数量
     * @param proid 商品id
     * @param tag 出售或者熔炼的标志  1:熔炼， 2：出售
     */
    sendHechengReq: function (count, proid, tag) {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.copyCombine;
        Req.lUserId = roleid;
        Req.iCount = count;
        Req.iHechengId = proid;
        Req.iReserved = tag;
        this.pushSendReq(Req);
        FYEngine.logObject(Req, "--------发送副本合成材料:");
    },

    handleHechengRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_copyhHecheng(byteBuf);
        FYEngine.logObject(rsp, "--------副本合成材料:");
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(FishCopyLobbyLayer.HechengConfirmLayer)
            || scene.getChildByName(FishCopyLobbyLayer.CopySoldInfoLayer);
        if (layer) {
            layer.removeLoading();
            layer.unschedule(layer.timeCount);
        }
        if (rsp.iResult == 0) {
            this.sendCopyGetWealthReq();
            if (rsp.iReserved == 1) {
                var newlayer = new HechengSucessLayer(rsp);
                if (newlayer) {
                    scene.addChild(newlayer, FishZorder.poplayer, FishCopyLobbyLayer.HechengSucessLayer);
                    FYEngine.popupLayerAnimate(newlayer.layerbg);
                }
            } else {
                FYEngine.AddCommToast("恭喜您，出售成功");
            }
        } else {
            if (rsp.iReserved == 1) {
                FYEngine.AddCommToast("熔炼失败");
            } else {
                FYEngine.AddCommToast("出售失败");
            }
        }
    },

    sendHechengListReq: function () {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.copyCombList;
        Req.lUserId = roleid;
        this.pushSendReq(Req);
    },

    handleHechengListRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_copyhHechengList(byteBuf);
        FYEngine.logObject(rsp, "--------副本合成材料列表:");
        var scene = FYEngine.getRunningLayer(0);
        if (rsp.iResult == 0) {
            var layer = scene.getChildByName(FishCopyLobbyLayer.hechenglayer);
            if (layer && layer.initListViewItems) {
                layer.initListViewItems(rsp.iList);
            }
        } else {
            var layer = scene.getChildByName(FishCopyLobbyLayer.hechenglayer);
            if (layer && layer.failGetListItem) {
                layer.failGetListItem();
            }
        }
    },

    sendGetCopyRoomCfg: function () {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.copyGetConf;
        Req.lUserId = roleid;
        this.pushSendReq(Req);
    },

    handleGetCopyRoomCfg: function (byteBuf) {
        var rsp = FishProtocol.decode_getCopyRoomCfg(byteBuf);
        FYEngine.logObject(rsp, "--------获取副本房间的配置:");
        if (rsp.iResult == 0) {
            FishGlobal.copyRoomConf = rsp.iList;
            FYEngine.logObject(FishGlobal.copyRoomConf, "房间配置");
            FYEngine.runScene(FishCopyLobby.createScene());
        }

    },

    handleCopyResult: function (byteBuf) {
        var rsp = FishProtocol.decode_CopyResult(byteBuf);
        FYEngine.logObject(rsp, "--------副本的结果:");
        FishGlobal.CopyNumber = null;
        for (var i = 0; i < rsp.chip.length; ++i) {
            if (rsp.chip[i].iCoinType >= 6 && rsp.chip[i].iCoinType <= 10) {
                if (rsp.chip[i].iCoinCount != 0) {
                    FishGlobal.CopyNumber = rsp.chip;
                    break;
                }
            }
        }
        var scene = FYEngine.getRunningLayer(0);
        if (scene.getName() == 'fishcopylobby' && FishGlobal.CopyNumber) {
            var layer = scene.getChildByName(FishCopyLobbyLayer.CopyResultLayer);
            if (!layer) {
                layer = new CopyResultLayer(FishGlobal.CopyNumber);
                scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.CopyResultLayer);
                FishGlobal.CopyNumber = null;
            }
        }
    },

    sendGPlayerInfoReq: function () {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.GET_P_INFO;
        Req.lRoleId = roleid;
        this.pushSendReq(Req);
    },

    handleGPlayerInfoRsp: function (byteBuf) {
        var rsp = FishProtocol.decode_GameNewInfoRsp(byteBuf);//todo 这个里面加上金币 ,积分
        FYEngine.logObject(rsp, "--------handleGPlayerInfoRsp:");
        var scene = FYEngine.getRunningLayer(0);
        if (rsp.iResult == 0) {
            for (var i = 0; i < 3; ++i) {
                GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[i] = rsp.iBombTimes[i]
            }

            for (var j = 0; j < 3; ++j) {
                GAME_NEW_INT_DATA.LEFT_EX_ATTACK_TIMES[j] = GAME_NEW_INT_DATA.TOTAL_EX_ATTACK_TIME[j] - rsp.iBuyTimes[j];
            }

            for (var k = 0; k < 3; ++k) {
                GAME_NEW_INT_DATA.GAME2_ENTER_TIMES[k] = GAME_NEW_INT_DATA.GAME2_TOTAL_ENTER_TIMES[k] - rsp.iGameTimes[k];
            }
            appglobal.getPlayer().fishcoin = rsp.lYuBi;
            appglobal.getPlayer().score = rsp.lScore;
            GAME_NEW_INT_DATA.player.fishcoin = rsp.lYuBi;
            GAME_NEW_INT_DATA.player.gold = rsp.lGold;
            GAME_NEW_INT_DATA.player.score = rsp.lScore;
        }
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.GAME_NEW_INFO_OK, rsp);
        }
    },

    sendSYLZBuyBoom: function (iBuyCount, rate) {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.SYLZ_BUY_BOOM;
        Req.lRoleId = roleid;
        Req.iBuyCount = iBuyCount;
        Req.iRate = rate;
        FYEngine.logObject(Req, "--------sendSYLZBuyBoom:");
        this.pushSendReq(Req);
    },

    handleSYLZBuyBoom: function (byteBuf) {
        var rsp = FishProtocol.decode_GameNewBuyBoom(byteBuf);
        FYEngine.logObject(rsp, "--------handleSYLZBuyBoom:");
        if (rsp.iResult == 0) {
            GAME_NEW_INT_DATA.player.score = rsp.iScore;
            let index = -1;
            for (var i = 0; i < 3; ++i) {
                if (GAME_NEW_INT_DATA.ATTACK_PRICE[i] == rsp.iRate) {
                    index = i;
                    break;
                }
            }
            if (index >= 0) {
                GAME_NEW_INT_DATA.LEFT_ATTACK_TIMES[index] = rsp.iLeftCount;
                GAME_NEW_INT_DATA.LEFT_EX_ATTACK_TIMES[index] = GAME_NEW_INT_DATA.TOTAL_EX_ATTACK_TIME[index]-rsp.iBuyCount;
            } else {
                //todo 重新拉一下配置
            }
        } else {
            //todo 重新拉一下配置
        }
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.GAME_NEW_BUY_BOOM, rsp);
        }
    },

    sendSYLZLottery: function (iRate, iLotteryType) {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.SYLZ_LOTTERY;
        Req.lRoleId = roleid;
        Req.iRate = iRate;
        Req.iLotteryType = iLotteryType;
        FYEngine.logObject(Req, "--------sendSYLZLottery:");
        this.pushSendReq(Req);
    },

    handleSYLZLottery: function (byteBuf) {
        var rsp = FishProtocol.decode_GameNewSYLZLottery(byteBuf);
        FYEngine.logObject(rsp, "--------handleSYLZLottery:");
        if (rsp.iResult == 0) {
            GAME_NEW_INT_DATA.player.gold += rsp.lAddGold;
            GAME_NEW_INT_DATA.player.fishcoin += rsp.lAddYubi;
        } else {
            //todo 开奖失败的处理
        }
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.GAME_NEW_SYLZ_LOTTERY, rsp);
        }
    },

    sendJZSJCreate: function (iRate) {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.JZSJ_CREATE_ROOM;
        Req.lRoleId = roleid;
        Req.iRate = iRate;
        this.pushSendReq(Req);
    },

    handleJZSJCreate: function (byteBuf) {
        var rsp = FishProtocol.decode_GameNewJZSJCreate(byteBuf);
        FYEngine.logObject(rsp, "--------handleJZSJCreate:");
        if(rsp.iResult ==0){
            GAME_NEW_INT_DATA.roominfo.gamelefttime = rsp.iGameTime;
        }
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.JZSJ_CREATE_ROOM, rsp);
        }

    },

    sendJZSJStart: function () {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.JZSJ_GAME_START;
        Req.lRoleId = roleid;
        cc.log("sendJZSJStart");
        this.pushSendReq(Req);
    },

    handleJZSJStart: function (byteBuf) {
        var rsp = FishProtocol.decode_GameNewJZSJStart(byteBuf);
        FYEngine.logObject(rsp, "--------handleJZSJStart:");
        if(rsp.iResult ==0){
            GAME_NEW_INT_DATA.roominfo.gamelefttime = rsp.iGameTime;
        }
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.JZSJ_GAME_START, rsp);
        }
    },

    sendJZSJLottery: function (iLotteryType,posx,posy) {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.JZSJ_LOTTERY;
        Req.lRoleId = roleid;
        Req.iLotteryType = iLotteryType;
        Req.fx = posx;
        Req.fy = posy;
        FYEngine.logObject(Req, "--------sendJZSJLottery:");
        this.pushSendReq(Req);
    },

    handleJZSJLottery: function (byteBuf) {
        var rsp = FishProtocol.decode_GameNewJZSJLottery(byteBuf);
        FYEngine.logObject(rsp, "--------handleJZSJLottery:");
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.JZSJ_GAME_LOTTERY, rsp);
        }
    },

    sendJZSJGameStatus : function(){
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.JZSJ_STATUS;
        Req.lRoleId = roleid;
        this.pushSendReq(Req);
    },

    handleJZSJGameStatus : function(byteBuf){
        var rsp = FishProtocol.decode_GameNewJZSJSTATUS(byteBuf);
        FYEngine.logObject(rsp, "--------handleJZSJGameStatus:");
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(GAME_NEW_EVENT.JZSJ_GAME_STATUS, rsp);
        }
    },


});
