/**
 * Created by daichunfeng on 2016/11/16.
 */
var BatteryType = {
    Battery0 : 0,
    Battery1 : 1,
    Battery2 : 2,
};

var BatteryRes = {

    BatteryName : {
        BatterySelf : 'cannonself{0}.png',
        BatteryOther : 'cannonother{0}.png',
        BulletEftSelf : 'bulleteftself{0}.png',
        BulletEftOther : 'bulleteftother{0}.png',
        Count : 3,
    },

};

var BatteryLayerName = {
    Cannon : 'cannon',
    BulletEft : 'bulleteft',
    Gold : 'gold',
    Sub : 'btnsub',
    Add : 'btnadd',
};
var Battery = ccui.Layout.extend({
    _chairId : 0,
    _bSelf : false,
    _bDown : false,
    _radianx : Math.sin(FYMath.AngletoRadian(0)),
    _radiany : Math.cos(FYMath.AngletoRadian(0)),
    _handler : null,
    _index : 0,
    _type : 0,
    _rate : 0,
    _count : 0,
    _cannon : null,
    _ratelabel : null,
    _bulleteft : null,
    _localBulletArry : [],
    _bRevise : false,
    _cannonRotate : 80,
    _bulletPos : cc.p(0,0),
    _scene : null,
    _actiondone : false,
    _userId : 0,


    ctor : function(chairId){
        this._super();
        this._scene = FYEngine.getRunningLayer(0);
        this._chairId = chairId;
        if(this._chairId >1){
            this._bDown = true;
            this._radianx = Math.sin(FYMath.AngletoRadian(180));
            this._radiany = Math.cos(FYMath.AngletoRadian(180));
        }

        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        if(this._handler.getSelfId() == this._chairId){
            this._bSelf = true;
        }

        this._userId = this._handler._fishData._userData[chairId].lRoleId;

        this._rate = this._handler._fishData._userData[this._chairId].iRate;

        this._index = FishGlobal.getFireIndex(FishGlobal.roomId, this._rate);
        this._type = FishGlobal.getFireType(FishGlobal.roomId, this._index);

        if(this._chairId == 1 || this._chairId == 2){
            this._bRevise = true;
        }
        this._count = FishGlobal.getFiresCount(FishGlobal.roomId);

        this.setContentSize(cc.size(181,101));
        this.setAnchorPoint(cc.p(0,0));

        this.initBattery();
        this.createUserInfo(chairId);
        this.setVisible(false);
    },

    initBattery : function(){
        var namebg = new cc.Sprite();
        this.addChild(namebg, 1, 'namebg');
        if(appglobal._switch6 ==0){
            namebg.setSpriteFrame('returngold7.png');
            if(this._chairId>1){
                namebg.setFlippedY(true);
                namebg.setAnchorPoint(cc.p(0,0));
                namebg.setPosition(cc.p(0,0));
            }else{
                namebg.setAnchorPoint(cc.p(0,1));
                namebg.setPosition(cc.p(0,101));
            }
        }else{
            namebg.setAnchorPoint(cc.p(0,0));
            namebg.setPosition(cc.p(0,0));
            namebg.setSpriteFrame(this._chairId > 1 ? 'gameui33.png':'gameui32.png');
        }


        //var name = new cc.LabelTTF('玩家姓名','微软雅黑',18,cc.size(150,23),cc.TEXT_ALIGNMENT_CENTER,cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        var name = FYEngine.createLengthText('玩家姓名',18,150);
        name.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
        name.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
        this.addChild(name,1,'name');
        name.setAnchorPoint(cc.p(0.5,0.5));
        name.setPosition(this._chairId > 1 ? cc.p(this.width*0.5,this.height*0.17):cc.p(this.width*0.5,this.height*0.83));

        var batterysprite = this._batterysprite = new cc.Sprite(FishSceneRes.Png.TipsBatteryBg);
        this.addChild(batterysprite,1,'batterybg');
        batterysprite.setAnchorPoint(cc.p(0.5,this._chairId > 1 ? 0 : 1));
        batterysprite.setFlippedY(this._chairId <2);

        if(batterysprite){
            var bulleteft = new cc.Sprite();
            batterysprite.addChild(bulleteft, 0, 'bulleteft');
            bulleteft.setAnchorPoint(cc.p(0.5,0.5));
            bulleteft.setVisible(false);
            bulleteft.setSpriteFrame(this._bSelf?BatteryRes.BatteryName.BulletEftSelf.format(this._type):BatteryRes.BatteryName.BulletEftOther.format(this._type));
            bulleteft.setRotation(this._chairId > 1?0:180);
            bulleteft.setPosition(this._chairId > 1?cc.p(batterysprite.width*0.5,125):cc.p(batterysprite.width*0.5,-50));
            this._bulleteft = bulleteft;

            var cannon = new cc.Sprite();
            batterysprite.addChild(cannon, 0, 'cannon');
            cannon.setAnchorPoint(cc.p(0.5,0.4));
            cannon.setSpriteFrame(this._bSelf?BatteryRes.BatteryName.BatterySelf.format(this._type):BatteryRes.BatteryName.BatteryOther.format(this._type));
            cannon.setRotation(this._chairId > 1?0:180);
            cannon.setPosition(this._chairId > 1?cc.p(batterysprite.width*0.5,60):cc.p(batterysprite.width*0.5,15));
            this._cannon = cannon;

            var goldbg = new cc.Sprite(FishSceneRes.Png.TipsGoldBg);
            if(goldbg){
                this._goldbg = goldbg;
                batterysprite.addChild(goldbg,0,'goldbg');
                goldbg.setAnchorPoint(cc.p(0.5,0.5));
                goldbg.setFlippedY(this._chairId > 1?false:true);
                goldbg.setPosition(this._chairId > 1?cc.p(batterysprite.width*0.5,20):cc.p(batterysprite.width*0.5,55));
            }


            if(this._bSelf){
                var btnsub = new ccui.Button(FishSceneRes.Png.BatterySubNormal,FishSceneRes.Png.BatterySubPressed,'',ccui.Widget.PLIST_TEXTURE);
                batterysprite.addChild(btnsub,0,'btnsub');
                this._btnsub=btnsub;
                btnsub.setPosition(cc.p(20,this._chairId > 1?25:50));
                btnsub.addClickEventListener(this.btnClickCallBack);

                var btnadd = new ccui.Button(FishSceneRes.Png.BatteryAddNormal,FishSceneRes.Png.BatteryAddPressed,'',ccui.Widget.PLIST_TEXTURE);
                batterysprite.addChild(btnadd,0,'btnadd');
                this._btnadd=btnadd;
                btnadd.setAnchorPoint(cc.p(0.5,0.5));
                btnadd.setPosition(cc.p(151,this._chairId > 1?25:50));
                btnadd.addClickEventListener(this.btnClickCallBack);

                var autobtn = new ccui.ImageView(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
                autobtn.setTouchEnabled(true);
                autobtn.setSwallowTouches(true);
                autobtn.loadTexture(FishSceneRes.Png.AutoPlayBtn, ccui.Widget.PLIST_TEXTURE);
                //autobtn.setPosition(this._bRevise? cc.p(61,50):cc.p(230,10));
                if(this._chairId ==0){
                    autobtn.setPosition(cc.p(230,10));
                }else if(this._chairId ==1){
                    autobtn.setPosition(cc.p(-50,10));
                }else if(this._chairId ==2){
                    autobtn.setPosition(cc.p(-50,80));
                }else{
                    autobtn.setPosition(cc.p(230,80));
                }
                this.addChild(autobtn, 1, 'autobtn');
                autobtn.addClickEventListener(this.autoBtnClickCallBack);
            }

            switch(this._chairId){
                case 0 :{
                    this.setPosition(cc.p(0,539));
                    batterysprite.setPosition(cc.p(345,101));

                }break;
                case 1: {
                    this.setPosition(cc.p(955,539));
                    batterysprite.setPosition(cc.p(-165,101));

                }break;
                case 2:{
                    this.setPosition(cc.p(955,0));
                    batterysprite.setPosition(cc.p(-165,0));

                }break;
                case 3 : {
                    this.setPosition(cc.p(0,0));
                    batterysprite.setPosition(cc.p(345,0));

                }break;
                default:break;
            }
        }

    },

    backCannon : function(type,bool){
        this._goldbg.setVisible(false);
        this._cannon.setVisible(false);
        this._ratelabel.setVisible(false);
        if(this._bSelf){
            this._btnadd.setVisible(false);
            this._btnsub.setVisible(false);
        }

        if(bool){
            this._handler.sendChangeCannonReq(this._chairId,0, FishGlobal.BoomConf.iList[type].iBulletType);
        }

    },

    resetCannon : function(bool){
        this._goldbg.setVisible(true);
        this._cannon.setVisible(true);
        this._ratelabel.setVisible(true);
        if(this._bSelf){
            this._btnadd.setVisible(true);
            this._btnsub.setVisible(true);
        }
        // if(bool){
        //
        // }

    },

    createUserInfo : function(chairId){
        var ratetext = this._ratelabel = FYEngine.createAlts('res/num/fishnum5.png', 10, '0', '0');
        this._batterysprite.addChild(ratetext, 0, 'rate');
        ratetext.setPosition(this._chairId > 1 ? cc.p(this._batterysprite.width*0.5,16):cc.p(this._batterysprite.width*0.5,56));

        if(appglobal._switch6 ==0){
            var labgold = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
            labgold.setPosition(this._chairId > 1 ? cc.p(31, 47) : cc.p(31, 52));
            labgold.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(labgold, 1, 'labgold');
            this._labgold = labgold;
        }else{
            var pos = chairId > 1 ? cc.p(31, 83) : cc.p(31, 52);
            var labgold = this._labgold = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
            labgold.setPosition(pos);
            labgold.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(labgold, 1, 'labgold');

            var pos1 = chairId > 1 ? cc.p(31, 47) : cc.p(31, 17);
            var labcoupon = this._labcoupon = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
            labcoupon.setPosition(pos1);
            labcoupon.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(labcoupon, 1, 'labcoupon');
        }



    },

    showUserInfo : function(chairId){
        var userinfo = this._handler._fishData._userData[chairId];
        if (userinfo.lRoleId == -1){
            this.setVisible(false);
        }else{
            this.setVisible(true);
            var nametext = this.getChildByName('name');
            if(nametext){
                if(!this._bSelf && cc.sys.os == 'iOS' && appglobal._switch1 == 0){
                    var str = "玩家"+userinfo.lRoleId;
                    nametext.setString("玩家"+userinfo.lRoleId);
                    if(nametext.getContentSize().width>150){
                        var newstr = str;
                        var newstr2 = str+"...";
                        nametext.setString(newstr2);
                        while(nametext.getContentSize().width>150){
                            newstr = newstr.substring(0,newstr.length-1);
                            var newstr2 = newstr+"...";
                            nametext.setString(newstr2);
                        }
                        nametext.setString(newstr2);
                    }
                }else{
                    var str = userinfo.szNickName;
                    nametext.setString(userinfo.szNickName+'');
                    if(nametext.getContentSize().width>150){
                        var newstr = str;
                        var newstr2 = str+"...";
                        nametext.setString(newstr2);
                        while(nametext.getContentSize().width>150){
                            newstr = newstr.substring(0,newstr.length-1);
                            var newstr2 = newstr+"...";
                            nametext.setString(newstr2);
                        }
                        nametext.setString(newstr2);
                    }
                }


            }

            this._ratelabel && this._ratelabel.setString(this._rate+'');
            if (this._labgold){
                this._labgold.setString(''+userinfo.lGold);
                if(userinfo.lGold >= 1000000000){
                    switch(chairId){
                        case 1 : {
                            this._labgold.setAnchorPoint(cc.p(1,0.5));
                            this._labgold.setPosition(cc.p(this.width,52));
                        }break;
                        case 2 : {
                            this._labgold.setAnchorPoint(cc.p(1,0.5));
                            if(appglobal._switch6==0){
                                this._labgold.setPosition(cc.p(this.width,47));
                            }else{
                                this._labgold.setPosition(cc.p(this.width,83));
                            }
                        }break;
                        default:break;
                    }
                }else{
                    switch(chairId){
                        case 1 : {
                            this._labgold.setAnchorPoint(cc.p(0,0.5));
                            this._labgold.setPosition(cc.p(31,52));
                        }break;
                        case 2 : {
                            this._labgold.setAnchorPoint(cc.p(0,0.5));
                            if(appglobal._switch6==0){
                                this._labgold.setPosition(cc.p(31,47));
                            }else{
                                this._labgold.setPosition(cc.p(31,83));
                            }
                        }break;
                        default:break;
                    }
                }
            }


            if (this._labcoupon){
                this._labcoupon.setString(''+userinfo.lCoupon);
                if(userinfo.lCoupon >= 1000000000){
                    switch(chairId){
                        case 1 : {
                            this._labcoupon.setAnchorPoint(cc.p(1,0.5));
                            this._labcoupon.setPosition(cc.p(this.width,17));
                        }break;
                        case 2 : {
                            this._labcoupon.setAnchorPoint(cc.p(1,0.5));
                            this._labcoupon.setPosition(cc.p(this.width,47));
                        }break;
                        default:break;
                    }
                }else{
                    switch(chairId){
                        case 1 : {
                            this._labcoupon.setAnchorPoint(cc.p(0,0.5));
                            this._labcoupon.setPosition(cc.p(31,17));
                        }break;
                        case 2 : {
                            this._labcoupon.setAnchorPoint(cc.p(0,0.5));
                            this._labcoupon.setPosition(cc.p(31,47));
                        }break;
                        default:break;
                    }
                }
            }


            if(!this._bSelf){
                this.changeOtherCannon(userinfo.iRate,userinfo.iType);
            }
        }
    },

    changeUserRate : function(){
        this._rate = FishGlobal.getFireRate(FishGlobal.roomId, this._index);
        if(this._ratelabel){
            this._ratelabel.setString(this._rate+'');
        }
    },

    createBullet  : function(lbulletId, alivetime){
        var self = this;
        var curRotate = self._cannon.getRotation();
        if (self._cannonRotate != curRotate)
        {
            self._cannonRotate = curRotate;
            self._radianx = Math.sin(FYMath.AngletoRadian(self._cannonRotate));
            self._radiany = Math.cos(FYMath.AngletoRadian(self._cannonRotate));
            self._bulletPos = self.getBulletPos(self._cannonRotate);
            self._bulleteft.setRotation(self._cannonRotate);
            self._bulleteft.setPosition(self.getBulletEftPos(self._cannonRotate));
        }

        self._bulleteft.setVisible(true);
        self._bulleteft.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.05, 0.9), new cc.FadeIn(0.05)),
            new cc.Spawn(new cc.ScaleTo(0.05, 1), new cc.FadeOut(0.05))));

        FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.shoot_eft);

        ///添加子弹
        var layer = self._scene._bulletlayer;
        var bullet = Bullet.create(lbulletId, self._type, self._bulletPos,
            self._cannonRotate, FishGlobal.bulletSpeed, self._rate, self._bSelf,
            self._radianx, self._radiany, alivetime, self._userId);
        var tagname = "name"+lbulletId;
        layer.addChild(bullet, 11, tagname);

        self._scene._bulletArr.push(bullet);

        self._handler.changeUserGold(self._chairId, -self._rate);
        self._scene.changeUserGold(self._chairId);

        ///子弹事件
        if (self._bSelf){
            layer.reSetCount(1);
            self.pushBulletEvent(lbulletId, self._rate);
        }
    },

    autoBtnClickCallBack : function(sender){
//        cc.log('---------按键响应-------');
        var scene = FYEngine.getRunningLayer(0);
        var battery = scene._playerNode[scene._handler.getSelfId()];
        if(battery._handler._fishData._userData[battery._chairId]< battery._rate){
            battery.checkNeedSubBatteryLevel();
            return;
        }
        var layer = scene._bulletlayer;
        layer.setAutoPlay(!layer.isAutoPlay());
        var btn = battery.getChildByName('autobtn');
        if(layer.isAutoPlay()){
            btn.loadTexture(FishSceneRes.Png.AutoPlayOpenBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = btn.getChildByName('autoeft');
            if(!autoeft){
                var autoeft = new cc.Sprite(FishSceneRes.Png.AutoEft);
                if(autoeft){
                    btn.addChild(autoeft,0,'autoeft');
                    autoeft.setPosition(cc.p(btn.width/2,btn.height/2));
                    var rotate = new cc.RotateBy(1.2,360);
                    autoeft.runAction(new cc.RepeatForever(rotate));
                }
            }
        }else{
            btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
            var autoeft = btn.getChildByName('autoeft');
            if(autoeft){
                autoeft.removeFromParent(true);
            }
        }
    },

    btnClickCallBack : function(sender){
        var name = sender.getName();
        var battery = sender.getParent().getParent();
        ///切换炮
        if (name == BatteryLayerName.Sub){
            battery.setIndexandType(-1);
        }
        else{
            battery.setIndexandType(1);
        }
        battery.pushCannonEvent();
        battery.changeCannon();
    },

    setIndexandType : function(num){
        this._index += num;
        if (this._index == -1){
            this._index = this._count-1;
        }
        else if (this._index == this._count){
            this._index = 0;
        }
        this._type = FishGlobal.getFireType(FishGlobal.roomId, this._index);
    },

    shootBullet : function(){
        if (this._actiondone){
            return;
        }

        this._actiondone = true;
        var self = this;
        var xdelta = FYMath.getSinx(8, self._cannon.getRotation());
        var ydelta = FYMath.getCosx(8, self._cannon.getRotation());

        var id = FishGlobal.getAddBulletId(this._handler.getSelfId());
        self.createBullet(id, 0);
        this._cannon.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.05, 0.98, 0.9), new cc.MoveBy(0.05,cc.p(-xdelta,-ydelta))), new cc.Spawn(new cc.ScaleTo(0.05, 1),new cc.MoveBy(0.05,cc.p(xdelta,ydelta))), new cc.CallFunc(function(){
            self._actiondone = false;
        })));
    },


    adjustBattery : function(angle){
        this._cannon.setRotation(angle);
        this._bulleteft.setRotation(angle);
        this._bulleteft.setPosition(this.getBulletEftPos(angle));
    },

    shootServerBullet : function(id, rotate, type, rate, alivetime, userid){
        // cc.log("-------发射服务器子弹的id"+id+"userid:"+userid+"type:"+type+"rate:"+rate);
        var self = this;
        if(self._bSelf){
            return;
        }

        self._rate = rate;
        self._index = FishGlobal.getFireIndex(FishGlobal.roomId, self._rate);
        self._type = FishGlobal.getFireType(FishGlobal.roomId, self._index);
        self._cannon.setRotation(rotate);
        self._userId = userid;

        var xdelta = FYMath.getSinx(8, rotate);
        var ydelta = FYMath.getCosx(8, rotate);

        self.createBullet(id, alivetime);
        self._cannon.runAction(new cc.Sequence(new cc.Spawn(new cc.ScaleTo(0.05, 0.98, 0.9), new cc.MoveBy(0.05,cc.p(-xdelta,-ydelta))),
            new cc.Spawn(new cc.ScaleTo(0.05, 1), new cc.MoveBy(0.05,cc.p(xdelta,ydelta)))));
    },

    getBulletPos : function(rotation){
        var pos = this.getPosition();
        if (this._bDown){
            pos.y += 60;
        }
        else{
            pos.y -= 60;
        }

        var r = 50;
        var rotate = this._bDown ? rotation : rotation-180;
        if (this._bDown && rotate >= 270){
            rotate -= 360;
        }

        var offx = r*Math.sin(Math.abs(FYMath.AngletoRadian(rotate)));
        var offy = r*Math.cos(Math.abs(FYMath.AngletoRadian(rotate)));
        if (rotate == 0){
            pos.y -= r;
        }
        else if (rotate > 0){
            if(this._bDown){
                pos.x += Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x -= Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        else{
            if(this._bDown){
                pos.x -= Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x += Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        return pos;
    },

    getBulletEftPos : function(rotation){
        var pos = this._cannon.getPosition();

        var r = 65;
        var rotate = this._bDown ? rotation : rotation-180;
        if (this._bDown && rotate >= 270){
            rotate -= 360;
        }

        var offx = r*Math.sin(Math.abs(FYMath.AngletoRadian(rotate)));
        var offy = r*Math.cos(Math.abs(FYMath.AngletoRadian(rotate)));
        if (rotate == 0){
            pos.y -= r;
        }
        else if (rotate > 0){
            if(this._bDown){
                pos.x += Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x -= Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        else{
            if(this._bDown){
                pos.x -= Math.abs(offx);
                pos.y += Math.abs(offy);
            }
            else{
                pos.x += Math.abs(offx);
                pos.y -= Math.abs(offy);
            }
        }
        return pos;
    },

    changeCannon : function(status){
        if(status == undefined){
            FYEngine.Audio.playEffect(FishSceneRes.preloadAudioName.effect.change_gun);
        }
        var self = this;
        var scaleto = new cc.ScaleTo(0.05, 0.95, 0.9);
        var scaleto1 = new cc.ScaleTo(0.05, 1);
        var seq = new cc.Sequence(scaleto, scaleto1, new cc.DelayTime(0.05), new cc.CallFunc(function(){
            self.changeUserRate();
            var index = self._type - BatteryType.Battery0;
            var cannonstr = self._bSelf ? BatteryRes.BatteryName.BatterySelf : BatteryRes.BatteryName.BatteryOther;
            var name = cannonstr.format(index%getObjCount(BatteryType));
            self._cannon.setSpriteFrame(name);

            var eftstr = self._bSelf ? BatteryRes.BatteryName.BulletEftSelf : BatteryRes.BatteryName.BulletEftOther;
            var eftname = eftstr.format(index%BatteryRes.BatteryName.Count);
            self._bulleteft.setSpriteFrame(eftname);
        }));
        this._cannon.runAction(seq);
    },

    changeOtherCannon : function(rate,iType){
        if(iType ==0){
            this._index = FishGlobal.getFireIndex(FishGlobal.roomId, rate);
            this._type = FishGlobal.getFireType(FishGlobal.roomId, this._index);
            this._rate = rate;
            var self = this;
            var seq = new cc.Sequence(new cc.ScaleTo(0.05, 0.95, 0.9), new cc.ScaleTo(0.05, 1), new cc.CallFunc(function(){
                self.changeUserRate();
                var index = self._type - BatteryType.Battery0;
                var cannonstr = self._bSelf ? BatteryRes.BatteryName.BatterySelf : BatteryRes.BatteryName.BatteryOther;
                var name = cannonstr.format(index%getObjCount(BatteryType));
                self._cannon.setSpriteFrame(name);
                var eftstr = self._bSelf ? BatteryRes.BatteryName.BulletEftSelf : BatteryRes.BatteryName.BulletEftOther;
                var eftname = eftstr.format(index%BatteryRes.BatteryName.Count);
                self._bulleteft.setSpriteFrame(eftname);
            }));
            this._cannon.runAction(seq);
        }else{
            this.backCannon(iType);
        }

    },

    pushBulletEvent : function(lbulletId, iRate){
        var iRotate =this._cannon.getRotation();
        var iChairId = this._chairId;
        var iType = this._type;
        this._handler.sendFireBulletReq(iChairId,lbulletId,iRate,iRotate,iType)
    },

    pushCannonEvent : function(){
        this._rate = FishGlobal.getFireRate(FishGlobal.roomId, this._index);
        this._handler.sendChangeCannonReq(this._chairId,this._rate,0);
    },

    getRate : function(){
        return this._rate;
    },

    changeUserGold : function(lGold){
        cc.log("changeUserGold"+lGold);
        if (this._labgold){
            this._labgold.setString(''+lGold);
            if(this._bRevise){
                if(lGold>=1000000000){
                    if(this._labgold.getAnchorPoint().x ==1){
                        return;
                    }else{
                        this._labgold.setAnchorPoint(cc.p(1,0.5));
                        if(this._chairId ==1){
                            this._labgold.setPosition(cc.p(this.width,52));
                        }else{
                            if(appglobal._switch6==0){
                                this._labgold.setPosition(cc.p(this.width,47));
                            }else{
                                this._labgold.setPosition(cc.p(this.width,83));
                            }
                        }
                    }
                }else{
                    if(this._labgold.getAnchorPoint().x == 0){
                        return;
                    }else{
                        this._labgold.setAnchorPoint(cc.p(0,0.5));
                        if(this._chairId ==1){
                            this._labgold.setPosition(cc.p(31,52));
                        }else{
                            if(appglobal._switch6==0){
                                this._labgold.setPosition(cc.p(31,47));
                            }else{
                                this._labgold.setPosition(cc.p(31,83));
                            }
                        }
                    }

                }
            }
        }
    },

    changeUserCoupon : function(lCoupon){
        if (this._labcoupon){
            this._labcoupon.setString(''+lCoupon);
        }
    },

    checkNeedSubBatteryLevel : function(){
        var userinfo = this._handler._fishData._userData[this._handler.getSelfId()];
        if(FishGlobal.roomArr[FishGlobal.roomId - 1].goldFires.length >1){
            if(userinfo.lGold < FishGlobal.roomArr[FishGlobal.roomId - 1].goldFires[0]){
                if(this._index != 0){
                    this._index = 0;
                    this._type = FishGlobal.getFireType(FishGlobal.roomId, this._index);
                    this.changeCannon();
                    this.pushCannonEvent();
                }
//                cc.log('---------渔场内限制的次数:'+FishGlobal.relivelimit);
                
                    if(FishGlobal.relivelimit != 0){
                        var mlayer = this._scene.getChildByName('jiuji');
                        if(!mlayer){
                            mlayer = new ReliveLayer();
                            this._scene.addChild(mlayer, FishZorder.poplayer, 'jiuji');
                            FYEngine.popupLayerAnimate(mlayer.layerbg);
                        }
                        //this._handler.sendFishSceneReliveGetReq();
                    }else{
                        var mlayer = this._scene.getChildByName('gocharge');
                        if(!mlayer){
                            mlayer = new FishSceneGoCharge();
                            this._scene.addChild(mlayer, FishZorder.poplayer, 'gocharge');
                            FYEngine.popupLayerAnimate(mlayer.layerbg);
                        }
                    }
                
            }else{
                for(var i = 0; i < FishGlobal.roomArr[FishGlobal.roomId - 1].goldFires.length -1 ; ++i){
                    if(userinfo.lGold >= FishGlobal.roomArr[FishGlobal.roomId - 1].goldFires[i] && userinfo.lGold <FishGlobal.roomArr[FishGlobal.roomId - 1].goldFires[i+1]){
                        this._index = i;
                        this._type = FishGlobal.getFireType(FishGlobal.roomId, this._index);
                        this.changeCannon();
                        this.pushCannonEvent();
                    }
                }
            }
        }
    },


    getPosition : function(){
        var pos = cc.p(0,0);
        switch (this._chairId){
            case 0:{
                pos = cc.p(345, 640);
            }
                break;
            case 1:{
                pos = cc.p(790, 640);
            }
                break;
            case 2:{
                pos = cc.p(790, 0);
            }
                break;
            case 3:{
                pos = cc.p(345, 0);
            }
                break;
            default:
                pos = cc.p(345, 640);
                cc.log('--------initBattery error');
                break;
        }
        return pos;
    },

    resetBattery : function(){
        this._type = 0;
        this._rate = FishGlobal.getFireRate(FishGlobal.roomId, 0);
        if (this._bDown){
            this._cannon.setRotation(0);
        }
        else{
            this._cannon.setRotation(180);
        }

        this._bulleteft.setSpriteFrame(BatteryRes.BatteryName.BulletEftSelf.format(0));
        this.resetCannon();
        this.changeCannon(true);

    },


});

var Rocket = cc.Node.extend({
    id:0,
    _isflying:false,
    _type:0,
    ctor:function(chaire,type){
        this._super();
        this._isflying =false;
        var rockname = "#fish_boom"+(27+type)+".png";
        cc.log("-----rocketname:"+rockname);
        var sprite = new cc.Sprite(rockname);
        if(sprite){
            sprite.setAnchorPoint(cc.p(0.5,0.4));
            sprite.setPosition(cc.p(0,1));
            this.addChild(sprite);
        }

        var boonlight = cc.AnimationCache.getInstance().getAnimation('rockfire');
        var stemp = new cc.Sprite();
        stemp.setAnchorPoint(cc.p(0.5,1));
        stemp.setPosition(cc.p(-2, -40));
        this.addChild(stemp, 0);
        stemp.runAction(new cc.RepeatForever(new cc.Animate(boonlight)));

        this.id= FishGlobal.getAddBulletId(chaire);
    },

    getid :function(){
        return this.id;
    },

    isFlying : function(){
        return this._isflying;
    },

    setFlying : function(bool){
        this._isflying = bool;
    },

});

var GameCostManager = {

    costMoney : function(number){//
        cc.log("------输钱"+number);
        if(appglobal._playerCostControl == false && appglobal._playerLocationControl == false){
            return true;
        }
        var date = new Date();
        var monthcost = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'monthcost'+date.getFullYear()+date.getMonth());
        if(monthcost){
            cc.log(monthcost+"costMoney"+FishGlobal._addmoneymon);
            if((Number(monthcost) - FishGlobal._addmoneymon)>FishGlobal.loseMoneyLimit.monthlevel){
                this.leaveGame();
                return false;
            }else{
                var cost = Number(monthcost)+number;
                cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'monthcost'+date.getFullYear()+date.getMonth(), ""+cost);
            }
        }else{
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'monthcost'+date.getFullYear()+date.getMonth(), ""+number);
        }

        var dailycost = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'dailycost'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(dailycost){
            if((Number(dailycost) - FishGlobal._addmoneydaily)>FishGlobal.loseMoneyLimit.dailylevel){
                this.leaveGame();
                return false
            }else{
                var cost = Number(dailycost)+number;
                cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'dailycost'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                    ""+cost);
            }
        }else{
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'dailycost'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                ""+number);
        }

        return true;

    },

    addMoney : function(number){
        cc.log("------赢钱"+number);
        if(appglobal._playerCostControl == false && appglobal._playerLocationControl == false){
            return true;
        }
        cc.log(FishGlobal._addmoneymon+"addMoney"+number);
        var date = new Date();
        var monthadd = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'monthadd'+date.getFullYear()+date.getMonth());
        if(monthadd){

            FishGlobal._addmoneymon = Number(monthadd)+number;
            cc.log("1addMoney"+FishGlobal._addmoneymon);
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'monthadd'+date.getFullYear()+date.getMonth(), ""+FishGlobal._addmoneymon);
        }else{
            FishGlobal._addmoneymon = number;
            cc.log("2addMoney"+FishGlobal._addmoneymon);
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'monthadd'+date.getFullYear()+date.getMonth(), ""+FishGlobal._addmoneymon);
        }

        var dailyadd = cc.sys.localStorage.getItem(appglobal.getPlayer().userid+'dailyadd'+date.getFullYear()+date.getMonth()+date.getUTCDate());
        if(dailyadd){
            FishGlobal._addmoneydaily = Number(dailyadd)+number;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'dailyadd'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                ""+FishGlobal._addmoneydaily);
        }else{
            FishGlobal._addmoneydaily = number;
            cc.sys.localStorage.setItem(appglobal.getPlayer().userid+'dailyadd'+date.getFullYear()+date.getMonth()+date.getUTCDate(),
                ""+FishGlobal._addmoneydaily);
        }
    },

    leaveGame : function(){
        var gamelayer = FYEngine.getRunningLayer(0);
        if(gamelayer.getName == "fishcopyscene"){
            var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
            if(gamehandle && gamehandle._canSendNormalMsg){
                gamehandle.sendLeaveTableReq();
            }
            FishGlobal.copyTimeControl.copyGameLeftTime =0;
            cc.sys.localStorage.setItem('copyRecordTime'+appglobal.getPlayer().userid,JSON.stringify(FishGlobal.copyTimeControl));
            gamelayer.exitGame();
        }else{
            var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
            if(gamehandle && gamehandle._canSendNormalMsg){
                gamehandle.sendLeaveTableReq();
                gamehandle.sendPlayerLogoutRequest();
            }
            gamelayer.runAction(new cc.Sequence(new cc.DelayTime(0.5), new cc.CallFunc(function(){
                gamelayer.exitGame();
            })));
        }
    },

};
