
var BulletType = {
    Bullet0 : 0,
    Bullet1 : 1,
    Bullet2 : 2,
};

///子弹图片
var BulletFrameName = {
    BulletSelf : 'bulletself{0}.png',
    BulletOther : 'bulletother{0}.png',
    Count : 5,
};

///渔网图片
var FishNetPng = {
    Net : '#net{0}.png',
    Count : 2,
    net : '#net3.png',
};

var Bullet = cc.Sprite.extend({
    _Id : 0,
    _Type : BulletType.Bullet0,
    _rate : 0,
    _Rotate : 0,
    _Speed : 0,
    _startPos : cc.p(0,0),
    _bSelf : false, //是否是自己的子弹
    _radianx : 0,
    _radiany : 0,
    _alievetime : 0,
    _userId : 0,
    _removetime : 0,

    ctor : function(type, bself){
        this._super();
        this._Type = type;
        this._bSelf = bself;
        this.initBullet();
    },

    setBulletInfo : function(id, type, startpos, rotate, speed, rate, bself, radianx, radiany, alievetime, userid){
        this._Id = id;
        this._Type = type;
        this._Speed = speed;
        this._startPos = startpos;
        this.setPosition(this._startPos);
        this._bSelf = bself;
        this._rate = rate;
        this._Rotate = rotate;
        this.setRotation(this._Rotate);
        this.setTag(id);
        this._alievetime = alievetime;
        this._radianx = radianx;//Math.sin(FYMath.AngletoRadian(rotate));
        this._radiany = radiany;//Math.cos(FYMath.AngletoRadian(rotate));
        this._userId = userid;
        if(this._alievetime < 0){
            this.initOriginalPosition();
        }

        this.scheduleUpdate();
    },

    bulletschedule : function(callback, interval){
        var then = Date.now();
        interval = interval*1000;
        this.schedule(function(){
            var now = Date.now();
            var delta = now-then;
            if (delta > interval){
                then = now - (delta%interval);
                callback.call(this);
            }
        }.bind(this), 0);
    },

    initOriginalPosition : function(){
//        cc.log('----子弹initOriginalPosition---');
        var rotate = this._Rotate;
        var curx = this.x+this._radianx*Math.abs(this._alievetime)*this._Speed;
        var cury = this.y+this._radiany*Math.abs(this._alievetime)*this._Speed;
        var size = FYEngine.winSize;
        if (cury >= size.height){
            var ytop = Math.floor(cury/size.height);
            var ytopcount = ytop%2;
            if(ytopcount ==0){
                cury = cury-ytop*size.height;

            }else{
                this._Rotate = 180-rotate;
                this.setRotation(this._Rotate);
                this._radiany = -this._radiany;
                cury = (ytop+1)*size.height - cury;
            }
        }
        else if (cury <= 0){
            var ybutton = Math.floor(Math.abs(cury)/size.height);
            var ybuttoncount = ybutton%2;
            if(ybuttoncount ==0){
                this._Rotate = 180-rotate;
                this.setRotation(this._Rotate);
                this._radiany = -this._radiany;
                cury = -cury-ybutton*size.height;

            }else{
                cury = (ybutton+1)*size.height+cury;
            }
        }
        if (curx >= size.width){
            var xright = Math.floor(curx/size.width);
            var xrightcount = xright%2;
            if(xrightcount ==0){
                curx = curx-xright*size.width;

            }else{
                this._Rotate = -this._Rotate;
                this.setRotation(this._Rotate);
                this._radianx = -this._radianx;
                curx = (xright+1)*size.width - curx;
            }
        }
        else if (curx <= 0){
            var xleft = Math.floor(Math.abs(curx)/size.width);
            var xleftcount = xleft%2;
            if(xleftcount ==0){
                this._Rotate = -this._Rotate;
                this.setRotation(this._Rotate);
                this._radianx = -this._radianx;
                curx = -curx-xleft*size.width;
            }else{
                curx = size.width-Math.abs((curx+xleft*size.width));
            }
        }

        this._alievetime = 0;
        this.x = curx;
        this.y = cury;

    },

    initBullet : function(){
        var index = this._Type - BulletType.Bullet0;
        var namestr = this._bSelf ? BulletFrameName.BulletSelf : BulletFrameName.BulletOther;
        this.setSpriteFrame(namestr.format(index));
    },

    startMove : function(dt){
        var rotate = this._Rotate;
        if (this._alievetime < 0){
            dt -= this._alievetime;
            this._alievetime = 0;
        }
        var curx = this.x+this._radianx*dt*this._Speed;
        var cury = this.y+this._radiany*dt*this._Speed;
        var size = FYEngine.winSize;
        if (cury >= size.height){
            this._Rotate = 180-rotate;
            this.setRotation(this._Rotate);
            this._radiany = -this._radiany;
            cury = size.height;
        }
        else if (cury <= 0){
            this._Rotate = 180-rotate;
            this.setRotation(this._Rotate);
            this._radiany = -this._radiany;
            cury = 0;
        }
        else if (curx >= size.width){
            this._Rotate = -rotate;
            this.setRotation(this._Rotate);
            this._radianx = -this._radianx;
            curx = size.width;
        }
        else if (curx <= 0){
            this._Rotate = -rotate;
            this.setRotation(this._Rotate);
            this._radianx = -this._radianx;
            curx = 0;
        }

        this.x = curx;
        this.y = cury;
        //cc.log('--------子弹id: '+this._Id+'---子弹坐标 [x: '+this.x+', y: '+this.y+' ]');
    },

    update : function(dt){
        if (this.isVisible() == false){
            return;
        }

        this.startMove(dt);

         if (!this._bSelf){
             this._removetime += dt;
             if (this._removetime >= 10){
                cc.log('-----超时子弹---------'+this._Id);
                 //this._removetime = 0;
 //                var scene = FYEngine.getRunningLayer(0);
 //                scene.removeLocalBUllet(this._Id);
             }
         }

    },

    openFishNet : function(){
        var pos = this.getPosition();
        this.removeSelf();

        var scene = FYEngine.getRunningLayer(0);
        var fishnet = FishNet.create();
        fishnet.setPosition(pos);
        scene.addChild(fishnet, FishZorder.bulletLayer);

        var neteft = FishNetEft.create();
        neteft.setPosition(fishnet.getPosition());
        scene.addChild(neteft, FishZorder.bulletLayer);
    },

    removeSelf : function(){
        var scene = FYEngine.getRunningLayer(0);
        scene._bulletArr.remove(this);

        cc.pool.putInPool(this);
    },

    getId : function(){
        return this._Id;
    },

    getRate : function(){
        return this._rate;
    },

    getSelf : function(){
        return this._bSelf;
    },

    getUserId : function(){
        return this._userId;
    },

    unuse : function(){
        this._Id = 0;
        this._bSelf = false;
        this._Type = 0;
        this._removetime = 0;
        this.stopAllActions();
        this.unscheduleAllCallbacks();
        this.setVisible(false);
        this.removeAllChildren(true);
        this.removeFromParent(true);
    },

    reuse : function(type, bself){
        this._Type = type;
        this._bSelf = bself;
        this._removetime = 0;
        this.setVisible(true);
        this.initBullet();
    },

});

Bullet.create = function(id, type, startpos, rotate, speed, rate, bself, radianx, radiany, alievetime, userid){
    var bullet = null;
    if (cc.pool.hasObject(Bullet)){
        bullet = cc.pool.getFromPool(Bullet, type, bself);
    }
    else{
        bullet = new Bullet(type, bself);
//        cc.log('--------bullet pool is not enough, type: '+type+'-----self:'+bself);
    }
    bullet.setBulletInfo(id, type, startpos, rotate, speed, rate, bself, radianx, radiany, alievetime, userid);
    return bullet;
};


/***
 * 渔网
 */
var FishNet = cc.Sprite.extend({
    _bSelf : false,


    ctor : function(bself){
        //var index = this._bSelf ? 1 : 2;
        this._super(FishNetPng.net);
        this.setScale(0);
        this.createAni();
    },

    createAni : function(){
        var scale1 = new cc.ScaleTo(0.05, 0.5);
        var scale2 = new cc.ScaleTo(0.25, 1.2);
        var delay = new cc.DelayTime(0.08);
        var scale3 = new cc.ScaleTo(0.12, 0.3);
        var fade = new cc.FadeTo(0.12, 0);
        var self = this;
        this.seq = new cc.Sequence(scale1, scale2, delay, new cc.Spawn(scale3, fade), new cc.CallFunc(function(){
            cc.pool.putInPool(self);
        }));
        this.seq.retain();
    },

    openNet : function(){
        this.runAction(this.seq);
    },

    unuse : function(){
        this.stopAllActions();
        this.removeFromParent();
    },

    reuse : function(){
        this.setScale(0);
        this.setOpacity(255);
        this.openNet();
    },

});

FishNet.create = function(){
    var fishnet = null;
    if (cc.pool.hasObject(FishNet)){
        fishnet = cc.pool.getFromPool(FishNet);
    }
    else{
        fishnet = new FishNet();
        fishnet.setOpacity(255);
        fishnet.openNet();
        cc.log('--------FishNet pool is not enough self:');
    }

    return fishnet;
};

var FishNetEft = cc.Sprite.extend({
    _netEft : null,
    ctor : function(){
        this._super();
        var self = this;
        this._netEft = cc.sequence(FYEngine.createAnimate('bulleteft'), cc.callFunc(function(){
                //cc.log('--------特效放进缓存');
                cc.pool.putInPool(self);
        }));
        this._netEft.retain();
    },

    unuse : function(){
        this.stopAllActions();
        this.removeFromParent(true);
    },

    reuse : function(){
        this.runAction(this._netEft);
    },
});

FishNetEft.create = function(){
    var fishnet = null;
    if (cc.pool.hasObject(FishNetEft)){
        fishnet = cc.pool.getFromPool(FishNetEft);
    }
    else{
        fishnet = new FishNetEft();
        fishnet.runAction(fishnet._netEft);
        cc.log('--------Fisheft pool is not enough self:');
    }
    return fishnet;
};


var BulletLayer = cc.Layer.extend({
    _bTouched : false,
    _bulletCount : 0,
    _isAutoPlay : false,
    _shoottime : 0,
    _touchtime : -1,
    _scene : null,
    _timeCount : 0,
    _time : 0,
    _posarr : [],
    _endtimemark:0,
    _arrlength :0,
    _startcount : 0,
    _lastposid:0,
    _handler : null,
    _canOpenFire : true,
    _noverrange:true,//没有超过数量
    _hastoomore:false,

    ctor : function(){
        this._super();
        this._scene = FYEngine.getRunningLayer(0);
        this._handler = CoreServiceProxy.getInstance().getGameHandler();
        this.createBulletPool();
        this.createFishNetPool();
        this._posarr = [];
        this._endtimemark = 0;
        this._arrlength=0;
        this._startcount =0;
        this._lastposid=0;
        this._noverrange =true;
        this._hastoomore =false;

        ///触摸监听
        this.addTouchListener();
        this.schedule(this.updateFire,0.033);
        //this.schedule(this.openFire,FishGlobal.bulletTimes);
        //this.schedule(this.update, 1/30);
    },

    openFire : function(){
        if ((this._isAutoPlay || this._bTouched)&&this._handler._fishData._fishTideControl && this._canOpenFire){
            //cc.log('发射子弹---------------------'+this._bTouched);
                var handlerMsg = this._handler._fishData;
                this._scene.shootBullet(handlerMsg._selfId);
                this._timeCount = 0;
                var mlayer = this._scene.getChildByName('timeoutlayer');
                if(mlayer){
                    mlayer.removeFromParent(true);
                }
        }
    },

    createBulletPool : function(){

    },

    createFishNetPool : function(){
        
    },

    updateFire : function(dt){
        var self = this;
        if(this._handler._canSendNormalMsg == false){
//            cc.log('-------断线了');
            return;
        }
        if(this._startcount ==1){
            this._endtimemark += dt;
            if(this._endtimemark > 1){
                this._startcount = 0;
                this._endtimemark = 0;
                this._posarr.splice(this._lastposid);
                //this._arrlength = this._arrlength - 1;
                if(this._posarr.length ==!0){
                    var angle =this.caculateFinalAngleByArry(this._handler.getSelfId(),this,this._posarr);
                    this._scene.adjustBattery(this._handler.getSelfId(), angle);
                }

            }
        }
        this._timeCount += dt;
        if(this._timeCount >= 120){
            if(this._isAutoPlay ==false){
                //this._timeCount = 0;
                var mlayer = this._scene.getChildByName('timeoutlayer');
                if(!mlayer && this._handler && this._handler._canSendNormalMsg){
                    var mlayer = new TimeoutLayer();
                    this._scene.addChild(mlayer, FishZorder.poplayer ,'timeoutlayer');
                }
            }
        }

        if(this._bulletCount <=15){

            this._noverrange = true;
            if(this._hastoomore){
                var layer = this._scene.getChildByName("toomore");
                if (layer) {
                    layer.removeFromParent(true);
                }
                this._hastoomore = false;
            }

        }

        if (this._bulletCount == 30){

            if(this._noverrange ==true){
                if(this._isAutoPlay||this._bTouched){
                    //this._canOpenFire = false;
                    var layer = this._scene.getChildByName("toomore");
                    if (!layer) {
                        this._hastoomore =true;
                        // this._bTouched = false;
                        layer = new DialogLayer();
                        this._scene.addChild(layer, FishZorder.poplayer, "toomore");
                        var bg = layer.addLayerBg(cc.size(612, 303));
                        var toast = new cc.Sprite(FishSceneRes.Png.tooMoreToast);
                        toast.setPosition(cc.p(bg.width / 2, 207));
                        bg.addChild(toast);
                        var self =this;
                        var confirmCallBack = function (sender) {
                            self._hastoomore =false;
                            sender.getParent().getParent().removeFromParent(true);
                            //self._canOpenFire = true;
                        };
                        layer.addConfirmBtn(confirmCallBack, cc.p(bg.width / 2, 74),"#iknow.png");
                    }
                }
                this._noverrange = false;
            }

            return;
        }
        if ((this._isAutoPlay || this._bTouched)&&this._handler._fishData._fishTideControl&&this._noverrange &&(FishGlobal.isBoom ==false)){
            //cc.log('发射子弹---------------------'+this._bTouched);
            if (this._shoottime == 0){
                var handlerMsg = this._handler._fishData;
                this._scene.shootBullet(handlerMsg._selfId);
                this._shoottime += dt;
                this._timeCount = 0;
                var mlayer = this._scene.getChildByName('timeoutlayer');
                if(mlayer){
                    mlayer.removeFromParent(true);
                }
                return;
            }

            this._shoottime += dt;
            if (this._shoottime >= FishGlobal.bulletTimes){
                this._shoottime = 0.0001;
                var handlerMsg =this._handler._fishData;
                this._scene.shootBullet(handlerMsg._selfId);
                this._timeCount = 0;
                var mlayer = this._scene.getChildByName('timeoutlayer');
                if(mlayer){
                    mlayer.removeFromParent(true);
                }
            }
        }
    },


    reSetCount : function(addnum){
        this._bulletCount += addnum;
        if (this._bulletCount > 30){
            this._bulletCount = 30;
        }
        else if (this._bulletCount < 0){
            this._bulletCount = 0;
        }
    },

    getTouched : function(){
        return this._bTouched;
    },

    addTouchListener : function(){
        var self = this;
        var selfId = self._handler.getSelfId();
        var listener = cc.EventListener.create({
            event : cc.EventListener.TOUCH_ALL_AT_ONCE,
            swallowTouches: true,
            onTouchesBegan: function (touches, event) {
                if(FishGlobal._ControlBtnEx){
                    return false;
                }
                var target = event.getCurrentTarget();
                //cc.log('--------'+touches[0].getId());
                target._startcount = 0;
                target._endtimemark = 0;
                //FYEngine.logObject(touches[0].getID(),'------------START ID :');
                target._posarr.push(touches[0].getLocation());
                target._arrlength = target._arrlength+1;
                var angle =target.caculateFinalAngleByArry(selfId,target,target._posarr);

                self._scene.adjustBattery(selfId, angle);
                self._noverrange = true;
                if(self._isAutoPlay){

                    self._scene.setTouchEffect(touches[0].getLocation());
                }
                else{
                    target._bTouched = true;
                    target._shoottime = 0;
                    self._scene.setTouchEffect(touches[0].getLocation());
                }
                return true;
            },

            onTouchesMoved : function(touches, event){
                if(FishGlobal._ControlBtnEx){
                    return false;
                }
                var target = event.getCurrentTarget();
                target._startcount = 0;
                target._endtimemark = 0;
                target._arrlength = touches.length;
                var angle =target.caculateFinalAngle(selfId,target,touches);
                self._scene.adjustBattery(selfId, angle);
                //FYEngine.logObject(touches,'------------moved Final angel :');
                //self._scene.adjustBattery(selfId, pos);
            },

            onTouchesCancelled : function(touches, event){
                var target = event.getCurrentTarget();
                //cc.log('cancel----------------------');
                target._bTouched = false;
            },

            onTouchesEnded: function (touches, event) {
                //cc.log('ended----------------------');
                //FYEngine.logObject(touches[0].getID(),'--------------END ID');
                if(FishGlobal._ControlBtnEx){
                    return false;
                }
                var target = event.getCurrentTarget();
                if(target._arrlength ==1 && target._posarr.length ==1){
//                    cc.log('test1');
                    target._startcount = 0;
                    target._endtimemark = 0;
                    target._posarr=[];
                    target._arrlength = 0;
                    target._bTouched = false;
                }else{
                    if(target._arrlength == target._posarr.length){
//                        cc.log('test2');
                        target._endtimemark = 0;
                        //FYEngine.logObject(touches[0].getID(), '---------------77777777777777777777------------');
                        target._lastposid =touches[0].getID();
                        target._startcount = 1;
                        target._arrlength =target._arrlength-1;
                    }else{
//                        cc.log('test3');
                        //FYEngine.logObject(touches[0].getID(), '---------------8888888888888888888------------');
                        target._startcount = 0;
                        target._endtimemark = 0;
                        target._arrlength =target._arrlength-1;
                        target._posarr.splice(touches[0].getID());
                        target._posarr.splice(target._lastposid);
                        if(target._posarr.length !=0){
                            var angle =target.caculateFinalAngleByArry(selfId,target,target._posarr);
                            self._scene.adjustBattery(selfId, angle);
                        }else{
                            target._bTouched = false;
                        }
                    }
                }


                //FYEngine.logObject(target._posarr,'------------最终的数组数量:');


                //
                //var index = target._posarr.indexOf(touches);
                //target._posarr.splice(index);
                //var angle =target.caculateFinalAngle(selfId,target,target._posarr);
                //FYEngine.logObject(target._posarr.length,'------------ended Final angel :');
                //self._scene.adjustBattery(selfId, angle);
                //target._bTouched = false;
            },
        });
        cc.eventManager.addListener(listener, this);
    },

    isAutoPlay : function(){
        return this._isAutoPlay;
    },

    setAutoPlay : function(status){
        this._isAutoPlay = status;
        this._shoottime = 0;
        this._noverrange = true;
    },

    caculateFinalAngleByArry : function(selfId,target,arry){
        var sum = 0;
        for(var i =0;i<arry.length;i++){
            var angle =target.caculateAngle(selfId,arry[i]);
            sum+=angle;
        }
        return sum/arry.length;
    },

    caculateFinalAngle : function(selfId,target,touches){
        var sum = 0;
        for(var i = 0;i < touches.length; i++){
            var angle = target.caculateAngle(selfId, touches[i].getLocation());
            this._posarr[i] = touches[i].getLocation();
            sum += angle;
        }
        return sum/touches.length;
    },

    caculateAngle : function(selfId,endpos){

        var battery = this._scene.getBattery(selfId);
        var pos = battery.getPosition();
        if (battery._bDown){
            pos.y += 60;
        }
        else{
            pos.y -= 60;
        }

        var rotate = FYMath.getAngle(pos.x, pos.y, endpos.x, endpos.y);
        if(battery._bDown){
            if(-180 <= rotate && rotate< (-90)){
                rotate = -90;
            }else if(180 > rotate && rotate >90){
                rotate = 90;
            }else if(180 <= rotate && rotate< 270){
                rotate = -90;
            }
        }else{
            if(rotate >=0 && rotate <90){
                rotate = 90;
            }else if( 270<rotate && rotate<360){
                rotate = 270;
            }else if(-90<rotate && rotate<0){
                rotate = 270;
            }
        }
        return rotate;
    }

});


var GoldProps = cc.Sprite.extend({
    _type : 0,
    _repet : null,

    ctor : function(type){
        this._super();

        this._type = type;
        this.setScale(0.2);
        var coinname = type ? FishSceneRes.Png.FishCoin : FishSceneRes.Png.FishCoin1;
        this._repet = new cc.RepeatForever(FYEngine.createFrameAni(coinname, 4, 0.4));
        this._repet.retain();
        this.runAction(this._repet);
    },


    startTomove : function(beginpos, endpos, index){
        var self = this;
        var moveup = new cc.MoveBy(0.2, cc.p(0, 60));
        var movedown = new cc.MoveBy(0.4, cc.p(0, -60));
        var distance = FYMath.getDistance(beginpos.x, beginpos.y, endpos.x, endpos.y);
        var moveto = new cc.MoveTo(distance*0.002, endpos);//
        var seq = new cc.Sequence(new cc.DelayTime(0.03*(index%10)),
            new cc.Spawn(moveup.easing(cc.easeOut(3)), new cc.ScaleTo(0.3, 1)),
            movedown.easing(cc.easeIn(3)), new cc.DelayTime(0.8),
            new cc.DelayTime(0.1),
            moveto.easing(cc.easeIn(3)), new cc.DelayTime(0.4),
            new cc.CallFunc(function(){
                FYEngine.pool.putInPoolbyTag(self, self._type);
            }));
        this.runAction(seq);
    },

    startToMoveFast : function(beginpos, endpos, index){
        var self = this;
        var moveup = new cc.MoveBy(0.2, cc.p(0, 60));
        var movedown = new cc.MoveBy(0.4, cc.p(0, -60));
        var distance = FYMath.getDistance(beginpos.x, beginpos.y, endpos.x, endpos.y);
        var moveto = new cc.MoveTo(distance*0.002, endpos);//
        var seq = new cc.Sequence(new cc.DelayTime(0.03*(index%10)),
            new cc.Spawn(moveup.easing(cc.easeOut(1)), new cc.ScaleTo(0.3, 1)),
            movedown.easing(cc.easeIn(1)),
            new cc.DelayTime(0.4),
            moveto.easing(cc.easeIn(1)), new cc.DelayTime(0.4),
            new cc.CallFunc(function(){
                FYEngine.pool.putInPoolbyTag(self, self._type);
            }));
        this.runAction(seq);
    },
    
    unuse : function(){
        this.setVisible(false);
        this.stopAllActions();
        this.retain();
        this.removeFromParent();
    },

    reuse : function(){
        this.setScale(0.2);
        this.setVisible(true);
        this.runAction(this._repet);
    },

});

GoldProps.create = function(type){
    var gold = null;
    if (FYEngine.pool.hasObjectbyTag(GoldProps, type)){
        gold = FYEngine.pool.getFromPoolbyTag(GoldProps, type);
    }
    else{
//        cc.log('------------GoldProps.create 金币缓存不足'+type);
        gold = new GoldProps(type);
    }
    return gold;
};
