/**
 * Created by mintao on 16/6/12.
 */

var FishHandler = ClientHandler.extend({
    _fishData : null,
    _selfId : 0,
    _scene : null,
    _bHeart : false,
    _gametime : 0, //服务器场景时间
    _unbirthFishArr : [],


    ctor: function(){
        this._super();
        this.setReconnetMaxCount(3);
        this.setHeartBeatTime(1);
        this.setReconnetMaxTime(5);
        this._fishData = new FishData();
    },

    getMsgHandler : function(){
        return this._fishData;
    },

    clearData : function(){
        this._fishData.clearData();
        this._unbirthFishArr = [];
    },

    setScene : function(scene){
        this._scene = scene;
    },

    getSelfId : function(){
        return this._fishData._selfId;
    },

    getShootArr : function(){
        return this._fishData._eShootArray;
    },

    /***
     * 链接成功失败可能会有一些逻辑展示
     * @param event_id
     */
    onConnectEvent : function(event_id){
        if (event_id == eClientEvent.EVENT_CONNECT_OK){
//            cc.log("-----连接游戏服务器成功----");
        }
        else{
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.onGameEvent && (scene.getName() == 'fishscene') ){
                scene.onGameEvent(FishGameEventID.unConnect, 1);
            }
        }
    },

    /***
     * 公私钥消息完成与否的一些逻辑处理
     * @param issuccess 0成功 其他失败
     */
    onAccessEvent : function(issuccess){
//        cc.log('--------------游戏服务器acess信息-----'+issuccess);
        if (issuccess == 0){
            if(FYEngine.getRunningLayer(0).getName() == 'fishscene'){
                this.sendPlayerReLoginRequest();
            }else{
                this.sendPlayerLoginRequest();
            }

        }
        else{
            cc.log("-----公私钥验证失败-------");
        }
    },

    /***
     * 发送消息 override
     * @param subCmd
     * @param req
     */
    sendDataMsg : function(subCmd, req){
        switch (req.mainCmd){
            case FishProtocol.GameBaseProto:
                this.sendGameBaseMsg(subCmd, req);
                break;
            case FishProtocol.FishProto:
                if(this._canSendNormalMsg){
                    this.sendFishProtoMsg(subCmd, req);
                }
                break;
            case FishProtocol.FishSceneRelive :
                if(this._canSendNormalMsg){
                    this.sendFishSceneReliveMsg(subCmd, req);
                }
                break;
            default:
                break;
        }
    },

    /***
     * receive msg
     * @param mainCmd
     * @param subCmd
     * @param byteBuf
     */
    handleDataMsg : function(mainCmd, subCmd, byteBuf){
         cc.log('----FishHandler handleDataMsg mainCmd : '+mainCmd+', subCmd: '+subCmd);
        switch (mainCmd){
            case FishProtocol.GameBaseProto:
                this.handleGameBaseMsg(subCmd,byteBuf);
                break;
            case FishProtocol.FishProto:
                this.handleFishProtoMsg(subCmd,byteBuf);
                break;
            case FishProtocol.FishBroad :
                this.handleFishBroadMsg(subCmd,byteBuf);
                break;
            case FishProtocol.FishSceneRelive :
                this.handlerFishSceneReliveMsg(subCmd, byteBuf);
                break;
            default:
                break;
        }
    },


    /****
     * 游戏基础消息
     * @param subCmd
     * @param Req
     */
    sendGameBaseMsg : function(subCmd, req){
        switch(subCmd){
            case FishProtocol.PlayerLogin:
                FishProtocol.encode_PlayerLogin(req, this._sendBuf);
                break;
            case FishProtocol.PlayerLogout:
                FishProtocol.encode_PlayerLogout(req, this._sendBuf);
                break;
            case FishProtocol.ReLogin :
                FishProtocol.encode_PlayerReLogon(req, this._sendBuf);
                break;
            case FishProtocol.GoldQuery:
                FishProtocol.encode_UpdateWealth(req, this._sendBuf);
                break;
            default:
                break;
        }
    },

    sendFishProtoMsg : function(subCmd, req){
        switch(subCmd){
            case FishProtocol.JoinTable :
                FishProtocol.encode_JoinTable(req, this._sendBuf);
                break;
            case FishProtocol.Collision :
                FishProtocol.encode_HitFish(req, this._sendBuf);
                break;
            case FishProtocol.FireBullet :
                FishProtocol.encode_FireBullet(req, this._sendBuf);
                break;
            case FishProtocol.ChangeCannon :
                FishProtocol.encode_ChangeCannon(req, this._sendBuf);
                break;
            case FishProtocol.LeaveTable :
                FishProtocol.encode_LeaveTable(req, this._sendBuf);
                break;
            case FishProtocol.SyncTable :
                FishProtocol.encode_SyncTable(req, this._sendBuf);
                break;
            case FishProtocol.FireSpecial:
                FishProtocol.encode_FireSpecialBullet(req, this._sendBuf);
                break;
            case FishProtocol.KillSpecialFish:
                FishProtocol.encode_SpecialHitFish(req, this._sendBuf);
                break;
            case FishProtocol.getBulletType :
                FishProtocol.encode_getBulletType(req, this._sendBuf);
                break;
            default : break;
        }
    },

    sendFishSceneReliveMsg : function(subCmd, req){
        switch(subCmd){
            case FishProtocol.FishSceneReliveGet :
                FishProtocol.encode_FishSceneReliveGet(req, this._sendBuf);
                break;
            default : break;
        }
    },

    handleGameBaseMsg : function(subCmd,byteBuf){
        switch(subCmd){
            case FishProtocol.PlayerLogin:
                this.handlePlayerLoginRsp(byteBuf);
                break;
            case FishProtocol.PlayerLogout:
                this.handlePlayerLogoutRsp(byteBuf);
                break;
            case FishProtocol.ReLogin :
                this.handlePlayerReLoginRsp(byteBuf);
                break;
            case FishProtocol.GoldQuery:
                this.handleUpdateWealthRsp(byteBuf);
                break;
            default:
                break;
        }
    },

    handleFishBroadMsg : function(subCmd,byteBuf){
        switch (subCmd){
            case FishProtocol.FishBroadMsg :
                this.handleFishSceneBroadMsg(byteBuf);
                break;
            default : break;
        }
    },

    handlerFishSceneReliveMsg : function(subCmd, byteBuf){
        switch(subCmd){
            case FishProtocol.FishSceneReliveGet :
                this.handleFishSceneReliveGetRsp(byteBuf);
                break;
            default : break;
        }
    },

    handleFishProtoMsg : function(subCmd,byteBuf){
        // this._heartBeat = 0;
        this._needReConnect = true;
        switch(subCmd){
            case FishProtocol.JoinTable :
                this.handleJoinTableRsp(byteBuf);
                break;
            case FishProtocol.JoinEvent :
                this.handleJoinEventRsp(byteBuf);
                break;
            case FishProtocol.LeaveTable :
                this.handleLeaveTableRsp(byteBuf);
                break;
            case FishProtocol.SyncTable :
                this.handleSyncTableRsp(byteBuf);
                break;
            case FishProtocol.TideStart :
                this.handleTideStartRsp(byteBuf);
                break;
            case FishProtocol.UpdateFish :
                this.handleUpdateFishRsp(byteBuf);
                break;
            case FishProtocol.UpdateBullet :
                this.handleUpdateBulletRsp(byteBuf);
                break;
            case FishProtocol.Collision :
                this.handleCollisionRsp(byteBuf);
                break;
            case FishProtocol.FireBullet :
                this.handleFireBulletRsp(byteBuf);
                break;
            case FishProtocol.ChangeCannon :
                this.handleChangeCannonRsp(byteBuf);
                break;
            case FishProtocol.KillFish :
                this.handleKillFishRsp(byteBuf);
                break;
            case FishProtocol.OnReliveInfo :
                this.handleReliveInfoRsp(byteBuf);
                break;
            case FishProtocol.FreeRommKick:
                this.handleFreeGameKickNotice(byteBuf);
                break;
            case FishProtocol.FireSpecial:
                this.handleFireSpecialRsp(byteBuf);
                break;
            case FishProtocol.KillSpecialFish:
                this.handleKillSpecialFishRsp(byteBuf);
                break;
            case FishProtocol.getBulletType :
                this.handleGetBulletTypeRsp(byteBuf);
                break;
            default :
                break;
        }
    },

    sendPlayerLoginRequest : function () {
        var player = appglobal.getPlayer();
        var req = createObj(FishProtocol.PlayerLoginReq);
        req.mainCmd = FishProtocol.GameBaseProto;
        req.subCmd = FishProtocol.PlayerLogin;
        req.lRoleId = player.roleid;
        req.iSourceId = appglobal._appCfg.source;
        req.szGameToken = player.gametoken;
        this.pushSendReq(req);
         // FYEngine.logObject(req, '-----sendPlayerLoginRequest : ');
    },

    handlePlayerLoginRsp : function(byteBuf){
        var rsp = FishProtocol.decode_PlayerLogin(byteBuf);
        FYEngine.logObject(rsp,"--handlePlayerLoginRsp:");
        if (rsp.iResult != 0){
            this.setLoginStatus(false);
            cc.log('-------登录游戏服务器失败, rsp.iResult:'+rsp.iResult);
            return;
        }
        this._canSendNormalMsg = true;
        this.setCanSendHeart(true);
        var player = appglobal.getPlayer();
        player.gametoken = rsp.szGameToken;

         //cc.log('-------登录游戏服务器成功'+rsp.szGameToken);

        //this.sendJoinTabelReq();
        this.setLoginStatus(true);
        this.sendGetBulletTypeReq();
    },

    sendPlayerLogoutRequest : function(){

        var player = appglobal.getPlayer();
        var req = createObj(FishProtocol.PlayerLogoutReq);
        req.mainCmd = FishProtocol.GameBaseProto;
        req.subCmd = FishProtocol.PlayerLogout;
        req.lRoleId = player.roleid;
        this.pushSendReq(req);
        // FYEngine.logObject(req, '-----sendPlayerLogoutRequest : ');
        //var coreserviceproxy = CoreServiceProxy.getInstance();
        //coreserviceproxy.unlinkGameClient();
    },

    handlePlayerLogoutRsp : function(byteBuf){
        var rsp = FishProtocol.decode_PlayerLogout(byteBuf);
        // FYEngine.logObject(rsp, '-------handlePlayehisrLogoutRsp');
    },

    sendPlayerReLoginRequest : function(){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.GameBaseProto;
        req.subCmd = FishProtocol.ReLogin;
        req.lRoleId = player.roleid;
        req.szGameToken = player.gametoken;
        this.pushSendReq(req);
        // FYEngine.logObject(req, '---发送断线重连消息--sendPlayerReLoginRequest : ');
    },

    handlePlayerReLoginRsp : function(byteBuf){
        this._needReConnect = true;
        var rsp = FishProtocol.decode_PlayerReLogon(byteBuf);
        // FYEngine.logObject(rsp, '------捕鱼服务器 --重连-handlePlayehisrReLoginRsp:');
        if(rsp.iResult ==0){
            this._canSendNormalMsg = true;
            this.setCanSendHeart(true);
            this.setLoginStatus(true);
            this.resetReconnetCount();
            this.sendAnycTableRequest();
            var scene = FYEngine.getRunningLayer(0);
            if(scene && scene.onGameEvent){
                scene.onGameEvent(FishGameEventID.unConnect, 2);
            }
        }else{
            this.setLoginStatus(false);
            //var layer = FYEngine.getRunningLayer(0);
            //layer._handler.sendLeaveTableReq();
            //layer._handler.sendPlayerLogoutRequest();
            //layer.scheduleOnce(layer.exitGame,0.1);
        }
    },


    ////
    sendJoinTabelReq : function(){
        var player = appglobal.getPlayer();
        var req = createObj(FishProtocol.JoinTableReq);
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.JoinTable;
        req.lRoleId = player.roleid;
        req.iRate = FishGlobal.getFireRate(FishGlobal.roomId, 0);
        req.iRoomId = FishGlobal.roomId;
        this.pushSendReq(req);
        FYEngine.logObject(req, '-----sendJoinTabelRequest : ');
    },

    sendChangeCannonReq : function(iChairId, iRate,itype){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.ChangeCannon;
        req.lRoleId = player.roleid;
        req.iChairId = iChairId;
        req.iRate = iRate;
        req.iType = itype;
        this.pushSendReq(req);
        FYEngine.logObject(req, '-----sendChangeCannonReq : ');
    },

    sendFireBulletReq : function(iChairId,lBulletId,iRate,iRotate,iType){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.FireBullet;
        req.lRoleId = player.roleid;
        req.iChairId = iChairId;
        req.lBulletId = lBulletId;
        req.iRate = iRate;
        req.fRotate = iRotate;
        req.iType = iType;
        req.iFireTime = 0;
        req.bisValid = 0;  //0有效,1无效;
        this.pushSendReq(req);
        // FYEngine.logObject(req, '----发送本地发射子弹消息-sendFireBulletReq : ');
    },

    sendHitFishReq : function(lBulletId,iHitFishId,iRate,iHitFishType,iFishNum,iFishId){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.Collision;
        req.lRoleId = player.roleid;
        req.lBulletId = lBulletId;
        req.iHitFishId = iHitFishId;
        req.iRate = iRate;
        req.iHitFishType = iHitFishType;
        req.bisValid = 1;
        req.iFishNum = iFishNum;
        req.iFishId = iFishId;
        this.pushSendReq(req);
//        FYEngine.logObject(req, '---发送本地碰撞消息--sendHitFishReq : ');

    },

    sendLeaveTableReq : function(){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.LeaveTable;
        req.lRoleId = player.roleid;
        this.pushSendReq(req);
        // FYEngine.logObject(req, '---发送离开牌桌消息--sendLeaveTableReq : ');
    },

    sendAnycTableRequest : function(){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.SyncTable;
        req.lRoleId = player.roleid;
        this.pushSendReq(req);
//        FYEngine.logObject(req, '---发送同步牌桌消息--sendAnycTableRequest : ');
    },

    sendFishSceneReliveGetReq : function(){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishSceneRelive;
        req.subCmd = FishProtocol.FishSceneReliveGet;
        req.lUserId = player.roleid;
        this.pushSendReq(req);
//        FYEngine.logObject(req, '---发送获领取济金的消息--sendFishSceneReliveGetReq : ');
    },


    handleJoinTableRsp : function(byteBuf){
        this.clearData();
        var rsp = FishProtocol.decode_JoinTable(byteBuf);
        FYEngine.logObject(rsp,'--------------加入牌桌消息返回:');
        if(rsp.iResult ==0){
            this._fishData.setSelfId(rsp.iChairId);

            for (var i = 0; i < rsp.tUserInfo.length; ++ i){
                this._fishData._userData[rsp.tUserInfo[i].iChairId] = rsp.tUserInfo[i];
            }
            this._bHeart = true;
            FYEngine.runScene(FishLayer.createScene());
        }else{
            CoreServiceProxy.getInstance().unlinkGameClient();
            var scene = FYEngine.getRunningLayer(0);
            if(scene.getName() == "lobbyscene"){
                if(scene.getChildByName("loadinglayer")!=null){
                    var layer = scene.getChildByName("loadinglayer");
                    layer.removeFromParent();
                }
                scene.unschedule(scene.joinTableCheck);
            }
            if(rsp.iResult ==2735){
                FYEngine.AddCommToast("比赛已结束");
            }else if(rsp.iResult ==2731){
                FYEngine.AddCommToast("比赛未开始");
            }else if(rsp.iResult ==2732){
                FYEngine.AddCommToast("暂时无法加入比赛，请稍后再试");
            }else if(rsp.iResult == -2){
                FYEngine.AddCommToast("参赛券不足");
            }
        }

    },

    handleJoinEventRsp : function(byteBuf){
        var rsp = FishProtocol.decode_JoinEvent(byteBuf);
        this._fishData._userData[rsp.iChairId] = rsp.tUserInfo;
        this._fishData._eJoinArray.push(rsp);
//        FYEngine.logObject(rsp,'--------------玩家加入牌桌事件:');
    },

    handleLeaveTableRsp : function(byteBuf){
        var rsp = FishProtocol.decode_LeaveTable(byteBuf);

        var userinfo = this._fishData._userData[rsp.iChairId];
        if (userinfo){
            userinfo.lRoleId = -1;
            userinfo.iRate = FishGlobal.getFireRate(FishGlobal.roomId, 0);
            this._fishData._userData[rsp.iChairId] = userinfo;
            this._fishData._eLeaveArray.push(rsp);
        }
//        FYEngine.logObject(rsp,'--------------玩家离开牌桌事件:');

    },

    handleSyncTableRsp : function(byteBuf){
        var rsp = FishProtocol.decode_SyncTable(byteBuf);
        if(this._scene && rsp.iResult == 0){
            this._fishData._selfId = rsp.iChairId;
            for (var i = 0; i < rsp.tUserInfo.length; ++ i){
                this._fishData._userData[rsp.tUserInfo[i].iChairId] = rsp.tUserInfo[i];
                this._scene.changeUserInfo(rsp.tUserInfo[i].iChairId);
            }
        }

    },

    handleTideStartRsp : function(byteBuf){
        var rsp = FishProtocol.decode_TideStart(byteBuf);
        this._fishData._fishTideTagTime = rsp.iSceneTime*0.001;
        this._fishData._fishTideCome = true;
        if(this._fishData._fishTideTagTime < 4){
            this._fishData._fishTideControl = false;
        }
        FYEngine.logObject(rsp,'--------------鱼潮开始事件:');
    },

    handleUpdateFishRsp : function(byteBuf){
        var rsp ={};
        rsp.iSceneTime = byteBuf.getInt32()*0.001;
        rsp.iCount = byteBuf.getInt32();
        for(var i = 0; i < rsp.iCount; ++i){
            var info = {};
            info.iFishId = byteBuf.getInt32();
            info.iPathId = byteBuf.getInt16();
            info.iSpeed = byteBuf.getInt16();
            info.iOffsetX = byteBuf.getInt16();
            info.iOffsetY = byteBuf.getInt16();
            info.iBirthTime = byteBuf.getInt32()*0.001;
            info.bSurprise = byteBuf.getUint8();
            info.tidefish = byteBuf.getInt8();
            byteBuf.getInt16();
            info.iAlieveTime = info.iBirthTime-rsp.iSceneTime;
            info.iFishType = info.iFishId >> 24;
            if(appglobal._switch8==0){
                if((info.iFishType >= FishServerType.Fish24 &&  info.iFishType<=FishServerType.Fish30) || info.iFishType >=FishServerType.Fish74){
//                    cc.log('-----------奖券鱼:'+info.iFishType);
                    continue;
                }
            }
            this._unbirthFishArr.push(info);
        }
        // if (this._gametime < rsp.iSceneTime){
        //     this._gametime = rsp.iSceneTime;
        // }
        this._gametime = rsp.iSceneTime;

        // var rsp = FishProtocol.decode_UpdateFish(byteBuf);
        // this._fishData._eFishArry.push(rsp);

         FYEngine.logObject(rsp,'--------------刷新鱼的事件:');
    },

    handleUpdateBulletRsp : function(byteBuf){
        var rsp = FishProtocol.decode_UpdateBullet(byteBuf);
        for(var i = 0;i < rsp.bulletArry.length; ++i){
            if (this.IsUserAlieve(rsp.bulletArry[i].iChairId, rsp.bulletArry[i].lRoleId)){
                this._fishData._eShootArray.push(rsp.bulletArry[i]);
            }
        }

        for(var j = 0;j < rsp.bulletArry.length; ++j){
            for(var k =0; k< 4; ++k){
                if(rsp.bulletArry[j].iChairId == this._fishData._userData[k].iChairId){
                    this._fishData._userData[k].lGold+= rsp.bulletArry[j].iRate;
//                    cc.log('------------第:'+k+'个玩家反钱');
                }

                if(this._scene && this._scene._playerNode[k]){
//                    cc.log('------------第:'+k+'个玩家反钱改变显示');
                    this._scene.changeUserGold(k);
                }
            }
        }


        // FYEngine.logObject(rsp,'--------------同步子弹事件:');
    },

    handleCollisionRsp : function(byteBuf){
        var rsp = FishProtocol.decode_Collision(byteBuf);
        if (this.IsUserAlieve(-1, rsp.lRoleId)){
            this._fishData._eHitArray.push(rsp);
        }

//       FYEngine.logObject(rsp,'--------------刷新碰撞事件:');
    },

    handleFireBulletRsp : function(byteBuf){
        var rsp = FishProtocol.decode_FireBullet(byteBuf);
        if (this.IsUserAlieve(rsp.iChairId, rsp.lRoleId)){
            this._fishData._eShootArray.push(rsp);
        }

//       FYEngine.logObject(rsp,'--------------刷新子弹事件:');

    },

    handleChangeCannonRsp : function(byteBuf){
        var rsp = FishProtocol.decode_ChangeCannon(byteBuf);
        if (this.IsUserAlieve(rsp.iChairId, rsp.lRoleId)){
            this._fishData._eCannonArray.push(rsp);
        }
        // FYEngine.logObject(rsp,'--------------刷新切换炮台事件:');
    },

    handleKillFishRsp : function(byteBuf){
        var rsp = FishProtocol.decode_KillFish(byteBuf);
        if (this.IsUserAlieve(-1, rsp.lRoleId)){
            this._fishData._eKillArray.push(rsp);
        }
        else{
            //cc.log('------tEventArr[i].lUserId: '+rsp.lRoleId+ '++++i+++'+i);
        }

       // FYEngine.logObject(rsp,'--------------刷新打死鱼事件:');

    },

    handleReliveInfoRsp : function(byteBuf){
        var rsp = FishProtocol.decode_ReliveInfo(byteBuf);
        if(appglobal.getPlayer().roleid == rsp.lRoleId){
            return;
        }
        for(var j =0 ; j< this._fishData._userData.length;++j){
            if(this._fishData._userData[j].lRoleId == rsp.lRoleId){
                this.changeUserGold(this._fishData._userData[j].iChairId, FishGlobal.reliveinfor.iAddGold);
//                cc.log('其他玩家领取救济金后金币增加'+FishGlobal.reliveinfor.iAddGold);
                this._scene.changeUserGold(this._fishData._userData[j].iChairId);

            }
        }

    },

    handleFishSceneBroadMsg : function(byteBuf){
        var rsp = FishProtocol.decode_FishSceneBroadMsg(byteBuf);
        // FYEngine.logObject(rsp,'--------------刷新渔场内广播事件:');
        if(appglobal._switch7==0){
            return;
        }
        if(FishGlobal.LiveLevel ==0 ||(FishGlobal.playerscorelevel<FishGlobal.realProSwitch)
            || (FishGlobal.playerscorelevel < FishGlobal.rankCoupon)){
            var number = rsp.szMsg.indexOf("真是太厉害了");
            if(number>0){
                return;
            }
            if(this._fishData._fishSceneBroadArry.length !=0){
                var i =0;
                for(; i< this._fishData._fishSceneBroadArry.length; ++i){
                    if(this._fishData._fishSceneBroadArry[i].iLevel < rsp.iLevel){
                        this._fishData._fishSceneBroadArry.splice(i,0,rsp);
                        break;
                    }
                }
                if( i == this._fishData._fishSceneBroadArry.length){
                    this._fishData._fishSceneBroadArry.push(rsp);
                }
            }else{
                this._fishData._fishSceneBroadArry.push(rsp);
            }
        }else if((FishGlobal.LiveLevel == 1 ||FishGlobal.LiveLevel == 2)){
            var number = rsp.szMsg.indexOf("弹头");
            if(number>0){
                return;
            }
            if(this._fishData._fishSceneBroadArry.length !=0){
                var i =0;
                for(; i< this._fishData._fishSceneBroadArry.length; ++i){
                    if(this._fishData._fishSceneBroadArry[i].iLevel < rsp.iLevel){
                        this._fishData._fishSceneBroadArry.splice(i,0,rsp);
                        break;
                    }
                }
                if( i == this._fishData._fishSceneBroadArry.length){
                    this._fishData._fishSceneBroadArry.push(rsp);
                }
            }else{
                this._fishData._fishSceneBroadArry.push(rsp);
            }
        }else{
            if(this._fishData._fishSceneBroadArry.length !=0){
                var i =0;
                for(; i< this._fishData._fishSceneBroadArry.length; ++i){
                    if(this._fishData._fishSceneBroadArry[i].iLevel < rsp.iLevel){
                        this._fishData._fishSceneBroadArry.splice(i,0,rsp);
                        break;
                    }
                }
                if( i == this._fishData._fishSceneBroadArry.length){
                    this._fishData._fishSceneBroadArry.push(rsp);
                }
            }else{
                this._fishData._fishSceneBroadArry.push(rsp);
            }
        }



    },

    handleFishSceneReliveGetRsp : function(byteBuf){
        var rsp = FishProtocol.decode_FishSceneReliveGet(byteBuf);
//        FYEngine.logObject(rsp,'--------------渔场内领取救济金的消息:');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName('jiuji');
        if(layer){
            layer.removeFromParent(true);
        }

        if(rsp.iResult !=0){
            FYEngine.AddCommToast('领取救济金失败');
            return;
        }

        FYEngine.AddCommToast('领取救济金成功');
        FishGlobal.relivelimit  = FishGlobal.relivelimit - 1;
//        cc.log('----渔场内--FishGlobal.relivelimit------'+FishGlobal.relivelimit);
        FishGlobal.reliveinfor.iDayCount = rsp.iTimes;
        this._fishData._userData[this._fishData._selfId].lGold = rsp.lTotalGold;
        scene._playerNode[this._fishData._selfId].changeUserGold(rsp.lTotalGold);
    },

    /**
     * 免费场被踢的消息
     * @param byteBuf
     */
    handleFreeGameKickNotice : function(byteBuf){
//        var rsp = FishProtocol.decode_FreeGameKickNoticeRsp(byteBuf);
////        FYEngine.logObject(rsp,'--------------免费场被踢的消息:');
//        var scene =FYEngine.getRunningLayer(0);
//        if(scene){
//            var layer = scene.getChildByName("FreeKickToLobby");
//            if(!layer){
//                layer = new FreeKickToLobby(rsp.iReason);
//                scene.addChild(layer,FishZorder.poplayer,"FreeKickToLobby");
//            }
//            if(scene._bulletlayer.isAutoPlay()){
//                scene._bulletlayer.setAutoPlay(false);
//                var btn = FYEngine.getChild(scene._playerNode[this.getSelfId()],'autobtn');
//                btn.loadTexture(FishSceneRes.Png.AutoPlayBtn,ccui.Widget.PLIST_TEXTURE);
//                var autoeft = FYEngine.getChild(btn, 'autoeft');
//                if(autoeft){
//                    autoeft.removeFromParent(true);
//                }
//            }
//
//        }
    },

    changeUserGold : function(chairId,sub){
//        cc.log('test101'+chairId);
        if (sub >= 0){
            this._fishData._userData[chairId].lGold += sub;
            if(chairId == this._fishData._selfId){
//            cc.log('--------------------------加钱:'+sub+'---总钱:'+this._fishData._userData[chairId].lGold);
            }
        }
        else{
            if (this._fishData._userData[chairId].lGold >= Math.abs(sub)){
                this._fishData._userData[chairId].lGold += sub;
                if(chairId == this._fishData._selfId){
//                    cc.log('--------------------------剪钱:'+sub+'---总钱:'+this._fishData._userData[chairId].lGold);
                }

            }else{
//                cc.log('---------------理论上不应该进来的----------------');
                if(chairId == this.getSelfId()){
                    var scene = FYEngine.getRunningLayer(0);
                    var playernode = scene._playerNode[this.getSelfId()];
                    playernode.checkNeedSubBatteryLevel();
                }

            }
        }
    },
    /**
     *
     * @param btype 特殊类型 101核弹  102激光  103 闪电  104 锁定
     * @param pos  爆炸点
     * @param lBulletId
     */

    sendSpecialBullet : function(btype,pos,angle,bullet){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.FireSpecial;
        req.iSpecialType = btype;
        req.ix = parseInt(pos.x);
        req.iy = parseInt(pos.y);
        req.lRoleId = player.roleid;
        req.iChairId = this.getSelfId();
        req.lBulletId = bullet;
        req.iRate = 0;
        req.fRotate = angle;
        req.iTfirype = 0;
        req.iFireTime = 0;
        req.bisValid = 0;  //0有效,1无效;
        this.pushSendReq(req);
//        FYEngine.logObject(req, '---发送特殊子弹 : ');
    },

    handleFireSpecialRsp : function(byteBuf){
        var rsp = FishProtocol.decode_FireSpecialBullet(byteBuf);

//       FYEngine.logObject(rsp,'--------------刷新特殊子弹事件:');
        if(rsp.iChairId!=this.getSelfId()){
            var scene = FYEngine.getRunningLayer(0);
            if(scene && scene.onGameEvent){
                scene.onGameEvent(FishGameEventID.firespecial,rsp);
            }
        }

    },

    sendSpecialHitReq:function(iFishNum,iFishId ,iboomtype,bullet){
        var player = appglobal.getPlayer();
        var req = {};
        req.mainCmd = FishProtocol.FishProto;
        req.subCmd = FishProtocol.KillSpecialFish;
        req.lGold = 0;
        req.lCoupon =0;
        req.iBoomType = iboomtype;
        req.lRoleId = player.roleid;
        req.lBulletId = bullet;
        req.iHitFishId = 0;
        req.iRate = 0;
        req.iHitFishType = 0;
        req.bisValid = 1;
        req.iFishNum = iFishNum;
        req.iFishId = iFishId;

        this.pushSendReq(req);
//       FYEngine.logObject(req, '---发送特殊子弹碰撞消息--sendHitFishReq : ');

    },

    handleKillSpecialFishRsp:function(byteBuf){
        var rsp = FishProtocol.decode_SpecialCollision(byteBuf);
//        FYEngine.logObject(rsp,'--------------刷新特殊子弹碰撞事件:');
        var scene = FYEngine.getRunningLayer(0);
        if(scene && scene.onGameEvent){
            scene.onGameEvent(FishGameEventID.hitspecial,rsp);
        }
    },

    sendUpdateWealthReq: function () {
        var roleid = appglobal.getPlayer().roleid;
        var Req = {};
        Req.mainCmd = FishProtocol.GameBaseProto;
        Req.subCmd = FishProtocol.GoldQuery;
        Req.lUserId = roleid;
        this.pushSendReq(Req);
    },

    handleUpdateWealthRsp: function (byteBuf) {
        var player = appglobal.getPlayer();
        var rsp = FishProtocol.decode_UpdateWealth(byteBuf);
        // FYEngine.logObject(rsp,'-----------内财富刷新:');
        player.crystal = rsp.lScore;

        var scene = FYEngine.getRunningLayer(0);

        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.refreshWealth);
        }
        //this.sendGetCrystalInfoReq();
    },

    sendGetBulletTypeReq : function(){
        var Req = {};
        Req.mainCmd = FishProtocol.FishProto;
        Req.subCmd = FishProtocol.getBulletType;
        Req.lUserId = appglobal.getPlayer().roleid;
        this.pushSendReq(Req);
//        FYEngine.logObject(Req,"--sendGetBulletTypeReq:");
    },

    handleGetBulletTypeRsp : function(byteBuf){
        var rsp = FishProtocol.decode_getBulletType(byteBuf);
//        FYEngine.logObject(rsp,'---handleGetBulletTypeRsp:');
        if(rsp.iResult == 0){
            FishGlobal.BoomConf.iMaxGold = rsp.iMaxGold;
            FishGlobal.BoomConf.iCount = rsp.iCount;
            FishGlobal.BoomConf.iList = rsp.iList;
            this.sendJoinTabelReq();
        }
    },

    IsUserAlieve : function(ichairId, luserId) {
        if (ichairId == -1){
            for (var i = 0; i < 4; ++ i){
                if (this._fishData._userData[i] && this._fishData._userData[i].lRoleId == luserId){
                    //cc.log('--------test1--this.userData[i].lUserId ');
                    return true;
                }
            }
        }

        if (this._fishData._userData[ichairId] && luserId == this._fishData._userData[ichairId].lRoleId){
//            cc.log("--------test1");
            return true;
        }

        return false;
    },

});
