/**
 * Created by mintao on 2016/10/13.
 * app应用管理
 * app的运行流程生命周期的管理
 * c++回调js的通用接口
 */

var AppConfig = {
    verCode: '', //更新版本号
    verString: '', //展示版本号
    source: 0, //渠道
    paysource: 0, //支付渠道
    imei: 0,
    ua: '',//UA
    androidId: 0,
    gameName: "",
};

function formTime(time) {
    return {name: "time", value: time};
}

function formsign(service, time) {
    var sign = hex_md5(service + time).toUpperCase();
    return {name: "sign", value: sign};
}

function formservice(service) {
    return {name: "service", value: service};
}

function formsource(source) {
    return {name: "source", value: source};
}

function formversion(version) {
    return {name: "version", value: version};
}

function formRoleId(source) {
    return {name: "roleId", value: source};
}

function formchecksum() {
    var checksum = '';
    var args = Array.prototype.slice.call(arguments);
    args.forEach(function (e) {
        checksum += e;
    });
    return {name: "checksum", value: hex_md5(checksum).toUpperCase()};
}

function formUrl(baseurl, apiName/*,args*/) {
    var paramString = "";
    var args = Array.prototype.slice.call(arguments);
    for (var i = 2; i < args.length; ++i) {
        var valueString = args[i].name + "=" + args[i].value;
        paramString = paramString + valueString + "&";
    }
    paramString = paramString.slice(0, paramString.length - 1);
    return baseurl + '/' + apiName + "?" + paramString;
}

var EVENT_3RD_SDK_LOGIN = 'EVENT_3RD_SDK_LOGIN';
var EVENT_3RD_SDK_LOGOUT = 'EVENT_3RD_SDK_LOGOUT';
var EVENT_3RD_SDK_CHANGECOUNT = 'EVENT_3RD_SDK_CHANGECOUNT';

var thirdSdkLoginCallback = function (jsonStr) {
    cc.log('###### 3rd sdk login ret : ' + JSON.stringify(jsonStr));
    cc.eventManager.dispatchCustomEvent(EVENT_3RD_SDK_LOGIN, jsonStr);
};

var thirdSdkLogoutCallback = function (jsonStr) {
    cc.log('###### 3rd sdk logout ret : ' + JSON.stringify(jsonStr));
    // cc.eventManager.dispatchCustomEvent(EVENT_3RD_SDK_LOGOUT, jsonStr);

    var coreserviceproxy = CoreServiceProxy.getInstance();
    coreserviceproxy.unlinkLobbyClient();
    NoticeComm.resetNoticeComm();
    app.accountManager.userLogout();
    appglobal._runLobby = false;
    FishGlobal.deletaccount = true;
    FishGlobal.is3rdSDKLogOut = true;
    cc.director.runScene(LoginLayer.createScene());

    // var loc = JSON.parse(app.sdkPlugin.getNativeInfo());
    // var param = {};
    // // param.userSdkUrl = appglobal.serviceUserSdk;
    // param.locX = loc.location && loc.location.latitude || '0';
    // param.locY = loc.location && loc.location.longtitude || '0';
    // param.province = loc.location && loc.location.province || '未知';
    // param.city = loc.location && loc.location.city || '未知';
    // param.sourceid = appglobal.getSource() || 0;
    // param.version = 0;
    //
    // FYEngine.javascriptJavaBridge.handle3rdSdkLogin(JSON.stringify(param));
};

var thirdSdkChangeCountCallback = function (jsonStr) {
    cc.log('###### 3rd sdk changeCount ret : ' + JSON.stringify(jsonStr));
    //cc.eventManager.dispatchCustomEvent(EVENT_3RD_SDK_CHANGECOUNT, jsonStr);
    app.accountManager.userLogout();
    var coreserviceproxy = CoreServiceProxy.getInstance();
    coreserviceproxy.unlinkLobbyClient();
    coreserviceproxy.unlinkGameClient();
    NoticeComm.resetNoticeComm();
    appglobal._runLobby = false;
    FishGlobal.deletaccount = true;
    FishGlobal.is3rdSDKLogOut = true;
    cc.director.runScene(LoginLayer.createScene());
};

var dspapi486Callback = function (ua) {
    cc.log('dspApi2:ua->' + ua);
    if (appglobal.getSource() == 486) {
        var key = 'dps_api_2';
        var url = 'http://auth.server.phoneunet.com/ttCollect/activeAndLoginDspVido?service=login&imei=%s&ua=%s';
        if (!ua) return;
        // var ipua = appglobal.ip + ua;
        // cc.log('dspApi2:ipua->' + ipua);
        var finalUrl = cc.formatStr(url, appglobal._appCfg.imei, ua);
        finalUrl = encodeURI(finalUrl);
        cc.log('dspApi2:finalUrl->' + finalUrl);
        Http.getMessage(finalUrl, null, function (data) {
            var obj = JSON.parse(data);
            if (obj.code == 0) {
                cc.sys.localStorage.setItem(key, 1);
                cc.log('dspApi 486 tracking successfully');
            }
        });
    }
};

s_SharedApp = null;
var AppGlobal = cc.Component.extend({
    gametype: GameType.Treasure,
    isLoginOut: false,
    isNetwork: true, //是否联网
    loginCompleteFlag: 0,//loginCompleteFlag:0 sdk登陆未完成,1:sdk登陆完成,2:被踢出

    ///new
    _fishApiUrl: '',
    _fishResurl: '',
    _player: null, //app用户信息
    m_ServiceUserSdkUrl: null,
    _localStringMap: null, //
    iosSwitch: 0, //ios屏蔽开关
    _lobbyAccess: null,
    _socialAccess: null,
    _gameAccess: null,
    _upphoto: null,
    _downphoto: null,
    _appCfg: null,
    _runLobby: false,
    _upHeadUrl: '',
    _switch1: 1,// 0关闭,1 打开
    _switch2: 1,
    _switch3: 1,
    _switch4: 1,
    _switch5: 1,
    _switch6: 1,
    _switch7: 1,
    _switch8: 1,
    _switch9: 1,
    _switch10: 1,
    _switch11: 1,
    _switch12: 1,
    _switch13: 1,
    _switch14: 1,
    _switch15: 1,
    _switch16: 1,
    _switch17: 1,
    _switch19: 1,
    _switch20: 1,//积分兑换
    _switch21: 1,//防沉迷
    _switch22: 1,//实名认证总开关
    _switch23: 1,//分享功能
    _switch25: 1,//签到功能
    _switch27: 1,//关入口
    _switchT: 0,
    _localHeadUrl: '',
    accptableLevel: 0,
    idVerifySwitch: false,
    idVerifySwitch1: false,
    isWechatLogin: false,
    _switchOpenSignedRank: 20, // webserver parameter ,control opening signed rank limit times, default 20
    _URLrewardinfo: "http://www.phoneunet.com/scroll.html",
    _URLfamily: "http://www.phoneunet.com/guardian3.html",
    _playerCostControl: false,
    _playerLocationControl: false,
    _dailyChargeMoney: -1,
    _sharesite: "http://www.phoneunet.com/weChatShareFish.do?userId={0}&type={1}",
    _imageUrl: "http://cdn.downloads.phoneunet.com/res/fish/ICON02.png",
    // ip: '',
    _isYXDMode: false,

    ctor: function () {
        this._super();
        this._isYXDMode = false;
        this.isLoginOut = false;
        this._runLobby = false;

        this._appCfg = createObj(AppConfig);
        this._player = new Player();

        this.testPlatform();
        this._switch1 = 1;
        this._switch2 = 1;
        this._switch3 = 1;
        this._switch4 = 1;
        this._switch5 = 1;
        this._switch6 = 1;
        this._switch7 = 1;
        this._switch8 = 1;
        this._switch9 = 1;
        this._switch10 = 1;
        this._switch11 = 1;
        this._switch12 = 1;
        this._switch13 = 1;
        this._switch14 = 1;
        this._switch15 = 1;
        this._switch16 = 1;
        this._switch17 = 1;
        this._switch19 = 1;
        this._switch20 = 1;
        this._switch21 = 1;
        this._switch22 = 1;
        this._switch23 = 1;
        this._switch25 = 1;
        this._switch27 = 1;
        this._switchT = 0;
        this._switchOpenSignedRank = 20;
        //this.accptableLevel = 5;
        this.idVerifySwitch = false;//实名制开关
        this.idVerifySwitch1 = true;
        this._playerCostControl = false;
        this._playerLocationControl = false;
        this._dailyChargeMoney = -1;

    },

    getScale: function () {
        return 1;
    },

    testPlatform: function () {
        this.iosSwitch = false;
    },

    getShareUrl: function () {
        return this._sharesite.format(this.getPlayer().userid, 1);
    },

    getImageUrl: function () {
        return this._imageUrl;
    },

    initApp: function () {
        this.initNotification();
        // cc.director.getTextureCache().addImage("res/hall/commonres1.png");

        // cc.spriteFrameCache.addSpriteFramesWithFile("res/hall/commonres1.plist");


        FYEngine.commToastBg = 'commontoast.png';
        app.coreservice.setComponent(this);
        app.coreservice.onConnectionEvent = function (clientId, eventId, eventParam) {
            var coreserviceProxy = CoreServiceProxy.getInstance();
            coreserviceProxy && coreserviceProxy.onConnectionMsg(clientId, eventId, eventParam);
        };

        this.preloadLobbyRes();


        cc.log("----本地文件---initApp---");
        // jsb.loadRemoteImg("http://a4.peoplecdn.cn/e9d75c955d38d90682c524b309600b76.jpg@1l", function(succeed, result)
        // {
        //     cc.log("loadRemoteImg----succeed: "+succeed+'---result: '+result);
        // });
    },


    initAppConfig: function (jsonStr) {
        var cfg = strTojson(jsonStr);
        this._appCfg.verCode = cfg["versionCode"];
        this._appCfg.verString = cfg["versionString"];
        this._appCfg.source = parseInt(cfg["source"]);
        this._appCfg.paysource = parseInt(cfg["paySource"]);
        this._appCfg.imei = cfg["imei"];
        this._appCfg.ua = cfg["ua"];
        this._appCfg.androidId = cfg["imei"];
        this._appCfg.gameName = cfg["appName"];
        FYEngine.logObject(this._appCfg, "-----appcfg : ");
        //if(this._appCfg.source >=308 &&this._appCfg.source<=311 ){//屏蔽了百度渠道的包
        //    this.iosSwitch = true;
        //}
        //cc.log('-----------测试IOS开关1:'+appglobal.getIosTicketSwitch());
    },

    getAppName: function () {
        return this._appCfg.gameName;
    },

    /**
     * 接受baseconf
     */
    recvAppConfJson: function (apiurl, accessurl, resurl) {
        this._fishApiUrl = apiurl;
        this._lobbyAccess = accessurl;
        //cc.log('-----测试1:'+accessurl);
        this._fishResurl = resurl;
        //cc.log('-----测试2resurl:'+resurl);
        if(this._lobbyAccess == "fish_lobby"){
            this.initYXD();
        }
    },

    recvPhotoUrl: function (photoupurl, photodlurl) {
        this._upphoto = photoupurl;
        this._downphoto = photodlurl;
        //cc.log('--------测试url1:'+this._upphoto);
        //cc.log('--------测试url2:'+this._downphoto);
    },
    recvServiceUserSdk: function (m_ServiceUserSdkUrl) {
        this.m_ServiceUserSdkUrl = m_ServiceUserSdkUrl;
        cc.log('--------测试url:' + this.m_ServiceUserSdkUrl);
    },

    recvSwitchParam: function (param) {
        FYEngine.logObject(param, '----------开关配置');
        if (param != "") {
            var moduleParams = JSON.parse(param);
            if (moduleParams && typeof moduleParams == "object" && moduleParams["goods"]) {
                var tempdata = moduleParams["goods"];
                var sp = tempdata.indexOf(",");
                if (sp >= 0) {
                    cc.log("---------" + tempdata);
                    var spdata = tempdata.split(",");
                    FishGlobal.chargegoodslevel = parseInt(spdata[0]);//商品门槛
                    FishGlobal.chargegoodsplayerup = parseInt(spdata[1]);//玩家充值上
                    FishGlobal.chargegoodsplayerdown = parseInt(spdata[2]);//玩家充值下
                }

            }

            if (moduleParams && typeof moduleParams == "object" && moduleParams["examine"]) {
                cc.log("---------------水闸：" + this._switchT);
                this._switchT = 1;

            }

            //cc.log('-------11'+typeof moduleParams+'---this._appCfg.verString'+this._appCfg.verString+'---this._appCfg.source'+this._appCfg.source);
            if (moduleParams && typeof moduleParams == "object" && moduleParams[this._appCfg.verString] && moduleParams[this._appCfg.verString][this._appCfg.source]) {
                var modules = moduleParams[this._appCfg.verString][this._appCfg.source];
                //FYEngine.logObject(modules,'----------开关配置2');
                for (var i = 0; i < modules.length; ++i) {
                    if (modules[i] == "1" && this._switchT) {
                        this._switch1 = 0;
                        //cc.log('--------进入1');
                        continue;
                    }
                    if (modules[i] == "2" && this._switchT) {
                        this._switch2 = 0;
                        //cc.log('--------进入2');
                        continue;
                    }
                    if (modules[i] == "3" && this._switchT) {
                        this._switch3 = 0;
                        //cc.log('--------进入3');
                        continue;
                    }
                    if (modules[i] == "4" && this._switchT) {
                        this._switch4 = 0;
                        //cc.log('--------进入4');
                        continue;
                    }
                    if (modules[i] == "5" && this._switchT) {
                        this._switch5 = 0;
                        //cc.log('--------进入5');
                        continue;
                    }
                    if (modules[i] == "6" && this._switchT) {
                        this._switch6 = 0;
                        //cc.log('--------进入6');
                        continue;
                    }
                    if (modules[i] == "7" && this._switchT) {
                        this._switch7 = 0;
                        //cc.log('--------进入7');
                        continue;
                    }
                    if (modules[i] == "8" && this._switchT) {
                        this._switch8 = 0;
                        //cc.log('--------进入8');
                        continue;
                    }
                    if (modules[i] == "9" && this._switchT) {
                        //cc.log('--------进入9');
                        this._switch9 = 0;
                        continue;
                    }
                    if (modules[i] == "10" && this._switchT) {
                        //cc.log('--------进入10');
                        this._switch10 = 0;
                        continue;
                    }
                    if (modules[i] == "11" && this._switchT) {
                        //cc.log('--------进入11');
                        this._switch11 = 0;
                        continue;
                    }
                    if (modules[i] == "12" && this._switchT) {
                        //cc.log('--------进入12');
                        this._switch12 = 0;
                        continue;
                    }
                    if (modules[i] == "13" && this._switchT) {
                        //cc.log('--------进入12');
                        this._switch13 = 0;
                        continue;
                    }
                    if (modules[i] == "14") {
                        //cc.log('--------进入12');
                        this._switch14 = 0;
                        continue;
                    }
                    if (modules[i] == "15" && this._switchT) {
                        //cc.log('--------进入12');
                        this._switch15 = 0;
                        continue;
                    }

                    if (modules[i] == "16") {
                        this._switch16 = 0;
                        continue;
                    }

                    if (modules[i] == "17") {
                        this._switch17 = 0;
                        continue;
                    }
                    if (modules[i] == "19") {
                        this._switch19 = 0;
                        continue;
                    }

                    if (modules[i] == "20") {
                        this._switch20 = 0;
                        continue;
                    }

                    if (modules[i] == "21") {
                        this._switch21 = 0;
                        continue;
                    }

                    if (modules[i] == "22") {
                        this._switch22 = 0;
                        continue;
                    }

                    if (modules[i] == "23") {
                        this._switch23 = 0;
                        continue;
                    }

                    if (modules[i] == "25") {
                        this._switch25 = 0;
                        continue;
                    }

                    if (modules[i] == "27" && this._switchT) {
                        //cc.log('--------进入12');
                        this._switch27 = 0;
                        continue;
                    }

                    if (typeof modules[i] == "object") {
                        if (modules[i]["lrank"]) {
                            FishGlobal.crystalsignlevel = parseInt(modules[i]["lrank"]);
                            // FYEngine.logObject(modules[i]["lrank"],"---");
                            continue;
                        }
                    }

                    if (typeof modules[i] == "object") {
                        if (modules[i]["exchangeLevel"]) {
                            FishGlobal.realProSwitch = parseInt(modules[i]["exchangeLevel"]);
                            continue;
                        }
                    }

                    if (typeof modules[i] == "object") {
                        if (modules[i]["rankTimes"]) {
                            this._switchOpenSignedRank = parseInt(modules[i]["rankTimes"]);
                            // FYEngine.logObject(modules[i]["rankTimes"],"---");
                            continue;
                        }
                    }

                    if (typeof modules[i] == "object") {
                        if (modules[i]["rankCharge"]) {
                            FishGlobal.rankCharge = parseInt(modules[i]["rankCharge"]);
                            // FYEngine.logObject(modules[i]["rankTimes"],"---");
                            continue;
                        }
                    }

                    if (typeof modules[i] == "object") {
                        if (modules[i]["rankCoupon"]) {
                            FishGlobal.rankCoupon = parseInt(modules[i]["rankCoupon"]);
                            // FYEngine.logObject(modules[i]["rankTimes"],"---");
                            continue;
                        }
                    }

                    if (typeof modules[i] == "object") {
                        if (modules[i]["totalLose"]) {
                            this._playerCostControl = true;
                            var lresult = modules[i]["totalLose"];
                            var larr = lresult.split(",");
                            FishGlobal.loseMoneyLimit.dailylevel = larr[0];
                            FishGlobal.loseMoneyLimit.monthlevel = larr[1];
                            FYEngine.logObject(FishGlobal.loseMoneyLimit, "---FishGlobal.loseMoneyLimit:");
                            continue;
                        }
                    }
                }
            }
        }
    },


    /***
     * 网络状态改变
     * @param param
     */
    sysnetChanged: function (param) {
        //cc.log("params======="+param);
        //var obj = eval('('+param+')');
        //if((FYEngine.getRunningLayer(0).getName()==AppSceneName.Login||FYEngine.getRunningLayer(0).getName()==AppSceneName.Lobby)&&obj.type==0){
        //    FYEngine.getRunningLayer(0).addChild(new EnterFailedLayer(),FishZorder.poplayer);
        //}
    },


    /***
     * 预加载层---在自动登录不跳转loginscene的情况下
     * 可以将需要加载的内容传到c++在c++的updatescene处理界面
     * 也可以在js直接创建一个界面,做loading
     */
    preloadLobbyRes: function () {
        cc.log('------------测试获取uid:' + appglobal._player.userid);
        //FishGlobal.getLocalCrystalRecord();
        var resourceArr = [];
        for (var i in LoginResourceName.Png) {
            resourceArr.push(LoginResourceName.Png[i]);
        }
        cc.Loader.preload(resourceArr, function () {
            for (var i in LoginResourceName.Plist) {
                cc.spriteFrameCache.addSpriteFramesWithFile(LoginResourceName.Plist[i]);
            }
        });
        //FishGlobal.loadResource();
        FishGlobal.initJson();
        FishGlobal.initSound();

    },

    getPlayer: function () {
        return this._player;
    },

    getUserId: function () {
        return this._player.userid;
    },

    setGameType: function (type) {
        this.gametype = type;
    },

    /***
     * 获取ios开关
     * @returns {boolean}
     */
    getIosTicketSwitch: function () {
        var iosswitch = this.iosSwitch;
        if (iosswitch) {
            return true;
        }
        return false;
    },

    closeClientHandler: function () {
        var coreServiceProxy = CoreServiceProxy.getInstance();
        // close client
        var clientHandler = coreServiceProxy.getGameHandler();
        clientHandler.setClient(null);
        coreServiceProxy.removeGameHandler();

        var gameclient = coreServiceProxy.getClientGame();
        gameclient.stop();
    },


    isInGame: function (bool) {
        this.isIngame = bool;
    },

    getIsInGame: function () {
        return this.isIngame;
    },

    /***
     * 注册事件
     */
    initNotification: function () {
        for (var i in FYCustomEventName) {
            FYEngine.AddCustomLister(this, FYCustomEventName[i], this.dispatchNotification, 1);
        }
    },

    /**
     * 注册事件回调
     * @param event_name
     * @param event_param
     */
    dispatchNotification: function (event) {
        var event_name = event.getEventName();
        var event_param = event.getUserData();
        cc.log('------JS Notification回调 event_name: ' + event_name + ',event_param:' + event_param);
        switch (event_name) {
            case FYCustomEventName.SystemNet: {
                FYEngine.AddCommToast("网络状态改变");
            }
                break;
            case FYCustomEventName.AppDialog:
                break;
            case FYCustomEventName.ExitApp: {
//                cc.director.end();
                FYEngine.closeApp();
            }
                break;
            case FYCustomEventName.RunLogin: {
                cc.log('-----------走JS登录流程');
                //this.checkPlayerLoginType();
                FYEngine.runScene(LoginLayer.createScene());
            }
                break;
            case FYCustomEventName.RunFish: {
                this.runFishScene();
            }
                break;
            case FYCustomEventName.RunPlayerLogin : {
                cc.log('-----------走JS登录流程1');
            }
                break;
        }
    },

    /***
     * 登录sdk事件回调
     * @param action
     * @param code
     */
    onLoginSdkEvent: function (param) {

        var params = param.split(':');
        var action = Number(params[0]);
        var code = Number(params[1]);
        cc.log('---------onLoginSdkEvent action: ' + action + ', code: ' + code);
        this.isLoginOut = false;
        switch (action) {
            case 1: // 登录注册
            {
                if (code == 0) {
                    if (this._runLobby == false) {
                        this.runLobbyScene();
                        this._runLobby = true;
                    }

                    /*
                     以下为百推sdk 统计sdk, 注意：appName是否需要改变
                     */
                    if (cc.sys.os != cc.sys.OS_ANDROID) return;
                    var source = parseInt(appglobal.getSource());
                    if ((source >= 303 && source <= 307)
                        || (source >= 341 && source <= 345)
                        || (source >= 372 && source <= 381)
                        || (source >= 453 && source <= 462)
                    ) {
                        var userid = appglobal.getPlayer().userid;
                        if (userid <= 0) return;

                        var lastLoginUid = cc.sys.localStorage.getItem('last_login_uid');
                        if (!lastLoginUid || lastLoginUid != userid) {
                            var isNewAcct = '0';
                            if (lastLoginUid && lastLoginUid != userid) isNewAcct = '1';
                            var obj = {};
                            obj.isNewAcct = isNewAcct;
                            obj.uid = '' + userid;
                            obj.chnl = '' + appglobal.getSource();
                            obj.appName = 'quanminbuyu';
                            if (source >= 372 && source <= 381) {
                                obj.appName = 'jinchanbuyuios';
                            } else if (source >= 453 && source <= 462) {
                                obj.appName = 'yiqiwanbuyu';
                            }
                            app.sdkPlugin.callNativeMethodAysc("htracking", JSON.stringify(obj));
                        }
                        cc.sys.localStorage.setItem('last_login_uid', userid);
                    }
                }
                else if (code == -111 || code == -112) {
                    cc.log("----- - 跳转到登录界面" + code);
                    app.accountManager.userLogout();
                    //if(FYEngine.getRunningLayer(0).getName()!=AppSceneName.Login){
                    //    FYEngine.runScene(LoginLayer.createScene(code));
                    //}
                    //cc.log(FYEngine.getRunningLayer(0).getName());
                    //FYEngine.runScene(LoginLayer.createScene());
                    //跳转到登录界面
                }
                else if (code == -117) {

                }
            }
                break;

            case 4: // 账号退出
            {
                if (code == 0) {
                    // 断开大厅和社交连接
                    var coreserviceProxy = CoreServiceProxy.getInstance();
                    var clientLobby = coreserviceProxy.getClientLobby();
                    clientLobby && clientLobby.stop();

                    var clientSocial = coreserviceProxy.getClientSocial();
                    clientSocial && clientSocial.stop();

                    this.isLoginOut = true;
                }
            }
                break;
        }

        this.sdkErrCodeToast(action, code);

        var scene = cc.director.getRunningScene();
        switch (scene.getName()) {
            case AppSceneName.Login: {
                var layer = FYEngine.getChild(scene, 0);
                layer.onSDKEvent(action, code);
            }
                break;
        }

    },

    sdkErrCodeToast: function (action, code) {
        cc.log('--------sdkErrCodeToast action is %d, code is %d', action, code);
        switch (code) {
            case 0: {
                switch (action) {
                    case 2:
                        FYEngine.AddCommToast(FYEngine.LanguageString.getValue("loginErr1"));
                        break;
                    case 3:
                        FYEngine.AddCommToast(FYEngine.LanguageString.getValue("loginErr2"));
                        break;
                    case 4:
                        FYEngine.AddCommToast(FYEngine.LanguageString.getValue("loginErr3"));
                        break;
                    case 5:
                        // FYEngine.AddCommToast('用户充值成功');
                        break;
                    default:
                        break;
                }
            }
                break;
            case -100:
                FYEngine.AddCommToast(FYEngine.LanguageString.getValue("loginErr4"));
                break;
            case -110:
                FYEngine.AddCommToast(FYEngine.LanguageString.getValue("loginErr5"));
                break;
            case -111:
                break;
            case -112:
                FYEngine.AddCommToast(FYEngine.LanguageString.getValue("loginErr7"));
                break;
            case -116:
                FYEngine.AddCommToast(FYEngine.LanguageString.getValue("loginErr8"));
                break;
            case -117:
                break;
            default:
                FYEngine.AddCommToast(FYEngine.LanguageString.getValue("loginErr10"));
                break;
        }
    },

    checkPlayerLoginType: function () {

        var loginType = app.coreservice.getUserLoginType();
        cc.log('--------测试JS登录的loginType:' + loginType);
        if (loginType == 1) {
            var scene = FYEngine.getRunningLayer(0);
            this.userQuickLogin();
            scene.schedule(this.userQuickLogin, 4.0);

        } else {
            FYEngine.runScene(LoginLayer.createScene());
            //FYEngine.runScene(FourthLayer.createScene());
        }
    },

    userQuickLogin: function () {
        //cc.log('-------用户登录');
        //app.accountManager.quickLogin();
    },


    runLobbyScene: function () {
        var userInfo = app.accountManager.getAccountInfo();//app.coreservice.getUserInfo();
        FYEngine.logObject(userInfo.nickname, '----------用户信息:');
        this._player.userid = userInfo.userId;
        FishGlobal.getLocalCrystalRecord();
        this._player.token = userInfo.token;
        this._player.imei = userInfo.imei;
        var tempname = SoftReplaceWords(userInfo.nickname);
        this._player.setNickName(tempname);
        this._player.setAccountName(userInfo.account);

        if (appglobal.isWechatLogin) {
            app.accountManager.userLogout();
        }

        if(this.isVIVOsource()){
            var scene = FYEngine.getRunningLayer(0);
            if(scene && scene.oldAccountLoginOk){
                scene.oldAccountLoginOk();
            }
        }else{
            FYEngine.runScene(FourthLayer.createScene());
        }
        cc.log("--------runLobbyScene------");
    },

    runFishScene: function () {
        if (this.isYXDMode()) {
            this.yxdTransformGame(6002);
        }
        var coreserviceproxy = CoreServiceProxy.getInstance();
        this._gameAccess && coreserviceproxy.linkGameClinet(this._gameAccess);
        coreserviceproxy.addGameHandler(new FishHandler());
    },

    runFishCopyScene: function () {
        if (this.isYXDMode()) {
            this.yxdTransformGame(6004);
        }
        var coreserviceproxy = CoreServiceProxy.getInstance();
        this._gameAccess && coreserviceproxy.linkGameClinet(this._gameAccess);
        coreserviceproxy.addGameHandler(new FishCopyHandler());
    },

    runFishFightScene: function () {
        if (this.isYXDMode()) {
            this.yxdTransformGame(6005);
        }
        var coreserviceproxy = CoreServiceProxy.getInstance();
        this._gameAccess && coreserviceproxy.linkGameClinet(this._gameAccess);
        coreserviceproxy.addGameHandler(new FishFightHandler());
    },

    runFishNewScene : function(){
        cc.log("runFishNewScene");
        if (this.isYXDMode()) {
            this.yxdTransformGame(6006);
        }
        var coreserviceproxy = CoreServiceProxy.getInstance();
        this._gameAccess && coreserviceproxy.linkGameClinet(this._gameAccess);
        coreserviceproxy.addGameHandler(new GameNewHandler());
    },

    onConnectionEvent: function (clientId, eventId, eventParam) {
        var coreserviceProxy = CoreServiceProxy.getInstance();
        coreserviceProxy && coreserviceProxy.onConnectionMsg(clientId, eventId, eventParam);
    },

    getFishApiUrl: function () {
        cc.log("fishresurl[=======" + this._fishApiUrl);
        return this._fishApiUrl;
    },

    getSource: function () {
        return this._appCfg.source;
    },

    /**
     * 百推sdk tracking
     */
    htracking: function () {

    },

    onCurlLoadEvent: function (event_param, event_id) {
        cc.log('----------上传图片的回调onCurlLoadEvent event_id:' + event_id + '----- event_param : ' + FYEngine.formatString(event_param));
        switch (event_id) {
            case "upHeadImg" : {
                event_param = event_param + "";
                if (event_param.indexOf(".") != -1) {
                    event_param = event_param.substr(0, event_param.indexOf(".")) + ".jpg";
                }
                var scene = FYEngine.getRunningLayer(0);
                if (scene && scene.onGameEvent) {
                    scene.onGameEvent(lobbyGameEvent.changeHead, event_param);
                }
            }
                break;
            default :
                break;
        }
    },

    //type : 0上传 1相册
    postUpHeadUrl: function (type) {
        if (this._upphoto == "") {
            this._upHeadUrl = "http://192.168.1.232:8080/fishIMG";
        }
        var service = formservice('fileUpload');
        var userid = {name: "userid", value: this._player.userid};
        var types = {name: "type", value: type};

        return formUrl(this._upphoto, "serviceIMG", service, userid, types);
    },

    onSystemPhotoEvent: function (event_param, event_id) {
        cc.log('------js----event_id:' + event_id + ', param=' + FYEngine.formatString(event_param));
        switch (event_id) {
            case 'headPhoto'://头像
            {
                this._localHeadUrl = event_param;
                var url = this.postUpHeadUrl(0);
                //var url = "http://192.168.1.232:8080/fishIMG/serviceIMG?service=fileUpload&userid=1055120&type=0";
                cc.log('------上传头像的 url=', url);
                if (url) {
                    app.curlLoader.startToLoad(url, event_param, 1, "upHeadImg");
                }
            }
                break;
        }
    },
    is3rdSdkLogin: function () {
        var jsonStr = app.sdkPlugin.callNativeMethod("is3rdSdkLogin", "");
        var is3rdLogin = false;
        if (jsonStr && jsonStr != 'callNativeMethod tag undefined') {
            var json = JSON.parse(jsonStr);
            is3rdLogin = json.is3rdSdkLogin;
            cc.log('------------is3rdLogin## : ' + is3rdLogin);
        }
        return is3rdLogin;
    },

    /**
     * 判断是否bufan渠道，主要控制调出支付
     * @returns {boolean}
     */
    isBufanPay: function () {
        if (this.getSource() == 511 || this.getSource() == 547 || this.getSource() == 554 ||
            this.getSource() == 608 || this.getSource() == 610 || this.getSource() == 615 ||
            this.getSource() == 620 || this.getSource() == 621 || this.getSource() == 623) {
            return true;
        } else {
            return false;
        }
    },


    /**
     *
     * @param width  width of qrcode
     * @param nType  0:内网
     * @returns {cc.LayerColor}
     * @constructor
     */
    CreateQRCodeImg: function (width) {
        var nType = 0;
        var qrcode = new QRCode(-1, QRErrorCorrectLevel.M);
        var url = this.getShareUrl();
        cc.log("shareurl" + url);
        qrcode.addData(url);
        // qrcode.addData(utf16to8("吕达的丁丁"));
        qrcode.make();
        var count = qrcode.getModuleCount();
        // bg

        var bg = new cc.LayerColor(cc.color("#ffffff"), width, width);
        var tileWidth = width / (count + 2);

        for (var row = 0; row < qrcode.getModuleCount(); row++) {
            for (var col = 0; col < qrcode.getModuleCount(); col++) {
                if (qrcode.isDark(row, col)) {
                    var drawNode = cc.LayerColor(cc.color("#000000"), tileWidth, tileWidth);
                    drawNode.setPosition(cc.p((col + 1) * tileWidth, (row + 1) * tileWidth));
                    bg.addChild(drawNode);
                }
            }
        }
        return bg;
    },

    isLiaoCert: function () {
        if (this.getSource() == 688 ||this.getSource() == 744) {
            return true;
        } else {
            return false;
        }
    },

    initYXD: function () {
        var jsonStr = app.sdkPlugin.callNativeMethod("YXDINIT", "");
        cc.log("初始化游戏盾" + JSON.stringify(jsonStr));
        if (jsonStr && jsonStr != 'callNativeMethod tag undefined' && jsonStr == "success") {
            this._isYXDMode = true;
        } else {
            this._isYXDMode = false;
            this._lobbyAccess = "";
        }
    },

    isYXDMode: function () {
        return this._isYXDMode;
    },

    yxdTransformLobby : function(){
        var minfo = {
            ddomain: "fish_lobby",
            dport: 6001
        };
        var jsonStr = app.sdkPlugin.callNativeMethod("YXDIP", JSON.stringify(minfo));
        cc.log("-------调用游戏盾解析lobby"+JSON.stringify(jsonStr));
        if (jsonStr && jsonStr != 'callNativeMethod tag undefined' && jsonStr!="") {
            let obj = JSON.parse(jsonStr);
            this._lobbyAccess = obj.ip+":"+obj.port;
        }
    },

    yxdTransformGame: function (mport) {
        if(mport){
            var minfo = {
                ddomain: "fish_lobby",
                dport: mport
            };
            var jsonStr = app.sdkPlugin.callNativeMethod("YXDIP", JSON.stringify(minfo));
            cc.log("-------调用游戏盾解析game" + JSON.stringify(jsonStr));
            if (jsonStr && jsonStr != 'callNativeMethod tag undefined' && jsonStr != "") {
                let obj = JSON.parse(jsonStr);
                this._gameAccess = obj.ip + ":" + obj.port;
            }
        }
    },

    isVIVOsource : function(){
        if(this.getSource() == 365 || this.isMEIZUsource()){
            return true;
        }else{
            return false;
        }
    },

    isMEIZUsource : function(){
        if(this.getSource() == 428){
            return true;
        }else{
            return false;
        }
    },

    /**
     * Baidu source change account system, remains wechate login and account login
     * @returns {boolean}
     */
    isBaiduSource : function(){
        return appglobal.getSource() == 308 || appglobal.getSource() == 309 || appglobal.getSource() == 310 || appglobal.getSource() == 311;
    },


    setPlayerWinLoseControl: function (param) {
        FYEngine.logObject(param, "----setPlayerWinLoseControl");
        if (param.code == 0) {
            let idata = param.data;
            if (Number(idata.Gold) > 0) {
                this._dailyChargeMoney = Number(idata.Gold);
            }
            if (Number(idata.Score) > 0) {
                this._playerLocationControl = true;
                let tempdata = FishGlobal.loseMoneyLimit.dailylevel;
                FishGlobal.loseMoneyLimit.dailylevel = Math.min(tempdata, Number(idata.Score));
            }
        } else {
            this._playerLocationControl = false;
        }

    },

});


AppGlobal.getInstance = function () {
    if (!s_SharedApp) {
        s_SharedApp = new AppGlobal();
    }
    return s_SharedApp;
};

appglobal = AppGlobal.getInstance();
