var DiaMsgkey = {
    reliveTipBefore: "reliveTipBefore",
    reliveTipAfter: "reliveTipAfter",
    goldNotEnoughTip: "goldNotEnoughTip"
};
/**
 * 通用弹出界面
 */
var DialogLayer = cc.LayerColor.extend({
    ctor: function () {
        this._super();
        this.init(cc.color(0, 0, 0, 190));
        this.bindTouch();
    },
    bindTouch: function () {
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {

                }

            },

        });
        cc.eventManager.addListener(this.touchListener, this);
    },
    /**
     * 弹出的提示框边框
     * @param bgSize 提示框大小
     * @returns {*}
     */
    addLayerBg: function (bgSize) {
        var layerbg = this.layerbg = FYEngine.createImageView(FishSceneRes.DialogPng.OuterBg, cc.p(cc.winSize.width / 2, cc.winSize.height / 2), cc.p(0.5, 0.5), bgSize);
        this.addChild(layerbg, 0, 1);
        return this.layerbg;
    },
    /**
     * 弹出的内部界面
     * @param innerSize 内部大笑
     * @returns {*}
     */
    addInnerBg: function (innerSize) {
        var innerBg = this.innerBg = FYEngine.createImageView(FishSceneRes.DialogPng.InnerBg,
            cc.p(this.layerbg.width / 2, this.layerbg.height * 0.55), cc.p(0.5, 0.5), innerSize);
        this.layerbg.addChild(innerBg, 0, 2);
        return this.innerBg;
    },

    /**
     * 标题
     * @param titleImage 标题图片资源
     * @param BigBgLength 图片背景长度
     */
    addTitleBg: function (titleImage, BigBgLength, smallBgSize) {
        smallBgSize = smallBgSize || cc.size(276, 54);
        var titleBigBg = FYEngine.createImageView(FishSceneRes.DialogPng.TitleBigBG, cc.p(this.layerbg.width / 2, this.layerbg.height * 0.95), cc.p(0.5, 0.5), cc.size(BigBgLength, 73), cc.rect(160, 0, 10, 73));
        this.layerbg.addChild(titleBigBg, 0, 3);
        var titleSmallBg = FYEngine.createImageView(FishSceneRes.DialogPng.TitleSmallBG, cc.p(titleBigBg.width / 2, titleBigBg.height * 0.56), cc.p(0.5, 0.5), smallBgSize, cc.rect(50, 0, 8, 54));
        titleBigBg.addChild(titleSmallBg, 0, 1);
        var titleName = FYEngine.createSprite(titleImage, cc.p(cc.p(titleBigBg.width / 2, titleBigBg.height * 0.56)));
        titleBigBg.addChild(titleName, 0, 2);
    },
    /**
     *  关闭按钮
     * @param func 回调函数 可不传,默认是执行popout动画,然后从父类移除;
     */
    addCloseBtn: function (func) {
        var that = this;
        var btnBack = new ccui.Button(FishSceneRes.DialogPng.BackBtnUp, FishSceneRes.DialogPng.BackBtnDowm, '', ccui.Widget.PLIST_TEXTURE);
        if (btnBack) {
            btnBack.setPosition(this.layerbg.width * 0.97, this.layerbg.height * 0.97);
            that.layerbg.addChild(btnBack, 0, 4);
            if (func) {
                btnBack.addClickEventListener(func);
            } else {
                btnBack.addClickEventListener(function () {
                    FYEngine.popoutLayerAnimate(that.layerbg);
                })
            }
        }
    },
    /**
     * 添加确认按钮
     * @param func 回调函数 可不传,默认是执行popout动画,然后从父类移除;
     * @param position
     * @param confirmName
     */
    addConfirmBtn: function (func, position, confirmName) {
        var that = this;
        if (!func) {
            func = function () {
                FYEngine.popoutLayerAnimate(that.layerbg);
            }
        }
        var confirmBtn = new cc.Sprite(FishSceneRes.DialogPng.ConfirmBtn);
        if (confirmBtn) {
            confirmBtn.setPosition(position);
            this.layerbg.addChild(confirmBtn, 0, 5);
            FYEngine.AddNodeTouchListener(confirmBtn, func, FYEngine.ActionType.Fade);
        }
        confirmName = confirmName || FishSceneRes.DialogPng.ConfirmTitle;
        var confirmTitle = new cc.Sprite(confirmName);
        if (confirmTitle) {
            confirmTitle.setPosition(confirmBtn.width / 2, confirmBtn.height * 0.6);
            confirmBtn.addChild(confirmTitle, 0);
        }

    },
    /**
     *  添加取消按钮
     * @param func 回调函数 可不传,默认是执行popout动画,然后从父类移除;
     * @param position
     */
    addCancelBtn: function (func, position, cancelBtnName) {
        var that = this;
        if (!func) {
            func = function () {
                FYEngine.popoutLayerAnimate(that.layerbg);
            }
        }
        var cancelBtn = new cc.Sprite(FishSceneRes.DialogPng.CancelBtn);
        if (cancelBtn) {
            cancelBtn.setPosition(position);
            this.layerbg.addChild(cancelBtn, 0, 6);

            FYEngine.AddNodeTouchListener(cancelBtn, func, FYEngine.ActionType.Fade);
        }
        cancelBtnName = cancelBtnName || FishSceneRes.DialogPng.CancelTitle;
        var cancelTitle = new cc.Sprite(cancelBtnName);
        if (cancelTitle) {
            cancelTitle.setPosition(cancelBtn.width / 2, cancelBtn.height * 0.6);
            cancelBtn.addChild(cancelTitle, 0);
        }
    },

});
/**
 * 登陆界面,忘记密码弹出的客服提示框
 */
var ServiceDialogLayer = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        var innerBg = this.addInnerBg(cc.size(586, 220));


        var mstr = FYEngine.LanguageString.getValue(LoginMsgKey.serviceDiaLogMsg);

        var tip = new ccui.Text(mstr, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerBg.addChild(tip, 0, 10);
        }
    }
});

var UnFinishedGameLayer = DialogLayer.extend({
    _tag: 0,
    ctor: function (tag) {
        this._super();
        this._tag = tag;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);

        var innerBg = this.addInnerBg(cc.size(586, 220));


        var tip = new ccui.Text("还有未完成的游戏，是否进入？", "微软雅黑", 30);
        if (tip) {
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerBg.addChild(tip, 0, 10);
        }

        this.addConfirmBtn(function () {
            self.removeFromParent(true);
            cc.log("去未完成的牌桌");
            var scene = FYEngine.getRunningLayer(0);
            if (scene && scene.getName() == "lobbyscene") {
                FishGlobal.isLobbyRecord = true;
                if (self._tag == 1) {
                    FishGlobal.roomId = 4;
                } else {
                    FishGlobal.roomId = 5;
                }
                scene.createLoading();
                scene.loadFish();
                scene.scheduleOnce(scene.joinTableCheck, 15);
            }
        }, cc.p(bg.width * 0.5, bg.height * 0.2 - 15));
    }
});

var FishSceneGoCharge = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn(this.closeCallBack);
        this.addConfirmBtn(this.closeCallBack, cc.p(bg.width * 0.5, bg.height * 0.2 - 15));
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var sp = "您的金币不足，请前往大厅充值";
        if(appglobal._switch27 == 0){
            sp = "您的金币不足";
        }
//        if( appglobal.getSource() ==509 ){
//            sp = '您的金币不足'
//        }
        var tip = new ccui.Text("" + sp, '微软雅黑', 30);
        if (tip) {
//            tip.setTextAreaSize(cc.size(450,120));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.5));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

    closeCallBack: function () {
        var layer = FYEngine.getRunningLayer(0);
//        if(appglobal.getSource() ==509){
//            FishGlobal.needCharge = 0;
//        }else{
//
//        }
        FishGlobal.needCharge = 1;
        if(appglobal._switch27 == 0){
            FishGlobal.needCharge = 0;
        }
        layer._handler.sendLeaveTableReq();
        layer._handler.sendPlayerLogoutRequest();
        layer.scheduleOnce(layer.exitGame, 0.1);
    },


});

var TimeoutLayer = cc.LayerColor.extend({
    time: 60,

    ctor: function () {
        this._super();
        this.init(cc.color(0, 0, 0, 0), 1136, 640);
        this._size = cc.winSize;
        this.time = 60;
        this.initUI();
        this.schedule(this.updatetime, 1);

        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: false,

            onTouchBegan: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    return true;
                }
                return false;
            },

            onTouchMoved: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                }
            },

            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                var target = event.getCurrentTarget();
                if (cc.rectContainsPoint(target.getBoundingBox(), pos)) {
                    //target.removeFromParent(true);
                    //var scene = cc.director.getRunningScene();
                    //var layer1 = scene.getChildByName(FishSceneName.BulletLayer);
                    ////layer1._timeCount = 0;
                    //var layer = scene.getChildByName('timeoutlayer');
                    //layer.removeFromParent(true);
                }

            },

        });
        cc.eventManager.addListener(this.touchListener, this);
    },

    initUI: function () {
        var timeOutSprite = new cc.Sprite("#gameui35.png");
        if (timeOutSprite) {
            this.addChild(timeOutSprite, 0, 0);
            timeOutSprite.setPosition(cc.p(cc.winSize.width / 2, cc.winSize.height / 2));
        }
        var time = new ccui.TextAtlas("10", "res/fishui/time_out_num.png", 21, 37, "0");
        if (time) {
            time.setPosition(cc.p(393, timeOutSprite.height / 2 - 1));
            time.setAnchorPoint(cc.p(1, 0.5));
            timeOutSprite.addChild(time, 0, 1);
            time.setString('' + this.time);
        }

    },

    updatetime: function (dt) {
        this.time = this.time - 1;
        var timeoutbg = this.getChildByTag(0);
        var time = timeoutbg.getChildByTag(1);
        time.setString('' + this.time);
        if (this.time <= 0) {
            // cc.log('该踢出房间了');
            this.unschedule(this.updatetime);
            FishGlobal.kick = 1;

            var handle = CoreServiceProxy.getInstance().getGameHandler();
            if (handle && handle._canSendNormalMsg) {
                handle.sendLeaveTableReq();
                handle.sendPlayerLogoutRequest();
                var layer = FYEngine.getRunningLayer(0);
                layer.runAction(new cc.Sequence(new cc.DelayTime(0.5), new cc.CallFunc(function () {
                    layer.exitGame();
                })));
            } else {
                this.removeFromParent(true);
            }
        }
    },


});

var unConnectLayer = DialogLayer.extend({
    _reConnectCode: 0,
    code: 0,
    _type: 0,
    ctor: function (type) {
        this._super();
        this._type = type;
        this.addLayerBg(cc.size(612, 303));
    },

    refreshUI: function (type) {
        if (this._type == type) {
            return;
        }
        this._type = type;
        this.layerbg.removeAllChildren(true);

        var sprite;
        var layerbg = this.layerbg;
        switch (type) {
            case 1:
//                cc.log('----------type1进入--'+this._type);
                sprite = new cc.Sprite(FishSceneRes.Png.tryConnect);
                for (var i = 0; i < 3; ++i) {
                    var point = new cc.Sprite(FishSceneRes.Png.tryPoint);
                    point.setTag(i);
                    point.setPosition(cc.p(602 / 2 + sprite.width / 2 + 7.5 + i * 15, 303 / 2 - sprite.height / 4));
                    point.setAnchorPoint(cc.p(0.5, 0));
                    point.setVisible(false);
                    this.layerbg.addChild(point);

                }
                var actionArr = [];
                for (var i = 0; i < 3; i++) {
                    actionArr.push(cc.targetedAction(this.layerbg.getChildByTag(i), cc.show()));
                    actionArr.push(cc.delayTime(0.5));
                }
                actionArr.push(cc.callFunc(function () {
                    for (var i = 0; i < 3; i++) {
                        if (layerbg.getChildByTag(i)) {
                            layerbg.getChildByTag(i).setVisible(false);
                        }
                    }
                }));
                layerbg.runAction(cc.sequence(actionArr).repeatForever());
                break;
            case 2:
//                cc.log('----------type2进入--'+this._type);
                sprite = new cc.Sprite(FishSceneRes.Png.tryConnectSuccess);
                this.scheduleOnce(this.removeLayer, 1);
                break;
            case 3:
                FishGlobal.bInFishScene = false;
                var coreserviceproxy = CoreServiceProxy.getInstance();
                coreserviceproxy.unlinkGameClient();
                coreserviceproxy.unlinkLobbyClient();
                var scene = FYEngine.getRunningLayer(0);
//                cc.log(scene.getName()+'----------type3进入--'+this._type);
                sprite = new cc.Sprite(FishSceneRes.Png.tryConnectFail);
                this._type = 3;
                scene.stopAllActions();
                scene.unscheduleAllCallbacks();
                if (scene.getName() == 'fishscene' || scene.getName() == "fishcopyscene") {
                    scene._bulletlayer.unscheduleAllCallbacks();
                }
                this.addConfirmBtn(function () {
                    FYEngine.closeApp();
                }, cc.p(612 / 2, 74));
                break;
        }
        if (type == 3) {
            sprite.setPosition(cc.p(602 / 2, 202));
        } else {
            sprite.setPosition(cc.p(612 / 2, 303 / 2));
        }
        this.layerbg.addChild(sprite);
    },

    layerF: function () {
//        cc.log('--------执行f-');
        this._reConnectCode = 1;
        this.refreshUI(3);
    },

    removeLayer: function () {
//        cc.log('-----------断线提示层删除--');
        this.removeFromParent(true);
        //var layer = cc.director.getRunningScene().getChildByName(FishSceneName.UnConnectDialog);
        //if(layer){
        //    layer.removeFromParent(true);
        //}
    }


});

var GameSettingLayer = DialogLayer.extend({
    _isVibrtion: 0,//open
    _bgVolum: 0.5,
    _eftVolum: 0.5,
    ctor: function () {
        this._super();
        this._tagbtn = 0;
        this.loadResource();
        this.initUI();
    },
    loadResource: function () {
        cc.textureCache.addImage(SettingRes.png);
        cc.spriteFrameCache.addSpriteFramesWithFile(SettingRes.plist);
    },
    initUI: function () {
        var bg = this.addLayerBg(cc.size(715, 385));
        bg.setPositionX(bg.getPositionX() - 7);
        this.addTitleBg(FishSceneRes.DialogPng.TitleSetting, 715);
        this.addCloseBtn(this.closeCallBack);
        var innerbg = this.addInnerBg(cc.size(644, 280));
        innerbg.setPositionY(190);
        var posArrLabel = [cc.p(102, 233), cc.p(390, 233), cc.p(73, 120)];
        var posArr = [cc.p(183, 290), cc.p(473, 290), cc.p(183, 173)];
        var arr = ["bgVolum", "eftVolum", "isVibration"];
        var textArr = ["音乐", "音效", "游戏震动"];
        for (var i = 0; i < arr.length; i++) {
            var imageView = new ccui.ImageView(SettingRes.settingOff, ccui.Widget.PLIST_TEXTURE);
            imageView.setTouchEnabled(true);
            var temp = cc.sys.localStorage.getItem(arr[i]);
            if (!temp) {
                cc.sys.localStorage.setItem(arr[i], i == 2 ? 0 : 1);
                temp = cc.sys.localStorage.getItem(arr[i]);
            }
            if (temp > 0 && i != 2) {

                imageView.loadTexture(SettingRes.settingOn, ccui.Widget.PLIST_TEXTURE);
            } else if (temp == 0 && i == 2) {
                imageView.loadTexture(SettingRes.settingOn, ccui.Widget.PLIST_TEXTURE);
            }
            imageView.setName(arr[i]);
            // imageView.attr({x: posArr[i], y: 450, anchorX: 0, anchorY: 1});
            imageView.setPosition(posArr[i]);
            imageView.setAnchorPoint(cc.p(0, 1));
            bg.addChild(imageView);
            var textLabel = cc.Label.createWithSystemFont("" + textArr[i], "", 25);
            textLabel.setColor(cc.color("8EF3FF"));
            // textLabel.attr({x: posArr[i] - 20, y: 425, anchorX: 1, anchorY: 1});
            textLabel.setPosition(posArrLabel[i]);
            textLabel.setAnchorPoint(cc.p(0, 0));
            bg.addChild(textLabel);
            imageView.addClickEventListener(this.imageViewBtnCallback);
        }
    },
    imageViewBtnCallback: function (sender) {
        var name = sender.getName();
        var image = sender.getRenderFile().file;
        if (image == SettingRes.settingOff) {
            sender.loadTexture(SettingRes.settingOn, ccui.Widget.PLIST_TEXTURE);
        } else {
            sender.loadTexture(SettingRes.settingOff, ccui.Widget.PLIST_TEXTURE);
        }


        if (cc.sys.localStorage.getItem(name) > 0) {
            cc.sys.localStorage.setItem(name, 0);
            switch (name) {
                case "bgVolum":
                    cc.audioEngine.stopMusic();
                    FYEngine.Audio.setOpenMusic(false);
                    break;
                case "eftVolum":
                    cc.audioEngine.stopAllEffects();
                    FYEngine.Audio.setOpenEffect(false);
                    break;
                case "isVibration":
                    break;
            }
        } else {
            cc.sys.localStorage.setItem(name, 1);
            switch (name) {
                case "bgVolum":
                    //cc.audioEngine.playMusic(FishSceneRes.preloadAudioName.music.Lobby_bg,true);
                    FYEngine.Audio.setOpenMusic(true);
                    break;

                case "eftVolum":
                    FYEngine.Audio.setOpenEffect(true);
                    break;
                case "isVibration":
                    break;
            }
        }
        if (name == "bgVolum") {
            FYEngine.getRunningLayer(0).initBackGroundMusic();
        } else {
            FYEngine.getRunningLayer(0).initBackGroundMusic(1);
        }
    },


    closeCallBack: function () {
        var scene = FYEngine.getRunningLayer(0).getChildByName("gamesettinglayer");

        FYEngine.popoutLayerAnimate(scene.layerbg);
    },

});

var SettingRes = {
    png: "res/setting/setting.png",
    plist: "res/setting/setting.plist",
    settingOff: "setting_btn_off.png",
    settingOn: "setting_btn_on.png",
    settingLineH: "setting_line_h.png",
    settingLineV: "setting_line_v.png",
    settingNickName: "#setting_nickname.png",
    settingAccount: "#setting_account.png",
    settingUserId: "#setting_userId.png",
    settingBtnBg: "setting_btnbg.png",
    settingChangeNick: "setting_change_nickname.png",
    settingCommitAccount: "setting_commit_msg.png",
    settingChangePass: "setting_change_pass.png",
    settingCheckOut: "setting_checkout.png"
};

var HelpInfoLayerNew = DialogLayer.extend({
    resource: {
        plist: "res/help/help.plist",
        png: "res/help/help.png",
        numBlue: "res/help/help_num_blue.png",
        numYellow: "res/help/help_num_yellow.png"
    },
    ctor: function () {
        this._super();
        this.loadResource();
        if (appglobal._switch9 == 0) {
            this.initUIIos();
        } else {
            this.initUI();
        }

    },

    loadResource: function () {
        cc.textureCache.addImage(this.resource.png);
        cc.spriteFrameCache.addSpriteFramesWithFile(this.resource.plist);
    },

    initUIIos: function () {
        var outerbg = this.addLayerBg(cc.size(930, 535));
        this.addTitleBg(FishSceneRes.DialogPng.TitleHelp, 930);
        this.addCloseBtn(this.closeCallBack);
        var scrollView = new ccui.ScrollView();
        scrollView.setContentSize(cc.size(870, 440));
        scrollView.setAnchorPoint(cc.p(0.5, 0.5));
        scrollView.setPosition(outerbg.width / 2, (outerbg.height - 30) / 2);
        scrollView.setScrollBarEnabled(false);
        scrollView.setInertiaScrollEnabled(false);
        outerbg.addChild(scrollView);

        var container = scrollView.getInnerContainer();
        container.setContentSize(868, 365 + 390 + 9);

        var bgFish = new ccui.Layout();
        bgFish.setContentSize(cc.size(868, 365));
        bgFish.setBackGroundImage(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
        bgFish.setBackGroundImageScale9Enabled(true);
        bgFish.setAnchorPoint(cc.p(0, 1));
        bgFish.setPosition(cc.p(0, container.height));
        container.addChild(bgFish);

        var spriteTitle = new cc.Sprite("#help_fish_title.png");
        spriteTitle.setPosition(30, 365 - 10);
        spriteTitle.setAnchorPoint(cc.p(0, 1));
        bgFish.addChild(spriteTitle);
        var posFish = cc.p(58, 312), posLabel = cc.p(167, 312);
        var fishArr = [{fishPng: "#help_fish_2_1.png", fishValue: 2},
            {fishValue: 2}, {fishValue: 3}, {fishValue: 4},
            {fishValue: 5}, {fishValue: 6}, {fishValue: 7}, {fishValue: 8},
            {fishValue: 9}, {fishValue: 10}, {fishValue: 12}, {fishValue: 15},
            {fishValue: 18}, {fishValue: 20}, {fishValue: 25}, {fishValue: 30},
            {fishValue: 40}, {fishValue: 150}, {fishValue: "150-300"}, {fishValue: 200}, {fishValue: 300}];
        for (var i = 0; i < fishArr.length; i++) {
            var fishPngName = fishArr[i].fishPng || ("#help_fish_" + fishArr[i].fishValue + ".png");
            var fish = new cc.Sprite(fishPngName);
            if (fish) {
                fish.attr({x: posFish.x + (i % 4) * 212, y: posFish.y - Math.floor(i / 4) * 53})
                bgFish.addChild(fish);
            }
            var smallbg = new cc.Sprite("#help_fish_bg.png");
            var fishLabel = new ccui.TextAtlas("" + fishArr[i].fishValue, this.resource.numYellow, 11, 20, "-");
            fishLabel.attr({x: smallbg.width / 2, y: smallbg.height / 2});
            smallbg.addChild(fishLabel);
            smallbg.attr({x: posLabel.x + (i % 4) * 215, y: posFish.y - Math.floor(i / 4) * 53});
            bgFish.addChild(smallbg);
        }

        var bgSpecial = new ccui.Layout();
        bgSpecial.setContentSize(cc.size(868, 390));
        bgSpecial.setBackGroundImage(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
        bgSpecial.setBackGroundImageScale9Enabled(true);
        bgSpecial.setAnchorPoint(cc.p(0, 0));
        bgSpecial.setPosition(cc.p(0, 0));
        container.addChild(bgSpecial);

        var specialTitle = new cc.Sprite("#help_special_title.png");
        specialTitle.setPosition(30, 390 - 10);
        specialTitle.setAnchorPoint(cc.p(0, 1));
        bgSpecial.addChild(specialTitle);

        var specialArr = [
            //{png:"#help_quan.png",title:"#help_quan_title.png",msg:"#help_msg_quan.png"},
            {png: "#help_pan.png", title: "#help_pan_msg_title.png", msg: "#help_msg_pan.png"},
            {png: "#help_special.png", title: "#help_special_msg_title.png", msg: "#help_msg_special.png"},
            {png: "#help_boom.png", title: "#help_boom_title.png", msg: "#help_msg_boom.png"}
        ];
        //var specialPosPng = cc.p(30,99),specialPosTitle = cc.p(178,81.5),specialMsg = cc.p(178,115.5);
        for (var i = 0; i < specialArr.length; i++) {

            var specialPng = new cc.Sprite(specialArr[i].png);
            specialPng.setAnchorPoint(cc.p(0, 0.5));
            var specialTitle = new cc.Sprite(specialArr[i].title);
            specialTitle.setAnchorPoint(cc.p(0, 0.5));
            var specialMsg = new cc.Sprite(specialArr[i].msg);
            specialMsg.setAnchorPoint(cc.p(0, 0.5));

            specialPng.attr({x: 30, y: 390 - 99 - i * 117});
            if (i == 0) {
                specialTitle.attr({x: 178, y: 390 - 30});
                specialMsg.attr({x: 178, y: 390 - 90.5 - 117 * i});
            } else {
                specialTitle.attr({x: 178, y: 390 - 81.5 - i * 117});
                specialMsg.attr({x: 178, y: 390 - 115.5 - 117 * i});
            }


            bgSpecial.addChild(specialPng);
            bgSpecial.addChild(specialTitle);
            bgSpecial.addChild(specialMsg);

        }
        scrollView.jumpToTop();

        //bgFish.setBackGroundColor(cc.color.RED);
        //bgFish.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);


    },

    initUI: function () {
        var outerbg = this.addLayerBg(cc.size(930, 535));
        this.addTitleBg(FishSceneRes.DialogPng.TitleHelp, 930);
        this.addCloseBtn(this.closeCallBack);
        var scrollView = new ccui.ScrollView();
        scrollView.setContentSize(cc.size(870, 440));
        scrollView.setAnchorPoint(cc.p(0.5, 0.5));
        scrollView.setPosition(outerbg.width / 2, (outerbg.height - 30) / 2);
        scrollView.setScrollBarEnabled(false);
        scrollView.setInertiaScrollEnabled(false);
        outerbg.addChild(scrollView);

        var container = scrollView.getInnerContainer();
        container.setContentSize(868, 365 + 500 + 9);

        var bgFish = new ccui.Layout();
        bgFish.setContentSize(cc.size(868, 365));
        bgFish.setBackGroundImage(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
        bgFish.setBackGroundImageScale9Enabled(true);
        bgFish.setAnchorPoint(cc.p(0, 1));
        bgFish.setPosition(cc.p(0, container.height));
        container.addChild(bgFish);

        var spriteTitle = new cc.Sprite("#help_fish_title.png");
        spriteTitle.setPosition(30, 365 - 10);
        spriteTitle.setAnchorPoint(cc.p(0, 1));
        bgFish.addChild(spriteTitle);
        var posFish = cc.p(58, 312), posLabel = cc.p(167, 312);
        var fishArr = [{fishPng: "#help_fish_2_1.png", fishValue: 2},
            {fishValue: 2}, {fishValue: 3}, {fishValue: 4},
            {fishValue: 5}, {fishValue: 6}, {fishValue: 7}, {fishValue: 8},
            {fishValue: 9}, {fishValue: 10}, {fishValue: 12}, {fishValue: 15},
            {fishValue: 18}, {fishValue: 20}, {fishValue: 25}, {fishValue: 30},
            {fishValue: 40}, {fishValue: 150}, {fishValue: "150-300"}, {fishValue: 200}, {fishValue: 300}];
        for (var i = 0; i < fishArr.length; i++) {
            var fishPngName = fishArr[i].fishPng || ("#help_fish_" + fishArr[i].fishValue + ".png");
            var fish = new cc.Sprite(fishPngName);
            if (fish) {
                fish.attr({x: posFish.x + (i % 4) * 212, y: posFish.y - Math.floor(i / 4) * 53})
                bgFish.addChild(fish);
            }
            var smallbg = new cc.Sprite("#help_fish_bg.png");
            var fishLabel = new ccui.TextAtlas("" + fishArr[i].fishValue, this.resource.numYellow, 11, 20, "-");
            fishLabel.attr({x: smallbg.width / 2, y: smallbg.height / 2});
            smallbg.addChild(fishLabel);
            smallbg.attr({x: posLabel.x + (i % 4) * 215, y: posFish.y - Math.floor(i / 4) * 53});
            bgFish.addChild(smallbg);
        }

        var bgSpecial = new ccui.Layout();
        bgSpecial.setContentSize(cc.size(868, 500));
        bgSpecial.setBackGroundImage(FishSceneRes.DialogPng.InnerBg, ccui.Widget.PLIST_TEXTURE);
        bgSpecial.setBackGroundImageScale9Enabled(true);
        bgSpecial.setAnchorPoint(cc.p(0, 0));
        bgSpecial.setPosition(cc.p(0, 0));
        container.addChild(bgSpecial);

        var specialTitle = new cc.Sprite("#help_special_title.png");
        specialTitle.setPosition(30, 500 - 10);
        specialTitle.setAnchorPoint(cc.p(0, 1));
        bgSpecial.addChild(specialTitle);

        var specialArr = [
            {png: "#help_quan.png", title: "#help_quan_title.png", msg: "#help_msg_quan.png"},
            {png: "#help_pan.png", title: "#help_pan_msg_title.png", msg: "#help_msg_pan.png"},
            {png: "#help_special.png", title: "#help_special_msg_title.png", msg: "#help_msg_special.png"},
            {png: "#help_boom.png", title: "#help_boom_title.png", msg: "#help_msg_boom.png"}
        ];
        //var specialPosPng = cc.p(30,99),specialPosTitle = cc.p(178,81.5),specialMsg = cc.p(178,115.5);
        for (var i = 0; i < specialArr.length; i++) {

            var specialPng = new cc.Sprite(specialArr[i].png);
            specialPng.setAnchorPoint(cc.p(0, 0.5));
            var specialTitle = new cc.Sprite(specialArr[i].title);
            specialTitle.setAnchorPoint(cc.p(0, 0.5));
            var specialMsg = new cc.Sprite(specialArr[i].msg);
            specialMsg.setAnchorPoint(cc.p(0, 0.5));

            specialPng.attr({x: 30, y: 500 - 99 - i * 117});
            if (i == 0) {
                specialTitle.attr({x: 178, y: 500 - 30});
                specialMsg.attr({x: 178, y: 500 - 90.5 - 117 * i});
            } else {
                specialTitle.attr({x: 178, y: 500 - 81.5 - i * 117});
                specialMsg.attr({x: 178, y: 500 - 115.5 - 117 * i});
            }


            bgSpecial.addChild(specialPng);
            bgSpecial.addChild(specialTitle);
            bgSpecial.addChild(specialMsg);

        }
        scrollView.jumpToTop();

        //bgFish.setBackGroundColor(cc.color.RED);
        //bgFish.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);


    },

    closeCallBack: function () {
        var scene = FYEngine.getRunningLayer(0).getChildByName("helpinfolayer");
        //scene.removeChildByName('helpinfolayer');
        FYEngine.popoutLayerAnimate(scene.layerbg);
    },

});

var BackToLobby = DialogLayer.extend({
    _tag: 0,//1:副本 2：正常场次
    ctor: function (tag) {
        this._tag = tag;
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));

        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        this.addConfirmBtn(function (sender) {
            self.confirmCallBack(sender);
        }, cc.p(bg.width * 0.72, bg.height * 0.15));

        this.addCancelBtn(function (sender) {
            FYEngine.popoutLayerAnimate(self.layerbg);
        }, cc.p(bg.width * 0.31, bg.height * 0.15));

        var tip = new ccui.Text("您是否返回大厅？", '微软雅黑', 30);
        if (tip) {
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

    confirmCallBack: function () {
        var gamelayer = FYEngine.getRunningLayer(0);
        cc.log("tag:" + this._tag);
        if (this._tag == 1) {
            var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
            if (gamehandle && gamehandle._canSendNormalMsg) {
                gamehandle.sendLeaveTableReq();
            }
            FishGlobal.copyTimeControl.copyGameLeftTime = 0;
            cc.sys.localStorage.setItem('copyRecordTime' + appglobal.getPlayer().userid, JSON.stringify(FishGlobal.copyTimeControl));
            gamelayer.exitGame();
        } else {
            var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
            if (gamehandle && gamehandle._canSendNormalMsg) {
                gamehandle.sendLeaveTableReq();
                gamehandle.sendPlayerLogoutRequest();
            }
            gamelayer.runAction(new cc.Sequence(new cc.DelayTime(0.5), new cc.CallFunc(function () {
                gamelayer.exitGame();
            })));
        }
    },

});

var TokenFailLayer = DialogLayer.extend({
    _index: 0,
    ctor: function (index) {
        this._super();
        this._index = index;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn(this.closeCallBack);
        this.addConfirmBtn(this.closeCallBack, cc.p(bg.width * 0.5, bg.height * 0.2 - 15));
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var word = '';
        if (this._index == 0) {
            word = '验证失败, 请重新登录';
        } else {
            word = '连接失败, 请重新登录';
        }
        var tip = new ccui.Text(word, '微软雅黑', 30);
        if (tip) {
            tip.setTextAreaSize(cc.size(450, 120));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

    closeCallBack: function () {
        //todo 需要使用注销登录的功能;
        var layer = FYEngine.getRunningLayer(0);
        var coreserviceproxy = CoreServiceProxy.getInstance();
        coreserviceproxy.unlinkGameClient();
        coreserviceproxy.unlinkLobbyClient();
        app.accountManager.userLogout();
        appglobal._runLobby = false;
        NoticeComm.resetNoticeComm();
        FYEngine.runScene(LoginLayer.createScene());

    },


});
var ReliveTimeOutLayer = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(null, cc.p(bg.width * 0.5, bg.height * 0.2 - 15));
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var limit = FishGlobal.reliveinfor.iLimit ? FishGlobal.reliveinfor.iLimit : 4;
        var tip = new ccui.Text(FYEngine.LanguageString.getValue(DiaMsgkey.reliveTipBefore) + limit + FYEngine.LanguageString.getValue(DiaMsgkey.reliveTipAfter), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setTextAreaSize(cc.size(450, 120));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

});

/**
 * 温馨提示我知道了
 */
var WarmTipLayer = DialogLayer.extend({
    _is3rdLogin: false,
    ctor: function (text, btnName, dontNeedCloseBtn) {
        btnName = btnName || "#iknow.png";
        this._super();

        this.dontNeedCloseBtn = dontNeedCloseBtn || false;

        var jsonStr = app.sdkPlugin.callNativeMethod("is3rdSdkLogin", "");
        if (jsonStr && jsonStr != 'callNativeMethod tag undefined') {
            var json = JSON.parse(jsonStr);
            this._is3rdLogin = appglobal.isBaiduSource()?false:json.is3rdSdkLogin;
        }

        text = text || FYEngine.LanguageString.getValue("WarmTipText");
        this.initUI(text, btnName);
    },
    initUI: function (text, btnName) {
//            cc.log("text--===="+text);
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        if (FishGlobal.kick == 2 && this._is3rdLogin || this.dontNeedCloseBtn) {

        } else {
            this.addCloseBtn();
        }

        var innerbg = this.addInnerBg(cc.size(586, 220));
        this.addConfirmBtn(this.iknowCallback, cc.p(bg.width / 2, bg.height * 0.15), btnName);

        var tip = new ccui.Text("" + text, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);

            if (tip.width > 500) {
                var height = Math.ceil(tip.width / 500) * 36 + 15;
                tip.setTextAreaSize(cc.size(500, height));
            }
        }
    },

    iknowCallback: function () {
        var timeOutLayer = FYEngine.getRunningLayer(0).getChildByName(LobbySceneName.TimeOutLayer);
        if (timeOutLayer) {
            FYEngine.popoutLayerAnimate(timeOutLayer.layerbg);
            return;
        }
        var loginkick = FYEngine.getRunningLayer(0).getChildByName("loginkick");
        if (loginkick) {
            FYEngine.popoutLayerAnimate(loginkick.layerbg);
            return;
        }
        var layer = FYEngine.getRunningLayer(0).getChildByName("layqiehuan");
        var layer1 = FYEngine.getRunningLayer(0).getChildByName("lay5") || FYEngine.getRunningLayer(0).getChildByName("lay4") || FYEngine.getRunningLayer(0).getChildByName("kickedbyserver");
        var layer2 = FYEngine.getRunningLayer(0).getChildByName('tipoutlayer') || FYEngine.getRunningLayer(0).getChildByName('timeoutkicklayer');
        var layer_serverKick = FYEngine.getRunningLayer(0).getChildByName('layer_serverKick');

        if (layer2) {
            FYEngine.popoutLayerAnimate(layer2.layerbg);
            return;
        }

        if (layer_serverKick) {
            FYEngine.closeApp();
            return;
        }

        if (layer) {
            app.accountManager.userLogout();
            cc.director.runScene(LoginLayer.createScene());
        }
        else {
            FYEngine.popoutLayerAnimate(layer1.layerbg);
        }


        //var layer = scene.getChildByName('lay4');
        //if(layer){
        //FYEngine.popoutLayerAnimate(layer.layerbg);
        //}
        //else{
        //    layer =scene.getChildByName("layqiehuan");
        //    if(layer){
        //        app.sdkservice.userLogout();
        //        cc.director.runScene(new InitScene());
        //    }
        //}
    },

});

var ExitGame = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));
        this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width * 0.72, bg.height * 0.15));
        this.addCancelBtn(null, cc.p(bg.width * 0.31, bg.height * 0.15));

        var tip = new ccui.Text(FYEngine.LanguageString.getValue("ExitGame"), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            //tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

    confirmCallBack: function () {
        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handler) {
            handler.sendPlayerLogoutReq();
        }
        FYEngine.closeApp();
    }

});

var DailyChargeOverrangeWindow = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(570, 190));
        innerbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.6));
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
        }, cc.p(bg.width * 0.5, bg.height * 0.21));
        // this.addCancelBtn(null, cc.p(bg.width*0.31, bg.height*0.21));
        var mstr = "适度娱乐，理性消费。您今天的充值额度已经达到每日限额了哦~\n如有疑问，请咨询客服QQ：3003674856";

        var tip = new ccui.Text(mstr, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (tip) {
            tip.setTextAreaSize(cc.size(500, 100));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.5));
            //tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            this.innerBg.addChild(tip, 0, 10);
        }
    },

});


var GoCharge = DialogLayer.extend({
    ctor: function (type, money) {
        this._super();
        this.initUI(type, money);
    },

    initUI: function (type, money) {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));
        this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width * 0.72, bg.height * 0.15));
        this.addCancelBtn(null, cc.p(bg.width * 0.31, bg.height * 0.15));
        var msg = type == 1 ? FYEngine.LanguageString.getValue("FastEnterLess") : FYEngine.LanguageString.getValue("FishEnterLess1") + money + FYEngine.LanguageString.getValue("FishEnterLess2");
        var tip = new ccui.Text(msg, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
            tip.setTextAreaSize(cc.size(450, 120));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            //tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },
    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        if (scene.getChildByName("gocharge")) {

            scene.getChildByName("gocharge").removeFromParent(true);
        }

        var mlayer = scene.getChildByName(LobbySceneName.MallLayer);
        if (!mlayer) {
            var mlayer = new MallLayer();
            scene.addChild(mlayer, FishZorder.poplayer, LobbySceneName.MallLayer);
            FYEngine.popupLayerAnimate(mlayer.layerbg, undefined, undefined, cc.p(mlayer.width / 2, mlayer.height * 0.4 + 30));
        }

    },

});


var GoHigher = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));
        this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width * 0.72, bg.height * 0.15), SccomRes.MallRes.gohigher);
        this.addCancelBtn(null, cc.p(bg.width * 0.31, bg.height * 0.15));

        var tip = new ccui.Text(FYEngine.LanguageString.getValue("FishEnterMore"), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.5));
            tip.setTextAreaSize(cc.size(450, 120));
            //tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        scene.removeChildByName('gocharge');
        var loadlayer = scene.getChildByName('loadinglayer');
        if (!loadlayer) {
            var mlayer = FYEngine.createLoadingLayer(UsedResName.HallLoadingquan, UsedResName.HallLoadingfish);
            scene.addChild(mlayer, FishZorder.poplayer, 'loadinglayer');
        }
        scene.FastEnter();

    },

});

var EnterFailedLayer = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg("#dialog_5.png", 654);
        this.addCloseBtn(this.closeCallBack);
        this.addConfirmBtn(this.closeCallBack, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), "#iknow.png");
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var tip = new ccui.Text(FYEngine.LanguageString.getValue("loginNetWorkErr"), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            //tip.setTextAreaSize(cc.size(450,120));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            //tip.enableShadow(cc.color(0,0,0,0),cc.size(1,1),0);
            //tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

    closeCallBack: function () {
//        cc.director.end();
        FYEngine.closeApp();
    },


});

var IosPayLayer = DialogLayer.extend({
    _info: {},
    ctor: function (info) {
        this._super();
        this._info = info;

        this.initUI();

    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(700, 400));
        var innerbg = this.addInnerBg(cc.size(635, 288));
        innerbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.5));
        var tittle = new cc.Sprite('#smallwines0.png');
        if (tittle) {
            bg.addChild(tittle);
            tittle.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.95));
            var tiname = new cc.Sprite('#iospayres4.png');
            if (tiname) {
                tittle.addChild(tiname);
                tiname.setPosition(cc.p(tittle.width / 2, tittle.height / 2 + 5));
            }
        }
        this.addCloseBtn();

        var IOSbtn = new cc.Sprite("#iospayres1.png");
        if (IOSbtn) {
            IOSbtn.setPosition(bg.width * 0.3, bg.height / 2);
            bg.addChild(IOSbtn, 0, 'IOSBTN');
            FYEngine.AddNodeTouchListener(IOSbtn, function (sender) {
                self.payCallBack(sender);
            }, FYEngine.ActionType.Fade);
        }


        var ABbtn = new cc.Sprite("#iospayres2.png");
        if (ABbtn) {
            ABbtn.setPosition(bg.width * 0.7, bg.height / 2);
            bg.addChild(ABbtn, 0, 'ABBTN');
            FYEngine.AddNodeTouchListener(ABbtn, function (sender) {
                self.payCallBack(sender);
            }, FYEngine.ActionType.Fade);
        }


    },

    payCallBack: function (sender) {
        var name = sender.getName();
        var scene = FYEngine.getRunningLayer(0);
        //var layer = scene.getChildByName(LobbySceneName.MallLayer);
        FishGlobal.iosPayTag = 0;
        switch (name) {
            case 'IOSBTN' : {
//                cc.log('------按钮名字:'+name);
                var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                if (handler) {
//                    cc.log('——————————————发送充值请求-------------');
                    FishGlobal.iosPayTag = 0;
                    handler.sendQueryDailyChargeReq(this._info.goodsId);
                }
            }
                break;
            case 'ABBTN' : {
//                cc.log('------按钮名字:'+name);
                FishGlobal.iosPayTag = 1;
                var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                if (handler) {
//                    cc.log('——————————————发送充值请求-------------');
                    handler.sendQueryDailyChargeReq(this._info.goodsId);
                }
            }
                break;
            default :
                break;
        }

    }

});

var MultiPayLayer = DialogLayer.extend({
    _info: {},
    ctor: function (info) {
        this._super();
        this._info = info;

        this.initUI();

    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(700, 400));
        var innerbg = this.addInnerBg(cc.size(635, 288));
        innerbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.5));
        var tittle = new cc.Sprite('#smallwines0.png');
        if (tittle) {
            bg.addChild(tittle);
            tittle.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.95));
            var tiname = new cc.Sprite('#iospayres4.png');
            if (tiname) {
                tittle.addChild(tiname);
                tiname.setPosition(cc.p(tittle.width / 2, tittle.height / 2 + 5));
            }
        }
        this.addCloseBtn();

        var WXbtn = new ccui.ImageView("iospayres5.png", ccui.Widget.PLIST_TEXTURE);
        if (WXbtn) {
            bg.addChild(WXbtn, 10, "WXbtn");
            WXbtn.setPosition(cc.p(bg.width * 0.3, bg.height * 0.5));
            WXbtn.setTouchEnabled(true);
            WXbtn.addClickEventListener(function (sender) {
                self.payCallBack(sender);
            });
            WXbtn.addTouchEventListener(this.btnEffect, this);
        }

        // var QQbtn = new ccui.ImageView("iospayres6.png",ccui.Widget.PLIST_TEXTURE);
        // if(QQbtn){
        //     bg.addChild(QQbtn,10,"QQbtn");
        //     QQbtn.setPosition(cc.p(bg.width*0.5,bg.height*0.5));
        //     QQbtn.setTouchEnabled(true);
        //     QQbtn.addClickEventListener(function(sender){
        //         self.payCallBack(sender);
        //     });
        //     QQbtn.addTouchEventListener(this.btnEffect,this);
        // }

        var APbtn = new ccui.ImageView("iospayres7.png", ccui.Widget.PLIST_TEXTURE);
        if (APbtn) {
            bg.addChild(APbtn, 10, "APbtn");
            APbtn.setPosition(cc.p(bg.width * 0.7, bg.height * 0.5));
            APbtn.setTouchEnabled(true);
            APbtn.addClickEventListener(function (sender) {
                self.payCallBack(sender);
            });
            APbtn.addTouchEventListener(this.btnEffect, this);
        }
    },

    btnEffect: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN: {
                sender.setScale(1.1);
            }
                break;
            case ccui.Widget.TOUCH_CANCELED: {

            }
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
        }
    },

    payCallBack: function (sender) {
        var name = sender.getName();
        cc.log("--btnname:" + name);
        FishGlobal.iosPayTag = 0;
        FishGlobal.multipayTag = "IAPPY";
        switch (name) {
            case 'WXbtn' : {
                FishGlobal.multipayTag = "WX";
                var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                if (handler) {
                    handler.sendQueryDailyChargeReq(this._info.goodsId);
                }
            }
                break;
            case 'QQbtn' : {
                FishGlobal.multipayTag = "QQ";
                var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                if (handler) {
                    handler.sendQueryDailyChargeReq(this._info.goodsId);
                }
            }
                break;
            case 'APbtn' : {
                FishGlobal.multipayTag = "AP";
                var handler = CoreServiceProxy.getInstance().getLobbyHandler();
                if (handler) {
                    handler.sendQueryDailyChargeReq(this._info.goodsId);
                }
            }
                break;
            default :
                break;
        }

    }

});

var LuckyCrystal = DialogLayer.extend({
    _time: 0,
    _showbutton: 0,
    ctor: function () {
        this._super();
        this.addLayerBg(cc.size(529, 530));
        this.addTitleBg("#fish_boom24.png", 545);
        this.addCloseBtn();

        var contentLayout = this._contentLayout = new ccui.Layout();
        if (contentLayout) {
            contentLayout.setContentSize(cc.size(529, 520));
            contentLayout.setBackGroundImageScale9Enabled(true);
            contentLayout.setAnchorPoint(cc.p(0.5, 0.5));
            contentLayout.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height / 2));
            this.layerbg.addChild(contentLayout);
        }


        this.scheduleOnce(this.enterfunction, 0.25);
        this.schedule(this.checkGetCrystalNumber, 1);
    },

    enterfunction: function () {
        var scene = FYEngine.getRunningLayer(0);
        this.addIncomingLoading();
        if (scene._handler._canSendNormalMsg) {
            scene._handler.sendGetCrystalInfoReq();
        }
    },

    addIncomingLoading: function () {
        var lsprite = this.layerbg.getChildByName('lsprite');
        if (!lsprite) {
            lsprite = new cc.Sprite('#crystal27.png');
            if (lsprite) {
                this.layerbg.addChild(lsprite, 10, 'lsprite');
                lsprite.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height / 2));
                lsprite.runAction(cc.repeatForever(cc.rotateBy(1, 360)));
                this._lsprite = lsprite;
            }
        }

    },

    removeIncomingLoading: function () {
        if (this._lsprite) {
            this._lsprite.removeFromParent(true);
        }
    },

    addLoadingErrTip: function () {
        var lsprite = new cc.Sprite('#crystal29.png');
        if (lsprite) {
            this.layerbg.addChild(lsprite);
            lsprite.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height / 2));
        }
    },

    checkGetCrystalNumber: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeIncomingLoading();
            this.addLoadingErrTip();
            this.unschedule(this.checkGetCrystalNumber);
        }
    },

    initUI: function () {
        cc.log("initUI" + this._showbutton);
        this._contentLayout.removeAllChildren();
        var player = appglobal.getPlayer();
        // if (player.crystal <= 0) {
        this._showbutton = 0;
        this.initUIwithoutButton();
        // } else {
        //     this._showbutton = 1;
        //     this.initUIwithButton();
        // }
    },

    initUIwithButton: function () {
        var self = this;
        var innerBg = this.innerBg = FYEngine.createImageView(FishSceneRes.DialogPng.InnerBg,
            cc.p(this.layerbg.width / 2, 220), cc.p(0.5, 0.5), cc.size(460, 220));
        if (innerBg) {
            this._contentLayout.addChild(innerBg, 0, "innerBg");
        }

        var innertext2 = new cc.LabelTTF();
        if (innertext2) {
            innertext2.initWithString("在渔场中发射核弹需要消耗数量不等的弹头，使用弹头炸鱼可随机获取一定数量金币；\n拥有弹头可略微提升捕鱼概率", '微软雅黑', 22);
            innertext2.setAnchorPoint(cc.p(0, 0.5));
            innertext2.setPosition(cc.p(12, 140));
            innertext2.setColor(cc.color(255, 255, 255));
            innertext2.setDimensions(cc.size(450, 120));
            innerBg.addChild(innertext2);
        }

        var innertext5 = new cc.LabelTTF();
        if (innertext5) {
            innertext5.initWithString("获取方式：", '微软雅黑', 22);
            innertext5.setAnchorPoint(cc.p(0, 0.5));
            innertext5.setPosition(cc.p(12, 95));
            innertext5.setColor(cc.color("02fef5"));
            innerBg.addChild(innertext5);
        }

        var innertext6 = new cc.LabelTTF();
        if (innertext6) {
            innertext6.initWithString("在兑换商城中使用奖券兑换\n在海神副本中使用材料熔炼", '微软雅黑', 22);
            innertext6.setAnchorPoint(cc.p(0, 0.5));
            innertext6.setPosition(cc.p(80, 45));
            innerBg.addChild(innertext6);
        }

        var upbg = new ccui.ImageView("fish_vip_res34.png", ccui.Widget.PLIST_TEXTURE);
        if (upbg) {
            this._contentLayout.addChild(upbg, 0, "upbg");
            upbg.setPosition(cc.p(this._contentLayout.width / 2, 400));
            upbg.setScale9Enabled(true);
            upbg.setContentSize(cc.size(473, 129));
            var crystalImage = new cc.Sprite('#fish_boom55.png');
            if (crystalImage) {
                upbg.addChild(crystalImage, 0, "crystalImage");
                crystalImage.setPosition(cc.p(70, upbg.height / 2));
            }

            var text1 = FYEngine.createText("拥有数量 :", '微软雅黑', 22);
            if (text1) {
                upbg.addChild(text1, 0, "text1");
                text1.setAnchorPoint(cc.p(0, 0.5));
                text1.setPosition(cc.p(135, 85));
                text1.setTextColor(cc.color("007290"));
            }

            var numberbg = new ccui.ImageView("crystal49.png", ccui.Widget.PLIST_TEXTURE);
            if (numberbg) {
                upbg.addChild(numberbg, 0, "numberbg");
                numberbg.setScale9Enabled(true);
                numberbg.setContentSize(cc.size(150, 45));
                numberbg.setPosition(cc.p(200, 40));
            }


            var text2 = FYEngine.createText(appglobal.getPlayer().crystal + '', '微软雅黑', 25);
            if (text2) {
                upbg.addChild(text2, 1, "boomqty");
                text2.setAnchorPoint(cc.p(0.5, 0.5));
                text2.setPosition(cc.p(200, 40));
                text2.setTextColor(cc.color("FCF304"));
            }
        }


        var btn_sendtoother = new ccui.ImageView("fish_boom50.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_sendtoother) {
            this._contentLayout.addChild(btn_sendtoother, 2, "btn_sendtoother");
            btn_sendtoother.setTouchEnabled(true);
            btn_sendtoother.setPosition(cc.p(410, 400));
            btn_sendtoother.addTouchEventListener(this.btnTouchEft, this);
            btn_sendtoother.addClickEventListener(function (sender) {
                self.clickCallBack(sender);
            });
        }


        var btn_entermall = new ccui.ImageView("fish_boom52.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_entermall) {
            this._contentLayout.addChild(btn_entermall, 1, "btn_entermall");
            btn_entermall.setTouchEnabled(true);
            btn_entermall.setPosition(cc.p(115, 60));
            btn_entermall.addTouchEventListener(this.btnTouchEft, this);
            btn_entermall.addClickEventListener(function (sender) {
                self.clickCallBack(sender);
            });
        }

        var btn_entercopy = new ccui.ImageView("fish_boom53.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_entercopy) {
            this._contentLayout.addChild(btn_entercopy, 1, "btn_entercopy");
            btn_entercopy.setTouchEnabled(true);
            btn_entercopy.setPosition(cc.p(265, 60));
            btn_entercopy.addTouchEventListener(this.btnTouchEft, this);
            btn_entercopy.addClickEventListener(function (sender) {
                self.clickCallBack(sender);
            });
        }

        var btn_sendRecord = new ccui.ImageView("fish_boom54.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_sendRecord) {
            this._contentLayout.addChild(btn_sendRecord, 1, "btn_sendRecord");
            btn_sendRecord.setTouchEnabled(true);
            btn_sendRecord.setPosition(cc.p(410, 60));
            btn_sendRecord.addTouchEventListener(this.btnTouchEft, this);
            btn_sendRecord.addClickEventListener(function (sender) {
                self.clickCallBack(sender);
            });

            var redtip = new cc.Sprite('#crystal09.png');
            if (redtip) {
                btn_sendRecord.addChild(redtip, 0, "redtip");
                redtip.setPosition(cc.p(btn_sendRecord.width * 0.88, btn_sendRecord.height * 0.87));
                if (FishGlobal.showRedTip == 1) {
                    this.showRed();
                } else {
                    this.hideRed();
                }
            }
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    initUIwithoutButton: function () {
        var self = this;
        var innerBg = this.innerBg = FYEngine.createImageView(FishSceneRes.DialogPng.InnerBg,
            cc.p(this.layerbg.width / 2, 220), cc.p(0.5, 0.5), cc.size(460, 220));
        if (innerBg) {
            this._contentLayout.addChild(innerBg, 0, "innerBg");
        }

        var innertext2 = new cc.LabelTTF();
        if (innertext2) {
            innertext2.initWithString("在渔场中发射核弹需要消耗数量不等的弹头，使用弹头炸鱼可随机获取一定数量金币；\n拥有弹头可略微提升捕鱼概率", '微软雅黑', 22);
            innertext2.setAnchorPoint(cc.p(0, 0.5));
            innertext2.setPosition(cc.p(12, 140));
            innertext2.setColor(cc.color(255, 255, 255));
            innertext2.setDimensions(cc.size(450, 120));
            innerBg.addChild(innertext2);
        }

        var innertext5 = new cc.LabelTTF();
        if (innertext5) {
            innertext5.initWithString("获取方式：", '微软雅黑', 22);
            innertext5.setAnchorPoint(cc.p(0, 0.5));
            innertext5.setPosition(cc.p(12, 105));
            innertext5.setColor(cc.color("02fef5"));
            innerBg.addChild(innertext5);
        }

        var innertext6 = new cc.LabelTTF();
        if (innertext6) {
            innertext6.initWithString("在兑换商城中使用奖券兑换\n在海神副本中使用材料熔炼\n在积分游戏中开启宝箱获得", '微软雅黑', 22);
            innertext6.setAnchorPoint(cc.p(0, 0.5));
            innertext6.setPosition(cc.p(80, 50));
            innerBg.addChild(innertext6);
        }

        var upbg = new ccui.ImageView("fish_vip_res34.png", ccui.Widget.PLIST_TEXTURE);
        if (upbg) {
            this._contentLayout.addChild(upbg, 0, "upbg");
            upbg.setPosition(cc.p(this._contentLayout.width / 2, 400));
            upbg.setScale9Enabled(true);
            upbg.setContentSize(cc.size(473, 129));

            var crystalImage = new cc.Sprite('#fish_boom55.png');
            if (crystalImage) {
                upbg.addChild(crystalImage, 0, "crystalImage");
                crystalImage.setPosition(cc.p(140, upbg.height / 2));
            }

            var text1 = FYEngine.createText("拥有数量 :", '微软雅黑', 22);
            if (text1) {
                upbg.addChild(text1, 0, "text1");
                text1.setAnchorPoint(cc.p(0, 0.5));
                text1.setPosition(cc.p(205, 85));
                text1.setTextColor(cc.color("007290"));
            }

            var numberbg = new ccui.ImageView("crystal49.png", ccui.Widget.PLIST_TEXTURE);
            if (numberbg) {
                upbg.addChild(numberbg, 0, "numberbg");
                numberbg.setScale9Enabled(true);
                numberbg.setContentSize(cc.size(150, 45));
                numberbg.setPosition(cc.p(270, 40));
            }

            var text2 = FYEngine.createText(appglobal.getPlayer().crystal + '', '微软雅黑', 25);
            if (text2) {
                upbg.addChild(text2, 1, "boomqty");
                text2.setAnchorPoint(cc.p(0.5, 0.5));
                text2.setPosition(cc.p(270, 40));
                text2.setTextColor(cc.color("F3FC04"));
            }
        }

        var btn_entermall = new ccui.ImageView("fish_boom52.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_entermall) {
            this._contentLayout.addChild(btn_entermall, 1, "btn_entermall");
            btn_entermall.setTouchEnabled(true);
            btn_entermall.setPosition(cc.p(110, 60));
            btn_entermall.addTouchEventListener(this.btnTouchEft, this);
            btn_entermall.addClickEventListener(function (sender) {
                self.clickCallBack(sender);
            });
        }

        var btn_entercopy = new ccui.ImageView("fish_boom53.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_entercopy) {
            this._contentLayout.addChild(btn_entercopy, 1, "btn_entercopy");
            btn_entercopy.setTouchEnabled(true);
            btn_entercopy.setPosition(cc.p(260, 60));
            btn_entercopy.addTouchEventListener(this.btnTouchEft, this);
            btn_entercopy.addClickEventListener(function (sender) {
                self.clickCallBack(sender);
            });
        }

        var btn_enterintgame = new ccui.ImageView("N_G_H_48.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_enterintgame) {
            this._contentLayout.addChild(btn_enterintgame, 1, "btn_enterintgame");
            btn_enterintgame.setTouchEnabled(true);
            btn_enterintgame.setPosition(cc.p(410, 60));
            btn_enterintgame.addTouchEventListener(this.btnTouchEft, this);
            btn_enterintgame.addClickEventListener(function (sender) {
                self.clickCallBack(sender);
            });
        }
    },

    showRed: function () {
        var recordbtn = this._contentLayout.getChildByName("btn_sendRecord");
        if (recordbtn) {
            var redtip = recordbtn.getChildByName("redtip");
            if (redtip) {
                redtip.setVisible(true);
            }
        }
    },

    hideRed: function () {
        var recordbtn = this._contentLayout.getChildByName("btn_sendRecord");
        if (recordbtn) {
            var redtip = recordbtn.getChildByName("redtip");
            if (redtip) {
                redtip.setVisible(false);
            }
        }
    },

    clickCallBack: function (sender) {
        var name = sender.getName();
        var scene = FYEngine.getRunningLayer(0);
        var player = appglobal.getPlayer();
        cc.log('-----------anniu:' + name);
        switch (name) {
            case "btn_enterintgame" :{
                FYEngine.runScene(GameNewLobby.createScene());
            }break;
            case 'btn_entermall' : {
                this.removeFromParent(true);
                var layer = scene.getChildByName(LobbySceneName.ExchangeLayer);
                if (!layer) {
                    layer = new RewardLayer();
                    scene.addChild(layer, FishZorder.poplayer, LobbySceneName.ExchangeLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg, undefined, undefined, cc.p(layer.width / 2, layer.height * 0.4 + 30));
                }
            }
                break;
            case 'btn_entercopy' : {
                FishGlobal.roomId = 4;
                scene.createLoading();
                scene.loadFish();
                scene.scheduleOnce(scene.joinTableCheck, 15);
            }
                break;
            case 'btn_sendtoother' : {
                cc.log('----FishGlobal.lRemaind:' + FishGlobal.lRemaind);
                if (player.iVIPLevel < FishGlobal._canSendLevel) {
                    var layer = scene.getChildByName(LobbySceneName.VipSendLevel);
                    if (!layer) {
                        layer = new VipSendLevel();
                        scene.addChild(layer, FishZorder.poplayer, LobbySceneName.VipSendLevel);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }
                } else if (FishGlobal.lRemaind > 0) {
                    if (FishGlobal.is3rdLogin) {
                        var layer = scene.getChildByName(LobbySceneName.CrystalFunctionLevel3rd);
                        if (!layer) {
                            layer = new SendCrystalLevel3rdDialog(FishGlobal.lRemaind);
                            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.CrystalFunctionLevel3rd);
                            FYEngine.popupLayerAnimate(layer.layerbg);
                        }
                    } else {
                        var layer = scene.getChildByName(LobbySceneName.CrystalFunctionLevel);
                        if (!layer) {
                            layer = new SendCrystalLevelDialog(FishGlobal.lRemaind, 0);
                            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.CrystalFunctionLevel);
                            FYEngine.popupLayerAnimate(layer.layerbg);
                        }
                    }
                } else if (FishGlobal.lRemaind < 0) {
                    var layer = scene.getChildByName(LobbySceneName.CrystalFunctionLevel);
                    if (!layer) {
                        layer = new SendCrystalLevelDialogAttache();
                        scene.addChild(layer, FishZorder.poplayer, LobbySceneName.CrystalFunctionLevel);
                        FYEngine.popupLayerAnimate(layer.layerbg);
                    }

                } else {
                    // if (scene.getName() == "lobbyscene") {
                    //     var layer = scene.getChildByName(LobbySceneName.CrystalSendToOtherLayer);
                    //     if (!layer) {
                    //         layer = new SendToOtherLayer();
                    //         scene.addChild(layer, FishZorder.poplayer, LobbySceneName.CrystalSendToOtherLayer);
                    //         FYEngine.popupLayerAnimate(layer.layerbg);
                    //     }
                    // }
                }
            }
                break;
            case "btn_sendRecord" : {
                FishGlobal.showRedTip = 0;
                cc.sys.localStorage.setItem(appglobal.getPlayer().userid + 'noRead', 0 + '');
                scene.onGameEvent(lobbyGameEvent.hideRed);
                var mlayer = new SendRecordLayer();
                if (mlayer) {
                    scene.addChild(mlayer, FishZorder.poplayer, LobbySceneName.CrystalSendRecordLayer);
                    FYEngine.popupLayerAnimate(mlayer.layerbg);
                }
            }
                break;
        }
    },

    updateWealth: function () {
        var player = appglobal.getPlayer();
        var numerBg = this._contentLayout.getChildByName("upbg");
        if (numerBg) {
            var qty = numerBg.getChildByName("boomqty");
            if (qty) {
                qty.setString(player.crystal);
            }
        }
    },


});

var SendRecordLayer = DialogLayer.extend({
    _index: 0,
    _loadend: 0,
    _loadRevEnd: 0,
    _revArry: [],
    _sedArry: [],
    ctor: function () {
        this._super();
        this._index = 0;
        this._revArry = [];
        this._sedArry = [];
        this.init(cc.color(0, 0, 0, 100), 1136, 640);
        this.initUI();

    },

    onExit: function () {
        this._super();
        cc.log('---------退出');
        for (var i = 0; i < this._revArry.length; ++i) {
            this._revArry[i].removeFromParent(true);
            cc.pool.putInPool(this._revArry[i]);

        }

        for (var j = 0; j < this._sedArry.length; ++j) {
            this._sedArry[j].removeFromParent(true);
            cc.pool.putInPool(this._sedArry[j]);
        }
    },

    initUI: function () {
        this.addLayerBg(cc.size(663, 540));
        this.addTitleBg('#crystal50.png', 670);
        this.addCloseBtn();
        this._loadend = 0;
        this._loadRevEnd = 0;

        var backBtn = new ccui.ImageView('crystal_oldres26.png', ccui.Widget.PLIST_TEXTURE);
        if (backBtn) {
            this.layerbg.addChild(backBtn, 0, 'backbtn');
            backBtn.setAnchorPoint(cc.p(0.5, 0.5));
            backBtn.setScale9Enabled(true);
            backBtn.setPosition(cc.p(this.layerbg.width / 2, 440));
            backBtn.setCapInsets(cc.rect(20, 0, 10, 52));
            backBtn.setContentSize(cc.size(345, 52));

            var revtip = new ccui.ImageView('');
            if (revtip) {
                backBtn.addChild(revtip, 0, 0);
                revtip.setAnchorPoint(cc.p(0.5, 0.5));
                revtip.setPosition(cc.p(backBtn.width * 0.25, backBtn.height / 2));
                revtip.setScale9Enabled(true);
                revtip.setContentSize(cc.size(160, 70));
                revtip.setTouchEnabled(true);
                revtip.addClickEventListener(this.clickCallBack);
                var revtiprender = new cc.Sprite("#crystal58.png");
                if (revtiprender) {
                    revtip.addChild(revtiprender);
                    revtiprender.setPosition(cc.p(revtip.width / 2, revtip.height / 2));
                }
                this._revtip = revtip;
            }
            var revbtn = new ccui.ImageView('crystal54.png', ccui.Widget.PLIST_TEXTURE);
            if (revbtn) {
                backBtn.addChild(revbtn, 1, 'revbtn');
                revbtn.setPosition(cc.p(backBtn.width * 0.25, backBtn.height / 2));
                revbtn.setSwallowTouches(true);
                var revtitle = new cc.Sprite('#crystal53.png');
                if (revtitle) {
                    revbtn.addChild(revtitle);
                    revtitle.setPosition(cc.p(revbtn.width / 2, revbtn.height / 2 + 5))
                }
                this._revbtn = revbtn;
            }

            //var sedtip = new ccui.ImageView('crystal51.png',ccui.Widget.PLIST_TEXTURE);
            var sedtip = new ccui.ImageView('');
            if (sedtip) {
                backBtn.addChild(sedtip, 0, 1);
                sedtip.setAnchorPoint(cc.p(0.5, 0.5));
                sedtip.setPosition(cc.p(backBtn.width * 0.75, backBtn.height / 2));
                sedtip.setScale9Enabled(true);
                sedtip.setContentSize(cc.size(160, 70));
                sedtip.setTouchEnabled(true);
                sedtip.addClickEventListener(this.clickCallBack);
                this._sedtip = sedtip;
                var sedtiprender = new cc.Sprite("#crystal51.png");
                if (sedtiprender) {
                    sedtip.addChild(sedtiprender);
                    sedtiprender.setPosition(cc.p(sedtip.width / 2, sedtip.height / 2));
                }
            }
            var sedbtn = new ccui.ImageView('crystal54.png', ccui.Widget.PLIST_TEXTURE);
            if (sedbtn) {
                sedbtn.setVisible(false);
                backBtn.addChild(sedbtn, 1, 'sedbtn');
                sedbtn.setSwallowTouches(true);
                sedbtn.setPosition(cc.p(backBtn.width * 0.75, backBtn.height / 2));
                var sedtitle = new cc.Sprite('#crystal57.png');
                if (sedtitle) {
                    sedbtn.addChild(sedtitle);
                    sedtitle.setPosition(cc.p(sedbtn.width / 2, sedbtn.height / 2 + 5))
                }
                this._sedbtn = sedbtn;
            }
        }
        this.scheduleOnce(function () {
            this.addIncomingLoading();
            this._revtip.setTouchEnabled(false);
            this._sedtip.setTouchEnabled(false);
        }, 0.2);

        this.scheduleOnce(function () {
            this.showRevRecord();
            //this.showSedRecord();
            //this._sedlist.setVisible(false);
            this._revlist.setVisible(false);
        }, 0.5);

        this.scheduleOnce(function () {
            this.removeLoading();
            this._loadend = 1;
            this._revtip.setTouchEnabled(true);
            this._sedtip.setTouchEnabled(true);
            if (this._index == 0) {
                if (this._revlist) {
                    this._revlist.setVisible(true);
                }
            } else {
                if (this._sedlist) {
                    this._sedlist.setVisible(true);
                }

            }
        }, 0.7);


    },

    clickCallBack: function (sender) {
//        cc.log('-----------按钮按下:'+sender.getTag());
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.CrystalSendRecordLayer);
        if (layer._index == sender.getTag()) {
            layer._index = sender.getTag();
            return;
        }
        if (sender.getTag() == 1) {
            layer._index = sender.getTag();
            layer._sedbtn.setVisible(true);
            layer._revbtn.setVisible(false);
            if (layer._loadRevEnd == 0) {
                if (layer._loadend == 1) {
                    layer._revlist.setVisible(false);
                }
                //layer.scheduleOnce(function(){
                //    layer.addIncomingLoading();
                //},0.1);
                layer._revtip.setTouchEnabled(false);
                layer._sedtip.setTouchEnabled(false);
                layer.addIncomingLoading();
                layer.scheduleOnce(function () {
                    layer.showSedRecord();
                    layer._sedlist.setVisible(false);
                }, 0.4);

                layer.scheduleOnce(function () {
                    layer.removeLoading();
                    layer._loadend = 1;
                    layer._loadRevEnd = 1;
                    layer._revtip.setTouchEnabled(true);
                    layer._sedtip.setTouchEnabled(true);
                    if (layer._index == 0) {
                        if (layer._revlist) {
                            layer._revlist.setVisible(true);
                        }
                    } else {
                        if (layer._sedlist) {
                            layer._sedlist.setVisible(true);
                        }

                    }

                }, 0.6);
                return;
            }
            if (layer._loadend == 1) {
                layer._revlist.setVisible(false);
                layer._sedlist.setVisible(true);
            }

            //layer.removeNoRevRecordBg();
            //layer.removeRevList();
            //layer.addIncomingLoading();
            //layer.unschedule(layer.turnToRev);
            //layer.scheduleOnce(layer.turnToSend,0.5);
            //layer.refreshListView(layer._index);
            //cc.eventManager.dispatchCustomEvent("recrystalfreshList", '' + layer._index);
        } else {
            layer._index = sender.getTag();
            layer._sedbtn.setVisible(false);
            layer._revbtn.setVisible(true);
            if (layer._loadend == 1) {
                layer._revlist.setVisible(true);
                layer._sedlist.setVisible(false);
            }

            //layer.removeNoSendRecordBg();
            //layer.removeSedList();
            //layer.addIncomingLoading();
            //layer.unschedule(layer.turnToSend);
            //layer.scheduleOnce(layer.turnToRev,0.5);
            //layer.refreshListView(layer._index);
            //cc.eventManager.dispatchCustomEvent("recrystalfreshList", '' + layer._index);
        }

    },

    turnToSend: function () {
        this.removeLoading();
        //this.removeNoRevRecordBg();
        //this.removeRevList();
        this.showSedRecord();
    },

    turnToRev: function () {
        this.removeLoading();
        //this.removeNoSendRecordBg();
        //this.removeSedList();
        this.showRevRecord();
    },


    addIncomingLoading: function () {
        var lsprite = this.layerbg.getChildByName('lsprite');
        if (!lsprite) {
            lsprite = new cc.Sprite('#crystal27.png');
            if (lsprite) {
                this.layerbg.addChild(lsprite, 10, 'lsprite');
                lsprite.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height / 2));
                lsprite.runAction(cc.repeatForever(cc.rotateBy(1, 360)));
                this._lsprite = lsprite;
            }
        }
    },

    removeLoading: function () {
        if (this._lsprite) {
            this._lsprite.removeFromParent(true);
        }
    },

    showRevRecord: function () {
        if (FishGlobal.revRecord.Msg.length == 0) {
            this.addNoRevRecordBg();
            return;
        }
        var listview = FYEngine.createListView(cc.size(660, 360), cc.p(this.layerbg.width / 2, this.layerbg.height * 0.4), cc.p(0.5, 0.5), 10, ccui.ScrollView.DIR_VERTICAL);
        if (listview) {
            this.layerbg.addChild(listview, 1, 'listrev');
            this._revlist = listview;
        }

        listview.setScrollBarEnabled(false);

        if (FishGlobal.revRecord.Msg.length > 0) {
            for (var i = (FishGlobal.revRecord.Msg.length - 1); i >= 0; --i) {
                //var box = new CrystalRecordBox(0, FishGlobal.revRecord.Msg[i]);
                //if (box) {
                //    box.setAnchorPoint(cc.p(0.5, 0.5));
                //    this._revlist.pushBackCustomItem(box);
                //}

                var box = CrystalRecordBox.create(0, FishGlobal.revRecord.Msg[i]);
                if (box) {
                    box.setAnchorPoint(cc.p(0.5, 0.5));
                    this._revlist.pushBackCustomItem(box);
                    this._revArry.push(box);
                }
            }
        }
    },

    addNoRevRecordBg: function () {
        var revbg = this.layerbg.getChildByName('revbg');
        if (!revbg) {
            revbg = new cc.Sprite('#fish_boom17.png');
            if (revbg) {
                revbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height / 2));
                this.layerbg.addChild(revbg, 1, 'revbg');
                this._revlist = revbg;
            }
        }

    },

    removeNoRevRecordBg: function () {
//        cc.log('------删除接受记录背景');
        var revbg = this.layerbg.getChildByName('revbg');
        if (revbg) {
            revbg.removeFromParent(true);
        }
    },

    removeRevList: function () {
//        cc.log('------删除接受记录');
        if (this._revlist) {
            this._revlist.removeFromParent(true);
        }
    },

    removeSedList: function () {
//        cc.log('------删除发送记录');
        if (this._sedlist) {
            this._sedlist.removeFromParent(true);
        }
    },

    addNoSendRecordBg: function () {
        var sedbg = this.layerbg.getChildByName('sedbg');
        if (!sedbg) {
            sedbg = new cc.Sprite('#fish_boom16.png');
            if (sedbg) {
                sedbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height / 2));
                this.layerbg.addChild(sedbg, 1, 'sedbg');
                this._sedlist = sedbg;
            }
        }

    },

    removeNoSendRecordBg: function () {
//        cc.log('------删除发送记录背景');
        var sedbg = this.layerbg.getChildByName('sedbg');
        if (sedbg) {
            sedbg.removeFromParent(true);
        }

    },

    showSedRecord: function () {
        if (FishGlobal.sendRecord.Msg.length == 0) {
            this.addNoSendRecordBg();
            return;
        }
//        cc.log('-----------创建发送-');
        var listview = FYEngine.createListView(cc.size(660, 360), cc.p(this.layerbg.width / 2, this.layerbg.height * 0.4), cc.p(0.5, 0.5), 10, ccui.ScrollView.DIR_VERTICAL);
        if (listview) {
            this.layerbg.addChild(listview, 1, 'listsed');
            this._sedlist = listview;
        }

        listview.setScrollBarEnabled(false);

        for (var i = (FishGlobal.sendRecord.Msg.length - 1); i >= 0; --i) {
            //var box = new CrystalRecordBox(1,FishGlobal.sendRecord.Msg[i]);
            var box = CrystalRecordBox.create(1, FishGlobal.sendRecord.Msg[i]);
            if (box) {
                box.setAnchorPoint(cc.p(0.5, 0.5));
                listview.pushBackCustomItem(box);
                this._sedArry.push(box);
            }
        }
    },


    refreshListView: function (tag) {
        cc.log('------------刷新' + tag);
        if (this._list) {
            this._list.removeAllItems();
            if (tag == 0) {//获赠
                if (FishGlobal.revRecord.Msg.length == 0) {
                    this.removeNoSendRecordBg();
                    this.addNoRevRecordBg();
                    return;
                } else {
                    this.removeNoRevRecordBg();
                    this.removeNoSendRecordBg();
                    for (var i = (FishGlobal.revRecord.Msg.length - 1); i >= 0; --i) {
                        var box = new CrystalRecordBox(tag, FishGlobal.revRecord.Msg[i]);
                        if (box) {
                            box.setAnchorPoint(cc.p(0.5, 0.5));
                            this._list.pushBackCustomItem(box);
                        }
                    }
                }
            } else {
                if (FishGlobal.sendRecord.Msg.length == 0) {
                    this.removeNoRevRecordBg();
                    this.addNoSendRecordBg();
                    return;
                } else {
                    this.removeNoRevRecordBg();
                    this.removeNoSendRecordBg();
                    for (var i = (FishGlobal.sendRecord.Msg.length - 1); i >= 0; --i) {
                        var box = new CrystalRecordBox(tag, FishGlobal.sendRecord.Msg[i]);
                        if (box) {
                            box.setAnchorPoint(cc.p(0.5, 0.5));
                            this._list.pushBackCustomItem(box);
                        }
                    }
                }

            }


        }
    }
});

var CrystalConfirmLayer = DialogLayer.extend({
    _index: 0,
    _info: 0,
    _time: 0,
    ctor: function (index, info) {
        this._super();
        this.init(cc.color(0, 0, 0, 100), 1136, 640);
        this._index = index;
        if (info) {
            this._info = info;
        }
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));

        var content = '';

        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));
        this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width * 0.72, bg.height * 0.15));
        this.addCancelBtn(undefined, cc.p(bg.width * 0.31, bg.height * 0.15));

        var tip = new ccui.Text(content + '', '微软雅黑', 25);
        if (tip) {

            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.5));
            tip.setTextAreaSize(cc.size(470, 120));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);

        }
    },


    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.CrystalConfirmLayer);
        layer.addLoading();
        if (layer._index == 0) {
            scene._handler.sendGiveCrystalReq();
            layer.schedule(layer.timeCount, 1);
        } else {
            scene._handler.sendGiveCrystalReq();
            layer.schedule(layer.timeCount, 1);
        }
    },

    addLoading: function () {
        var size = cc.winSize;
        var layer = new cc.LayerColor(cc.color(0, 0, 0, 0), size.width, size.height);
        var touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            }
        });

        cc.eventManager.addListener(touchListener, layer);
        var loadingBg = new cc.Sprite('#crystal56.png');
        if (loadingBg) {
            layer.addChild(loadingBg);
            loadingBg.setPosition(cc.p(layer.width / 2, layer.height / 2));

            var circle = new cc.Sprite("#crystal55.png");
            if (circle) {
                loadingBg.addChild(circle);
                circle.setPosition(cc.p(loadingBg.width / 2, loadingBg.height / 2));
                var rotate = new cc.RotateBy(0.3, 30);
                circle.runAction(new cc.RepeatForever(rotate));
            }
        }
        this.addChild(layer, 100);
        this._layerLoading = layer;
    },

    removeLoading: function () {
        if (this._layerLoading) {
            this._layerLoading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    }

});

var CrystalRecordBox = ccui.ImageView.extend({
    _index: 0,
    _info: {},
    ctor: function () {
        this._super();

        this.setScale9Enabled(true);
        this.setContentSize(cc.size(659, 90));
        this.initUI();
    },

    initUI: function () {

        var line = new cc.Sprite("#crystal01.png");
        if (line) {
            this.addChild(line);
            line.setPosition(cc.p(this.width / 2, 2));
        }

        var text1 = FYEngine.createText('内容', '微软雅黑', 25);
        if (text1) {
            text1.setAnchorPoint(cc.p(0, 0.5));
            text1.setPosition(cc.p(45, 50));
            text1.setTextAreaSize(cc.size(570, 80));
            text1.setTextColor(cc.color("8ef3ff"));
            this.addChild(text1);
            this._text1 = text1;
        }

        var text2 = FYEngine.createText("时间", '微软雅黑', 18, 1);
        if (text2) {
            this.addChild(text2);
            text2.setPosition(cc.p(this.width - 55, 20));
            text2.setAnchorPoint(cc.p(1, 0.5));
            text2.setTextColor(cc.color(255, 255, 255));
            this._text2 = text2;
        }


    },

    setContent: function (index, info) {
        this._index = index;
        this._info = info;
        var tempname = SoftReplaceWords(this._info.szGiveName);
        var test = "";
        
        this._text1.setString(test);
        this._text2.setString(this._info.szTime)
    },

    unuse: function () {
        this.removeFromParent(true);
    },

    reuse: function (index, info) {
        this.setContent(index, info);

    },
});

CrystalRecordBox.create = function (index, info) {
    var box = null;
    if (cc.pool.hasObject(CrystalRecordBox)) {
        box = cc.pool.getFromPool(CrystalRecordBox, index, info);
    }
    else {
        box = new CrystalRecordBox();
        box.setContent(index, info);
//        cc.log('--------crystalRecordBox is not enough ');
    }
    return box;
};

var LoginErrorLayer = DialogLayer.extend({
    _temp: 0,
    ctor: function (temp, btnName) {
        btnName = btnName || "#iknow.png";
        this._super();
        this._temp = temp;
        this.initUI(temp, btnName);

    },
    initUI: function (temp, btnName) {
//        cc.log("tip--===="+temp);
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn(this.closeCallBack);
        var innerbg = this.addInnerBg(cc.size(586, 220));
        this.addConfirmBtn(this.iknowCallback, cc.p(bg.width / 2, bg.height * 0.15), btnName);
        if (this._temp == -3 || this._temp == -4) {
            var text = '登录失败，请重试';
        } else {
            var text = '登录失败，请重试';
        }


        var tip = new ccui.Text("" + text, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);

            if (tip.width > 500) {
                var height = Math.ceil(tip.width / 500) * 36 + 15;
                tip.setTextAreaSize(cc.size(500, height));
            }
        }
    },

    iknowCallback: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LoginLayerName.LoginErrLayer);
        if (layer._temp == -3 || layer._temp == -4) {
            FYEngine.closeApp();
        } else {
            layer.removeFromParent(true);
            var coreserviceproxy = CoreServiceProxy.getInstance();
            coreserviceproxy.unlinkLobbyClient();
            scene.scheduleOnce(function () {
                appglobal._lobbyAccess && coreserviceproxy.linkLobbyClient(appglobal._lobbyAccess);
                coreserviceproxy.addLobbyHandler(new Lobbyhandler());
            }, 0.5);

        }


    },

    closeCallBack: function () {
        FYEngine.closeApp();
    }
});

var KickByServer = DialogLayer.extend({
    _code: 0,
    ctor: function (code) {

        this._super();
        this._code = code;
        var btnName = UsedResName.ConfirmTitle;
        if (this._code == 1 || this._code == 2 || this._code == 3) {
            btnName = '#btn_close.png';
        }
        this.initUI(btnName);

    },

    initUI: function (btnName) {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);

        var innerbg = this.addInnerBg(cc.size(586, 220));
        if (this._code != 4) {
            this.addCloseBtn(this.closeCallBack);
            this.addConfirmBtn(this.closeCallBack, cc.p(bg.width / 2, bg.height * 0.15), btnName);
        }


        var cont = "";
        if (this._code == 0) {
            cont = "与服务器连接断开，请重启游戏。";
        } else if (this._code == 2) {
            cont = "此版本的游戏登录已关停，如有疑问，请联系客服QQ：3003674856";

        } else if (this._code == 3) {
            cont = "此版本的游客登录已关停，如有疑问，请联系客服QQ：3003674856";

        } else if (this._code == 4) {
            cont = "您的账号已被封禁，请联系客服QQ：3003674856";
        }
        else {
            cont = FYEngine.LanguageString.getValue("loginErr9");

        }

        var tip = new ccui.Text(cont, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);

            if (tip.width > 500) {
                var height = Math.ceil(tip.width / 500) * 36 + 15;
                tip.setTextAreaSize(cc.size(500, height));
            }
        }
    },

    closeCallBack: function () {
        FYEngine.closeApp();
    }
});

var ChangeHeadLayer = cc.LayerColor.extend({

    ctor: function () {
        this._super();
        var self = this;
        this.init(cc.color(0, 0, 0, 190));
        this.initUI();
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            },

            onTouchEnded: function (touch, event) {
                self.removeFromParent(true);
            },
        });
        cc.eventManager.addListener(this.touchListener, this);

    },

    initUI: function () {
        var layerBg = this.layerbg = new ccui.ImageView('rankup006.png', ccui.Widget.PLIST_TEXTURE);
        if (layerBg) {
            this.addChild(layerBg);
            //layerBg.setEnabled(false);
            layerBg.setSwallowTouches(true);
            layerBg.setTouchEnabled(true);
            layerBg.setPosition(cc.p(this.width / 2, this.height / 2));
            layerBg.setScale9Enabled(true);
            layerBg.setCapInsets(cc.size(200, 105, 135, 100));
            layerBg.setContentSize(cc.size(535, 305));
        }

        var title = new ccui.Text('更改头像', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 25);
        if (title) {
            title.setAnchorPoint(cc.p(0, 0.5));
            title.setPosition(cc.p(40, 265));
            title.setColor(cc.color("074E8B"));
            //title.enableOutline(cc.color("074E8B"), 1);
            this.layerbg.addChild(title, 0);
        }

        var line_0 = new ccui.Scale9Sprite('rankup013.png');
        if (line_0) {
            line_0.setPosition(layerBg.width * 0.5 - 2, 240);
            line_0.setContentSize(485, 6);
            this.layerbg.addChild(line_0, 0);
        }

        var line_1 = new ccui.Scale9Sprite('rankup013.png');
        if (line_1) {
            line_1.setPosition(layerBg.width * 0.5 - 2, 128);
            line_1.setContentSize(485, 6);
            this.layerbg.addChild(line_1, 0);
        }

        var takePhoneImg = new ccui.ImageView('rankup004.png', ccui.Widget.PLIST_TEXTURE);
        if (takePhoneImg) {
            this.layerbg.addChild(takePhoneImg);
            //takePhoneImg.setTouchEnabled(true);
            takePhoneImg.setPosition(cc.p(85, 185));

            var word1 = new ccui.Text('拍照', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
            if (word1) {
                word1.setAnchorPoint(cc.p(0, 0.5));
                word1.setPosition(cc.p(160, 185));
                word1.setColor(cc.color("074E8B"));
                word1.enableOutline(cc.color("074E8B"), 1);
                this.layerbg.addChild(word1, 0);
            }

            var arrow1 = new cc.Sprite("#rankup009.png");
            if (arrow1) {
                this.layerbg.addChild(arrow1);
                arrow1.setPosition(cc.p(470, 185));
            }

            var takeBtn = new ccui.ImageView("");
            if (takeBtn) {
//                cc.log('0-----------创建成功');
                this.layerbg.addChild(takeBtn, 10, 'take');
                //takeBtn.setEnabled(true);
                takeBtn.setTouchEnabled(true);
                takeBtn.setScale9Enabled(true);
                //takeBtn.setColor(cc.color(255,0,0));
                takeBtn.setAnchorPoint(cc.p(0.5, 0.5));
                takeBtn.setPosition(this.layerbg.width / 2, 184);
                takeBtn.setContentSize(cc.size(485, 112));
                takeBtn.addClickEventListener(this.takePicCallBack);
            }

        }


        var PhoneImg = new ccui.ImageView('rankup005.png', ccui.Widget.PLIST_TEXTURE);
        if (PhoneImg) {
            this.layerbg.addChild(PhoneImg);
            PhoneImg.setPosition(cc.p(85, 75));

            var word2 = new ccui.Text('从相册选取', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
            if (word2) {
                word2.setAnchorPoint(cc.p(0, 0.5));
                word2.setPosition(cc.p(160, 75));
                word2.setColor(cc.color("074E8B"));
                word2.enableOutline(cc.color("074E8B"), 1);
                this.layerbg.addChild(word2, 0);
            }

            var arrow2 = new cc.Sprite("#rankup009.png");
            if (arrow1) {
                this.layerbg.addChild(arrow2);
                arrow2.setPosition(cc.p(470, 75));
            }

            var takeBtn2 = new ccui.ImageView("");
            if (takeBtn2) {
//                cc.log('0-----------创建成功2');
                this.layerbg.addChild(takeBtn2, 10, 'bring');
                //takeBtn.setEnabled(true);
                takeBtn2.setTouchEnabled(true);
                takeBtn2.setScale9Enabled(true);
                //takeBtn.setColor(cc.color(255,0,0));
                takeBtn2.setAnchorPoint(cc.p(0.5, 0.5));
                takeBtn2.setPosition(cc.p(this.layerbg.width / 2, 72));
                takeBtn2.setContentSize(cc.size(485, 112));
                takeBtn2.addClickEventListener(this.takePicCallBack);
            }
        }
    },

    takePicCallBack: function (sender) {
        var name = sender.getName();
//        cc.log('--------测试头像功能:'+name);
        switch (name) {
            case 'bring' : {
                app.sdkPlugin.callNativeMethodAysc("capture", JSON.stringify({'mode': 1}));
            }
                break;
            case 'take' : {
                app.sdkPlugin.callNativeMethodAysc("capture", JSON.stringify({'mode': 0}));
            }
                break;
            default :
                break;
        }
        var scene = FYEngine.getRunningLayer(0);
        if (scene) {
            var layer = scene.getChildByName(LobbySceneName.ChangeHeadLayer);
            if (layer) {
                layer.removeFromParent(true);
            }
        }
    }
});

var LobbyRankIten = ccui.ImageView.extend({
    _data: {},
    _turn: 0,
    ctor: function (data, i) {
        this._super();
        this._data = data;
        this._turn = i;
        this.setScale9Enabled(true);
        this.loadTexture("rankup021.png", ccui.Widget.PLIST_TEXTURE);
        this.setContentSize(cc.size(279, 100));
        this.initUI();
    },

    initUI: function () {
        var headK = new FYEngine.rangkImage('#rankup044.png', '#rankup046.png', '#rankup045.png', 1, this._data.icon, 0, 0, 0);
        if (headK) {
            this.addChild(headK);
            headK.attr({x: 50, y: 55, anchorX: 0.5, anchorY: 0.5});
            this.headnode = headK;
        }

        var iconname = '';
        switch (this._turn) {
            case 0 : {
                iconname = "#rankup018.png";
            }
                break;
            case 1 : {
                iconname = "#rankup015.png";
            }
                break;
            case 2 : {
                iconname = "#rankup016.png";
            }
                break;
            default :
                break;
        }
        var rewardicon = new cc.Sprite(iconname);
        if (rewardicon) {
            rewardicon.setScale(0.8);
            this.addChild(rewardicon);
            rewardicon.setPosition(cc.p(10, 85));
        }

        //var nickNameLabel = new cc.LabelTTF(''+this._data.nickName, "", 21);
        var tempname = SoftReplaceWords("" + this._data.nickName);
        var nickNameLabel = FYEngine.createLengthText(tempname, 21, 180);
        if (nickNameLabel) {
            nickNameLabel.setColor(cc.color("#6b3110"));
            this.addChild(nickNameLabel);
            nickNameLabel.setPosition(cc.p(95, 75));
            nickNameLabel.setAnchorPoint(cc.p(0, 0.5))
        }

        var crystalBg = ccui.ImageView("crystal59.png", ccui.Widget.PLIST_TEXTURE);
        if (crystalBg) {
            crystalBg.setScale9Enabled(true);
            crystalBg.setContentSize(cc.size(160, 35));
            crystalBg.setPosition(cc.p(170, 35));
            this.addChild(crystalBg);

            var crystalicon = new cc.Sprite('#fish_boom21.png');
            if (crystalicon) {
                crystalBg.addChild(crystalicon);
                crystalicon.setPosition(cc.p(17, crystalBg.height / 2));
            }

            if (this._data.rank != -1) {
                var number = new cc.LabelTTF('' + this._data.crystalCount, "", 25);
                if (number) {
                    crystalBg.addChild(number);
                    number.setAnchorPoint(cc.p(0.5, 0.5));
                    number.setColor(cc.color('fc3f09'));
                    number.setPosition(cc.p(crystalBg.width / 2 + crystalicon.width / 2, crystalBg.height / 2));
                }
            }

        }

    }
});

var LobbyRankItenNew = ccui.ImageView.extend({
    _data: "",
    ctor: function (data) {
        this._super();

        if (data) {
            // cc.log("数据存在"+data);
            this._data = data;
        } else {
            // cc.log("数据不存在"+data);
            this._data = "";
        }
        this.setScale9Enabled(true);
        this.setCascadeOpacityEnabled(true);
        // this.loadTexture("rankup021.png", ccui.Widget.PLIST_TEXTURE);
        this.setContentSize(cc.size(279, 100));
        this.initUI();
    },

    initUI: function () {
        var headK = new FYEngine.rangkImageForNewRank('#fishranknew_8.png', '#fishranknew_6.png', '#fishranknew_7.png', 1, this._data, 0, 0, 0);
        if (headK) {
            this.addChild(headK);
            headK.attr({x: 50, y: 55, anchorX: 0.5, anchorY: 0.5});
            this.headnode = headK;
        }
    }
});

var BuyIntergralLayer = DialogLayer.extend({
    _info: {},
    _id: 0,
    ctor: function (info) {
        this._super();
        this._info = info;
        this._id = this._info.goodsId;
        this.initUI();
        this.clearTempData();
    },

    clearTempData : function(){
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.IntergralLayer);
        if(layer){
            layer.clearTempResult();
        }
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));
        this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width * 0.72, bg.height * 0.15));
        this.addCancelBtn(null, cc.p(bg.width * 0.31, bg.height * 0.15));

        //var tip = new ccui.Text('确定使用'+this._info.gold+'金币和'+this._info.score+'积分兑换'+this._info.name+'吗?',FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        //if(tip){
        //    tip.setTextAreaSize(cc.size(400,200));
        //    //tip.setContentSize(cc.size(200,200));
        //    tip.setPosition(cc.p(innerbg.width/2, innerbg.height*0.45));
        //    tip.enableOutline(cc.color(255, 255, 255, 255), 1);
        //    innerbg.addChild(tip, 0, 10);
        //}

        var tip = new ccui.RichText();
        if (tip) {
            innerbg.addChild(tip);
            tip.setPosition(cc.p(innerbg.width * 0.5, innerbg.height * 0.2));
            tip.ignoreContentAdaptWithSize(false);
            tip.setContentSize(cc.size(440, 200));
            tip.setAnchorPoint(cc.p(0.5, 0.4));

            var ele1 = new ccui.RichElementText(1, cc.color(255, 255, 255), 255, '确定使用', "", 30);
            tip.pushBackElement(ele1);

            if (this._info.score >= 100000) {
                var nums = this._info.score;
                nums = Math.floor(nums / 1000);
                nums = nums / 10;
                var ele2 = new ccui.RichElementText(2, cc.color("02fef5"), 255, '' + nums + '万积分', "", 30);
                tip.pushBackElement(ele2);
            } else {
                var ele2 = new ccui.RichElementText(2, cc.color("02fef5"), 255, '' + this._info.score + '积分', "", 30);
                tip.pushBackElement(ele2);
            }


            var ele3 = new ccui.RichElementText(3, cc.color(255, 255, 255), 255, '和', "", 30);
            tip.pushBackElement(ele3);

            if (this._info.gold >= 100000) {
                var numg = this._info.gold;
                numg = Math.floor(numg / 1000);
                numg = numg / 10;
                var ele4 = new ccui.RichElementText(4, cc.color("02fef5"), 255, numg + '万金币', "", 30);
                tip.pushBackElement(ele4);
            } else {
                var ele4 = new ccui.RichElementText(4, cc.color("02fef5"), 255, this._info.gold + '金币', "", 30);
                tip.pushBackElement(ele4);
            }


            var ele5 = new ccui.RichElementText(5, cc.color(255, 255, 255), 255, '兑换', "", 30);
            tip.pushBackElement(ele5);

            var ele6 = new ccui.RichElementText(6, cc.color("fafd06"), 255, this._info.name + '', "", 30);
            tip.pushBackElement(ele6);

            var ele7 = new ccui.RichElementText(7, cc.color(255, 255, 255), 255, '吗?', "", 30);
            tip.pushBackElement(ele7);
        }
    },

    confirmCallBack: function (sender) {
//        cc.log('---------------1');
        var scene = FYEngine.getRunningLayer(0);

        var layer = sender.getParent().getParent();

        var player = appglobal.getPlayer();
        if (player.gold < layer._info.gold) {
            FYEngine.AddCommToast('金币或积分不足');
            return;
        }
        if (player.score < layer._info.score) {
            FYEngine.AddCommToast('金币或积分不足');
            return;
        }
        var Interlayer = scene.getChildByName(LobbySceneName.IntergralLayer);
        Interlayer.schedule(Interlayer.timeCount, 1);

        var loading = FYEngine.createLoadingLayer(SccomRes.MallRes.loadingbg, SccomRes.MallRes.loadingfish);
        if (loading) {
            scene.addChild(loading, FishZorder.poplayer, 'loading2');
        }
        var handler = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handler) {
            FishGlobal._tempScoreId = layer._id;
            handler.sendIntergralBuyReq(layer._id);
        }
        layer.removeFromParent(true);
    }
});


var IntergralResultLayer = DialogLayer.extend({
    count: 0,
    ctor: function (count) {
        this._super();
        this.count = count;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        //this.addConfirmBtn(undefined, cc.p(bg.width * 0.3, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        var innerBg = this.addInnerBg(cc.size(586, 220));

        var cancelBtn = new cc.Sprite(FishSceneRes.DialogPng.CancelBtn);
        if (cancelBtn) {
            cancelBtn.setPosition(cc.p(bg.width * 0.3, bg.height * 0.2 - 15));
            this.layerbg.addChild(cancelBtn, 0, 5);
            FYEngine.AddNodeTouchListener(cancelBtn, this.cancelCallBack, FYEngine.ActionType.Fade);
        }
        var cancelTitle = new cc.Sprite(UsedResName.iknowbtn);
        if (cancelTitle) {
            cancelTitle.setPosition(cancelBtn.width / 2, cancelBtn.height * 0.6);
            cancelBtn.addChild(cancelTitle, 0);
        }

        var confirmBtn = new cc.Sprite(FishSceneRes.DialogPng.ConfirmBtn);
        if (confirmBtn) {
            confirmBtn.setPosition(cc.p(bg.width * 0.7, bg.height * 0.2 - 15));
            this.layerbg.addChild(confirmBtn, 0, 5);
            FYEngine.AddNodeTouchListener(confirmBtn, this.confirmCallBack, FYEngine.ActionType.Fade);
        }
        var confirmTitle = new cc.Sprite('#integral13.png');
        if (confirmTitle) {
            confirmTitle.setPosition(confirmBtn.width / 2, confirmBtn.height * 0.6);
            confirmBtn.addChild(confirmTitle, 0);
        }

        var mLabel1 = new ccui.Text('本次捕鱼额外获得', '微软雅黑', 30);
        if (mLabel1) {
            mLabel1.setAnchorPoint(cc.p(0, 0.5));
            mLabel1.enableOutline(cc.color(255, 255, 255), 1);
            innerBg.addChild(mLabel1);

            var mLabel2 = new ccui.Text(this.count + '积分', '微软雅黑', 30);
            if (mLabel2) {
                mLabel2.setAnchorPoint(cc.p(0, 0.5));
                mLabel2.enableOutline(cc.color("02fef5"), 1);
                mLabel2.setColor(cc.color("02fef5"));
                mLabel2.setPosition(cc.p(mLabel1.width, mLabel1.height / 2));
                mLabel1.addChild(mLabel2);
            }
            mLabel1.setPosition(cc.p(innerBg.width / 2 - (mLabel1.width + mLabel2.width) / 2, innerBg.height / 2 + 20));
        }

        var mLabel3 = new ccui.Text("积分可用于兑换奖券和弹头", '微软雅黑', 30);
        if (mLabel3) {
            mLabel3.setAnchorPoint(cc.p(0.5, 0.5));
            mLabel3.enableOutline(cc.color(255, 255, 255), 1);
            mLabel3.setPosition(cc.p(innerBg.width / 2, innerBg.height / 2 - 20));
            innerBg.addChild(mLabel3);
        }

    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer1 = scene.getChildByName(LobbySceneName.IntergralTipsLayer);
        if (layer1) {
            layer1.removeFromParent(true);
        }
        var layer = new IntergralMallLayer();
        if (layer) {
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.IntergralLayer);
            FYEngine.popupLayerAnimate(layer.layerbg, undefined, undefined, cc.p(layer.width / 2, layer.height * 0.4 + 30));
        }
    },

    cancelCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.IntergralTipsLayer);
        if (layer) {
            layer.removeFromParent(true);
        }
    },
});

var BindPhoneDialog = DialogLayer.extend({
    _recount: 60,
    _time: 0,
    _time1: 0,
    _canTouch: true,
    ctor: function () {
        this._super();
        this._recount = 60;
        this._time = 0;
        this._time1 = 0;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg("#fish_acbind_21.png", 654);
        this.addCloseBtn();
        //this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        //this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width*0.72, bg.height*0.15));
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.15));
        var numbersprite = new ccui.Text("手机号:", "微软雅黑", 28);
        if (numbersprite) {
            numbersprite.enableOutline(cc.color("8ef3ff"), 1);
            numbersprite.setColor(cc.color("8ef3ff"));
            numbersprite.setAnchorPoint(cc.p(0, 0.5));
            numbersprite.setPosition(cc.p(90, 250));
            this.layerbg.addChild(numbersprite);
        }

        var codesprite = new ccui.Text("验证码:", "微软雅黑", 28);
        if (codesprite) {
            codesprite.enableOutline(cc.color("8ef3ff"), 1);
            codesprite.setColor(cc.color("8ef3ff"));
            codesprite.setAnchorPoint(cc.p(0, 0.5));
            codesprite.setPosition(cc.p(90, 180));
            this.layerbg.addChild(codesprite);
        }

        for (var i = 0; i < 2; ++i) {
            var smallbg = new ccui.ImageView(SettingRes.settingBtnBg, ccui.Widget.PLIST_TEXTURE);
            if (smallbg) {
                bg.addChild(smallbg);
                smallbg.setScale9Enabled(true);
                smallbg.setContentSize(cc.size(340, 49));
                smallbg.setPosition(cc.p(380, 180 + i * 70));
            }
        }

        var phoneedit = FYEngine.createEditBox("", cc.size(340, 50), cc.EDITBOX_INPUT_MODE_NUMERIC, "输入手机号码", cc.color("28b5f2"), cc.color("8ef3ff"), 30, 11);
        if (phoneedit) {
            phoneedit.setPlaceholderFontSize(24);
            phoneedit.setPosition(cc.p(390, 250));
            bg.addChild(phoneedit);

            var delegate1 = {
                editBoxEditingDidBegin: function () {
                    phoneedit.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = phoneedit.getString();
                    if (str == "") {
                        phoneedit.setPlaceHolder("输入手机号码");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }

            };
            phoneedit.setDelegate(delegate1);
            this.phoneedit = phoneedit;
        }

        var codeedit = FYEngine.createEditBox("", cc.size(190, 50), cc.EDITBOX_INPUT_MODE_NUMERIC, "输入验证码", cc.color("28b5f2"), cc.color("8ef3ff"), 30, 6);
        if (codeedit) {
            codeedit.setPlaceholderFontSize(24);
            codeedit.setPosition(cc.p(315, 180));
            bg.addChild(codeedit);

            var delegate2 = {
                editBoxEditingDidBegin: function () {
                    codeedit.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = codeedit.getString();
                    if (str == "") {
                        codeedit.setPlaceHolder("输入验证码");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }

            };
            codeedit.setDelegate(delegate2);
            this.codeedit = codeedit;
        }

        var getCodeBtn = new ccui.ImageView("fish_acbind_0.png", ccui.Widget.PLIST_TEXTURE);
        if (getCodeBtn) {
            bg.addChild(getCodeBtn);
            getCodeBtn.setTouchEnabled(true);
            getCodeBtn.setPosition(cc.p(482, 180.5));
            getCodeBtn.setSwallowTouches(true);
            getCodeBtn.addTouchEventListener(this.getCodeCallBack, this);
            this._getCodeBtn = getCodeBtn;
            var btnTip = new cc.Sprite("#fish_acbind_3.png");
            if (btnTip) {
                getCodeBtn.addChild(btnTip);
                btnTip.setPosition(cc.p(getCodeBtn.width / 2, getCodeBtn.height / 2));
            }
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.15));


    },

    confirmCallBack: function () {
        var phonenumber = this.phoneedit.getString();
        var code = this.codeedit.getString();

        if (phonenumber == '') {
            FYEngine.AddCommToast('手机号码不能为空');
            return;
        }

        if (code == '') {
            FYEngine.AddCommToast('验证码不能为空');
            return;
        }

        if (phonenumber.length < 11) {
            FYEngine.AddCommToast('请输入正确的手机号');
            return;
        }

        if (code.length < 6) {
            FYEngine.AddCommToast('请输入正确的验证码');
            return;
        }

        if (!(/^1\d{10}$/.test(phonenumber))) {
            FYEngine.AddCommToast('请输入正确的手机号');
            return;
        }

        var loading = FYEngine.CreateAccRelatedLoading();
        if (loading) {
            this.addChild(loading, 100, 'accloading');
        }
        this._time = 0;
        this.schedule(this.timeCount, 1);

        var lobbyHandler = CoreServiceProxy.getInstance().getLobbyHandler();
        if (lobbyHandler) {
            lobbyHandler.sendBindPhoneNumReq(phonenumber, code);
        }
    },

    getCodeCallBack: function (sender, type) {
        cc.log('--------倒计时按钮');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.BindPhoneDialog);
        //var layer = scene.getChildByName(LoginLayerName.lobbysmalllayer);
        if (!layer._canTouch) {
            return;
        }
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN : {
                sender.setOpacity(180);
            }
                break;
            case ccui.Widget.TOUCH_MOVED : {

            }
                break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                layer.enterRecountMode();
            }
                break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(180);
            }
                break;
        }
    },

    enterRecountMode: function () {
        var phonenumber = this.phoneedit.getString();
        if (phonenumber == '') {
            FYEngine.AddCommToast('手机号码不能为空');
            return;
        }

        if (phonenumber.length < 11) {
            FYEngine.AddCommToast('请输入正确的手机号');
            return;
        }

        if (!(/^1\d{10}$/.test(phonenumber))) {
            FYEngine.AddCommToast('请输入正确的手机号');
            return;
        }

        var date = new Date();
        //cc.log('-----年:'+date.getFullYear()+'--月:'+date.getMonth()+'---日:'+date.getUTCDate());
        var uidrecord = cc.sys.localStorage.getItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord');
        if (uidrecord) {
            if (parseInt(uidrecord) > 20) {
                FYEngine.AddCommToast("今日短信发送过于频繁，请明日再试");
                return;
            } else {
                var record = parseInt(uidrecord) + 1;
                cc.sys.localStorage.setItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord', record + "");
            }
        } else {
            cc.sys.localStorage.setItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord', "1");
        }

        this.sendGetPhoneMsg();
        this._canTouch = false;
        this._recount = 60;
        this._getCodeBtn.removeAllChildren();
        this._getCodeBtn.setColor(cc.color(180, 180, 180, 255));
        //this._getCodeBtn.setTouchEnabled(false);
        //this._getCodeBtn.setSwallowTouches(true);
        var btntip = new cc.Sprite("#fish_acbind_6.png");
        if (btntip) {
            this._getCodeBtn.addChild(btntip, 0, "tip");
            btntip.setPosition(cc.p(this._getCodeBtn.width / 2 - 21, this._getCodeBtn.height / 2));
            this._btntip = btntip;
        }

        var btntip1 = new cc.Sprite("#fish_acbind_14.png");
        if (btntip1) {
            btntip.addChild(btntip1);
            btntip1.setPosition(cc.p(btntip.width + 21, btntip.height / 2));
            this._verytip1 = btntip1;
        }

        var count = FYEngine.createAlts("res/updateacc/fish_acc_number_01.png", 12, this._recount, '.');
        if (count) {
            btntip1.addChild(count);
            count.setPosition(cc.p(btntip1.width / 2, btntip1.height / 2));
            this._countlabel = count;
        }

        this.schedule(this.changeCount, 1);

    },

    changeCount: function () {
        --this._recount;
        if (this._recount == 0) {
            this.unschedule(this.changeCount);
            this.enterNextMode();
            return;
        }
        if (this._recount == 9) {
            this._verytip1.setSpriteFrame("fish_acbind_13.png");
            this._verytip1.setPosition(cc.p(this._btntip.width + 20, this._btntip.height / 2));
            this._countlabel.setPosition(cc.p(this._verytip1.width / 2, this._verytip1.height / 2));
        }
        this._countlabel.setString("" + this._recount);
    },

    enterNextMode: function () {
        this._canTouch = true;
        this._recount = 60;
        this._getCodeBtn.setColor(cc.color(255, 255, 255, 255));
        this._getCodeBtn.removeAllChildren();
        var btntip = new cc.Sprite("#fish_acbind_6.png");
        if (btntip) {
            this._getCodeBtn.addChild(btntip, 0, "tip");
            btntip.setPosition(cc.p(this._getCodeBtn.width / 2, this._getCodeBtn.height / 2));
        }
    },

    sendGetPhoneMsg: function () {
        var self = this;
        self._time1 = 0;
        self.schedule(self.timeCount1, 1);
        var phonenumber = this.phoneedit.getString();
        Http.getMessage(function () {
            var service = formservice("SmsService");
            var time = Date.now();
            var token = {name: "token", value: appglobal.getPlayer().token};
            var pnumber = {name: "phoneNo", value: phonenumber};
            var sign = formsign("SmsService", time);
            var type = {name: "type", value: 0}; // 0绑定,1解绑
            var uid = {name: "uid", value: appglobal.getPlayer().userid};
            time = formTime(time);
            var checksum = formchecksum(uid.value, token.value, pnumber.value, type.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, token, pnumber, type, uid, sign, checksum);
            cc.log('-------发送短信url:' + url);
            return url;
        }(), null, function (cfgStr) {
//            FYEngine.logObject(cfgStr,'------获取短信:');
            self.unschedule(self.timeCount1);
            var jsonInfo = eval('(' + cfgStr + ')');

            var errcode = jsonInfo.code;
            if (errcode != 0) {//-2 超过限制
                cc.log('-----获取短信失败');
                if (errcode == -2) {
                    FYEngine.AddCommToast('今日短信发送过于频繁，请明日再试');
                } else {
                    FYEngine.AddCommToast('获取验证码失败');
                }
                return;
            }
            FYEngine.AddCommToast('短信验证码发送成功');

        });
    },

    removeLoading: function () {
        var loading = this.getChildByName("accloading");
        if (loading) {
            loading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

    timeCount1: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time1 += dt;
        if (this._time1 > 15) {
            this._time1 = 0;
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount1);
        }
    },

});

var UnBindPhoneDialog = DialogLayer.extend({
    _recount: 60,
    _time: 0,
    _time1: 0,
    _canTouch: true,
    ctor: function () {
        this._super();
        this._recount = 60;
        this._time = 0;
        this._time1 = 0;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg("#fish_acbind_20.png", 654);
        this.addCloseBtn();
        //this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        //this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width*0.72, bg.height*0.15));
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.15));
        var numbersprite = new ccui.Text("手机号:", "微软雅黑", 28);
        if (numbersprite) {
            numbersprite.enableOutline(cc.color("8ef3ff"), 1);
            numbersprite.setColor(cc.color("8ef3ff"));
            numbersprite.setAnchorPoint(cc.p(0, 0.5));
            numbersprite.setPosition(cc.p(90, 250));
            this.layerbg.addChild(numbersprite);
        }

        var codesprite = new ccui.Text("验证码:", "微软雅黑", 28);
        if (codesprite) {
            codesprite.enableOutline(cc.color("8ef3ff"), 1);
            codesprite.setColor(cc.color("8ef3ff"));
            codesprite.setAnchorPoint(cc.p(0, 0.5));
            codesprite.setPosition(cc.p(90, 180));
            this.layerbg.addChild(codesprite);
        }


        var smallbg = new ccui.ImageView(SettingRes.settingBtnBg, ccui.Widget.PLIST_TEXTURE);
        if (smallbg) {
            bg.addChild(smallbg);
            smallbg.setScale9Enabled(true);
            smallbg.setContentSize(cc.size(300, 49));
            smallbg.setPosition(cc.p(360, 180));
        }

        var phonesprite = new ccui.Text("" + appglobal.getPlayer().getFreshPhoneNumber(), "微软雅黑", 28);
        if (phonesprite) {
            phonesprite.enableOutline(cc.color("8ef3ff"), 1);
            phonesprite.setColor(cc.color("8ef3ff"));
            phonesprite.setAnchorPoint(cc.p(0, 0.5));
            phonesprite.setPosition(cc.p(220, 250));
            this.layerbg.addChild(phonesprite);
        }

        var codeedit = FYEngine.createEditBox("", cc.size(150, 50), cc.EDITBOX_INPUT_MODE_NUMERIC, "输入验证码", cc.color("28b5f2"), cc.color("8ef3ff"), 28, 6);
        if (codeedit) {
            codeedit.setPlaceholderFontSize(24);
            codeedit.setPosition(cc.p(295, 180));
            bg.addChild(codeedit);

            var delegate2 = {
                editBoxEditingDidBegin: function () {
                    codeedit.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = codeedit.getString();
                    if (str == "") {
                        codeedit.setPlaceHolder("输入验证码");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }

            };
            codeedit.setDelegate(delegate2);
            this.codeedit = codeedit;
        }

        var getCodeBtn = new ccui.ImageView("fish_acbind_0.png", ccui.Widget.PLIST_TEXTURE);
        if (getCodeBtn) {
            bg.addChild(getCodeBtn);
            getCodeBtn.setTouchEnabled(true);
            getCodeBtn.setPosition(cc.p(445, 180.5));
            getCodeBtn.setSwallowTouches(true);
            getCodeBtn.addTouchEventListener(this.getCodeCallBack, this);
            this._getCodeBtn = getCodeBtn;
            var btnTip = new cc.Sprite("#fish_acbind_3.png");
            if (btnTip) {
                getCodeBtn.addChild(btnTip);
                btnTip.setPosition(cc.p(getCodeBtn.width / 2, getCodeBtn.height / 2));
            }
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.15));


    },

    confirmCallBack: function () {
        var code = this.codeedit.getString();
        if (code == '') {
            FYEngine.AddCommToast('验证码不能为空');
            return;
        }

        if (code.length < 6) {
            FYEngine.AddCommToast('请输入正确的验证码');
            return;
        }

        var loading = FYEngine.CreateAccRelatedLoading();
        if (loading) {
            this.addChild(loading, 100, 'accloading');
        }
        this._time = 0;
        this.schedule(this.timeCount, 1);
        var phonenumber = appglobal.getPlayer().phonenumber;
        var lobbyHandler = CoreServiceProxy.getInstance().getLobbyHandler();
        if (lobbyHandler) {
            lobbyHandler.sendUnBindPhoneNumReq(phonenumber, code);
        }
    },

    getCodeCallBack: function (sender, type) {
        cc.log('--------倒计时按钮');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.UnBindPhoneDialog);
        //var layer = scene.getChildByName(LoginLayerName.lobbysmalllayer);
        if (!layer._canTouch) {
            return;
        }
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN : {
                sender.setOpacity(180);
            }
                break;
            case ccui.Widget.TOUCH_MOVED : {

            }
                break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                layer.enterRecountMode();
            }
                break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(180);
            }
                break;
        }
    },

    enterRecountMode: function () {
        var date = new Date();
        //cc.log('-----年:'+date.getFullYear()+'--月:'+date.getMonth()+'---日:'+date.getUTCDate());
        var uidrecord = cc.sys.localStorage.getItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord');
        if (uidrecord) {
            if (parseInt(uidrecord) > 20) {
                FYEngine.AddCommToast("今日短信发送过于频繁，请明日再试");
                return;
            } else {
                var record = parseInt(uidrecord) + 1;
                cc.sys.localStorage.setItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord', record + "");
            }
        } else {
            cc.sys.localStorage.setItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord', "1");
        }

        this.sendGetPhoneMsg();
        this._canTouch = false;
        this._recount = 60;
        this._getCodeBtn.removeAllChildren();
        this._getCodeBtn.setColor(cc.color(180, 180, 180, 255));
        //this._getCodeBtn.setTouchEnabled(false);
        //this._getCodeBtn.setSwallowTouches(true);
        var btntip = new cc.Sprite("#fish_acbind_6.png");
        if (btntip) {
            this._getCodeBtn.addChild(btntip, 0, "tip");
            btntip.setPosition(cc.p(this._getCodeBtn.width / 2 - 21, this._getCodeBtn.height / 2));
            this._btntip = btntip;
        }

        var btntip1 = new cc.Sprite("#fish_acbind_14.png");
        if (btntip1) {
            btntip.addChild(btntip1);
            btntip1.setPosition(cc.p(btntip.width + 21, btntip.height / 2));
            this._verytip1 = btntip1;
        }

        var count = FYEngine.createAlts("res/updateacc/fish_acc_number_01.png", 12, this._recount, '.');
        if (count) {
            btntip1.addChild(count);
            count.setPosition(cc.p(btntip1.width / 2, btntip1.height / 2));
            this._countlabel = count;
        }

        this.schedule(this.changeCount, 1);

    },

    changeCount: function () {
        --this._recount;
        if (this._recount == 0) {
            this.unschedule(this.changeCount);
            this.enterNextMode();
            return;
        }
        if (this._recount == 9) {
            this._verytip1.setSpriteFrame("fish_acbind_13.png");
            this._verytip1.setPosition(cc.p(this._btntip.width + 20, this._btntip.height / 2));
            this._countlabel.setPosition(cc.p(this._verytip1.width / 2, this._verytip1.height / 2));
        }
        this._countlabel.setString("" + this._recount);
    },

    enterNextMode: function () {
        this._canTouch = true;
        this._recount = 60;
        this._getCodeBtn.setColor(cc.color(255, 255, 255, 255));
        this._getCodeBtn.removeAllChildren();
        var btntip = new cc.Sprite("#fish_acbind_6.png");
        if (btntip) {
            this._getCodeBtn.addChild(btntip, 0, "tip");
            btntip.setPosition(cc.p(this._getCodeBtn.width / 2, this._getCodeBtn.height / 2));
        }
    },

    sendGetPhoneMsg: function () {
        var self = this;
        self._time1 = 0;
        self.schedule(self.timeCount1, 1);
        Http.getMessage(function () {
            var service = formservice("SmsService");
            var time = Date.now();
            var token = {name: "token", value: appglobal.getPlayer().token};
            var pnumber = {name: "phoneNo", value: appglobal.getPlayer().phonenumber};
            var sign = formsign("SmsService", time);
            var type = {name: "type", value: 1}; // 0绑定,1解绑
            var uid = {name: "uid", value: appglobal.getPlayer().userid};
            time = formTime(time);
            var checksum = formchecksum(uid.value, token.value, pnumber.value, type.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, token, pnumber, type, uid, sign, checksum);
            cc.log('-------发送短信url:' + url);
            return url;
        }(), null, function (cfgStr) {
            self.unschedule(self.timeCount1);
            var jsonInfo = eval('(' + cfgStr + ')');
//            FYEngine.logObject(jsonInfo,'------获取短信:');
            var errcode = jsonInfo.code;
            if (errcode != 0) {//-2 超过限制
                cc.log('-----获取短信失败');
                if (errcode == -2) {
                    FYEngine.AddCommToast('今日短信发送过于频繁，请明日再试');
                } else {
                    FYEngine.AddCommToast('获取验证码失败');
                }
                return;
            }
            FYEngine.AddCommToast('短信验证码发送成功');

        });
    },

    removeLoading: function () {
        var loading = this.getChildByName("accloading");
        if (loading) {
            loading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

    timeCount1: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time1 += dt;
        if (this._time1 > 15) {
            this._time1 = 0;
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount1);
        }
    },

});

var GameFindBackPswDialog = DialogLayer.extend({
    _recount: 60,
    _time: 0,
    _time1: 0,
    _canTouch: true,
    ctor: function () {
        this._super();
        this._recount = 60;
        this._time = 0;
        this._time1 = 0;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg("#fish_acbind_19.png", 654);
        this.addCloseBtn();
        //this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        //this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width*0.72, bg.height*0.15));
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.15));
        var numbersprite = new ccui.Text("手机号:", "微软雅黑", 28);
        if (numbersprite) {
            numbersprite.enableOutline(cc.color("8ef3ff"), 1);
            numbersprite.setColor(cc.color("8ef3ff"));
            numbersprite.setAnchorPoint(cc.p(0, 0.5));
            numbersprite.setPosition(cc.p(90, 250));
            this.layerbg.addChild(numbersprite);
        }

        var codesprite = new ccui.Text("验证码:", "微软雅黑", 28);
        if (codesprite) {
            codesprite.enableOutline(cc.color("8ef3ff"), 1);
            codesprite.setColor(cc.color("8ef3ff"));
            codesprite.setAnchorPoint(cc.p(0, 0.5));
            codesprite.setPosition(cc.p(90, 180));
            this.layerbg.addChild(codesprite);
        }


        var smallbg = new ccui.ImageView(SettingRes.settingBtnBg, ccui.Widget.PLIST_TEXTURE);
        if (smallbg) {
            bg.addChild(smallbg);
            smallbg.setScale9Enabled(true);
            smallbg.setContentSize(cc.size(300, 49));
            smallbg.setPosition(cc.p(360, 180));
        }

        var phonesprite = new ccui.Text("" + appglobal.getPlayer().getFreshPhoneNumber(), "微软雅黑", 28);
        if (phonesprite) {
            phonesprite.enableOutline(cc.color("8ef3ff"), 1);
            phonesprite.setColor(cc.color("8ef3ff"));
            phonesprite.setAnchorPoint(cc.p(0, 0.5));
            phonesprite.setPosition(cc.p(220, 250));
            this.layerbg.addChild(phonesprite);
        }

        var codeedit = FYEngine.createEditBox("", cc.size(150, 50), cc.EDITBOX_INPUT_MODE_NUMERIC, "输入验证码", cc.color("28b5f2"), cc.color("8ef3ff"), 28, 6);
        if (codeedit) {
            codeedit.setPlaceholderFontSize(24);
            codeedit.setPosition(cc.p(295, 180));
            bg.addChild(codeedit);

            var delegate2 = {
                editBoxEditingDidBegin: function () {
                    codeedit.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = codeedit.getString();
                    if (str == "") {
                        codeedit.setPlaceHolder("输入验证码");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }

            };
            codeedit.setDelegate(delegate2);
            this.codeedit = codeedit;
        }

        var getCodeBtn = new ccui.ImageView("fish_acbind_0.png", ccui.Widget.PLIST_TEXTURE);
        if (getCodeBtn) {
            bg.addChild(getCodeBtn);
            getCodeBtn.setTouchEnabled(true);
            getCodeBtn.setPosition(cc.p(445, 180.5));
            getCodeBtn.setSwallowTouches(true);
            getCodeBtn.addTouchEventListener(this.getCodeCallBack, this);
            this._getCodeBtn = getCodeBtn;
            var btnTip = new cc.Sprite("#fish_acbind_3.png");
            if (btnTip) {
                getCodeBtn.addChild(btnTip);
                btnTip.setPosition(cc.p(getCodeBtn.width / 2, getCodeBtn.height / 2));
            }
        }

        var self = this;
        this.addConfirmBtn(function () {
            //self.removeFromParent(true);
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.15));


    },

    confirmCallBack: function () {
        var self = this;
        var code = this.codeedit.getString();
        if (code == '') {
            FYEngine.AddCommToast('验证码不能为空');
            return;
        }

        if (code.length < 6) {
            FYEngine.AddCommToast('请输入正确的验证码');
            return;
        }

        var loading = FYEngine.CreateAccRelatedLoading();
        if (loading) {
            this.addChild(loading, 100, 'accloading');
        }
        this._time = 0;
        this.schedule(this.timeCount, 1);

        Http.getMessage(function () {
            var service = formservice("checkMsgCode");
            var time = Date.now();
            var pnumber = {name: "phoneNo", value: appglobal.getPlayer().phonenumber};
            var msgCode = {name: "msgCode", value: code};
            var sign = formsign("checkMsgCode", time);
            time = formTime(time);
            var checksum = formchecksum(pnumber.value, msgCode.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, pnumber, msgCode, sign, checksum);
            cc.log('-------发送短信url:' + url);
            return url;
        }(), null, function (cfgStr) {
            self.removeLoading();
            self.unschedule(self.timeCount);
            var jsonInfo = eval('(' + cfgStr + ')');
//            FYEngine.logObject(jsonInfo,'------获取短信checkmsgcode:');
            var errcode = jsonInfo.code;
            if (errcode != 0) {//-2 超过限制
                cc.log('-----获取短信失败');
                var datas = jsonInfo.data;
                FYEngine.AddCommToast('' + datas);
                return;
            }
            //appglobal.acctempcode = code;
            self.removeFromParent(true);
            var newlayer = new FindPSWenterDialog(code);
            FYEngine.getRunningScene(0).addChild(newlayer, FishZorder.poplayer, LobbySceneName.FindPSWenterDialog);
        });
    },

    getCodeCallBack: function (sender, type) {
        cc.log('--------倒计时按钮');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.GameFindBackPswDialog);
        if (!layer._canTouch) {
            return;
        }
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN : {
                sender.setOpacity(180);
            }
                break;
            case ccui.Widget.TOUCH_MOVED : {

            }
                break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                layer.enterRecountMode();
            }
                break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(180);
            }
                break;
        }
    },

    enterRecountMode: function () {
        var date = new Date();
        //cc.log('-----年:'+date.getFullYear()+'--月:'+date.getMonth()+'---日:'+date.getUTCDate());
        var uidrecord = cc.sys.localStorage.getItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord');
        if (uidrecord) {
            if (parseInt(uidrecord) > 20) {
                FYEngine.AddCommToast("今日短信发送过于频繁，请明日再试");
                return;
            } else {
                var record = parseInt(uidrecord) + 1;
                cc.sys.localStorage.setItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord', record + "");
            }
        } else {
            cc.sys.localStorage.setItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord', "1");
        }


        this.sendGetPhoneMsg();
        this._canTouch = false;
        this._recount = 60;
        this._getCodeBtn.removeAllChildren();
        this._getCodeBtn.setColor(cc.color(180, 180, 180, 255));
        //this._getCodeBtn.setTouchEnabled(false);
        //this._getCodeBtn.setSwallowTouches(true);
        var btntip = new cc.Sprite("#fish_acbind_6.png");
        if (btntip) {
            this._getCodeBtn.addChild(btntip, 0, "tip");
            btntip.setPosition(cc.p(this._getCodeBtn.width / 2 - 21, this._getCodeBtn.height / 2));
            this._btntip = btntip;
        }

        var btntip1 = new cc.Sprite("#fish_acbind_14.png");
        if (btntip1) {
            btntip.addChild(btntip1);
            btntip1.setPosition(cc.p(btntip.width + 21, btntip.height / 2));
            this._verytip1 = btntip1;
        }

        var count = FYEngine.createAlts("res/updateacc/fish_acc_number_01.png", 12, this._recount, '.');
        if (count) {
            btntip1.addChild(count);
            count.setPosition(cc.p(btntip1.width / 2, btntip1.height / 2));
            this._countlabel = count;
        }

        this.schedule(this.changeCount, 1);

    },

    changeCount: function () {
        --this._recount;
        if (this._recount == 0) {
            this.unschedule(this.changeCount);
            this.enterNextMode();
            return;
        }
        if (this._recount == 9) {
            this._verytip1.setSpriteFrame("fish_acbind_13.png");
            this._verytip1.setPosition(cc.p(this._btntip.width + 20, this._btntip.height / 2));
            this._countlabel.setPosition(cc.p(this._verytip1.width / 2, this._verytip1.height / 2));
        }
        this._countlabel.setString("" + this._recount);
    },

    enterNextMode: function () {
        this._canTouch = true;
        this._recount = 60;
        this._getCodeBtn.setColor(cc.color(255, 255, 255, 255));
        this._getCodeBtn.removeAllChildren();
        var btntip = new cc.Sprite("#fish_acbind_6.png");
        if (btntip) {
            this._getCodeBtn.addChild(btntip, 0, "tip");
            btntip.setPosition(cc.p(this._getCodeBtn.width / 2, this._getCodeBtn.height / 2));
        }
    },

    sendGetPhoneMsg: function () {
        var self = this;
        self._time1 = 0;
        self.schedule(self.timeCount1, 1);
        Http.getMessage(function () {
            var service = formservice("SmsService");
            var time = Date.now();
            var token = {name: "token", value: appglobal.getPlayer().token};
            var pnumber = {name: "phoneNo", value: appglobal.getPlayer().phonenumber};
            var sign = formsign("SmsService", time);
            var type = {name: "type", value: 2}; // 0绑定,1解绑
            var uid = {name: "uid", value: appglobal.getPlayer().userid};
            time = formTime(time);
            var checksum = formchecksum(uid.value, token.value, pnumber.value, type.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, token, pnumber, type, uid, sign, checksum);
            cc.log('-------发送短信url:' + url);
            return url;
        }(), null, function (cfgStr) {
            self.unschedule(self.timeCount1);
            var jsonInfo = eval('(' + cfgStr + ')');
//            FYEngine.logObject(jsonInfo,'------获取短信:');
            var errcode = jsonInfo.code;
            if (errcode != 0) {//-2 超过限制
                cc.log('-----获取短信失败');
                if (errcode == -2) {
                    FYEngine.AddCommToast('今日短信发送过于频繁，请明日再试');
                } else {
                    FYEngine.AddCommToast('获取验证码失败');
                }
                return;
            }
            FYEngine.AddCommToast('短信验证码发送成功');

        });
    },

    removeLoading: function () {
        var loading = this.getChildByName("accloading");
        if (loading) {
            loading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

    timeCount1: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time1 += dt;
        if (this._time1 > 15) {
            this._time1 = 0;
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount1);
        }
    },

});


var LoginFindPswDialog = DialogLayer.extend({
    _recount: 60,
    _time: 0,
    _time1: 0,
    _canTouch: true,
    ctor: function () {
        this._super();
        this._recount = 60;
        this._time = 0;
        this._time1 = 0;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg("#fish_acbind_19.png", 654);
        this.addCloseBtn();
        //this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        //this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width*0.72, bg.height*0.15));
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.15));
        var numbersprite = new ccui.Text("手机号:", "微软雅黑", 28);
        if (numbersprite) {
            numbersprite.enableOutline(cc.color("8ef3ff"), 1);
            numbersprite.setColor(cc.color("8ef3ff"));
            numbersprite.setAnchorPoint(cc.p(0, 0.5));
            numbersprite.setPosition(cc.p(90, 250));
            this.layerbg.addChild(numbersprite);
        }

        var codesprite = new ccui.Text("验证码:", "微软雅黑", 28);
        if (codesprite) {
            codesprite.enableOutline(cc.color("8ef3ff"), 1);
            codesprite.setColor(cc.color("8ef3ff"));
            codesprite.setAnchorPoint(cc.p(0, 0.5));
            codesprite.setPosition(cc.p(90, 180));
            this.layerbg.addChild(codesprite);
        }

        for (var i = 0; i < 2; ++i) {
            var smallbg = new ccui.ImageView(SettingRes.settingBtnBg, ccui.Widget.PLIST_TEXTURE);
            if (smallbg) {
                bg.addChild(smallbg);
                smallbg.setScale9Enabled(true);
                smallbg.setContentSize(cc.size(340, 49));
                smallbg.setPosition(cc.p(380, 180 + i * 70));
            }
        }

        var phoneedit = FYEngine.createEditBox("", cc.size(340, 50), cc.EDITBOX_INPUT_MODE_NUMERIC, "输入手机号码", cc.color("28b5f2"), cc.color("8ef3ff"), 30, 11);
        if (phoneedit) {
            phoneedit.setPlaceholderFontSize(24);
            phoneedit.setPosition(cc.p(390, 250));
            bg.addChild(phoneedit);

            var delegate1 = {
                editBoxEditingDidBegin: function () {
                    phoneedit.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = phoneedit.getString();
                    if (str == "") {
                        phoneedit.setPlaceHolder("输入手机号码");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }

            };
            phoneedit.setDelegate(delegate1);
            this.phoneedit = phoneedit;
        }

        var codeedit = FYEngine.createEditBox("", cc.size(190, 50), cc.EDITBOX_INPUT_MODE_NUMERIC, "输入验证码", cc.color("28b5f2"), cc.color("8ef3ff"), 30, 6);
        if (codeedit) {
            codeedit.setPlaceholderFontSize(24);
            codeedit.setPosition(cc.p(315, 180));
            bg.addChild(codeedit);

            var delegate2 = {
                editBoxEditingDidBegin: function () {
                    codeedit.setPlaceHolder("");
                },

                editBoxEditingDidEnd: function () {
                    var str = codeedit.getString();
                    if (str == "") {
                        codeedit.setPlaceHolder("输入验证码");
                    }
                },

                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }

            };
            codeedit.setDelegate(delegate2);
            this.codeedit = codeedit;
        }

        var getCodeBtn = new ccui.ImageView("fish_acbind_0.png", ccui.Widget.PLIST_TEXTURE);
        if (getCodeBtn) {
            bg.addChild(getCodeBtn);
            getCodeBtn.setTouchEnabled(true);
            getCodeBtn.setPosition(cc.p(482, 180.5));
            getCodeBtn.setSwallowTouches(true);
            getCodeBtn.addTouchEventListener(this.getCodeCallBack, this);
            this._getCodeBtn = getCodeBtn;
            var btnTip = new cc.Sprite("#fish_acbind_3.png");
            if (btnTip) {
                getCodeBtn.addChild(btnTip);
                btnTip.setPosition(cc.p(getCodeBtn.width / 2, getCodeBtn.height / 2));
            }
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.15));


    },

    confirmCallBack: function () {
        var phonenumber = this.phoneedit.getString();
        var code = this.codeedit.getString();

        if (phonenumber == '') {
            FYEngine.AddCommToast('手机号码不能为空');
            return;
        }

        if (code == '') {
            FYEngine.AddCommToast('验证码不能为空');
            return;
        }

        if (phonenumber.length < 11) {
            FYEngine.AddCommToast('请输入正确的手机号');
            return;
        }

        if (code.length < 6) {
            FYEngine.AddCommToast('请输入正确的验证码');
            return;
        }

        if (!(/^1\d{10}$/.test(phonenumber))) {
            FYEngine.AddCommToast('请输入正确的手机号');
            return;
        }

        var loading = FYEngine.CreateAccRelatedLoading();
        if (loading) {
            this.addChild(loading, 100, 'accloading');
        }
        this._time = 0;
        this.schedule(this.timeCount, 1);

        var self = this;

        Http.getMessage(function () {
            var service = formservice("checkMsgCode");
            var time = Date.now();
            var pnumber = {name: "phoneNo", value: phonenumber};
            var msgCode = {name: "msgCode", value: code};
            var sign = formsign("checkMsgCode", time);
            time = formTime(time);
            var checksum = formchecksum(pnumber.value, msgCode.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, pnumber, msgCode, sign, checksum);
            cc.log('-------发送短信url:' + url);
            return url;
        }(), null, function (cfgStr) {
            self.removeLoading();
            self.unschedule(self.timeCount);
            var jsonInfo = eval('(' + cfgStr + ')');
//            FYEngine.logObject(jsonInfo,'------登录界面对比验证码返回:');
            var errcode = jsonInfo.code;
            if (errcode != 0) {//-2 超过限制
                cc.log('-----获取短信失败');
                var datas = jsonInfo.data;
                FYEngine.AddCommToast('' + datas);
                return;
            }
            //appglobal.acctempcode = code;
            self.removeFromParent(true);
            var newlayer = new FindPSWenterDialog(code, phonenumber, jsonInfo.data);
            if (newlayer) {
                FYEngine.getRunningScene(0).addChild(newlayer, 2, LobbySceneName.FindPSWenterDialog);
            }

        });
    },

    getCodeCallBack: function (sender, type) {
        cc.log('--------倒计时按钮');
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.LoginFindPswDialog);
        //var layer = scene.getChildByName(LoginLayerName.lobbysmalllayer);
        if (!layer._canTouch) {
            return;
        }
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN : {
                sender.setOpacity(180);
            }
                break;
            case ccui.Widget.TOUCH_MOVED : {

            }
                break;
            case ccui.Widget.TOUCH_ENDED : {
                sender.setOpacity(255);
                layer.enterRecountMode();
            }
                break;
            case ccui.Widget.TOUCH_CANCELED : {
                sender.setOpacity(180);
            }
                break;
        }
    },

    enterRecountMode: function () {
        var phonenumber = this.phoneedit.getString();
        if (phonenumber == '') {
            FYEngine.AddCommToast('手机号码不能为空');
            return;
        }

        if (phonenumber.length < 11) {
            FYEngine.AddCommToast('请输入正确的手机号');
            return;
        }

        if (!(/^1\d{10}$/.test(phonenumber))) {
            FYEngine.AddCommToast('请输入正确的手机号');
            return;
        }

        var date = new Date();
        //cc.log('-----年:'+date.getFullYear()+'--月:'+date.getMonth()+'---日:'+date.getUTCDate());
        var uidrecord = cc.sys.localStorage.getItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord');
        //cc.log('-------uidrecord--'+uidrecord);
        if (uidrecord) {
            if (parseInt(uidrecord) > 20) {
                FYEngine.AddCommToast("今日短信发送过于频繁，请明日再试");
                return;
            } else {
                var record = parseInt(uidrecord) + 1;
                cc.sys.localStorage.setItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord', record + "");
            }
        } else {
            cc.sys.localStorage.setItem(date.getFullYear() + date.getMonth() + date.getUTCDate() + 'uidrecord', "1");
        }

        this.sendGetPhoneMsg();
        this._canTouch = false;
        this._recount = 60;
        this._getCodeBtn.removeAllChildren();
        this._getCodeBtn.setColor(cc.color(180, 180, 180, 255));
        //this._getCodeBtn.setTouchEnabled(false);
        //this._getCodeBtn.setSwallowTouches(true);
        var btntip = new cc.Sprite("#fish_acbind_6.png");
        if (btntip) {
            this._getCodeBtn.addChild(btntip, 0, "tip");
            btntip.setPosition(cc.p(this._getCodeBtn.width / 2 - 21, this._getCodeBtn.height / 2));
            this._btntip = btntip;
        }

        var btntip1 = new cc.Sprite("#fish_acbind_14.png");
        if (btntip1) {
            btntip.addChild(btntip1);
            btntip1.setPosition(cc.p(btntip.width + 21, btntip.height / 2));
            this._verytip1 = btntip1;
        }

        var count = FYEngine.createAlts("res/updateacc/fish_acc_number_01.png", 12, this._recount, '.');
        if (count) {
            btntip1.addChild(count);
            count.setPosition(cc.p(btntip1.width / 2, btntip1.height / 2));
            this._countlabel = count;
        }

        this.schedule(this.changeCount, 1);

    },

    changeCount: function () {
        --this._recount;
        if (this._recount == 0) {
            this.unschedule(this.changeCount);
            this.enterNextMode();
            return;
        }
        if (this._recount == 9) {
            this._verytip1.setSpriteFrame("fish_acbind_13.png");
            this._verytip1.setPosition(cc.p(this._btntip.width + 20, this._btntip.height / 2));
            this._countlabel.setPosition(cc.p(this._verytip1.width / 2, this._verytip1.height / 2));
        }
        this._countlabel.setString("" + this._recount);
    },

    enterNextMode: function () {
        this._canTouch = true;
        this._recount = 60;
        this._getCodeBtn.setColor(cc.color(255, 255, 255, 255));
        this._getCodeBtn.removeAllChildren();
        var btntip = new cc.Sprite("#fish_acbind_6.png");
        if (btntip) {
            this._getCodeBtn.addChild(btntip, 0, "tip");
            btntip.setPosition(cc.p(this._getCodeBtn.width / 2, this._getCodeBtn.height / 2));
        }
    },

    sendGetPhoneMsg: function () {
        var self = this;
        self._time1 = 0;
        self.schedule(self.timeCount1, 1);
        var phonenumber = this.phoneedit.getString();
        Http.getMessage(function () {
            var service = formservice("SmsService");
            var time = Date.now();
            var token = {name: "token", value: appglobal.getPlayer().token};
            var pnumber = {name: "phoneNo", value: phonenumber};
            var sign = formsign("SmsService", time);
            var type = {name: "type", value: 2}; // 0绑定,1解绑,2找回密码
            var uid = {name: "uid", value: appglobal.getPlayer().userid};
            time = formTime(time);
            var checksum = formchecksum(uid.value, token.value, pnumber.value, type.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, token, pnumber, type, uid, sign, checksum);
            cc.log('-------发送短信url:' + url);
            return url;
        }(), null, function (cfgStr) {
//            FYEngine.logObject(cfgStr,'------获取短信:');
            self.unschedule(self.timeCount1);
            var jsonInfo = eval('(' + cfgStr + ')');

            var errcode = jsonInfo.code;
            if (errcode != 0) {//-2 超过限制
                cc.log('-----获取短信失败');
                if (errcode == -2) {
                    FYEngine.AddCommToast('今日短信发送过于频繁，请明日再试');
                } else {
                    FYEngine.AddCommToast('获取验证码失败');
                }
                return;
            }
            FYEngine.AddCommToast('短信验证码发送成功');

        });
    },

    removeLoading: function () {
        var loading = this.getChildByName("accloading");
        if (loading) {
            loading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

    timeCount1: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time1 += dt;
        if (this._time1 > 15) {
            this._time1 = 0;
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount1);
        }
    },

});

var BindAccountOkDialog = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var tip = new ccui.Text(FYEngine.LanguageString.getValue("bindAccouontOKContent"), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setTextAreaSize(cc.size(506, 110));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.15), "#fish_acbind_8.png");
        this.addCancelBtn(null, cc.p(bg.width * 0.25, bg.height * 0.15), "#fish_acbind_11.png");
    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = new BindPhoneDialog();
        if (layer) {
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.BindPhoneDialog);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    }
});

var BindPhoneOkDialog = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var tip = new ccui.Text(FYEngine.LanguageString.getValue("bindPhoneOKContent1"), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setTextAreaSize(cc.size(506, 35));
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6 + 10));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            tip.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            innerbg.addChild(tip, 0, 10);
        }

        var tip1 = new ccui.Text(FYEngine.LanguageString.getValue("bindPhoneOKContent2"), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip1) {
            tip1.setTextAreaSize(cc.size(506, 35));
            tip1.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.4 + 10));
            // tip1.enableOutline(cc.color(255, 255, 255, 255), 1);
            tip1.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            innerbg.addChild(tip1, 0, 11);
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
        }, cc.p(bg.width * 0.5, bg.height * 0.15), UsedResName.iknowbtn);
    },

    confirmCallBack: function () {

    }
});

var UnBindPhoneConfirmDialog = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.init(cc.color(0, 0, 0, 190), 1136, 640);
        this.initUI();
    },

    initUI: function () {
        var bigShark = new cc.Sprite("#fish_acbind_22.png");
        if (bigShark) {
            this.addChild(bigShark);
            this.layerbg = bigShark;
            bigShark.setAnchorPoint(cc.p(0.5, 0.5));
            bigShark.setPosition(cc.p(this.width * 0.33, this.height * 0.51));
        }

        var bg1 = new ccui.ImageView("fish_acbind_17.png", ccui.Widget.PLIST_TEXTURE);
        if (bg1) {
            this.layerbg.addChild(bg1);
            bg1.setScale9Enabled(true);
            bg1.setContentSize(cc.size(530, 300));
            bg1.setPosition(cc.p(bigShark.width * 1.39, bigShark.height * 0.59));
        }
        var smallfish = new cc.Sprite("#fish_acbind_23.png");
        if (smallfish) {
            this.layerbg.addChild(smallfish);
            smallfish.setPosition(cc.p(201, 97));
        }

        var bg2 = new ccui.ImageView("fish_acbind_18.png", ccui.Widget.PLIST_TEXTURE);
        if (bg2) {
            bg1.addChild(bg2);
            bg2.setScale9Enabled(true);
            bg2.setContentSize(cc.size(500, 183));
            bg2.setPosition(cc.p(bg1.width / 2, bg1.height * 0.65));
        }

        var tip = new ccui.Text(FYEngine.LanguageString.getValue("unbindPhoneConfirmContent"), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (tip) {
            tip.setTextAreaSize(cc.size(450, 90));
            tip.setColor(cc.color("#074e8b"));
            tip.setPosition(cc.p(bg2.width / 2, bg2.height * 0.5));
            tip.enableOutline(cc.color("#074e8b"), 1);
            bg2.addChild(tip, 0, 10);
        }


        var self = this;
        var confirmBtn = new cc.Sprite(FishSceneRes.DialogPng.ConfirmBtn);
        if (confirmBtn) {
            confirmBtn.setPosition(cc.p(bg1.width * 0.75, bg1.height * 0.15));
            bg1.addChild(confirmBtn, 0, 5);
            FYEngine.AddNodeTouchListener(confirmBtn, function () {
                self.removeFromParent(true);
                self.confirmCallBack();
            }, FYEngine.ActionType.Fade);
        }
        var confirmTitle = new cc.Sprite("#fish_acbind_7.png");
        if (confirmTitle) {
            confirmTitle.setPosition(confirmBtn.width / 2, confirmBtn.height * 0.6);
            confirmBtn.addChild(confirmTitle, 0);
        }

        var cancelBtn = new cc.Sprite(FishSceneRes.DialogPng.CancelBtn);
        if (cancelBtn) {
            cancelBtn.setPosition(cc.p(bg1.width * 0.25, bg1.height * 0.15));
            bg1.addChild(cancelBtn, 0, 6);

            FYEngine.AddNodeTouchListener(cancelBtn, function () {
                self.cancelCallBack();
            }, FYEngine.ActionType.Fade);
        }
        var cancelTitle = new cc.Sprite(FishSceneRes.DialogPng.CancelTitle);
        if (cancelTitle) {
            cancelTitle.setPosition(cancelBtn.width / 2, cancelBtn.height * 0.6);
            cancelBtn.addChild(cancelTitle, 0);
        }

    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = new UnBindPhoneDialog();
        if (layer) {
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.UnBindPhoneDialog);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    },

    cancelCallBack: function () {
        this.removeFromParent(true);
    },
});

var ChangePSWchoseDialog = cc.LayerColor.extend({

    ctor: function () {
        this._super();
        var self = this;
        this.init(cc.color(0, 0, 0, 190));
        this.initUI();
        this.touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            },

            onTouchEnded: function (touch, event) {
                self.removeFromParent(true);
            },
        });
        cc.eventManager.addListener(this.touchListener, this);

    },

    initUI: function () {
        var self = this;
        var layerBg = this.layerbg = new ccui.ImageView('rankup006.png', ccui.Widget.PLIST_TEXTURE);
        if (layerBg) {
            this.addChild(layerBg);
            //layerBg.setEnabled(false);
            layerBg.setSwallowTouches(true);
            layerBg.setTouchEnabled(true);
            layerBg.setPosition(cc.p(this.width / 2, this.height / 2));
            layerBg.setScale9Enabled(true);
            layerBg.setCapInsets(cc.size(200, 105, 135, 100));
            layerBg.setContentSize(cc.size(535, 305));
        }

        var title = new ccui.Text('修改密码', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 25);
        if (title) {
            title.setAnchorPoint(cc.p(0, 0.5));
            title.setPosition(cc.p(40, 265));
            title.setColor(cc.color("074E8B"));
            //title.enableOutline(cc.color("074E8B"), 1);
            this.layerbg.addChild(title, 0);
        }

        var line_0 = new ccui.Scale9Sprite('rankup013.png');
        if (line_0) {
            line_0.setPosition(layerBg.width * 0.5 - 2, 240);
            line_0.setContentSize(485, 6);
            this.layerbg.addChild(line_0, 0);
        }

        var line_1 = new ccui.Scale9Sprite('rankup013.png');
        if (line_1) {
            line_1.setPosition(layerBg.width * 0.5 - 2, 128);
            line_1.setContentSize(485, 6);
            this.layerbg.addChild(line_1, 0);
        }

        var takePhoneImg = new ccui.ImageView('fish_acbind_24.png', ccui.Widget.PLIST_TEXTURE);
        if (takePhoneImg) {
            this.layerbg.addChild(takePhoneImg);
            //takePhoneImg.setTouchEnabled(true);
            takePhoneImg.setPosition(cc.p(85, 185));

            var word1 = new ccui.Text('验证当前密码修改', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
            if (word1) {
                word1.setAnchorPoint(cc.p(0, 0.5));
                word1.setPosition(cc.p(160, 185));
                word1.setColor(cc.color("074E8B"));
                word1.enableOutline(cc.color("074E8B"), 1);
                this.layerbg.addChild(word1, 0);
            }

            var arrow1 = new cc.Sprite("#rankup009.png");
            if (arrow1) {
                this.layerbg.addChild(arrow1);
                arrow1.setPosition(cc.p(470, 185));
            }

            var takeBtn = new ccui.ImageView("");
            if (takeBtn) {
//                cc.log('0-----------创建成功');
                this.layerbg.addChild(takeBtn, 10, 'take');
                //takeBtn.setEnabled(true);
                takeBtn.setTouchEnabled(true);
                takeBtn.setScale9Enabled(true);
                //takeBtn.setColor(cc.color(255,0,0));
                takeBtn.setAnchorPoint(cc.p(0.5, 0.5));
                takeBtn.setPosition(this.layerbg.width / 2, 184);
                takeBtn.setContentSize(cc.size(485, 112));
                //takeBtn.addClickEventListener(this.takePicCallBack);
                takeBtn.addClickEventListener(function (sender) {
                    self.takePicCallBack(sender);
                })
            }

        }


        var PhoneImg = new ccui.ImageView('fish_acbind_25.png', ccui.Widget.PLIST_TEXTURE);
        if (PhoneImg) {
            this.layerbg.addChild(PhoneImg);
            PhoneImg.setPosition(cc.p(85, 75));

            var word2 = new ccui.Text('通过绑定手机重置', FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
            if (word2) {
                word2.setAnchorPoint(cc.p(0, 0.5));
                word2.setPosition(cc.p(160, 75));
                word2.setColor(cc.color("074E8B"));
                word2.enableOutline(cc.color("074E8B"), 1);
                this.layerbg.addChild(word2, 0);
            }

            var arrow2 = new cc.Sprite("#rankup009.png");
            if (arrow1) {
                this.layerbg.addChild(arrow2);
                arrow2.setPosition(cc.p(470, 75));
            }

            var takeBtn2 = new ccui.ImageView("");
            if (takeBtn2) {
//                cc.log('0-----------创建成功2');
                this.layerbg.addChild(takeBtn2, 10, 'bring');
                //takeBtn.setEnabled(true);
                takeBtn2.setTouchEnabled(true);
                takeBtn2.setScale9Enabled(true);
                //takeBtn.setColor(cc.color(255,0,0));
                takeBtn2.setAnchorPoint(cc.p(0.5, 0.5));
                takeBtn2.setPosition(cc.p(this.layerbg.width / 2, 72));
                takeBtn2.setContentSize(cc.size(485, 112));
                //takeBtn2.addClickEventListener(this.takePicCallBack);
                takeBtn2.addClickEventListener(function (sender) {
                    self.takePicCallBack(sender);
                })
            }
        }
    },

    takePicCallBack: function (sender) {
        var self = this;

        var name = sender.getName();
//        cc.log('--------测试头像功能:'+name);
        switch (name) {
            case 'bring' : {
                var player = appglobal.getPlayer();
                cc.log('-------通过绑定手机重置');
                if (player.phonenumber != 0 && player.phonenumber != "") {
                    self.removeFromParent(true);
                    var layer = new GameFindBackPswDialog();
                    FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.GameFindBackPswDialog);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                } else {
                    FYEngine.AddCommToast("请先绑定手机");
                }
            }
                break;
            case 'take' : {
                self.removeFromParent(true);
                cc.log('-------验证当前密码修改');
                var layer = new ChangePasswordLayer();
                FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.ChangepSWLayer);
                FYEngine.popupLayerAnimate(layer.layerbg);
            }
                break;
            default :
                break;
        }
    }
});

var FindPSWenterDialog = DialogLayer.extend({
    _recount: 60,
    _time: 0,
    _time1: 0,
    _canTouch: true,
    _code: 0,
    _number: 0,
    _acc: "",
    ctor: function (code, number, account) {
        this._super();
        this._recount = 60;
        this._time = 0;
        this._time1 = 0;
        this._code = code;
        if (number == undefined) {
            this._number = appglobal.getPlayer().phonenumber;
        } else {
            this._number = number;
        }

        if (account == undefined) {
            this._acc = appglobal.getPlayer().account;
        } else {
            this._acc = account;
        }
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(667, 392));
        this.addTitleBg("#fish_acbind_19.png", 674);
        this.addCloseBtn();
        //this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        //this.addConfirmBtn(this.confirmCallBack, cc.p(bg.width*0.72, bg.height*0.15));
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.15));
        var numbersprite = new ccui.Text("确认密码:", "微软雅黑", 28);
        if (numbersprite) {
            numbersprite.enableOutline(cc.color("8ef3ff"), 1);
            numbersprite.setColor(cc.color("8ef3ff"));
            numbersprite.setAnchorPoint(cc.p(0, 0.5));
            numbersprite.setPosition(cc.p(50, 240));
            this.layerbg.addChild(numbersprite);
        }

        var codesprite = new ccui.Text("新  密  码:", "微软雅黑", 28);
        if (codesprite) {
            codesprite.enableOutline(cc.color("8ef3ff"), 1);
            codesprite.setColor(cc.color("8ef3ff"));
            codesprite.setAnchorPoint(cc.p(0, 0.5));
            codesprite.setPosition(cc.p(50, 170));
            this.layerbg.addChild(codesprite);
        }

        var accountsprite = new ccui.Text("账        号:", "微软雅黑", 28);
        if (accountsprite) {
            accountsprite.enableOutline(cc.color("8ef3ff"), 1);
            accountsprite.setColor(cc.color("8ef3ff"));
            accountsprite.setAnchorPoint(cc.p(0, 0.5));
            accountsprite.setPosition(cc.p(50, 310));
            this.layerbg.addChild(accountsprite);
        }

        var accountcontent = new ccui.Text("" + this._acc, "微软雅黑", 28);
        if (accountcontent) {
            accountcontent.enableOutline(cc.color("8ef3ff"), 1);
            accountcontent.setColor(cc.color("8ef3ff"));
            accountcontent.setAnchorPoint(cc.p(0, 0.5));
            accountcontent.setPosition(cc.p(200, 310));
            this.layerbg.addChild(accountcontent);
        }

        for (var i = 0; i < 2; ++i) {
            var smallbg = new ccui.ImageView(SettingRes.settingBtnBg, ccui.Widget.PLIST_TEXTURE);
            if (smallbg) {
                bg.addChild(smallbg);
                smallbg.setScale9Enabled(true);
                smallbg.setContentSize(cc.size(440, 49));
                smallbg.setPosition(cc.p(410, 170 + i * 70));
            }
        }

        var phoneedit = FYEngine.createEditBox("", cc.size(400, 50), cc.EDITBOX_INPUT_MODE_SINGLELINE, FYEngine.LanguageString.getValue(SettingMsgKey.settingPassRule), cc.color("28b5f2"), cc.color("8ef3ff"), 22, 18);
        if (phoneedit) {
            phoneedit.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
            phoneedit.setFontSize(22);
            phoneedit.setPlaceholderFontSize(22);
            phoneedit.setPosition(cc.p(400, 240));
            bg.addChild(phoneedit);
            this.phoneedit = phoneedit;
        }

        var codeedit = FYEngine.createEditBox("", cc.size(400, 50), cc.EDITBOX_INPUT_MODE_SINGLELINE, FYEngine.LanguageString.getValue(SettingMsgKey.settingPassCheck), cc.color("28b5f2"), cc.color("8ef3ff"), 22, 18);
        if (codeedit) {
            codeedit.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
            codeedit.setFontSize(22);
            codeedit.setPlaceholderFontSize(22);
            codeedit.setPosition(cc.p(400, 170));
            bg.addChild(codeedit);
            this.codeedit = codeedit;
        }

        codeedit.setDelegate({
            editBoxEditingDidBegin: function () {
                codeedit.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {
                if (codeedit.getString() != phoneedit.getString()) {
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr1));
                }
                codeedit.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassCheck));
                //codeedit.setFontSize(24);
            },

        });
        phoneedit.setDelegate({
            editBoxEditingDidBegin: function () {
                phoneedit.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {
                if (phoneedit.getString() == "") {
                    phoneedit.setPlaceHolder(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassRule));
                } else if (!/^\w{6,18}$/.test(phoneedit.getString())) {
                    FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr3));
                }
                //phoneedit.setFontSize(24);
            }
        });

        var self = this;
        this.addConfirmBtn(function () {
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.15));


    },

    confirmCallBack: function () {
        var editPass = this.phoneedit;
        var editpassmodify = this.codeedit;

        if (editPass.getString() == "") {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr9));
            return;
        }

        if (editpassmodify.getString() != editPass.getString()) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr5));
            return;
        }

        if (!/^\w{6,18}$/.test(editPass.getString()) || !/[A-Za-z].*[0-9]|[0-9].*[A-Za-z]/.test(editPass.getString())) {
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassRule));
            return;
        }

        if (this._code == 0) {
            FYEngine.AddCommToast("修改密码失败");
            return;
        }
        this.sendGetMsg();

    },

    sendGetMsg: function () {
        var newpass1 = this.phoneedit.getString();
        var loading = FYEngine.CreateAccRelatedLoading();
        if (loading) {
            this.addChild(loading, 100, 'accloading');
        }
        this._time = 0;
        this.schedule(this.timeCount, 1);
        var self = this;

        var new_hash = hex_md5(newpass1).toUpperCase();

        Http.getMessage(function () {
            var service = formservice("LoginFindPass");
            var time = Date.now();
            var pnumber = {name: "phoneNo", value: self._number};
            var msgCode = {name: "msgCode", value: self._code};
            var newPass = {name: "newPass", value: new_hash};
            var imei = {name: "imei", value: appglobal._appCfg.imei};
            var sign = formsign("LoginFindPass", time);
            time = formTime(time);
            var checksum = formchecksum(pnumber.value, msgCode.value, newPass.value, imei.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, pnumber, msgCode, newPass, imei, sign, checksum);
            cc.log(checksum + '-------发送修改密码的请求url:' + url);
            return url;
        }(), null, function (cfgStr) {
            self.removeLoading();
            self.unschedule(self.timeCount);
            var jsonInfo = eval('(' + cfgStr + ')');
//            FYEngine.logObject(jsonInfo,'------获取:');
            var errcode = jsonInfo.code;
            if (errcode != 0) {
                cc.log('-----获取失败');
                switch (errcode) {
                    case -3 : {
                        FYEngine.AddCommToast('验证码错误');
                    }
                        break;
                    case -5 : {
                        FYEngine.AddCommToast('验证码超时');
                    }
                        break;
                    default : {
                        FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr8));
                    }
                }
                return;
            }
            FYEngine.AddCommToast(FYEngine.LanguageString.getValue(SettingMsgKey.settingPassErr6));

            self.removeFromParent(true);
            //如果是在登录界面修改密码,不写入缓存
            if (FYEngine.getRunningLayer(0).getName() == AppSceneName.Login) {
                return;
            }
            app.accountManager.modifyPwd(new_hash);

        });
    },

    removeLoading: function () {
        var loading = this.getChildByName("accloading");
        if (loading) {
            loading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

    timeCount1: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time1 += dt;
        if (this._time1 > 15) {
            this._time1 = 0;
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount1);
        }
    },

});

/**
 * 绑定手机引导界面
 * @param 0 :未绑定账号   1:未绑定手机
 */
var UserGuideDialog = DialogLayer.extend({
    _code: 0,
    ctor: function (code) {
        this._super();
        this._code = code;
        this.init(cc.color(0, 0, 0, 190), 1136, 640);
        this.initUI();
    },

    initUI: function () {
        var bigShark = new cc.Sprite("#fish_acbind_22.png");
        if (bigShark) {
            this.addChild(bigShark);
            this.layerbg = bigShark;
            bigShark.setAnchorPoint(cc.p(0.5, 0.5));
            bigShark.setPosition(cc.p(this.width * 0.33, this.height * 0.51));
        }

        var bg1 = new ccui.ImageView("fish_acbind_17.png", ccui.Widget.PLIST_TEXTURE);
        if (bg1) {
            this.layerbg.addChild(bg1);
            bg1.setScale9Enabled(true);
            bg1.setContentSize(cc.size(530, 300));
            bg1.setPosition(cc.p(bigShark.width * 1.39, bigShark.height * 0.59));
        }
        var smallfish = new cc.Sprite("#fish_acbind_23.png");
        if (smallfish) {
            this.layerbg.addChild(smallfish);
            smallfish.setPosition(cc.p(201, 97));
        }

        var bg2 = new ccui.ImageView("fish_acbind_18.png", ccui.Widget.PLIST_TEXTURE);
        if (bg2) {
            bg1.addChild(bg2);
            bg2.setScale9Enabled(true);
            bg2.setContentSize(cc.size(500, 183));
            bg2.setPosition(cc.p(bg1.width / 2, bg1.height * 0.65));
        }

        var tiptitle = "";
        var tipcontent = "";
        var confirmTitle = "";
        if (this._code == 0) {
            tiptitle = FYEngine.LanguageString.getValue("userguide1");
            tipcontent = FYEngine.LanguageString.getValue("userguide2");
            confirmTitle = "#fish_acbind_9.png";
        } else {
            tiptitle = FYEngine.LanguageString.getValue("userguide3");
            tipcontent = FYEngine.LanguageString.getValue("userguide4");
            confirmTitle = "#fish_acbind_8.png";
        }


        var tip = new ccui.Text(tiptitle, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 28);
        if (tip) {
            tip.setTextAreaSize(cc.size(460, 30));
            tip.setColor(cc.color("#074e8b"));
            tip.setPosition(cc.p(bg2.width / 2, bg2.height * 0.7));
            tip.enableOutline(cc.color("#074e8b"), 1);
            bg2.addChild(tip, 0, 10);
        }

        var tip2 = new ccui.Text(tipcontent, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (tip2) {
            tip2.setTextAreaSize(cc.size(450, 60));
            tip2.setColor(cc.color("#074e8b"));
            tip2.setPosition(cc.p(bg2.width / 2, bg2.height * 0.35));
            tip2.enableOutline(cc.color("#074e8b"), 1);
            bg2.addChild(tip2, 0, 10);
        }


        var self = this;
        var confirmBtn = new cc.Sprite(FishSceneRes.DialogPng.ConfirmBtn);
        if (confirmBtn) {
            confirmBtn.setPosition(cc.p(bg1.width * 0.75, bg1.height * 0.15));
            bg1.addChild(confirmBtn, 0, 5);
            FYEngine.AddNodeTouchListener(confirmBtn, function () {
                self.removeFromParent(true);
                self.confirmCallBack();
            }, FYEngine.ActionType.Fade);
        }
        var confirmTitle = new cc.Sprite(confirmTitle);
        if (confirmTitle) {
            confirmTitle.setPosition(confirmBtn.width / 2, confirmBtn.height * 0.6);
            confirmBtn.addChild(confirmTitle, 0);
        }

        var cancelBtn = new cc.Sprite(FishSceneRes.DialogPng.CancelBtn);
        if (cancelBtn) {
            cancelBtn.setPosition(cc.p(bg1.width * 0.25, bg1.height * 0.15));
            bg1.addChild(cancelBtn, 0, 6);

            FYEngine.AddNodeTouchListener(cancelBtn, function () {
                self.cancelCallBack();
            }, FYEngine.ActionType.Fade);
        }
        var cancelTitle = new cc.Sprite(FishSceneRes.DialogPng.CancelTitle);
        if (cancelTitle) {
            cancelTitle.setPosition(cancelBtn.width / 2, cancelBtn.height * 0.6);
            cancelBtn.addChild(cancelTitle, 0);
        }

    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        if (this._code == 0) {
            var layer = new CompleteInfoLayer();
            if (layer) {
                scene.addChild(layer, FishZorder.poplayer, LobbySceneName.CompleteInfoLayer);
                FYEngine.popupLayerAnimate(layer.layerbg);
            }
        } else {
            var layer = new BindPhoneDialog();
            if (layer) {
                scene.addChild(layer, FishZorder.poplayer, LobbySceneName.BindPhoneDialog);
                FYEngine.popupLayerAnimate(layer.layerbg);
            }
        }


    },

    cancelCallBack: function () {
        this.removeFromParent(true);
    },
});

var SendCrystalLevelDialogAttache = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var mstr = "您的游戏行为异常，请联系客服人工解锁此功能，客服QQ：3003674856";

        var tip1 = new ccui.Text(mstr, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip1) {
            tip1.setAnchorPoint(cc.p(0.5, 0.5));
            tip1.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.55));
            // tip1.enableOutline(cc.color(255, 255, 255, 255), 1);
            tip1.setTextAreaSize(cc.size(450, 200));
            // tip1.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            tip1.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
            innerbg.addChild(tip1, 0, 10);
        }


        this.addConfirmBtn(function () {
            self.removeFromParent(true);
        }, cc.p(bg.width * 0.5, bg.height * 0.15), UsedResName.iknowbtn);
    },

});

var SendCrystalLevelDialog = DialogLayer.extend({
    _money: 0,
    _tag: 0,
    ctor: function (money, tag) {
        this._super();
        this._tag = tag;
        this._money = money;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var tip1 = new ccui.Text("还要充值", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip1) {
            tip1.setAnchorPoint(cc.p(0, 0.5));
            //tip1.setPosition(cc.p(40, innerbg.height*0.65));
            // tip1.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip1, 0, 10);
        }

        var tip2 = new ccui.Text(this._money + "元", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip2) {
            tip2.setAnchorPoint(cc.p(0, 0.5));
            tip2.setColor(cc.color("07f9e5"));
            tip2.setPosition(cc.p(tip1.width, tip1.height * 0.5));
            tip2.enableOutline(cc.color("07f9e5"), 1);
            tip1.addChild(tip2, 0, 12);
        }

        //var tip3 = new ccui.Text("或",FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        //if(tip3){
        //    tip3.setAnchorPoint(cc.p(0,0.5));
        //    tip3.setPosition(cc.p(tip1.width+tip2.width, tip1.height*0.5));
        //    tip3.enableOutline(cc.color(255, 255, 255, 255), 1);
        //    tip1.addChild(tip3, 0, 13);
        //}
        //
        //var tip4 = new ccui.Text("绑定手机",FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        //if(tip4){
        //    tip4.setAnchorPoint(cc.p(0,0.5));
        //    tip4.setColor(cc.color("07f9e5"));
        //    tip4.setPosition(cc.p(tip1.width+tip2.width+tip3.width, tip1.height*0.5));
        //    tip4.enableOutline(cc.color("07f9e5"), 1);
        //    tip1.addChild(tip4, 0, 14);
        //}

        var tip5 = new ccui.Text("才能解锁", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip5) {
            tip5.setAnchorPoint(cc.p(0, 0.5));
            //tip5.setPosition(cc.p(tip1.width+tip2.width+tip3.width+tip4.width, tip1.height*0.5));
            tip5.setPosition(cc.p(tip1.width + tip2.width, tip1.height * 0.5));
            // tip5.enableOutline(cc.color(255, 255, 255, 255), 1);
            tip1.addChild(tip5, 0, 15);
            //tip1.setPosition(cc.p(innerbg.width/2-(tip1.width+tip2.width+tip3.width+tip4.width+tip5.width)/2, innerbg.height*0.65));

        }

        var mtext = "";
        if (this._tag) {
            mtext = "创建比赛功能";
        }
        var tip6 = new ccui.Text(mtext, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip6) {
            tip6.setAnchorPoint(cc.p(0, 0.5));
            //tip6.setPosition(cc.p(tip1.getPositionX(), innerbg.height*0.45));
            tip6.setPosition(cc.p(tip1.width + tip2.width + tip5.width, tip1.height * 0.5));
            // tip6.enableOutline(cc.color(255, 255, 255, 255), 1);
            //innerbg.addChild(tip6, 0, 16);
            tip1.addChild(tip6, 0, 16);
            tip1.setPosition(cc.p(innerbg.width / 2 - (tip1.width + tip2.width + tip5.width + tip6.width) / 2, innerbg.height * 0.65));
        }

        var tip7 = new ccui.Text("游戏内直冲金币或购买礼包都视为充值", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (tip7) {
            tip7.setTextAreaSize(cc.size(500, 30));
            tip7.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            tip7.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.25));
            // tip7.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip7, 0, 17);
        }

        var self = this;
        //this.addConfirmBtn(function(){
        //    self.removeFromParent(true);
        //    self.confirmCallBack();
        //}, cc.p(bg.width*0.75, bg.height*0.15),"#fish_acbind_8.png");
        //this.addCancelBtn(null, cc.p(bg.width*0.25, bg.height*0.15),"#fish_acbind_11.png");
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
        }, cc.p(bg.width * 0.5, bg.height * 0.15), UsedResName.iknowbtn);
    },

    confirmCallBack: function () {
        //var player = appglobal.getPlayer();
        //var scene = FYEngine.getRunningLayer(0);
        //if(player.account == player.userid){
        //    var layer = new SettingLayer();
        //    if(layer){
        //        scene.addChild(layer,FishZorder.poplayer,LobbySceneName.SettingInfoLayer);
        //        FYEngine.popupLayerAnimate(layer.layerbg);
        //    }
        //}else{
        //    var layer = new BindPhoneDialog();
        //    if(layer){
        //        scene.addChild(layer, FishZorder.poplayer, LobbySceneName.BindPhoneDialog);
        //        FYEngine.popupLayerAnimate(layer.layerbg);
        //    }
        //}
    }
});

var SendCrystalLevel3rdDialog = DialogLayer.extend({
    _money: 0,
    ctor: function (money) {
        this._super();
        this._money = money;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var tip1 = new ccui.Text("还需要充值", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip1) {
            tip1.setAnchorPoint(cc.p(0, 0.5));
            // tip1.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip1, 0, 10);
        }

        var tip2 = new ccui.Text(this._money + "元", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip2) {
            tip2.setAnchorPoint(cc.p(0, 0.5));
            tip2.setColor(cc.color("07f9e5"));
            tip2.setPosition(cc.p(tip1.width, tip1.height * 0.5));
            tip2.enableOutline(cc.color("07f9e5"), 1);
            tip1.addChild(tip2, 0, 12);
        }

        var tip3 = new ccui.Text("才能解锁功能", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip3) {
            tip3.setAnchorPoint(cc.p(0, 0.5));
            tip3.setPosition(cc.p(tip1.width + tip2.width, tip1.height * 0.5));
            // tip3.enableOutline(cc.color(255, 255, 255, 255), 1);
            tip1.addChild(tip3, 0, 13);
        }

        tip1.setPosition(cc.p(innerbg.width / 2 - (tip1.width + tip2.width + tip3.width) / 2, innerbg.height * 0.65));

        var tip7 = new ccui.Text("游戏内直冲金币或购买礼包都视为充值", FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (tip7) {
            tip7.setTextAreaSize(cc.size(500, 30));
            tip7.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            tip7.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.35));
            // tip7.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip7, 0, 17);
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
            //self.confirmCallBack();
        }, cc.p(bg.width * 0.5, bg.height * 0.15), UsedResName.iknowbtn);
        //this.addCancelBtn(null, cc.p(bg.width*0.25, bg.height*0.15),"#fish_acbind_11.png");
    },
});

//未认证用户在时间段内无法游戏
var IDverifyDialog1 = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var content1 = new cc.Sprite("#fish_idverify_8.png");
        if (content1) {
            bg.addChild(content1);
            content1.setPosition(bg.width / 2, bg.height * 0.55);
        }

        var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + FishGlobal.idControl.noid.gamecontroltimedown, '0');
        if (count1) {
            content1.addChild(count1);
            count1.setAnchorPoint(cc.p(0.5, 0.5));
            count1.setPosition(cc.p(175, content1.height / 2));
        }

        var count2 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + FishGlobal.idControl.noid.gamecontroltimeup, '0');
        if (count2) {
            content1.addChild(count2);
            count2.setAnchorPoint(cc.p(0.5, 0.5));
            count2.setPosition(cc.p(275, content1.height / 2));
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.15), "#fish_idverify_11.png");
        this.addCancelBtn(null, cc.p(bg.width * 0.25, bg.height * 0.15), "#fish_idverify_15.png");
    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = new IDverifyLayer();
        scene.addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
        FYEngine.popupLayerAnimate(layer.layerbg);
    }
});
//未认证用户超过游戏时长
var IDverifyDialog2 = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var content1 = new cc.Sprite("#fish_idverify_7.png");
        if (content1) {
            bg.addChild(content1);
            content1.setPosition(bg.width / 2, bg.height * 0.55);
        }

        var totaltime = Math.floor((FishGlobal.idControl.noid.totalgametime / (60 * 60)));
        var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + totaltime, '0');
        if (count1) {
            content1.addChild(count1);
            count1.setAnchorPoint(cc.p(0, 0.5));
            count1.setPosition(cc.p(370, content1.height / 2));
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.15), "#fish_idverify_11.png");
        this.addCancelBtn(null, cc.p(bg.width * 0.25, bg.height * 0.15), "#fish_idverify_15.png");
    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = new IDverifyLayer();
        scene.addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
        FYEngine.popupLayerAnimate(layer.layerbg);
    }
});

//未成年用户在时间段内无法游戏
var IDverifyDialog3 = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var content1 = new cc.Sprite("#fish_idverify_6.png");
        if (content1) {
            bg.addChild(content1);
            content1.setPosition(bg.width / 2, bg.height * 0.55);
        }

        var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + FishGlobal.idControl.child.gamecontroltimedown, '0');
        if (count1) {
            content1.addChild(count1);
            count1.setAnchorPoint(cc.p(0.5, 0.5));
            count1.setPosition(cc.p(175, content1.height / 2));
        }

        var count2 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + FishGlobal.idControl.child.gamecontroltimeup, '0');
        if (count2) {
            content1.addChild(count2);
            count2.setAnchorPoint(cc.p(0.5, 0.5));
            count2.setPosition(cc.p(275, content1.height / 2));
        }

        this.addCancelBtn(null, cc.p(bg.width * 0.5, bg.height * 0.15), "#fish_idverify_15.png");
    },

});

//未成年用户超过游戏时长
var IDverifyDialog4 = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var content1 = new cc.Sprite("#fish_idverify_5.png");
        if (content1) {
            bg.addChild(content1);
            content1.setPosition(bg.width / 2, bg.height * 0.55);
        }

        var totaltime = Math.floor((FishGlobal.idControl.child.totalgametime / (60 * 60)));
        var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + totaltime, '0');
        if (count1) {
            content1.addChild(count1);
            count1.setAnchorPoint(cc.p(0, 0.5));
            count1.setPosition(cc.p(370, content1.height / 2));
        }
        this.addCancelBtn(null, cc.p(bg.width * 0.5, bg.height * 0.15), "#fish_idverify_15.png");
    },


});

//成年用户在时间段内无法游戏
var IDverifyDialog5 = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var content1 = new cc.Sprite("#fish_idverify_4.png");
        if (content1) {
            bg.addChild(content1);
            content1.setPosition(bg.width / 2, bg.height * 0.55);
        }

        var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + FishGlobal.idControl.adult.gamecontroltimedown, '0');
        if (count1) {
            content1.addChild(count1);
            count1.setAnchorPoint(cc.p(0.5, 0.5));
            count1.setPosition(cc.p(150, content1.height / 2));
        }

        var count2 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + FishGlobal.idControl.adult.gamecontroltimeup, '0');
        if (count2) {
            content1.addChild(count2);
            count2.setAnchorPoint(cc.p(0.5, 0.5));
            count2.setPosition(cc.p(255, content1.height / 2));
        }

        this.addCancelBtn(null, cc.p(bg.width * 0.5, bg.height * 0.15), "#fish_idverify_15.png");
    },

});

//成年用户超过游戏时长
var IDverifyDialog6 = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var content1 = new cc.Sprite("#fish_idverify_3.png");
        if (content1) {
            bg.addChild(content1);
            content1.setPosition(bg.width / 2, bg.height * 0.55);
        }

        var totaltime = Math.floor((FishGlobal.idControl.adult.totalgametime / (60 * 60)));
        var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + totaltime, '0');
        if (count1) {
            content1.addChild(count1);
            count1.setAnchorPoint(cc.p(0, 0.5));
            count1.setPosition(cc.p(350, content1.height / 2));
        }

        this.addCancelBtn(null, cc.p(bg.width * 0.5, bg.height * 0.15), "#fish_idverify_15.png");
    },


});

/***
 * @param 0:未认证, 1:未成年, 2:成年人
 */
var IDchargerControlDialog = DialogLayer.extend({
    _tag: 0,
    ctor: function (tag) {
        this._super();
        this._tag = tag;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        switch (this._tag) {
            case 0 : {
                var content1 = new cc.Sprite("#fish_idverify_2.png");
                if (content1) {
                    bg.addChild(content1);
                    content1.setPosition(bg.width / 2 - 30, bg.height * 0.55);
                }

                var totaltime = FishGlobal.idControl.noid.totalcharge;
                var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + totaltime, '0');
                if (count1) {
                    content1.addChild(count1);
                    count1.setAnchorPoint(cc.p(0, 0.5));
                    count1.setPosition(cc.p(310, content1.height / 2));
                }
            }
                break;
            case 1: {
                var content1 = new cc.Sprite("#fish_idverify_1.png");
                if (content1) {
                    bg.addChild(content1);
                    content1.setPosition(bg.width / 2 - 45, bg.height * 0.55);
                }

                var totaltime = FishGlobal.idControl.child.totalcharge;
                var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + totaltime, '0');
                if (count1) {
                    content1.addChild(count1);
                    count1.setAnchorPoint(cc.p(0, 0.5));
                    count1.setPosition(cc.p(310, content1.height / 2));
                }
            }
                break;
            case 2: {
                var content1 = new cc.Sprite("#fish_idverify_0.png");
                if (content1) {
                    bg.addChild(content1);
                    content1.setPosition(bg.width / 2 - 45, bg.height * 0.55);
                }

                var totaltime = FishGlobal.idControl.adult.totalcharge;
                var count1 = FYEngine.createAlts("res/updateplayerid/fish_idverify_number.png", 10, "" + totaltime, '0');
                if (count1) {
                    content1.addChild(count1);
                    count1.setAnchorPoint(cc.p(0, 0.5));
                    count1.setPosition(cc.p(285, content1.height / 2));
                }
            }
                break;
            default:
                break;
        }

        var yuansprite = new cc.Sprite("#fish_idverify_10.png");
        if (yuansprite) {
            count1.addChild(yuansprite);
            yuansprite.setAnchorPoint(cc.p(0, 0.5));
            yuansprite.setPosition(cc.p(count1.width + 5, count1.height / 2));
        }


        if (this._tag == 0) {
            var self = this;
            this.addConfirmBtn(function () {
                self.removeFromParent(true);
                self.confirmCallBack();
            }, cc.p(bg.width * 0.75, bg.height * 0.15), "#fish_idverify_11.png");
            this.addCancelBtn(null, cc.p(bg.width * 0.25, bg.height * 0.15), "#fish_idverify_15.png");
        } else {
            this.addCancelBtn(null, cc.p(bg.width * 0.5, bg.height * 0.15), "#fish_idverify_15.png");
        }

    },

    confirmCallBack: function () {
        var scene = FYEngine.getRunningLayer(0);
        var layer = new IDverifyLayer();
        scene.addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
        FYEngine.popupLayerAnimate(layer.layerbg);
    }


});

var WeChatLoginValid = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));


        var tip1 = new ccui.Text(FYEngine.LanguageString.getValue("wechatinvalid"), FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip1) {
            tip1.setAnchorPoint(cc.p(0.5, 0.5));
            // tip1.enableOutline(cc.color(255, 255, 255, 255), 1);
            tip1.setPosition(cc.p(innerbg.width / 2, innerbg.height / 2));
            innerbg.addChild(tip1, 0, 10);
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
            //self.confirmCallBack();
        }, cc.p(bg.width * 0.5, bg.height * 0.15), UsedResName.iknowbtn);
        //this.addCancelBtn(null, cc.p(bg.width*0.25, bg.height*0.15),"#fish_acbind_11.png");
    },
});


var SourceCheckIDLayer = DialogLayer.extend({
    _recount: 60,
    _time: 0,
    _time1: 0,
    _canTouch: true,
    ctor: function () {
        this._super();
        this._recount = 60;
        this._time = 0;
        this._time1 = 0;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg("#fish_idverify_11.png", 654);
        if (appglobal._switch15 == 1) {
            this.addCloseBtn();
        }
        var placeHoldStr = ["请输入身份证号码", "请输入姓名"];

        //var tips = new cc.Sprite('#fish_idverify_18.png');
        //if(tips){
        //    bg.addChild(tips);
        //    tips.setPosition(cc.p(bg.width/2,346));
        //}

        for (var i = 0; i < 2; i++) {

            var passwordbg = new cc.Scale9Sprite(SccomRes.SmallWinRes.Smallbg);
            if (passwordbg) {
                var editBox = cc.EditBox(cc.size(380, 58), passwordbg);
                editBox.setFontSize(22);
                editBox.setPlaceHolder(placeHoldStr[i]);
                editBox.setPlaceholderFontSize(22);
                editBox.setPlaceholderFontColor(cc.color("#7ef0fe"));
                editBox.setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
                if (i == 0) {
                    editBox.setMaxLength(18);
                } else {
                    editBox.setInputFlag(cc.EDITBOX_INPUT_FLAG_INITIAL_CAPS_WORD);
                    editBox.setMaxLength(6);
                }
                editBox.setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
                editBox.setPosition(cc.p(378, 191 + i * 80));
                bg.addChild(editBox, 0, i + 100);
            }

        }

        var name1 = new ccui.Text("身份证", "微软雅黑", 24);
        name1.setColor(cc.color(142, 243, 255));
        if (name1) {
            name1.enableOutline(cc.color(142, 243, 255, 255), 1);
            name1.setPosition(cc.p(170, 191));
            name1.setAnchorPoint(cc.p(1, 0.5));
            bg.addChild(name1);
        }
        var name2 = new ccui.Text("姓    名", "微软雅黑", 24);
        name2.setColor(cc.color(142, 243, 255));
        if (name2) {
            name2.enableOutline(cc.color(142, 243, 255, 255), 1);
            name2.setPosition(cc.p(170, 271));
            name2.setAnchorPoint(cc.p(1, 0.5));
            bg.addChild(name2);
        }


        var useridnumber = bg.getChildByTag(100);
        var username = bg.getChildByTag(101);

        useridnumber.setDelegate({
            editBoxEditingDidBegin: function () {
                useridnumber.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {

            },

            editBoxTextChanged: function (sender) {
                var flag = false;
                var str = sender.getString();
                if (FYEngine.isEmojiCharacter(str)) {
                    flag = true;
                }

                if (flag) {
                    sender.setString("");
                    FYEngine.AddCommToast('身份证中有不支持的字符');
                }
            },

        });
        username.setDelegate({
            editBoxEditingDidBegin: function () {
                username.setPlaceHolder("");
            },
            editBoxEditingDidEnd: function () {

            },

            editBoxTextChanged: function (sender) {
                var flag = false;
                var str = sender.getString();
                if (FYEngine.isEmojiCharacter(str)) {
                    flag = true;
                }

                if (flag) {
                    sender.setString("");
                    FYEngine.AddCommToast('姓名中有不支持的字符');
                }
            },


        });

        var texttip = new ccui.Text("实名认证需要一定时间，请耐心等待", "微软雅黑", 25);
        if (texttip) {
            this.layerbg.addChild(texttip);
            texttip.setPosition(cc.p(bg.width * 0.5, bg.height * 0.33));
        }

        var self = this;
        this.addConfirmBtn(function () {
            self.confirmCallBack();
        }, cc.p(bg.width * 0.5, bg.height * 0.15));


    },

    confirmCallBack: function () {
        var date = new Date();
        var times = cc.sys.localStorage.getItem('idchecktimes' + date.getFullYear() + date.getMonth() + date.getUTCDate());
        if (times && parseInt(times) >= FishGlobal.idControl.idcheckdailytime) {
            FYEngine.AddCommToast('您今天实名认证太多次啦，请明天再试');
            return;
        }
        //cc.log("---times"+times);

        var useridnumber = this.layerbg.getChildByTag(100).getString().toUpperCase();
        var username = this.layerbg.getChildByTag(101).getString();

        if (username.length == 0) {
            FYEngine.AddCommToast("姓名不能为空");
            return;
        }

        //if(useridnumber.length ==0){
        //    FYEngine.AddCommToast("身份证号不能为空");
        //    return;
        //}

        if (username.length < 2) {
            FYEngine.AddCommToast("您的姓名不符合规范，请重新输入");
            return;
        }

        if (/[^\u4e00-\u9fa5]/.test(username)) {
            FYEngine.AddCommToast('您的姓名不符合规范，请重新输入');
            return;
        }

        if (FYEngine.checkIsRealCard(useridnumber) === false) {
            return;
        }


        if (useridnumber.length == 15) {
            useridnumber = FYEngine.IDchangeFivteenToEighteen(useridnumber);
        }


        var loading = FYEngine.CreateAccRelatedLoading();
        if (loading) {
            this.addChild(loading, 100, 'accloading');
        }
        this._time = 0;
        this.schedule(this.timeCount, 1);
        this.sendMSG(username, useridnumber);

    },

    sendMSG: function (username, useridnumber) {
        Http.getMessage(function () {
            var service = formservice("idCardCheck");
            var time = Date.now();
            var uid = {name: "uid", value: ""};
            var name = {name: "name", value: encodeURI(username)};
            var idNo = {name: "idNo", value: useridnumber};
            var imei = {name: "imei", value: appglobal._appCfg.imei};
            var sign = formsign("idCardCheck", time);
            time = formTime(time);
            var checksum = formchecksum(uid.value, idNo.value, imei.value, sign.value, FYEngine.PrivateKey);
            var url = formUrl(appglobal.getFishApiUrl(), "fishService", service, time, uid, name, idNo, imei, sign, checksum);
            cc.log('-------发送验证身份证号请求url:' + url);
            return url;
        }(), null, function (cfgStr) {
            var date = new Date();
            var times = cc.sys.localStorage.getItem('idchecktimes' + date.getFullYear() + date.getMonth() + date.getUTCDate());
            if (times) {
                if (parseInt(times) < FishGlobal.idControl.idcheckdailytime) {
                    var currenttimes = parseInt(times) + 1;
                    cc.sys.localStorage.setItem('idchecktimes' + date.getFullYear() + date.getMonth() + date.getUTCDate(), "" + currenttimes);
                }
            } else {
                cc.sys.localStorage.setItem('idchecktimes' + date.getFullYear() + date.getMonth() + date.getUTCDate(), "1");
            }
            var scene = FYEngine.getRunningLayer(0);
            var layer = scene.getChildByName("loginidcheck");
            if (layer) {
                layer.removeLoading();
                layer.unschedule(layer.timeCount);
            }
            var jsonInfo = eval('(' + cfgStr + ')');
            FYEngine.logObject(jsonInfo, '------获取:');
            var errcode = jsonInfo.code;
            if (errcode != 0) {
                cc.log('-----获取失败');
                var oklayer = scene.getChildByName("SourceCheckIDResultLayer");
                if (!oklayer) {
                    oklayer = new SourceCheckIDResultLayer(1);
                    scene.addChild(oklayer, FishZorder.poplayer, "SourceCheckIDResultLayer");
                }
                //switch(errcode){
                //    case -1 :{//未实名认证
                //
                //    }break;
                //    case 1 :{//实名认证失败
                //        FYEngine.AddCommToast("认证失败，请输入正确的姓名和身份证号");
                //    }break;
                //    case 2 :{//连接实名认证服务器失败
                //        FYEngine.AddCommToast("认证失败，请输入正确的姓名和身份证号");
                //    }break;
                //    case 3 :{//身份证不符合规则
                //        FYEngine.AddCommToast("认证失败，请输入正确的姓名和身份证号");
                //    }break;
                //    case 4 :{
                //        FYEngine.AddCommToast("网络连接超时，请稍后再试");
                //    }break;
                //    default : break;
                //}
            } else {
                if (layer) {
                    layer.removeFromParent(true);
                }
                cc.sys.localStorage.setItem("baiduidcheck", "1");
                var oklayer = scene.getChildByName("SourceCheckIDResultLayer");
                if (!oklayer) {
                    oklayer = new SourceCheckIDResultLayer(0);
                    scene.addChild(oklayer, FishZorder.poplayer, "SourceCheckIDResultLayer");
                }

            }

        });
    },


    removeLoading: function () {
        var loading = this.getChildByName("accloading");
        if (loading) {
            loading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            this.unschedule(this.timeCount);
            var scene = FYEngine.getRunningLayer(0);
            var oklayer = scene.getChildByName("SourceCheckIDResultLayer");
            if (!oklayer) {
                oklayer = new SourceCheckIDResultLayer(2);
                scene.addChild(oklayer, FishZorder.poplayer, "SourceCheckIDResultLayer");
            }
        }
    },

    timeCount1: function (dt) {
        //cc.log('@@@@@@@@@' + this._time);
        this._time1 += dt;
        if (this._time1 > 15) {
            this._time1 = 0;
            FYEngine.AddCommToast("与服务器连接超时，请稍后再试");
            this.unschedule(this.timeCount1);
        }
    },

});

/**
 * type 0 :成功  1:失败  2:超时
 */
var SourceCheckIDResultLayer = DialogLayer.extend({
    type: 0,
    ctor: function (type) {
        this._super();
        this.init(cc.color(0, 0, 0, 100));
        this.type = type;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        var callfunc = function (sender) {
            self.closeCallBack(sender);
        };
        this.addCloseBtn();


        if (this.type == 0) {
            var text = new ccui.Text("恭喜您成功完成了实名认证", "微软雅黑", 35);
            if (text) {
                this.layerbg.addChild(text);
                text.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.62));
                text.enableOutline(cc.color(255, 255, 255, 255), 1)
            }
        } else if (this.type == 1) {
            var date = new Date();
            var times = cc.sys.localStorage.getItem('idchecktimes' + date.getFullYear() + date.getMonth() + date.getUTCDate());
            var word = "";
            if (times && times < FishGlobal.idControl.idcheckdailytime) {
                word = "实名认证失败，您还有" + (FishGlobal.idControl.idcheckdailytime - times) + "次机会";
                var text = new ccui.Text(word, "微软雅黑", 35);
                if (text) {
                    this.layerbg.addChild(text);
                    text.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.62));
                    text.enableOutline(cc.color(255, 255, 255, 255), 1)
                }
            } else {
                word = "实名认证失败，请明天再试";
                var text = new ccui.Text(word, "微软雅黑", 35);
                if (text) {
                    this.layerbg.addChild(text);
                    text.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.62));
                    text.enableOutline(cc.color(255, 255, 255, 255), 1)
                }
            }
        } else if (this.type == 2) {
            var text = new ccui.Text("实名认证超时，请重试", "微软雅黑", 35);
            if (text) {
                this.layerbg.addChild(text);
                text.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.62));
                text.enableOutline(cc.color(255, 255, 255, 255), 1)
            }
        }

        this.addConfirmBtn(callfunc, cc.p(bg.width * 0.5, bg.height * 0.25), "#iknow.png");

    },

    closeCallBack: function () {
        this.removeFromParent(true);
    },

});

var ChangeNickFailLayer = DialogLayer.extend({
    _number: 0,
    ctor: function (number) {
        this._super();
        this._number = number;
        this.init(cc.color(0, 0, 0, 100));
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addInnerBg(cc.size(600, 200));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        var callfunc = function (sender) {
            self.closeCallBack(sender);
        };
        this.addCloseBtn();

        var m_text = "还需充值{0}元可解锁昵称修改功能".format(this._number);
        var text = new ccui.Text(m_text, "微软雅黑", 30);
        if (text) {
            text.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            text.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            text.setTextAreaSize(cc.size(500, 90));
            this.layerbg.addChild(text);
            text.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.55));
            text.enableOutline(cc.color(255, 255, 255, 255), 1)
        }

        this.addConfirmBtn(callfunc, cc.p(bg.width * 0.5, bg.height * 0.15), "#iknow.png");

    },

    closeCallBack: function () {
        this.removeFromParent(true);
    },

});

var HeChengLayer = DialogLayer.extend({
    _isClose: false,
    _listview: null,
    ctor: function () {
        this._super();
        this.init(cc.color(0, 0, 0, 100));
        this.initData();
        this.initUI();
        this.getListInfo();
    },

    initData: function () {
        this._isClose = false;
        this._listview = null;
    },

    getListInfo: function () {
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle && handle._canSendNormalMsg) {
            handle.sendHechengListReq();
        }
    },

    initUI: function () {
        var self = this;
        var layerbg = this.layerbg = new ccui.ImageView(SccomRes.MallRes.Outerbg, ccui.Widget.PLIST_TEXTURE);
        if (layerbg) {
            this.addChild(layerbg, 0, "layerbg");
            layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
            layerbg.setScale9Enabled(true);
            layerbg.setContentSize(cc.size(965, 550));
        }

        var title = new cc.Sprite("#fish_copy_35.png");
        if (title) {
            layerbg.addChild(title, 0, "title");
            title.setPosition(cc.p(layerbg.width / 2, layerbg.height + 10));
        }

        var btn_close = new ccui.Button(FishSceneRes.DialogPng.BackBtnUp, FishSceneRes.DialogPng.BackBtnDowm, '', ccui.Widget.PLIST_TEXTURE);
        if (btn_close) {
            btn_close.setPosition(this.layerbg.width * 0.97, this.layerbg.height * 0.95);
            this.layerbg.addChild(btn_close, 0, "btn_close");
            btn_close.addClickEventListener(function () {
                FYEngine.popoutLayerAnimate(self.layerbg);
            });
        }

        var rightbg = new ccui.ImageView("fish_copy_32.png", ccui.Widget.PLIST_TEXTURE);
        if (rightbg) {
            this.layerbg.addChild(rightbg, 1, "rightbg");
            rightbg.setPosition(cc.p(835, this.layerbg.height / 2));
        }


        var labelname = ["beike", "haixing", "shanhu", "shuijing", "zhenzhu"];
        for (var i = 0; i < 5; ++i) {
            var labgold = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
            labgold.setPosition(cc.p(860, 395 - i * 63));
            labgold.setAnchorPoint(cc.p(0.5, 0.5));
            this.layerbg.addChild(labgold, 1, "" + labelname[i]);
        }

        var btncall = function (sender) {
            self.soldCallBack(sender);
        };
        var btn_sold = new ccui.ImageView("fish_copy_29.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_sold) {
            rightbg.addChild(btn_sold, 0, "btn_sold");
            btn_sold.setPosition(cc.p(rightbg.width / 2, 46));
            btn_sold.setTouchEnabled(true);
            btn_sold.addTouchEventListener(this.btnTouchEft, this);
            btn_sold.addClickEventListener(btncall);
        }

        // var listview = FYEngine.createListView(cc.size(850, 410), cc.p(this.layerbg.width / 2, 240), cc.p(0.5, 0.5), 10, ccui.ScrollView.DIR_HORIZONTAL);
        // if (listview) {
        //     this.layerbg.addChild(listview, 1, "listview");
        //     this._listview = listview;
        //     listview.setScrollBarEnabled(false);
        // }

        this.updateWealth();
    },

    initListViewItems: function (data) {
        cc.log("initListViewItems");
        // for (var i = 0; i < data.length; ++i) {
        //     FishGlobal.copyToolArry.push(data[i]);
        //     if (data[i].iHechengId < 1000) {
        //         var box = new HechengListItem(i, data[i]);
        //         if (box) {
        //             box.setAnchorPoint(cc.p(0.5, 0.5));
        //             this._listview.pushBackCustomItem(box);
        //         }
        //     }
        // }

        for (var i = 0; i < data.length; ++i) {
            FishGlobal.copyToolArry.push(data[i]);
            if (data[i].iHechengId < 1000) {
                var box = new HechengListItem(i, data[i]);
                if (box) {
                    box.setAnchorPoint(cc.p(0.5, 0.5));
                    this.layerbg.addChild(box, 0, "box" + i);
                    box.setPosition(cc.p(200 + i * 350, this.layerbg.height / 2 - 5));
                }
            }
        }
    },

    failGetListItem: function () {
        cc.log("获取列表失败");
        FYEngine.AddCommToast("暂无熔炼列表");
    },

    soldCallBack: function (sender) {
        var scene = FYEngine.getRunningLayer(0);
        var layer = new CopySelectSoldLayer();
        if (layer) {
            scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.CopySelectSoldLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    },

    updateWealth: function () {
        var player = appglobal.getPlayer();
        this.layerbg.getChildByName("beike").setString(player.beike);
        this.layerbg.getChildByName("haixing").setString(player.haixing);
        this.layerbg.getChildByName("shanhu").setString(player.shanhu);
        this.layerbg.getChildByName("shuijing").setString(player.shuijing);
        this.layerbg.getChildByName("zhenzhu").setString(player.zhenzhu);

    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

});

var HechengListItem = ccui.ImageView.extend({
    _item: 0,
    _info: {},
    _status: 0,
    ctor: function (i, info) {
        this._super();
        this._item = i;
        this._info = info;
        this.loadTexture("fish_copy_15.png", ccui.Widget.PLIST_TEXTURE);
        this.initUI();
    },

    initUI: function () {
        var self = this;
        if (this._info.iCount > 0) {
            var targetinfo = FishGlobal.getCoinInfo(this._info.content[0].iCoinType);
            var target = new ccui.ImageView("" + targetinfo.picname, ccui.Widget.PLIST_TEXTURE);
            if (target) {
                if (targetinfo.picname == "intergral50.png") {
                    target.setScale(0.7);
                }
                this.addChild(target, 0, "target");
                target.setPosition(cc.p(170, 285));

            }

            var targettip = new ccui.Text("" + this._info.content[0].iCoinCount + targetinfo.name, "微软雅黑", 22);
            if (targettip) {
                targettip.setPosition(cc.p(this.width / 2, 225));
                targettip.enableOutline(cc.color(255, 255, 255, 255), 1);
                this.addChild(targettip, 1, 100);
            }

            var spposition = [cc.p(170, 400), cc.p(65, 185), cc.p(275, 185)];
            var spposition1 = [cc.p(170, 355), cc.p(65, 140), cc.p(275, 140)];

            for (var i = 0; i < this._info.iCount - 1; ++i) {
                var spinfo = FishGlobal.getCoinInfo(this._info.content[i + 1].iCoinType);
                var sp = new ccui.ImageView("" + spinfo.picname, ccui.Widget.PLIST_TEXTURE);
                if (sp) {


                    this.addChild(sp, 0, "sp" + i);
                    sp.setPosition(spposition[i]);
                }

                var spnum = FYEngine.createAlts(CommResource.selfNum_png, 12, this._info.content[i + 1].iCoinCount, '.');
                if (spnum) {
                    this.addChild(spnum, 1, "spnum" + i);
                    spnum.setPosition(spposition1[i]);
                }

            }
        }

        var btncall = function (sender) {
            self.combineTool(sender);

        };

        var btn_comb = new ccui.ImageView(SccomRes.MallRes.Boxbtn, ccui.Widget.PLIST_TEXTURE);
        if (btn_comb) {
            this.addChild(btn_comb, 1, "btn_comb");
            btn_comb.setTouchEnabled(true);
            btn_comb.setPosition(cc.p(this.width / 2, 44));
            btn_comb.addTouchEventListener(this.btnTouchEft, this);
            btn_comb.addClickEventListener(btncall);

            var btntip = new ccui.ImageView("fish_copy_18.png", ccui.Widget.PLIST_TEXTURE);
            if (btntip) {
                btn_comb.addChild(btntip, 0, "btntip");
                btntip.setPosition(cc.p(btn_comb.width / 2, btn_comb.height * 0.55));
            }
        }
    },

    combineTool: function (sender) {
        cc.log("熔炼");

        var scene = FYEngine.getRunningLayer(0);
        var layer = new HechengConfirmLayer(this._info);
        if (layer) {
            scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.HechengConfirmLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    },


    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

});


var HechengConfirmLayer = DialogLayer.extend({
    _time: 0,
    _info: {},
    _needbeike: 0,
    _needshuijing: 0,
    _needshanhu: 0,
    _needhaixing: 0,
    _needzhenzhu: 0,
    _cannum: 10000000,

    ctor: function (info) {
        this._super();
        this._info = info;
        this.initData();
        this.init(cc.color(0, 0, 0, 100), 1136, 640);
        this.initUI();


    },

    initData: function () {
        this._cannum = 1000000000;
        for (var i = 1; i < this._info.iCount; ++i) {
            if (this._info.content[i].iCoinType == FishGlobal.WealthType.beike) {
                this._needbeike = this._info.content[i].iCoinCount;
            } else if (this._info.content[i].iCoinType == FishGlobal.WealthType.shuijing) {
                this._needshuijing = this._info.content[i].iCoinCount;
            } else if (this._info.content[i].iCoinType == FishGlobal.WealthType.shanhu) {
                this._needshanhu = this._info.content[i].iCoinCount;
            } else if (this._info.content[i].iCoinType == FishGlobal.WealthType.haixing) {
                this._needhaixing = this._info.content[i].iCoinCount;
            } else if (this._info.content[i].iCoinType == FishGlobal.WealthType.zhenzhu) {
                this._needzhenzhu = this._info.content[i].iCoinCount;
            }
        }

    },

    initUI: function () {
        var self = this;
        this.addLayerBg(cc.size(630, 340));

        var innerBg = this.innerBg = FYEngine.createImageView(FishSceneRes.DialogPng.InnerBg,
            cc.p(this.layerbg.width / 2, 240), cc.p(0.5, 0.5), cc.size(565, 70));
        this.layerbg.addChild(innerBg, 0, "innerbg");

        this.addTitleBg('#fish_copy_8.png', 645);
        this.addCloseBtn();

        var text2 = FYEngine.createText("合成数量:", '微软雅黑', 30, 1);
        if (text2) {
            text2.setAnchorPoint(cc.p(1, 0.5));
            text2.setPosition(cc.p(200, this.layerbg.height / 2 - 10));
            text2.setTextColor(cc.color("8ef3ff"));
            this.layerbg.addChild(text2, 1, "text2");
        }

        var text3 = new ccui.Text("当前材料最多可合成:", '微软雅黑', 30, 1);
        if (text3) {
            text3.setAnchorPoint(cc.p(0, 0.5));
            text3.enableOutline(cc.color("003e7e"), 2);
            this.layerbg.addChild(text3, 2, "text3");

            var text4 = this._text4 = FYEngine.createText("0个", '微软雅黑', 30, 0);
            if (text4) {
                text4.setAnchorPoint(cc.p(0, 0.5));
                text4.setPosition(cc.p(text3.width + 2, text3.height / 2));
                text4.setTextColor(cc.color("fbfe02"));
                text3.addChild(text4);
            }
            text3.setPosition(cc.p(this.layerbg.width / 2 - (text3.width + text4.width) / 2, 240));
        }

        var edit2 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(300, 42), cc.EDITBOX_INPUT_MODE_NUMERIC,
            '合成数量', cc.color(255, 255, 255), cc.color(0, 51, 89), 20, 6);
        if (edit2) {
            edit2.setFontColor(cc.color(255, 255, 255));
            edit2.setPosition(cc.p(360, this.layerbg.height / 2 - 10));
            this.layerbg.addChild(edit2, 2, "editbox");

            var delegate2 = {
                editBoxEditingDidBegin: function () {
                    edit2.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit2.getString();
                    if (str == "") {
                        edit2.setPlaceHolder("合成数量");
                    }
                },
                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }
            };
            edit2.setDelegate(delegate2);
        }

        this.addConfirmBtn(function (sender) {
            self.confirmCallBack(sender);
        }, cc.p(this.layerbg.width * 0.5, this.layerbg.height * 0.24));
        this.updateWealth();

    },

    updateWealth: function () {
        var player = appglobal.getPlayer();
        this._cannum = 1000000000;
        for (var i = 1; i < this._info.iCount; ++i) {
            if (this._info.content[i].iCoinType == FishGlobal.WealthType.beike) {

                var canbeike = Math.floor(player.beike / this._info.content[i].iCoinCount);
                if (canbeike <= this._cannum) {
                    this._cannum = canbeike;
                }
            } else if (this._info.content[i].iCoinType == FishGlobal.WealthType.shuijing) {

                var canshuijing = Math.floor(player.shuijing / this._info.content[i].iCoinCount);
                if (canshuijing <= this._cannum) {
                    this._cannum = canshuijing;
                }
            } else if (this._info.content[i].iCoinType == FishGlobal.WealthType.shanhu) {

                var canshanhu = Math.floor(player.shanhu / this._info.content[i].iCoinCount);
                if (canshanhu <= this._cannum) {
                    this._cannum = canshanhu;
                }
            } else if (this._info.content[i].iCoinType == FishGlobal.WealthType.haixing) {

                var canhaixing = Math.floor(player.haixing / this._info.content[i].iCoinCount);
                if (canhaixing <= this._cannum) {
                    this._cannum = canhaixing;
                }
            } else if (this._info.content[i].iCoinType == FishGlobal.WealthType.zhenzhu) {

                var canzhenzhu = Math.floor(player.zhenzhu / this._info.content[i].iCoinCount);
                if (canzhenzhu <= this._cannum) {
                    this._cannum = canzhenzhu;
                }
            }
        }

        if (this._text4) {
            this._text4.setString("" + this._cannum + "个");
        }
    },

    confirmCallBack: function () {
        var edit2 = this.layerbg.getChildByName("editbox");
        var qty = edit2.getString();
        if (this.checkIsAcceptabel()) {
            this.addLoading();
            var handle = CoreServiceProxy.getInstance().getGameHandler();
            if (handle && handle._canSendNormalMsg) {
                handle.sendHechengReq(qty, this._info.iHechengId, 1);
            }
            this._time = 0;
            this.schedule(this.timeCount, 1);
        }

    },

    checkIsAcceptabel: function () {
        var edit2 = this.layerbg.getChildByName("editbox");
        var mqty = edit2.getString();
        var player = appglobal.getPlayer();
        if (mqty == "") {
            FYEngine.AddCommToast("合成数量不能为空");
            return false;
        }

        if (Number(mqty) > 500000) {
            FYEngine.AddCommToast("每次合成数量不能超过500000");
            return false;
        }

        if (Number(mqty) <= 0) {
            FYEngine.AddCommToast("合成数量不能为0");
            return false;
        }
        if (Number(mqty) > this._cannum) {
            FYEngine.AddCommToast("最多可合成{0}个".format(this._cannum));
            return false;
        }
        if ((Number(mqty) * this._needbeike > player.beike) ||
            (Number(mqty) * this._needshuijing > player.shuijing) ||
            (Number(mqty) * this._needshanhu > player.shanhu) ||
            (Number(mqty) * this._needhaixing > player.haixing) ||
            (Number(mqty) * this._needzhenzhu > player.zhenzhu)) {
            FYEngine.AddCommToast("道具数量不足");
            return false;
        }

        return true;
    },

    addLoading: function () {
        var size = cc.winSize;
        var layer = new cc.LayerColor(cc.color(0, 0, 0, 0), size.width, size.height);
        var touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            }
        });

        cc.eventManager.addListener(touchListener, layer);
        var loadingBg = new cc.Sprite('#crystal56.png');
        if (loadingBg) {
            layer.addChild(loadingBg);
            loadingBg.setPosition(cc.p(layer.width / 2, layer.height / 2));

            var circle = new cc.Sprite("#crystal55.png");
            if (circle) {
                loadingBg.addChild(circle);
                circle.setPosition(cc.p(loadingBg.width / 2, loadingBg.height / 2));
                var rotate = new cc.RotateBy(0.3, 30);
                circle.runAction(new cc.RepeatForever(rotate));
            }
        }
        this.addChild(layer, 100);
        this._layerLoading = layer;
    },

    removeLoading: function () {
        if (this._layerLoading) {
            this._layerLoading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
//        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    }
});

var HechengSucessLayer = DialogLayer.extend({
    _info: null,
    ctor: function (info) {
        this._super();
        this._info = info;
        this.init(cc.color(0, 0, 0, 100), 1136, 640);
        this.addResource();
        this.initUI();
    },

    addResource: function () {// todo 资源加载整理
        cc.director.getTextureCache().addImage("res/turnTable/turn_table.png");
        cc.spriteFrameCache.addSpriteFramesWithFile("res/turnTable/turn_table.plist");
    },

    initUI: function () {
        var self = this;
        var prolist = FishGlobal.getCopyToolItem(this._info.iHechengId);
        var targetinfo = FishGlobal.getCoinInfo(prolist.content[0].iCoinType);

        var layerbg = this.layerbg = new ccui.Layout();
        if (layerbg) {
            this.addChild(layerbg, 0, "layerbg");
            layerbg.setAnchorPoint(cc.p(0.5, 0.5));
            layerbg.setContentSize(cc.size(1136, 640));
            layerbg.setBackGroundColorType(ccui.Layout.BG_COLOR_NONE);
            layerbg.setPosition(cc.p(cc.winSize.width / 2, cc.winSize.height / 2));
        }

        var lightbg = new cc.Sprite(TurnTableDialog.ImgName.reward);
        if (lightbg) {
            layerbg.addChild(lightbg, 0, "lightbg");
            lightbg.setPosition(layerbg.width / 2, layerbg.height / 2);
            lightbg.runAction(cc.sequence(cc.rotateBy(1, 45)).repeatForever());
        }

        var title = new cc.Sprite(TurnTableDialog.ImgName.rewardTitle);
        if (title) {
            layerbg.addChild(title, 0, "title");
            title.setPosition(cc.p(layerbg.width / 2, 520));

            var titlename = new cc.Sprite("#fish_copy_16.png");
            if (titlename) {
                title.addChild(titlename, 0, "titlename");
                titlename.setPosition(cc.p(title.width / 2, title.height * 0.7));
            }
        }


        var propic = new ccui.ImageView(targetinfo.picname, ccui.Widget.PLIST_TEXTURE);
        if (propic) {
            layerbg.addChild(propic, 1, "propic");
            propic.setPosition(cc.p(layerbg.width / 2, layerbg.height / 2));

        }

        var totalcount = this._info.iCount * prolist.content[0].iCoinCount;
        var Count = new ccui.TextAtlas("/" + totalcount, TurnTableDialog.ImgName.turnTableNum, 32, 42, "/");
        if (Count) {
            layerbg.addChild(Count, 1, "Count");
            Count.setPosition(cc.p(layerbg.width / 2, 190));
        }


        this.addConfirmBtn(function (sender) {
            self.confirmCallBack(sender);
        }, cc.p(this.layerbg.width * 0.5, this.layerbg.height * 0.15));

    },

    confirmCallBack: function () {
        this.removeFromParent(true);
    },
});

var CopySelectSoldLayer = DialogLayer.extend({
    _listview: null,
    ctor: function () {
        var self = this;
        this._super();
        var bg = this.addLayerBg(cc.size(462, 500));
        var titleBigBg = FYEngine.createImageView(FishSceneRes.DialogPng.TitleBigBG,
            cc.p(bg.width / 2, bg.height * 0.95), null, cc.size(490, 73), cc.rect(100, 0, 490 - 200, 73));
        bg.addChild(titleBigBg, 0, 3);

        var titleName = FYEngine.createSprite("#fish_copy_99.png", cc.p(titleBigBg.width / 2, titleBigBg.height * 0.56));
        titleBigBg.addChild(titleName, 0, 2);

        this.addCloseBtn();

        var listview = FYEngine.createListView(cc.size(400, 400), cc.p(bg.width / 2, bg.height * 0.4 + 20), cc.p(0.5, 0.5), 14, ccui.ScrollView.DIR_VERTICAL);
        if (listview) {
            this._listview = listview;
            bg.addChild(listview, 1, 'list');
            listview.setScrollBarEnabled(false);
        }


        var ttag = [6, 9, 8, 7, 10];
        for (var i = 0; i < 5; ++i) {
            var box = new CopyClassBox(ttag[i]);
            if (box) {
                box.setAnchorPoint(cc.p(0.5, 0.5));
                listview.pushBackCustomItem(box);
            }
        }
    },

    updateWealth: function () {
        if (this._listview) {
            for (var i = 0; i < 5; ++i) {
                var item = this._listview.getItem(i);
                item.updateWealth();
            }
        }
    }
});


var CopyClassBox = ccui.ImageView.extend({
    _item: 0,
    ctor: function (i) {
        var self = this;
        this._super();
        this._item = i;
        this.loadTexture(SccomRes.RewardRes.Dialog, ccui.Widget.PLIST_TEXTURE);
        this.setScale9Enabled(true);
        this.setTouchEnabled(true);
        this.setContentSize(cc.size(399, this.getContentSize().height));
        this.initUI();
        this.addClickEventListener(function (sender) {
            self.soldCallBack(sender);
        })
    },

    soldCallBack: function () {
        cc.log("---" + this._item);
        var scene = FYEngine.getRunningLayer(0);
        var layer = new CopySoldInfoLayer(this._item);
        if (layer) {
            scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.CopySoldInfoLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }
    },

    initUI: function () {
        var framename = "";
        var name = "";
        var qty = 0;
        var player = appglobal.getPlayer();
        if (this._item == FishGlobal.WealthType.beike) {
            framename = "fish_copy_27.png";
            name = "贝壳";
            qty = player.beike;
        } else if (this._item == FishGlobal.WealthType.shuijing) {
            framename = "fish_copy_26.png";
            name = "水晶";
            qty = player.shuijing;
        } else if (this._item == FishGlobal.WealthType.shanhu) {
            framename = "fish_copy_28.png";
            name = "珊瑚";
            qty = player.shanhu;
        } else if (this._item == FishGlobal.WealthType.haixing) {
            framename = "fish_copy_24.png";
            name = "海星";
            qty = player.haixing;
        } else if (this._item == FishGlobal.WealthType.zhenzhu) {
            framename = "fish_copy_25.png";
            name = "珍珠";
            qty = player.zhenzhu;
        }

        var pro = new ccui.ImageView(framename, ccui.Widget.PLIST_TEXTURE);
        if (pro) {
            this.addChild(pro, 0, "pro");
            pro.setScale(0.5);
            pro.setPosition(cc.p(50, this.height / 2 + 5));
        }

        var proname = new ccui.Text("" + name, "微软雅黑", 30);
        if (proname) {
            this.addChild(proname, 0, "proname");
            proname.setColor(cc.color("6b3110"));
            proname.setAnchorPoint(cc.p(0, 0.5));
            proname.setPosition(cc.p(80, this.height / 2 + 5));
        }

        var proqty = this._qty = new ccui.Text("" + qty, "微软雅黑", 30);
        if (proqty) {
            this.addChild(proqty, 0, "proqty");
            proqty.setColor(cc.color("fd4302"));
            proqty.setAnchorPoint(cc.p(1, 0.5));
            proqty.setPosition(cc.p(350, this.height / 2 + 5));
        }
    },

    updateWealth: function () {
        if (this._qty) {
            var qty = 0;
            var player = appglobal.getPlayer();
            if (this._item == FishGlobal.WealthType.beike) {
                qty = player.beike;
            } else if (this._item == FishGlobal.WealthType.shuijing) {
                qty = player.shuijing;
            } else if (this._item == FishGlobal.WealthType.shanhu) {
                qty = player.shanhu;
            } else if (this._item == FishGlobal.WealthType.haixing) {
                qty = player.haixing;
            } else if (this._item == FishGlobal.WealthType.zhenzhu) {
                qty = player.zhenzhu;
            }
            this._qty.setString("" + qty);
        }
    }
});

var CopySoldInfoLayer = DialogLayer.extend({
    _time: 0,
    _item: 0,
    _price: 0,
    _info: {},
    ctor: function (item) {
        this._super();
        this._item = item;
        this.initData();
        this.init(cc.color(0, 0, 0, 100), 1136, 640);
        this.initUI();
    },

    initData: function () {

    },

    initUI: function () {
        var self = this;
        this.addLayerBg(cc.size(630, 440));

        var innerBg = this.innerBg = FYEngine.createImageView(FishSceneRes.DialogPng.InnerBg,
            cc.p(this.layerbg.width / 2, 310), cc.p(0.5, 0.5), cc.size(565, 125));
        this.layerbg.addChild(innerBg, 0, "innerbg");

        this.addTitleBg('#crystal04.png', 645);
        this.addCloseBtn();

        var pinfo = this._info = FishGlobal.getCopyToolItem(this._item + 1000);
        var price = this._price = pinfo.content[0].iCoinCount;

        var framename = "";
        var name = "";
        var qty = 0;
        var player = appglobal.getPlayer();
        if (this._item == FishGlobal.WealthType.beike) {
            framename = "fish_copy_27.png";
            name = "贝壳";
            qty = player.beike;
        } else if (this._item == FishGlobal.WealthType.shuijing) {
            framename = "fish_copy_26.png";
            name = "水晶";
            qty = player.shuijing;
        } else if (this._item == FishGlobal.WealthType.shanhu) {
            framename = "fish_copy_28.png";
            name = "珊瑚";
            qty = player.shanhu;
        } else if (this._item == FishGlobal.WealthType.haixing) {
            framename = "fish_copy_24.png";
            name = "海星";
            qty = player.haixing;
        } else if (this._item == FishGlobal.WealthType.zhenzhu) {
            framename = "fish_copy_25.png";
            name = "珍珠";
            qty = player.zhenzhu;
        }

        var pro = new ccui.ImageView(framename, ccui.Widget.PLIST_TEXTURE);
        if (pro) {
            innerBg.addChild(pro, 0, "pro");
            pro.setPosition(cc.p(150, innerBg.height / 2));
        }

        var proname = new ccui.Text("当前拥有" + name, "微软雅黑", 30);
        if (proname) {
            innerBg.addChild(proname, 0, "proname");
            //proname.setColor(cc.color("6b3110"));
            proname.enableOutline(cc.color("003e7e"), 2);
            proname.setAnchorPoint(cc.p(0, 0.5));
            proname.setPosition(cc.p(215, 80));
        }

        var proqty = this._qty = new FYEngine.createAlts('res/num/fish_number.png', 12, qty, '.');
        if (proqty) {
            proqty.setPosition(cc.p(215, 40));
            proqty.setAnchorPoint(cc.p(0, 0.5));
            innerBg.addChild(proqty, 1, 'labgold');
        }


        var text3 = new ccui.Text("出售单价:", '微软雅黑', 30, 1);
        if (text3) {
            text3.setAnchorPoint(cc.p(1, 0.5));
            text3.setTextColor(cc.color("8ef3ff"));
            text3.setPosition(cc.p(200, 210));
            this.layerbg.addChild(text3, 2, "text3");

            var sp1 = new ccui.ImageView("hall82.png", ccui.Widget.PLIST_TEXTURE);
            if (sp1) {
                this.layerbg.addChild(sp1, 2, "sp1");
                sp1.setAnchorPoint(cc.p(0, 0.5));
                sp1.setPosition(cc.p(210, 210));

            }


            var text4 = FYEngine.createAlts('res/num/fish_number.png', 12, price, '.');
            text4.setPosition(cc.p(sp1.width + 10, sp1.height / 2));
            text4.setAnchorPoint(cc.p(0, 0.5));
            sp1.addChild(text4, 1, 'labgold');

        }

        var text2 = new ccui.Text("出售数量:", '微软雅黑', 30);
        if (text2) {
            text2.setAnchorPoint(cc.p(1, 0.5));
            text2.setPosition(cc.p(200, this.layerbg.height / 2 - 70));
            text2.setTextColor(cc.color("8ef3ff"));
            this.layerbg.addChild(text2, 1, "text2");
        }

        var edit2 = FYEngine.createEditBox(SmallLayerRes.Smallbg, cc.size(300, 42), cc.EDITBOX_INPUT_MODE_NUMERIC,
            '输入数量', cc.color(255, 255, 255), cc.color(0, 51, 89), 20, 6);
        if (edit2) {
            edit2.setFontColor(cc.color(255, 255, 255));
            edit2.setPosition(cc.p(360, this.layerbg.height / 2 - 70));
            this.layerbg.addChild(edit2, 2, "editbox");

            var delegate2 = {
                editBoxEditingDidBegin: function () {
                    edit2.setPlaceHolder("");
                },
                editBoxEditingDidEnd: function () {
                    var str = edit2.getString();
                    if (str == "") {
                        edit2.setPlaceHolder("输入数量");
                    }
                },
                editBoxTextChanged: function (text) {
                    var value = text.getString();
//                    cc.log(value+'---------文本改变了---');
                    if (/[^0-9]/.test(value)) {
                        value = value.replace(new RegExp(/[^0-9]/g), "");
//                        cc.log(value+'---------文本改变了2---');
                        text.setString(value);
                    }
                }
            };
            edit2.setDelegate(delegate2);
        }

        this.addConfirmBtn(function (sender) {
            self.confirmCallBack(sender);
        }, cc.p(this.layerbg.width * 0.5, this.layerbg.height * 0.15));

    },

    confirmCallBack: function () {
        var edit2 = this.layerbg.getChildByName("editbox");
        var qty = edit2.getString();
        if (this.checkIsAcceptabel()) {
            this.addLoading();
            var handle = CoreServiceProxy.getInstance().getGameHandler();
            if (handle && handle._canSendNormalMsg) {
                handle.sendHechengReq(qty, this._info.iHechengId, 2);
            }
            this._time = 0;
            this.schedule(this.timeCount, 1);
        }

    },

    checkIsAcceptabel: function () {
        var edit2 = this.layerbg.getChildByName("editbox");
        var mqty = edit2.getString();
        var player = appglobal.getPlayer();
        if (mqty == "") {
            FYEngine.AddCommToast("出售数量不能为空");
            return false;
        }

        if (Number(mqty) <= 0) {
            FYEngine.AddCommToast("出售数量不能为0");
            return false;
        }

        var totalnumer = Number(mqty);

        if (totalnumer > 500000) {
            FYEngine.AddCommToast("每次出售道具数量不能超过500000");
            return false;
        }
        if (this._item == FishGlobal.WealthType.beike) {
            if (totalnumer > player.beike) {
                FYEngine.AddCommToast("道具数量不足");
                return false;
            }
        } else if (this._item == FishGlobal.WealthType.shuijing) {
            if (totalnumer > player.shuijing) {
                FYEngine.AddCommToast("道具数量不足");
                return false;
            }
        } else if (this._item == FishGlobal.WealthType.shanhu) {
            if (totalnumer > player.shanhu) {
                FYEngine.AddCommToast("道具数量不足");
                return false;
            }
        } else if (this._item == FishGlobal.WealthType.haixing) {
            if (totalnumer > player.haixing) {
                FYEngine.AddCommToast("道具数量不足");
                return false;
            }
        } else if (this._item == FishGlobal.WealthType.zhenzhu) {
            if (totalnumer > player.zhenzhu) {
                FYEngine.AddCommToast("道具数量不足");
                return false;
            }
        }

        return true;
    },

    addLoading: function () {
        var size = cc.winSize;
        var layer = new cc.LayerColor(cc.color(0, 0, 0, 0), size.width, size.height);
        var touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            }
        });

        cc.eventManager.addListener(touchListener, layer);
        var loadingBg = new cc.Sprite('#crystal56.png');
        if (loadingBg) {
            layer.addChild(loadingBg);
            loadingBg.setPosition(cc.p(layer.width / 2, layer.height / 2));

            var circle = new cc.Sprite("#crystal55.png");
            if (circle) {
                loadingBg.addChild(circle);
                circle.setPosition(cc.p(loadingBg.width / 2, loadingBg.height / 2));
                var rotate = new cc.RotateBy(0.3, 30);
                circle.runAction(new cc.RepeatForever(rotate));
            }
        }
        this.addChild(layer, 100);
        this._layerLoading = layer;
    },

    removeLoading: function () {
        if (this._layerLoading) {
            this._layerLoading.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
//        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

    updateWealth: function () {
        if (this._qty) {
            var qty = 0;
            var player = appglobal.getPlayer();
            if (this._item == FishGlobal.WealthType.beike) {
                qty = player.beike;
            } else if (this._item == FishGlobal.WealthType.shuijing) {
                qty = player.shuijing;
            } else if (this._item == FishGlobal.WealthType.shanhu) {
                qty = player.shanhu;
            } else if (this._item == FishGlobal.WealthType.haixing) {
                qty = player.haixing;
            } else if (this._item == FishGlobal.WealthType.zhenzhu) {
                qty = player.zhenzhu;
            }
            this._qty.setString("" + qty);
        }
    }
});

var ConfirmEnter = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);

        var innerBg = this.addInnerBg(cc.size(586, 220));


        var roominfo = FishGlobal.getCopyRoomConfById(FishGlobal.roomId - 1);
        var upname = "进入初级场需要";
        var fennum = roominfo.iExpendScore;
        if (FishGlobal.roomId == 1) {
            upname = "进入初级场需要";

        } else if (FishGlobal.roomId == 2) {
            upname = "进入中级场需要";

        } else {
            upname = "进入高级场需要";
        }
        var tip = new ccui.Text(upname, "微软雅黑", 30);
        if (tip) {
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.6));
            innerBg.addChild(tip, 0, "tip");
        }

        var tip2 = new ccui.Text("消耗积分", "微软雅黑", 30);
        if (tip2) {
            tip2.setAnchorPoint(cc.p(0, 0.5));
            innerBg.addChild(tip2, 0, "tip2");

            var tip3 = new ccui.Text("" + fennum, "微软雅黑", 30);
            if (tip3) {
                tip3.setTextColor(cc.color("8ef3ff"));
                tip3.setAnchorPoint(cc.p(0, 0.5));
                tip3.setPosition(cc.p(tip2.width, tip2.height / 2));
                tip2.addChild(tip3, 0, "tip3");
            }

            var tip4 = new ccui.Text("，是否进入？", "微软雅黑", 30);
            if (tip4) {
                tip4.setAnchorPoint(cc.p(0, 0.5));
                tip4.setPosition(cc.p(tip2.width + tip3.width, tip2.height / 2));
                tip2.addChild(tip4, 0, "tip4");
            }
            tip2.setPosition(cc.p(innerBg.width / 2 - (tip2.width + tip3.width + tip4.width) / 2, innerBg.height * 0.4));
        }

        this.addCloseBtn();

        this.addCancelBtn(function (sender) {
            FYEngine.popoutLayerAnimate(self.layerbg);
        }, cc.p(bg.width * 0.3, bg.height * 0.15));

        this.addConfirmBtn(function (sender) {
            self.enterCallBack(sender);
        }, cc.p(bg.width * 0.7, bg.height * 0.15));
    },

    enterCallBack: function () {
        var player = appglobal.getPlayer();
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.getName() == "fishcopylobby") {
            if (player.score < FishGlobal.getCopyRoomConfById(FishGlobal.roomId - 1).iExpendScore) {
                this.removeFromParent(true);
                var layer = scene.getChildByName(FishCopyLobbyLayer.ScoreNotEnoughLayer);
                if (!layer) {
                    layer = new ScoreNotEnoughLayer();
                    scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.ScoreNotEnoughLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            } else {
                scene.createLoading();
                scene.scheduleOnce(scene.joinTableCheck, 15);
                var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
                if (gamehandle && gamehandle._canSendNormalMsg) {
                    gamehandle.sendJoinTabelReq(FishGlobal.roomId);
                }
            }
        }
    },
});

var ScoreNotEnoughLayer = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);

        var innerBg = this.addInnerBg(cc.size(586, 220));


        var tip = new ccui.Text("积分不足，无法进入\n积分可从普通渔场捕鱼获得", "微软雅黑", 30);
        if (tip) {
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerBg.addChild(tip, 0, 10);
        }

        this.addCloseBtn();
        this.addConfirmBtn(function () {
            FYEngine.popoutLayerAnimate(self.layerbg);
        }, cc.p(bg.width * 0.5, bg.height * 0.2 - 15));
    }
});

var CopyTimeOutLayer = DialogLayer.extend({
    _recount: 10,
    _type: 0, //0：钱不够  1：时间到
    _mtext: "",
    ctor: function (type) {
        this._super();
        this._recount = 10;
        this._type = type;
        this.initUI();
    },

    initUI: function () {
        if (this._type == 1) {
            this._mtext = "副本时间结束，{0}秒后返回大厅";
        } else {
            this._mtext = "金币不足，将在{0}秒后返回大厅";
        }
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        var innerBg = this.addInnerBg(cc.size(586, 220));
        var tip = new ccui.Text(this._mtext.format(this._recount), "微软雅黑", 30);
        if (tip) {
            this._tip = tip;
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerBg.addChild(tip, 0, 10);
        }
        this.addConfirmBtn(this.backToLobby, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        cc.log("test1");
        this.schedule(this.myRecountFun, 1, 9);
        FishGlobal.copyTimeControl.copyGameLeftTime = 0;
        cc.sys.localStorage.setItem('copyRecordTime' + appglobal.getPlayer().userid, JSON.stringify(FishGlobal.copyTimeControl));
        var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
        if (gamehandle && gamehandle._canSendNormalMsg) {
            gamehandle.sendLeaveTableReq();
        }
    },

    myRecountFun: function () {
        this._recount -= 1;
        if (this._recount > 0) {
            this._tip.setString(this._mtext.format(this._recount));
        } else {
            this._recount = 0;
            this.unschedule(this.myRecountFun);
            this.backToLobby();
        }
    },

    backToLobby: function () {
        var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
        if (gamehandle) {
            var gamelayer = FYEngine.getRunningLayer(0);
            gamelayer.exitGame();
        }
    },
});

var DailyChargeOverTip = DialogLayer.extend({
    _info: {},
    _type: false,
    ctor: function (info,type) {
        this._super();
        this._info = info;
        this._type = false;
        if (type) {
            this._type = true;
        }
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerBg = this.addInnerBg(cc.size(586, 220));


        var tip1 = "未实名认证用户每日充值限额";
        if (this._info.iShenfenType == 0) {
            tip1 = "未实名认证用户每日充值限额";

            var cancelBtn = new cc.Sprite("#hall01.png");
            if (cancelBtn) {
                cancelBtn.setPosition(cc.p(bg.width * 0.3, bg.height * 0.2 - 15));
                this.layerbg.addChild(cancelBtn, 0, "cancelbtn");
                FYEngine.AddNodeTouchListener(cancelBtn, function (sender) {
                    self.removeFromParent(true);
                    var layer = new IDverifyLayer();
                    FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }, FYEngine.ActionType.Fade);
            }
            this.addConfirmBtn(undefined, cc.p(bg.width * 0.7, bg.height * 0.2 - 20), UsedResName.iknowbtn);
        } else if (this._info.iShenfenType == 1) {
            tip1 = "未成年用户每日充值限额";
            this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 20), UsedResName.iknowbtn);
        } else if (this._info.iShenfenType == 2) {
            tip1 = "每日充值限额";
            this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 20), UsedResName.iknowbtn);
        }

        var rich1 = new ccui.RichText();
        if (rich1) {
            innerBg.addChild(rich1, 0, "rich1");
            rich1.setPosition(cc.p(innerBg.width / 2, 180));
            if (this._type) {
                var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "每日充值限额已达上限", "", 30);
                rich1.pushBackElement(mtxt1);
            } else {
                var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, tip1, "", 30);
                rich1.pushBackElement(mtxt1);

                var mtxt2 = new ccui.RichElementText(2, cc.color("08f9e6"), 255, "" + this._info.iDayLimitMoney, "", 30);
                rich1.pushBackElement(mtxt2);

                var mtxt3 = new ccui.RichElementText(3, cc.color.WHITE, 255, "元", "", 30);
                rich1.pushBackElement(mtxt3);
            }

        }

        var rich2 = new ccui.RichText();
        if (rich2) {
            innerBg.addChild(rich2, 0, "rich2");
            rich2.setPosition(cc.p(innerBg.width / 2, 120));

            var ntxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "（您已充值", "", 26);
            rich2.pushBackElement(ntxt1);

            var ntxt2 = new ccui.RichElementText(2, cc.color("08f9e6"), 255, "" + this._info.iDayChargeMoney, "", 26);
            rich2.pushBackElement(ntxt2);

            var ntxt3 = new ccui.RichElementText(3, cc.color.WHITE, 255, "元，还可充值", "", 26);
            rich2.pushBackElement(ntxt3);

            var leftmoney = this._info.iDayLimitMoney - this._info.iDayChargeMoney;
            var ntxt4 = new ccui.RichElementText(4, cc.color("08f9e6"), 255, "" + leftmoney, "", 26);
            rich2.pushBackElement(ntxt4);

            var ntxt5 = new ccui.RichElementText(5, cc.color.WHITE, 255, "元）", "", 26);
            rich2.pushBackElement(ntxt5);
        }

        var text2 = FYEngine.createText("充值限额在每日的0点刷新", '微软雅黑', 26);
        if (text2) {
            innerBg.addChild(text2, 1, "text2");
            text2.setAnchorPoint(cc.p(0.5, 0.5));
            text2.setPosition(cc.p(innerBg.width / 2, 60));
            text2.setTextColor(cc.color("fffcbc"));
        }
    }
});


var AvoidGameLostTip = DialogLayer.extend({
    _time: {},
    ctor: function (time) {
        this._super();
        this._time = time;
        this.initUI(time);
    },

    initUI: function (time) {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 470));
        this.addTitleBg("#hall02.png", 658);
        this.addCloseBtn();
        var innerBg = this.addInnerBg(cc.size(586, 285));
        var player = appglobal.getPlayer();
        if (player.realIDnumber == "") {
            if (time < FishGlobal.lostTime.controllevel1) {
                this.addNoidTime1(time);
            } else {
                this.addNoidTime2(time);
            }
        } else {
            if (time < FishGlobal.lostTime.controllevel1) {
                this.addChildHourTime1(time);
            } else {
                this.addChildHourTime2(time);
            }
        }

    },

    refreshUI: function (time) {
        var cancelbtn = this.layerbg.getChildByName("cancelbtn");
        if (cancelbtn) {
            cancelbtn.removeFromParent(true);
        }
        var confirmbtn = this.layerbg.getChildByTag(5);
        if (confirmbtn) {
            confirmbtn.removeFromParent(true);
        }
        this.innerBg.removeAllChildren();
        var player = appglobal.getPlayer();
        if (player.realIDnumber == "") {
            if (time < FishGlobal.lostTime.controllevel1) {
                this.addNoidTime1(time);
            } else {
                this.addNoidTime2(time);
            }
        } else {
            if (time < FishGlobal.lostTime.controllevel1) {
                this.addChildHourTime1(time);
            } else {
                this.addChildHourTime2(time);
            }
        }
    },

    addNoidTime1: function (time) {
        var self = this;
        var rich1 = new ccui.RichText();
        if (rich1) {
            this.innerBg.addChild(rich1, 0, "rich1");
            rich1.setPosition(cc.p(this.innerBg.width / 2, 220));
            var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "您累计在线时间已满", "", 30);
            rich1.pushBackElement(mtxt1);

            var realtime = Math.floor(time / 60);
            var mtxt2 = new ccui.RichElementText(2, cc.color("08f9e6"), 255, realtime + "小时", "", 30);
            rich1.pushBackElement(mtxt2);
        }

        var text2 = FYEngine.createText("为预防青少年过度游戏，未满18岁的用户将受到防沉迷系统的限制。\n年龄已满18周岁的玩家，在填写身份资料后，可以不受防沉迷系统的影响，自由进行游戏", '微软雅黑', 26);
        if (text2) {
            this.innerBg.addChild(text2, 1, "text2");
            text2.setAnchorPoint(cc.p(0.5, 0.5));
            text2.setPosition(cc.p(this.innerBg.width / 2, 90));
            text2.setTextAreaSize(cc.size(530, 170));
        }

        var cancelBtn = new cc.Sprite("#hall01.png");
        if (cancelBtn) {
            cancelBtn.setPosition(cc.p(this.layerbg.width * 0.3, this.layerbg.height * 0.2 - 25));
            this.layerbg.addChild(cancelBtn, 0, "cancelbtn");
            FYEngine.AddNodeTouchListener(cancelBtn, function (sender) {
                self.removeFromParent(true);
                var player = appglobal.getPlayer();
                var scene = FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(LobbySceneName.IDverifyLayer);
                if (layer) {
                    layer.removeFromParent(true);
                }
                if (player.realIDnumber == "") {
                    var layer1 = new IDverifyLayer();
                    scene.addChild(layer1, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer1.layerbg);
                } else {
                    var layer1 = new IDverifyShowLayer();
                    scene.addChild(layer1, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer1.layerbg);
                }
            }, FYEngine.ActionType.Fade);
        }
        this.addConfirmBtn(undefined, cc.p(this.layerbg.width * 0.7, this.layerbg.height * 0.2 - 30), UsedResName.iknowbtn);
    },

    addNoidTime2: function (time) {
        cc.log("addNoidTime2" + time);
        var self = this;
        var tip1 = "";
        var tip2 = "";
        var tip3 = "";
        if (time == FishGlobal.lostTime.controllevel1) {
            tip1 = "您累计在线时间已满";
            tip2 = "3小时";
            tip3 = "您已进入疲劳游戏时间，您的游戏收益将降为正常值的50%，为了您的健康，请尽快下线休息，做适当身体活动，合理安排学习生活！";
        } else if (time > FishGlobal.lostTime.controllevel1 && time < FishGlobal.lostTime.controllevel2) {
            tip1 = "您累计在线时间已超过";
            tip2 = "3小时";
            tip3 = "您已进入疲劳游戏时间，您的游戏收益将降为正常值的50%，为了您的健康，请尽快下线休息，做适当身体活动，合理安排学习生活！";
        } else if (time == FishGlobal.lostTime.controllevel2) {
            tip1 = "您累计在线时间已满";
            tip2 = "5小时";
            tip3 = "您已进入不健康游戏时间，为了您的健康，请您立即下线休息。如不下线，您的身体将受到损害，您的收益已降为零";
        } else if (time > FishGlobal.lostTime.controllevel2) {
            tip1 = "您累计在线时间已超过";
            tip2 = "5小时";
            tip3 = "您已进入不健康游戏时间，为了您的健康，请您立即下线休息。如不下线，您的身体将受到损害，您的收益已降为零";
        }
        var rich1 = new ccui.RichText();
        if (rich1) {
            this.innerBg.addChild(rich1, 0, "rich1");
            rich1.setPosition(cc.p(this.innerBg.width / 2, 190));
            rich1.setContentSize(cc.size(530, 120));
            rich1.ignoreContentAdaptWithSize(false);
            rich1.formatText();
            var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, tip1, "", 30);
            rich1.pushBackElement(mtxt1);

            var mtxt2 = new ccui.RichElementText(2, cc.color("08f9e6"), 255, tip2, "", 30);
            rich1.pushBackElement(mtxt2);

            var mtxt3 = new ccui.RichElementText(3, cc.color.WHITE, 255, "，请您下线休息，做适当身体活动！", "", 30);
            rich1.pushBackElement(mtxt3);
        }

        var text2 = FYEngine.createText(tip3, '微软雅黑', 26);
        if (text2) {
            this.innerBg.addChild(text2, 1, "text2");
            text2.setAnchorPoint(cc.p(0.5, 0.5));
            text2.setPosition(cc.p(this.innerBg.width / 2, 80));
            text2.setTextAreaSize(cc.size(530, 130));
        }

        var cancelBtn = new cc.Sprite("#hall01.png");
        if (cancelBtn) {
            cancelBtn.setPosition(cc.p(this.layerbg.width * 0.3, this.layerbg.height * 0.2 - 25));
            this.layerbg.addChild(cancelBtn, 0, "cancelbtn");
            FYEngine.AddNodeTouchListener(cancelBtn, function (sender) {
                self.removeFromParent(true);
                var player = appglobal.getPlayer();
                var scene = FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(LobbySceneName.IDverifyLayer);
                if (layer) {
                    layer.removeFromParent(true);
                }
                if (player.realIDnumber == "") {
                    var layer1 = new IDverifyLayer();
                    scene.addChild(layer1, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer1.layerbg);
                } else {
                    var layer1 = new IDverifyShowLayer();
                    scene.addChild(layer1, FishZorder.poplayer, LobbySceneName.IDverifyLayer);
                    FYEngine.popupLayerAnimate(layer1.layerbg);
                }
            }, FYEngine.ActionType.Fade);
        }
        this.addConfirmBtn(undefined, cc.p(this.layerbg.width * 0.7, this.layerbg.height * 0.2 - 30), UsedResName.iknowbtn);
    },

    addChildHourTime1: function (time) {
        var rich1 = new ccui.RichText();
        if (rich1) {
            this.innerBg.addChild(rich1, 0, "rich1");
            rich1.setPosition(cc.p(this.innerBg.width / 2, 200));
            var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "您累计在线时间已满", "", 30);
            rich1.pushBackElement(mtxt1);
            var realtime = Math.floor(time / 60);
            var mtxt2 = new ccui.RichElementText(2, cc.color("08f9e6"), 255, realtime + "小时", "", 30);
            rich1.pushBackElement(mtxt2);
        }

        var text2 = FYEngine.createText("为预防青少年过度游戏，未满18岁的用户将受到防沉迷系统的限制", '微软雅黑', 26);
        if (text2) {
            this.innerBg.addChild(text2, 1, "text2");
            text2.setAnchorPoint(cc.p(0.5, 0.5));
            text2.setPosition(cc.p(this.innerBg.width / 2, 80));
            text2.setTextAreaSize(cc.size(530, 110));
        }

        this.addConfirmBtn(undefined, cc.p(this.layerbg.width * 0.5, this.layerbg.height * 0.2 - 25), UsedResName.iknowbtn);
    },

    addChildHourTime2: function (time) {
        var tip1 = "";
        var tip2 = "";
        var tip3 = "";
        if (time == FishGlobal.lostTime.controllevel1) {
            tip1 = "您累计在线时间已满";
            tip2 = "3小时";
            tip3 = "您已进入疲劳游戏时间，您的游戏收益将降为正常值的50%，为了您的健康，请尽快下线休息，做适当身体活动，合理安排学习生活！";
        } else if (time > FishGlobal.lostTime.controllevel1 && time < FishGlobal.lostTime.controllevel2) {
            tip1 = "您累计在线时间已超过";
            tip2 = "3小时";
            tip3 = "您已进入疲劳游戏时间，您的游戏收益将降为正常值的50%，为了您的健康，请尽快下线休息，做适当身体活动，合理安排学习生活！";
        } else if (time == FishGlobal.lostTime.controllevel2) {
            tip1 = "您累计在线时间已满";
            tip2 = "5小时";
            tip3 = "您已进入不健康游戏时间，为了您的健康，请您立即下线休息。如不下线，您的身体将受到损害，您的收益已降为零";
        } else if (time > FishGlobal.lostTime.controllevel2) {
            tip1 = "您累计在线时间已超过";
            tip2 = "5小时";
            tip3 = "您已进入不健康游戏时间，为了您的健康，请您立即下线休息。如不下线，您的身体将受到损害，您的收益已降为零";
        }
        var rich1 = new ccui.RichText();
        if (rich1) {
            this.innerBg.addChild(rich1, 0, "rich1");
            rich1.setPosition(cc.p(this.innerBg.width / 2, 190));
            rich1.setContentSize(cc.size(530, 120));
            rich1.ignoreContentAdaptWithSize(false);
            rich1.formatText();
            var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, tip1, "", 30);
            rich1.pushBackElement(mtxt1);

            var mtxt2 = new ccui.RichElementText(2, cc.color("08f9e6"), 255, tip2, "", 30);
            rich1.pushBackElement(mtxt2);

            var mtxt3 = new ccui.RichElementText(3, cc.color.WHITE, 255, "，为保护青少年过度沉迷，请您下线休息，做适当身体活动！", "", 30);
            rich1.pushBackElement(mtxt3);
        }

        var text2 = FYEngine.createText(tip3, '微软雅黑', 26);
        if (text2) {
            this.innerBg.addChild(text2, 1, "text2");
            text2.setAnchorPoint(cc.p(0.5, 0.5));
            text2.setPosition(cc.p(this.innerBg.width / 2, 60));
            text2.setTextAreaSize(cc.size(530, 130));
        }

        this.addConfirmBtn(undefined, cc.p(this.layerbg.width * 0.5, this.layerbg.height * 0.2 - 25), UsedResName.iknowbtn);
    },
});

var OverLoseLayer = DialogLayer.extend({
    _type: 0,//1 :每月超过上限
    ctor: function (type) {
        this._super();
        this._type = type;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn(function () {
            self.removeFromParent(true);
        });
        var innerBg = this.addInnerBg(cc.size(586, 220));


        var sp = "";
        if (this._type == 1) {
            sp = '您本月输分已达到上限' + FishGlobal.loseMoneyLimit.monthlevel + '分，请下个月再玩吧'
        } else {
            sp = '您今日输分已达到上限' + FishGlobal.loseMoneyLimit.dailylevel + '分，请明日再玩吧'
        }
        var tip = new ccui.Text(sp, '微软雅黑', 30);
        if (tip) {
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.5));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            tip.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
            tip.setTextAreaSize(cc.size(540, 100));
            innerBg.addChild(tip, 0, 10);
        }
        this.addConfirmBtn(function () {
            self.removeFromParent(true);
        }, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
    }
});

var NewIntergralResultLayer = DialogLayer.extend({
    count: 0,
    ctor: function (count) {
        this._super();
        this.count = count;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        var innerBg = this.addInnerBg(cc.size(586, 220));

        if (appglobal._switch20) {
            this.switchNormal();
        } else {
            this.switchClose();
        }

    },

    switchNormal: function () {
        var self = this;
        var rich1 = new ccui.RichText();
        if (rich1) {

            this.innerBg.addChild(rich1, 0, "rich1");
            rich1.setAnchorPoint(cc.p(0,0.5));
            rich1.setPosition(cc.p(this.innerBg.width / 2-250, 150));

            var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "本次捕鱼额外获得", "", 30);
            rich1.pushBackElement(mtxt1);

            var mtxt2 = new ccui.RichElementText(2, cc.color("02fef5"), 255, "" + this.count + '积分', "", 30);
            rich1.pushBackElement(mtxt2);
        }

        var rich2 = new ccui.RichText();
        if (rich2) {
            this.innerBg.addChild(rich2, 0, "rich2");
            rich2.setAnchorPoint(cc.p(0,0.5));
            rich2.setPosition(cc.p(this.innerBg.width / 2-250, 120));

            var ntxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "积分可通过参与", "", 30);
            rich2.pushBackElement(ntxt1);

            var ntxt2 = new ccui.RichElementText(2, cc.color("02fef5"), 255, "积分兑换", "", 30);
            rich2.pushBackElement(ntxt2);

            var ntxt3 = new ccui.RichElementText(2, cc.color.WHITE, 255, "、", "", 30);
            rich2.pushBackElement(ntxt3);

            var ntxt4 = new ccui.RichElementText(2, cc.color("02fef5"), 255, "积分游戏", "", 30);
            rich2.pushBackElement(ntxt4);

            var ntxt5 = new ccui.RichElementText(2, cc.color.WHITE, 255, "或", "", 30);
            rich2.pushBackElement(ntxt5);

        }

        var rich3 = new ccui.RichText();
        if (rich3) {
            this.innerBg.addChild(rich3, 0, "rich3");
            rich3.setAnchorPoint(cc.p(0,0.5));
            rich3.setPosition(cc.p(this.innerBg.width / 2-250, 85));

            var itxt1 = new ccui.RichElementText(1, cc.color("02fef5"), 255, "海神副本", "", 30);
            rich3.pushBackElement(itxt1);

            var itxt2 = new ccui.RichElementText(2, cc.color.WHITE, 255, "来获取奖券和弹头奖励", "", 30);
            rich3.pushBackElement(itxt2);

        }



        var underline1 = new ccui.ImageView("fish_copy_98.png", ccui.Widget.PLIST_TEXTURE);
        if (underline1) {
            this.innerBg.addChild(underline1, 1, "underline1");
            underline1.setScale9Enabled(true);
            underline1.setContentSize(cc.size(125, 4));
            underline1.setPosition(cc.p(314, 102));
        }

        var underline2 = new ccui.ImageView("fish_copy_98.png", ccui.Widget.PLIST_TEXTURE);
        if (underline2) {
            this.innerBg.addChild(underline2, 1, "underline2");
            underline2.setScale9Enabled(true);
            underline2.setContentSize(cc.size(125, 4));
            underline2.setPosition(cc.p(468, 102));
        }

        var underline3 = new ccui.ImageView("fish_copy_98.png", ccui.Widget.PLIST_TEXTURE);
        if (underline3) {
            this.innerBg.addChild(underline3, 1, "underline3");
            underline3.setScale9Enabled(true);
            underline3.setContentSize(cc.size(125, 4));
            underline3.setPosition(cc.p(104, 62));
        }

        var btngojifen = new ccui.ImageView();
        if (btngojifen) {
            this.innerBg.addChild(btngojifen, 10, 'btngojifen');
            btngojifen.setTouchEnabled(true);
            btngojifen.setScale9Enabled(true);
            btngojifen.setPosition(this.innerBg.width / 2+15, 120);
            btngojifen.setContentSize(cc.size(120, 50));
            btngojifen.addClickEventListener(function (sender) {
                self.goJifen(sender);
            });
        }

        var btngocopy = new ccui.ImageView();
        if (btngocopy) {
            this.innerBg.addChild(btngocopy, 10, 'btngocopy');
            btngocopy.setTouchEnabled(true);
            btngocopy.setScale9Enabled(true);
            btngocopy.setPosition(this.innerBg.width / 2-185, 80);
            btngocopy.setContentSize(cc.size(120, 50));
            btngocopy.addClickEventListener(function (sender) {
                self.goCopy(sender);
            });
        }

        var btngojifengame = new ccui.ImageView();
        if (btngojifengame) {
            this.innerBg.addChild(btngojifengame, 10, 'btngojifengame');
            btngojifengame.setTouchEnabled(true);
            btngojifengame.setScale9Enabled(true);
            btngojifengame.setPosition(this.innerBg.width / 2+170, 120);
            btngojifengame.setContentSize(cc.size(120, 50));
            btngojifengame.addClickEventListener(function (sender) {
                self.goJifenGame(sender);
            });
        }

    },

    switchClose: function () {
        var self = this;
        var rich1 = new ccui.RichText();
        if (rich1) {
            this.innerBg.addChild(rich1, 0, "rich1");
            rich1.setAnchorPoint(cc.p(0,0.5));
            rich1.setPosition(cc.p(this.innerBg.width / 2-250, 155));

            var mtxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "本次捕鱼额外获得", "", 30);
            rich1.pushBackElement(mtxt1);

            var mtxt2 = new ccui.RichElementText(2, cc.color("02fef5"), 255, this.count + '积分', "", 30);
            rich1.pushBackElement(mtxt2);
        }

        var rich2 = new ccui.RichText();
        if (rich2) {
            this.innerBg.addChild(rich2, 0, "rich2");
            rich2.setAnchorPoint(cc.p(0,0.5));
            rich2.setPosition(cc.p(this.innerBg.width / 2-250, 120));

            var ntxt1 = new ccui.RichElementText(1, cc.color.WHITE, 255, "积分可通过参与", "", 30);
            rich2.pushBackElement(ntxt1);

            var ntxt2 = new ccui.RichElementText(2, cc.color("02fef5"), 255, "积分游戏", "", 30);
            rich2.pushBackElement(ntxt2);

            var ntxt3 = new ccui.RichElementText(2, cc.color.WHITE, 255, "或", "", 30);
            rich2.pushBackElement(ntxt3);

            var ntxt4 = new ccui.RichElementText(2, cc.color("02fef5"), 255, "海神副本", "", 30);
            rich2.pushBackElement(ntxt4);
        }

        var rich3 = new ccui.RichText();
        if (rich3) {
            this.innerBg.addChild(rich3, 0, "rich3");
            rich3.setAnchorPoint(cc.p(0,0.5));
            rich3.setPosition(cc.p(this.innerBg.width / 2-250, 85));

            var itxt2 = new ccui.RichElementText(1, cc.color.WHITE, 255, "来获取奖券和弹头奖励", "", 30);
            rich3.pushBackElement(itxt2);
        }


        var underline1 = new ccui.ImageView("fish_copy_98.png", ccui.Widget.PLIST_TEXTURE);
        if (underline1) {
            this.innerBg.addChild(underline1, 1, "underline1");
            underline1.setScale9Enabled(true);
            underline1.setContentSize(cc.size(125, 4));
            underline1.setPosition(cc.p(314, 102));
        }

        var underline2 = new ccui.ImageView("fish_copy_98.png", ccui.Widget.PLIST_TEXTURE);
        if (underline2) {
            this.innerBg.addChild(underline2, 1, "underline2");
            underline2.setScale9Enabled(true);
            underline2.setContentSize(cc.size(125, 4));
            underline2.setPosition(cc.p(468, 102));
        }

        var btngocopy = new ccui.ImageView();
        if (btngocopy) {
            this.innerBg.addChild(btngocopy, 10, 'btngocopy');
            btngocopy.setTouchEnabled(true);
            btngocopy.setScale9Enabled(true);
            btngocopy.setPosition(this.innerBg.width / 2+170, 120);
            btngocopy.setContentSize(cc.size(120, 50));
            btngocopy.addClickEventListener(function (sender) {
                self.goCopy(sender);
            });
        }

        var btngojifengame = new ccui.ImageView();
        if (btngojifengame) {
            this.innerBg.addChild(btngojifengame, 10, 'btngojifengame');
            btngojifengame.setTouchEnabled(true);
            btngojifengame.setScale9Enabled(true);
            btngojifengame.setPosition(this.innerBg.width / 2+15, 120);
            btngojifengame.setContentSize(cc.size(120, 50));
            btngojifengame.addClickEventListener(function (sender) {
                self.goJifenGame(sender);
            });
        }

    },

    goJifen: function () {
        cc.log("打开积分商城");
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        var layer = new IntergralMallLayer();
        if (layer) {
            scene.addChild(layer, FishZorder.poplayer, LobbySceneName.IntergralLayer);
            FYEngine.popupLayerAnimate(layer.layerbg, undefined, undefined, cc.p(layer.width / 2, layer.height * 0.4 + 30));
        }
    },

    goCopy: function () {
        cc.log("打开海参副本");
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        FishGlobal.roomId = 4;
        scene.createLoading();
        scene.loadFish();
        scene.scheduleOnce(scene.joinTableCheck, 15);
    },

    goJifenGame : function(){
        this.removeFromParent(true);
        FYEngine.runScene(GameNewLobby.createScene());
    },
});

var CopyGameGuideLayer = DialogLayer.extend({
    _isClose: false,
    ctor: function () {
        this._super();
        this._isClose = false;
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(850, 535));
        this.addTitleBg(FishSceneRes.DialogPng.TitleHelp, 860);
        this.addCloseBtn();

        // var tip1 = new ccui.ImageView("fish_copy_0.png",ccui.Widget.PLIST_TEXTURE);
        // if(tip1){
        //     this.layerbg.addChild(tip1,1,"tip1");
        //     tip1.setPosition(cc.p(this.layerbg.width/2,380));
        // }

        var listview = FYEngine.createListView(cc.size(770, 430), cc.p(this.layerbg.width / 2, 260), cc.p(0.5, 0.5), 5, ccui.ScrollView.DIR_VERTICAL);
        if (listview) {
            this.layerbg.addChild(listview, 1, "listview");
            listview.setScrollBarEnabled(false);

            var tip1 = new ccui.ImageView("fish_copy_0.png", ccui.Widget.PLIST_TEXTURE);
            if (tip1) {
                listview.pushBackCustomItem(tip1);
            }

            for (var i = 0; i < FishGlobal.copyHelpConf.length; ++i) {
                var item = new copyGameGuideItem(FishGlobal.copyHelpConf[i]);
                if (item) {
                    listview.pushBackCustomItem(item);
                }
            }
        }
    },

});

var copyGameGuideItem = ccui.ImageView.extend({

    _info: {},
    ctor: function (info) {
        this._super();
        this._info = info;
        this.loadTexture("fish_copy_1.png", ccui.Widget.PLIST_TEXTURE);
        this.initUI();
    },

    initUI: function () {
        cc.log("copyGameGuideItem");
        var fishpic = new ccui.ImageView('fish' + FishGlobal.getFishClientType(this._info.servertype) + '_0.png', ccui.Widget.PLIST_TEXTURE);
        if (fishpic) {
            this.addChild(fishpic, 1, "fishpic");
            fishpic.setPosition(cc.p(90, this.height * 0.55));
            fishpic.setScale(this._info.scalerate);
        }

        var name = new ccui.Text("" + this._info.name, '微软雅黑', 30);
        if (name) {
            name.setPosition(cc.p(150, this.height * 0.55));
            name.setAnchorPoint(cc.p(0, 0.5));
            name.setTextColor(cc.color("91533a"));
            this.addChild(name, 0, "name");
        }

        var reward = new ccui.Text("随机掉落" + this._info.reward, '微软雅黑', 30);
        if (reward) {
            reward.setTextColor(cc.color("002b39"));
            reward.setPosition(cc.p(345, this.height * 0.55));
            reward.setAnchorPoint(cc.p(0, 0.5));
            this.addChild(reward, 0, "reward");
        }
    },
});

var ExitCopy = DialogLayer.extend({
    _tag:1,
    ctor: function (tag) {
        this._super();
        if(tag){
            this._tag = 0;
        }else{
            this._tag = 1;
        }
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));
        this.addConfirmBtn(function (sender) {
            self.confirmCallBack(sender);
        }, cc.p(bg.width * 0.72, bg.height * 0.15));
        this.addCancelBtn(null, cc.p(bg.width * 0.31, bg.height * 0.15));

        var tip = new ccui.Text("您是否返回捕鱼大厅？", "", 26);
        if (tip) {
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.5));
            //tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

    confirmCallBack: function () {
        if(this._tag == 0){
            FYEngine.runScene(LobbyLayer.createScene());
            return;
        }
        var scene = FYEngine.getRunningLayer(0);
        if (scene) {
            scene.createLoading();
        }
        var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
        if (gamehandle && gamehandle._canSendNormalMsg) {
            gamehandle.sendPlayerLogoutRequest();
        }

        var lobbyHandle = CoreServiceProxy.getInstance().getLobbyHandler();
        if (lobbyHandle && lobbyHandle._canSendNormalMsg) {
            lobbyHandle.sendBackToLobbyRequest();
        }

        this.runAction(new cc.Sequence(new cc.DelayTime(0.5), new cc.CallFunc(function () {
            FYEngine.runScene(LobbyLayer.createScene());
        })));
    }

});

var ChargeProtect = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(586, 220));

        this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);

        var tip = new ccui.Text("您今日充值已达上限", "", 30);
        if (tip) {
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.6));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

});

var GoldNotEnough = DialogLayer.extend({
    ctor: function (money) {
        this._super();
        this.initUI(money);
    },

    initUI: function (money) {
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        var innerbg = this.addInnerBg(cc.size(586, 220));
        var msg = "您还需要{0}金币才能进入该房间".format(money);
        cc.log("money" + money);
        var tip = new ccui.Text(msg, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setTextVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER);
            tip.setPosition(cc.p(innerbg.width / 2, innerbg.height * 0.55));
            // tip.enableOutline(cc.color(255, 255, 255, 255), 1);
            innerbg.addChild(tip, 0, 10);
        }
    },

});

var UserAgreementLayer = DialogLayer.extend({
    ctor: function () {

        this._super();
        this.initUI();

    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(950, 570));
        this.addTitleBg("#fish_vip_res31.png", 960);
        var innerbg = this.addInnerBg(cc.size(870, 390));
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width / 2, bg.height * 0.12));

        var scrollView = new ccui.ScrollView();
        scrollView.setScrollBarEnabled(false);
        scrollView.setContentSize(840, 385);
        scrollView.setAnchorPoint(cc.p(0.5, 0.5));
        scrollView.setPosition(cc.p(innerbg.width / 2, innerbg.height / 2));
        innerbg.addChild(scrollView);


        var mstr = "欢迎使用本公司的游戏服务，请您（以下可称“用户”“玩家”或“您”）仔细阅读以下条款：如您未满18周岁，请在法定监护人的陪同下阅读本协议。本协议系您与本公司之间所订立的权利义务规范。如果您对本协议的任何条款或本公司随时对其的修改表示异议，您可以选择不进入本游戏；进入本游戏或者使用本公司服务，则意味着您同意遵守本协议的全部约定，包括本公司对协议随时所做的任何修改，并完全服从本公司的统一管理。\n一、定义\n1.1本协议：指本协议正文及其修订版本、本游戏的规则及其修订版本。本协议同时还包括文化部依据《网络游戏管理暂行办法》（文化部令第49号）制定的《网络游戏服务格式化协议必备条款》（详见附录）。\n1.2游戏规则：指本公司不时发布并修订的关于游戏的用户协议、游戏规则、游戏公告及通知、指引、说明等内容。\n1.3您：又称“玩家”或“用户”，指接受本公司服务的自然人。\n1.4游戏数据：指您在使用本公司服务过程中产生的并存储于服务器的各种数据信息，包括游戏日志、安全日志等。\n二、账号\n2.1请您妥善保管您的各类账户和密码，确保账户安全。如您将账户、密码转让、出售或出借予他人使用，或授权他人使用账号，应对被授权人在该账号下发生所有行为负全部责任，本公司对您前述行为所造成的任何后果，不承担任何法律责任。\n2.2如果本公司在今后自建账号体系，则账户的所有权归本公司，您在完成注册申请手续后，仅获得本公司账户的使用权。您应提供及时、详尽及准确的个人资料，并不断更新注册信息。因注册信息不真实而导致的问题及后果，本公司对此不负任何责任。因黑客行为等第三方因素或用户自身原因导致的账号安全问题，本公司对受影响玩家不承担任何法律责任。\n2.3您应当通过真实身份信息认证注册账号，且您提交的账号名称、头像和简介等注册信息中不得出现违法和不良信息，经本公司审核，如存在上述情况，本公司将不予注册；同时，在注册后如发现您以虚假信息骗取账号名称注册，或账号头像、简介等注册信息存在违法和不良信息的，本公司有权不经通知单方采取限制改正、暂停使用、注销登记、收回等措施。 \n2.4您如果需要使用和享受本公司服务，您需要按照《网络游戏管理暂行规定》及文化部《网络游戏服务格式化协议必备条款》的要求，登录实名注册系统并进行实名注册。 \n2.5您充分理解并同意：本公司会按照国家相关要求将您的实名注册信息运用于防沉迷系统中，及本公司可能会根据您的实名注册信息判断您是否年满18周岁，从而决定是否对您的游戏账号予以防沉迷限制。并且，若您未满18周岁，本公司 会根据有关规则及您家长的要求对您的账户进行限制。 \n2.6如果您长期连续未登录，您在游戏内的游戏数据可能会由于技术原因被删除，对此本公司不承担任何责任。\n三、本公司服务\n3.1本公司将向您提供本游戏作为休闲娱乐之用，本公司严禁一切形式的赌博和其他违法犯罪活动。请您适度游戏，本公司将与您共同打造绿色的休闲平台\n3.2在您遵守本协议及相关法律法规的前提下，本公司给予您一项不可转让及非排他性的许可，以使用本公司服务。您使用本公司服务仅可以非商业目的的使用，包括： \n（1）接收、下载、安装、启动、升级、登录、显示、运行本游戏； \n（2）创建游戏角色，设置角色名、查阅游戏规则、用户个人资料； \n（3）使用本游戏支持并允许的其他某一项或几项功能。 \n3.3您在使用本公司的收费功能时，应当按照本公司的要求支付相应的费用。该权利属于本公司的经营自主权，本公司保留随时改变经营模式的权利，及保留变更收费的费率标准、收费的软件功能、收费对象及收费时间等权利。同时也保留对本公司进行升级、改版，增加、删除、修改、变更其功能或者变更其游戏规则的权利。用户如果不接受该等变更的，应当立即停止使用本公司；用户继续使用本游戏的行为，视为用户接受改变后的经营模式。 \n3.4为保障玩家的正当利益，本公司对盗号及盗号相关行为（包括但不限于盗取账号、游戏数据、玩家个人资料、协助盗号者操作等）予以严厉打击和处罚。一经查证属实或应有权机关要求，本公司有权视具体情况立即采取封号等处罚措施，情节严重的，本公司保留对涉案玩家追究法律责任的权利。 \n3.5如果本公司发现或收到他人举报或投诉用户违反本协议约定的，经查证属实，本公司有权不经过通知随时对相关内容进行删除，并视行为情节对违规账号处以包括但不限于警告、限制或禁止使用全部或部分功能、封号甚至终止服务的处罚。 \n3.6您充分理解并同意，因您违反本协议或相关规则的规定，导致或产生第三方主张的任何索赔、要求或损失，您应当独立承担责任；本公司因此遭受损失的，您也一并赔偿。 \n3.7本公司可能会通过本公司官方网站、本公司客服官方网站、客服电话、本公司微信公众号、游戏管理员或者其他的途径，向用户提供诸如游戏规则说明，BUG或外挂投诉、游戏账号锁定或解除锁定、游戏账号申诉、游戏账号暂时封停、游戏账号实名注册信息修改和/或查验等客户服务。 \n3.8您可向本公司举报本游戏中存在的作弊等违规行为，如对处理结果不满意，可申诉一次，申诉的结果为最终判定结果。用户如果对最终判定结果不满意，本公司有权拒绝用户再次申诉请求。\n四、用户行为规范\n4.1您充分了解并同意，您必须为自己账号下的一些行为负责，包括您所发表的任何内容以及由此产生的任何后果。您应对本游戏中的内容自行加以判断，并承担因使用本游戏而引起的所有风险，包括因对本游戏内容的正确性、完整性或实用性的依赖而产生的风险。本公司无法且不会对因前述风险而导致的任何损失或损害承担责任。\n4.2除非法律允许或本公司书面许可，您不得（营利或非营利性的）从事下列行为： \n（1）通过非本公司开发、授权的第三方软件、插件、外挂、系统，使用本游戏及本公司的其他服务； \n（2）制作、发布、传播非本公司开发、授权的第三方软件、插件、外挂、系统； \n（3）建立有关本公司的镜像站点，或者进行网页（络）快照，或者利用架设服务器等方式，为他人提供与本游戏服务完全相同或者类似的服务； \n（4）对本游戏软件进行反向工程、反向汇编、反向编译或者以其他方式尝试获取软件的源代码； \n（5）通过各种方式进入游戏服务器，干扰服务器的正常运行，接触、拷贝、篡改、增加、删除游戏数据； \n（6）使用本公司的名称、商标或其他知识产权；\n（7）其他未经本公司明示授权的行为 。\n4.3您在使用本游戏服务过程中有如下行为的，本公司将视情节严重程度，依据本协议及相关游戏规则的规定，对您暂时或永久性地做出禁言（关闭聊天功能）、强制离线、封号（暂停游戏账户）、终止服务等处理措施，情节严重的将移交有关机关给予行政处罚，甚至向公安机关举报、追究您的刑事责任： \n（1）假冒本公司工作人员或其他客户服务人员； \n（2）传播非法言论或不当信息，包括使用非法或不当词语、字符等用于角色命名； \n（3）对本公司工作人员或其他玩家进行辱骂、人身攻击等；不断吵闹、重复发言、不断发布广告、恶意刷屏等，以及恶意连续骚扰他人，影响他人游戏等其他行为； \n（4）以任何方式破坏本游戏或影响本游戏服务的正常进行； \n（5）各种非法外挂行为； \n（6）利用系统BUG、漏洞为自己及他人牟利； \n（7）利用本游戏进行赌博； \n（8）侵犯本公司的知识产权，或者进行其他有损于本游戏或第三方合法权益的行为； \n（9）通过各种方式侵入游戏服务器，干扰服务器的正常运行，接触、拷贝、篡改、增加、删除 游戏数据； \n（10）其他在行业内被广泛认可的不当行为，无论是否已经被本协议或游戏规则明确列明。\n五、免责声明\n5.1本公司可能因游戏软件BUG、版本更新缺陷、运营BUG、第三方病毒攻击或其他任何因素导致您无法登陆账号，或导致您的游戏角色、游戏数据等账号数据发生异常。在数据异常的议案因未得到查明前，本公司有权暂时冻结该账号；若查明数据异常为非正常游戏行为，您游戏账号数据将可能被恢复至异常发生前的原始状态，本公司对此免责。 \n5.2对于您从未经本公司官方授权合作方处交易的行为，本公司不承担任何责任；本公司不对未经授权的第三方交易的行为负责，并且不受理因任何未经授权的第三方交易发生纠纷带来的申诉。 \n5.3由于互联网服务的特殊性，本公司有权根据法律法规的规定及相关主管部门的要求、第三方权利人的投诉举报、与合作方的合作情况，以及本公司业务发展情况，随时变更、中断或终止本服务的部分或全部内容。\n六、知识产权\n6.1本公司是本游戏的知识产权权利人。相关的著作权、商标权、专利权、商业秘密等知识产权，以及其他信息内容（包括文字、图片、音频、视频、图标、界面设计、版面框架、有关数据或电子文档等）均受中华人民共和国法律和相应国际条约保护，本公司享有上述知识产权，但相关权利人依照法律规定应享有的权利除外。 \n6.2您在使用本公司服务中产生的游戏数据的所有权和知识产权归本公司所有，本公司有权处置该游戏数据。\n6.3本公司可能涉及第三方知识产权，而该等第三方对您基于本协议在本公司中使用该等知识产权要求的，您应当一并遵守。\n七、用户信息收集、使用及保护\n7.1您同意并授权本公司为履行本协议之目的收集您的用户信息，这些信息包括您在实名注册系统中注册的信息、您账号下的游戏数据以及其他您在使用本游戏服务的过程中向本公司提供的或本公司基于安全、用户体验优化等考虑而需收集的信息，本公司对您的用户信息的收集将遵循相关法律的规定。 \n7.2您充分理解并同意：为更好地向您提供本公司服务，本公司可以将您的用户信息交给关联公司，且本公司有权自行或通过第三方对您的用户信息进行整理、统计、分析及利用。 \n7.3您充分理解并同意：本公司可以根据您的用户信息，通过短信、电话、邮件等各种方式向您提供关于本公司的活动信息、推广信息等各类信息。\n7.4本公司保证不对外公开或向任何第三方提供您的个人信息，但是存在下列情形之一的除外： \n（1）公开或提供相关信息之前获得您许可的； \n（2）根据法律或政策的规定而公开或提供的； \n（3）只有公开或提供您的个人信息，才能向您提供您需要的本公司服务的； \n（4）根据国家权力机关要求公开或提供的； \n（5）根据本协议其他条款约定而公开提供的。\n八、管辖与法律适用\n8.1本协议签订地为中华人民共和国苏州市。 \n8.2本协议的成立、生效、履行、解释及纠纷解决、适用中华人民共和国大陆地区法律。 \n8.3若您和本公司之间因本协议发生任何纠纷或争议，首先应友好协商解决；协商不成的，您同意将纠纷或争议提交至本公司住所地有管辖权的人民法院管辖。\n九、协议的变更和生效\n9.1本公司有权根据需要不时修改本协议条款。上述内容一经正式公布即生效。您可以在本公司的相关页面查阅最新版本的协议条款。 \n9.2本协议条款变更后，如果您继续使用本游戏服务，即视为您已接受变更后的协议。如果您不接受变更后的协议，应当立即停止用本游戏服务。\n9.3除非本协议另有其他明示规定，本公司所推出的新产品、新功能、新服务，均受到本协议之规范。\n附录：《网络游戏服务格式化协议必备条款》\n1.账号注册\n1.1乙方承诺以其真实身份注册成为甲方的用户，并保证所提供的个人身份资料信息真实、完整、有效，依据法律规定和必备条款约定对所提供的信息承担相应的法律责任。\n1.2乙方以其真实身份注册成为甲方用户后，需要修改所提供的个人身份资料信息的，甲方应当及时、有效地为其提供该项服务。\n2.用户账号使用与保管\n2.1根据必备条款的约定，甲方有权审查乙方注册所提供的身份信息是否真实、有效，并应积极地采取技术与管理等合理措施保障用户账号的安全、有效；乙方有义务妥善保管其账号及密码，并正确、安全地使用其账号及密码。任何乙方未尽上述义务导致账号密码遗失、账号被盗等情形而给乙方和他人的民事权利造成损害的，应当承担由此产生的法律责任。\n2.2乙方对登陆后所持账号产生的行为依法享有权利和承担责任。\n2.3乙方发现其账号或密码被他人非法使用或有使用异常的情况的，应及时根据甲方公布的处理方式通知甲方，并有权通知甲方采取措施暂停该账号的登录和使用。\n2.4甲方根据乙方的通知采取措施暂停乙方账号的登录和使用的，甲方应当要求乙方提供并核实与其注册身份信息相一致的有效身份信息。\n2.4.1甲方核实乙方所提供的个人有效身份信息与所注册的身份信息相一致的，应当及时采取措施暂停乙方账号的登录和使用。\n2.4.2甲方违反2.4.1款项的约定，为及时采取措施暂停乙方账号的登录和使用，因此给乙方造成损失的，应当承担其相应的法律责任。\n2.4.3乙方没有提供其个人有效身份证件或者乙方提供的个人有效身份证件与所注册的身份信息不一致的，甲方有权拒绝乙方上述请求。\n2.5乙方为了维护其合法权益，向甲方提供所注册的身份信息相一致的个人有效身份信息时，甲方应当为乙方提供账号注册人证明、原始注册信息等必要的协助和支持，并根据需要向有关行政机关和司法机关提供相关证据信息资料。 3.服务的中止与终止 \n3.1乙方有发布违法信息、严重违背社会公德、以及其他违反法律禁止性规定的行为，甲方应当立即终止对乙方提供服务。\n3.2乙方在接受甲方服务时实施不正当行为的，甲方有权终止对乙方提供服务。该不正当行为的具体情形应当在本协议中有明确约定或属于甲方事先明确告知的应被终止服务的禁止性行为，否则，甲方不得终止对乙方提供服务。\n3.3乙方提供虚假注册身份信息，或实施违反本协议的行为，甲方有权终止对乙方提供全部或部分服务；甲方采取中止措施应当通知乙方并告知中止期间，中止期间应该是合理的，中止期间届满甲方应当及时恢复对乙方的服务。\n3.4甲方根据本条约定中止或终止对乙方提供部分或全部服务的，甲方应负举证责任。\n4.用户信息保护\n4.1甲方要求乙方提供与其个人身份有关的信息资料时，应当事先以明确而易见的方式向乙方公开其隐私权保护政策和个人信息利用政策，并采取必要措施保护乙方的个人信息资料的安全。\n4.2未经乙方许可甲方不得向任何第三方提供、公开或共享乙方注册资料中的姓名、个人有效身份证件号码、联系方式、家庭住址等个人身份信息，但下列情况除外：\n4.2.1乙方或乙方监护人授权甲方披露的；\n4.2.2有关法律要求甲方披露的；\n4.2.3司法机关或行政机关基于法定程序要求甲方提供的；\n4.2.4甲方为了维护自己合法权益而向乙方提起诉讼或者仲裁时；\n4.2.5应乙方监护人的合法要求而提供乙方个人身份信息时。";

        var container = scrollView.getInnerContainer();
        var content = new cc.LabelTTF("", "微软雅黑", 18);
        content.setString(mstr);
        // content.setColor(cc.color("6e1203"));
        content.setDimensions(840, 0);
        scrollView.setInnerContainerSize(content.getContentSize());
        content.setAnchorPoint(cc.p(0, 1));
        content.setPosition(cc.p(0, scrollView.getInnerContainerSize().height));
        container.addChild(content);
        scrollView.jumpToTop();

    },

});

var VIPinfoLayer = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var bg = this.addLayerBg(cc.size(830, 510));
        bg.setPosition(cc.p(cc.winSize.width / 2, cc.winSize.height * 0.45));
        var titlebg1 = new cc.Sprite("#fish_vip_res1.png");
        if (titlebg1) {
            titlebg1.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height + 10));
            this.layerbg.addChild(titlebg1, 0, 1);
        }
        this.addCloseBtn();
        this.initUp();
        this.initUnder();
    },

    initUp: function () {

        var self = this;
        var player = appglobal.getPlayer();
        var bg = new ccui.ImageView("fish_vip_res4.png", ccui.Widget.PLIST_TEXTURE);
        if (bg) {
            this.layerbg.addChild(bg, 10, "upbg");
            bg.setPosition(cc.p(this.layerbg.width / 2, 300));
        }

        var des1 = ["捕鱼概率\n提升", "好友赛创\n建资格", "还需充值\n金额"];
        if (appglobal._switch11 == 0) {
            des1 = ["捕鱼概率\n提升", "炸弹额外\n奖励", "还需充值\n金额"];
        }

        for (var i = 0; i < 3; ++i) {
            var text1 = new ccui.Text(des1[i], "", 22);
            if (text1) {
                bg.addChild(text1, 1, "text1" + i);
                // text1.enableOutline(cc.color("6e2a06"),1);
                text1.setPosition(cc.p(60, 200 - i * 80));
            }
        }

        var des2 = ["无", "略微提升", "略微提升", "略微提升", "略微提升", "少量提升", "少量提升"];
        var temprange = ["0", "5%", "10%", "15%", "20%", "25%", "30%"];
        for (var j = 0; j < 7; ++j) {
            var text2 = new ccui.Text(des2[j], "", 20);
            if (text2) {
                bg.addChild(text2, 1, "text2" + j);
                // text2.enableOutline(cc.color("6e2a06"),1);
                text2.setPosition(cc.p(167 + j * 91, 200));
            }

            var contenttext5 = "";
            if (appglobal._switch11 == 1) {
                contenttext5 = j >= FishGlobal._canSendLevel ? "可以创建" : "无";
            } else {
                contenttext5 = temprange[j];
            }

            var text3 = new ccui.Text(contenttext5, "", 20);
            if (text3) {
                bg.addChild(text3, 1, "text3" + j);
                // text3.enableOutline(cc.color("6e2a06"),1);
                text3.setPosition(cc.p(167 + j * 91, 120));
            }
            if (player.iMoney >= FishGlobal.getVipcfg()[j].iMoney) {
                var text4 = new cc.Sprite("#fish_vip_res2.png");
                if (text4) {
                    bg.addChild(text4, 1, "text4" + j);
                    text4.setPosition(cc.p(167 + j * 91, 40));
                }
            } else {
                var text4 = new ccui.Text((FishGlobal.getVipcfg()[j].iMoney - player.iMoney) + "元", "", 20);
                if (text4) {
                    bg.addChild(text4, 1, "text4" + j);
                    // text4.enableOutline(cc.color("6e2a06"),1);
                    text4.setPosition(cc.p(167 + j * 91, 40));
                }
            }

        }

        var currentvip = new ccui.ImageView("fish_vip_res0.png", ccui.Widget.PLIST_TEXTURE);
        if (currentvip) {
            bg.addChild(currentvip, 10, "currentvip");
            currentvip.setScale9Enabled(true);
            currentvip.setContentSize(cc.size(100, 320));
            currentvip.setPosition(cc.p(166 + player.iVIPLevel * 91, bg.height / 2));
        }

    },

    initUnder: function () {
        var self = this;
        var player = appglobal.getPlayer();
        var vipbigbg = new ccui.ImageView("fish_vip_res32.png", ccui.Widget.PLIST_TEXTURE);
        if (vipbigbg) {
            this.layerbg.addChild(vipbigbg, 10, "vipbigbg");
            vipbigbg.setScale9Enabled(true);
            vipbigbg.setContentSize(cc.size(760, 95));
            vipbigbg.setPosition(cc.p(this.layerbg.width / 2, 85));
        }

        for (var i = 0; i < 2; ++i) {
            var sp = new cc.Sprite("#fish_vip_res5.png");
            if (sp) {
                vipbigbg.addChild(sp, 1, "sp" + i);
                sp.setPosition(cc.p(25 + i * 710, vipbigbg.height));
            }
        }

        var tip1 = new ccui.Text("当前等级：", "", 22);
        if (tip1) {
            vipbigbg.addChild(tip1, 1, "tip1");
            // tip1.setTextColor(cc.color("3843ab"));
            // tip1.enableOutline(cc.color("6e2a06"),2);
            tip1.setAnchorPoint(cc.p(0, 0.5));
            tip1.setPosition(cc.p(75, 65));
        }

        var tip2 = new ccui.Text("购买金币或活动礼包均能提升VIP等级", "", 18);
        if (tip2) {
            vipbigbg.addChild(tip2, 1, "tip2");
            tip2.setTextColor(cc.color("f3fc04"));
            tip2.setAnchorPoint(cc.p(0, 0.5));
            tip2.setPosition(cc.p(50, 20));
        }

        var viplogobg = this._logonumber = new ccui.ImageView("fish_vip_res" + (10 + player.iVIPLevel) + ".png", ccui.Widget.PLIST_TEXTURE);
        if (viplogobg) {
            vipbigbg.addChild(viplogobg, 0, "viplogobg");
            viplogobg.setPosition(cc.p(240, 65));
        }


        var btnname = ["fish_vip_res9", "fish_vip_res8"];
        for (var j = 0; j < 2; ++j) {
            var lightbg = new cc.Sprite('#newyear10.png');
            if (lightbg) {
                vipbigbg.addChild(lightbg, 1, "lightbg" + j);
                lightbg.setScale(0.8);
                lightbg.setPosition(cc.p(550 + j * 100, vipbigbg.height / 2));
                var rotateact = new cc.RotateBy(5.5, 360);
                lightbg.runAction(new cc.RepeatForever(rotateact));
            }

            var btn = new ccui.ImageView(btnname[j] + ".png", ccui.Widget.PLIST_TEXTURE);
            if (btn) {
                vipbigbg.addChild(btn, 1, btnname[j]);
                btn.setTouchEnabled(true);
                btn.setPosition(cc.p(550 + j * 100, vipbigbg.height / 2 - 10));
                btn.addTouchEventListener(this.btnTouchEft, this);
                btn.addClickEventListener(function (sender) {
                    self.callFunction(sender);
                });
                if (btnname[j] == "fish_vip_res9") {
                    var stip = new cc.Sprite("#fish_vip_res7.png");
                    btn.addChild(stip);
                    stip.setPosition(cc.p(5, btn.height - 15));
                }
            }

            if (j == 0 && appglobal._switch11 == 0) {
                btn.setVisible(false);
                lightbg.setVisible(false);
            }
            if(j==1 && appglobal._switch27 ==0){
                if(player.account == player.userid){
                    btn.setVisible(false);
                    lightbg.setVisible(false);
                } 
            }
        }

    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    callFunction: function (sender) {
        var name = sender.getName();
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        if (name == "fish_vip_res9") {
            var layer = new NYMallLayer();
            if (layer) {
                scene.addChild(layer, FishZorder.poplayer, LobbySceneName.NYMallLayer);
                FYEngine.popupLayerAnimate(layer.layerbg, undefined, undefined, cc.p(layer.width / 2, layer.height * 0.4 + 30));
            }
        } else {
            var layer = new MallLayer();
            if (layer) {
                scene.addChild(layer, FishZorder.poplayer, LobbySceneName.MallLayer);
                FYEngine.popupLayerAnimate(layer.layerbg, undefined, undefined, cc.p(layer.width / 2, layer.height * 0.4 + 30));
            }
        }
    }
});

var VipSendLevel = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.75, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var rich1 = new ccui.RichText();
        if (rich1) {
            innerbg.addChild(rich1, 0, "rich1");
            rich1.setPosition(cc.p(innerbg.width / 2, innerbg.height / 2));

            var mtxt1 = new ccui.RichElementText(1, cc.color("ffec4d"), 255, "VIP" + FishGlobal._canSendLevel, "", 30);
            rich1.pushBackElement(mtxt1);

            var mtxt2 = new ccui.RichElementText(2, cc.color.WHITE, 255, "可使用弹头功能", "", 30);
            rich1.pushBackElement(mtxt2);
        }

        this.addCancelBtn(function (sender) {
            self.removeFromParent(true);
            var layer = new VIPinfoLayer();
            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.VIPinfoLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, cc.p(bg.width * 0.25, bg.height * 0.2 - 15), "#fish_vip_res29.png")
    },

});

var VIPcreateLevel = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.75, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var rich1 = new ccui.RichText();
        if (rich1) {
            innerbg.addChild(rich1, 0, "rich1");
            rich1.setPosition(cc.p(innerbg.width / 2, innerbg.height / 2));

            var mtxt1 = new ccui.RichElementText(1, cc.color("ffec4d"), 255, "VIP" + FishGlobal._canSendLevel, "", 30);
            rich1.pushBackElement(mtxt1);

            var mtxt2 = new ccui.RichElementText(2, cc.color.WHITE, 255, "可创建比赛", "", 30);
            rich1.pushBackElement(mtxt2);
        }

        this.addCancelBtn(function (sender) {
            self.removeFromParent(true);
            FishGlobal._SHOWVIPINFO = true;
            var scene = FYEngine.getRunningLayer(0);
            if (scene) {
                scene.createLoading();
            }
            var gamehandle = CoreServiceProxy.getInstance().getGameHandler();
            if (gamehandle && gamehandle._canSendNormalMsg) {
                gamehandle.sendPlayerLogoutRequest();
            }

            var lobbyHandle = CoreServiceProxy.getInstance().getLobbyHandler();
            if (lobbyHandle && lobbyHandle._canSendNormalMsg) {
                lobbyHandle.sendBackToLobbyRequest();
            }

            scene.runAction(new cc.Sequence(new cc.DelayTime(0.5), new cc.CallFunc(function () {
                FYEngine.runScene(LobbyLayer.createScene());
            })));
        }, cc.p(bg.width * 0.25, bg.height * 0.2 - 15), "#fish_vip_res29.png")
    },

});

var CreateRoomFail = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        var innerbg = this.addInnerBg(cc.size(586, 220));
        var t_word = "创建房间失败，请联系客服QQ：3003674856";

        var text1 = new ccui.Text(t_word, "微软雅黑", 22);
        if (text1) {
            innerbg.addChild(text1, 0, "text1");
            text1.setPosition(cc.p(innerbg.width / 2, innerbg.height / 2));
        }
    },

});

var VipSendFail = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.75, bg.height * 0.2 - 15), UsedResName.iknowbtn);
        var innerbg = this.addInnerBg(cc.size(586, 220));

        var text1 = new ccui.Text("", "微软雅黑", 26);
        if (text1) {
            innerbg.addChild(text1, 0, "text1");
            text1.setPosition(cc.p(innerbg.width / 2, 135))
        }

        var player = appglobal.getPlayer();
        if (player.iVIPLevel < 6) {
            var rich1 = new ccui.RichText();
            if (rich1) {
                innerbg.addChild(rich1, 0, "rich1");
                rich1.setPosition(cc.p(innerbg.width / 2, 90));

                var mtxt1 = new ccui.RichElementText(1, cc.color("02FEF5"), 255, "提升", "", 24);
                rich1.pushBackElement(mtxt1);

                var mtxt2 = new ccui.RichElementText(2, cc.color("FFEC4D"), 255, "VIP等级", "", 24);
                rich1.pushBackElement(mtxt2);

                var mtxt3 = new ccui.RichElementText(3, cc.color("02FEF5"), 255, "，可增加数量上限", "", 24);
                rich1.pushBackElement(mtxt3);
            }
        }


        this.addCancelBtn(function (sender) {
            self.removeFromParent(true);
            var layer = new VIPinfoLayer();
            FYEngine.getRunningLayer(0).addChild(layer, FishZorder.poplayer, LobbySceneName.VIPinfoLayer);
            FYEngine.popupLayerAnimate(layer.layerbg);
        }, cc.p(bg.width * 0.25, bg.height * 0.2 - 15), "#fish_vip_res29.png")
    },

});

var FightSeletLayer = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.layerbg = new cc.Sprite("res/updatefight/fish_fight_bg.png");
        if (bg) {
            this.addChild(bg, 0, "bg");
            bg.setCascadeColorEnabled(false);
            bg.setColor(cc.color(150, 150, 150));
            bg.setPosition(cc.p(this.width / 2, this.height / 2));
        }

        var btn1 = new ccui.ImageView("fish_fight_res9.png", ccui.Widget.PLIST_TEXTURE);
        if (btn1) {
            bg.addChild(btn1, 1, "btn1");
            btn1.setTouchEnabled(true);
            btn1.setPosition(cc.p(360, bg.height / 2));
            btn1.addTouchEventListener(this.btnTouchEft, this);
            btn1.addClickEventListener(function (sender) {
                self.btnClickCallBack(sender);
            });
        }

        var btn2 = new ccui.ImageView("fish_fight_res7.png", ccui.Widget.PLIST_TEXTURE);
        if (btn2) {
            bg.addChild(btn2, 1, "btn2");
            btn2.setTouchEnabled(true);
            btn2.setPosition(cc.p(770, bg.height / 2 + 10));
            btn2.addTouchEventListener(this.btnTouchEft, this);
            btn2.addClickEventListener(function (sender) {
                self.btnClickCallBack(sender);
            });
        }

        var btn3 = new ccui.ImageView("fish_copy_6.png", ccui.Widget.PLIST_TEXTURE);
        if (btn3) {
            bg.addChild(btn3, 1, "btn3");
            btn3.setPosition(cc.p(55, 600));
            btn3.setTouchEnabled(true);
            btn3.addTouchEventListener(this.btnTouchEft, this);
            btn3.addClickEventListener(function (sender) {
                self.btnClickCallBack(sender);
            });
        }

        for (var i = 0; i < 2; ++i) {
            var mtip = new cc.Sprite("#fish_fight_res" + (13 + i) + ".png");
            if (mtip) {
                bg.addChild(mtip, 2, "mtip" + i);
                mtip.setPosition(cc.p(360 + 410 * i, 70));
            }
        }

        var mpicname = ["fish_boom33.png", "hall83.png"];
        for (var j = 0; j < 2; ++j) {
            var goldbg = new ccui.ImageView("hall35.png", ccui.Widget.PLIST_TEXTURE);
            if (goldbg) {
                bg.addChild(goldbg, 0, "goldbg");
                goldbg.setAnchorPoint(cc.p(0, 0.5));
                goldbg.setScale9Enabled(true);
                goldbg.setPosition(cc.p(320 + 250 * j, 597));
                // goldbg.setCapInsets(cc.rect(30,0, 10,0));
                // goldbg.setContentSize(cc.size(240,41));

                var tip1 = new ccui.ImageView(mpicname[j], ccui.Widget.PLIST_TEXTURE);
                if (tip1) {
                    goldbg.addChild(tip1, 0, "goldtip");
                    tip1.setPosition(cc.p(10, goldbg.height / 2 + 5));
                    if (j == 0) {
                        tip1.setScale(0.6);
                    }
                }
            }
        }
        this.updateWealth();
    },

    updateWealth: function () {
        var player = appglobal.getPlayer();
        var boom = this.layerbg.getChildByName("playerboom");
        if (!boom) {
            cc.log("createlabel");
            boom = FYEngine.createAlts(CommResource.selfNum_png, 12, player.crystal, '.');
            this.layerbg.addChild(boom, 2, "playerboom");
            boom.setPosition(cc.p(345, 597));
            boom.setAnchorPoint(cc.p(0, 0.5));
        } else {
            boom.setString(player.crystal);
        }

        var coupon = this.layerbg.getChildByName("playercoupon");
        if (!coupon) {
            cc.log("createlabel");
            coupon = FYEngine.createAlts(CommResource.selfNum_png, 12, player.coupon, '.');
            this.layerbg.addChild(coupon, 2, "playercoupon");
            coupon.setPosition(cc.p(595, 597));
            coupon.setAnchorPoint(cc.p(0, 0.5));
        } else {
            coupon.setString(player.coupon);
        }
    },

    btnClickCallBack: function (sender) {
        var name = sender.getName();
        var scene = FYEngine.getRunningLayer(0);
        switch (name) {
            case "btn1" : {
                FYEngine.AddCommToast("四人匹配赛暂未开放，敬请期待");
            }
                break;
            case "btn2" : {
                FishGlobal.roomId = 5;
                scene.createLoading();
                scene.loadFish();
                scene.scheduleOnce(scene.joinTableCheck, 15);
            }
                break;
            case "btn3" : {
                this.removeFromParent(true);
            }
                break;
            default:
                break;
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

});


var FishFightRuleLayer = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(655, 420));
        this.addTitleBg("#fish_fight_res0.png", 665);
        this.addCloseBtn();

        var innerbg = this.addInnerBg(cc.size(585, 305));
        innerbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.46));
        var leftword = ["开炮规则：", "排名规则："];
        for (var i = 0; i < 2; ++i) {
            var text1 = new ccui.Text(leftword[i], "", 22);
            if (text1) {
                innerbg.addChild(text1, 1, "left" + i);
                text1.setPosition(cc.p(25, 260 - i * 100));
                text1.setAnchorPoint(cc.p(0, 1));
                text1.setColor(cc.color("02fef5"));
            }
        }

        var rightword = ["开炮无需消耗金币，在比赛期间可以尽情开炮。", "率先取得目标分数的玩家排名第一。其余玩家按照达到目标分数所花的时间进行排名，时间越短，排名越靠前。比赛结束时还没有达到目标分数的玩家，按照分数高低进行排名。"];
        for (var j = 0; j < 2; ++j) {
            var text2 = new ccui.Text(rightword[j], "", 22);
            if (text2) {
                innerbg.addChild(text2, 1, "right" + j);
                text2.setPosition(cc.p(135, 260 - j * 100));
                text2.setTextAreaSize(cc.size(420, 150));
                text2.setAnchorPoint(cc.p(0, 1));
            }
        }

    },
});

var FishFightBox = ccui.ImageView.extend({
    _data: null,
    _tag: 0,
    _cointype: 0,
    ctor: function (i, data, cointype) {
        cc.log(cointype + "----box:" + i);
        this._super();
        this._tag = i;
        this._cointype = cointype;
        this._data = data;
        var player = appglobal.getPlayer();
        var texturename = "fish_fight_res18.png";
        if (player.userid == data.lUserId) {
            texturename = "fish_fight_res16.png"
        }
        this.loadTexture(texturename, ccui.Widget.PLIST_TEXTURE);
        this.setScale9Enabled(true);
        this.setCapInsets(cc.rect(30, 0, 10, 0));
        this.setContentSize(cc.size(520, 100));
        this.initUI();
    },
    initUI: function () {
        var player = appglobal.getPlayer();
        var self = this;
        var rankBg = cc.Sprite("#rankup017.png");
        rankBg.attr({anchorX: 0, anchorY: 1, x: 10, y: 100});
        this.addChild(rankBg, 0);
        var rankIcon;
        if (this._tag < 3) {
            switch (this._tag) {
                case 0:
                    rankIcon = cc.Sprite("#rankup018.png");
                    break;
                case 1:
                    rankIcon = cc.Sprite("#rankup015.png");
                    break;
                case 2:
                    rankIcon = cc.Sprite("#rankup016.png");
                    break
            }
        } else {
            rankIcon = FYEngine.createAlts(LobbyRes.Onlinenum.RankNumber, 10, "" + (this._tag + 1), '0');
        }
        rankIcon && rankIcon.setPosition(cc.p(rankBg.width / 2 - 2, 50));
        rankBg.addChild(rankIcon, 0, "icon");

        var tempname = SoftReplaceWords("" + this._data.szNickName);
        var playername = FYEngine.createLengthText(tempname, 22, 180);
        playername.setColor(cc.color("#6b3110"));
        playername.attr({x: 185, y: 70, anchorX: 0});
        this.addChild(playername, 1);


        var playerid = new ccui.Text("ID：" + this._data.lUserId, "", 20);
        playerid.setColor(cc.color("#126f88"));
        playerid.attr({x: 185, y: 35, anchorX: 0, anchorY: 0.5});
        this.addChild(playerid, 2);

        var mfaceid = this._data.szFaceId;
        // cc.log("1mfaceid"+mfaceid);
        if (player.userid == this._data.lUserId) {
            if (player.facestatus == 0 || player.facestatus == -1) {
                mfaceid = "";
            } else {
                mfaceid = player.faceid;
            }
        }

        // cc.log("12mfaceid"+mfaceid);
        var headK = new FYEngine.rangkImage('#rankup042.png', '#fish_hallnew02.png', '#rankup012.png', 1, mfaceid, 0, 0, 0);
        if (headK) {
            headK.setScale(0.7);
            this.addChild(headK, 3);
            headK.attr({x: 122, y: 55, anchorX: 0.5, anchorY: 0.5});
            this.headnode = headK;
        }

        var picname = this._cointype == 1 ? "fish_fight_res1.png" : "fish_boom55.png";
        var rpic = new cc.Sprite("#" + picname);
        if (rpic) {
            this.addChild(rpic, 4);
            var tsize = 24;
            if (this._cointype != 1) {
                tsize = 30;
                rpic.setScale(0.7);
            } else {
                rpic.setScale(0.9);
            }
            rpic.setPosition(cc.p(440, 55));

            var txt = ccui.Text("x" + this._data.iPrize, '微软雅黑', tsize);
            if (txt) {
                txt.setAnchorPoint(cc.p(1, 0));
                txt.setColor(cc.color("fff000"));
                txt.enableOutline(cc.color("0b394e"), 2);
                txt.setPosition(cc.p(rpic.width - 8, 8));
                rpic.addChild(txt, 0);
            }
        }
    }
});

var FishFightResultLayer = DialogLayer.extend({//todo
    _pointinfo: null,
    _peoplenum: 0,
    _data: null,
    ctor: function (info) {
        cc.log("FishFightResultLayer");
        FYEngine.logObject(info, "-----FishFightResultLayer:");
        this._super();
        this._data = info;
        this._peoplenum = info.iMaxPlayer;
        this.initData();
        this.initUI();

    },

    initData: function () {
        this._pointinfo = [{}, {}, {
            bgsize: cc.size(590, 390),
            innersize: cc.size(535, 235),
            innerhight: 0.55,
            btnheight: 0.14
        }, {
            bgsize: cc.size(590, 510),
            innersize: cc.size(535, 345),
            innerhight: 0.53,
            btnheight: 0.11
        }, {
            bgsize: cc.size(590, 615),
            innersize: cc.size(535, 455),
            innerhight: 0.52,
            btnheight: 0.09
        }];
    },

    initUI: function () {
        var bg = this.addLayerBg(this._pointinfo[this._peoplenum].bgsize);
        this.addTitleBg("#fish_fight_res4.png", 600);
        var innerbg = this.addInnerBg(this._pointinfo[this._peoplenum].innersize);
        innerbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * this._pointinfo[this._peoplenum].innerhight));
        this.addConfirmBtn(function () {
            FYEngine.runScene(FishFightLobby.createScene());
        }, cc.p(bg.width / 2, bg.height * this._pointinfo[this._peoplenum].btnheight));

        for (var i = 0; i < this._peoplenum; ++i) {
            var box = new FishFightBox(i, this._data.tScore[i], this._data.iCoinType);
            if (box) {
                innerbg.addChild(box);
                box.setAnchorPoint(cc.p(0.5, 1));
                box.setPosition(cc.p(innerbg.width / 2, innerbg.height - 10 - i * 110));
            }
        }
    },


});

var FishFightCreate = DialogLayer.extend({
    _gametype: 1,//  1:奖券  2，弹头
    _gamepeo: 2,
    _gametime: 1,
    _gamegoal: 100,
    gameconfig: null,
    _time: 0,
    ctor: function () {
        this._super();
        this.initRoomConfig();
        this.initData();
        this.initUI();
    },

    initRoomConfig: function () {
        this.gameconfig = {
            type: [1, 5],
            people: [2, 3, 4],
            maxtime: [1, 2, 3],
            goal: [1000, 2000, 4000],
            couponlimit: 1000,
            nuclearlimit: 1000,
        };
    },

    initData: function () {
        this._time = 0;
        this._gametype = 1;
        this._gamepeo = 0;
        this._gametime = 0;
        this._gamegoal = 0;
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(840, 620));
        this.addTitleBg("#fish_fight_res5.png", 850);
        this.addCloseBtn();
        var innerbg = this.addInnerBg(cc.size(780, 455));
        innerbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.53));

        for (var a = 0; a < 4; ++a) {
            var line = new ccui.ImageView("fish_fight_res62.png", ccui.Widget.PLIST_TEXTURE);
            if (line) {
                innerbg.addChild(line, 0, "line" + a);
                line.setScale9Enabled(true);
                line.setPosition(cc.p(this.innerBg.width / 2, 380 - a * 65));
                line.setContentSize(cc.size(730, 2));
            }
        }
        var lefttip = ["fish_fight_res6.png", "fish_fight_res8.png", "fish_fight_res10.png", "fish_fight_res11.png", "fish_fight_res12.png"];
        for (var i = 0; i < 5; ++i) {
            var ltip = new cc.Sprite("#" + lefttip[i]);
            if (ltip) {
                innerbg.addChild(ltip, 0, "ltip" + i);
                ltip.setAnchorPoint(cc.p(0, 0.5));
                ltip.setPosition(cc.p(30, 415 - i * 65));
            }
        }

        var nameline1 = ["fish_fight_res29.png", "fish_fight_res28.png"];
        for (var j = 0; j < 2; ++j) {
            var btnGameType = new ccui.ImageView(nameline1[j], ccui.Widget.PLIST_TEXTURE);
            if (btnGameType) {
                innerbg.addChild(btnGameType, 1, "btnGameType" + j);
                btnGameType.setTouchEnabled(true);
                btnGameType.setPosition(cc.p(290 + j * 190, 415));
                btnGameType.addClickEventListener(function (sender) {
                    self.selectGameType(sender);
                });

                var sptip = new cc.Sprite("#fish_fight_res31.png");
                if (sptip) {
                    btnGameType.addChild(sptip, 0, "pic");
                    sptip.setPosition(cc.p(btnGameType.width - 5, 10));
                    if (j == 0) {
                        sptip.setVisible(false);
                    }
                }
            }
        }

        var tpeople = [2, 3, 4];
        for (var b = 0; b < 3; ++b) {
            var btnGamePeople = new ccui.ImageView(b == 0 ? "fish_fight_res33.png" : "fish_fight_res35.png", ccui.Widget.PLIST_TEXTURE);
            if (btnGamePeople) {
                innerbg.addChild(btnGamePeople, 2, "btnGamePeople" + b);
                btnGamePeople.setTouchEnabled(true);
                btnGamePeople.setAnchorPoint(cc.p(0, 0.5));
                btnGamePeople.setPosition(cc.p(150 + b * 190, 350));
                btnGamePeople.addClickEventListener(function (sender) {
                    self.selectGamePeople(sender);
                });
            }

            var textpeo = new ccui.Text(tpeople[b], "", 26);
            if (textpeo) {
                innerbg.addChild(textpeo, 2, "textpep" + b);
                textpeo.setAnchorPoint(cc.p(0, 0.5));
                textpeo.setPosition(cc.p(210 + b * 190, 350));
                textpeo.setColor(b == 0 ? cc.color("fff000") : cc.color("00fffc"))
            }
        }

        var ttime = [1, 2, 3];
        for (var c = 0; c < 3; ++c) {
            var btnGameTime = new ccui.ImageView(c == 0 ? "fish_fight_res33.png" : "fish_fight_res35.png", ccui.Widget.PLIST_TEXTURE);
            if (btnGameTime) {
                innerbg.addChild(btnGameTime, 2, "btnGameTime" + c);
                btnGameTime.setTouchEnabled(true);
                btnGameTime.setAnchorPoint(cc.p(0, 0.5));
                btnGameTime.setPosition(cc.p(150 + c * 190, 285));
                btnGameTime.addClickEventListener(function (sender) {
                    self.selectGameTime(sender);
                });
            }

            var texttime = new ccui.Text(ttime[c] + "分钟", "", 26);
            if (texttime) {
                innerbg.addChild(texttime, 2, "texttime" + c);
                texttime.setAnchorPoint(cc.p(0, 0.5));
                texttime.setPosition(cc.p(210 + c * 190, 285));
                texttime.setColor(c == 0 ? cc.color("fff000") : cc.color("00fffc"))
            }
        }

        var tgoal = this.gameconfig.goal;
        for (var d = 0; d < 3; ++d) {
            var btnGameGoal = new ccui.ImageView(d == 0 ? "fish_fight_res33.png" : "fish_fight_res35.png", ccui.Widget.PLIST_TEXTURE);
            if (btnGameGoal) {
                innerbg.addChild(btnGameGoal, 3, "btnGameGoal" + d);
                btnGameGoal.setTouchEnabled(true);
                btnGameGoal.setAnchorPoint(cc.p(0, 0.5));
                btnGameGoal.setPosition(cc.p(150 + d * 190, 220));
                btnGameGoal.addClickEventListener(function (sender) {
                    self.selectGameGoal(sender);
                });
            }

            var textgoal = new ccui.Text(tgoal[d], "", 26);
            if (textgoal) {
                innerbg.addChild(textgoal, 2, "textgoal" + d);
                textgoal.setAnchorPoint(cc.p(0, 0.5));
                textgoal.setPosition(cc.p(210 + d * 190, 220));
                textgoal.setColor(d == 0 ? cc.color("fff000") : cc.color("00fffc"))
            }
        }

        var wreward = ["第一名", "第二名", "第三名", "第四名"];
        for (var e = 0; e < 4; ++e) {
            var treward = new ccui.Text(wreward[e], "", 22);
            if (treward) {
                innerbg.addChild(treward, 4, "treward" + e);
                treward.setPosition(cc.p(195 + e * 150, 168));
                treward.setVisible(e > 1 ? false : true);
                treward.setColor(cc.color("00fffc"))
            }

            var piccoupon = new ccui.ImageView("fish_fight_res1.png", ccui.Widget.PLIST_TEXTURE);
            if (piccoupon) {
                innerbg.addChild(piccoupon, 4, "piccoupon" + e);
                piccoupon.setPosition(cc.p(195 + e * 150, 113));
                piccoupon.setVisible(false);
            }

            var picboom = new ccui.ImageView("fish_boom55.png", ccui.Widget.PLIST_TEXTURE);
            if (picboom) {
                innerbg.addChild(picboom, 4, "picboom" + e);
                picboom.setPosition(cc.p(195 + e * 150, 113));
                picboom.setVisible(e > 1 ? false : true);
                picboom.setScale(0.8);
            }

            var editbg = new ccui.ImageView("crystal49.png", ccui.Widget.PLIST_TEXTURE);
            if (editbg) {
                innerbg.addChild(editbg, 4, "editnumber" + e);
                editbg.setPosition(cc.p(195 + e * 150, 52));
                editbg.setVisible(e > 1 ? false : true);
                editbg.setScale9Enabled(true);
                editbg.setContentSize(cc.size(110, 40));
            }
            var edit1 = FYEngine.createEditBox("", cc.size(100, 41), cc.EDITBOX_INPUT_MODE_NUMERIC,
                '输入数量', cc.color(255, 255, 255), cc.color(255, 255, 255), 20, 6);
            if (edit1) {
                editbg.addChild(edit1, 4, "editbox");
                edit1.setPosition(cc.p(editbg.width / 2, editbg.height / 2));
                // edit1.setVisible(e > 1 ? false : true);
                var delegate1 = {
                    editBoxEditingDidBegin: function (text) {
                        cc.log("--editBoxEditingDidBegin:" + text.getName());
                        text.setPlaceHolder("");
                    },
                    editBoxEditingDidEnd: function (text) {
                        var str = text.getString();
                        if (str == "") {
                            text.setPlaceHolder("输入数量");
                        }
                    },
                    editBoxTextChanged: function (text) {
                        var value = text.getString();
                        if (/[^0-9]/.test(value)) {
                            value = value.replace(new RegExp(/[^0-9]/g), "");
                            text.setString(value);
                        }
                    }
                };
                edit1.setDelegate(delegate1);
            }
        }

        var tip = new ccui.Text("(所有奖励将从您的账号中扣除)", "", 20);
        if (tip) {
            innerbg.addChild(tip);
            tip.setPosition(cc.p(innerbg.width / 2, 15));
            tip.setColor(cc.color("fefe02"));
        }

        var btn_create = new ccui.ImageView("fish_fight_res17.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_create) {
            this.layerbg.addChild(btn_create, 5, "btn_create");
            btn_create.setTouchEnabled(true);
            btn_create.setPosition(cc.p(this.layerbg.width / 2, 58));
            btn_create.addTouchEventListener(this.btnTouchEft, this);
            btn_create.addClickEventListener(function (sender) {
                self.createGame(sender);
            })
        }
    },

    createGame: function (sender) {
        cc.log("createGame");
        if (this.canCreate()) {
            this.sendInfoToServer();
        }
    },

    sendInfoToServer: function () {
        this.addLoading();
        this.schedule(this.timeCount, 1);

        var iCoinType = this.gameconfig.type[this._gametype];
        var iMaxPlayer = this.gameconfig.people[this._gamepeo];
        var iDesScore = this.gameconfig.goal[this._gamegoal];
        var iTimeMs = this.gameconfig.maxtime[this._gametime] * 60 * 1000;
        var iPrize = [0, 0, 0, 0];
        for (var i = 0; i < iMaxPlayer; ++i) {
            var number = this.innerBg.getChildByName("editnumber" + i).getChildByName("editbox").getString();
            iPrize[i] = Number(number);
        }
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle && handle._canSendNormalMsg) {
            handle.sendCreateTableReq(iCoinType, iMaxPlayer, iDesScore, iTimeMs, iPrize);
        }
    },

    canCreate: function () {
        var peoplenumber = this.gameconfig.people[this._gamepeo];
        var totalreward = 0;
        var numarr = [0, 0, 0, 0];
        for (var i = 0; i < peoplenumber; ++i) {
            var number = this.innerBg.getChildByName("editnumber" + i).getChildByName("editbox").getString();
            cc.log(number);
            if (number == "") {
                FYEngine.AddCommToast("请填写各名次奖励");
                return false;
            }
            totalreward += Number(number);
            numarr[i] = Number(number);
        }

        if (totalreward == 0) {
            FYEngine.AddCommToast("请填写各名次奖励");
            return false;
        }

        var player = appglobal.getPlayer();
        if (this._gametype == 0) {
            if (player.coupon < totalreward) {
                FYEngine.AddCommToast("您的奖券不足，请调整奖励数量");
                return false;
            }
            if (totalreward > this.gameconfig.couponlimit) {
                FYEngine.AddCommToast("总奖励已超出每局比赛上限，上限为{0}奖券".format(this.gameconfig.couponlimit));
                return false;
            }
        } else {
            if (player.crystal < totalreward) {
                FYEngine.AddCommToast("您的弹头不足，请调整奖励数量");
                return false;
            }
            if (totalreward > this.gameconfig.nuclearlimit) {
                FYEngine.AddCommToast("总奖励已超出每局比赛上限，上限为{0}弹头".format(this.gameconfig.nuclearlimit));
                return false;
            }
        }

        if (numarr[0] >= numarr[1] && numarr[1] >= numarr[2] && numarr[2] >= numarr[3]) {
            return true;
        } else {
            var scene = FYEngine.getRunningLayer(0);
            var layer = scene.getChildByName(FishFightLayer.FishFightWrongSequence);
            if (!layer) {
                layer = new FishFightWrongSequence();
                this.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightWrongSequence);
            }
            return false;
        }


        return true;
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    changeRewardUI: function () {
        cc.log("_gametype:" + this._gametype + "_gamepeo:" + this._gamepeo);
        if (this._gametype == 0) {
            for (var i = 0; i < 4; ++i) {
                var treward = this.innerBg.getChildByName("treward" + i);
                treward.setVisible((this._gamepeo + 1) >= i ? true : false);

                var piccoupon = this.innerBg.getChildByName("piccoupon" + i);
                piccoupon.setVisible((this._gamepeo + 1) >= i ? true : false);

                var picboom = this.innerBg.getChildByName("picboom" + i);
                picboom.setVisible(false);

                var edit = this.innerBg.getChildByName("editnumber" + i);
                edit.setVisible((this._gamepeo + 1) >= i ? true : false);
            }
        } else {
            for (var i = 0; i < 4; ++i) {
                var treward = this.innerBg.getChildByName("treward" + i);
                treward.setVisible((this._gamepeo + 1) >= i ? true : false);

                var piccoupon = this.innerBg.getChildByName("piccoupon" + i);
                piccoupon.setVisible(false);

                var picboom = this.innerBg.getChildByName("picboom" + i);
                picboom.setVisible((this._gamepeo + 1) >= i ? true : false);

                var edit = this.innerBg.getChildByName("editnumber" + i);
                edit.setVisible((this._gamepeo + 1) >= i ? true : false);
            }
        }
    },

    selectGameGoal: function (sender) {
        var name = sender.getName();
        cc.log("selectGameGoal:" + name);
        var currenttag = 0;
        if (name == "btnGameGoal0") {
            currenttag = 0;
        } else if (name == "btnGameGoal1") {
            currenttag = 1;
        } else {
            currenttag = 2;
        }

        if (currenttag == this._gamegoal) {
            return;
        } else {
            this.changeGameGoalUI(this._gamegoal, currenttag);
            this._gamegoal = currenttag;
        }
    },

    changeGameGoalUI: function (lastselect, currentselect) {
        var btnlast = this.innerBg.getChildByName("btnGameGoal" + lastselect);
        var textlast = this.innerBg.getChildByName("textgoal" + lastselect);
        var btncurrent = this.innerBg.getChildByName("btnGameGoal" + currentselect);
        var textcurrent = this.innerBg.getChildByName("textgoal" + currentselect);
        btnlast.loadTexture("fish_fight_res35.png", ccui.Widget.PLIST_TEXTURE);
        textlast.setColor(cc.color("00fffc"));
        btncurrent.loadTexture("fish_fight_res33.png", ccui.Widget.PLIST_TEXTURE);
        textcurrent.setColor(cc.color("fff000"));
    },

    selectGameTime: function (sender) {
        var name = sender.getName();
        cc.log("selectGameTime:" + name);
        var currenttag = 0;
        if (name == "btnGameTime0") {
            currenttag = 0;
        } else if (name == "btnGameTime1") {
            currenttag = 1;
        } else {
            currenttag = 2;
        }

        if (currenttag == this._gametime) {
            return;
        } else {
            this.changeGameTimeUI(this._gametime, currenttag);
            this._gametime = currenttag;
        }
    },

    changeGameTimeUI: function (lastselect, currentselect) {
        var btnlast = this.innerBg.getChildByName("btnGameTime" + lastselect);
        var textlast = this.innerBg.getChildByName("texttime" + lastselect);
        var btncurrent = this.innerBg.getChildByName("btnGameTime" + currentselect);
        var textcurrent = this.innerBg.getChildByName("texttime" + currentselect);
        btnlast.loadTexture("fish_fight_res35.png", ccui.Widget.PLIST_TEXTURE);
        textlast.setColor(cc.color("00fffc"));
        btncurrent.loadTexture("fish_fight_res33.png", ccui.Widget.PLIST_TEXTURE);
        textcurrent.setColor(cc.color("fff000"));
    },

    selectGamePeople: function (sender) {
        var name = sender.getName();
        cc.log("selectGamePeople:" + name);
        var currenttag = 0;
        if (name == "btnGamePeople0") {
            currenttag = 0;
        } else if (name == "btnGamePeople1") {
            currenttag = 1;
        } else {
            currenttag = 2;
        }

        if (currenttag == this._gamepeo) {
            return;
        } else {
            this.changeGamePeopUI(this._gamepeo, currenttag);
            this._gamepeo = currenttag;
            this.changeRewardUI();
        }
    },

    changeGamePeopUI: function (lastselect, currentselect) {
        var btnlast = this.innerBg.getChildByName("btnGamePeople" + lastselect);
        var textlast = this.innerBg.getChildByName("textpep" + lastselect);
        var btncurrent = this.innerBg.getChildByName("btnGamePeople" + currentselect);
        var textcurrent = this.innerBg.getChildByName("textpep" + currentselect);
        btnlast.loadTexture("fish_fight_res35.png", ccui.Widget.PLIST_TEXTURE);
        textlast.setColor(cc.color("00fffc"));
        btncurrent.loadTexture("fish_fight_res33.png", ccui.Widget.PLIST_TEXTURE);
        textcurrent.setColor(cc.color("fff000"));
    },

    selectGameType: function (sender) {
        var name = sender.getName();
        cc.log("selectGameType:" + name);
        var currenttag = 0;
        if (name == "btnGameType0") {
            currenttag = 0;
        } else {
            currenttag = 1;
        }
        if (currenttag == this._gametype) {
            return;
        } else {
            this._gametype = currenttag;
            this.changeGameTypeUI();
            this.changeRewardUI();
        }

    },

    changeGameTypeUI: function () {
        cc.log("changeGameTypeUI");
        var btn0 = this.innerBg.getChildByName("btnGameType0");
        var tip0 = btn0.getChildByName("pic");
        var btn1 = this.innerBg.getChildByName("btnGameType1");
        var tip1 = btn1.getChildByName("pic");
        if (this._gametype == 0) {
            btn0.loadTexture("fish_fight_res23.png", ccui.Widget.PLIST_TEXTURE);
            tip0.setVisible(true);
            btn1.loadTexture("fish_fight_res24.png", ccui.Widget.PLIST_TEXTURE);
            tip1.setVisible(false);
        } else {
            btn0.loadTexture("fish_fight_res29.png", ccui.Widget.PLIST_TEXTURE);
            tip0.setVisible(false);
            btn1.loadTexture("fish_fight_res28.png", ccui.Widget.PLIST_TEXTURE);
            tip1.setVisible(true);
        }
    },

    addLoading: function () {
        var size = cc.winSize;
        var layer = new cc.LayerColor(cc.color(0, 0, 0, 0), size.width, size.height);
        var touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            }
        });

        cc.eventManager.addListener(touchListener, layer);
        var loadingBg = new cc.Sprite('#crystal56.png');
        if (loadingBg) {
            layer.addChild(loadingBg);
            loadingBg.setPosition(cc.p(layer.width / 2, layer.height / 2));

            var circle = new cc.Sprite("#crystal55.png");
            if (circle) {
                loadingBg.addChild(circle);
                circle.setPosition(cc.p(loadingBg.width / 2, loadingBg.height / 2));
                var rotate = new cc.RotateBy(0.3, 30);
                circle.runAction(new cc.RepeatForever(rotate));
            }
        }
        this.addChild(layer, 100, "loadinglayer");
    },

    removeLoading: function () {
        var loadinglayer = this.getChildByName("loadinglayer");
        if (loadinglayer) {
            loadinglayer.removeFromParent(true);
        }

    },

    timeCount: function (dt) {
//        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

});

var FishFightWrongSequence = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(function () {
            self.confirmContinue();
        }, cc.p(bg.width * 0.75, bg.height * 0.2 - 15));
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.2 - 15));
        var innerBg = this.addInnerBg(cc.size(586, 220));


        var mstr = "您的奖励分配不合理，是否继续创建？";
        var tip = new ccui.Text(mstr, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 28);
        if (tip) {
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.5));
            innerBg.addChild(tip, 0, 10);
        }
    },

    confirmContinue: function () {
        cc.log("confirmContinue");
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(FishFightLayer.FishFightCreate);
        if (layer && layer.sendInfoToServer) {
            layer.sendInfoToServer();
        }
    },
});

var FishFightNoQualification = DialogLayer.extend({

    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.75, bg.height * 0.2 - 15));
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.2 - 15));
        var innerBg = this.addInnerBg(cc.size(586, 220));

        var mstr = "您的账号存在异常\n如需创建房间请联系客服QQ:3003674856";


        var tip = new ccui.Text(mstr, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 24);
        if (tip) {
            tip.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
            tip.setTextAreaSize(cc.size(500, 90));
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.5));
            innerBg.addChild(tip, 0, 10);
        }
    },
});

var FishFightTableDissolveNotice = DialogLayer.extend({
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addConfirmBtn(undefined, cc.p(bg.width * 0.5, bg.height * 0.2 - 15));
        var innerBg = this.addInnerBg(cc.size(586, 220));

        var mstr = "房间已被房主解散";

        var tip = new ccui.Text(mstr, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 30);
        if (tip) {
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.5));
            innerBg.addChild(tip, 0, 10);
        }
    },
});

var FishFightTableDissolveConfirm = DialogLayer.extend({
    _tableid: null,
    ctor: function (id) {
        this._super();
        this._tableid = id;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.2 - 15));
        this.addConfirmBtn(function (sender) {
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.2 - 15));
        var innerBg = this.addInnerBg(cc.size(586, 220));
        var mstr = "您确定要解散比赛吗？所有比赛奖励将会返还给您。";

        var tip = new ccui.Text(mstr, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 26);
        if (tip) {
            tip.setTextAreaSize(cc.size(500, 75));
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.5));
            innerBg.addChild(tip, 0, 10);
        }
    },

    confirmCallBack: function () {
        this.removeFromParent(true);
        //var scene = FYEngine.getRunningLayer(0);
        // if(scene){
        //     var layer = scene.getChildByName(FishFightLayer.FishFightWatingLayer);
        //     if(layer){
        //         layer.removeFromParent(true);
        //     }
        // }
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler && handler._canSendNormalMsg) {
            handler.sendDissolveReq(this._tableid);
        }
    },
});

var FishFightTableLeaveConfirm = DialogLayer.extend({

    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(647, 392));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        this.addCancelBtn(undefined, cc.p(bg.width * 0.25, bg.height * 0.2 - 15));
        this.addConfirmBtn(function (sender) {
            self.confirmCallBack();
        }, cc.p(bg.width * 0.75, bg.height * 0.2 - 15));
        var innerBg = this.addInnerBg(cc.size(586, 220));
        var mstr = "您确定要退出房间吗？";

        var tip = new ccui.Text(mstr, FYEngine.LanguageString.getValue(LoginMsgKey.Yahei), 26);
        if (tip) {
            tip.setPosition(cc.p(innerBg.width / 2, innerBg.height * 0.5));
            innerBg.addChild(tip, 0, 10);
        }
    },

    confirmCallBack: function () {
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(FishFightLayer.FishFightWatingLayer);
        if (layer) {
            layer.removeFromParent(true);
        }
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler && handler._canSendNormalMsg) {
            handler.sendLeaveTableReq();
        }
    },
});

var FishFightTableInfo = DialogLayer.extend({
    _data: null,
    _time: 0,
    ctor: function (data) {
        this._super();
        this._time = 0;
        this._data = data;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        this.addLayerBg(cc.size(625, 400));
        var innerbg = this.addInnerBg(cc.size(570, 300));
        innerbg.setPosition(cc.p(this.layerbg.width / 2, this.layerbg.height * 0.45));

        var roomtitle = new cc.Sprite("#fish_fight_res32.png");
        if (roomtitle) {
            this.layerbg.addChild(roomtitle, 1, "roomtitle");
            roomtitle.setPosition(cc.p(250, 355));
        }

        var roomnumber = FYEngine.createAlts(FishFightNum.NUM2, 10, "" + this._data.iTableId, '0');
        if (roomnumber) {
            roomnumber.setPosition(cc.p(320, 355));
            roomnumber.setAnchorPoint(cc.p(0, 0.5));
            this.layerbg.addChild(roomnumber, 2, "shownum");
        }

        var minfo = ["" + this._data.iMaxPlayer + "人",
            Math.floor(this._data.iTimeMs / 60000) + "分钟",
            "" + this._data.iDesScore];
        var lefttip = ["fish_fight_res8.png", "fish_fight_res10.png", "fish_fight_res11.png", "fish_fight_res12.png"];
        for (var i = 0; i < 4; ++i) {
            var ltip = new cc.Sprite("#" + lefttip[i]);
            if (ltip) {
                innerbg.addChild(ltip, 0, "ltip" + i);
                ltip.setAnchorPoint(cc.p(0, 0.5));
                ltip.setPosition(cc.p(30, 270 - i * 40));
            }
        }

        for (var j = 0; j < 3; ++j) {
            cc.log(j + "-----:" + minfo[j]);
            var tresult = new ccui.Text(minfo[j], "", 24);
            if (tresult) {
                innerbg.addChild(tresult, 4, "tresult" + j);
                tresult.setPosition(cc.p(160, 270 - j * 40));
                tresult.setAnchorPoint(cc.p(0, 0.5));
                tresult.setColor(cc.color("f7ff76"));
            }
        }

        var posconfig = [{}, {}, {
            startx: 200,
            range: 200,
        }, {
            startx: 140,
            range: 145,
        }, {
            startx: 70,
            range: 145,
        }];
        var picname = this._data.iCoinType == 1 ? "fish_fight_res1.png" : "fish_boom55.png";
        var wreward = ["第一名", "第二名", "第三名", "第四名"];
        for (var k = 0; k < this._data.iMaxPlayer; ++k) {
            var treward = new ccui.Text(wreward[k], "", 22);
            if (treward) {
                innerbg.addChild(treward, 4, "treward" + k);
                treward.setPosition(cc.p(posconfig[this._data.iMaxPlayer].startx + k * posconfig[this._data.iMaxPlayer].range, 115));
                treward.setColor(cc.color("00fffc"));
            }

            var piccoupon = new ccui.ImageView(picname, ccui.Widget.PLIST_TEXTURE);
            if (piccoupon) {
                var tsize = 24;
                if (this._data.iCoinType != 1) {
                    piccoupon.setScale(0.8);
                    tsize = 30;
                }
                innerbg.addChild(piccoupon, 4, "piccoupon" + k);
                piccoupon.setPosition(cc.p(posconfig[this._data.iMaxPlayer].startx + k * posconfig[this._data.iMaxPlayer].range, 60));

                var txt = ccui.Text("x" + this._data.iPrize[k], '微软雅黑', tsize);
                if (txt) {
                    txt.setAnchorPoint(cc.p(1, 0));
                    txt.setColor(cc.color("fff000"));
                    txt.enableOutline(cc.color("0b394e"), 2);
                    txt.setPosition(cc.p(piccoupon.width - 8, 8));
                    piccoupon.addChild(txt, 0);
                }
            }

        }

        var btncancel = new ccui.ImageView("dialog_17.png", ccui.Widget.PLIST_TEXTURE);
        if (btncancel) {
            this.layerbg.addChild(btncancel, 5, "btncance");
            btncancel.setTouchEnabled(true);
            btncancel.setPosition(cc.p(this.layerbg.width * 0.3, -60));
            btncancel.addTouchEventListener(this.btnTouchEft, this);
            btncancel.addClickEventListener(function () {
                self.removeFromParent(true);
            });

            var btntip = new cc.Sprite("#smallwines20.png");
            if (btntip) {
                btncancel.addChild(btntip);
                btntip.setPosition(cc.p(btncancel.width / 2, btncancel.height * 0.6));
            }
        }

        var btnJoin = new ccui.ImageView("fish_fight_res40.png", ccui.Widget.PLIST_TEXTURE);
        if (btnJoin) {
            this.layerbg.addChild(btnJoin, 5, "btnJoin");
            btnJoin.setTouchEnabled(true);
            btnJoin.setPosition(cc.p(this.layerbg.width * 0.7, -60));
            btnJoin.addTouchEventListener(this.btnTouchEft, this);
            btnJoin.addClickEventListener(function () {
                self.joinTabel();
            });
        }

    },

    joinTabel: function () {
        cc.log("joinTabel");
        var handler = CoreServiceProxy.getInstance().getGameHandler();
        if (handler && handler._canSendNormalMsg) {
            this._time = 0;
            this.addLoading();
            this.schedule(this.timeCount, 1);
            handler.sendJoinTabelReq(this._data.iTableId);
        }

    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    addLoading: function () {
        var size = cc.winSize;
        var layer = new cc.LayerColor(cc.color(0, 0, 0, 0), size.width, size.height);
        var touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                return true;
            }
        });

        cc.eventManager.addListener(touchListener, layer);
        var loadingBg = new cc.Sprite('#crystal56.png');
        if (loadingBg) {
            layer.addChild(loadingBg);
            loadingBg.setPosition(cc.p(layer.width / 2, layer.height / 2));

            var circle = new cc.Sprite("#crystal55.png");
            if (circle) {
                loadingBg.addChild(circle);
                circle.setPosition(cc.p(loadingBg.width / 2, loadingBg.height / 2));
                var rotate = new cc.RotateBy(0.3, 30);
                circle.runAction(new cc.RepeatForever(rotate));
            }
        }
        this.addChild(layer, 100, "loadinglayer");
    },

    removeLoading: function () {
        var loadinglayer = this.getChildByName("loadinglayer");
        if (loadinglayer) {
            loadinglayer.removeFromParent(true);
        }

    },

    timeCount: function (dt) {
        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },
});

var FishFightWatingLayer = DialogLayer.extend({
    _isOwner: false,
    _data: null,
    _currentplayer: 0,
    ctor: function (data) {
        this._super();
        this.initData(data);
        this.initUI();
        this.changeUserStatus();
    },

    initData: function (data) {
        this._data = data;
        var player = appglobal.getPlayer();
        if (player.userid == this._data.lMainRole) {
            this._isOwner = true;
        } else {
            this._isOwner = false;
        }
        this._currentplayer = 0;
        FishGlobal._FightLeftTime = this._data.iTimeMs / 1000;
    },

    dissolveTable: function () {
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(FishFightLayer.FishFightTableDissolveNotice);
        if (!layer && !this._isOwner) {
            layer = new FishFightTableDissolveNotice();
            scene.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightTableDissolveNotice);
        }
    },

    initUI: function () {
        var self = this;
        var bg = this.layerbg = new cc.Sprite("res/updatefight/fish_fight_bg.png");
        if (bg) {
            this.addChild(bg, 0, "bg");
            bg.setCascadeColorEnabled(false);
            bg.setColor(cc.color(150, 150, 150));
            bg.setPosition(cc.p(this.width / 2, this.height / 2));
        }

        if (this._isOwner) {
            var btndissolve = new ccui.ImageView("fish_fight_res69.png", ccui.Widget.PLIST_TEXTURE);
            if (btndissolve) {
                bg.addChild(btndissolve, 1, "btndissolve");
                btndissolve.setPosition(cc.p(70, 60));
                btndissolve.setTouchEnabled(true);
                btndissolve.addTouchEventListener(this.btnTouchEft, this);
                btndissolve.addClickEventListener(function (sender) {
                    self.btnCallBack(sender);
                });
            }
        } else {
            var btnquit = new ccui.ImageView("fish_fight_res52.png", ccui.Widget.PLIST_TEXTURE);
            if (btnquit) {
                bg.addChild(btnquit, 1, "btnquit");
                btnquit.setPosition(cc.p(70, 60));
                btnquit.setTouchEnabled(true);
                btnquit.addTouchEventListener(this.btnTouchEft, this);
                btnquit.addClickEventListener(function (sender) {
                    self.btnCallBack(sender);
                });
            }
        }

        this.initLeft();
        this.initRight();
    },

    phoneKeyFuntion: function () {
        cc.log("phoneKeyFuntion" + this._isOwner);
        var scene = FYEngine.getRunningLayer(0);
        if (this._isOwner) {
            var layer = scene.getChildByName(FishFightLayer.FishFightTableDissolveConfirm);
            if (!layer) {
                layer = new FishFightTableDissolveConfirm(this._data.iTableId);
                scene.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightTableDissolveConfirm);
            }
        } else {
            var layer = scene.getChildByName(FishFightLayer.FishFightTableLeaveConfirm);
            if (!layer) {
                layer = new FishFightTableLeaveConfirm();
                scene.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightTableLeaveConfirm);
            }
        }

    },

    btnCallBack: function (sender) {
        var name = sender.getName();
        cc.log("btncallbakc" + name);
        var scene = FYEngine.getRunningLayer(0);
        switch (name) {
            case "btndissolve" : {
                var layer = scene.getChildByName(FishFightLayer.FishFightTableDissolveConfirm);
                if (!layer) {
                    layer = new FishFightTableDissolveConfirm(this._data.iTableId);
                    scene.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightTableDissolveConfirm);
                }
            }
                break;
            case "btnquit" : {
                var layer = scene.getChildByName(FishFightLayer.FishFightTableLeaveConfirm);
                if (!layer) {
                    layer = new FishFightTableLeaveConfirm();
                    scene.addChild(layer, FishZorder.poplayer, FishFightLayer.FishFightTableLeaveConfirm);
                }
            }
                break;
            case "btn_start": {
                if (this._currentplayer < this._data.iMaxPlayer) {
                    FYEngine.AddCommToast("参赛人数满足后开始比赛");
                } else {
                    var handler = CoreServiceProxy.getInstance().getGameHandler();
                    if (handler && handler._canSendNormalMsg) {
                        handler.sendGameStartReq()
                    }
                }

            }
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    changeUserStatus: function () {
        cc.log("changeUserStatus" + this._data.iMaxPlayer);
        var player = appglobal.getPlayer();
        var handle = CoreServiceProxy.getInstance().getGameHandler();
        if (handle) {
            var pnumber = 0;
            var data = handle._fishData._userData;
            for (var i = 0; i < this._data.iMaxPlayer; ++i) {
                var sp = this._lbg.getChildByName("sp" + i);
                var playerhead = this._lbg.getChildByName("playerhead" + i);
                var spframe = this._lbg.getChildByName("spframe" + i);
                var playername = spframe.getChildByName("playername");
                var playerid = spframe.getChildByName("playerid");
                if (data[i]) {
                    if (data[i].lRoleId == -1) {
                        if (i == handle.getSelfId()) {
                            var scene = FYEngine.getRunningLayer(0);
                            var layer = scene.getChildByName(FishFightLayer.FishFightTableDissolveConfirm);
                            if (layer) {
                                layer.removeFromParent(true);
                            }
                            this.removeFromParent(true);
                            scene.queryWealth();
                            return;
                        }
                        playerhead.playerLeave();
                        spframe.setVisible(false);
                        sp.setVisible(false);
                    } else {
                        var faceid = data[i].szFaceId;
                        if (player.userid == data[i].lRoleId) {
                            if (player.facestatus == 0 || player.facestatus == -1) {
                                faceid = "";
                            } else {
                                faceid = player.faceid;
                            }
                        }
                        playerhead.playerJoin(faceid);
                        playername.setStringNew(data[i].szNickName);
                        playername.shortFunction();
                        playerid.setString("ID:" + data[i].lRoleId);
                        spframe.setVisible(true);
                        sp.setVisible(true);
                        pnumber++;
                    }
                }
            }
            this._currentplayer = pnumber;

            if (!this._isOwner) {
                if (this._currentplayer < this._data.iMaxPlayer) {
                    var node1 = this._lbg.getChildByName("node1");
                    node1.setVisible(true);
                    var node2 = this._lbg.getChildByName("node2");
                    node2.setVisible(false);
                } else {
                    var node1 = this._lbg.getChildByName("node1");
                    node1.setVisible(false);
                    var node2 = this._lbg.getChildByName("node2");
                    node2.setVisible(true);
                }
            } else {
                var startbtn = this._lbg.getChildByName("btn_start");
                if (this._currentplayer < this._data.iMaxPlayer) {
                    // startbtn.setColor(cc.color(100,100,100));
                    cc.log("--2");
                    var lightsprite = startbtn.getChildByName("lightani");
                    lightsprite.setVisible(false);

                } else {
                    // startbtn.setColor(cc.color(255,255,255));
                    var lightsprite = startbtn.getChildByName("lightani");
                    lightsprite.setVisible(true);
                }
            }

        }
    },

    initLeft: function () {
        var self = this;
        var lbg = this._lbg = new ccui.ImageView("fish_fight_res75.png", ccui.Widget.PLIST_TEXTURE);
        if (lbg) {
            this.layerbg.addChild(lbg, 1, "lbg");
            lbg.setPosition(cc.p(380, 325));
        }

        for (var i = 0; i < 4; ++i) {
            var sp = new cc.Sprite("#fish_fight_res65.png");
            if (sp) {
                lbg.addChild(sp, 1, "sp" + i);
                sp.setPosition(cc.p(100 + i * 160, 150));
                sp.setVisible(false);
            }

            var spframe = new ccui.ImageView("fish_fight_res61.png", ccui.Widget.PLIST_TEXTURE);
            if (spframe) {
                lbg.addChild(spframe, 1, "spframe" + i);
                spframe.setScale9Enabled(true);
                spframe.setPosition(cc.p(100 + i * 160, 105));
                spframe.setContentSize(cc.size(155, 60));
                spframe.setVisible(false);

                var playername = new FYEngine.NewLengthText2("12344", 18, 150);
                if (playername) {
                    spframe.addChild(playername, 1, "playername");
                    playername.setPosition(cc.p(spframe.width / 2, 40));
                }

                var playerid = new ccui.Text("id", "", 16);
                if (playerid) {
                    spframe.addChild(playerid, 1, "playerid");
                    playerid.setPosition(cc.p(spframe.width / 2, 20));
                    playerid.setColor(cc.color("faf866"));
                }
            }

            var playerhead = new FYEngine.FightImage("fish_fight_res67.png", "fish_fight_res71.png", "fish_fight_res59.png", (i < this._data.iMaxPlayer ? true : false));
            if (playerhead) {
                lbg.addChild(playerhead, 2, "playerhead" + i);
                playerhead.setPosition(cc.p(100 + i * 160, 220));


            }

            if (i == 0) {
                var ownerpic = new cc.Sprite("#fish_fight_res53.png");
                if (ownerpic) {
                    lbg.addChild(ownerpic, 3, "ownerpic");
                    ownerpic.setPosition(cc.p(70, 270));
                }
            }

        }

        if (this._isOwner) {
            var btn_start = new ccui.ImageView("fish_fight_res66.png", ccui.Widget.PLIST_TEXTURE);
            if (btn_start) {
                lbg.addChild(btn_start, 2, "btn_start");
                // btn_start.setColor(cc.color(100,100,100));
                btn_start.setPosition(cc.p(lbg.width / 2, 0));
                btn_start.setTouchEnabled(true);
                btn_start.addTouchEventListener(this.btnTouchEft, this);
                btn_start.addClickEventListener(function (sender) {
                    self.btnCallBack(sender);
                });

                var lightani = cc.AnimationCache.getInstance().getAnimation('fish_fight_light');
                var stemp = new cc.Sprite();
                stemp.setVisible(false);
                stemp.setAnchorPoint(cc.p(0.5, 0.5));
                stemp.setPosition(cc.p(btn_start.width / 2, btn_start.height / 2));
                btn_start.addChild(stemp, 1, "lightani");
                stemp.runAction(new cc.RepeatForever(new cc.Animate(lightani)));

            }
        } else {
            cc.log("---创建");
            var node1 = new cc.Sprite("#fish_fight_res42.png");//人数不足
            if (node1) {
                lbg.addChild(node1, 10, "node1");
                node1.setAnchorPoint(cc.p(1, 0.5));
                node1.setPosition(cc.p(lbg.width / 2 + 110, -20));
            }
            var node2 = new cc.Sprite("#fish_fight_res47.png");//等待房主
            if (node2) {
                lbg.addChild(node2, 10, "node2");
                node2.setAnchorPoint(cc.p(1, 0.5));
                node2.setPosition(cc.p(lbg.width / 2 + 110, -20));
            }

            var node = new cc.Node();
            lbg.addChild(node, 300, "conneting");
            node.setPosition(cc.p(lbg.width / 2 + 120, -20));
            for (var t = 0; t < 5; ++t) {
                var point = new cc.Sprite("#fish_fight_res43.png");
                if (point) {
                    point.setVisible(false);
                    node.addChild(point, 1, t);
                    point.setPosition(cc.p(t * 15, node.height / 2));
                }
            }
            var count = 0;
            node.runAction(cc.sequence(cc.delayTime(0.5), cc.callFunc(function () {
                if (count == 5) {
                    for (var m = 0; m < 5; ++m) {
                        var sp = node.getChildByTag(m);
                        sp && sp.setVisible(false);
                    }
                    count = 0;
                } else {
                    var sp = node.getChildByTag(count);
                    sp && sp.setVisible(true);
                    ++count;
                }
            })).repeatForever());
        }

        var roomtitle = new cc.Sprite("#fish_fight_res32.png");
        if (roomtitle) {
            lbg.addChild(roomtitle, 1, "roomtitle");
            roomtitle.setPosition(cc.p(285, 390));
        }

        var roomnumber = FYEngine.createAlts(FishFightNum.NUM2, 10, "" + this._data.iTableId, '0');
        if (roomnumber) {
            roomnumber.setPosition(cc.p(345, 390));
            roomnumber.setAnchorPoint(cc.p(0, 0.5));
            lbg.addChild(roomnumber, 2, "roomnumber");
        }

    },

    initRight: function () {
        var rightConfig = [{
            param1: 420,
            param2: 325,
            param3: 285,
            param4: 220,
            param5: 190,
            param6: 150,//地框高度
            param7: 85, //底框位置
            param8: 85,//名次图片X坐标
            param9: 115,//名次高度
            param10: 60,//图片高度
            param11: 130,//间隔

        }, {
            param1: 420,
            param2: 325,
            param3: 285,
            param4: 220,
            param5: 190,
            param6: 150,//地框高度
            param7: 85, //底框位置
            param8: 50,//名次图片X坐标
            param9: 115,//名次高度
            param10: 60,//图片高度
            param11: 100,//间隔
        }, {
            param1: 450,
            param2: 410,//下面高度
            param3: 375,//时间高度
            param4: 305,//线高度
            param5: 280,
            param6: 245,//地框高度
            param7: 135, //底框位置
            param8: 85,//名次图片X坐标
            param9: 225,//名次高度
            param10: 170,//图片高度
            param11: 130,//间隔
        }];

        var rbg = this._rbg = new ccui.ImageView("fish_fight_res72.png", ccui.Widget.PLIST_TEXTURE);
        if (rbg) {
            this.layerbg.addChild(rbg, 2, "rbg");
            rbg.setAnchorPoint(cc.p(0, 0.5));
            rbg.setPosition(cc.p(745, this.layerbg.height / 2));

            var bg1 = new ccui.ImageView("fish_fight_res68.png", ccui.Widget.PLIST_TEXTURE);
            if (bg1) {
                rbg.addChild(bg1, 0, "bg1");
                bg1.setScale9Enabled(true);
                bg1.setContentSize(cc.size(325, 55));
                bg1.setAnchorPoint(cc.p(0.5, 0));
                bg1.setPosition(cc.p(rbg.width / 2, rightConfig[this._data.iMaxPlayer - 2].param1));

                var sp1 = new cc.Sprite("#fish_fight_res50.png");
                if (sp1) {
                    bg1.addChild(sp1, 0, "sp1");
                    sp1.setPosition(cc.p(bg1.width / 2, bg1.height / 2));
                }
            }

            var infocontent = [Math.floor(this._data.iTimeMs / 60000) + "分钟", this._data.iDesScore + "分"];
            var bg2 = new ccui.ImageView("fish_fight_res70.png", ccui.Widget.PLIST_TEXTURE);
            if (bg2) {
                bg1.addChild(bg2, 0, "bg2");
                bg2.setScale9Enabled(true);
                bg2.setContentSize(cc.size(325, rightConfig[this._data.iMaxPlayer - 2].param2));
                bg2.setAnchorPoint(cc.p(0.5, 1));
                bg2.setPosition(cc.p(bg1.width / 2, 0));

                var spimage = ["fish_fight_res56.png", "fish_fight_res58.png"];
                for (var i = 0; i < 2; ++i) {
                    var titlesp = new cc.Sprite("#" + spimage[i]);
                    if (titlesp) {
                        bg2.addChild(titlesp, 0, "titlesp" + i);
                        titlesp.setPosition(cc.p(65, rightConfig[this._data.iMaxPlayer - 2].param3 - i * 40));
                    }

                    var infosp = new ccui.Text(infocontent[i], "", 24);
                    if (infosp) {
                        bg2.addChild(infosp, 0, "infosp" + i);
                        infosp.setAnchorPoint(cc.p(0, 0.5));
                        infosp.setPosition(cc.p(140, rightConfig[this._data.iMaxPlayer - 2].param3 - i * 40));
                        infosp.setColor(cc.color('e75033'));
                    }
                }

                var line = new ccui.ImageView("fish_fight_res62.png", ccui.Widget.PLIST_TEXTURE);
                if (line) {
                    bg2.addChild(line, 2, "line");
                    line.setContentSize(cc.size(306, 2));
                    line.setScale9Enabled(true);
                    line.setPosition(cc.p(bg2.width / 2, rightConfig[this._data.iMaxPlayer - 2].param4));
                }
                var sp2 = new cc.Sprite("#fish_fight_res46.png");
                if (sp2) {
                    bg2.addChild(sp2, 2, "sp2");
                    sp2.setPosition(cc.p(bg2.width / 2, rightConfig[this._data.iMaxPlayer - 2].param5));
                }

                var picname = this._data.iCoinType == 1 ? "fish_fight_res1.png" : "fish_boom55.png";
                var bg3 = new ccui.ImageView("fish_fight_res64.png", ccui.Widget.PLIST_TEXTURE);
                if (bg3) {
                    bg2.addChild(bg3, 3, "bg3");
                    bg3.setScale9Enabled(true);
                    bg3.setContentSize(cc.size(300, rightConfig[this._data.iMaxPlayer - 2].param6));
                    bg3.setPosition(cc.p(bg2.width / 2, rightConfig[this._data.iMaxPlayer - 2].param7));

                    var wreward = ["第一名", "第二名", "第三名", "第四名"];
                    if (this._data.iMaxPlayer == 4) {
                        for (var j = 0; j < this._data.iMaxPlayer; ++j) {
                            cc.log("j" + j);
                            var treward = new ccui.Text(wreward[j], "", 22);
                            if (treward) {
                                bg3.addChild(treward, 4, "treward" + j);
                                treward.setPosition(cc.p(rightConfig[this._data.iMaxPlayer - 2].param8 + (j % 2) * rightConfig[this._data.iMaxPlayer - 2].param11,
                                    rightConfig[this._data.iMaxPlayer - 2].param9 - (Math.floor(j / 2)) * 110));
                                FYEngine.logObject(treward.getPosition(), "position:");
                                treward.setColor(cc.color("2c7dd3"));
                            }

                            var piccoupon = new ccui.ImageView(picname, ccui.Widget.PLIST_TEXTURE);
                            if (piccoupon) {
                                if (this._data.iCoinType != 1) {
                                    piccoupon.setScale(0.8);
                                }
                                bg3.addChild(piccoupon, 4, "picname" + j);
                                piccoupon.setPosition(cc.p(rightConfig[this._data.iMaxPlayer - 2].param8 + (j % 2) * rightConfig[this._data.iMaxPlayer - 2].param11,
                                    rightConfig[this._data.iMaxPlayer - 2].param10 - Math.floor((j / 2)) * 110));

                                var txt = ccui.Text("x" + this._data.iPrize[j], '微软雅黑', 18);
                                if (txt) {
                                    txt.setAnchorPoint(cc.p(1, 0));
                                    txt.setColor(cc.color("fff000"));
                                    txt.enableOutline(cc.color("0b394e"), 2);
                                    txt.setPosition(cc.p(piccoupon.width - 5, 6));
                                    piccoupon.addChild(txt, 0);
                                }
                            }
                        }
                    } else {
                        for (var j = 0; j < this._data.iMaxPlayer; ++j) {
                            var treward = new ccui.Text(wreward[j], "", 22);
                            if (treward) {
                                bg3.addChild(treward, 4, "treward" + j);
                                treward.setPosition(cc.p(rightConfig[this._data.iMaxPlayer - 2].param8 + j * rightConfig[this._data.iMaxPlayer - 2].param11,
                                    rightConfig[this._data.iMaxPlayer - 2].param9));
                                treward.setColor(cc.color("2c7dd3"));
                            }

                            var piccoupon = new ccui.ImageView(picname, ccui.Widget.PLIST_TEXTURE);
                            if (piccoupon) {
                                var tsize = 24;
                                if (this._data.iCoinType != 1) {
                                    piccoupon.setScale(0.8);
                                    tsize = 30;
                                }
                                bg3.addChild(piccoupon, 4, "picname" + j);
                                piccoupon.setPosition(cc.p(rightConfig[this._data.iMaxPlayer - 2].param8 + j * rightConfig[this._data.iMaxPlayer - 2].param11,
                                    rightConfig[this._data.iMaxPlayer - 2].param10));
                                var txt = ccui.Text("x" + this._data.iPrize[j], '微软雅黑', tsize);
                                if (txt) {
                                    txt.setAnchorPoint(cc.p(1, 0));
                                    txt.setColor(cc.color("fff000"));
                                    txt.enableOutline(cc.color("0b394e"), 2);
                                    txt.setPosition(cc.p(piccoupon.width - 8, 8));
                                    piccoupon.addChild(txt, 0);
                                }
                            }
                        }
                    }

                }
            }

        }

    },


});

var ShareFriendLayer = DialogLayer.extend({

    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var layerbg = this.layerbg = new ccui.ImageView("fish_share_res9.png", ccui.Widget.PLIST_TEXTURE);
        if (layerbg) {
            this.addChild(layerbg, 0, "layerbg");
            layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        }

        this.addCloseBtn();

        var qr = appglobal.CreateQRCodeImg(130);
        if (qr) {
            layerbg.addChild(qr, 10, "qr");
            qr.setPosition(cc.p(50, 110));
        }
    },

});


var CopyResultLayer = DialogLayer.extend({
    _data: [],
    ctor: function (count) {
        this._super();
        this._data = count;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var bg = this.addLayerBg(cc.size(650, 440));
        this.addTitleBg(FishSceneRes.DialogPng.TitleTip, 654);
        this.addCloseBtn();
        var innerBg = this.addInnerBg(cc.size(586, 260));
        innerBg.setPosition(cc.p(bg.width / 2, bg.height * 0.55));

        var btn_next = new ccui.ImageView("dialog_17.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_next) {
            this.layerbg.addChild(btn_next, 1, "btn_next");
            btn_next.setTouchEnabled(true);
            btn_next.setPosition(cc.p(this.layerbg.width * 0.25, 65));
            btn_next.addTouchEventListener(this.btnTouchEft, this);
            btn_next.addClickEventListener(function () {
                self.removeFromParent(true);
            });

            var tip1 = new cc.Sprite("#fish_copy_34.png");
            if (tip1) {
                btn_next.addChild(tip1, 1, "tip1");
                tip1.setPosition(cc.p(btn_next.width / 2, btn_next.height * 0.6));
            }
        }

        var btn_hecheng = new ccui.ImageView("dialog_18.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_hecheng) {
            this.layerbg.addChild(btn_hecheng, 1, "btn_hecheng");
            btn_hecheng.setTouchEnabled(true);
            btn_hecheng.setPosition(cc.p(this.layerbg.width * 0.75, 65));
            btn_hecheng.addTouchEventListener(this.btnTouchEft, this);
            btn_hecheng.addClickEventListener(function () {
                self.removeFromParent(true);
                var scene = FYEngine.getRunningLayer(0);
                var layer = scene.getChildByName(FishCopyLobbyLayer.hechenglayer);
                if (!layer) {
                    layer = new HeChengLayer();
                    scene.addChild(layer, FishZorder.poplayer, FishCopyLobbyLayer.hechenglayer);
                    FYEngine.popupLayerAnimate(layer.layerbg);
                }
            });

            var tip2 = new cc.Sprite("#fish_copy_33.png");
            if (tip2) {
                btn_hecheng.addChild(tip2, 1, "tip2");
                tip2.setPosition(cc.p(btn_hecheng.width / 2, btn_hecheng.height * 0.6));
            }
        }
        this.showInnerBg();
    },

    showInnerBg: function () {
        var content1 = new ccui.Text("本次副本获得材料：", "", 30);
        if (content1) {
            this.innerBg.addChild(content1, 0, "content1");
            content1.setAnchorPoint(cc.p(0, 0.5));
            content1.setPosition(cc.p(30, 220));
            // content1.setTextColor(cc.color("8a5438"));
        }

        var tipname = ["fish_copy_27.png", "fish_copy_24.png", "fish_copy_28.png", "fish_copy_26.png", "fish_copy_25.png"];
        var labelname = ["beike", "haixing", "shanhu", "shuijing", "zhenzhu"];
        for (var i = 0; i < 5; ++i) {
            var tip = new ccui.ImageView(tipname[i], ccui.Widget.PLIST_TEXTURE);
            if (tip) {
                tip.setScale(0.6);
                this.innerBg.addChild(tip, 0, "tipname" + i);
                tip.setPosition(cc.p(45 + (i % 3) * 190, 170 - Math.floor(i / 3) * 55));
            }
            // var labgold = FYEngine.createAlts('res/num/fish_number.png', 12, 0, '.');
            var labgold = ccui.Text("X0", "", 26);
            labgold.setTextColor(cc.color("d95a0d"));
            labgold.setPosition(cc.p(75 + (i % 3) * 190, 170 - Math.floor(i / 3) * 55));
            labgold.setAnchorPoint(cc.p(0, 0.5));
            labgold.setTextColor(cc.color("07f9e5"));
            this.innerBg.addChild(labgold, 1, labelname[i]);
        }

        var content2 = new ccui.Text("材料可用于合成奖券和弹头，或直接出售换取金币", "", 30);
        if (content1) {
            this.innerBg.addChild(content2, 0, "content2");
            content2.setAnchorPoint(cc.p(0, 0.5));
            content2.setPosition(cc.p(30, 50));
            content2.setTextAreaSize(cc.size(530, 75));
            // content2.setTextColor(cc.color("8a5438"));
        }

        for (var j = 0; j < this._data.length; ++j) {
            if (this._data[j].iCoinType == FishGlobal.WealthType.beike) {
                var beike = this.innerBg.getChildByName("beike");
                beike.setString("X" + this._data[j].iCoinCount);
            } else if (this._data[j].iCoinType == FishGlobal.WealthType.shuijing) {
                var shuijing = this.innerBg.getChildByName("shuijing");
                shuijing.setString("X" + this._data[j].iCoinCount);
            } else if (this._data[j].iCoinType == FishGlobal.WealthType.shanhu) {
                var shanhu = this.innerBg.getChildByName("shanhu");
                shanhu.setString("X" + this._data[j].iCoinCount);
            } else if (this._data[j].iCoinType == FishGlobal.WealthType.haixing) {
                var haixing = this.innerBg.getChildByName("haixing");
                haixing.setString("X" + this._data[j].iCoinCount);
            } else if (this._data[j].iCoinType == FishGlobal.WealthType.zhenzhu) {
                var zhenzhu = this.innerBg.getChildByName("zhenzhu");
                zhenzhu.setString("X" + this._data[j].iCoinCount);
            }
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

});


var ShareSelectLayer = DialogLayer.extend({
    ctor: function () {
        this._super();

        this.initUI();
    },

    initUI: function () {
        var self = this;
        this.addLayerBg(cc.size(550, 303));
        this.addCloseBtn();

        var btn_1 = new ccui.ImageView("fish_share_res11.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_1) {
            this.layerbg.addChild(btn_1, 1, "btn_1");
            btn_1.setTouchEnabled(true);
            btn_1.setPosition(cc.p(this.layerbg.width * 0.28, this.layerbg.height / 2));
            btn_1.addTouchEventListener(this.btnTouchEft, this);
            btn_1.addClickEventListener(function (sender) {
                self.removeFromParent(true);
                self.btnCallBack(sender);
            });
        }

        var btn_2 = new ccui.ImageView("fish_share_res10.png", ccui.Widget.PLIST_TEXTURE);
        if (btn_2) {
            this.layerbg.addChild(btn_2, 1, "btn_2");
            btn_2.setTouchEnabled(true);
            btn_2.setPosition(cc.p(this.layerbg.width * 0.72, this.layerbg.height / 2));
            btn_2.addTouchEventListener(this.btnTouchEft, this);
            btn_2.addClickEventListener(function (sender) {
                self.removeFromParent(true);
                self.btnCallBack(sender);
            });
        }


    },

    btnCallBack: function (sender) {
        cc.log("--:" + sender.getName());
        var name = sender.getName();
        var m_tag = 0;
        if (name == "btn_1") {
            m_tag = 0;
        } else {
            m_tag = 1;
        }

        var base = new Base64();
        var data = {
            type: 1,
            data1: appglobal.getShareUrl(),
            data2: "",
            data3: "",
            tag: m_tag,
            title: base.encode(appglobal.getAppName()),
            description: base.encode("满屏爆金High翻天，百万金币每天领，天降红包挡不住，街机捕鱼等你来，千人竞技嗨到底！"),
            imageUrl: appglobal.getImageUrl()
        };

        app.sdkPlugin.callNativeMethod("WXShare", JSON.stringify(data));
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },
});

var LayerCheckIn = DialogLayer.extend({
    _itemArr: [],
    _infoArr: [],
    _gotData: false,
    _lastDay: 7,//第7天
    _isClose: false,
    _time: 0,
    _isMove: false,
    ctor: function () {
        this._super();
        this._itemArr = [];
        this._infoArr = [];
        this._gotData = false;
        this._isClose = false;
        this._time = 0;
        this._isMove = false;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/ResCheckin/LayerChecin.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 0, 'mainscene');

        var btn_checkin = this._btn_checkin = this.layerbg.getChildByName("bg").getChildByName("btn_checkin");
        btn_checkin.addTouchEventListener(this.btnTouchEft, this);
        btn_checkin.addClickEventListener(function (sender) {
            self.btnClickCallBack(sender);
        });
        var btn_checkin_already = this._btn_checkin_already = this.layerbg.getChildByName("bg").getChildByName("btn_checkin_already");
        btn_checkin_already.addTouchEventListener(this.btnTouchEft, this);
        btn_checkin_already.addClickEventListener(function (sender) {
            self.btnClickCallBack(sender);
        });

        var btn_quit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btn_quit.addClickEventListener(function () {
            self.closeCallBack();
        });

        this.scheduleOnce(this.timeOutCheck, 15);
        this.addLoading();
        this.getInfoFromServer();

    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

    closeCallBack: function () {

        if (this._isClose == true) {
            FYEngine.popoutLayerAnimate(this.layerbg);
            return;
        }

        if (this._isMove == true) {
            return;
        }


        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.LayerCheckinResult);
        if (layer) {
            layer.removeFromParent(true);
            return;
        }

        var loadinglayer = this.getChildByName("loadingnew");
        if (loadinglayer) {
            return;
        }

        if (FishGlobal.CheckIn.iStatus == 0) {
            var layer1 = scene.getChildByName(LobbySceneName.LayerCheckinConfirm);
            if (layer1) {
                layer1.removeFromParent(true);
            } else {
                layer1 = new LayerCheckinConfirm();
                scene.addChild(layer1, FishZorder.poplayer, LobbySceneName.LayerCheckinConfirm);
                FYEngine.popupLayerAnimate(layer1.layerbg);
            }
        } else {
            this._isMove = true;
            FYEngine.popoutLayerAnimate(this.layerbg);
        }
    },

    btnClickCallBack: function (sender) {
        this._time = 0;
        var name = sender.getName();
        if (name == "btn_checkin") {
            var handle = CoreServiceProxy.getInstance().getLobbyHandler();
            if (handle && handle._canSendNormalMsg) {
                handle.sendGetCheckinResult();
                this.addGetLoading();
                this.schedule(this.timeCount, 1);
            }
        } else {
            FYEngine.AddCommToast("您今日已经签到过了，明天再来吧");
        }
    },

    getInfoFromServer: function () {
        var handle = CoreServiceProxy.getInstance().getLobbyHandler();
        if (handle && handle._canSendNormalMsg) {
            handle.sendQueryCheckinCfgReq();
        }
    },

    addLoading: function () {
        var _sprite = FYEngine.createSprite(SccomRes.MallRes.loadingbg, cc.p(this.layerbg.width / 2, this.layerbg.height * 0.5));
        if (_sprite) {
            this.layerbg.addChild(_sprite, 99, SccomLayerName.loading);
            var rotate = new cc.RotateBy(1.2, 360);
            _sprite.runAction(new cc.RepeatForever(rotate));
        }
    },

    removeLoading: function () {
        var fish = this.layerbg.getChildByName(SccomLayerName.loading);
        if (fish) {
            fish.removeFromParent(true);
        }
    },

    timeOutCheck: function () {
        if (this._gotData == false) {
            this._isClose = true;
            this.removeLoading();
            this.addLoadFailTip();
        }
    },

    addLoadFailTip: function () {
        var LoadFail = this.layerbg.getChildByName("bg").getChildByName("LoadFail");
        LoadFail.setVisible(true);
    },

    showLayer: function () {
        if (this._isClose == true) {
            return;
        }
        this._gotData = true;
        this._itemArr = [];
        this._infoArr = [];
        this.removeLoading();
        var text = this.layerbg.getChildByName("bg").getChildByName("content");
        text.setVisible(true);

        this.initCheckInItem();
        this.refreshBtnStatus();
    },

    initCheckInItem: function () {
        var self = this;
        var bg = this.layerbg.getChildByName("bg");
        var shape = new cc.DrawNode();
        shape.drawRect(cc.p(0, 0), cc.p(785, 360), cc.color(255, 255, 255, 255));
        var mask = new cc.ClippingNode(shape);
        mask.setAnchorPoint(cc.p(0.5, 0.5));
        mask.setPosition(cc.p(30, 135));
        bg.addChild(mask, 1, "mask");
        if (FishGlobal.CheckIn.iCheckinDays == this._lastDay && FishGlobal.CheckIn.iStatus == 0) {
            this._infoArr = [0, 1];
        } else {
            this._infoArr = [0];
        }

        var index = 0;
        this._infoArr.forEach(() => {
            let pageitem = new ItemCheckIn(index);
            self._itemArr.push(pageitem);
            pageitem.setAnchorPoint(cc.p(0, 0));
            mask.addChild(pageitem, 1, "pageitem" + index);
            if (index > 0) {
                pageitem.setPositionX(800);
            } else {
                pageitem.setPositionX(10);
            }
            index++;
        });
    },

    checkInOk: function () {
        if (FishGlobal.CheckIn.iCheckinDays == 7) {
            var content = this.layerbg.getChildByName("bg").getChildByName("content");
            content.setString("连续签到奖励已重置，记得明天继续来签到哦~");
            this.moveFunction();
        } else {
            var content = this.layerbg.getChildByName("bg").getChildByName("content");
            content.setString("连续签到一旦中断，便会从第一天重新计算！记得来签到哦");
        }
    },

    refreshStatus: function () {
        if (this._itemArr.length > 0) {
            var item = this._itemArr[0];
            if (item) {
                item.initUI();
            }
        }
        this.refreshBtnStatus();
    },

    refreshBtnStatus: function () {
        FishGlobal.CheckIn.iStatus;
        var btn_checkin = this._btn_checkin = this.layerbg.getChildByName("bg").getChildByName("btn_checkin");
        var btn_checkin_already = this._btn_checkin_already = this.layerbg.getChildByName("bg").getChildByName("btn_checkin_already");
        if (FishGlobal.CheckIn.iStatus == 1) {
            btn_checkin.setVisible(false);
            btn_checkin_already.setVisible(true);
        } else {
            btn_checkin.setVisible(true);
            btn_checkin_already.setVisible(false);
        }
    },

    moveFunction: function () {
        if (this._itemArr.length > 1) {
            var self = this;
            this._isMove = true;
            var item1 = this._itemArr[0];
            var item2 = this._itemArr[1];
            item1.runAction(new cc.Sequence(new cc.DelayTime(0.3), new cc.MoveTo(0.3, cc.p(-1136, 0)), new cc.CallFunc(function () {
                self._isMove = false;
            })));
            item2.runAction(new cc.Sequence(new cc.DelayTime(0.3), new cc.MoveTo(0.3, cc.p(-20, 0)).easing(cc.easeIn(3)), new cc.MoveTo(0.1, cc.p(10, 0))));
        }
    },

    onExit: function () {
        this._super();
        FishGlobal.stoptip = 0;
        var scene = FYEngine.getRunningLayer(0);
        if (scene && scene.onGameEvent) {
            scene.onGameEvent(lobbyGameEvent.refreshWealth);
        }

    },

    addGetLoading: function () {
        var layer = FYEngine.CreateAccRelatedLoading();
        if (layer) {
            this.addChild(layer, 100, "loadingnew");
        }
    },

    removeGetLoading: function () {
        var loadinglayer = this.getChildByName("loadingnew");
        if (loadinglayer) {
            loadinglayer.removeFromParent(true);
        }
    },

    timeCount: function (dt) {
        cc.log('@@@@@@@@@' + this._time);
        this._time += dt;
        if (this._time > 14) {
            this._time = 0;
            this.removeGetLoading();
            FYEngine.AddCommToast("请求超时，请稍后再试");
            this.unschedule(this.timeCount);
        }
    },

});

var ItemCheckIn = ccui.ImageView.extend({
    _item: 0,
    _info: null,
    ctor: function (i) {
        var self = this;
        this._super();
        this._item = i;
        this.setScale9Enabled(true);
        this.setEnabled(true);
        this.setContentSize(cc.size(775, 355));

        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/ResCheckin/ItemCheckin.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 0, 'mainscene');
        if (this._item == 0) {
            if (FishGlobal.CheckIn.iCheckinDays == 7 && FishGlobal.CheckIn.iStatus == 1) {
                this.initUI2();
            } else {
                this.initUI();
            }
        } else {
            this.initUI2();
        }
    },

    initUI: function () {
        this._info = FishGlobal.CheckIn.cfg;
        for (var i = 0; i < 7; ++i) {
            if (this._info[i].iDays < FishGlobal.CheckIn.iCheckinDays) {//签到过了
                this.setAlredyCheckin(i, this._info[i].iDays);
            } else if (this._info[i].iDays > FishGlobal.CheckIn.iCheckinDays) {//没签到的
                this.setNotCheckin(i, this._info[i].iDays);
            } else {//签到当天的
                if (FishGlobal.CheckIn.iStatus == 1) {//当天已签到
                    this.setAlredyCheckin(i, this._info[i].iDays);
                } else {
                    this.setCurrent(i, this._info[i].iDays);
                }
            }
        }
    },

    initUI2: function () {
        this._info = FishGlobal.CheckIn.cfg;
        for (var i = 0; i < 7; ++i) {
            this.setNotCheckin(i, this._info[i].iDays);
        }
    },

    setAlredyCheckin: function (i, realday) {
        cc.log("" + realday);
        var cfg = FishGlobal.CheckIn.cfg;
        var dayitem = this.layerbg.getChildByName("day" + realday);
        var canget = dayitem.getChildByName("canget");
        var alreadyget = dayitem.getChildByName("alreadyget");
        var current = dayitem.getChildByName("current");
        current.setVisible(false);

        var day = canget.getChildByName("day");
        day.setString(realday == 1 ? "第1天" : "连续{0}天".format(realday));
        var pro_pic_coupon = canget.getChildByName("pro_pic_coupon");
        var pro_pic_gold = canget.getChildByName("pro_pic_gold");
        var pro_des = canget.getChildByName("pro_des");
        if (cfg[i].iCoinValue1 > 0 && cfg[i].iCoinValue2 > 0) {//都有 todo

        } else if (cfg[i].iCoinValue1 > 0) {//奖券
            pro_pic_gold.setVisible(false);
            pro_pic_coupon.setVisible(true);
            pro_des.setString(cfg[i].iCoinValue1);
        } else {
            pro_pic_gold.setVisible(true);
            pro_pic_coupon.setVisible(false);
            pro_des.setString(cfg[i].iCoinValue2);
        }
        canget.setColor(cc.color(150, 150, 150));
        alreadyget.setVisible(true);
        canget.setVisible(true);
    },

    setNotCheckin: function (i, realday) {
        var cfg = FishGlobal.CheckIn.cfg;
        var dayitem = this.layerbg.getChildByName("day" + realday);
        var canget = dayitem.getChildByName("canget");
        var alreadyget = dayitem.getChildByName("alreadyget");
        var current = dayitem.getChildByName("current");
        current.setVisible(false);
        alreadyget.setVisible(false);
        canget.setColor(cc.color(255, 255, 255));
        canget.setVisible(true);

        var pro_pic_coupon = canget.getChildByName("pro_pic_coupon");
        var pro_pic_gold = canget.getChildByName("pro_pic_gold");

        var day = canget.getChildByName("day");
        day.setString(realday == 1 ? "第1天" : "连续{0}天".format(realday));

        var pro_des = canget.getChildByName("pro_des");
        if (cfg[i].iCoinValue1 > 0 && cfg[i].iCoinValue2 > 0) {//都有 todo

        } else if (cfg[i].iCoinValue1 > 0) {//奖券
            pro_pic_coupon.setVisible(true);
            pro_pic_gold.setVisible(false);
            pro_des.setString(cfg[i].iCoinValue1);
        } else {
            pro_pic_gold.setVisible(true);
            pro_pic_coupon.setVisible(false);
            pro_des.setString(cfg[i].iCoinValue2);
        }
    },

    setCurrent: function (i, realday) {
        var cfg = FishGlobal.CheckIn.cfg;
        var dayitem = this.layerbg.getChildByName("day" + realday);
        var canget = dayitem.getChildByName("canget");
        var alreadyget = dayitem.getChildByName("alreadyget");
        var current = dayitem.getChildByName("current");
        current.setVisible(true);
        alreadyget.setVisible(false);
        canget.setVisible(false);
        canget.setColor(cc.color(255, 255, 255));

        var pro_pic_coupon = current.getChildByName("pro_pic_coupon");
        var pro_pic_gold = current.getChildByName("pro_pic_gold");
        var day = current.getChildByName("day");
        day.setString(realday == 1 ? "第1天" : "连续{0}天".format(realday));

        var pro_des = current.getChildByName("pro_des");
        if (cfg[i].iCoinValue1 > 0 && cfg[i].iCoinValue2 > 0) {//都有 todo

        } else if (cfg[i].iCoinValue1 > 0) {//奖券
            pro_pic_gold.setVisible(false);
            pro_pic_coupon.setVisible(true);
            pro_des.setString(cfg[i].iCoinValue1);
        } else {
            pro_pic_coupon.setVisible(false);
            pro_pic_gold.setVisible(true);
            pro_des.setString(cfg[i].iCoinValue2);
        }
    },

});

var LayerCheckinResult = DialogLayer.extend({
    _info: null,
    ctor: function (info) {
        this._super();
        this._info = info;
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/ResCheckin/LayerCheckInResult.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var bg = this.layerbg.getChildByName("bg");

        var light1 = bg.getChildByName("light1");
        light1.runAction(new cc.RepeatForever(new cc.RotateBy(2, 360)));

        var pro_des = bg.getChildByName("win_num");

        if (this._info.iCoinValue1 > 0 && this._info.iCoinValue2 > 0) {//都有 todo

        } else if (this._info.iCoinValue1 > 0) {//奖券
            var pro_coupon = bg.getChildByName("pro_coupon");
            pro_coupon.setVisible(true);
            if (FishGlobal.CheckIn.iCheckinDays == 4 || FishGlobal.CheckIn.iCheckinDays == 7) {
                pro_coupon.setSpriteFrame("intergral54.png");
            }
            pro_des.setString("/" + this._info.iCoinValue1);
        } else {
            var pro_gold = bg.getChildByName("pro_gold");
            pro_gold.setVisible(true);
            pro_des.setString("/" + this._info.iCoinValue2);
            if (FishGlobal.CheckIn.iCheckinDays == 4 || FishGlobal.CheckIn.iCheckinDays == 7) {
                pro_gold.setSpriteFrame("gold_small.png");
            }
        }

        var btn_confirm = bg.getChildByName("btn_confirm");
        btn_confirm.addTouchEventListener(this.btnTouchEft, this);
        btn_confirm.addClickEventListener(function () {
            self.removeFromParent(true);

        });
    },

    onExit: function () {
        this._super();
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.LayerCheckin);
        if (layer) {
            layer.checkInOk();
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },


});

var LayerCheckinConfirm = DialogLayer.extend({
    _info: null,
    ctor: function () {
        this._super();
        this.initUI();
    },

    initUI: function () {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/ResCheckin/LayerCheckinConfirm.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var btn_cancel = this.layerbg.getChildByName("bg").getChildByName("btn_left");
        btn_cancel.addTouchEventListener(this.btnTouchEft, this);
        btn_cancel.addClickEventListener(function () {
            self.closeCallBack();
        });

        var btn_confirm = this.layerbg.getChildByName("bg").getChildByName("btn_right");
        btn_confirm.addTouchEventListener(this.btnTouchEft, this);
        btn_confirm.addClickEventListener(function () {
            self.removeFromParent(true);
        });
    },

    closeCallBack: function () {
        this.removeFromParent(true);
        var scene = FYEngine.getRunningLayer(0);
        var layer = scene.getChildByName(LobbySceneName.LayerCheckin);
        if (layer) {
            layer.removeFromParent(true);
        }
    },

    btnTouchEft: function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                sender.setScale(1.1);
                break;
            case ccui.Widget.TOUCH_CANCELED:
                sender.setScale(1);
                break;
            case ccui.Widget.TOUCH_ENDED: {
                sender.setScale(1);
            }
                break;
            default:
                break;
        }
    },

});
var IntgralLimitLayer = DialogLayer.extend({

    ctor: function (tag,pa0,pa1) {
        this._super();
        this.initUI(tag,pa0,pa1);
    },

    initUI: function (tag,pa0,pa1) {
        var self = this;
        var mainscene = this.layerbg = fycommonfunc.ccsLoadNode("res/NewGameRes/CommonUse.csb");
        this.layerbg.setPosition(cc.p(this.width / 2, this.height / 2));
        this.addChild(mainscene, 2, 'mainscene');

        var innerBg = this.layerbg.getChildByName("bg");
        var btn_quit = this.layerbg.getChildByName("bg").getChildByName("btn_quit");
        btn_quit.setVisible(true);
        btn_quit.addClickEventListener(function(){
            self.removeFromParent(true);
        });

        var btn_confirm = this.layerbg.getChildByName("bg").getChildByName("btn_confirm");
        btn_confirm.setVisible(true);
        btn_confirm.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var btn_cancel = this.layerbg.getChildByName("bg").getChildByName("btn_cancel");
        btn_cancel.setVisible(true);
        btn_cancel.addClickEventListener(function () {
            self.removeFromParent(true);
        });

        var content = this.layerbg.getChildByName("bg").getChildByName("content");
        content.setString("" );

        var rich0 = new ccui.RichText();
        if(rich0){
            innerBg.addChild(rich0, 1, "rich0");
            rich0.setPosition(cc.p(innerBg.width / 2, 240));
            if(tag ==0){//失败
                var mtxt1 = new ccui.RichElementText(1, cc.color("#ffffff"), 255, "兑换失败，该商品今日已达兑换上限","", 30);
                rich0.pushBackElement(mtxt1);

            }else{
                var mtxt1 = new ccui.RichElementText(1, cc.color("#ffffff"), 255, "兑换成功！该商品今日还可","", 30);
                rich0.pushBackElement(mtxt1);
            }
        }

        var rich1 = new ccui.RichText();
        if (rich1) {
            innerBg.addChild(rich1, 1, "rich1");
            rich1.setAnchorPoint(cc.p(0,0.5));
            if(tag ==0){//失败
                rich1.setPosition(cc.p(innerBg.width / 2-240, 200));
                var mtxt1 = new ccui.RichElementText(1, cc.color("#ffffff"), 255, "（","", 30);
                rich1.pushBackElement(mtxt1);
                var mtxt2 = new ccui.RichElementText(2, cc.color("02fef5"), 255, "" + pa0, "", 30);
                rich1.pushBackElement(mtxt2);
                var mtxt3 = new ccui.RichElementText(3, cc.color("#ffffff"), 255, "次），请尝试兑换其他商品", "", 30);
                rich1.pushBackElement(mtxt3);
            }else{
                rich1.setPosition(cc.p(innerBg.width / 2-180, 200));
                var mtxt1 = new ccui.RichElementText(1, cc.color("#ffffff"), 255, "兑换","", 30);
                rich1.pushBackElement(mtxt1);
                var mtxt2 = new ccui.RichElementText(2, cc.color("02fef5"), 255, "" + (pa0-pa1), "", 30);
                rich1.pushBackElement(mtxt2);
                var mtxt3 = new ccui.RichElementText(3, cc.color("#ffffff"), 255, "次（共", "", 30);
                rich1.pushBackElement(mtxt3);
                var mtxt4 = new ccui.RichElementText(4, cc.color("02fef5"), 255, "" + pa0, "", 30);
                rich1.pushBackElement(mtxt4);
                var mtxt5= new ccui.RichElementText(5, cc.color("#ffffff"), 255, "次）", "", 30);
                rich1.pushBackElement(mtxt5);
            }
        }

    },

});
